
# --------------------------
#
# --------- CONFIG ---------
#
# --------------------------


ifdef MAME4ALL_ALL
MAME4ALL_AGED=1
MAME4ALL_CLASSIC=1
MAME4ALL_GOLD=1
endif

#
# - CPU Core options:
#

ifndef PSP
M68000_ASM_CORE=1
Z80_ASM_CORE=1
else
ifdef MAME4ALL_GOLD
#DRIVER_NEOGEO=1
DRIVER_TMS=1
endif
#CZ80=1
#FAMEC=1
#Option to compile FAME/C faster (if activated) but with worse performance
#MORE_CFLAGS += -DFAMEC_NO_GOTOS
endif

ifdef MAME4ALL_GOLD
ifndef MAME4ALL_CLASSIC
ifndef Z80_ASM_CORE
ifndef PSP
CZ80=1
endif
endif
endif
endif

ifndef M68000_ASM_CORE
ifndef GP2X
ifndef PSP
FAMEC=1
endif
endif
endif

#
# - Drivers to add:
#
ifdef GP2X
MAME4ALL_GOLD=1
MAME4ALL_CLASSIC=1
MAME4ALL_AGED=1
endif

# MAME4ALL Gold:
ifdef MAME4ALL_GOLD
DRIVER_TMNT=1
#DRIVER_SYSTEM16=1
ifndef PSP
DRIVER_CPS1=1
endif
endif

#MAME4ALL Classic:
ifdef MAME4ALL_CLASSIC
DRIVER_SYSTEM16=1
DRIVER_TAITO2=1
DRIVER_CENTIPEDE=1
DRIVER_ATARIVG=1
DRIVER_NEMESIS=1
DRIVER_MCR=1
DRIVER_TEHKAN=1
DRIVER_DEC0=1
DRIVER_ATARI=1
DRIVER_TECHNOS=1
DRIVER_CAPCOM=1
DRIVER_ATARISY1=1
DRIVER_SEIBU=1
DRIVER_NICHIBUT=1
DRIVER_OTHER=1
endif

# MAME4ALL Aged:
ifdef MAME4ALL_AGED
DRIVER_GENERIC_8BIT=1
endif

# Only for GP2X:
ifdef GP2X
DRIVER_NEOGEO=1
DRIVER_TMS=1
endif

ifdef DRIVER_TMS
M6809_CORE=1
endif

#
# - General options:
#

ifndef GP2X
DEFS+= -DUSE_FILECACHE
DEFS+= -DGP2X_SDLWRAPPER_NODOUBLEBUFFER
DEFS+= -DNO_Z80_BIG_FLAGS_ARRAY
#DEFS+= -DNO_SPLASH
endif

DEFS+= -DUSE_CPLUS
#DEFS+= -DDEBUG_FILECACHE
#DEFS+= -DDEBUG_FRAMERATE
#DEFS+= -DDEBUG_FRAMERATE_MAX=3000
#DEFS+= -DMAME4ALL_BENCH=1000
#DEFS+= -DPROFILER_MAME4ALL
#DEFS+= -DSOUND_THREADED
#DEFS+= -DNOSOUND
#DEFS+= -DDEBUG_SOUND
#DEFS+= -DUSE_FLOAT_VEC
#DEFS+= -DNO_FASTMEM
#DEFS+= -DUSE_ZIP_CACHE
#DEFS+= -DUSE_OLD_LIST_INIT
#DEFS+= -DSND_OPM_REDUCTION=2.1
#DEFS+= -DSND_PCM_REDUCTION=2.2
#DEFS+= -DSND_STR_REDUCTION=2.8
#DEFS+= -DSND_UDP_REDUCTION=2.3

ifndef GP2X
ifdef MAME4ALL_GOLD
ifndef MAME4ALL_CLASSIC
DEFS+= -DSND_CHANNELS_REDUCTION
endif
endif
endif

#DEFS+= -DFAME_ONE_HANDLER
#DEFS+= -DFAME_ONLY_HANDLER
#DEFS+= -DFAME_EMULATE1
#DEFS+= -DFAME_N_ENTRIES=64

#DEFS+= -DRAZE_ONLY_HANDLER


ifndef GP2X
ifdef MAME4ALL_AGED
DEFS+= -DMAME4ALL_AGED
DEFS+= -DMAME4ALL_CPU_CLOCK=100
else
ifdef MAME4ALL_CLASSIC
DEFS+= -DMAME4ALL_CLASSIC
DEFS+= -DMAME4ALL_CPU_CLOCK=90
else
DEFS+= -DMAME4ALL_GOLD
DEFS+= -DMAME4ALL_CPU_CLOCK=80
DEFS+= -DSND_CHANNELS_REDUCTION
DEFS+= -DFAME_N_ENTRIES=64
endif
endif
endif

#DEFS+= -DFAMEC_NO_GOTOS


#DEFS+= -DDEBUG_MEMALLOC_FULL_REPORT 
#DEFS+= -DDEBUG_MEMALLOC_FULL_REPORT_UNZIP 
#DEFS+= -DDEBUG_MEMALLOC_REPORT

#DEFS+= -DAUTOEVENTS=3000


# --------------------------
#
# --------- CONFIG ---------
#
# --------------------------



# Optional set CPU cores manually (FORCED):
#M68000_CORE=1
#M6805_CORE=1
#I8039_CORE=1
#I8085_CORE=1
#M6808_CORE=1
#S2650_CORE=1
#I86_CORE=1
#T11_CORE=1
#M6502_CORE=1
#M6809_CORE=1
#TMS_CORE=1
#H6280_CORE=1
#TMS32010_CORE=1

ifdef M6805_CORE
MORE_CFLAGS += -DUSE_M6805_GP
endif

ifdef I8039_CORE
MORE_CFLAGS += -DUSE_I8039_GP
endif

ifdef M6808_CORE
MORE_CFLAGS += -DUSE_M6808_GP
endif

ifdef S2650_CORE
MORE_CFLAGS += -DUSE_S2650_GP
endif

ifdef I86_CORE
MORE_CFLAGS += -DUSE_I86_GP
endif

ifdef T11_CORE
MORE_CFLAGS += -DUSE_T11_GP
endif

ifdef M6502_CORE
MORE_CFLAGS += -DUSE_M6502_GP
endif

ifdef M6809_CORE
MORE_CFLAGS += -DUSE_M6809_GP
endif

ifdef TMS_CORE
MORE_CFLAGS += -DUSE_TMS34010_GP -DUSE_TMS9900_GP
endif

MORE_CFLAGS += -DUSE_Z80_GP

ifndef DRIVER_GENERIC_8BIT
MORE_CFLAGS += -DNO_DRIVER_GENERIC_8BIT
else
ifndef M6809_CORE
M6809_CORE=1
MORE_CFLAGS += -DUSE_M6809_GP
endif
ifndef M6502_CORE
M6502_CORE=1
MORE_CFLAGS += -DUSE_M6502_GP
endif
ifndef M6805_CORE
M6805_CORE=1
MORE_CFLAGS += -DUSE_M6805_GP
endif
ifndef I8085_CORE
I8085_CORE=1
MORE_CFLAGS += -DUSE_I8085_GP
endif
ifndef I8039_CORE
I8039_CORE=1
MORE_CFLAGS += -DUSE_I8039_GP
endif
ifndef M6808_CORE
M6808_CORE=1
MORE_CFLAGS += -DUSE_M6808_GP
endif
ifndef S2650_CORE
S2650_CORE=1
MORE_CFLAGS += -DUSE_S2650_GP
endif
ifndef I86_CORE
I86_CORE=1
MORE_CFLAGS += -DUSE_I86_GP
endif
ifndef T11_CORE
T11_CORE=1
MORE_CFLAGS += -DUSE_T11_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif
ifndef MSM5205_CORE
MSM5205_CORE=1
MORE_CFLAGS += -DUSE_MSM5205_GP
endif
endif

ifndef DRIVER_TMS
MORE_CFLAGS += -DNO_DRIVER_TMS
else
ifndef TMS_CORE
TMS_CORE=1
MORE_CFLAGS += -DUSE_TMS34010_GP -DUSE_TMS9900_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif
endif

ifdef Z80_ASM_CORE
ifdef GP2X
MORE_CFLAGS += -DUSE_DRZ80
else
MORE_CFLAGS += -DUSE_RAZE
endif
else
ifdef CZ80
MORE_CFLAGS += -DUSE_CZ80
endif
endif

ifndef DRIVER_TMNT
MORE_CFLAGS += -DNO_DRIVER_TMNT
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
endif

ifndef DRIVER_ATARISY1
MORE_CFLAGS += -DNO_DRIVER_ATARISY1
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef M6502_CORE
M6502_CORE=1
MORE_CFLAGS += -DUSE_M6502_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
endif


ifndef DRIVER_SYSTEM16
MORE_CFLAGS += -DNO_DRIVER_SYSTEM16
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef MSM5205_CORE
MSM5205_CORE=1
MORE_CFLAGS += -DUSE_MSM5205_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef SEGAPCM_CORE
SEGAPCM_CORE=1
MORE_CFLAGS += -DUSE_SEGAPCM_GP
endif
ifndef RF5C68_CORE
RF5C68_CORE=1
MORE_CFLAGS += -DUSE_RF5C68_GP
endif
endif

ifndef DRIVER_TAITO2
MORE_CFLAGS += -DNO_DRIVER_TAITO2
else
ifndef M6809_CORE
M6809_CORE=1
MORE_CFLAGS += -DUSE_M6809_GP
endif
ifndef TMS32010_CORE
TMS32010_CORE=1
MORE_CFLAGS += -DUSE_TMS32010_GP
endif
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef ADPCM_CORE
ADPCM_CORE=1
MORE_CFLAGS += -DUSE_ADPCM_GP
endif
ifndef MSM5205_CORE
MSM5205_CORE=1
MORE_CFLAGS += -DUSE_MSM5205_GP
endif
endif

ifndef DRIVER_ATARIVG
MORE_CFLAGS += -DNO_DRIVER_ATARIVG
MORE_CFLAGS += -DNO_DRIVER_CENTIPEDE
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef M6809_CORE
M6809_CORE=1
MORE_CFLAGS += -DUSE_M6809_GP
endif
ifndef M6502_CORE
M6502_CORE=1
MORE_CFLAGS += -DUSE_M6502_GP
endif
ifndef DRIVER_CENTIPEDE
MORE_CFLAGS += -DNO_DRIVER_CENTIPEDE
endif
endif


ifndef DRIVER_NEMESIS
MORE_CFLAGS += -DNO_DRIVER_NEMESIS
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
endif

ifndef DRIVER_MCR
MORE_CFLAGS += -DNO_DRIVER_MCR
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
endif

ifndef DRIVER_TEHKAN
MORE_CFLAGS += -DNO_DRIVER_TEHKAN
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef ADPCM_CORE
ADPCM_CORE=1
MORE_CFLAGS += -DUSE_ADPCM_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif
ifndef MSM5205_CORE
MSM5205_CORE=1
MORE_CFLAGS += -DUSE_MSM5205_GP
endif
endif

ifndef DRIVER_DEC0
MORE_CFLAGS += -DNO_DRIVER_DEC0
else
ifndef H6280_CORE
H6280_CORE=1
MORE_CFLAGS += -DUSE_H6280_GP
endif
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef M6502_CORE
M6502_CORE=1
MORE_CFLAGS += -DUSE_M6502_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef ADPCM_CORE
ADPCM_CORE=1
MORE_CFLAGS += -DUSE_ADPCM_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif

endif

ifndef DRIVER_ATARI
MORE_CFLAGS += -DNO_DRIVER_ATARI
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef M6502_CORE
M6502_CORE=1
MORE_CFLAGS += -DUSE_M6502_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif
endif

ifndef DRIVER_TECHNOS
MORE_CFLAGS += -DNO_DRIVER_TECHNOS
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef M6809_CORE
M6809_CORE=1
MORE_CFLAGS += -DUSE_M6809_GP
endif
ifndef M6502_CORE
M6502_CORE=1
MORE_CFLAGS += -DUSE_M6502_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef ADPCM_CORE
ADPCM_CORE=1
MORE_CFLAGS += -DUSE_ADPCM_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif
endif

ifndef DRIVER_CAPCOM
MORE_CFLAGS += -DNO_DRIVER_CAPCOM
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef M6809_CORE
M6809_CORE=1
MORE_CFLAGS += -DUSE_M6809_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef ADPCM_CORE
ADPCM_CORE=1
MORE_CFLAGS += -DUSE_ADPCM_GP
endif
endif

ifndef DRIVER_CPS1
MORE_CFLAGS += -DNO_DRIVER_CPS1
else
MORE_CFLAGS += -DUSE_QSOUND_GP
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef MSM5205_CORE
MSM5205_CORE=1
MORE_CFLAGS += -DUSE_MSM5205_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif
endif

ifndef DRIVER_SEIBU
MORE_CFLAGS += -DNO_DRIVER_SEIBU
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef M6502_CORE
M6502_CORE=1
MORE_CFLAGS += -DUSE_M6502_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif
endif

ifndef DRIVER_NICHIBUT
MORE_CFLAGS += -DNO_DRIVER_NICHIBUT
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
endif

ifndef DRIVER_OTHER
MORE_CFLAGS += -DNO_DRIVER_OTHER
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef M6809_CORE
M6809_CORE=1
MORE_CFLAGS += -DUSE_M6809_GP
endif
ifndef M6502_CORE
M6502_CORE=1
MORE_CFLAGS += -DUSE_M6502_GP
endif
ifndef I8039_CORE
I8039_CORE=1
MORE_CFLAGS += -DUSE_I8039_GP
endif
ifndef I8085_CORE
I8085_CORE=1
MORE_CFLAGS += -DUSE_I8085_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef AY8910_CORE
AY8910_CORE=1
MORE_CFLAGS += -DUSE_AY8910_GP
endif
ifndef ADPCM_CORE
ADPCM_CORE=1
MORE_CFLAGS += -DUSE_ADPCM_GP
endif
ifndef OKIM6295_CORE
OKIM6295_CORE=1
MORE_CFLAGS += -DUSE_OKIM6295_GP
endif
ifndef MSM5205_CORE
MSM5205_CORE=1
MORE_CFLAGS += -DUSE_MSM5205_GP
endif
endif

ifndef DRIVER_NEOGEO
MORE_CFLAGS += -DNO_DRIVER_NEOGEO
else
ifndef M68000_CORE
M68000_CORE=1
endif
ifndef YM2XXX_CORE
YM2XXX_CORE=1
MORE_CFLAGS += -DUSE_YM2XXX_GP
endif
ifndef YM2151_CORE
YM2151_CORE=1
MORE_CFLAGS += -DUSE_YM2151_GP
endif
endif


ifdef M68000_CORE
MORE_CFLAGS += -DUSE_M68000_GP

ifdef M68000_ASM_CORE
ifdef GP2X
MORE_CFLAGS += -DUSE_CYCLONE
else
MORE_CFLAGS += -DUSE_FAME
endif
else
ifdef FAMEC
MORE_CFLAGS += -DUSE_FAME -DFAME_IS_FAMEC
endif
endif
endif

