! --------------------------------------------------
! Fast and Accurate Motorola 68000 Emulation Library
! FAME SH4 version 2.1 (03/23/2007)
! Oscar Orallo Pelaez
! Assembly file generated on Apr  4 2011 23:25:03
! --------------------------------------------------
! Generation options:
! - Code generation format for GNU assembler (GAS)
! - CPU address bus width (24 bits)
! - Program counter bit width (24 bits)
! - Emulate dummy reads (OFF)
! - Emulate undocumented behaviour (OFF)
! - Single memory address space
! - Emulate group 0 error exceptions (OFF)
! - Prefix of API function identifiers: m68k
! - Accurate timing emulation (OFF)
! - Direct mapping for memory management (12 bits)
! - Keep track of executed CPU clocks (ON)
! - Use running state indicator in execinfo (ON)
! - Emulate trace mode exception (OFF)
! - CPU clocks spent in IRQ processing (ON)
! - Check for address exceptions in branches (OFF)
! - Bypass TAS writeback (OFF)
! - Declare CPU context as global variable (ON)
! --------------------------------------------------
.global __io_cycle_counter
.data
.align 5
.global _m68kcontext
_m68kcontext:
contextbegin:
fetch:     .long 0
readbyte:  .long 0
readword:  .long 0
writebyte: .long 0
writeword: .long 0
s_fetch:     .long 0
s_readbyte:  .long 0
s_readword:  .long 0
s_writebyte: .long 0
s_writeword: .long 0
u_fetch:     .long 0
u_readbyte:  .long 0
u_readword:  .long 0
u_writebyte: .long 0
u_writeword: .long 0
resethandler: .long 0
iackhandler:  .long 0
icusthandler: .long 0
reg:
dreg: .long 0,0,0,0,0,0,0,0
areg: .long 0,0,0,0,0,0,0
a7:   .long 0
asp:  .long 0
pc:   .long 0
cycles_counter: .long 0
interrupts: .byte 0,0,0,0,0,0,0,0
sreg: .word 0
execinfo: .word 0
contextend:
execexit_addr: .long execexit
fdl_addr: .long fdl
cycles_needed:    .long 0
__io_cycle_counter: .long 0
io_fetchbase:     .long 0
io_fetchbased_pc: .long 0
fetch_vector:	    .long sfmhtbl, srwmhtbl
fetch_idx:        .long 0
readbyte_idx:     .long 0
readword_idx:     .long 0
writebyte_idx:    .long 0
writeword_idx:    .long 0
decode_extw_addr: .long decode_extw
rb_addr: .long readmemorybyte
rw_addr: .long readmemoryword
rl_addr: .long readmemorydword
wb_addr: .long writememorybyte
ww_addr: .long writememoryword
wl_addr: .long writememorydword
wdecb_addr: .long writememorydecbyte
wdecw_addr: .long writememorydecword
wdecl_addr: .long writememorydecdword
sfmhtbl:
.rept 4096
 .long 0
 .endr
srbmhtbl:
.rept 4096
 .long 0
 .endr
srwmhtbl:
.rept 4096
 .long 0
 .endr
swbmhtbl:
.rept 4096
 .long 0
 .endr
swwmhtbl:
.rept 4096
 .long 0
 .endr
.text
top:
.align 5
.global _m68k_init
_m68k_init:
rts
mov #0,r0
.align 5
.global _m68k_emulate
_m68k_emulate:
mov.l execinfo_addr,r1
mov.w @r1,r0
tst #0x80,r0
bt notstopped
mov.l cycles_counter_addr,r0
mov.l @r0,r1
add r4,r1
mov.l r1,@r0
rts
mov #0,r0
.align 5
notstopped:
mov.l r8,@-r15
mov r4,r7
mov.l r9,@-r15
mov.l r10,@-r15
mov.l r11,@-r15
mov.l r12,@-r15
mov.l fetch_idx_addr,r11
mov.l r13,@-r15
mov.l jmptbl_addr,r12
mov.l r14,@-r15
mov.l reg_addr,r13
sts.l pr,@-r15
mov.l areg_addr,r14
or #1,r0
mov.w r0,@r1
mov r0,r2
mov.l @(fdl_addr-areg,r14),r10
mov.l @(sreg - areg,r14),r0
mov #3,r8
and r0,r8
mov r0,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l pc_addr,r1
mov.l r4,@(cycles_needed-pc,r1)
mov.l @r1,r6
flush_irqs:
mov.l sreg_addr1,r1
mov.l interrupts_addr1,r0
mov.w @r1,r1
mov #7,r4
shlr8 r1
mov.b @r0,r2
and r4,r1
mov r2,r5
sub r1,r4
mov #7,r1
shll16 r2
shll8 r2
.loop1:
shll r2
bt .int
dt r4
cmp/pl r4
bt/s .loop1
dt r1
bra .noint
mov #0,r0
.align 5
.int:
mov r5,r2
mov r1,r5
mov #1,r1
shld r5,r1
xor r1,r2
mov.l r5,@-r15
mov.b r2,@r0
mov.b @(r0,r5),r4
mov #0,r5
mov.l g1_exception_addr,r0
jsr @r0
shll2 r4
mov #0xf8,r0
mov.l @r15+,r5
mov.l sreg_addr1,r2
add #1,r2
mov.b @r2,r1
add #-44,r7
and r0,r1
or r5,r1
mov.b r1,@r2
mov.l iackhandler_addr,r0
mov.l @r0,r1
tst r1,r1
bt .intdone
mov.l r3,@-r15
mov.l __io_cycle_counter_addr1,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
jsr @r1
nop
mov.l __io_cycle_counter_addr1,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
mov.l @r15+,r3
.intdone:
mov #1,r0
.noint:
cmp/pz r7
bf/s irqclk_exit
mov #0,r5
execbase:
bsr basefunction
pref @r13
add r5,r6
execloop:
mov.w @r6+,r0
shll2 r0
mov.l @(r0,r12),r4
mov #0x1C,r2
jmp @r4
and r0,r2
.align 5
execexit:
add #-2,r6
irqclk_exit:
mov.l pc_addr,r2
sub r5,r6
rotl r3
mov r8,r0
addc r9,r9
shlr2 r0
rotr r3
and #1,r0
xor r0,r9
mov r8,r0
tst r3,r3
addc r9,r9
and #3,r0
shll2 r9
or r0,r9
mov.l sreg_addr1,r0
mov.b r9,@r0
mov.l r6,@r2
mov.l @(cycles_needed-pc,r2),r4
sub r7,r4
mov.l @(cycles_counter-pc,r2),r6
add r4,r6
mov.l r6,@(cycles_counter-pc,r2)
mov.l execinfo_addr,r1
mov.w @r1,r0
xor #1,r0
mov.w r0,@r1
lds.l	@r15+,pr
mov.l @r15+,r14
mov.l @r15+,r13
mov.l @r15+,r12
mov.l @r15+,r11
mov.l @r15+,r10
mov.l @r15+,r9
rts
mov.l @r15+,r8
.align 2
interrupts_addr1: .long interrupts
pc_addr: .long pc
reg_addr: .long reg
areg_addr: .long areg
fetch_vector_addr: .long fetch_vector
sreg_addr1: .long sreg
jmptbl_addr: .long jmptbl
cycles_counter_addr: .long cycles_counter
execinfo_addr: .long execinfo
fetch_idx_addr: .long fetch_idx
g1_exception_addr: .long group_1_exception
basefunction_addr: .long basefunction
iackhandler_addr: .long iackhandler
__io_cycle_counter_addr1: .long __io_cycle_counter
.align 5
.global _m68k_reset
_m68k_reset:
mov.l r11,@-r15
mov.l fetchidx_addr,r11
mov #1,r0
mov.l execinfo_addr2,r2
mov.w @r2,r1
tst r1,r0
bf return
mov.l sup_fetch_addr,r0
mov.l @r0,r1
mov #2,r0
tst r1,r1
bt return
mov.l reg_addr2,r0
mov #64,r1
add r1,r0
shlr2 r1
xor r4,r4
gp:
mov.l r4,@-r0
dt r1
bf gp
mov.l asp_addr2,r2
mov.l r4,@r2
mov.l interrupts_addr2,r2
mov.b r4,@r2
mov.l execinfo_addr2,r2
mov.w r4,@r2
mov.l sreg_addr2,r2
mov #0x27,r4
shll8 r4
mov.w r4,@r2
mov.l sfmhtbl_addr2,r0
mov.l fetch_idx_addr2,r1
mov.l r0,@r1
mov.l srbmhtbl_addr2,r0
mov.l r0,@(4,r1)
mov.l srwmhtbl_addr2,r0
mov.l r0,@(8,r1)
mov.l swbmhtbl_addr2,r0
mov.l r0,@(12,r1)
mov.l swwmhtbl_addr2,r0
mov.l r0,@(16,r1)
sts pr,r4
bsr basefunction
xor r6,r6
lds r4,pr
add r5,r6
mov.l @r6+,r0
swap.w r0,r0
mov.l a7_addr2,r2
mov.l r0,@r2
mov.l @r6,r0
swap.w r0,r0
mov.l pc_addr2,r2
mov.l r0,@r2
mov #0,r0
return:
rts
mov.l @r15+,r11
.align 2
reg_addr2: .long reg
execinfo_addr2: .long execinfo
interrupts_addr2: .long interrupts
pc_addr2: .long pc
sreg_addr2: .long sreg
a7_addr2: .long a7
asp_addr2: .long asp
sup_fetch_addr: .long s_fetch
sup_readbyte: .long s_readbyte
sup_readword: .long s_readword
sup_writebyte: .long s_writebyte
sup_writeword: .long s_writeword
act_fetch: .long fetch
act_readbyte: .long readbyte
act_readword: .long readword
act_writebyte: .long writebyte
act_writeword: .long writeword
fetchidx_addr: .long fetch_idx
sfmhtbl_addr2: .long sfmhtbl
srbmhtbl_addr2: .long srbmhtbl
srwmhtbl_addr2: .long srwmhtbl
swbmhtbl_addr2: .long swbmhtbl
swwmhtbl_addr2: .long swwmhtbl
fetch_idx_addr2: .long fetch_idx
.align 5
.global _m68k_raise_irq
_m68k_raise_irq:
mov r4,r0
and #7,r0
tst r0,r0
bt badinput
mov #0xff,r4
extu.b r4,r4
cmp/gt r4,r5
bt badinput
mov #-2,r4
cmp/ge r4,r5
bf badinput
cmp/eq r5,r4
bf notspurious
bra notauto
mov #0x18,r5
notspurious:
mov #-1,r4
cmp/eq r5,r4
bf notauto
mov #0x18,r5
add r0,r5
notauto:
mov #1,r4
shld r0,r4
mov.l interrupts_addr3,r1
mov.b @r1,r6
tst r6,r4
bf failure
or r4,r6
mov.b r5,@(r0,r1)
mov.b r6,@r1
mov #0x80,r1
mov.l execinfo_addr3,r6
extu.b r1,r1
mov.w @r6,r7
tst r1,r7
bt .notstopped
mov.l sreg_addr3,r1
mov.w @r1,r5
shlr8 r5
mov #7,r1
cmp/eq r1,r0
movt r4
and r1,r5
add r4,r0
cmp/hs r0,r5
movt r2
mov #0x7f,r0
shld r1,r2
and r0,r7
or r2,r7
mov.w r7,@r6
.notstopped:
rts
mov #0,r0
failure:
rts
mov #-1,r0
badinput:
rts
mov #-2,r0
.align 2
interrupts_addr3: .long interrupts
execinfo_addr3: .long execinfo
sreg_addr3: .long sreg
.align 5
.global _m68k_lower_irq
_m68k_lower_irq:
mov #6,r1
cmp/gt r1,r4
bt .badlevel
tst r4,r4
bt .badlevel
mov #1,r1
shld r4,r1
mov.l interrupts_addr4,r2
mov.b @r2,r3
tst r3,r1
bt .failstat
not r1,r1
and r1,r3
mov.b r3,@r2
rts
mov #0,r0
.failstat:
rts
mov #-1,r0
.badlevel:
rts
mov #-2,r0
.align 2
interrupts_addr4: .long interrupts
.align 5
.global _m68k_set_irq_type
_m68k_set_irq_type:
mov #1,r0
and r0,r5
tst r4,r4
bt .si_irq
mov #interrupts-contextbegin,r0
mov.b @(r0,r4),r1
shlr r1
shll r1
or r5,r1
mov.b r1,@(r0,r4)
rts
mov #0,r0
.si_irq:
mov.l interrupts_addr5,r1
mov.b @r1,r0
and #0xFE,r0
or r5,r0
mov.b r0,@r1
rts
mov #0,r0
.align 2
interrupts_addr5: .long interrupts
.align 5
.global _m68k_get_irq_vector
_m68k_get_irq_vector:
mov r4,r0
and #7,r0
tst r0,r0
bt badlev
mov #1,r1
shld r0,r1
mov.l interrupts_addr6,r2
mov.b @r2,r3
tst r3,r1
bt notraised
mov.b @(r0,r2),r0
rts
extu.b r0,r0
notraised:
rts
mov #-1,r0
badlev:
rts
mov #-2,r0
.align 2
interrupts_addr6: .long interrupts
.align 5
.global _m68k_change_irq_vector
_m68k_change_irq_vector:
mov r4,r0
and #7,r0
tst r0,r0
bt .badin
mov #1,r1
shld r0,r1
mov.l interrupts_addr7,r7
mov.b @r7,r3
tst r3,r1
bt .nraised
mov #255,r4
extu.b r4,r4
cmp/gt r4,r5
bt .badin
mov #-2,r4
cmp/gt r5,r4
bt .badin
cmp/eq r5,r4
bf .notspurious
bra .notauto
mov #0x18,r5
.notspurious:
dt r4
cmp/eq r5,r4
bf .notauto
mov #0x18,r5
add r0,r5
.notauto:
mov.b r5,@(r0,r7)
rts
mov #0,r0
.nraised:
rts
mov #-1,r0
.badin:
rts
mov #-2,r0
.align 2
interrupts_addr7: .long interrupts
.align 5
.global _m68k_get_context_size
_m68k_get_context_size:
mov.l contextend_addr8,r0
mov.l contextbegin_addr8,r1
rts
sub r1,r0
.align 2
contextbegin_addr8: .long contextbegin
contextend_addr8: .long contextend
.align 5
.global _m68k_get_context
_m68k_get_context:
mov.l contextbegin_addr9,r2
mov.l contextend_addr9,r1
loopgc:
mov.l @r2+,r0
mov.l r0,@r4
add #4,r4
cmp/eq r2,r1
bf loopgc
rts
mov #0,r0
.align 2
contextbegin_addr9: .long contextbegin
contextend_addr9: .long contextend
.align 5
.global _m68k_set_context
_m68k_set_context:
mov.l contxtb,r2
mov.l contxte,r1
lloop:
mov.l @r4+,r0
mov.l r0,@r2
add #4,r2
cmp/eq r2,r1
bf lloop
mov.l idxtbl_size,r1
mov.l sfmhtbl_addr,r2
mov #0,r0
mloop:
mov.l r0,@r2
add #4,r2
dt r1
bf mloop
mov.l sfmhtbl_addr,r4
mov.l s_fetch_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm0:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm0
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop0:
mov.l r1,@r0
add r6,r0
dt r2
bf loop0
bra begincmm0
add #12,r1
endcmm0:
mov.l srbmhtbl_addr,r4
mov.l s_readbyte_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm1:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm1
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop1:
mov.l r1,@r0
add r6,r0
dt r2
bf loop1
bra begincmm1
add #16,r1
endcmm1:
mov.l srwmhtbl_addr,r4
mov.l s_readword_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm2:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm2
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop2:
mov.l r1,@r0
add r6,r0
dt r2
bf loop2
bra begincmm2
add #16,r1
endcmm2:
mov.l swbmhtbl_addr,r4
mov.l s_writebyte_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm3:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm3
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop3:
mov.l r1,@r0
add r6,r0
dt r2
bf loop3
bra begincmm3
add #16,r1
endcmm3:
mov.l swwmhtbl_addr,r4
mov.l s_writeword_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm4:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm4
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop4:
mov.l r1,@r0
add r6,r0
dt r2
bf loop4
bra begincmm4
add #16,r1
endcmm4:
rts
mov #0,r0
.align 2
interrupts_addr10: .long interrupts
idxtbl_size: .long 20480
contxte: .long contextend
contxtb: .long contextbegin
sfmhtbl_addr: .long sfmhtbl
srbmhtbl_addr: .long srbmhtbl
swbmhtbl_addr: .long swbmhtbl
srwmhtbl_addr: .long srwmhtbl
swwmhtbl_addr: .long swwmhtbl
s_fetch_addr: .long s_fetch
s_readbyte_addr: .long s_readbyte
s_writebyte_addr: .long s_writebyte
s_readword_addr: .long s_readword
s_writeword_addr: .long s_writeword
.align 5
.global _m68k_get_register
_m68k_get_register:
mov #17,r0
cmp/gt r0,r4
bt cont_get
mov #16,r0
cmp/gt r0,r4
bf .set_dareg
bra _m68k_get_pc
nop
.set_dareg:
mov.l reg_addr11,r0
shll2 r4
rts
mov.l @(r0,r4),r0
cont_get:
mov #18,r0
cmp/eq r0,r4
bf inv_idx
mov.l sreg_addr11,r0
mov.w @r0,r0
rts
extu.w r0,r0
inv_idx:
rts
mov #-1,r0
.align 2
sreg_addr11: .long sreg
reg_addr11: .long reg
.align 5
.global _m68k_get_pc
_m68k_get_pc:
mov.l execinfo_addr12,r0
mov.w @r0,r0
tst #1,r0
bf running
mov.l pc_addr12,r0
rts
mov.l @r0,r0
running:
mov.l io_fetchbased_pc_addr12,r0
mov.l @r0,r0
mov.l io_fetchbase_addr12,r1
mov.l @r1,r1
rts
sub r1,r0
.align 2
pc_addr12: .long pc
execinfo_addr12: .long execinfo
io_fetchbase_addr12: .long io_fetchbase
io_fetchbased_pc_addr12: .long io_fetchbased_pc
.align 5
.global _m68k_set_register
_m68k_set_register:
mov #17,r0
cmp/gt r0,r4
bt .cont_set
mov #16,r0
cmp/gt r0,r4
bt .set_pc
mov.l reg_addr13,r0
shll2 r4
mov.l r5,@(r0,r4)
rts
mov #0,r0
.set_pc:
shll8 r5
shlr8 r5
mov.l execinfo_addr13,r0
mov #1,r2
mov.b @r0,r1
tst r2,r1
bf .cpulive
mov.l pc_addr13,r0
mov.l r5,@r0
rts
mov #0,r0
.cpulive:
mov.l io_fetchbase_addr13,r0
mov.l @r0,r1
mov.l io_fetchbased_pc_addr13,r2
add r5,r1
mov.l r1,@r2
rts
mov #0,r0
.cont_set:
mov #18,r0
cmp/eq r0,r4
bf .inv_idx
mov.l sreg_addr13,r0
mov.w r5,@r0
rts
mov #0,r0
.inv_idx:
rts
mov #-1,r0
.align 2
sreg_addr13: .long sreg
reg_addr13: .long reg
execinfo_addr13: .long execinfo
pc_addr13: .long pc
io_fetchbase_addr13: .long io_fetchbase
io_fetchbased_pc_addr13: .long io_fetchbased_pc
.align 5
.global _m68k_fetch
_m68k_fetch:
mov #3,r0
and r0,r5
mov r4,r2
mov #-12,r0
shld r0,r4
mov.l fetch_vector_addr14,r0
shll2 r5
mov.l @(r0,r5),r0
shll2 r4
mov.l @(r0,r4),r0
mov r2,r4
tst r0,r0
bt .outofrange
mov #4,r1
tst r1,r5
bt .base_prg
bra .base_dat
nop
.outofrange:
rts
mov #-1,r0
.base_prg:
mov.l @(8,r0),r0
mov.w @(r0,r4),r0
rts
extu.w r0,r0
.base_dat:
mov.l @(8,r0),r1
tst r1,r1
bf .callio
mov.l @(12,r0),r0
mov.w @(r0,r4),r0
rts
extu.w r0,r0
.callio:
sts.l	pr,@-r15
jsr @r1
nop
lds.l	@r15+,pr
rts
extu.w r0,r0
.align 2
fetch_vector_addr14: .long fetch_vector
.align 5
.global _m68k_get_cycles_counter
_m68k_get_cycles_counter:
mov.l execinfo_addr15,r0
mov.w @r0,r0
tst #1,r0
bt/s cpuidle
mov #0,r1
mov.l cycles_needed_addr15,r2
mov.l @r2,r1
mov.l __io_cycle_counter_addr15,r0
mov.l @r0,r0
sub r0,r1
cpuidle:
mov.l cycles_counter_addr15,r0
mov.l @r0,r0
rts
add r1,r0
.align 2
execinfo_addr15: .long execinfo
cycles_counter_addr15: .long cycles_counter
cycles_needed_addr15: .long cycles_needed
__io_cycle_counter_addr15: .long __io_cycle_counter
.align 5
.global _m68k_control_cycles_counter
_m68k_control_cycles_counter:
tst r4,r4
bf _m68k_trip_cycles_counter
bra _m68k_get_cycles_counter
nop
rts
nop
.align 5
.global _m68k_trip_cycles_counter
_m68k_trip_cycles_counter:
mov.l cycles_needed_addr16,r4
mov.l @r4,r3
mov.l execinfo_addr16,r5
mov.b @r5,r0
tst #1,r0
bt .cpuidle
mov.l __io_cycle_counter_addr16,r1
mov.l @r1,r7
sub r7,r3
.cpuidle:
mov.l cycles_counter_addr16,r2
mov.l @r2,r6
add r3,r6
mov.l r6,@r2
tst #1,r0
bt .cpuidle2
mov.l @r1,r3
.cpuidle2:
mov.l r3,@r4
mov.l @r2,r0
xor r1,r1
rts
mov.l r1,@r2
.align 2
execinfo_addr16: .long execinfo
cycles_needed_addr16: .long cycles_needed
__io_cycle_counter_addr16: .long __io_cycle_counter
cycles_counter_addr16: .long cycles_counter
.align 5
.global _m68k_release_timeslice
_m68k_release_timeslice:
mov.l execinfo_addr17,r0
mov.w @r0,r0
tst #1,r0
bt/s cpu_idle
mov #0,r0
mov.l __io_cycle_counter_addr17,r2
mov.l r0,@r2
cpu_idle:
rts
mov #0,r0
.align 2
execinfo_addr17: .long execinfo
__io_cycle_counter_addr17: .long __io_cycle_counter
.align 5
.global _m68k_stop_emulating
_m68k_stop_emulating:
mov.l execinfo_addr18,r0
mov.w @r0,r0
tst #1,r0
bt se_cpu_idle
mov.l __io_cycle_counter_addr18,r2
mov.l @r2,r3
mov.l cycles_needed_addr18,r1
mov.l @r1,r0
sub r3,r0
mov.l r0,@r1
mov #0,r0
mov.l r0,@r2
se_cpu_idle:
rts
mov #0,r0
.align 2
execinfo_addr18: .long execinfo
cycles_needed_addr18: .long cycles_needed
__io_cycle_counter_addr18: .long __io_cycle_counter
.align 5
.global _m68k_add_cycles
_m68k_add_cycles:
mov.l execinfo_addr19,r0
mov.w @r0,r0
tst #1,r0
bt ac_cpu_idle
mov.l __io_cycle_counter_addr19,r2
mov.l @r2,r1
bra ac_end_proc
sub r4,r1
ac_cpu_idle:
mov.l cycles_counter_addr19,r2
mov.l @r2,r1
add r4,r1
ac_end_proc:
mov #0,r0
rts
mov.l r1,@r2
.align 2
execinfo_addr19: .long execinfo
cycles_counter_addr19: .long cycles_counter
__io_cycle_counter_addr19: .long __io_cycle_counter
.align 5
.global _m68k_release_cycles
_m68k_release_cycles:
mov.l execinfo_addr20,r0
mov.w @r0,r0
tst #1,r0
bt rc_cpu_idle
mov.l __io_cycle_counter_addr20,r2
mov.l @r2,r1
bra rc_end_proc
add r4,r1
rc_cpu_idle:
mov.l cycles_counter_addr20,r2
mov.l @r2,r1
sub r4,r1
rc_end_proc:
mov #0,r0
rts
mov.l r1,@r2
.align 2
execinfo_addr20: .long execinfo
cycles_counter_addr20: .long cycles_counter
__io_cycle_counter_addr20: .long __io_cycle_counter
.align 5
.global _m68k_get_cpu_state
_m68k_get_cpu_state:
mov.l execinfo_addr21,r0
mov.w @r0,r0
rts
extu.w r0,r0
.align 2
execinfo_addr21: .long execinfo
.align 5
basefunction:
shll8 r6
shlr8 r6
mov r6,r0
mov #-12,r1
shld r1,r0
mov.l @r11,r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt outofrange
rts
mov.l @(8,r0),r5
outofrange:
xor r5,r5
mov.l execinfo_addr22,r1
mov.w @r1,r0
or #2,r0
rts
mov.w r0,@r1
.align 2
execinfo_addr22: .long execinfo
.align 5
readmemorybyte:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov r4,r0
mov #-12,r1
shld r1,r0
mov.l @(readbyte_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt readb_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf readb_callio
mov.l @(12,r0),r0
add r4,r0
xor #1,r0
mov.b @r0,r3
rts
mov.l @r15+,r4
.align 5
readb_callio:
mov.l r2,@-r15
mov.l __io_cycle_counter_addr23,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
nop
exts.b r0,r3
lds.l	@r15+,pr
mov.l __io_cycle_counter_addr23,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
mov.l @r15+,r2
rts
mov.l @r15+,r4
readb_outofrange:
bra readw_outofrange
nop
.align 2
__io_cycle_counter_addr23: .long __io_cycle_counter
.align 5
readmemoryword:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov r4,r0
mov #-12,r1
shld r1,r0
mov.l @(readword_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt readw_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf readw_callio
mov.l @(12,r0),r0
mov.w @(r0,r4),r3
rts
mov.l @r15+,r4
.align 5
readw_callio:
mov.l r2,@-r15
mov.l __io_cycle_counter_addr25,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
nop
exts.w r0,r3
lds.l	@r15+,pr
mov.l __io_cycle_counter_addr25,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
mov.l @r15+,r2
rts
mov.l @r15+,r4
readw_outofrange:
mov #-1,r3
rts
mov.l @r15+,r4
.align 2
__io_cycle_counter_addr25: .long __io_cycle_counter
.align 5
readmemorydword:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov r4,r0
mov #-12,r1
shld r1,r0
mov.l @(readword_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt readl_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf readl_callio
mov.l @(12,r0),r1
add r1,r4
mov.w @r4+,r0
mov.w @r4,r3
shll16 r3
xtrct r0,r3
rts
mov.l @r15+,r4
readl_outofrange:
bra readw_outofrange
nop
.align 5
readl_callio:
mov.l r2,@-r15
sts.l	pr,@-r15
mov.l r4,@-r15
mov.l r1,@-r15
mov.l __io_cycle_counter_addr27,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
jsr @r1
nop
mov.l @r15+,r1
mov.l @r15+,r4
mov.l r0,@-r15
jsr @r1
add #2,r4
mov.l @r15+,r3
lds.l	@r15+,pr
shll16 r3
extu.w r0,r0
mov.l @r15+,r2
or r0,r3
mov.l __io_cycle_counter_addr27,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
rts
mov.l @r15+,r4
.align 2
__io_cycle_counter_addr27: .long __io_cycle_counter
.align 5
writememorybyte:
writememorydecbyte:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov r4,r0
mov #-12,r1
shld r1,r0
mov.l @(writebyte_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt writeb_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf writeb_callio
mov.l @(12,r0),r0
add r4,r0
xor #1,r0
mov.b r3,@r0
rts
mov.l @r15+,r4
writeb_outofrange:
bra writew_outofrange
nop
.align 5
writeb_callio:
mov.l r2,@-r15
mov.l r3,@-r15
mov.l __io_cycle_counter_addr29,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
extu.b r3,r5
lds.l	@r15+,pr
mov.l __io_cycle_counter_addr29,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
mov.l @r15+,r3
mov.l @r15+,r2
rts
mov.l @r15+,r4
.align 2
__io_cycle_counter_addr29: .long __io_cycle_counter
.align 5
writememoryword:
writememorydecword:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov r4,r0
mov #-12,r1
shld r1,r0
mov.l @(writeword_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt writew_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf writew_callio
mov.l @(12,r0),r0
mov.w r3,@(r0,r4)
rts
mov.l @r15+,r4
writew_outofrange:
rts
mov.l @r15+,r4
.align 5
writew_callio:
mov.l r2,@-r15
mov.l r3,@-r15
mov.l __io_cycle_counter_addr31,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
extu.w r3,r5
lds.l	@r15+,pr
mov.l __io_cycle_counter_addr31,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
mov.l @r15+,r3
mov.l @r15+,r2
rts
mov.l @r15+,r4
.align 2
__io_cycle_counter_addr31: .long __io_cycle_counter
.align 5
writememorydword:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov r4,r0
mov #-12,r1
shld r1,r0
mov.l @(writeword_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt writel_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf writel_callio
mov.l @(12,r0),r0
mov r3,r1
shlr16 r1
mov.w r1,@(r0,r4)
add #2,r4
mov.w r3,@(r0,r4)
rts
mov.l @r15+,r4
writel_outofrange:
bra readw_outofrange
nop
.align 5
writel_callio:
mov.l @(8,r0),r1
mov.l __io_cycle_counter_addr33,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
mov.l r2,@-r15
mov.l r3,@-r15
sts.l	pr,@-r15
mov.l r4,@-r15
mov.l r1,@-r15
mov r3,r5
jsr @r1
shlr16 r5
mov.l @r15+,r1
mov.l @r15+,r4
mov.l @(4,r15),r5
add #2,r4
jsr @r1
extu.w r5,r5
lds.l	@r15+,pr
mov.l @r15+,r3
mov.l @r15+,r2
mov.l __io_cycle_counter_addr33,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
rts
mov.l @r15+,r4
.align 2
__io_cycle_counter_addr33: .long __io_cycle_counter
.align 5
writememorydecdword:
sts.l pr,@-r15
mov.l writememoryword_addr35,r0
jsr @r0
add #2,r4
mov.l writememoryword_addr35,r0
swap.w r3,r3
jsr @r0
add #-2,r4
lds.l @r15+,pr
rts
swap.w r3,r3
.align 2
writememoryword_addr35: .long writememoryword
.align 5
decode_extw:
mov.w @r6+,r0
exts.b r0,r4
shlr8 r0
shlr2 r0
tst #0x02,r0
and #0x3c,r0
bf/s longwd
mov.l @(r0,r13),r0
exts.w r0,r0
longwd:
add r1,r4
rts
add r0,r4
.align 5
group_1_exception:
group_2_exception:
mov.l icusthandler_addr36,r0
mov.l @r0,r0
tst r0,r0
bt .vect_except
mov r4,r1
mov.l @(r0,r1),r1
tst r1,r1
bt .vect_except
mov.l r3,@-r15
rotl r3
mov r8,r0
addc r9,r9
shlr2 r0
rotr r3
and #1,r0
xor r0,r9
mov r8,r0
tst r3,r3
addc r9,r9
and #3,r0
shll2 r9
or r0,r9
mov.l sreg_addr36,r0
mov.b r9,@r0
mov.l __io_cycle_counter_addr36,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
sts.l pr,@-r15
jsr @r1
shlr2 r4
lds.l @r15+,pr
mov.l __io_cycle_counter_addr36,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
mov.l @r15+,r3
mov.l @(sreg - areg,r14),r0
mov #3,r8
and r0,r8
mov r0,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
rts
sub r5,r6
.align 5
.vect_except:
sts.l	pr,@-r15
mov.l r3,@-r15
mov.l readmemorydword_addr36,r0
jsr @r0
sub r5,r6
mov r3,r2
mov.l @r15,r3
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov r3,r5
mov.l @(sreg-areg,r14),r0
mov #0x20,r1
shll8 r1
tst r1,r0
bf ln37
or r1,r0
mov.l r0,@(sreg-areg,r14)
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln37:
mov.l sreg_addr36,r1
mov.b @(1,r1),r0
mov r6,r3
and #0x27,r0
mov.b r0,@(1,r1)
mov.l @(60,r13),r4
mov.l writememorydword_addr36,r0
jsr @r0
add #-4,r4
mov r5,r3
mov.l writememoryword_addr36,r0
jsr @r0
add #-2,r4
mov.l @r15+,r3
mov.l r4,@(60,r13)
lds.l	@r15+,pr
rts
mov r2,r6
.align 2
readmemoryword_addr36: .long readmemoryword
readmemorydword_addr36: .long readmemorydword
writememoryword_addr36: .long writememoryword
writememorydword_addr36: .long writememorydword
icusthandler_addr36: .long icusthandler
__io_cycle_counter_addr36: .long __io_cycle_counter
execinfo_addr36: .long execinfo
sreg_addr36: .long sreg
.align 5
privilege_violation:
add #-2,r6
bsr group_1_exception
mov #0x20,r4
mov.l bf_addr38,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-34,r7
.align 2
bf_addr38: .long basefunction
.align 5
fdl:
mov.w @r6+,r0
cmp/pl r7
shll2 r0
bt/s fdl_exec
mov.l @(r0,r12),r4
mov.l @(execexit_addr-areg,r14),r4
fdl_exec:
mov #0x1C,r2
jmp @r4
and r0,r2
.align 5
fdl_cp:
mov.w @r6+,r0
cmp/pl r7
shll2 r0
bt/s continue39
mov.l @(r0,r12),r4
bra fdl39
mov.l @(execexit_addr-areg,r14),r4
continue39:
mov.l flush_irqs_addr,r1
add #-2,r6
jmp @r1
sub r5,r6
fdl39:
mov #0x1C,r2
jmp @r4
and r0,r2
.align 2
flush_irqs_addr: .long flush_irqs
! Opcodes 0000 - 0007
K000:
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
or r1,r3
mov.b r3,@r2
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 0010 - 0017
K010:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0018 - 001F
K018:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0020 - 0027
K020:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 0028 - 002F
K028:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 0030 - 0037
K030:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 0038
K038:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 0039
K039:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 003C
K03C:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
or r2,r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-20,r7
! Opcodes 0040 - 0047
K040:
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
or r1,r3
mov.w r3,@r2
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 0050 - 0057
K050:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0058 - 005F
K058:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0060 - 0067
K060:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 0068 - 006F
K068:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 0070 - 0077
K070:
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 0078
K078:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 0079
K079:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 007C
K07C:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok40
mov.l priviolation_addr40,r0
jmp @r0
nop
.align 2
priviolation_addr40: .long privilege_violation
pcheck_ok40:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
or r2,r3
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln41
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln41:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr43,r4
jmp @r4
add #-20,r7
.align 2
fdl_cp_addr43: .long fdl_cp
! Opcodes 0080 - 0087
K080:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
or r1,r3
mov.l r3,@r2
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0090 - 0097
K090:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 0098 - 009F
K098:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 00A0 - 00A7
K0A0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 00A8 - 00AF
K0A8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcodes 00B0 - 00B7
K0B0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 00B8
K0B8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 00B9
K0B9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-36,r7
! Opcodes 0100 - 0107
K100:
mov.b @r13,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-6,r7
! Opcodes 0108 - 010F
K108:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.w r2,@r13
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0110 - 0117
K110:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0118 - 011F
K118:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0120 - 0127
K120:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-10,r7
! Opcodes 0128 - 012F
K128:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0130 - 0137
K130:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0138
K138:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0139
K139:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 013A
K13A:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 013B
K13B:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 013C
K13C:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.b @r6,r3
add #2,r6
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0140 - 0147
K140:
mov.b @r13,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0148 - 014F
K148:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@r13
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0150 - 0157
K150:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0158 - 015F
K158:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0160 - 0167
K160:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0168 - 016F
K168:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0170 - 0177
K170:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0178
K178:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0179
K179:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0180 - 0187
K180:
mov.b @r13,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-10,r7
! Opcodes 0188 - 018F
K188:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @r13,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0190 - 0197
K190:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0198 - 019F
K198:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 01A0 - 01A7
K1A0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 01A8 - 01AF
K1A8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 01B0 - 01B7
K1B0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 01B8
K1B8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 01B9
K1B9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 01C0 - 01C7
K1C0:
mov.b @r13,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 01C8 - 01CF
K1C8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @r13,r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 01D0 - 01D7
K1D0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 01D8 - 01DF
K1D8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 01E0 - 01E7
K1E0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 01E8 - 01EF
K1E8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 01F0 - 01F7
K1F0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 01F8
K1F8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 01F9
K1F9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0200 - 0207
K200:
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
and r1,r3
mov.b r3,@r2
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 0210 - 0217
K210:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0218 - 021F
K218:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0220 - 0227
K220:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 0228 - 022F
K228:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 0230 - 0237
K230:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 0238
K238:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 0239
K239:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 023C
K23C:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
and r2,r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-20,r7
! Opcodes 0240 - 0247
K240:
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
and r1,r3
mov.w r3,@r2
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 0250 - 0257
K250:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0258 - 025F
K258:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0260 - 0267
K260:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 0268 - 026F
K268:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 0270 - 0277
K270:
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 0278
K278:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 0279
K279:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 027C
K27C:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok44
mov.l priviolation_addr44,r0
jmp @r0
nop
.align 2
priviolation_addr44: .long privilege_violation
pcheck_ok44:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
and r2,r3
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln45
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln45:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr47,r4
jmp @r4
add #-20,r7
.align 2
fdl_cp_addr47: .long fdl_cp
! Opcodes 0280 - 0287
K280:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
and r1,r3
mov.l r3,@r2
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 0290 - 0297
K290:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 0298 - 029F
K298:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 02A0 - 02A7
K2A0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 02A8 - 02AF
K2A8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcodes 02B0 - 02B7
K2B0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 02B8
K2B8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 02B9
K2B9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-36,r7
! Opcodes 0300 - 0307
K300:
mov.b @(4,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-6,r7
! Opcodes 0308 - 030F
K308:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #4,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0310 - 0317
K310:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0318 - 031F
K318:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0320 - 0327
K320:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-10,r7
! Opcodes 0328 - 032F
K328:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0330 - 0337
K330:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0338
K338:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0339
K339:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 033A
K33A:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 033B
K33B:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 033C
K33C:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.b @r6,r3
add #2,r6
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0340 - 0347
K340:
mov.b @(4,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0348 - 034F
K348:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(4,r13)
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0350 - 0357
K350:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0358 - 035F
K358:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0360 - 0367
K360:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0368 - 036F
K368:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0370 - 0377
K370:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0378
K378:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0379
K379:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0380 - 0387
K380:
mov.b @(4,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-10,r7
! Opcodes 0388 - 038F
K388:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(4,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0390 - 0397
K390:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0398 - 039F
K398:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 03A0 - 03A7
K3A0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 03A8 - 03AF
K3A8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 03B0 - 03B7
K3B0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 03B8
K3B8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 03B9
K3B9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 03C0 - 03C7
K3C0:
mov.b @(4,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 03C8 - 03CF
K3C8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(4,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 03D0 - 03D7
K3D0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 03D8 - 03DF
K3D8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 03E0 - 03E7
K3E0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 03E8 - 03EF
K3E8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 03F0 - 03F7
K3F0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 03F8
K3F8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 03F9
K3F9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(4,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0400 - 0407
K400:
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes 0410 - 0417
K410:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 0418 - 041F
K418:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-16,r7
! Opcodes 0420 - 0427
K420:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-18,r7
! Opcodes 0428 - 042F
K428:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 0430 - 0437
K430:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-22,r7
! Opcode 0438
K438:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcode 0439
K439:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 0440 - 0447
K440:
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes 0450 - 0457
K450:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 0458 - 045F
K458:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-16,r7
! Opcodes 0460 - 0467
K460:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-18,r7
! Opcodes 0468 - 046F
K468:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 0470 - 0477
K470:
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-22,r7
! Opcode 0478
K478:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcode 0479
K479:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 0480 - 0487
K480:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes 0490 - 0497
K490:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 0498 - 049F
K498:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-28,r7
! Opcodes 04A0 - 04A7
K4A0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-30,r7
! Opcodes 04A8 - 04AF
K4A8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-32,r7
! Opcodes 04B0 - 04B7
K4B0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-34,r7
! Opcode 04B8
K4B8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-32,r7
! Opcode 04B9
K4B9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-36,r7
! Opcodes 0500 - 0507
K500:
mov.b @(8,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-6,r7
! Opcodes 0508 - 050F
K508:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #8,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0510 - 0517
K510:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0518 - 051F
K518:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0520 - 0527
K520:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-10,r7
! Opcodes 0528 - 052F
K528:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0530 - 0537
K530:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0538
K538:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0539
K539:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 053A
K53A:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 053B
K53B:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 053C
K53C:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.b @r6,r3
add #2,r6
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0540 - 0547
K540:
mov.b @(8,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0548 - 054F
K548:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(8,r13)
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0550 - 0557
K550:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0558 - 055F
K558:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0560 - 0567
K560:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0568 - 056F
K568:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0570 - 0577
K570:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0578
K578:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0579
K579:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0580 - 0587
K580:
mov.b @(8,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-10,r7
! Opcodes 0588 - 058F
K588:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(8,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0590 - 0597
K590:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0598 - 059F
K598:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 05A0 - 05A7
K5A0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 05A8 - 05AF
K5A8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 05B0 - 05B7
K5B0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 05B8
K5B8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 05B9
K5B9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 05C0 - 05C7
K5C0:
mov.b @(8,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 05C8 - 05CF
K5C8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(8,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 05D0 - 05D7
K5D0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 05D8 - 05DF
K5D8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 05E0 - 05E7
K5E0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 05E8 - 05EF
K5E8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 05F0 - 05F7
K5F0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 05F8
K5F8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 05F9
K5F9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(8,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0600 - 0607
K600:
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes 0610 - 0617
K610:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 0618 - 061F
K618:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-16,r7
! Opcodes 0620 - 0627
K620:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-18,r7
! Opcodes 0628 - 062F
K628:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 0630 - 0637
K630:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-22,r7
! Opcode 0638
K638:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcode 0639
K639:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 0640 - 0647
K640:
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes 0650 - 0657
K650:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 0658 - 065F
K658:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-16,r7
! Opcodes 0660 - 0667
K660:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-18,r7
! Opcodes 0668 - 066F
K668:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 0670 - 0677
K670:
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-22,r7
! Opcode 0678
K678:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcode 0679
K679:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 0680 - 0687
K680:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes 0690 - 0697
K690:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 0698 - 069F
K698:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-28,r7
! Opcodes 06A0 - 06A7
K6A0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-30,r7
! Opcodes 06A8 - 06AF
K6A8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-32,r7
! Opcodes 06B0 - 06B7
K6B0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-34,r7
! Opcode 06B8
K6B8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-32,r7
! Opcode 06B9
K6B9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-36,r7
! Opcodes 0700 - 0707
K700:
mov.b @(12,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-6,r7
! Opcodes 0708 - 070F
K708:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #12,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0710 - 0717
K710:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0718 - 071F
K718:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0720 - 0727
K720:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-10,r7
! Opcodes 0728 - 072F
K728:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0730 - 0737
K730:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0738
K738:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0739
K739:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 073A
K73A:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 073B
K73B:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 073C
K73C:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.b @r6,r3
add #2,r6
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0740 - 0747
K740:
mov.b @(12,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0748 - 074F
K748:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(12,r13)
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0750 - 0757
K750:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0758 - 075F
K758:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0760 - 0767
K760:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0768 - 076F
K768:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0770 - 0777
K770:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0778
K778:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0779
K779:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0780 - 0787
K780:
mov.b @(12,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-10,r7
! Opcodes 0788 - 078F
K788:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(12,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0790 - 0797
K790:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0798 - 079F
K798:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 07A0 - 07A7
K7A0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 07A8 - 07AF
K7A8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 07B0 - 07B7
K7B0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 07B8
K7B8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 07B9
K7B9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 07C0 - 07C7
K7C0:
mov.b @(12,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 07C8 - 07CF
K7C8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(12,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 07D0 - 07D7
K7D0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 07D8 - 07DF
K7D8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 07E0 - 07E7
K7E0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 07E8 - 07EF
K7E8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 07F0 - 07F7
K7F0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 07F8
K7F8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 07F9
K7F9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @(12,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0800 - 0807
K800:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-10,r7
! Opcodes 0810 - 0817
K810:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0818 - 081F
K818:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0820 - 0827
K820:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcodes 0828 - 082F
K828:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcodes 0830 - 0837
K830:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-18,r7
! Opcode 0838
K838:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 0839
K839:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-20,r7
! Opcode 083A
K83A:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 083B
K83B:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-18,r7
! Opcode 083C
K83C:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.b @r6,r3
add #2,r6
mov.l @r15+,r0
mov #1,r1
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0840 - 0847
K840:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-12,r7
! Opcodes 0850 - 0857
K850:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0858 - 085F
K858:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0860 - 0867
K860:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcodes 0868 - 086F
K868:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0870 - 0877
K870:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-22,r7
! Opcode 0878
K878:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcode 0879
K879:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-24,r7
! Opcodes 0880 - 0887
K880:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-14,r7
! Opcodes 0890 - 0897
K890:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0898 - 089F
K898:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 08A0 - 08A7
K8A0:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcodes 08A8 - 08AF
K8A8:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 08B0 - 08B7
K8B0:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-22,r7
! Opcode 08B8
K8B8:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcode 08B9
K8B9:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-24,r7
! Opcodes 08C0 - 08C7
K8C0:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-12,r7
! Opcodes 08D0 - 08D7
K8D0:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 08D8 - 08DF
K8D8:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 08E0 - 08E7
K8E0:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcodes 08E8 - 08EF
K8E8:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 08F0 - 08F7
K8F0:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-22,r7
! Opcode 08F8
K8F8:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcode 08F9
K8F9:
mov.w @r6+,r0
rotl r3
movt r1
shll2 r1
xor r1,r8
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-24,r7
! Opcodes 0900 - 0907
K900:
mov #16,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-6,r7
! Opcodes 0908 - 090F
K908:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #16,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0910 - 0917
K910:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0918 - 091F
K918:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0920 - 0927
K920:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-10,r7
! Opcodes 0928 - 092F
K928:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0930 - 0937
K930:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0938
K938:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0939
K939:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 093A
K93A:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 093B
K93B:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 093C
K93C:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0940 - 0947
K940:
mov #16,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0948 - 094F
K948:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(16,r13)
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0950 - 0957
K950:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0958 - 095F
K958:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0960 - 0967
K960:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0968 - 096F
K968:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0970 - 0977
K970:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0978
K978:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0979
K979:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0980 - 0987
K980:
mov #16,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-10,r7
! Opcodes 0988 - 098F
K988:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(16,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0990 - 0997
K990:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0998 - 099F
K998:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 09A0 - 09A7
K9A0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 09A8 - 09AF
K9A8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 09B0 - 09B7
K9B0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 09B8
K9B8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 09B9
K9B9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 09C0 - 09C7
K9C0:
mov #16,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 09C8 - 09CF
K9C8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(16,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 09D0 - 09D7
K9D0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 09D8 - 09DF
K9D8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 09E0 - 09E7
K9E0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 09E8 - 09EF
K9E8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 09F0 - 09F7
K9F0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 09F8
K9F8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 09F9
K9F9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0A00 - 0A07
KA00:
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
xor r1,r3
mov.b r3,@r2
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 0A10 - 0A17
KA10:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0A18 - 0A1F
KA18:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0A20 - 0A27
KA20:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 0A28 - 0A2F
KA28:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 0A30 - 0A37
KA30:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 0A38
KA38:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 0A39
KA39:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 0A3C
KA3C:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
xor r2,r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-20,r7
! Opcodes 0A40 - 0A47
KA40:
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
xor r1,r3
mov.w r3,@r2
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 0A50 - 0A57
KA50:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0A58 - 0A5F
KA58:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0A60 - 0A67
KA60:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 0A68 - 0A6F
KA68:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 0A70 - 0A77
KA70:
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 0A78
KA78:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 0A79
KA79:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 0A7C
KA7C:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok48
mov.l priviolation_addr48,r0
jmp @r0
nop
.align 2
priviolation_addr48: .long privilege_violation
pcheck_ok48:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
xor r2,r3
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln49
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln49:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr51,r4
jmp @r4
add #-20,r7
.align 2
fdl_cp_addr51: .long fdl_cp
! Opcodes 0A80 - 0A87
KA80:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
xor r1,r3
mov.l r3,@r2
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 0A90 - 0A97
KA90:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 0A98 - 0A9F
KA98:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 0AA0 - 0AA7
KAA0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 0AA8 - 0AAF
KAA8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcodes 0AB0 - 0AB7
KAB0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 0AB8
KAB8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 0AB9
KAB9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-36,r7
! Opcodes 0B00 - 0B07
KB00:
mov #20,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-6,r7
! Opcodes 0B08 - 0B0F
KB08:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #20,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0B10 - 0B17
KB10:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0B18 - 0B1F
KB18:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0B20 - 0B27
KB20:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-10,r7
! Opcodes 0B28 - 0B2F
KB28:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0B30 - 0B37
KB30:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0B38
KB38:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0B39
KB39:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 0B3A
KB3A:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0B3B
KB3B:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0B3C
KB3C:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0B40 - 0B47
KB40:
mov #20,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0B48 - 0B4F
KB48:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(20,r13)
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0B50 - 0B57
KB50:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0B58 - 0B5F
KB58:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0B60 - 0B67
KB60:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0B68 - 0B6F
KB68:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0B70 - 0B77
KB70:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0B78
KB78:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0B79
KB79:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0B80 - 0B87
KB80:
mov #20,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-10,r7
! Opcodes 0B88 - 0B8F
KB88:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(20,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0B90 - 0B97
KB90:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0B98 - 0B9F
KB98:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0BA0 - 0BA7
KBA0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0BA8 - 0BAF
KBA8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0BB0 - 0BB7
KBB0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0BB8
KBB8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0BB9
KBB9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0BC0 - 0BC7
KBC0:
mov #20,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0BC8 - 0BCF
KBC8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(20,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0BD0 - 0BD7
KBD0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0BD8 - 0BDF
KBD8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0BE0 - 0BE7
KBE0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0BE8 - 0BEF
KBE8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0BF0 - 0BF7
KBF0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0BF8
KBF8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0BF9
KBF9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0C00 - 0C07
KC00:
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-8,r7
! Opcodes 0C10 - 0C17
KC10:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes 0C18 - 0C1F
KC18:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes 0C20 - 0C27
KC20:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-14,r7
! Opcodes 0C28 - 0C2F
KC28:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-16,r7
! Opcodes 0C30 - 0C37
KC30:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-18,r7
! Opcode 0C38
KC38:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-16,r7
! Opcode 0C39
KC39:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-20,r7
! Opcodes 0C40 - 0C47
KC40:
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-8,r7
! Opcodes 0C50 - 0C57
KC50:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes 0C58 - 0C5F
KC58:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes 0C60 - 0C67
KC60:
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-14,r7
! Opcodes 0C68 - 0C6F
KC68:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-16,r7
! Opcodes 0C70 - 0C77
KC70:
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-18,r7
! Opcode 0C78
KC78:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-16,r7
! Opcode 0C79
KC79:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-20,r7
! Opcodes 0C80 - 0C87
KC80:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
jmp @r10
add #-14,r7
! Opcodes 0C90 - 0C97
KC90:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes 0C98 - 0C9F
KC98:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes 0CA0 - 0CA7
KCA0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
jmp @r10
add #-22,r7
! Opcodes 0CA8 - 0CAF
KCA8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
jmp @r10
add #-24,r7
! Opcodes 0CB0 - 0CB7
KCB0:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
jmp @r10
add #-26,r7
! Opcode 0CB8
KCB8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
jmp @r10
add #-24,r7
! Opcode 0CB9
KCB9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
addc r8,r8
jmp @r10
add #-28,r7
! Opcodes 0D00 - 0D07
KD00:
mov #24,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-6,r7
! Opcodes 0D08 - 0D0F
KD08:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #24,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0D10 - 0D17
KD10:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0D18 - 0D1F
KD18:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0D20 - 0D27
KD20:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-10,r7
! Opcodes 0D28 - 0D2F
KD28:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0D30 - 0D37
KD30:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0D38
KD38:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0D39
KD39:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 0D3A
KD3A:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0D3B
KD3B:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0D3C
KD3C:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0D40 - 0D47
KD40:
mov #24,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0D48 - 0D4F
KD48:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(24,r13)
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0D50 - 0D57
KD50:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0D58 - 0D5F
KD58:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0D60 - 0D67
KD60:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0D68 - 0D6F
KD68:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0D70 - 0D77
KD70:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0D78
KD78:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0D79
KD79:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0D80 - 0D87
KD80:
mov #24,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-10,r7
! Opcodes 0D88 - 0D8F
KD88:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(24,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0D90 - 0D97
KD90:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0D98 - 0D9F
KD98:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0DA0 - 0DA7
KDA0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0DA8 - 0DAF
KDA8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0DB0 - 0DB7
KDB0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0DB8
KDB8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0DB9
KDB9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0DC0 - 0DC7
KDC0:
mov #24,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0DC8 - 0DCF
KDC8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(24,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0DD0 - 0DD7
KDD0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0DD8 - 0DDF
KDD8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0DE0 - 0DE7
KDE0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0DE8 - 0DEF
KDE8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0DF0 - 0DF7
KDF0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0DF8
KDF8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0DF9
KDF9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0F00 - 0F07
KF00:
mov #28,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
jmp @r10
add #-6,r7
! Opcodes 0F08 - 0F0F
KF08:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #28,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0F10 - 0F17
KF10:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0F18 - 0F1F
KF18:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0F20 - 0F27
KF20:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-10,r7
! Opcodes 0F28 - 0F2F
KF28:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcodes 0F30 - 0F37
KF30:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0F38
KF38:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0F39
KF39:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-16,r7
! Opcode 0F3A
KF3A:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-12,r7
! Opcode 0F3B
KF3B:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-14,r7
! Opcode 0F3C
KF3C:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
and r1,r3
jmp @r10
add #-8,r7
! Opcodes 0F40 - 0F47
KF40:
mov #28,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
xor r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0F48 - 0F4F
KF48:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(28,r13)
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0F50 - 0F57
KF50:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0F58 - 0F5F
KF58:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0F60 - 0F67
KF60:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0F68 - 0F6F
KF68:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0F70 - 0F77
KF70:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0F78
KF78:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0F79
KF79:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0F80 - 0F87
KF80:
mov #28,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
not r4,r4
and r4,r1
mov.l r1,@r2
jmp @r10
add #-10,r7
! Opcodes 0F88 - 0F8F
KF88:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(28,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 0F90 - 0F97
KF90:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0F98 - 0F9F
KF98:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0FA0 - 0FA7
KFA0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0FA8 - 0FAF
KFA8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0FB0 - 0FB7
KFB0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0FB8
KFB8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0FB9
KFB9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 0FC0 - 0FC7
KFC0:
mov #28,r0
mov.b @(r0,r13),r0
rotl r3
movt r1
shll2 r1
xor r1,r8
mov #1,r4
and #31,r0
add r13,r2
mov.l @r2,r1
shld r0,r4
tst r4,r1
movt r3
dt r3
shlr r3
or r4,r1
mov.l r1,@r2
jmp @r10
add #-8,r7
! Opcodes 0FC8 - 0FCF
KFC8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(28,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcodes 0FD0 - 0FD7
KFD0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0FD8 - 0FDF
KFD8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-12,r7
! Opcodes 0FE0 - 0FE7
KFE0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-14,r7
! Opcodes 0FE8 - 0FEF
KFE8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcodes 0FF0 - 0FF7
KFF0:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-18,r7
! Opcode 0FF8
KFF8:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-16,r7
! Opcode 0FF9
KFF9:
rotl r3
movt r1
shll2 r1
xor r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
mov #1,r1
and #7,r0
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
shlr r3
jmp @r10
add #-20,r7
! Opcodes 1000 - 1007
L000:
add r13,r2
mov.b @r2,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1008 - 100F
L008:
add r14,r2
mov.b @r2,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1010 - 1017
L010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1018 - 101F
L018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1020 - 1027
L020:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 1028 - 102F
L028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1030 - 1037
L030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1038
L038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1039
L039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 103A
L03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 103B
L03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 103C
L03C:
mov.b @r6,r3
add #2,r6
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1080 - 1087
L080:
add r13,r2
mov.b @r2,r3
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1088 - 108F
L088:
add r14,r2
mov.b @r2,r3
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1090 - 1097
L090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1098 - 109F
L098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 10A0 - 10A7
L0A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 10A8 - 10AF
L0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 10B0 - 10B7
L0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 10B8
L0B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 10B9
L0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 10BA
L0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 10BB
L0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 10BC
L0BC:
mov.b @r6,r3
add #2,r6
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 10C0 - 10C7
L0C0:
add r13,r2
mov.b @r2,r3
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 10C8 - 10CF
L0C8:
add r14,r2
mov.b @r2,r3
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 10D0 - 10D7
L0D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 10D8 - 10DF
L0D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 10E0 - 10E7
L0E0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 10E8 - 10EF
L0E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 10F0 - 10F7
L0F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 10F8
L0F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 10F9
L0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 10FA
L0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 10FB
L0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 10FC
L0FC:
mov.b @r6,r3
add #2,r6
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1100 - 1107
L100:
add r13,r2
mov.b @r2,r3
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1108 - 110F
L108:
add r14,r2
mov.b @r2,r3
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1110 - 1117
L110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1118 - 111F
L118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1120 - 1127
L120:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1128 - 112F
L128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1130 - 1137
L130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1138
L138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1139
L139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 113A
L13A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 113B
L13B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 113C
L13C:
mov.b @r6,r3
add #2,r6
mov.l @(32,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1140 - 1147
L140:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1148 - 114F
L148:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1150 - 1157
L150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1158 - 115F
L158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1160 - 1167
L160:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1168 - 116F
L168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1170 - 1177
L170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1178
L178:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1179
L179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 117A
L17A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 117B
L17B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 117C
L17C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1180 - 1187
L180:
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1188 - 118F
L188:
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1190 - 1197
L190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1198 - 119F
L198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 11A0 - 11A7
L1A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 11A8 - 11AF
L1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 11B0 - 11B7
L1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 11B8
L1B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 11B9
L1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 11BA
L1BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 11BB
L1BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 11BC
L1BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 11C0 - 11C7
L1C0:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 11C8 - 11CF
L1C8:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 11D0 - 11D7
L1D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 11D8 - 11DF
L1D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 11E0 - 11E7
L1E0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 11E8 - 11EF
L1E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 11F0 - 11F7
L1F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 11F8
L1F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 11F9
L1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 11FA
L1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 11FB
L1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 11FC
L1FC:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1200 - 1207
L200:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1208 - 120F
L208:
add r14,r2
mov.b @r2,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1210 - 1217
L210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1218 - 121F
L218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1220 - 1227
L220:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 1228 - 122F
L228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1230 - 1237
L230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1238
L238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1239
L239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 123A
L23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 123B
L23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 123C
L23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1280 - 1287
L280:
add r13,r2
mov.b @r2,r3
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1288 - 128F
L288:
add r14,r2
mov.b @r2,r3
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1290 - 1297
L290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1298 - 129F
L298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 12A0 - 12A7
L2A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 12A8 - 12AF
L2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 12B0 - 12B7
L2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 12B8
L2B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 12B9
L2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 12BA
L2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 12BB
L2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 12BC
L2BC:
mov.b @r6,r3
add #2,r6
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 12C0 - 12C7
L2C0:
add r13,r2
mov.b @r2,r3
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 12C8 - 12CF
L2C8:
add r14,r2
mov.b @r2,r3
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 12D0 - 12D7
L2D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 12D8 - 12DF
L2D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 12E0 - 12E7
L2E0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 12E8 - 12EF
L2E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 12F0 - 12F7
L2F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 12F8
L2F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 12F9
L2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 12FA
L2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 12FB
L2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 12FC
L2FC:
mov.b @r6,r3
add #2,r6
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1300 - 1307
L300:
add r13,r2
mov.b @r2,r3
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1308 - 130F
L308:
add r14,r2
mov.b @r2,r3
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1310 - 1317
L310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1318 - 131F
L318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1320 - 1327
L320:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1328 - 132F
L328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1330 - 1337
L330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1338
L338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1339
L339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 133A
L33A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 133B
L33B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 133C
L33C:
mov.b @r6,r3
add #2,r6
mov.l @(36,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1340 - 1347
L340:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1348 - 134F
L348:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1350 - 1357
L350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1358 - 135F
L358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1360 - 1367
L360:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1368 - 136F
L368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1370 - 1377
L370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1378
L378:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1379
L379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 137A
L37A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 137B
L37B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 137C
L37C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1380 - 1387
L380:
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1388 - 138F
L388:
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1390 - 1397
L390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1398 - 139F
L398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 13A0 - 13A7
L3A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 13A8 - 13AF
L3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 13B0 - 13B7
L3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 13B8
L3B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 13B9
L3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 13BA
L3BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 13BB
L3BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 13BC
L3BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 13C0 - 13C7
L3C0:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 13C8 - 13CF
L3C8:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 13D0 - 13D7
L3D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 13D8 - 13DF
L3D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 13E0 - 13E7
L3E0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 13E8 - 13EF
L3E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 13F0 - 13F7
L3F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 13F8
L3F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 13F9
L3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 13FA
L3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 13FB
L3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 13FC
L3FC:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1400 - 1407
L400:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1408 - 140F
L408:
add r14,r2
mov.b @r2,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1410 - 1417
L410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1418 - 141F
L418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1420 - 1427
L420:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 1428 - 142F
L428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1430 - 1437
L430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1438
L438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1439
L439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 143A
L43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 143B
L43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 143C
L43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1480 - 1487
L480:
add r13,r2
mov.b @r2,r3
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1488 - 148F
L488:
add r14,r2
mov.b @r2,r3
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1490 - 1497
L490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1498 - 149F
L498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 14A0 - 14A7
L4A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 14A8 - 14AF
L4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 14B0 - 14B7
L4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 14B8
L4B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 14B9
L4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 14BA
L4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 14BB
L4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 14BC
L4BC:
mov.b @r6,r3
add #2,r6
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 14C0 - 14C7
L4C0:
add r13,r2
mov.b @r2,r3
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 14C8 - 14CF
L4C8:
add r14,r2
mov.b @r2,r3
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 14D0 - 14D7
L4D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 14D8 - 14DF
L4D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 14E0 - 14E7
L4E0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 14E8 - 14EF
L4E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 14F0 - 14F7
L4F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 14F8
L4F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 14F9
L4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 14FA
L4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 14FB
L4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 14FC
L4FC:
mov.b @r6,r3
add #2,r6
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1500 - 1507
L500:
add r13,r2
mov.b @r2,r3
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1508 - 150F
L508:
add r14,r2
mov.b @r2,r3
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1510 - 1517
L510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1518 - 151F
L518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1520 - 1527
L520:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1528 - 152F
L528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1530 - 1537
L530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1538
L538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1539
L539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 153A
L53A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 153B
L53B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 153C
L53C:
mov.b @r6,r3
add #2,r6
mov.l @(40,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1540 - 1547
L540:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1548 - 154F
L548:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1550 - 1557
L550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1558 - 155F
L558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1560 - 1567
L560:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1568 - 156F
L568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1570 - 1577
L570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1578
L578:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1579
L579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 157A
L57A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 157B
L57B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 157C
L57C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1580 - 1587
L580:
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1588 - 158F
L588:
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1590 - 1597
L590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1598 - 159F
L598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 15A0 - 15A7
L5A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 15A8 - 15AF
L5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 15B0 - 15B7
L5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 15B8
L5B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 15B9
L5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 15BA
L5BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 15BB
L5BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 15BC
L5BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1600 - 1607
L600:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1608 - 160F
L608:
add r14,r2
mov.b @r2,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1610 - 1617
L610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1618 - 161F
L618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1620 - 1627
L620:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 1628 - 162F
L628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1630 - 1637
L630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1638
L638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1639
L639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 163A
L63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 163B
L63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 163C
L63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1680 - 1687
L680:
add r13,r2
mov.b @r2,r3
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1688 - 168F
L688:
add r14,r2
mov.b @r2,r3
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1690 - 1697
L690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1698 - 169F
L698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 16A0 - 16A7
L6A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 16A8 - 16AF
L6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 16B0 - 16B7
L6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 16B8
L6B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 16B9
L6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 16BA
L6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 16BB
L6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 16BC
L6BC:
mov.b @r6,r3
add #2,r6
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 16C0 - 16C7
L6C0:
add r13,r2
mov.b @r2,r3
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 16C8 - 16CF
L6C8:
add r14,r2
mov.b @r2,r3
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 16D0 - 16D7
L6D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 16D8 - 16DF
L6D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 16E0 - 16E7
L6E0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 16E8 - 16EF
L6E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 16F0 - 16F7
L6F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 16F8
L6F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 16F9
L6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 16FA
L6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 16FB
L6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 16FC
L6FC:
mov.b @r6,r3
add #2,r6
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1700 - 1707
L700:
add r13,r2
mov.b @r2,r3
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1708 - 170F
L708:
add r14,r2
mov.b @r2,r3
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1710 - 1717
L710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1718 - 171F
L718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1720 - 1727
L720:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1728 - 172F
L728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1730 - 1737
L730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1738
L738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1739
L739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 173A
L73A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 173B
L73B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 173C
L73C:
mov.b @r6,r3
add #2,r6
mov.l @(44,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1740 - 1747
L740:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1748 - 174F
L748:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1750 - 1757
L750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1758 - 175F
L758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1760 - 1767
L760:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1768 - 176F
L768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1770 - 1777
L770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1778
L778:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1779
L779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 177A
L77A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 177B
L77B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 177C
L77C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1780 - 1787
L780:
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1788 - 178F
L788:
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1790 - 1797
L790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1798 - 179F
L798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 17A0 - 17A7
L7A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 17A8 - 17AF
L7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 17B0 - 17B7
L7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 17B8
L7B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 17B9
L7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 17BA
L7BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 17BB
L7BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 17BC
L7BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1800 - 1807
L800:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1808 - 180F
L808:
add r14,r2
mov.b @r2,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1810 - 1817
L810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1818 - 181F
L818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1820 - 1827
L820:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 1828 - 182F
L828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1830 - 1837
L830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1838
L838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1839
L839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 183A
L83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 183B
L83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 183C
L83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1880 - 1887
L880:
add r13,r2
mov.b @r2,r3
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1888 - 188F
L888:
add r14,r2
mov.b @r2,r3
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1890 - 1897
L890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1898 - 189F
L898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 18A0 - 18A7
L8A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 18A8 - 18AF
L8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 18B0 - 18B7
L8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 18B8
L8B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 18B9
L8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 18BA
L8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 18BB
L8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 18BC
L8BC:
mov.b @r6,r3
add #2,r6
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 18C0 - 18C7
L8C0:
add r13,r2
mov.b @r2,r3
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 18C8 - 18CF
L8C8:
add r14,r2
mov.b @r2,r3
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 18D0 - 18D7
L8D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 18D8 - 18DF
L8D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 18E0 - 18E7
L8E0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 18E8 - 18EF
L8E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 18F0 - 18F7
L8F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 18F8
L8F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 18F9
L8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 18FA
L8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 18FB
L8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 18FC
L8FC:
mov.b @r6,r3
add #2,r6
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1900 - 1907
L900:
add r13,r2
mov.b @r2,r3
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1908 - 190F
L908:
add r14,r2
mov.b @r2,r3
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1910 - 1917
L910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1918 - 191F
L918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1920 - 1927
L920:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1928 - 192F
L928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1930 - 1937
L930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1938
L938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1939
L939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 193A
L93A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 193B
L93B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 193C
L93C:
mov.b @r6,r3
add #2,r6
mov.l @(48,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1940 - 1947
L940:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1948 - 194F
L948:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1950 - 1957
L950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1958 - 195F
L958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1960 - 1967
L960:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1968 - 196F
L968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1970 - 1977
L970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1978
L978:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1979
L979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 197A
L97A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 197B
L97B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 197C
L97C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1980 - 1987
L980:
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1988 - 198F
L988:
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1990 - 1997
L990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1998 - 199F
L998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 19A0 - 19A7
L9A0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 19A8 - 19AF
L9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 19B0 - 19B7
L9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 19B8
L9B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 19B9
L9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 19BA
L9BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 19BB
L9BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 19BC
L9BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1A00 - 1A07
LA00:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1A08 - 1A0F
LA08:
add r14,r2
mov.b @r2,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1A10 - 1A17
LA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1A18 - 1A1F
LA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1A20 - 1A27
LA20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 1A28 - 1A2F
LA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1A30 - 1A37
LA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1A38
LA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1A39
LA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1A3A
LA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1A3B
LA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1A3C
LA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1A80 - 1A87
LA80:
add r13,r2
mov.b @r2,r3
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1A88 - 1A8F
LA88:
add r14,r2
mov.b @r2,r3
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1A90 - 1A97
LA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1A98 - 1A9F
LA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1AA0 - 1AA7
LAA0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1AA8 - 1AAF
LAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1AB0 - 1AB7
LAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1AB8
LAB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1AB9
LAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1ABA
LABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1ABB
LABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1ABC
LABC:
mov.b @r6,r3
add #2,r6
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1AC0 - 1AC7
LAC0:
add r13,r2
mov.b @r2,r3
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1AC8 - 1ACF
LAC8:
add r14,r2
mov.b @r2,r3
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1AD0 - 1AD7
LAD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1AD8 - 1ADF
LAD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1AE0 - 1AE7
LAE0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1AE8 - 1AEF
LAE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1AF0 - 1AF7
LAF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1AF8
LAF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1AF9
LAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1AFA
LAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1AFB
LAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1AFC
LAFC:
mov.b @r6,r3
add #2,r6
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1B00 - 1B07
LB00:
add r13,r2
mov.b @r2,r3
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1B08 - 1B0F
LB08:
add r14,r2
mov.b @r2,r3
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1B10 - 1B17
LB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1B18 - 1B1F
LB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1B20 - 1B27
LB20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1B28 - 1B2F
LB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1B30 - 1B37
LB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1B38
LB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1B39
LB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1B3A
LB3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1B3B
LB3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1B3C
LB3C:
mov.b @r6,r3
add #2,r6
mov.l @(52,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1B40 - 1B47
LB40:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1B48 - 1B4F
LB48:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1B50 - 1B57
LB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1B58 - 1B5F
LB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1B60 - 1B67
LB60:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1B68 - 1B6F
LB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1B70 - 1B77
LB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1B78
LB78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1B79
LB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1B7A
LB7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1B7B
LB7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1B7C
LB7C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1B80 - 1B87
LB80:
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1B88 - 1B8F
LB88:
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1B90 - 1B97
LB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1B98 - 1B9F
LB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1BA0 - 1BA7
LBA0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1BA8 - 1BAF
LBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 1BB0 - 1BB7
LBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1BB8
LBB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1BB9
LBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 1BBA
LBBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1BBB
LBBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1BBC
LBBC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1C00 - 1C07
LC00:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1C08 - 1C0F
LC08:
add r14,r2
mov.b @r2,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1C10 - 1C17
LC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1C18 - 1C1F
LC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1C20 - 1C27
LC20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 1C28 - 1C2F
LC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1C30 - 1C37
LC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1C38
LC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1C39
LC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1C3A
LC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1C3B
LC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1C3C
LC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1C80 - 1C87
LC80:
add r13,r2
mov.b @r2,r3
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1C88 - 1C8F
LC88:
add r14,r2
mov.b @r2,r3
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1C90 - 1C97
LC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1C98 - 1C9F
LC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1CA0 - 1CA7
LCA0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1CA8 - 1CAF
LCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1CB0 - 1CB7
LCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1CB8
LCB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1CB9
LCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1CBA
LCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1CBB
LCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1CBC
LCBC:
mov.b @r6,r3
add #2,r6
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1CC0 - 1CC7
LCC0:
add r13,r2
mov.b @r2,r3
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1CC8 - 1CCF
LCC8:
add r14,r2
mov.b @r2,r3
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1CD0 - 1CD7
LCD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1CD8 - 1CDF
LCD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1CE0 - 1CE7
LCE0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1CE8 - 1CEF
LCE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1CF0 - 1CF7
LCF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1CF8
LCF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1CF9
LCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1CFA
LCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1CFB
LCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1CFC
LCFC:
mov.b @r6,r3
add #2,r6
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1D00 - 1D07
LD00:
add r13,r2
mov.b @r2,r3
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1D08 - 1D0F
LD08:
add r14,r2
mov.b @r2,r3
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1D10 - 1D17
LD10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1D18 - 1D1F
LD18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1D20 - 1D27
LD20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1D28 - 1D2F
LD28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1D30 - 1D37
LD30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1D38
LD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1D39
LD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1D3A
LD3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1D3B
LD3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1D3C
LD3C:
mov.b @r6,r3
add #2,r6
mov.l @(56,r13),r4
add #-1,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1D40 - 1D47
LD40:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1D48 - 1D4F
LD48:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1D50 - 1D57
LD50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1D58 - 1D5F
LD58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1D60 - 1D67
LD60:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1D68 - 1D6F
LD68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1D70 - 1D77
LD70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1D78
LD78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1D79
LD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1D7A
LD7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1D7B
LD7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1D7C
LD7C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1D80 - 1D87
LD80:
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1D88 - 1D8F
LD88:
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1D90 - 1D97
LD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1D98 - 1D9F
LD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1DA0 - 1DA7
LDA0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1DA8 - 1DAF
LDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 1DB0 - 1DB7
LDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1DB8
LDB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1DB9
LDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 1DBA
LDBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1DBB
LDBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1DBC
LDBC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1E00 - 1E07
LE00:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1E08 - 1E0F
LE08:
add r14,r2
mov.b @r2,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 1E10 - 1E17
LE10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1E18 - 1E1F
LE18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1E20 - 1E27
LE20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 1E28 - 1E2F
LE28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1E30 - 1E37
LE30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1E38
LE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1E39
LE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1E3A
LE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 1E3B
LE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 1E3C
LE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1E80 - 1E87
LE80:
add r13,r2
mov.b @r2,r3
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1E88 - 1E8F
LE88:
add r14,r2
mov.b @r2,r3
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1E90 - 1E97
LE90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1E98 - 1E9F
LE98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1EA0 - 1EA7
LEA0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1EA8 - 1EAF
LEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1EB0 - 1EB7
LEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1EB8
LEB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1EB9
LEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1EBA
LEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1EBB
LEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1EBC
LEBC:
mov.b @r6,r3
add #2,r6
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1EC0 - 1EC7
LEC0:
add r13,r2
mov.b @r2,r3
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1EC8 - 1ECF
LEC8:
add r14,r2
mov.b @r2,r3
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1ED0 - 1ED7
LED0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1ED8 - 1EDF
LED8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1EE0 - 1EE7
LEE0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1EE8 - 1EEF
LEE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1EF0 - 1EF7
LEF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1EF8
LEF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1EF9
LEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1EFA
LEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1EFB
LEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1EFC
LEFC:
mov.b @r6,r3
add #2,r6
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1F00 - 1F07
LF00:
add r13,r2
mov.b @r2,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1F08 - 1F0F
LF08:
add r14,r2
mov.b @r2,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 1F10 - 1F17
LF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1F18 - 1F1F
LF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1F20 - 1F27
LF20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1F28 - 1F2F
LF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1F30 - 1F37
LF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1F38
LF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1F39
LF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1F3A
LF3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 1F3B
LF3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 1F3C
LF3C:
mov.b @r6,r3
add #2,r6
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1F40 - 1F47
LF40:
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1F48 - 1F4F
LF48:
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 1F50 - 1F57
LF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1F58 - 1F5F
LF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1F60 - 1F67
LF60:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1F68 - 1F6F
LF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1F70 - 1F77
LF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1F78
LF78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1F79
LF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1F7A
LF7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 1F7B
LF7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1F7C
LF7C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 1F80 - 1F87
LF80:
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1F88 - 1F8F
LF88:
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 1F90 - 1F97
LF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1F98 - 1F9F
LF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 1FA0 - 1FA7
LFA0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 1FA8 - 1FAF
LFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 1FB0 - 1FB7
LFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1FB8
LFB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1FB9
LFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 1FBA
LFBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 1FBB
LFBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 1FBC
LFBC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2000 - 2007
M000:
add r13,r2
mov.l @r2,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2008 - 200F
M008:
add r14,r2
mov.l @r2,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2010 - 2017
M010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2018 - 201F
M018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2020 - 2027
M020:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 2028 - 202F
M028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2030 - 2037
M030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2038
M038:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2039
M039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 203A
M03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 203B
M03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 203C
M03C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2040 - 2047
M040:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2048 - 204F
M048:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2050 - 2057
M050:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2058 - 205F
M058:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2060 - 2067
M060:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 2068 - 206F
M068:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 2070 - 2077
M070:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2078
M078:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2079
M079:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 207A
M07A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 207B
M07B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 207C
M07C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2080 - 2087
M080:
add r13,r2
mov.l @r2,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2088 - 208F
M088:
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2090 - 2097
M090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2098 - 209F
M098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 20A0 - 20A7
M0A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 20A8 - 20AF
M0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 20B0 - 20B7
M0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 20B8
M0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 20B9
M0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 20BA
M0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 20BB
M0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 20BC
M0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 20C0 - 20C7
M0C0:
add r13,r2
mov.l @r2,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 20C8 - 20CF
M0C8:
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 20D0 - 20D7
M0D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 20D8 - 20DF
M0D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 20E0 - 20E7
M0E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 20E8 - 20EF
M0E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 20F0 - 20F7
M0F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 20F8
M0F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 20F9
M0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 20FA
M0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 20FB
M0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 20FC
M0FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2100 - 2107
M100:
add r13,r2
mov.l @r2,r3
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2108 - 210F
M108:
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2110 - 2117
M110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2118 - 211F
M118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2120 - 2127
M120:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2128 - 212F
M128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2130 - 2137
M130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2138
M138:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2139
M139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 213A
M13A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 213B
M13B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 213C
M13C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2140 - 2147
M140:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2148 - 214F
M148:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2150 - 2157
M150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2158 - 215F
M158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2160 - 2167
M160:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2168 - 216F
M168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2170 - 2177
M170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2178
M178:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2179
M179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 217A
M17A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 217B
M17B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 217C
M17C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2180 - 2187
M180:
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2188 - 218F
M188:
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2190 - 2197
M190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2198 - 219F
M198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 21A0 - 21A7
M1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 21A8 - 21AF
M1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 21B0 - 21B7
M1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 21B8
M1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 21B9
M1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 21BA
M1BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 21BB
M1BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 21BC
M1BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 21C0 - 21C7
M1C0:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 21C8 - 21CF
M1C8:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 21D0 - 21D7
M1D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 21D8 - 21DF
M1D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 21E0 - 21E7
M1E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 21E8 - 21EF
M1E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 21F0 - 21F7
M1F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 21F8
M1F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 21F9
M1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 21FA
M1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 21FB
M1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 21FC
M1FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2200 - 2207
M200:
add r13,r2
mov.l @r2,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2208 - 220F
M208:
add r14,r2
mov.l @r2,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2210 - 2217
M210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2218 - 221F
M218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2220 - 2227
M220:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 2228 - 222F
M228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2230 - 2237
M230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2238
M238:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2239
M239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 223A
M23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 223B
M23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 223C
M23C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2240 - 2247
M240:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2248 - 224F
M248:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2250 - 2257
M250:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2258 - 225F
M258:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2260 - 2267
M260:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 2268 - 226F
M268:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 2270 - 2277
M270:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2278
M278:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2279
M279:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 227A
M27A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 227B
M27B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 227C
M27C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2280 - 2287
M280:
add r13,r2
mov.l @r2,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2288 - 228F
M288:
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2290 - 2297
M290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2298 - 229F
M298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 22A0 - 22A7
M2A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 22A8 - 22AF
M2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 22B0 - 22B7
M2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 22B8
M2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 22B9
M2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 22BA
M2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 22BB
M2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 22BC
M2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 22C0 - 22C7
M2C0:
add r13,r2
mov.l @r2,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 22C8 - 22CF
M2C8:
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 22D0 - 22D7
M2D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 22D8 - 22DF
M2D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 22E0 - 22E7
M2E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 22E8 - 22EF
M2E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 22F0 - 22F7
M2F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 22F8
M2F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 22F9
M2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 22FA
M2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 22FB
M2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 22FC
M2FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2300 - 2307
M300:
add r13,r2
mov.l @r2,r3
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2308 - 230F
M308:
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2310 - 2317
M310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2318 - 231F
M318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2320 - 2327
M320:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2328 - 232F
M328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2330 - 2337
M330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2338
M338:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2339
M339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 233A
M33A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 233B
M33B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 233C
M33C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2340 - 2347
M340:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2348 - 234F
M348:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2350 - 2357
M350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2358 - 235F
M358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2360 - 2367
M360:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2368 - 236F
M368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2370 - 2377
M370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2378
M378:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2379
M379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 237A
M37A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 237B
M37B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 237C
M37C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2380 - 2387
M380:
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2388 - 238F
M388:
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2390 - 2397
M390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2398 - 239F
M398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 23A0 - 23A7
M3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 23A8 - 23AF
M3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 23B0 - 23B7
M3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 23B8
M3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 23B9
M3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 23BA
M3BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 23BB
M3BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 23BC
M3BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 23C0 - 23C7
M3C0:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 23C8 - 23CF
M3C8:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 23D0 - 23D7
M3D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 23D8 - 23DF
M3D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 23E0 - 23E7
M3E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 23E8 - 23EF
M3E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcodes 23F0 - 23F7
M3F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 23F8
M3F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 23F9
M3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-36,r7
! Opcode 23FA
M3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 23FB
M3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 23FC
M3FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2400 - 2407
M400:
add r13,r2
mov.l @r2,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2408 - 240F
M408:
add r14,r2
mov.l @r2,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2410 - 2417
M410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2418 - 241F
M418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2420 - 2427
M420:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 2428 - 242F
M428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2430 - 2437
M430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2438
M438:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2439
M439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 243A
M43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 243B
M43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 243C
M43C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2440 - 2447
M440:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2448 - 244F
M448:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2450 - 2457
M450:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2458 - 245F
M458:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2460 - 2467
M460:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 2468 - 246F
M468:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 2470 - 2477
M470:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2478
M478:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2479
M479:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 247A
M47A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 247B
M47B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 247C
M47C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2480 - 2487
M480:
add r13,r2
mov.l @r2,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2488 - 248F
M488:
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2490 - 2497
M490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2498 - 249F
M498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 24A0 - 24A7
M4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 24A8 - 24AF
M4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 24B0 - 24B7
M4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 24B8
M4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 24B9
M4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 24BA
M4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 24BB
M4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 24BC
M4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 24C0 - 24C7
M4C0:
add r13,r2
mov.l @r2,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 24C8 - 24CF
M4C8:
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 24D0 - 24D7
M4D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 24D8 - 24DF
M4D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 24E0 - 24E7
M4E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 24E8 - 24EF
M4E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 24F0 - 24F7
M4F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 24F8
M4F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 24F9
M4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 24FA
M4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 24FB
M4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 24FC
M4FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2500 - 2507
M500:
add r13,r2
mov.l @r2,r3
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2508 - 250F
M508:
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2510 - 2517
M510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2518 - 251F
M518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2520 - 2527
M520:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2528 - 252F
M528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2530 - 2537
M530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2538
M538:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2539
M539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 253A
M53A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 253B
M53B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 253C
M53C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2540 - 2547
M540:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2548 - 254F
M548:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2550 - 2557
M550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2558 - 255F
M558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2560 - 2567
M560:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2568 - 256F
M568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2570 - 2577
M570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2578
M578:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2579
M579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 257A
M57A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 257B
M57B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 257C
M57C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2580 - 2587
M580:
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2588 - 258F
M588:
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2590 - 2597
M590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2598 - 259F
M598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 25A0 - 25A7
M5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 25A8 - 25AF
M5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 25B0 - 25B7
M5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 25B8
M5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 25B9
M5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 25BA
M5BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 25BB
M5BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 25BC
M5BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2600 - 2607
M600:
add r13,r2
mov.l @r2,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2608 - 260F
M608:
add r14,r2
mov.l @r2,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2610 - 2617
M610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2618 - 261F
M618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2620 - 2627
M620:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 2628 - 262F
M628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2630 - 2637
M630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2638
M638:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2639
M639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 263A
M63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 263B
M63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 263C
M63C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2640 - 2647
M640:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2648 - 264F
M648:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2650 - 2657
M650:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2658 - 265F
M658:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2660 - 2667
M660:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 2668 - 266F
M668:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 2670 - 2677
M670:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2678
M678:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2679
M679:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 267A
M67A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 267B
M67B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 267C
M67C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2680 - 2687
M680:
add r13,r2
mov.l @r2,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2688 - 268F
M688:
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2690 - 2697
M690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2698 - 269F
M698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 26A0 - 26A7
M6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 26A8 - 26AF
M6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 26B0 - 26B7
M6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 26B8
M6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 26B9
M6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 26BA
M6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 26BB
M6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 26BC
M6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 26C0 - 26C7
M6C0:
add r13,r2
mov.l @r2,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 26C8 - 26CF
M6C8:
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 26D0 - 26D7
M6D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 26D8 - 26DF
M6D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 26E0 - 26E7
M6E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 26E8 - 26EF
M6E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 26F0 - 26F7
M6F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 26F8
M6F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 26F9
M6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 26FA
M6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 26FB
M6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 26FC
M6FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2700 - 2707
M700:
add r13,r2
mov.l @r2,r3
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2708 - 270F
M708:
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2710 - 2717
M710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2718 - 271F
M718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2720 - 2727
M720:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2728 - 272F
M728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2730 - 2737
M730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2738
M738:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2739
M739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 273A
M73A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 273B
M73B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 273C
M73C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2740 - 2747
M740:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2748 - 274F
M748:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2750 - 2757
M750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2758 - 275F
M758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2760 - 2767
M760:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2768 - 276F
M768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2770 - 2777
M770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2778
M778:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2779
M779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 277A
M77A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 277B
M77B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 277C
M77C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2780 - 2787
M780:
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2788 - 278F
M788:
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2790 - 2797
M790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2798 - 279F
M798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 27A0 - 27A7
M7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 27A8 - 27AF
M7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 27B0 - 27B7
M7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 27B8
M7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 27B9
M7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 27BA
M7BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 27BB
M7BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 27BC
M7BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2800 - 2807
M800:
add r13,r2
mov.l @r2,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2808 - 280F
M808:
add r14,r2
mov.l @r2,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2810 - 2817
M810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2818 - 281F
M818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2820 - 2827
M820:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 2828 - 282F
M828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2830 - 2837
M830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2838
M838:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2839
M839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 283A
M83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 283B
M83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 283C
M83C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2840 - 2847
M840:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2848 - 284F
M848:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2850 - 2857
M850:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2858 - 285F
M858:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2860 - 2867
M860:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 2868 - 286F
M868:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 2870 - 2877
M870:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2878
M878:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2879
M879:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 287A
M87A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 287B
M87B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 287C
M87C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2880 - 2887
M880:
add r13,r2
mov.l @r2,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2888 - 288F
M888:
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2890 - 2897
M890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2898 - 289F
M898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 28A0 - 28A7
M8A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 28A8 - 28AF
M8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 28B0 - 28B7
M8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 28B8
M8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 28B9
M8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 28BA
M8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 28BB
M8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 28BC
M8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 28C0 - 28C7
M8C0:
add r13,r2
mov.l @r2,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 28C8 - 28CF
M8C8:
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 28D0 - 28D7
M8D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 28D8 - 28DF
M8D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 28E0 - 28E7
M8E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 28E8 - 28EF
M8E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 28F0 - 28F7
M8F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 28F8
M8F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 28F9
M8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 28FA
M8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 28FB
M8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 28FC
M8FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2900 - 2907
M900:
add r13,r2
mov.l @r2,r3
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2908 - 290F
M908:
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2910 - 2917
M910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2918 - 291F
M918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2920 - 2927
M920:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2928 - 292F
M928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2930 - 2937
M930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2938
M938:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2939
M939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 293A
M93A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 293B
M93B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 293C
M93C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2940 - 2947
M940:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2948 - 294F
M948:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2950 - 2957
M950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2958 - 295F
M958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2960 - 2967
M960:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2968 - 296F
M968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2970 - 2977
M970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2978
M978:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2979
M979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 297A
M97A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 297B
M97B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 297C
M97C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2980 - 2987
M980:
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2988 - 298F
M988:
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2990 - 2997
M990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2998 - 299F
M998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 29A0 - 29A7
M9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 29A8 - 29AF
M9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 29B0 - 29B7
M9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 29B8
M9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 29B9
M9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 29BA
M9BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 29BB
M9BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 29BC
M9BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2A00 - 2A07
MA00:
add r13,r2
mov.l @r2,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2A08 - 2A0F
MA08:
add r14,r2
mov.l @r2,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2A10 - 2A17
MA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2A18 - 2A1F
MA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2A20 - 2A27
MA20:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 2A28 - 2A2F
MA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2A30 - 2A37
MA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2A38
MA38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2A39
MA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 2A3A
MA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2A3B
MA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2A3C
MA3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2A40 - 2A47
MA40:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2A48 - 2A4F
MA48:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2A50 - 2A57
MA50:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2A58 - 2A5F
MA58:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2A60 - 2A67
MA60:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 2A68 - 2A6F
MA68:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 2A70 - 2A77
MA70:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2A78
MA78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2A79
MA79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 2A7A
MA7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2A7B
MA7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2A7C
MA7C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2A80 - 2A87
MA80:
add r13,r2
mov.l @r2,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2A88 - 2A8F
MA88:
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2A90 - 2A97
MA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2A98 - 2A9F
MA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2AA0 - 2AA7
MAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2AA8 - 2AAF
MAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2AB0 - 2AB7
MAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2AB8
MAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2AB9
MAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2ABA
MABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2ABB
MABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2ABC
MABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2AC0 - 2AC7
MAC0:
add r13,r2
mov.l @r2,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2AC8 - 2ACF
MAC8:
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2AD0 - 2AD7
MAD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2AD8 - 2ADF
MAD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2AE0 - 2AE7
MAE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2AE8 - 2AEF
MAE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2AF0 - 2AF7
MAF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2AF8
MAF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2AF9
MAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2AFA
MAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2AFB
MAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2AFC
MAFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2B00 - 2B07
MB00:
add r13,r2
mov.l @r2,r3
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2B08 - 2B0F
MB08:
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2B10 - 2B17
MB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2B18 - 2B1F
MB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2B20 - 2B27
MB20:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2B28 - 2B2F
MB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2B30 - 2B37
MB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2B38
MB38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2B39
MB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2B3A
MB3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2B3B
MB3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2B3C
MB3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2B40 - 2B47
MB40:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2B48 - 2B4F
MB48:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2B50 - 2B57
MB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2B58 - 2B5F
MB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2B60 - 2B67
MB60:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2B68 - 2B6F
MB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2B70 - 2B77
MB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2B78
MB78:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2B79
MB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2B7A
MB7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2B7B
MB7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2B7C
MB7C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2B80 - 2B87
MB80:
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2B88 - 2B8F
MB88:
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2B90 - 2B97
MB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2B98 - 2B9F
MB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2BA0 - 2BA7
MBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2BA8 - 2BAF
MBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 2BB0 - 2BB7
MBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2BB8
MBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2BB9
MBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 2BBA
MBBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2BBB
MBBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2BBC
MBBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2C00 - 2C07
MC00:
add r13,r2
mov.l @r2,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2C08 - 2C0F
MC08:
add r14,r2
mov.l @r2,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2C10 - 2C17
MC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2C18 - 2C1F
MC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2C20 - 2C27
MC20:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 2C28 - 2C2F
MC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2C30 - 2C37
MC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2C38
MC38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2C39
MC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 2C3A
MC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2C3B
MC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2C3C
MC3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2C40 - 2C47
MC40:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2C48 - 2C4F
MC48:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2C50 - 2C57
MC50:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2C58 - 2C5F
MC58:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2C60 - 2C67
MC60:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 2C68 - 2C6F
MC68:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 2C70 - 2C77
MC70:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2C78
MC78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2C79
MC79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 2C7A
MC7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2C7B
MC7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2C7C
MC7C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2C80 - 2C87
MC80:
add r13,r2
mov.l @r2,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2C88 - 2C8F
MC88:
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2C90 - 2C97
MC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2C98 - 2C9F
MC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2CA0 - 2CA7
MCA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2CA8 - 2CAF
MCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2CB0 - 2CB7
MCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2CB8
MCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2CB9
MCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2CBA
MCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2CBB
MCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2CBC
MCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2CC0 - 2CC7
MCC0:
add r13,r2
mov.l @r2,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2CC8 - 2CCF
MCC8:
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2CD0 - 2CD7
MCD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2CD8 - 2CDF
MCD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2CE0 - 2CE7
MCE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2CE8 - 2CEF
MCE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2CF0 - 2CF7
MCF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2CF8
MCF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2CF9
MCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2CFA
MCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2CFB
MCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2CFC
MCFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2D00 - 2D07
MD00:
add r13,r2
mov.l @r2,r3
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2D08 - 2D0F
MD08:
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2D10 - 2D17
MD10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2D18 - 2D1F
MD18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2D20 - 2D27
MD20:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2D28 - 2D2F
MD28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2D30 - 2D37
MD30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2D38
MD38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2D39
MD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2D3A
MD3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2D3B
MD3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2D3C
MD3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2D40 - 2D47
MD40:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2D48 - 2D4F
MD48:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2D50 - 2D57
MD50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2D58 - 2D5F
MD58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2D60 - 2D67
MD60:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2D68 - 2D6F
MD68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2D70 - 2D77
MD70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2D78
MD78:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2D79
MD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2D7A
MD7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2D7B
MD7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2D7C
MD7C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2D80 - 2D87
MD80:
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2D88 - 2D8F
MD88:
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2D90 - 2D97
MD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2D98 - 2D9F
MD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2DA0 - 2DA7
MDA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2DA8 - 2DAF
MDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 2DB0 - 2DB7
MDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2DB8
MDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2DB9
MDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 2DBA
MDBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2DBB
MDBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2DBC
MDBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2E00 - 2E07
ME00:
add r13,r2
mov.l @r2,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2E08 - 2E0F
ME08:
add r14,r2
mov.l @r2,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 2E10 - 2E17
ME10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2E18 - 2E1F
ME18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2E20 - 2E27
ME20:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 2E28 - 2E2F
ME28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2E30 - 2E37
ME30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2E38
ME38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2E39
ME39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 2E3A
ME3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 2E3B
ME3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 2E3C
ME3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2E40 - 2E47
ME40:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2E48 - 2E4F
ME48:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 2E50 - 2E57
ME50:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2E58 - 2E5F
ME58:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2E60 - 2E67
ME60:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 2E68 - 2E6F
ME68:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 2E70 - 2E77
ME70:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2E78
ME78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2E79
ME79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 2E7A
ME7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 2E7B
ME7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 2E7C
ME7C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 2E80 - 2E87
ME80:
add r13,r2
mov.l @r2,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2E88 - 2E8F
ME88:
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2E90 - 2E97
ME90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2E98 - 2E9F
ME98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2EA0 - 2EA7
MEA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2EA8 - 2EAF
MEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2EB0 - 2EB7
MEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2EB8
MEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2EB9
MEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2EBA
MEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2EBB
MEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2EBC
MEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2EC0 - 2EC7
MEC0:
add r13,r2
mov.l @r2,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2EC8 - 2ECF
MEC8:
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2ED0 - 2ED7
MED0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2ED8 - 2EDF
MED8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2EE0 - 2EE7
MEE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2EE8 - 2EEF
MEE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2EF0 - 2EF7
MEF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2EF8
MEF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2EF9
MEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2EFA
MEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2EFB
MEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2EFC
MEFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2F00 - 2F07
MF00:
add r13,r2
mov.l @r2,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2F08 - 2F0F
MF08:
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 2F10 - 2F17
MF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2F18 - 2F1F
MF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2F20 - 2F27
MF20:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 2F28 - 2F2F
MF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2F30 - 2F37
MF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2F38
MF38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2F39
MF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2F3A
MF3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 2F3B
MF3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 2F3C
MF3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 2F40 - 2F47
MF40:
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2F48 - 2F4F
MF48:
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 2F50 - 2F57
MF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2F58 - 2F5F
MF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2F60 - 2F67
MF60:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2F68 - 2F6F
MF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2F70 - 2F77
MF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2F78
MF78:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2F79
MF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2F7A
MF7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 2F7B
MF7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2F7C
MF7C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 2F80 - 2F87
MF80:
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2F88 - 2F8F
MF88:
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 2F90 - 2F97
MF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2F98 - 2F9F
MF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 2FA0 - 2FA7
MFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 2FA8 - 2FAF
MFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcodes 2FB0 - 2FB7
MFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2FB8
MFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2FB9
MFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-34,r7
! Opcode 2FBA
MFBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-30,r7
! Opcode 2FBB
MFBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-32,r7
! Opcode 2FBC
MFBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcodes 3000 - 3007
N000:
add r13,r2
mov.w @r2,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3008 - 300F
N008:
add r14,r2
mov.w @r2,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3010 - 3017
N010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3018 - 301F
N018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3020 - 3027
N020:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 3028 - 302F
N028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3030 - 3037
N030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3038
N038:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3039
N039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 303A
N03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 303B
N03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 303C
N03C:
mov.w @r6+,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3040 - 3047
N040:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3048 - 304F
N048:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3050 - 3057
N050:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3058 - 305F
N058:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3060 - 3067
N060:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-10,r7
! Opcodes 3068 - 306F
N068:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 3070 - 3077
N070:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3078
N078:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3079
N079:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 307A
N07A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 307B
N07B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 307C
N07C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3080 - 3087
N080:
add r13,r2
mov.w @r2,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3088 - 308F
N088:
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3090 - 3097
N090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3098 - 309F
N098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 30A0 - 30A7
N0A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 30A8 - 30AF
N0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 30B0 - 30B7
N0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 30B8
N0B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 30B9
N0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 30BA
N0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 30BB
N0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 30BC
N0BC:
mov.w @r6+,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 30C0 - 30C7
N0C0:
add r13,r2
mov.w @r2,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 30C8 - 30CF
N0C8:
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 30D0 - 30D7
N0D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 30D8 - 30DF
N0D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 30E0 - 30E7
N0E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 30E8 - 30EF
N0E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 30F0 - 30F7
N0F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 30F8
N0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 30F9
N0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 30FA
N0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 30FB
N0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 30FC
N0FC:
mov.w @r6+,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3100 - 3107
N100:
add r13,r2
mov.w @r2,r3
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3108 - 310F
N108:
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3110 - 3117
N110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3118 - 311F
N118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3120 - 3127
N120:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3128 - 312F
N128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3130 - 3137
N130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3138
N138:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3139
N139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 313A
N13A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 313B
N13B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 313C
N13C:
mov.w @r6+,r3
mov.l @(32,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3140 - 3147
N140:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3148 - 314F
N148:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3150 - 3157
N150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3158 - 315F
N158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3160 - 3167
N160:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3168 - 316F
N168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3170 - 3177
N170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3178
N178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3179
N179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 317A
N17A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 317B
N17B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 317C
N17C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3180 - 3187
N180:
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3188 - 318F
N188:
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3190 - 3197
N190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3198 - 319F
N198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 31A0 - 31A7
N1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 31A8 - 31AF
N1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 31B0 - 31B7
N1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 31B8
N1B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 31B9
N1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 31BA
N1BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 31BB
N1BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 31BC
N1BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(32,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 31C0 - 31C7
N1C0:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 31C8 - 31CF
N1C8:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 31D0 - 31D7
N1D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 31D8 - 31DF
N1D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 31E0 - 31E7
N1E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 31E8 - 31EF
N1E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 31F0 - 31F7
N1F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 31F8
N1F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 31F9
N1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 31FA
N1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 31FB
N1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 31FC
N1FC:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3200 - 3207
N200:
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3208 - 320F
N208:
add r14,r2
mov.w @r2,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3210 - 3217
N210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3218 - 321F
N218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3220 - 3227
N220:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 3228 - 322F
N228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3230 - 3237
N230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3238
N238:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3239
N239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 323A
N23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 323B
N23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 323C
N23C:
mov.w @r6+,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3240 - 3247
N240:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3248 - 324F
N248:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3250 - 3257
N250:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3258 - 325F
N258:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3260 - 3267
N260:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-10,r7
! Opcodes 3268 - 326F
N268:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 3270 - 3277
N270:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3278
N278:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3279
N279:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 327A
N27A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 327B
N27B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 327C
N27C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3280 - 3287
N280:
add r13,r2
mov.w @r2,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3288 - 328F
N288:
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3290 - 3297
N290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3298 - 329F
N298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 32A0 - 32A7
N2A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 32A8 - 32AF
N2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 32B0 - 32B7
N2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 32B8
N2B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 32B9
N2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 32BA
N2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 32BB
N2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 32BC
N2BC:
mov.w @r6+,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 32C0 - 32C7
N2C0:
add r13,r2
mov.w @r2,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 32C8 - 32CF
N2C8:
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 32D0 - 32D7
N2D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 32D8 - 32DF
N2D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 32E0 - 32E7
N2E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 32E8 - 32EF
N2E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 32F0 - 32F7
N2F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 32F8
N2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 32F9
N2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 32FA
N2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 32FB
N2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 32FC
N2FC:
mov.w @r6+,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3300 - 3307
N300:
add r13,r2
mov.w @r2,r3
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3308 - 330F
N308:
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3310 - 3317
N310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3318 - 331F
N318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3320 - 3327
N320:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3328 - 332F
N328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3330 - 3337
N330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3338
N338:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3339
N339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 333A
N33A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 333B
N33B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 333C
N33C:
mov.w @r6+,r3
mov.l @(36,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3340 - 3347
N340:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3348 - 334F
N348:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3350 - 3357
N350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3358 - 335F
N358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3360 - 3367
N360:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3368 - 336F
N368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3370 - 3377
N370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3378
N378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3379
N379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 337A
N37A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 337B
N37B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 337C
N37C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3380 - 3387
N380:
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3388 - 338F
N388:
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3390 - 3397
N390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3398 - 339F
N398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 33A0 - 33A7
N3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 33A8 - 33AF
N3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 33B0 - 33B7
N3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 33B8
N3B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 33B9
N3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 33BA
N3BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 33BB
N3BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 33BC
N3BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(36,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 33C0 - 33C7
N3C0:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 33C8 - 33CF
N3C8:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 33D0 - 33D7
N3D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 33D8 - 33DF
N3D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 33E0 - 33E7
N3E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 33E8 - 33EF
N3E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 33F0 - 33F7
N3F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 33F8
N3F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 33F9
N3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcode 33FA
N3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 33FB
N3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 33FC
N3FC:
mov.w @r6+,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3400 - 3407
N400:
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3408 - 340F
N408:
add r14,r2
mov.w @r2,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3410 - 3417
N410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3418 - 341F
N418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3420 - 3427
N420:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 3428 - 342F
N428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3430 - 3437
N430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3438
N438:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3439
N439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 343A
N43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 343B
N43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 343C
N43C:
mov.w @r6+,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3440 - 3447
N440:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3448 - 344F
N448:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3450 - 3457
N450:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3458 - 345F
N458:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3460 - 3467
N460:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-10,r7
! Opcodes 3468 - 346F
N468:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 3470 - 3477
N470:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3478
N478:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3479
N479:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 347A
N47A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 347B
N47B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 347C
N47C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3480 - 3487
N480:
add r13,r2
mov.w @r2,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3488 - 348F
N488:
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3490 - 3497
N490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3498 - 349F
N498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 34A0 - 34A7
N4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 34A8 - 34AF
N4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 34B0 - 34B7
N4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 34B8
N4B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 34B9
N4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 34BA
N4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 34BB
N4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 34BC
N4BC:
mov.w @r6+,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 34C0 - 34C7
N4C0:
add r13,r2
mov.w @r2,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 34C8 - 34CF
N4C8:
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 34D0 - 34D7
N4D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 34D8 - 34DF
N4D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 34E0 - 34E7
N4E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 34E8 - 34EF
N4E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 34F0 - 34F7
N4F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 34F8
N4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 34F9
N4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 34FA
N4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 34FB
N4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 34FC
N4FC:
mov.w @r6+,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3500 - 3507
N500:
add r13,r2
mov.w @r2,r3
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3508 - 350F
N508:
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3510 - 3517
N510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3518 - 351F
N518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3520 - 3527
N520:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3528 - 352F
N528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3530 - 3537
N530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3538
N538:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3539
N539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 353A
N53A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 353B
N53B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 353C
N53C:
mov.w @r6+,r3
mov.l @(40,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3540 - 3547
N540:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3548 - 354F
N548:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3550 - 3557
N550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3558 - 355F
N558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3560 - 3567
N560:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3568 - 356F
N568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3570 - 3577
N570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3578
N578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3579
N579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 357A
N57A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 357B
N57B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 357C
N57C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3580 - 3587
N580:
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3588 - 358F
N588:
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3590 - 3597
N590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3598 - 359F
N598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 35A0 - 35A7
N5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 35A8 - 35AF
N5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 35B0 - 35B7
N5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 35B8
N5B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 35B9
N5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 35BA
N5BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 35BB
N5BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 35BC
N5BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(40,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3600 - 3607
N600:
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3608 - 360F
N608:
add r14,r2
mov.w @r2,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3610 - 3617
N610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3618 - 361F
N618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3620 - 3627
N620:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 3628 - 362F
N628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3630 - 3637
N630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3638
N638:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3639
N639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 363A
N63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 363B
N63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 363C
N63C:
mov.w @r6+,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3640 - 3647
N640:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3648 - 364F
N648:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3650 - 3657
N650:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3658 - 365F
N658:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3660 - 3667
N660:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-10,r7
! Opcodes 3668 - 366F
N668:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 3670 - 3677
N670:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3678
N678:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3679
N679:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 367A
N67A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 367B
N67B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 367C
N67C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3680 - 3687
N680:
add r13,r2
mov.w @r2,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3688 - 368F
N688:
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3690 - 3697
N690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3698 - 369F
N698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 36A0 - 36A7
N6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 36A8 - 36AF
N6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 36B0 - 36B7
N6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 36B8
N6B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 36B9
N6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 36BA
N6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 36BB
N6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 36BC
N6BC:
mov.w @r6+,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 36C0 - 36C7
N6C0:
add r13,r2
mov.w @r2,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 36C8 - 36CF
N6C8:
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 36D0 - 36D7
N6D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 36D8 - 36DF
N6D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 36E0 - 36E7
N6E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 36E8 - 36EF
N6E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 36F0 - 36F7
N6F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 36F8
N6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 36F9
N6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 36FA
N6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 36FB
N6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 36FC
N6FC:
mov.w @r6+,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3700 - 3707
N700:
add r13,r2
mov.w @r2,r3
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3708 - 370F
N708:
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3710 - 3717
N710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3718 - 371F
N718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3720 - 3727
N720:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3728 - 372F
N728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3730 - 3737
N730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3738
N738:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3739
N739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 373A
N73A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 373B
N73B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 373C
N73C:
mov.w @r6+,r3
mov.l @(44,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3740 - 3747
N740:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3748 - 374F
N748:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3750 - 3757
N750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3758 - 375F
N758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3760 - 3767
N760:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3768 - 376F
N768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3770 - 3777
N770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3778
N778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3779
N779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 377A
N77A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 377B
N77B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 377C
N77C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3780 - 3787
N780:
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3788 - 378F
N788:
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3790 - 3797
N790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3798 - 379F
N798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 37A0 - 37A7
N7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 37A8 - 37AF
N7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 37B0 - 37B7
N7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 37B8
N7B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 37B9
N7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 37BA
N7BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 37BB
N7BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 37BC
N7BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(44,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3800 - 3807
N800:
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3808 - 380F
N808:
add r14,r2
mov.w @r2,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3810 - 3817
N810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3818 - 381F
N818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3820 - 3827
N820:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 3828 - 382F
N828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3830 - 3837
N830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3838
N838:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3839
N839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 383A
N83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 383B
N83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 383C
N83C:
mov.w @r6+,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3840 - 3847
N840:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3848 - 384F
N848:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3850 - 3857
N850:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3858 - 385F
N858:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3860 - 3867
N860:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-10,r7
! Opcodes 3868 - 386F
N868:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 3870 - 3877
N870:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3878
N878:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3879
N879:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 387A
N87A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 387B
N87B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 387C
N87C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3880 - 3887
N880:
add r13,r2
mov.w @r2,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3888 - 388F
N888:
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3890 - 3897
N890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3898 - 389F
N898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 38A0 - 38A7
N8A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 38A8 - 38AF
N8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 38B0 - 38B7
N8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 38B8
N8B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 38B9
N8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 38BA
N8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 38BB
N8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 38BC
N8BC:
mov.w @r6+,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 38C0 - 38C7
N8C0:
add r13,r2
mov.w @r2,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 38C8 - 38CF
N8C8:
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 38D0 - 38D7
N8D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 38D8 - 38DF
N8D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 38E0 - 38E7
N8E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 38E8 - 38EF
N8E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 38F0 - 38F7
N8F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 38F8
N8F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 38F9
N8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 38FA
N8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 38FB
N8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 38FC
N8FC:
mov.w @r6+,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3900 - 3907
N900:
add r13,r2
mov.w @r2,r3
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3908 - 390F
N908:
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3910 - 3917
N910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3918 - 391F
N918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3920 - 3927
N920:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3928 - 392F
N928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3930 - 3937
N930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3938
N938:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3939
N939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 393A
N93A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 393B
N93B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 393C
N93C:
mov.w @r6+,r3
mov.l @(48,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3940 - 3947
N940:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3948 - 394F
N948:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3950 - 3957
N950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3958 - 395F
N958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3960 - 3967
N960:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3968 - 396F
N968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3970 - 3977
N970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3978
N978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3979
N979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 397A
N97A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 397B
N97B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 397C
N97C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3980 - 3987
N980:
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3988 - 398F
N988:
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3990 - 3997
N990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3998 - 399F
N998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 39A0 - 39A7
N9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 39A8 - 39AF
N9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 39B0 - 39B7
N9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 39B8
N9B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 39B9
N9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 39BA
N9BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 39BB
N9BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 39BC
N9BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(48,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3A00 - 3A07
NA00:
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3A08 - 3A0F
NA08:
add r14,r2
mov.w @r2,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3A10 - 3A17
NA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3A18 - 3A1F
NA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3A20 - 3A27
NA20:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 3A28 - 3A2F
NA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3A30 - 3A37
NA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3A38
NA38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3A39
NA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3A3A
NA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3A3B
NA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3A3C
NA3C:
mov.w @r6+,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3A40 - 3A47
NA40:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3A48 - 3A4F
NA48:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3A50 - 3A57
NA50:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3A58 - 3A5F
NA58:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3A60 - 3A67
NA60:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-10,r7
! Opcodes 3A68 - 3A6F
NA68:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 3A70 - 3A77
NA70:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3A78
NA78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3A79
NA79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 3A7A
NA7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3A7B
NA7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3A7C
NA7C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3A80 - 3A87
NA80:
add r13,r2
mov.w @r2,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3A88 - 3A8F
NA88:
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3A90 - 3A97
NA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3A98 - 3A9F
NA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3AA0 - 3AA7
NAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3AA8 - 3AAF
NAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3AB0 - 3AB7
NAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3AB8
NAB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3AB9
NAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3ABA
NABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3ABB
NABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3ABC
NABC:
mov.w @r6+,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3AC0 - 3AC7
NAC0:
add r13,r2
mov.w @r2,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3AC8 - 3ACF
NAC8:
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3AD0 - 3AD7
NAD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3AD8 - 3ADF
NAD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3AE0 - 3AE7
NAE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3AE8 - 3AEF
NAE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3AF0 - 3AF7
NAF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3AF8
NAF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3AF9
NAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3AFA
NAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3AFB
NAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3AFC
NAFC:
mov.w @r6+,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3B00 - 3B07
NB00:
add r13,r2
mov.w @r2,r3
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3B08 - 3B0F
NB08:
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3B10 - 3B17
NB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3B18 - 3B1F
NB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3B20 - 3B27
NB20:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3B28 - 3B2F
NB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3B30 - 3B37
NB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3B38
NB38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3B39
NB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3B3A
NB3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3B3B
NB3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3B3C
NB3C:
mov.w @r6+,r3
mov.l @(52,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3B40 - 3B47
NB40:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3B48 - 3B4F
NB48:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3B50 - 3B57
NB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3B58 - 3B5F
NB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3B60 - 3B67
NB60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3B68 - 3B6F
NB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3B70 - 3B77
NB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3B78
NB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3B79
NB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3B7A
NB7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3B7B
NB7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3B7C
NB7C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3B80 - 3B87
NB80:
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3B88 - 3B8F
NB88:
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3B90 - 3B97
NB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3B98 - 3B9F
NB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3BA0 - 3BA7
NBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3BA8 - 3BAF
NBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 3BB0 - 3BB7
NBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3BB8
NBB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3BB9
NBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 3BBA
NBBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3BBB
NBBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3BBC
NBBC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(52,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3C00 - 3C07
NC00:
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3C08 - 3C0F
NC08:
add r14,r2
mov.w @r2,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3C10 - 3C17
NC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3C18 - 3C1F
NC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3C20 - 3C27
NC20:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 3C28 - 3C2F
NC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3C30 - 3C37
NC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3C38
NC38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3C39
NC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3C3A
NC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3C3B
NC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3C3C
NC3C:
mov.w @r6+,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3C40 - 3C47
NC40:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3C48 - 3C4F
NC48:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3C50 - 3C57
NC50:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3C58 - 3C5F
NC58:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3C60 - 3C67
NC60:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-10,r7
! Opcodes 3C68 - 3C6F
NC68:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 3C70 - 3C77
NC70:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3C78
NC78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3C79
NC79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 3C7A
NC7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3C7B
NC7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3C7C
NC7C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3C80 - 3C87
NC80:
add r13,r2
mov.w @r2,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3C88 - 3C8F
NC88:
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3C90 - 3C97
NC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3C98 - 3C9F
NC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3CA0 - 3CA7
NCA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3CA8 - 3CAF
NCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3CB0 - 3CB7
NCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3CB8
NCB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3CB9
NCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3CBA
NCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3CBB
NCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3CBC
NCBC:
mov.w @r6+,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3CC0 - 3CC7
NCC0:
add r13,r2
mov.w @r2,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3CC8 - 3CCF
NCC8:
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3CD0 - 3CD7
NCD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3CD8 - 3CDF
NCD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3CE0 - 3CE7
NCE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3CE8 - 3CEF
NCE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3CF0 - 3CF7
NCF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3CF8
NCF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3CF9
NCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3CFA
NCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3CFB
NCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3CFC
NCFC:
mov.w @r6+,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3D00 - 3D07
ND00:
add r13,r2
mov.w @r2,r3
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3D08 - 3D0F
ND08:
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3D10 - 3D17
ND10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3D18 - 3D1F
ND18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3D20 - 3D27
ND20:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3D28 - 3D2F
ND28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3D30 - 3D37
ND30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3D38
ND38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3D39
ND39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3D3A
ND3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3D3B
ND3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3D3C
ND3C:
mov.w @r6+,r3
mov.l @(56,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3D40 - 3D47
ND40:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3D48 - 3D4F
ND48:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3D50 - 3D57
ND50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3D58 - 3D5F
ND58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3D60 - 3D67
ND60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3D68 - 3D6F
ND68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3D70 - 3D77
ND70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3D78
ND78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3D79
ND79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3D7A
ND7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3D7B
ND7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3D7C
ND7C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3D80 - 3D87
ND80:
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3D88 - 3D8F
ND88:
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3D90 - 3D97
ND90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3D98 - 3D9F
ND98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3DA0 - 3DA7
NDA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3DA8 - 3DAF
NDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 3DB0 - 3DB7
NDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3DB8
NDB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3DB9
NDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 3DBA
NDBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3DBB
NDBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3DBC
NDBC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(56,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3E00 - 3E07
NE00:
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3E08 - 3E0F
NE08:
add r14,r2
mov.w @r2,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 3E10 - 3E17
NE10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3E18 - 3E1F
NE18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3E20 - 3E27
NE20:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 3E28 - 3E2F
NE28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3E30 - 3E37
NE30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3E38
NE38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3E39
NE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3E3A
NE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 3E3B
NE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 3E3C
NE3C:
mov.w @r6+,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3E40 - 3E47
NE40:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3E48 - 3E4F
NE48:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 3E50 - 3E57
NE50:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3E58 - 3E5F
NE58:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3E60 - 3E67
NE60:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-10,r7
! Opcodes 3E68 - 3E6F
NE68:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 3E70 - 3E77
NE70:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3E78
NE78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3E79
NE79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 3E7A
NE7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 3E7B
NE7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 3E7C
NE7C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 3E80 - 3E87
NE80:
add r13,r2
mov.w @r2,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3E88 - 3E8F
NE88:
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3E90 - 3E97
NE90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3E98 - 3E9F
NE98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3EA0 - 3EA7
NEA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3EA8 - 3EAF
NEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3EB0 - 3EB7
NEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3EB8
NEB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3EB9
NEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3EBA
NEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3EBB
NEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3EBC
NEBC:
mov.w @r6+,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3EC0 - 3EC7
NEC0:
add r13,r2
mov.w @r2,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3EC8 - 3ECF
NEC8:
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3ED0 - 3ED7
NED0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3ED8 - 3EDF
NED8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3EE0 - 3EE7
NEE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3EE8 - 3EEF
NEE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3EF0 - 3EF7
NEF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3EF8
NEF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3EF9
NEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3EFA
NEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3EFB
NEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3EFC
NEFC:
mov.w @r6+,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3F00 - 3F07
NF00:
add r13,r2
mov.w @r2,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3F08 - 3F0F
NF08:
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 3F10 - 3F17
NF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3F18 - 3F1F
NF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3F20 - 3F27
NF20:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3F28 - 3F2F
NF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3F30 - 3F37
NF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3F38
NF38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3F39
NF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3F3A
NF3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 3F3B
NF3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 3F3C
NF3C:
mov.w @r6+,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3F40 - 3F47
NF40:
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3F48 - 3F4F
NF48:
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 3F50 - 3F57
NF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3F58 - 3F5F
NF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3F60 - 3F67
NF60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3F68 - 3F6F
NF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3F70 - 3F77
NF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3F78
NF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3F79
NF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3F7A
NF7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 3F7B
NF7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3F7C
NF7C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 3F80 - 3F87
NF80:
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3F88 - 3F8F
NF88:
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 3F90 - 3F97
NF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3F98 - 3F9F
NF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 3FA0 - 3FA7
NFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 3FA8 - 3FAF
NFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 3FB0 - 3FB7
NFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3FB8
NFB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3FB9
NFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 3FBA
NFBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 3FBB
NFBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 3FBC
NFBC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
mov.l @(60,r13),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 4000 - 4007
O000:
mov r3,r4
add r13,r2
mov.b @r2,r3
mov #24,r0
shld r0,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.b r3,@r2
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 4010 - 4017
O010:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-12,r7
! Opcodes 4018 - 401F
O018:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-12,r7
! Opcodes 4020 - 4027
O020:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-14,r7
! Opcodes 4028 - 402F
O028:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-16,r7
! Opcodes 4030 - 4037
O030:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcode 4038
O038:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-16,r7
! Opcode 4039
O039:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-20,r7
! Opcodes 4040 - 4047
O040:
mov r3,r4
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.w r3,@r2
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 4050 - 4057
O050:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-12,r7
! Opcodes 4058 - 405F
O058:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-12,r7
! Opcodes 4060 - 4067
O060:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-14,r7
! Opcodes 4068 - 406F
O068:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-16,r7
! Opcodes 4070 - 4077
O070:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcode 4078
O078:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-16,r7
! Opcode 4079
O079:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-20,r7
! Opcodes 4080 - 4087
O080:
mov r3,r4
add r13,r2
mov.l @r2,r3
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@r2
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 4090 - 4097
O090:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-20,r7
! Opcodes 4098 - 409F
O098:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-20,r7
! Opcodes 40A0 - 40A7
O0A0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-22,r7
! Opcodes 40A8 - 40AF
O0A8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-24,r7
! Opcodes 40B0 - 40B7
O0B0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-26,r7
! Opcode 40B8
O0B8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-24,r7
! Opcode 40B9
O0B9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
cmp/pl r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-28,r7
! Opcodes 40C0 - 40C7
O0C0:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-6,r7
! Opcodes 40D0 - 40D7
O0D0:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 40D8 - 40DF
O0D8:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 40E0 - 40E7
O0E0:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 40E8 - 40EF
O0E8:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 40F0 - 40F7
O0F0:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 40F8
O0F8:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 40F9
O0F9:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
rotl r3
addc r1,r1
shlr2 r0
and #1,r0
xor r0,r1
mov r8,r0
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
shll8 r0
or r0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 4180 - 4187
O180:
mov r2,r0
mov.w @(r0,r13),r3
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn52
mov #0,r8
cmp/hi r3,r1
bt ln52
jmp @r10
add #-10,r7
setn52:
mov #1,r8
ln52:
mov.l r1,@-r15
mov.l g2_except_ptr52,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr52,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_ptr52: .long group_2_exception
bf_addr52: .long basefunction
! Opcodes 4190 - 4197
O190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn53
mov #0,r8
cmp/hi r3,r1
bt ln53
jmp @r10
add #-14,r7
setn53:
mov #1,r8
ln53:
mov.l r1,@-r15
mov.l g2_except_ptr53,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr53,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr53: .long group_2_exception
bf_addr53: .long basefunction
! Opcodes 4198 - 419F
O198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn54
mov #0,r8
cmp/hi r3,r1
bt ln54
jmp @r10
add #-14,r7
setn54:
mov #1,r8
ln54:
mov.l r1,@-r15
mov.l g2_except_ptr54,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr54,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr54: .long group_2_exception
bf_addr54: .long basefunction
! Opcodes 41A0 - 41A7
O1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn55
mov #0,r8
cmp/hi r3,r1
bt ln55
jmp @r10
add #-16,r7
setn55:
mov #1,r8
ln55:
mov.l r1,@-r15
mov.l g2_except_ptr55,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr55,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-56,r7
.align 2
g2_except_ptr55: .long group_2_exception
bf_addr55: .long basefunction
! Opcodes 41A8 - 41AF
O1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn56
mov #0,r8
cmp/hi r3,r1
bt ln56
jmp @r10
add #-18,r7
setn56:
mov #1,r8
ln56:
mov.l r1,@-r15
mov.l g2_except_ptr56,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr56,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr56: .long group_2_exception
bf_addr56: .long basefunction
! Opcodes 41B0 - 41B7
O1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn57
mov #0,r8
cmp/hi r3,r1
bt ln57
jmp @r10
add #-20,r7
setn57:
mov #1,r8
ln57:
mov.l r1,@-r15
mov.l g2_except_ptr57,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr57,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr57: .long group_2_exception
bf_addr57: .long basefunction
! Opcode 41B8
O1B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn58
mov #0,r8
cmp/hi r3,r1
bt ln58
jmp @r10
add #-18,r7
setn58:
mov #1,r8
ln58:
mov.l r1,@-r15
mov.l g2_except_ptr58,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr58,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr58: .long group_2_exception
bf_addr58: .long basefunction
! Opcode 41B9
O1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn59
mov #0,r8
cmp/hi r3,r1
bt ln59
jmp @r10
add #-22,r7
setn59:
mov #1,r8
ln59:
mov.l r1,@-r15
mov.l g2_except_ptr59,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr59,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-62,r7
.align 2
g2_except_ptr59: .long group_2_exception
bf_addr59: .long basefunction
! Opcode 41BA
O1BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn60
mov #0,r8
cmp/hi r3,r1
bt ln60
jmp @r10
add #-18,r7
setn60:
mov #1,r8
ln60:
mov.l r1,@-r15
mov.l g2_except_ptr60,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr60,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr60: .long group_2_exception
bf_addr60: .long basefunction
! Opcode 41BB
O1BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn61
mov #0,r8
cmp/hi r3,r1
bt ln61
jmp @r10
add #-20,r7
setn61:
mov #1,r8
ln61:
mov.l r1,@-r15
mov.l g2_except_ptr61,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr61,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr61: .long group_2_exception
bf_addr61: .long basefunction
! Opcode 41BC
O1BC:
mov.w @r6+,r3
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn62
mov #0,r8
cmp/hi r3,r1
bt ln62
jmp @r10
add #-14,r7
setn62:
mov #1,r8
ln62:
mov.l r1,@-r15
mov.l g2_except_ptr62,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr62,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr62: .long group_2_exception
bf_addr62: .long basefunction
! Opcodes 41D0 - 41D7
O1D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(32,r13)
jmp @r10
add #-4,r7
! Opcodes 41E8 - 41EF
O1E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(32,r13)
jmp @r10
add #-8,r7
! Opcodes 41F0 - 41F7
O1F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l r4,@(32,r13)
jmp @r10
add #-12,r7
! Opcode 41F8
O1F8:
mov.w @r6+,r4
mov.l r4,@(32,r13)
jmp @r10
add #-8,r7
! Opcode 41F9
O1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(32,r13)
jmp @r10
add #-12,r7
! Opcode 41FA
O1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(32,r13)
jmp @r10
add #-8,r7
! Opcode 41FB
O1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l r4,@(32,r13)
jmp @r10
add #-12,r7
! Opcodes 4200 - 4207
O200:
mov #0,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov r3,r8
jmp @r10
add #-4,r7
! Opcodes 4210 - 4217
O210:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 4218 - 421F
O218:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 4220 - 4227
O220:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
jmp @r10
add #-14,r7
! Opcodes 4228 - 422F
O228:
mov #0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-16,r7
! Opcodes 4230 - 4237
O230:
mov #0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-18,r7
! Opcode 4238
O238:
mov #0,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-16,r7
! Opcode 4239
O239:
mov #0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-20,r7
! Opcodes 4240 - 4247
O240:
mov #0,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov r3,r8
jmp @r10
add #-4,r7
! Opcodes 4250 - 4257
O250:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 4258 - 425F
O258:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 4260 - 4267
O260:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
jmp @r10
add #-14,r7
! Opcodes 4268 - 426F
O268:
mov #0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-16,r7
! Opcodes 4270 - 4277
O270:
mov #0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-18,r7
! Opcode 4278
O278:
mov #0,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-16,r7
! Opcode 4279
O279:
mov #0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-20,r7
! Opcodes 4280 - 4287
O280:
mov #0,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov r3,r8
jmp @r10
add #-6,r7
! Opcodes 4290 - 4297
O290:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 4298 - 429F
O298:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 42A0 - 42A7
O2A0:
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 42A8 - 42AF
O2A8:
mov #0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 42B0 - 42B7
O2B0:
mov #0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-12,r7
! Opcode 42B8
O2B8:
mov #0,r3
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-12,r7
! Opcode 42B9
O2B9:
mov #0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
jmp @r10
add #-12,r7
! Opcodes 4380 - 4387
O380:
mov r2,r0
mov.w @(r0,r13),r3
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn63
mov #0,r8
cmp/hi r3,r1
bt ln63
jmp @r10
add #-10,r7
setn63:
mov #1,r8
ln63:
mov.l r1,@-r15
mov.l g2_except_ptr63,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr63,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_ptr63: .long group_2_exception
bf_addr63: .long basefunction
! Opcodes 4390 - 4397
O390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn64
mov #0,r8
cmp/hi r3,r1
bt ln64
jmp @r10
add #-14,r7
setn64:
mov #1,r8
ln64:
mov.l r1,@-r15
mov.l g2_except_ptr64,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr64,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr64: .long group_2_exception
bf_addr64: .long basefunction
! Opcodes 4398 - 439F
O398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn65
mov #0,r8
cmp/hi r3,r1
bt ln65
jmp @r10
add #-14,r7
setn65:
mov #1,r8
ln65:
mov.l r1,@-r15
mov.l g2_except_ptr65,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr65,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr65: .long group_2_exception
bf_addr65: .long basefunction
! Opcodes 43A0 - 43A7
O3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn66
mov #0,r8
cmp/hi r3,r1
bt ln66
jmp @r10
add #-16,r7
setn66:
mov #1,r8
ln66:
mov.l r1,@-r15
mov.l g2_except_ptr66,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr66,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-56,r7
.align 2
g2_except_ptr66: .long group_2_exception
bf_addr66: .long basefunction
! Opcodes 43A8 - 43AF
O3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn67
mov #0,r8
cmp/hi r3,r1
bt ln67
jmp @r10
add #-18,r7
setn67:
mov #1,r8
ln67:
mov.l r1,@-r15
mov.l g2_except_ptr67,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr67,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr67: .long group_2_exception
bf_addr67: .long basefunction
! Opcodes 43B0 - 43B7
O3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn68
mov #0,r8
cmp/hi r3,r1
bt ln68
jmp @r10
add #-20,r7
setn68:
mov #1,r8
ln68:
mov.l r1,@-r15
mov.l g2_except_ptr68,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr68,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr68: .long group_2_exception
bf_addr68: .long basefunction
! Opcode 43B8
O3B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn69
mov #0,r8
cmp/hi r3,r1
bt ln69
jmp @r10
add #-18,r7
setn69:
mov #1,r8
ln69:
mov.l r1,@-r15
mov.l g2_except_ptr69,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr69,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr69: .long group_2_exception
bf_addr69: .long basefunction
! Opcode 43B9
O3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn70
mov #0,r8
cmp/hi r3,r1
bt ln70
jmp @r10
add #-22,r7
setn70:
mov #1,r8
ln70:
mov.l r1,@-r15
mov.l g2_except_ptr70,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr70,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-62,r7
.align 2
g2_except_ptr70: .long group_2_exception
bf_addr70: .long basefunction
! Opcode 43BA
O3BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn71
mov #0,r8
cmp/hi r3,r1
bt ln71
jmp @r10
add #-18,r7
setn71:
mov #1,r8
ln71:
mov.l r1,@-r15
mov.l g2_except_ptr71,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr71,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr71: .long group_2_exception
bf_addr71: .long basefunction
! Opcode 43BB
O3BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn72
mov #0,r8
cmp/hi r3,r1
bt ln72
jmp @r10
add #-20,r7
setn72:
mov #1,r8
ln72:
mov.l r1,@-r15
mov.l g2_except_ptr72,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr72,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr72: .long group_2_exception
bf_addr72: .long basefunction
! Opcode 43BC
O3BC:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn73
mov #0,r8
cmp/hi r3,r1
bt ln73
jmp @r10
add #-14,r7
setn73:
mov #1,r8
ln73:
mov.l r1,@-r15
mov.l g2_except_ptr73,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr73,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr73: .long group_2_exception
bf_addr73: .long basefunction
! Opcodes 43D0 - 43D7
O3D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(36,r13)
jmp @r10
add #-4,r7
! Opcodes 43E8 - 43EF
O3E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(36,r13)
jmp @r10
add #-8,r7
! Opcodes 43F0 - 43F7
O3F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l r4,@(36,r13)
jmp @r10
add #-12,r7
! Opcode 43F8
O3F8:
mov.w @r6+,r4
mov.l r4,@(36,r13)
jmp @r10
add #-8,r7
! Opcode 43F9
O3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(36,r13)
jmp @r10
add #-12,r7
! Opcode 43FA
O3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(36,r13)
jmp @r10
add #-8,r7
! Opcode 43FB
O3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l r4,@(36,r13)
jmp @r10
add #-12,r7
! Opcodes 4400 - 4407
O400:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 4410 - 4417
O410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 4418 - 441F
O418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 4420 - 4427
O420:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 4428 - 442F
O428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 4430 - 4437
O430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 4438
O438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 4439
O439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 4440 - 4447
O440:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 4450 - 4457
O450:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 4458 - 445F
O458:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 4460 - 4467
O460:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 4468 - 446F
O468:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 4470 - 4477
O470:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 4478
O478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 4479
O479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 4480 - 4487
O480:
add r13,r2
mov.l @r2,r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l r3,@r2
jmp @r10
add #-6,r7
! Opcodes 4490 - 4497
O490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 4498 - 449F
O498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 44A0 - 44A7
O4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 44A8 - 44AF
O4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 44B0 - 44B7
O4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 44B8
O4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 44B9
O4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 44C0 - 44C7
O4C0:
mov r2,r0
mov.w @(r0,r13),r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-12,r7
! Opcodes 44D0 - 44D7
O4D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-16,r7
! Opcodes 44D8 - 44DF
O4D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-16,r7
! Opcodes 44E0 - 44E7
O4E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-18,r7
! Opcodes 44E8 - 44EF
O4E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-20,r7
! Opcodes 44F0 - 44F7
O4F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-22,r7
! Opcode 44F8
O4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-20,r7
! Opcode 44F9
O4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-24,r7
! Opcode 44FA
O4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-20,r7
! Opcode 44FB
O4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-22,r7
! Opcode 44FC
O4FC:
mov.w @r6+,r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
jmp @r10
add #-16,r7
! Opcodes 4580 - 4587
O580:
mov r2,r0
mov.w @(r0,r13),r3
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn74
mov #0,r8
cmp/hi r3,r1
bt ln74
jmp @r10
add #-10,r7
setn74:
mov #1,r8
ln74:
mov.l r1,@-r15
mov.l g2_except_ptr74,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr74,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_ptr74: .long group_2_exception
bf_addr74: .long basefunction
! Opcodes 4590 - 4597
O590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn75
mov #0,r8
cmp/hi r3,r1
bt ln75
jmp @r10
add #-14,r7
setn75:
mov #1,r8
ln75:
mov.l r1,@-r15
mov.l g2_except_ptr75,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr75,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr75: .long group_2_exception
bf_addr75: .long basefunction
! Opcodes 4598 - 459F
O598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn76
mov #0,r8
cmp/hi r3,r1
bt ln76
jmp @r10
add #-14,r7
setn76:
mov #1,r8
ln76:
mov.l r1,@-r15
mov.l g2_except_ptr76,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr76,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr76: .long group_2_exception
bf_addr76: .long basefunction
! Opcodes 45A0 - 45A7
O5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn77
mov #0,r8
cmp/hi r3,r1
bt ln77
jmp @r10
add #-16,r7
setn77:
mov #1,r8
ln77:
mov.l r1,@-r15
mov.l g2_except_ptr77,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr77,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-56,r7
.align 2
g2_except_ptr77: .long group_2_exception
bf_addr77: .long basefunction
! Opcodes 45A8 - 45AF
O5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn78
mov #0,r8
cmp/hi r3,r1
bt ln78
jmp @r10
add #-18,r7
setn78:
mov #1,r8
ln78:
mov.l r1,@-r15
mov.l g2_except_ptr78,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr78,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr78: .long group_2_exception
bf_addr78: .long basefunction
! Opcodes 45B0 - 45B7
O5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn79
mov #0,r8
cmp/hi r3,r1
bt ln79
jmp @r10
add #-20,r7
setn79:
mov #1,r8
ln79:
mov.l r1,@-r15
mov.l g2_except_ptr79,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr79,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr79: .long group_2_exception
bf_addr79: .long basefunction
! Opcode 45B8
O5B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn80
mov #0,r8
cmp/hi r3,r1
bt ln80
jmp @r10
add #-18,r7
setn80:
mov #1,r8
ln80:
mov.l r1,@-r15
mov.l g2_except_ptr80,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr80,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr80: .long group_2_exception
bf_addr80: .long basefunction
! Opcode 45B9
O5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn81
mov #0,r8
cmp/hi r3,r1
bt ln81
jmp @r10
add #-22,r7
setn81:
mov #1,r8
ln81:
mov.l r1,@-r15
mov.l g2_except_ptr81,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr81,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-62,r7
.align 2
g2_except_ptr81: .long group_2_exception
bf_addr81: .long basefunction
! Opcode 45BA
O5BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn82
mov #0,r8
cmp/hi r3,r1
bt ln82
jmp @r10
add #-18,r7
setn82:
mov #1,r8
ln82:
mov.l r1,@-r15
mov.l g2_except_ptr82,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr82,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr82: .long group_2_exception
bf_addr82: .long basefunction
! Opcode 45BB
O5BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn83
mov #0,r8
cmp/hi r3,r1
bt ln83
jmp @r10
add #-20,r7
setn83:
mov #1,r8
ln83:
mov.l r1,@-r15
mov.l g2_except_ptr83,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr83,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr83: .long group_2_exception
bf_addr83: .long basefunction
! Opcode 45BC
O5BC:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn84
mov #0,r8
cmp/hi r3,r1
bt ln84
jmp @r10
add #-14,r7
setn84:
mov #1,r8
ln84:
mov.l r1,@-r15
mov.l g2_except_ptr84,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr84,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr84: .long group_2_exception
bf_addr84: .long basefunction
! Opcodes 45D0 - 45D7
O5D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(40,r13)
jmp @r10
add #-4,r7
! Opcodes 45E8 - 45EF
O5E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(40,r13)
jmp @r10
add #-8,r7
! Opcodes 45F0 - 45F7
O5F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l r4,@(40,r13)
jmp @r10
add #-12,r7
! Opcode 45F8
O5F8:
mov.w @r6+,r4
mov.l r4,@(40,r13)
jmp @r10
add #-8,r7
! Opcode 45F9
O5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(40,r13)
jmp @r10
add #-12,r7
! Opcode 45FA
O5FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(40,r13)
jmp @r10
add #-8,r7
! Opcode 45FB
O5FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l r4,@(40,r13)
jmp @r10
add #-12,r7
! Opcodes 4600 - 4607
O600:
add r13,r2
mov.b @r2,r3
not r3,r3
mov.b r3,@r2
exts.b r3,r3
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 4610 - 4617
O610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 4618 - 461F
O618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.b r3,r3
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 4620 - 4627
O620:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.b r3,r3
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 4628 - 462F
O628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 4630 - 4637
O630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 4638
O638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 4639
O639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 4640 - 4647
O640:
add r13,r2
mov.w @r2,r3
not r3,r3
mov.w r3,@r2
exts.w r3,r3
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 4650 - 4657
O650:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 4658 - 465F
O658:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 4660 - 4667
O660:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 4668 - 466F
O668:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 4670 - 4677
O670:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 4678
O678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 4679
O679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 4680 - 4687
O680:
add r13,r2
mov.l @r2,r3
not r3,r3
mov.l r3,@r2
mov #0,r8
jmp @r10
add #-6,r7
! Opcodes 4690 - 4697
O690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 4698 - 469F
O698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 46A0 - 46A7
O6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 46A8 - 46AF
O6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 46B0 - 46B7
O6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 46B8
O6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 46B9
O6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 46C0 - 46C7
O6C0:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok85
mov.l priviolation_addr85,r0
jmp @r0
nop
.align 2
priviolation_addr85: .long privilege_violation
pcheck_ok85:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln86
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln86:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr88,r4
jmp @r4
add #-12,r7
.align 2
fdl_cp_addr88: .long fdl_cp
! Opcodes 46D0 - 46D7
O6D0:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok89
mov.l priviolation_addr89,r0
jmp @r0
nop
.align 2
priviolation_addr89: .long privilege_violation
pcheck_ok89:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln90
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln90:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr92,r4
jmp @r4
add #-16,r7
.align 2
fdl_cp_addr92: .long fdl_cp
! Opcodes 46D8 - 46DF
O6D8:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok93
mov.l priviolation_addr93,r0
jmp @r0
nop
.align 2
priviolation_addr93: .long privilege_violation
pcheck_ok93:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln94
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln94:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr96,r4
jmp @r4
add #-16,r7
.align 2
fdl_cp_addr96: .long fdl_cp
! Opcodes 46E0 - 46E7
O6E0:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok97
mov.l priviolation_addr97,r0
jmp @r0
nop
.align 2
priviolation_addr97: .long privilege_violation
pcheck_ok97:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln98
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln98:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr100,r4
jmp @r4
add #-18,r7
.align 2
fdl_cp_addr100: .long fdl_cp
! Opcodes 46E8 - 46EF
O6E8:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok101
mov.l priviolation_addr101,r0
jmp @r0
nop
.align 2
priviolation_addr101: .long privilege_violation
pcheck_ok101:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln102
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln102:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr104,r4
jmp @r4
add #-20,r7
.align 2
fdl_cp_addr104: .long fdl_cp
! Opcodes 46F0 - 46F7
O6F0:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok105
mov.l priviolation_addr105,r0
jmp @r0
nop
.align 2
priviolation_addr105: .long privilege_violation
pcheck_ok105:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln106
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln106:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr108,r4
jmp @r4
add #-22,r7
.align 2
fdl_cp_addr108: .long fdl_cp
! Opcode 46F8
O6F8:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok109
mov.l priviolation_addr109,r0
jmp @r0
nop
.align 2
priviolation_addr109: .long privilege_violation
pcheck_ok109:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln110
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln110:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr112,r4
jmp @r4
add #-20,r7
.align 2
fdl_cp_addr112: .long fdl_cp
! Opcode 46F9
O6F9:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok113
mov.l priviolation_addr113,r0
jmp @r0
nop
.align 2
priviolation_addr113: .long privilege_violation
pcheck_ok113:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln114
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln114:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr116,r4
jmp @r4
add #-24,r7
.align 2
fdl_cp_addr116: .long fdl_cp
! Opcode 46FA
O6FA:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok117
mov.l priviolation_addr117,r0
jmp @r0
nop
.align 2
priviolation_addr117: .long privilege_violation
pcheck_ok117:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln118
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln118:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr120,r4
jmp @r4
add #-20,r7
.align 2
fdl_cp_addr120: .long fdl_cp
! Opcode 46FB
O6FB:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok121
mov.l priviolation_addr121,r0
jmp @r0
nop
.align 2
priviolation_addr121: .long privilege_violation
pcheck_ok121:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln122
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln122:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr124,r4
jmp @r4
add #-22,r7
.align 2
fdl_cp_addr124: .long fdl_cp
! Opcode 46FC
O6FC:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok125
mov.l priviolation_addr125,r0
jmp @r0
nop
.align 2
priviolation_addr125: .long privilege_violation
pcheck_ok125:
mov.w @r6+,r3
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln126
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln126:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l fdl_cp_addr128,r4
jmp @r4
add #-16,r7
.align 2
fdl_cp_addr128: .long fdl_cp
! Opcodes 4780 - 4787
O780:
mov r2,r0
mov.w @(r0,r13),r3
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn129
mov #0,r8
cmp/hi r3,r1
bt ln129
jmp @r10
add #-10,r7
setn129:
mov #1,r8
ln129:
mov.l r1,@-r15
mov.l g2_except_ptr129,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr129,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_ptr129: .long group_2_exception
bf_addr129: .long basefunction
! Opcodes 4790 - 4797
O790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn130
mov #0,r8
cmp/hi r3,r1
bt ln130
jmp @r10
add #-14,r7
setn130:
mov #1,r8
ln130:
mov.l r1,@-r15
mov.l g2_except_ptr130,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr130,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr130: .long group_2_exception
bf_addr130: .long basefunction
! Opcodes 4798 - 479F
O798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn131
mov #0,r8
cmp/hi r3,r1
bt ln131
jmp @r10
add #-14,r7
setn131:
mov #1,r8
ln131:
mov.l r1,@-r15
mov.l g2_except_ptr131,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr131,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr131: .long group_2_exception
bf_addr131: .long basefunction
! Opcodes 47A0 - 47A7
O7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn132
mov #0,r8
cmp/hi r3,r1
bt ln132
jmp @r10
add #-16,r7
setn132:
mov #1,r8
ln132:
mov.l r1,@-r15
mov.l g2_except_ptr132,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr132,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-56,r7
.align 2
g2_except_ptr132: .long group_2_exception
bf_addr132: .long basefunction
! Opcodes 47A8 - 47AF
O7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn133
mov #0,r8
cmp/hi r3,r1
bt ln133
jmp @r10
add #-18,r7
setn133:
mov #1,r8
ln133:
mov.l r1,@-r15
mov.l g2_except_ptr133,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr133,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr133: .long group_2_exception
bf_addr133: .long basefunction
! Opcodes 47B0 - 47B7
O7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn134
mov #0,r8
cmp/hi r3,r1
bt ln134
jmp @r10
add #-20,r7
setn134:
mov #1,r8
ln134:
mov.l r1,@-r15
mov.l g2_except_ptr134,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr134,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr134: .long group_2_exception
bf_addr134: .long basefunction
! Opcode 47B8
O7B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn135
mov #0,r8
cmp/hi r3,r1
bt ln135
jmp @r10
add #-18,r7
setn135:
mov #1,r8
ln135:
mov.l r1,@-r15
mov.l g2_except_ptr135,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr135,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr135: .long group_2_exception
bf_addr135: .long basefunction
! Opcode 47B9
O7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn136
mov #0,r8
cmp/hi r3,r1
bt ln136
jmp @r10
add #-22,r7
setn136:
mov #1,r8
ln136:
mov.l r1,@-r15
mov.l g2_except_ptr136,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr136,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-62,r7
.align 2
g2_except_ptr136: .long group_2_exception
bf_addr136: .long basefunction
! Opcode 47BA
O7BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn137
mov #0,r8
cmp/hi r3,r1
bt ln137
jmp @r10
add #-18,r7
setn137:
mov #1,r8
ln137:
mov.l r1,@-r15
mov.l g2_except_ptr137,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr137,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr137: .long group_2_exception
bf_addr137: .long basefunction
! Opcode 47BB
O7BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn138
mov #0,r8
cmp/hi r3,r1
bt ln138
jmp @r10
add #-20,r7
setn138:
mov #1,r8
ln138:
mov.l r1,@-r15
mov.l g2_except_ptr138,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr138,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr138: .long group_2_exception
bf_addr138: .long basefunction
! Opcode 47BC
O7BC:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn139
mov #0,r8
cmp/hi r3,r1
bt ln139
jmp @r10
add #-14,r7
setn139:
mov #1,r8
ln139:
mov.l r1,@-r15
mov.l g2_except_ptr139,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr139,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr139: .long group_2_exception
bf_addr139: .long basefunction
! Opcodes 47D0 - 47D7
O7D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(44,r13)
jmp @r10
add #-4,r7
! Opcodes 47E8 - 47EF
O7E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(44,r13)
jmp @r10
add #-8,r7
! Opcodes 47F0 - 47F7
O7F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l r4,@(44,r13)
jmp @r10
add #-12,r7
! Opcode 47F8
O7F8:
mov.w @r6+,r4
mov.l r4,@(44,r13)
jmp @r10
add #-8,r7
! Opcode 47F9
O7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(44,r13)
jmp @r10
add #-12,r7
! Opcode 47FA
O7FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(44,r13)
jmp @r10
add #-8,r7
! Opcode 47FB
O7FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l r4,@(44,r13)
jmp @r10
add #-12,r7
! Opcodes 4800 - 4807
O800:
mov.l r3,@-r15
add r13,r2
mov.b @r2,r3
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd141
add #-6,r8
.nonibadd141:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop141
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop141:
exts.b r3,r3
mov r9,r8
mov.b r3,@r2
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-6,r7
! Opcodes 4810 - 4817
O810:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd143
add #-6,r8
.nonibadd143:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop143
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop143:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-12,r7
! Opcodes 4818 - 481F
O818:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd145
add #-6,r8
.nonibadd145:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop145
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop145:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-12,r7
! Opcodes 4820 - 4827
O820:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd147
add #-6,r8
.nonibadd147:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop147
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop147:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-14,r7
! Opcodes 4828 - 482F
O828:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd149
add #-6,r8
.nonibadd149:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop149
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop149:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-16,r7
! Opcodes 4830 - 4837
O830:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd151
add #-6,r8
.nonibadd151:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop151
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop151:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcode 4838
O838:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd153
add #-6,r8
.nonibadd153:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop153
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop153:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-16,r7
! Opcode 4839
O839:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd155
add #-6,r8
.nonibadd155:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop155
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop155:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-20,r7
! Opcodes 4840 - 4847
O840:
add r13,r2
mov.l @r2,r3
swap.w r3,r3
mov.l r3,@r2
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 4850 - 4857
O850:
mov r2,r0
mov.l @(r0,r14),r4
mov r3,r2
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-12,r7
! Opcodes 4868 - 486F
O868:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r3,r2
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-16,r7
! Opcodes 4870 - 4877
O870:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov r3,r2
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-20,r7
! Opcode 4878
O878:
mov.w @r6+,r4
mov r3,r2
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-16,r7
! Opcode 4879
O879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov r3,r2
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-20,r7
! Opcode 487A
O87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov r3,r2
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-16,r7
! Opcode 487B
O87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov r3,r2
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-20,r7
! Opcodes 4880 - 4887
O880:
add r13,r2
mov.b @r2,r3
mov.w r3,@r2
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 4890 - 4897
O890:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov #0,r2
ln156:
shlr r10
bf ln157
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln157:
add #4,r2
mov #64,r0
tst r0,r2
bt ln156
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 48A0 - 48A7
O8A0:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov.l r2,@-r15
mov #60,r2
ln158:
shlr r10
bf ln159
mov r13,r0
add #-2,r4
mov.l @(r0,r2),r3
mov.l @(wdecw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
ln159:
add #-4,r2
cmp/pz r2
bt ln158
mov.l @r15+,r2
mov.l @r15+,r10
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 48A8 - 48AF
O8A8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln160:
shlr r10
bf ln161
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln161:
add #4,r2
mov #64,r0
tst r0,r2
bt ln160
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 48B0 - 48B7
O8B0:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov #0,r2
ln162:
shlr r10
bf ln163
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln163:
add #4,r2
mov #64,r0
tst r0,r2
bt ln162
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 48B8
O8B8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov #0,r2
ln164:
shlr r10
bf ln165
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln165:
add #4,r2
mov #64,r0
tst r0,r2
bt ln164
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 48B9
O8B9:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov #0,r2
ln166:
shlr r10
bf ln167
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln167:
add #4,r2
mov #64,r0
tst r0,r2
bt ln166
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 48C0 - 48C7
O8C0:
add r13,r2
mov.w @r2,r3
mov.l r3,@r2
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 48D0 - 48D7
O8D0:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov #0,r2
ln168:
shlr r10
bf ln169
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln169:
add #4,r2
mov #64,r0
tst r0,r2
bt ln168
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 48E0 - 48E7
O8E0:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov.l r2,@-r15
mov #60,r2
ln170:
shlr r10
bf ln171
mov r13,r0
add #-4,r4
mov.l @(r0,r2),r3
mov.l @(wdecl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
ln171:
add #-4,r2
cmp/pz r2
bt ln170
mov.l @r15+,r2
mov.l @r15+,r10
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 48E8 - 48EF
O8E8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln172:
shlr r10
bf ln173
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln173:
add #4,r2
mov #64,r0
tst r0,r2
bt ln172
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 48F0 - 48F7
O8F0:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov #0,r2
ln174:
shlr r10
bf ln175
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln175:
add #4,r2
mov #64,r0
tst r0,r2
bt ln174
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcode 48F8
O8F8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov #0,r2
ln176:
shlr r10
bf ln177
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln177:
add #4,r2
mov #64,r0
tst r0,r2
bt ln176
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcode 48F9
O8F9:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov #0,r2
ln178:
shlr r10
bf ln179
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln179:
add #4,r2
mov #64,r0
tst r0,r2
bt ln178
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 4980 - 4987
O980:
mov r2,r0
mov.w @(r0,r13),r3
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn180
mov #0,r8
cmp/hi r3,r1
bt ln180
jmp @r10
add #-10,r7
setn180:
mov #1,r8
ln180:
mov.l r1,@-r15
mov.l g2_except_ptr180,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr180,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_ptr180: .long group_2_exception
bf_addr180: .long basefunction
! Opcodes 4990 - 4997
O990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn181
mov #0,r8
cmp/hi r3,r1
bt ln181
jmp @r10
add #-14,r7
setn181:
mov #1,r8
ln181:
mov.l r1,@-r15
mov.l g2_except_ptr181,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr181,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr181: .long group_2_exception
bf_addr181: .long basefunction
! Opcodes 4998 - 499F
O998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn182
mov #0,r8
cmp/hi r3,r1
bt ln182
jmp @r10
add #-14,r7
setn182:
mov #1,r8
ln182:
mov.l r1,@-r15
mov.l g2_except_ptr182,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr182,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr182: .long group_2_exception
bf_addr182: .long basefunction
! Opcodes 49A0 - 49A7
O9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn183
mov #0,r8
cmp/hi r3,r1
bt ln183
jmp @r10
add #-16,r7
setn183:
mov #1,r8
ln183:
mov.l r1,@-r15
mov.l g2_except_ptr183,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr183,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-56,r7
.align 2
g2_except_ptr183: .long group_2_exception
bf_addr183: .long basefunction
! Opcodes 49A8 - 49AF
O9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn184
mov #0,r8
cmp/hi r3,r1
bt ln184
jmp @r10
add #-18,r7
setn184:
mov #1,r8
ln184:
mov.l r1,@-r15
mov.l g2_except_ptr184,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr184,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr184: .long group_2_exception
bf_addr184: .long basefunction
! Opcodes 49B0 - 49B7
O9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn185
mov #0,r8
cmp/hi r3,r1
bt ln185
jmp @r10
add #-20,r7
setn185:
mov #1,r8
ln185:
mov.l r1,@-r15
mov.l g2_except_ptr185,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr185,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr185: .long group_2_exception
bf_addr185: .long basefunction
! Opcode 49B8
O9B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn186
mov #0,r8
cmp/hi r3,r1
bt ln186
jmp @r10
add #-18,r7
setn186:
mov #1,r8
ln186:
mov.l r1,@-r15
mov.l g2_except_ptr186,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr186,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr186: .long group_2_exception
bf_addr186: .long basefunction
! Opcode 49B9
O9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn187
mov #0,r8
cmp/hi r3,r1
bt ln187
jmp @r10
add #-22,r7
setn187:
mov #1,r8
ln187:
mov.l r1,@-r15
mov.l g2_except_ptr187,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr187,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-62,r7
.align 2
g2_except_ptr187: .long group_2_exception
bf_addr187: .long basefunction
! Opcode 49BA
O9BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn188
mov #0,r8
cmp/hi r3,r1
bt ln188
jmp @r10
add #-18,r7
setn188:
mov #1,r8
ln188:
mov.l r1,@-r15
mov.l g2_except_ptr188,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr188,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr188: .long group_2_exception
bf_addr188: .long basefunction
! Opcode 49BB
O9BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn189
mov #0,r8
cmp/hi r3,r1
bt ln189
jmp @r10
add #-20,r7
setn189:
mov #1,r8
ln189:
mov.l r1,@-r15
mov.l g2_except_ptr189,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr189,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr189: .long group_2_exception
bf_addr189: .long basefunction
! Opcode 49BC
O9BC:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn190
mov #0,r8
cmp/hi r3,r1
bt ln190
jmp @r10
add #-14,r7
setn190:
mov #1,r8
ln190:
mov.l r1,@-r15
mov.l g2_except_ptr190,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr190,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr190: .long group_2_exception
bf_addr190: .long basefunction
! Opcodes 49D0 - 49D7
O9D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(48,r13)
jmp @r10
add #-4,r7
! Opcodes 49E8 - 49EF
O9E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(48,r13)
jmp @r10
add #-8,r7
! Opcodes 49F0 - 49F7
O9F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l r4,@(48,r13)
jmp @r10
add #-12,r7
! Opcode 49F8
O9F8:
mov.w @r6+,r4
mov.l r4,@(48,r13)
jmp @r10
add #-8,r7
! Opcode 49F9
O9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(48,r13)
jmp @r10
add #-12,r7
! Opcode 49FA
O9FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(48,r13)
jmp @r10
add #-8,r7
! Opcode 49FB
O9FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l r4,@(48,r13)
jmp @r10
add #-12,r7
! Opcodes 4A00 - 4A07
OA00:
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 4A10 - 4A17
OA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 4A18 - 4A1F
OA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 4A20 - 4A27
OA20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 4A28 - 4A2F
OA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 4A30 - 4A37
OA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 4A38
OA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 4A39
OA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 4A40 - 4A47
OA40:
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 4A50 - 4A57
OA50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 4A58 - 4A5F
OA58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 4A60 - 4A67
OA60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 4A68 - 4A6F
OA68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 4A70 - 4A77
OA70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 4A78
OA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 4A79
OA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 4A80 - 4A87
OA80:
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 4A90 - 4A97
OA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 4A98 - 4A9F
OA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 4AA0 - 4AA7
OAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 4AA8 - 4AAF
OAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 4AB0 - 4AB7
OAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 4AB8
OAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 4AB9
OAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 4AC0 - 4AC7
OAC0:
mov r2,r0
mov.b @(r0,r13),r3
mov r3,r1
mov.l r3,@-r15
mov #0,r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 4AD0 - 4AD7
OAD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
mov #0,r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 4AD8 - 4ADF
OAD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
mov #0,r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 4AE0 - 4AE7
OAE0:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
mov #0,r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 4AE8 - 4AEF
OAE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
mov #0,r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcodes 4AF0 - 4AF7
OAF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
mov #0,r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-24,r7
! Opcode 4AF8
OAF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
mov #0,r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 4AF9
OAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
mov #0,r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-26,r7
! Opcode 4AFA
OAFA:
r_illegal:
mov.l r3,@-r15
mov.l g1_except_addr191,r0
add #-2,r6
jsr @r0
mov #0x10,r4
mov.l bf_addr191,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
jmp @r10
add #-34,r7
.align 2
g1_except_addr191: .long group_1_exception
bf_addr191: .long basefunction
! Opcode 4AFB
OAFB:
mov.l r3,@-r15
mov.l g1_except_addr192,r0
add #-2,r6
jsr @r0
mov #0x10,r4
mov.l bf_addr192,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
jmp @r10
add #-34,r7
.align 2
g1_except_addr192: .long group_1_exception
bf_addr192: .long basefunction
! Opcode 4AFC
OAFC:
mov.l r3,@-r15
mov.l g1_except_addr193,r0
add #-2,r6
jsr @r0
mov #0x10,r4
mov.l bf_addr193,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
jmp @r10
add #-34,r7
.align 2
g1_except_addr193: .long group_1_exception
bf_addr193: .long basefunction
! Opcodes 4B80 - 4B87
OB80:
mov r2,r0
mov.w @(r0,r13),r3
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn194
mov #0,r8
cmp/hi r3,r1
bt ln194
jmp @r10
add #-10,r7
setn194:
mov #1,r8
ln194:
mov.l r1,@-r15
mov.l g2_except_ptr194,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr194,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_ptr194: .long group_2_exception
bf_addr194: .long basefunction
! Opcodes 4B90 - 4B97
OB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn195
mov #0,r8
cmp/hi r3,r1
bt ln195
jmp @r10
add #-14,r7
setn195:
mov #1,r8
ln195:
mov.l r1,@-r15
mov.l g2_except_ptr195,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr195,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr195: .long group_2_exception
bf_addr195: .long basefunction
! Opcodes 4B98 - 4B9F
OB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn196
mov #0,r8
cmp/hi r3,r1
bt ln196
jmp @r10
add #-14,r7
setn196:
mov #1,r8
ln196:
mov.l r1,@-r15
mov.l g2_except_ptr196,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr196,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr196: .long group_2_exception
bf_addr196: .long basefunction
! Opcodes 4BA0 - 4BA7
OBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn197
mov #0,r8
cmp/hi r3,r1
bt ln197
jmp @r10
add #-16,r7
setn197:
mov #1,r8
ln197:
mov.l r1,@-r15
mov.l g2_except_ptr197,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr197,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-56,r7
.align 2
g2_except_ptr197: .long group_2_exception
bf_addr197: .long basefunction
! Opcodes 4BA8 - 4BAF
OBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn198
mov #0,r8
cmp/hi r3,r1
bt ln198
jmp @r10
add #-18,r7
setn198:
mov #1,r8
ln198:
mov.l r1,@-r15
mov.l g2_except_ptr198,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr198,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr198: .long group_2_exception
bf_addr198: .long basefunction
! Opcodes 4BB0 - 4BB7
OBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn199
mov #0,r8
cmp/hi r3,r1
bt ln199
jmp @r10
add #-20,r7
setn199:
mov #1,r8
ln199:
mov.l r1,@-r15
mov.l g2_except_ptr199,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr199,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr199: .long group_2_exception
bf_addr199: .long basefunction
! Opcode 4BB8
OBB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn200
mov #0,r8
cmp/hi r3,r1
bt ln200
jmp @r10
add #-18,r7
setn200:
mov #1,r8
ln200:
mov.l r1,@-r15
mov.l g2_except_ptr200,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr200,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr200: .long group_2_exception
bf_addr200: .long basefunction
! Opcode 4BB9
OBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn201
mov #0,r8
cmp/hi r3,r1
bt ln201
jmp @r10
add #-22,r7
setn201:
mov #1,r8
ln201:
mov.l r1,@-r15
mov.l g2_except_ptr201,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr201,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-62,r7
.align 2
g2_except_ptr201: .long group_2_exception
bf_addr201: .long basefunction
! Opcode 4BBA
OBBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn202
mov #0,r8
cmp/hi r3,r1
bt ln202
jmp @r10
add #-18,r7
setn202:
mov #1,r8
ln202:
mov.l r1,@-r15
mov.l g2_except_ptr202,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr202,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr202: .long group_2_exception
bf_addr202: .long basefunction
! Opcode 4BBB
OBBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn203
mov #0,r8
cmp/hi r3,r1
bt ln203
jmp @r10
add #-20,r7
setn203:
mov #1,r8
ln203:
mov.l r1,@-r15
mov.l g2_except_ptr203,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr203,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr203: .long group_2_exception
bf_addr203: .long basefunction
! Opcode 4BBC
OBBC:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn204
mov #0,r8
cmp/hi r3,r1
bt ln204
jmp @r10
add #-14,r7
setn204:
mov #1,r8
ln204:
mov.l r1,@-r15
mov.l g2_except_ptr204,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr204,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr204: .long group_2_exception
bf_addr204: .long basefunction
! Opcodes 4BD0 - 4BD7
OBD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(52,r13)
jmp @r10
add #-4,r7
! Opcodes 4BE8 - 4BEF
OBE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(52,r13)
jmp @r10
add #-8,r7
! Opcodes 4BF0 - 4BF7
OBF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l r4,@(52,r13)
jmp @r10
add #-12,r7
! Opcode 4BF8
OBF8:
mov.w @r6+,r4
mov.l r4,@(52,r13)
jmp @r10
add #-8,r7
! Opcode 4BF9
OBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(52,r13)
jmp @r10
add #-12,r7
! Opcode 4BFA
OBFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(52,r13)
jmp @r10
add #-8,r7
! Opcode 4BFB
OBFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l r4,@(52,r13)
jmp @r10
add #-12,r7
! Opcodes 4C90 - 4C97
OC90:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov #0,r2
ln205:
shlr r10
bf ln206
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln206:
add #4,r2
mov #64,r0
tst r0,r2
bt ln205
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 4C98 - 4C9F
OC98:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov.l r2,@-r15
mov #0,r2
ln207:
shlr r10
bf ln208
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
add #2,r4
mov.l r3,@(r0,r2)
ln208:
add #4,r2
mov #64,r0
tst r0,r2
bt ln207
mov.l @r15+,r2
mov.l @r15+,r10
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 4CA8 - 4CAF
OCA8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln209:
shlr r10
bf ln210
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln210:
add #4,r2
mov #64,r0
tst r0,r2
bt ln209
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 4CB0 - 4CB7
OCB0:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov #0,r2
ln211:
shlr r10
bf ln212
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln212:
add #4,r2
mov #64,r0
tst r0,r2
bt ln211
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 4CB8
OCB8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov #0,r2
ln213:
shlr r10
bf ln214
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln214:
add #4,r2
mov #64,r0
tst r0,r2
bt ln213
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 4CB9
OCB9:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov #0,r2
ln215:
shlr r10
bf ln216
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln216:
add #4,r2
mov #64,r0
tst r0,r2
bt ln215
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 4CBA
OCBA:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov #0,r2
ln217:
shlr r10
bf ln218
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln218:
add #4,r2
mov #64,r0
tst r0,r2
bt ln217
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 4CBB
OCBB:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov #0,r2
ln219:
shlr r10
bf ln220
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln220:
add #4,r2
mov #64,r0
tst r0,r2
bt ln219
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 4CD0 - 4CD7
OCD0:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov #0,r2
ln221:
shlr r10
bf ln222
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln222:
add #4,r2
mov #64,r0
tst r0,r2
bt ln221
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 4CD8 - 4CDF
OCD8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov.l r2,@-r15
mov #0,r2
ln223:
shlr r10
bf ln224
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
add #4,r4
mov.l r3,@(r0,r2)
ln224:
add #4,r2
mov #64,r0
tst r0,r2
bt ln223
mov.l @r15+,r2
mov.l @r15+,r10
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 4CE8 - 4CEF
OCE8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln225:
shlr r10
bf ln226
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln226:
add #4,r2
mov #64,r0
tst r0,r2
bt ln225
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 4CF0 - 4CF7
OCF0:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov #0,r2
ln227:
shlr r10
bf ln228
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln228:
add #4,r2
mov #64,r0
tst r0,r2
bt ln227
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 4CF8
OCF8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov #0,r2
ln229:
shlr r10
bf ln230
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln230:
add #4,r2
mov #64,r0
tst r0,r2
bt ln229
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 4CF9
OCF9:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov #0,r2
ln231:
shlr r10
bf ln232
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln232:
add #4,r2
mov #64,r0
tst r0,r2
bt ln231
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 4CFA
OCFA:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov #0,r2
ln233:
shlr r10
bf ln234
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln234:
add #4,r2
mov #64,r0
tst r0,r2
bt ln233
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 4CFB
OCFB:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov #0,r2
ln235:
shlr r10
bf ln236
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln236:
add #4,r2
mov #64,r0
tst r0,r2
bt ln235
mov.l @r15+,r10
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 4D80 - 4D87
OD80:
mov r2,r0
mov.w @(r0,r13),r3
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn237
mov #0,r8
cmp/hi r3,r1
bt ln237
jmp @r10
add #-10,r7
setn237:
mov #1,r8
ln237:
mov.l r1,@-r15
mov.l g2_except_ptr237,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr237,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_ptr237: .long group_2_exception
bf_addr237: .long basefunction
! Opcodes 4D90 - 4D97
OD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn238
mov #0,r8
cmp/hi r3,r1
bt ln238
jmp @r10
add #-14,r7
setn238:
mov #1,r8
ln238:
mov.l r1,@-r15
mov.l g2_except_ptr238,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr238,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr238: .long group_2_exception
bf_addr238: .long basefunction
! Opcodes 4D98 - 4D9F
OD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn239
mov #0,r8
cmp/hi r3,r1
bt ln239
jmp @r10
add #-14,r7
setn239:
mov #1,r8
ln239:
mov.l r1,@-r15
mov.l g2_except_ptr239,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr239,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr239: .long group_2_exception
bf_addr239: .long basefunction
! Opcodes 4DA0 - 4DA7
ODA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn240
mov #0,r8
cmp/hi r3,r1
bt ln240
jmp @r10
add #-16,r7
setn240:
mov #1,r8
ln240:
mov.l r1,@-r15
mov.l g2_except_ptr240,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr240,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-56,r7
.align 2
g2_except_ptr240: .long group_2_exception
bf_addr240: .long basefunction
! Opcodes 4DA8 - 4DAF
ODA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn241
mov #0,r8
cmp/hi r3,r1
bt ln241
jmp @r10
add #-18,r7
setn241:
mov #1,r8
ln241:
mov.l r1,@-r15
mov.l g2_except_ptr241,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr241,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr241: .long group_2_exception
bf_addr241: .long basefunction
! Opcodes 4DB0 - 4DB7
ODB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn242
mov #0,r8
cmp/hi r3,r1
bt ln242
jmp @r10
add #-20,r7
setn242:
mov #1,r8
ln242:
mov.l r1,@-r15
mov.l g2_except_ptr242,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr242,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr242: .long group_2_exception
bf_addr242: .long basefunction
! Opcode 4DB8
ODB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn243
mov #0,r8
cmp/hi r3,r1
bt ln243
jmp @r10
add #-18,r7
setn243:
mov #1,r8
ln243:
mov.l r1,@-r15
mov.l g2_except_ptr243,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr243,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr243: .long group_2_exception
bf_addr243: .long basefunction
! Opcode 4DB9
ODB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn244
mov #0,r8
cmp/hi r3,r1
bt ln244
jmp @r10
add #-22,r7
setn244:
mov #1,r8
ln244:
mov.l r1,@-r15
mov.l g2_except_ptr244,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr244,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-62,r7
.align 2
g2_except_ptr244: .long group_2_exception
bf_addr244: .long basefunction
! Opcode 4DBA
ODBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn245
mov #0,r8
cmp/hi r3,r1
bt ln245
jmp @r10
add #-18,r7
setn245:
mov #1,r8
ln245:
mov.l r1,@-r15
mov.l g2_except_ptr245,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr245,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr245: .long group_2_exception
bf_addr245: .long basefunction
! Opcode 4DBB
ODBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn246
mov #0,r8
cmp/hi r3,r1
bt ln246
jmp @r10
add #-20,r7
setn246:
mov #1,r8
ln246:
mov.l r1,@-r15
mov.l g2_except_ptr246,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr246,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr246: .long group_2_exception
bf_addr246: .long basefunction
! Opcode 4DBC
ODBC:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn247
mov #0,r8
cmp/hi r3,r1
bt ln247
jmp @r10
add #-14,r7
setn247:
mov #1,r8
ln247:
mov.l r1,@-r15
mov.l g2_except_ptr247,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr247,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr247: .long group_2_exception
bf_addr247: .long basefunction
! Opcodes 4DD0 - 4DD7
ODD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(56,r13)
jmp @r10
add #-4,r7
! Opcodes 4DE8 - 4DEF
ODE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(56,r13)
jmp @r10
add #-8,r7
! Opcodes 4DF0 - 4DF7
ODF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l r4,@(56,r13)
jmp @r10
add #-12,r7
! Opcode 4DF8
ODF8:
mov.w @r6+,r4
mov.l r4,@(56,r13)
jmp @r10
add #-8,r7
! Opcode 4DF9
ODF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(56,r13)
jmp @r10
add #-12,r7
! Opcode 4DFA
ODFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(56,r13)
jmp @r10
add #-8,r7
! Opcode 4DFB
ODFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l r4,@(56,r13)
jmp @r10
add #-12,r7
! Opcodes 4E40 - 4E4F
OE40:
mov #0x80,r4
and #0x3C,r0
mov.l g2_exception_addr,r1
extu.b r4,r4
jsr @r1
add r0,r4
mov.l bf_addr248,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_exception_addr: .long group_2_exception
bf_addr248: .long basefunction
! Opcodes 4E50 - 4E57
OE50:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @(60,r13),r3
mov r2,r0
mov.l r3,@(r0,r14)
mov.w @r6+,r4
add r4,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 4E58 - 4E5F
OE58:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r3
mov.l r3,@(60,r13)
mov.l @(60,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov r2,r0
mov.l r3,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 4E60 - 4E67
OE60:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok249
mov.l priviolation_addr249,r0
jmp @r0
nop
.align 2
priviolation_addr249: .long privilege_violation
pcheck_ok249:
mov r2,r0
mov.l @(r0,r14),r1
mov.l r1,@(32,r14)
jmp @r10
add #-4,r7
! Opcodes 4E68 - 4E6F
OE68:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok250
mov.l priviolation_addr250,r0
jmp @r0
nop
.align 2
priviolation_addr250: .long privilege_violation
pcheck_ok250:
mov.l @(32,r14),r1
mov r2,r0
mov.l r1,@(r0,r14)
jmp @r10
add #-4,r7
! Opcode 4E70
OE70:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok252
mov.l priviolation_addr252,r0
jmp @r0
nop
.align 2
priviolation_addr252: .long privilege_violation
pcheck_ok252:
mov.l resethandler_addr251,r0
mov.l @r0,r1
tst r1,r1
bt r_done
mov.l r3,@-r15
mov.l __io_cycle_counter_addr251,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-__io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-__io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
nop
lds.l	@r15+,pr
mov.l __io_cycle_counter_addr251,r0
mov.l @r0,r7
mov.l @(io_fetchbase-__io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-__io_cycle_counter,r0),r6
mov.l @r15+,r3
r_done:
add #-128,r7
jmp @r10
add #-4,r7
.align 2
__io_cycle_counter_addr251: .long __io_cycle_counter
resethandler_addr251: .long resethandler
! Opcode 4E71
OE71:
jmp @r10
add #-4,r7
! Opcode 4E72
OE72:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok253
mov.l priviolation_addr253,r0
jmp @r0
nop
.align 2
priviolation_addr253: .long privilege_violation
pcheck_ok253:
mov.w @r6+,r3
mov.l execinfo_addr253,r2
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln254
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln254:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.w @r2,r0
mov #0x80,r1
extu.b r1,r1
or r1,r0
mov.w r0,@r2
mov.l @(execexit_addr-areg,r14),r0
add #2,r6
jmp @r0
add #-4,r7
.align 2
execinfo_addr253: .long execinfo
! Opcode 4E73
OE73:
mov.l @(sreg-areg,r14),r0
shlr8 r0
tst #0x20,r0
bf pcheck_ok257
mov.l priviolation_addr257,r0
jmp @r0
nop
.align 2
priviolation_addr257: .long privilege_violation
pcheck_ok257:
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
mov.l @(60,r13),r4
add #2,r4
mov.l @(sreg - areg,r14),r0
mov #0x20,r1
shll8 r1
xor r3,r0
tst r1,r0
bt ln258
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln258:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov #(sreg-areg),r1
add r14,r1
add #1,r1
mov.b r0,@r1
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov.l @(sreg-areg,r14),r0
shlr8 r0
extu.b r0,r0
tst #0x20,r0
movt r2
mov.l r3,@-r15
shll2 r2
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #28,r2
add r14,r2
mov.l @r2,r4
add #6,r4
mov.l r4,@r2
mov.l execinfo_addr256,r1
mov.w @r1,r0
and #0xE7,r0
mov.w r0,@r1
mov r3,r6
mov.l bf_addr256,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.l fdl_cp_addr260,r4
jmp @r4
add #-20,r7
.align 2
fdl_cp_addr260: .long fdl_cp
.align 2
bf_addr256: .long basefunction
execinfo_addr256: .long execinfo
! Opcode 4E75
OE75:
mov r3,r2
mov.l @(60,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov r3,r6
mov.l bf_addr261,r0
jsr @r0
nop
add r5,r6
mov r2,r3
jmp @r10
add #-16,r7
.align 2
bf_addr261: .long basefunction
! Opcode 4E76
OE76:
mov r8,r0
tst #0x2,r0
bf ln262
jmp @r10
add #-4,r7
ln262:
mov.l g2_exception_ptr,r0
jsr @r0
mov #0x1C,r4
mov.l bf_addr262,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_exception_ptr: .long group_2_exception
bf_addr262: .long basefunction
! Opcode 4E77
OE77:
mov.l @(60,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
and r0,r9
and r0,r3
movt r0
shll2 r0
or r0,r8
mov r3,r2
mov.l @(60,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov r3,r6
mov.l bf_addr263,r0
jsr @r0
nop
add r5,r6
mov r2,r3
jmp @r10
add #-20,r7
.align 2
bf_addr263: .long basefunction
! Opcodes 4E90 - 4E97
OE90:
mov r2,r0
mov.l @(r0,r14),r4
mov r3,r2
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr264,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-16,r7
.align 2
bf_addr264: .long basefunction
! Opcodes 4EA8 - 4EAF
OEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r3,r2
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr265,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-18,r7
.align 2
bf_addr265: .long basefunction
! Opcodes 4EB0 - 4EB7
OEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov r3,r2
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr266,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-22,r7
.align 2
bf_addr266: .long basefunction
! Opcode 4EB8
OEB8:
mov.w @r6+,r4
mov r3,r2
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr267,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-18,r7
.align 2
bf_addr267: .long basefunction
! Opcode 4EB9
OEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov r3,r2
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr268,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-20,r7
.align 2
bf_addr268: .long basefunction
! Opcode 4EBA
OEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov r3,r2
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr269,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-18,r7
.align 2
bf_addr269: .long basefunction
! Opcode 4EBB
OEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov r3,r2
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr270,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-22,r7
.align 2
bf_addr270: .long basefunction
! Opcodes 4ED0 - 4ED7
OED0:
mov r2,r0
mov.l @(r0,r14),r4
mov r4,r6
mov.l bf_addr271,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-8,r7
.align 2
bf_addr271: .long basefunction
! Opcodes 4EE8 - 4EEF
OEE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r4,r6
mov.l bf_addr272,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-10,r7
.align 2
bf_addr272: .long basefunction
! Opcodes 4EF0 - 4EF7
OEF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov r4,r6
mov.l bf_addr273,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-14,r7
.align 2
bf_addr273: .long basefunction
! Opcode 4EF8
OEF8:
mov.w @r6+,r4
mov r4,r6
mov.l bf_addr274,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-10,r7
.align 2
bf_addr274: .long basefunction
! Opcode 4EF9
OEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov r4,r6
mov.l bf_addr275,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-12,r7
.align 2
bf_addr275: .long basefunction
! Opcode 4EFA
OEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov r4,r6
mov.l bf_addr276,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-10,r7
.align 2
bf_addr276: .long basefunction
! Opcode 4EFB
OEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov r4,r6
mov.l bf_addr277,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-14,r7
.align 2
bf_addr277: .long basefunction
! Opcodes 4F80 - 4F87
OF80:
mov r2,r0
mov.w @(r0,r13),r3
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn278
mov #0,r8
cmp/hi r3,r1
bt ln278
jmp @r10
add #-10,r7
setn278:
mov #1,r8
ln278:
mov.l r1,@-r15
mov.l g2_except_ptr278,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr278,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_ptr278: .long group_2_exception
bf_addr278: .long basefunction
! Opcodes 4F90 - 4F97
OF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn279
mov #0,r8
cmp/hi r3,r1
bt ln279
jmp @r10
add #-14,r7
setn279:
mov #1,r8
ln279:
mov.l r1,@-r15
mov.l g2_except_ptr279,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr279,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr279: .long group_2_exception
bf_addr279: .long basefunction
! Opcodes 4F98 - 4F9F
OF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn280
mov #0,r8
cmp/hi r3,r1
bt ln280
jmp @r10
add #-14,r7
setn280:
mov #1,r8
ln280:
mov.l r1,@-r15
mov.l g2_except_ptr280,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr280,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr280: .long group_2_exception
bf_addr280: .long basefunction
! Opcodes 4FA0 - 4FA7
OFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn281
mov #0,r8
cmp/hi r3,r1
bt ln281
jmp @r10
add #-16,r7
setn281:
mov #1,r8
ln281:
mov.l r1,@-r15
mov.l g2_except_ptr281,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr281,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-56,r7
.align 2
g2_except_ptr281: .long group_2_exception
bf_addr281: .long basefunction
! Opcodes 4FA8 - 4FAF
OFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn282
mov #0,r8
cmp/hi r3,r1
bt ln282
jmp @r10
add #-18,r7
setn282:
mov #1,r8
ln282:
mov.l r1,@-r15
mov.l g2_except_ptr282,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr282,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr282: .long group_2_exception
bf_addr282: .long basefunction
! Opcodes 4FB0 - 4FB7
OFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn283
mov #0,r8
cmp/hi r3,r1
bt ln283
jmp @r10
add #-20,r7
setn283:
mov #1,r8
ln283:
mov.l r1,@-r15
mov.l g2_except_ptr283,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr283,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr283: .long group_2_exception
bf_addr283: .long basefunction
! Opcode 4FB8
OFB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn284
mov #0,r8
cmp/hi r3,r1
bt ln284
jmp @r10
add #-18,r7
setn284:
mov #1,r8
ln284:
mov.l r1,@-r15
mov.l g2_except_ptr284,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr284,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr284: .long group_2_exception
bf_addr284: .long basefunction
! Opcode 4FB9
OFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn285
mov #0,r8
cmp/hi r3,r1
bt ln285
jmp @r10
add #-22,r7
setn285:
mov #1,r8
ln285:
mov.l r1,@-r15
mov.l g2_except_ptr285,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr285,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-62,r7
.align 2
g2_except_ptr285: .long group_2_exception
bf_addr285: .long basefunction
! Opcode 4FBA
OFBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn286
mov #0,r8
cmp/hi r3,r1
bt ln286
jmp @r10
add #-18,r7
setn286:
mov #1,r8
ln286:
mov.l r1,@-r15
mov.l g2_except_ptr286,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr286,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-58,r7
.align 2
g2_except_ptr286: .long group_2_exception
bf_addr286: .long basefunction
! Opcode 4FBB
OFBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn287
mov #0,r8
cmp/hi r3,r1
bt ln287
jmp @r10
add #-20,r7
setn287:
mov #1,r8
ln287:
mov.l r1,@-r15
mov.l g2_except_ptr287,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr287,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-60,r7
.align 2
g2_except_ptr287: .long group_2_exception
bf_addr287: .long basefunction
! Opcode 4FBC
OFBC:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn288
mov #0,r8
cmp/hi r3,r1
bt ln288
jmp @r10
add #-14,r7
setn288:
mov #1,r8
ln288:
mov.l r1,@-r15
mov.l g2_except_ptr288,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr288,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-54,r7
.align 2
g2_except_ptr288: .long group_2_exception
bf_addr288: .long basefunction
! Opcodes 4FD0 - 4FD7
OFD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(60,r13)
jmp @r10
add #-4,r7
! Opcodes 4FE8 - 4FEF
OFE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(60,r13)
jmp @r10
add #-8,r7
! Opcodes 4FF0 - 4FF7
OFF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l r4,@(60,r13)
jmp @r10
add #-12,r7
! Opcode 4FF8
OFF8:
mov.w @r6+,r4
mov.l r4,@(60,r13)
jmp @r10
add #-8,r7
! Opcode 4FF9
OFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(60,r13)
jmp @r10
add #-12,r7
! Opcode 4FFA
OFFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(60,r13)
jmp @r10
add #-8,r7
! Opcode 4FFB
OFFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l r4,@(60,r13)
jmp @r10
add #-12,r7
! Opcodes 5000 - 5007
P000:
add r13,r2
mov.b @r2,r3
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5008 - 500F
P008:
add r13,r2
mov.b @r2,r3
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5010 - 5017
P010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5018 - 501F
P018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5020 - 5027
P020:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5028 - 502F
P028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5030 - 5037
P030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5038
P038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5039
P039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5040 - 5047
P040:
add r13,r2
mov.w @r2,r3
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5048 - 504F
P048:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 8,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-4,r7
! Opcodes 5050 - 5057
P050:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5058 - 505F
P058:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5060 - 5067
P060:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5068 - 506F
P068:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5070 - 5077
P070:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5078
P078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5079
P079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5080 - 5087
P080:
add r13,r2
mov.l @r2,r3
mov #8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5088 - 508F
P088:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 8,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5090 - 5097
P090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5098 - 509F
P098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 50A0 - 50A7
P0A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 50A8 - 50AF
P0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 50B0 - 50B7
P0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 50B8
P0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 50B9
P0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 50C0 - 50C7
P0C0:
mov.l r3,@-r15
mov #255,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-6,r7
! Opcodes 50C8 - 50CF
P0C8:
add #2,r6
jmp @r10
add #-12,r7
! Opcodes 50D0 - 50D7
P0D0:
mov.l r3,@-r15
mov #255,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 50D8 - 50DF
P0D8:
mov.l r3,@-r15
mov #255,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 50E0 - 50E7
P0E0:
mov.l r3,@-r15
mov #255,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 50E8 - 50EF
P0E8:
mov.l r3,@-r15
mov #255,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 50F0 - 50F7
P0F0:
mov.l r3,@-r15
mov #255,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 50F8
P0F8:
mov.l r3,@-r15
mov #255,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 50F9
P0F9:
mov.l r3,@-r15
mov #255,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5100 - 5107
P100:
add r13,r2
mov.b @r2,r3
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5108 - 510F
P108:
add r13,r2
mov.b @r2,r3
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5110 - 5117
P110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5118 - 511F
P118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5120 - 5127
P120:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5128 - 512F
P128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5130 - 5137
P130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5138
P138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5139
P139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5140 - 5147
P140:
add r13,r2
mov.w @r2,r3
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5148 - 514F
P148:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-8,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5150 - 5157
P150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5158 - 515F
P158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5160 - 5167
P160:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5168 - 516F
P168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5170 - 5177
P170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5178
P178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5179
P179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5180 - 5187
P180:
add r13,r2
mov.l @r2,r3
mov #8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5188 - 518F
P188:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-8,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5190 - 5197
P190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5198 - 519F
P198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 51A0 - 51A7
P1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 51A8 - 51AF
P1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 51B0 - 51B7
P1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 51B8
P1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 51B9
P1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 51C0 - 51C7
P1C0:
mov.l r3,@-r15
mov #0,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 51C8 - 51CF
P1C8:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w289
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w289:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 51D0 - 51D7
P1D0:
mov.l r3,@-r15
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 51D8 - 51DF
P1D8:
mov.l r3,@-r15
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 51E0 - 51E7
P1E0:
mov.l r3,@-r15
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 51E8 - 51EF
P1E8:
mov.l r3,@-r15
mov #0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 51F0 - 51F7
P1F0:
mov.l r3,@-r15
mov #0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 51F8
P1F8:
mov.l r3,@-r15
mov #0,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 51F9
P1F9:
mov.l r3,@-r15
mov #0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5200 - 5207
P200:
add r13,r2
mov.b @r2,r3
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5208 - 520F
P208:
add r13,r2
mov.b @r2,r3
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5210 - 5217
P210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5218 - 521F
P218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5220 - 5227
P220:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5228 - 522F
P228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5230 - 5237
P230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5238
P238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5239
P239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5240 - 5247
P240:
add r13,r2
mov.w @r2,r3
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5248 - 524F
P248:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 1,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-4,r7
! Opcodes 5250 - 5257
P250:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5258 - 525F
P258:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5260 - 5267
P260:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5268 - 526F
P268:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5270 - 5277
P270:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5278
P278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5279
P279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5280 - 5287
P280:
add r13,r2
mov.l @r2,r3
mov #1,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5288 - 528F
P288:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 1,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5290 - 5297
P290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5298 - 529F
P298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 52A0 - 52A7
P2A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 52A8 - 52AF
P2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 52B0 - 52B7
P2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 52B8
P2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 52B9
P2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 52C0 - 52C7
P2C0:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 52C8 - 52CF
P2C8:
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
bf dbcc290
add #2,r6
jmp @r10
add #-12,r7
dbcc290:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w290
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w290:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 52D0 - 52D7
P2D0:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 52D8 - 52DF
P2D8:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 52E0 - 52E7
P2E0:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 52E8 - 52EF
P2E8:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 52F0 - 52F7
P2F0:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 52F8
P2F8:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 52F9
P2F9:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5300 - 5307
P300:
add r13,r2
mov.b @r2,r3
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5308 - 530F
P308:
add r13,r2
mov.b @r2,r3
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5310 - 5317
P310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5318 - 531F
P318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5320 - 5327
P320:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5328 - 532F
P328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5330 - 5337
P330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5338
P338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5339
P339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5340 - 5347
P340:
add r13,r2
mov.w @r2,r3
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5348 - 534F
P348:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-1,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5350 - 5357
P350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5358 - 535F
P358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5360 - 5367
P360:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5368 - 536F
P368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5370 - 5377
P370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5378
P378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5379
P379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5380 - 5387
P380:
add r13,r2
mov.l @r2,r3
mov #1,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5388 - 538F
P388:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-1,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5390 - 5397
P390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5398 - 539F
P398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 53A0 - 53A7
P3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 53A8 - 53AF
P3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 53B0 - 53B7
P3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 53B8
P3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 53B9
P3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 53C0 - 53C7
P3C0:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
add #-1,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 53C8 - 53CF
P3C8:
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
bt dbcc291
add #2,r6
jmp @r10
add #-12,r7
dbcc291:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w291
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w291:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 53D0 - 53D7
P3D0:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 53D8 - 53DF
P3D8:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 53E0 - 53E7
P3E0:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 53E8 - 53EF
P3E8:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 53F0 - 53F7
P3F0:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
add #-1,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 53F8
P3F8:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 53F9
P3F9:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
movt r3
add #-1,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5400 - 5407
P400:
add r13,r2
mov.b @r2,r3
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5408 - 540F
P408:
add r13,r2
mov.b @r2,r3
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5410 - 5417
P410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5418 - 541F
P418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5420 - 5427
P420:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5428 - 542F
P428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5430 - 5437
P430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5438
P438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5439
P439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5440 - 5447
P440:
add r13,r2
mov.w @r2,r3
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5448 - 544F
P448:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 2,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-4,r7
! Opcodes 5450 - 5457
P450:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5458 - 545F
P458:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5460 - 5467
P460:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5468 - 546F
P468:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5470 - 5477
P470:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5478
P478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5479
P479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5480 - 5487
P480:
add r13,r2
mov.l @r2,r3
mov #2,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5488 - 548F
P488:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 2,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5490 - 5497
P490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5498 - 549F
P498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 54A0 - 54A7
P4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 54A8 - 54AF
P4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 54B0 - 54B7
P4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 54B8
P4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 54B9
P4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 54C0 - 54C7
P4C0:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 54C8 - 54CF
P4C8:
mov r8,r0
tst #1,r0
bf dbcc292
add #2,r6
jmp @r10
add #-12,r7
dbcc292:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w292
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w292:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 54D0 - 54D7
P4D0:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 54D8 - 54DF
P4D8:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 54E0 - 54E7
P4E0:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 54E8 - 54EF
P4E8:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 54F0 - 54F7
P4F0:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 54F8
P4F8:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 54F9
P4F9:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5500 - 5507
P500:
add r13,r2
mov.b @r2,r3
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5508 - 550F
P508:
add r13,r2
mov.b @r2,r3
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5510 - 5517
P510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5518 - 551F
P518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5520 - 5527
P520:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5528 - 552F
P528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5530 - 5537
P530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5538
P538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5539
P539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5540 - 5547
P540:
add r13,r2
mov.w @r2,r3
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5548 - 554F
P548:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-2,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5550 - 5557
P550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5558 - 555F
P558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5560 - 5567
P560:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5568 - 556F
P568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5570 - 5577
P570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5578
P578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5579
P579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5580 - 5587
P580:
add r13,r2
mov.l @r2,r3
mov #2,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5588 - 558F
P588:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-2,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5590 - 5597
P590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5598 - 559F
P598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 55A0 - 55A7
P5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 55A8 - 55AF
P5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 55B0 - 55B7
P5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 55B8
P5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 55B9
P5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 55C0 - 55C7
P5C0:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
add #-1,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 55C8 - 55CF
P5C8:
mov r8,r0
tst #1,r0
bt dbcc293
add #2,r6
jmp @r10
add #-12,r7
dbcc293:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w293
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w293:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 55D0 - 55D7
P5D0:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 55D8 - 55DF
P5D8:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 55E0 - 55E7
P5E0:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 55E8 - 55EF
P5E8:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 55F0 - 55F7
P5F0:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
add #-1,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 55F8
P5F8:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 55F9
P5F9:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
add #-1,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5600 - 5607
P600:
add r13,r2
mov.b @r2,r3
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5608 - 560F
P608:
add r13,r2
mov.b @r2,r3
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5610 - 5617
P610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5618 - 561F
P618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5620 - 5627
P620:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5628 - 562F
P628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5630 - 5637
P630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5638
P638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5639
P639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5640 - 5647
P640:
add r13,r2
mov.w @r2,r3
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5648 - 564F
P648:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 3,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-4,r7
! Opcodes 5650 - 5657
P650:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5658 - 565F
P658:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5660 - 5667
P660:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5668 - 566F
P668:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5670 - 5677
P670:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5678
P678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5679
P679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5680 - 5687
P680:
add r13,r2
mov.l @r2,r3
mov #3,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5688 - 568F
P688:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 3,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5690 - 5697
P690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5698 - 569F
P698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 56A0 - 56A7
P6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 56A8 - 56AF
P6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 56B0 - 56B7
P6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 56B8
P6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 56B9
P6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 56C0 - 56C7
P6C0:
mov.l r3,@-r15
tst r3,r3
movt r3
add #-1,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 56C8 - 56CF
P6C8:
tst r3,r3
bt dbcc294
add #2,r6
jmp @r10
add #-12,r7
dbcc294:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w294
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w294:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 56D0 - 56D7
P6D0:
mov.l r3,@-r15
tst r3,r3
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 56D8 - 56DF
P6D8:
mov.l r3,@-r15
tst r3,r3
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 56E0 - 56E7
P6E0:
mov.l r3,@-r15
tst r3,r3
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 56E8 - 56EF
P6E8:
mov.l r3,@-r15
tst r3,r3
movt r3
add #-1,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 56F0 - 56F7
P6F0:
mov.l r3,@-r15
tst r3,r3
movt r3
add #-1,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 56F8
P6F8:
mov.l r3,@-r15
tst r3,r3
movt r3
add #-1,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 56F9
P6F9:
mov.l r3,@-r15
tst r3,r3
movt r3
add #-1,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5700 - 5707
P700:
add r13,r2
mov.b @r2,r3
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5708 - 570F
P708:
add r13,r2
mov.b @r2,r3
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5710 - 5717
P710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5718 - 571F
P718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5720 - 5727
P720:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5728 - 572F
P728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5730 - 5737
P730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5738
P738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5739
P739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5740 - 5747
P740:
add r13,r2
mov.w @r2,r3
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5748 - 574F
P748:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-3,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5750 - 5757
P750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5758 - 575F
P758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5760 - 5767
P760:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5768 - 576F
P768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5770 - 5777
P770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5778
P778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5779
P779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5780 - 5787
P780:
add r13,r2
mov.l @r2,r3
mov #3,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5788 - 578F
P788:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-3,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5790 - 5797
P790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5798 - 579F
P798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 57A0 - 57A7
P7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 57A8 - 57AF
P7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 57B0 - 57B7
P7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 57B8
P7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 57B9
P7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 57C0 - 57C7
P7C0:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 57C8 - 57CF
P7C8:
tst r3,r3
bf dbcc295
add #2,r6
jmp @r10
add #-12,r7
dbcc295:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w295
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w295:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 57D0 - 57D7
P7D0:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 57D8 - 57DF
P7D8:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 57E0 - 57E7
P7E0:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 57E8 - 57EF
P7E8:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 57F0 - 57F7
P7F0:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 57F8
P7F8:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 57F9
P7F9:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5800 - 5807
P800:
add r13,r2
mov.b @r2,r3
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5808 - 580F
P808:
add r13,r2
mov.b @r2,r3
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5810 - 5817
P810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5818 - 581F
P818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5820 - 5827
P820:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5828 - 582F
P828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5830 - 5837
P830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5838
P838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5839
P839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5840 - 5847
P840:
add r13,r2
mov.w @r2,r3
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5848 - 584F
P848:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 4,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-4,r7
! Opcodes 5850 - 5857
P850:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5858 - 585F
P858:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5860 - 5867
P860:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5868 - 586F
P868:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5870 - 5877
P870:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5878
P878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5879
P879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5880 - 5887
P880:
add r13,r2
mov.l @r2,r3
mov #4,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5888 - 588F
P888:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 4,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5890 - 5897
P890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5898 - 589F
P898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 58A0 - 58A7
P8A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 58A8 - 58AF
P8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 58B0 - 58B7
P8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 58B8
P8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 58B9
P8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 58C0 - 58C7
P8C0:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 58C8 - 58CF
P8C8:
mov r8,r0
tst #2,r0
bf dbcc296
add #2,r6
jmp @r10
add #-12,r7
dbcc296:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w296
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w296:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 58D0 - 58D7
P8D0:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 58D8 - 58DF
P8D8:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 58E0 - 58E7
P8E0:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 58E8 - 58EF
P8E8:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 58F0 - 58F7
P8F0:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 58F8
P8F8:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 58F9
P8F9:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5900 - 5907
P900:
add r13,r2
mov.b @r2,r3
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5908 - 590F
P908:
add r13,r2
mov.b @r2,r3
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5910 - 5917
P910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5918 - 591F
P918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5920 - 5927
P920:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5928 - 592F
P928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5930 - 5937
P930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5938
P938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5939
P939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5940 - 5947
P940:
add r13,r2
mov.w @r2,r3
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5948 - 594F
P948:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-4,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5950 - 5957
P950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5958 - 595F
P958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5960 - 5967
P960:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5968 - 596F
P968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5970 - 5977
P970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5978
P978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5979
P979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5980 - 5987
P980:
add r13,r2
mov.l @r2,r3
mov #4,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5988 - 598F
P988:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-4,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5990 - 5997
P990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5998 - 599F
P998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 59A0 - 59A7
P9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 59A8 - 59AF
P9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 59B0 - 59B7
P9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 59B8
P9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 59B9
P9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 59C0 - 59C7
P9C0:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
add #-1,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 59C8 - 59CF
P9C8:
mov r8,r0
tst #2,r0
bt dbcc297
add #2,r6
jmp @r10
add #-12,r7
dbcc297:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w297
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w297:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 59D0 - 59D7
P9D0:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 59D8 - 59DF
P9D8:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 59E0 - 59E7
P9E0:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 59E8 - 59EF
P9E8:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 59F0 - 59F7
P9F0:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
add #-1,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 59F8
P9F8:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 59F9
P9F9:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
add #-1,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5A00 - 5A07
PA00:
add r13,r2
mov.b @r2,r3
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5A08 - 5A0F
PA08:
add r13,r2
mov.b @r2,r3
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5A10 - 5A17
PA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5A18 - 5A1F
PA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5A20 - 5A27
PA20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5A28 - 5A2F
PA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5A30 - 5A37
PA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5A38
PA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5A39
PA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5A40 - 5A47
PA40:
add r13,r2
mov.w @r2,r3
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5A48 - 5A4F
PA48:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 5,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-4,r7
! Opcodes 5A50 - 5A57
PA50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5A58 - 5A5F
PA58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5A60 - 5A67
PA60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5A68 - 5A6F
PA68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5A70 - 5A77
PA70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5A78
PA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5A79
PA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5A80 - 5A87
PA80:
add r13,r2
mov.l @r2,r3
mov #5,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5A88 - 5A8F
PA88:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 5,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5A90 - 5A97
PA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5A98 - 5A9F
PA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 5AA0 - 5AA7
PAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 5AA8 - 5AAF
PAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 5AB0 - 5AB7
PAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 5AB8
PAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 5AB9
PAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 5AC0 - 5AC7
PAC0:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
add #-1,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 5AC8 - 5ACF
PAC8:
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
bt dbcc298
add #2,r6
jmp @r10
add #-12,r7
dbcc298:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w298
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w298:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 5AD0 - 5AD7
PAD0:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5AD8 - 5ADF
PAD8:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5AE0 - 5AE7
PAE0:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 5AE8 - 5AEF
PAE8:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 5AF0 - 5AF7
PAF0:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
add #-1,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 5AF8
PAF8:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 5AF9
PAF9:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
add #-1,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5B00 - 5B07
PB00:
add r13,r2
mov.b @r2,r3
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5B08 - 5B0F
PB08:
add r13,r2
mov.b @r2,r3
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5B10 - 5B17
PB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5B18 - 5B1F
PB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5B20 - 5B27
PB20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5B28 - 5B2F
PB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5B30 - 5B37
PB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5B38
PB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5B39
PB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5B40 - 5B47
PB40:
add r13,r2
mov.w @r2,r3
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5B48 - 5B4F
PB48:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-5,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5B50 - 5B57
PB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5B58 - 5B5F
PB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5B60 - 5B67
PB60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5B68 - 5B6F
PB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5B70 - 5B77
PB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5B78
PB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5B79
PB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5B80 - 5B87
PB80:
add r13,r2
mov.l @r2,r3
mov #5,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5B88 - 5B8F
PB88:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-5,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5B90 - 5B97
PB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5B98 - 5B9F
PB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 5BA0 - 5BA7
PBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 5BA8 - 5BAF
PBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 5BB0 - 5BB7
PBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 5BB8
PBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 5BB9
PBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 5BC0 - 5BC7
PBC0:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
neg r3,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 5BC8 - 5BCF
PBC8:
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
bf dbcc299
add #2,r6
jmp @r10
add #-12,r7
dbcc299:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w299
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w299:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 5BD0 - 5BD7
PBD0:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5BD8 - 5BDF
PBD8:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5BE0 - 5BE7
PBE0:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 5BE8 - 5BEF
PBE8:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 5BF0 - 5BF7
PBF0:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 5BF8
PBF8:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 5BF9
PBF9:
mov.l r3,@-r15
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5C00 - 5C07
PC00:
add r13,r2
mov.b @r2,r3
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5C08 - 5C0F
PC08:
add r13,r2
mov.b @r2,r3
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5C10 - 5C17
PC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5C18 - 5C1F
PC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5C20 - 5C27
PC20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5C28 - 5C2F
PC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5C30 - 5C37
PC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5C38
PC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5C39
PC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5C40 - 5C47
PC40:
add r13,r2
mov.w @r2,r3
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5C48 - 5C4F
PC48:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 6,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-4,r7
! Opcodes 5C50 - 5C57
PC50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5C58 - 5C5F
PC58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5C60 - 5C67
PC60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5C68 - 5C6F
PC68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5C70 - 5C77
PC70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5C78
PC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5C79
PC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5C80 - 5C87
PC80:
add r13,r2
mov.l @r2,r3
mov #6,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5C88 - 5C8F
PC88:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 6,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5C90 - 5C97
PC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5C98 - 5C9F
PC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 5CA0 - 5CA7
PCA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 5CA8 - 5CAF
PCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 5CB0 - 5CB7
PCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 5CB8
PCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 5CB9
PCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 5CC0 - 5CC7
PCC0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
add #-1,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 5CC8 - 5CCF
PCC8:
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
bt dbcc300
add #2,r6
jmp @r10
add #-12,r7
dbcc300:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w300
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w300:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 5CD0 - 5CD7
PCD0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5CD8 - 5CDF
PCD8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5CE0 - 5CE7
PCE0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 5CE8 - 5CEF
PCE8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 5CF0 - 5CF7
PCF0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
add #-1,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 5CF8
PCF8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 5CF9
PCF9:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
add #-1,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5D00 - 5D07
PD00:
add r13,r2
mov.b @r2,r3
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5D08 - 5D0F
PD08:
add r13,r2
mov.b @r2,r3
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5D10 - 5D17
PD10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5D18 - 5D1F
PD18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5D20 - 5D27
PD20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5D28 - 5D2F
PD28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5D30 - 5D37
PD30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5D38
PD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5D39
PD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5D40 - 5D47
PD40:
add r13,r2
mov.w @r2,r3
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5D48 - 5D4F
PD48:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-6,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5D50 - 5D57
PD50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5D58 - 5D5F
PD58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5D60 - 5D67
PD60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5D68 - 5D6F
PD68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5D70 - 5D77
PD70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5D78
PD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5D79
PD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5D80 - 5D87
PD80:
add r13,r2
mov.l @r2,r3
mov #6,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5D88 - 5D8F
PD88:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-6,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5D90 - 5D97
PD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5D98 - 5D9F
PD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 5DA0 - 5DA7
PDA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 5DA8 - 5DAF
PDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 5DB0 - 5DB7
PDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 5DB8
PDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 5DB9
PDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 5DC0 - 5DC7
PDC0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
neg r3,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 5DC8 - 5DCF
PDC8:
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
bf dbcc301
add #2,r6
jmp @r10
add #-12,r7
dbcc301:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w301
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w301:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 5DD0 - 5DD7
PDD0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5DD8 - 5DDF
PDD8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5DE0 - 5DE7
PDE0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 5DE8 - 5DEF
PDE8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 5DF0 - 5DF7
PDF0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 5DF8
PDF8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 5DF9
PDF9:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5E00 - 5E07
PE00:
add r13,r2
mov.b @r2,r3
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5E08 - 5E0F
PE08:
add r13,r2
mov.b @r2,r3
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5E10 - 5E17
PE10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5E18 - 5E1F
PE18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5E20 - 5E27
PE20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5E28 - 5E2F
PE28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5E30 - 5E37
PE30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5E38
PE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5E39
PE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5E40 - 5E47
PE40:
add r13,r2
mov.w @r2,r3
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5E48 - 5E4F
PE48:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 7,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-4,r7
! Opcodes 5E50 - 5E57
PE50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5E58 - 5E5F
PE58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5E60 - 5E67
PE60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5E68 - 5E6F
PE68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5E70 - 5E77
PE70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5E78
PE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5E79
PE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5E80 - 5E87
PE80:
add r13,r2
mov.l @r2,r3
mov #7,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5E88 - 5E8F
PE88:
mov r3,r4
add r14,r2
mov.l @r2,r3
add # 7,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5E90 - 5E97
PE90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5E98 - 5E9F
PE98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 5EA0 - 5EA7
PEA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 5EA8 - 5EAF
PEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 5EB0 - 5EB7
PEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 5EB8
PEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 5EB9
PEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 5EC0 - 5EC7
PEC0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 5EC8 - 5ECF
PEC8:
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
bf dbcc302
add #2,r6
jmp @r10
add #-12,r7
dbcc302:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w302
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w302:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 5ED0 - 5ED7
PED0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5ED8 - 5EDF
PED8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5EE0 - 5EE7
PEE0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 5EE8 - 5EEF
PEE8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 5EF0 - 5EF7
PEF0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 5EF8
PEF8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 5EF9
PEF9:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcodes 5F00 - 5F07
PF00:
add r13,r2
mov.b @r2,r3
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5F08 - 5F0F
PF08:
add r13,r2
mov.b @r2,r3
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5F10 - 5F17
PF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5F18 - 5F1F
PF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5F20 - 5F27
PF20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5F28 - 5F2F
PF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5F30 - 5F37
PF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5F38
PF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5F39
PF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5F40 - 5F47
PF40:
add r13,r2
mov.w @r2,r3
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-4,r7
! Opcodes 5F48 - 5F4F
PF48:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-7,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5F50 - 5F57
PF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 5F58 - 5F5F
PF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 5F60 - 5F67
PF60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 5F68 - 5F6F
PF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 5F70 - 5F77
PF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 5F78
PF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 5F79
PF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5F80 - 5F87
PF80:
add r13,r2
mov.l @r2,r3
mov #7,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes 5F88 - 5F8F
PF88:
mov r3,r4
add r14,r2
mov.l @r2,r3
add #-7,r3
mov.l r3,@r2
mov r4,r3
jmp @r10
add #-8,r7
! Opcodes 5F90 - 5F97
PF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 5F98 - 5F9F
PF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 5FA0 - 5FA7
PFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 5FA8 - 5FAF
PFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 5FB0 - 5FB7
PFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 5FB8
PFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 5FB9
PFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 5FC0 - 5FC7
PFC0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
add #-1,r3
add r3,r7
add r3,r7
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
jmp @r10
add #-4,r7
! Opcodes 5FC8 - 5FCF
PFC8:
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
bt dbcc303
add #2,r6
jmp @r10
add #-12,r7
dbcc303:
mov r2,r0
mov.w @(r0,r13),r1
tst r1,r1
add #-1,r1
bf/s bcc_w303
mov.w r1,@(r0,r13)
add #2,r6
jmp @r10
add #-14,r7
bcc_w303:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 5FD0 - 5FD7
PFD0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5FD8 - 5FDF
PFD8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 5FE0 - 5FE7
PFE0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
add #-1,r3
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 5FE8 - 5FEF
PFE8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 5FF0 - 5FF7
PFF0:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
add #-1,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 5FF8
PFF8:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
add #-1,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 5FF9
PFF9:
mov.l r3,@-r15
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
movt r3
add #-1,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 6000
Q000:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6001 - 60FF
Q001:
shlr2 r0
exts.b r0,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6100
Q100:
mov.w @r6,r1
mov r3,r2
mov r6,r3
add #2,r3
add r1,r6
sub r5,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-18,r7
! Opcodes 6101 - 61FF
Q101:
shlr2 r0
mov r3,r2
exts.b r0,r1
mov r6,r3
add r1,r6
sub r5,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov r2,r3
jmp @r10
add #-18,r7
! Opcode 6200
Q200:
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
bt bcc_w305
add #2,r6
jmp @r10
add #-12,r7
bcc_w305:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6201 - 62FF
Q201:
mov r0,r2
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
bt bcc_b306
jmp @r10
add #-8,r7
bcc_b306:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6300
Q300:
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
bf bcc_w307
add #2,r6
jmp @r10
add #-12,r7
bcc_w307:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6301 - 63FF
Q301:
mov r0,r2
tst r3,r3
mov r8,r0
addc r0,r0
tst #3,r0
bf bcc_b308
jmp @r10
add #-8,r7
bcc_b308:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6400
Q400:
mov r8,r0
tst #1,r0
bt bcc_w309
add #2,r6
jmp @r10
add #-12,r7
bcc_w309:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6401 - 64FF
Q401:
mov r0,r2
mov r8,r0
tst #1,r0
bt bcc_b310
jmp @r10
add #-8,r7
bcc_b310:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6500
Q500:
mov r8,r0
tst #1,r0
bf bcc_w311
add #2,r6
jmp @r10
add #-12,r7
bcc_w311:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6501 - 65FF
Q501:
mov r0,r2
mov r8,r0
tst #1,r0
bf bcc_b312
jmp @r10
add #-8,r7
bcc_b312:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6600
Q600:
tst r3,r3
bf bcc_w313
add #2,r6
jmp @r10
add #-12,r7
bcc_w313:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6601 - 66FF
Q601:
mov r0,r2
tst r3,r3
bf bcc_b314
jmp @r10
add #-8,r7
bcc_b314:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6700
Q700:
tst r3,r3
bt bcc_w315
add #2,r6
jmp @r10
add #-12,r7
bcc_w315:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6701 - 67FF
Q701:
mov r0,r2
tst r3,r3
bt bcc_b316
jmp @r10
add #-8,r7
bcc_b316:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6800
Q800:
mov r8,r0
tst #2,r0
bt bcc_w317
add #2,r6
jmp @r10
add #-12,r7
bcc_w317:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6801 - 68FF
Q801:
mov r0,r2
mov r8,r0
tst #2,r0
bt bcc_b318
jmp @r10
add #-8,r7
bcc_b318:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6900
Q900:
mov r8,r0
tst #2,r0
bf bcc_w319
add #2,r6
jmp @r10
add #-12,r7
bcc_w319:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6901 - 69FF
Q901:
mov r0,r2
mov r8,r0
tst #2,r0
bf bcc_b320
jmp @r10
add #-8,r7
bcc_b320:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6A00
QA00:
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
bf bcc_w321
add #2,r6
jmp @r10
add #-12,r7
bcc_w321:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6A01 - 6AFF
QA01:
mov r0,r2
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
bf bcc_b322
jmp @r10
add #-8,r7
bcc_b322:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6B00
QB00:
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
bt bcc_w323
add #2,r6
jmp @r10
add #-12,r7
bcc_w323:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6B01 - 6BFF
QB01:
mov r0,r2
mov r8,r0
rotl r3
movt r1
shlr2 r0
xor r1,r0
rotr r3
shlr r0
bt bcc_b324
jmp @r10
add #-8,r7
bcc_b324:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6C00
QC00:
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
bf bcc_w325
add #2,r6
jmp @r10
add #-12,r7
bcc_w325:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6C01 - 6CFF
QC01:
mov r0,r2
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
bf bcc_b326
jmp @r10
add #-8,r7
bcc_b326:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6D00
QD00:
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
bt bcc_w327
add #2,r6
jmp @r10
add #-12,r7
bcc_w327:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6D01 - 6DFF
QD01:
mov r0,r2
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
xor r8,r0
shlr r0
shlr r0
mov r8,r0
rotl r3
movt r1
shlr2 r0
rotr r3
xor r0,r1
mov r8,r0
shlr r0
xor r1,r0
shlr r0
bt bcc_b328
jmp @r10
add #-8,r7
bcc_b328:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6E00
QE00:
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
bt bcc_w329
add #2,r6
jmp @r10
add #-12,r7
bcc_w329:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6E01 - 6EFF
QE01:
mov r0,r2
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
bt bcc_b330
jmp @r10
add #-8,r7
bcc_b330:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcode 6F00
QF00:
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
bf bcc_w331
add #2,r6
jmp @r10
add #-12,r7
bcc_w331:
mov.w @r6,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 6F01 - 6FFF
QF01:
mov r0,r2
mov r3,r1
mov r8,r0
rotl r1
shlr r0
shll r1
xor r1,r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #5,r0
bf bcc_b332
jmp @r10
add #-8,r7
bcc_b332:
shlr2 r2
exts.b r2,r0
add r0,r6
jmp @r10
add #-10,r7
! Opcodes 7000 - 70FF
R000:
shlr2 r0
exts.b r0,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 7200 - 72FF
R200:
shlr2 r0
exts.b r0,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 7400 - 74FF
R400:
shlr2 r0
exts.b r0,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 7600 - 76FF
R600:
shlr2 r0
exts.b r0,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 7800 - 78FF
R800:
shlr2 r0
exts.b r0,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 7A00 - 7AFF
RA00:
shlr2 r0
exts.b r0,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 7C00 - 7CFF
RC00:
shlr2 r0
exts.b r0,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 7E00 - 7EFF
RE00:
shlr2 r0
exts.b r0,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8000 - 8007
S000:
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8010 - 8017
S010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8018 - 801F
S018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8020 - 8027
S020:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8028 - 802F
S028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8030 - 8037
S030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8038
S038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8039
S039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 803A
S03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 803B
S03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 803C
S03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8040 - 8047
S040:
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8050 - 8057
S050:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8058 - 805F
S058:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8060 - 8067
S060:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8068 - 806F
S068:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8070 - 8077
S070:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8078
S078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8079
S079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 807A
S07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 807B
S07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 807C
S07C:
mov.w @r6+,r3
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8080 - 8087
S080:
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8090 - 8097
S090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8098 - 809F
S098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 80A0 - 80A7
S0A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 80A8 - 80AF
S0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 80B0 - 80B7
S0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 80B8
S0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 80B9
S0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 80BA
S0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 80BB
S0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 80BC
S0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 80C0 - 80C7
S0C0:
add r13,r2
mov.w @r2,r3
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln333
shll16 r3
cmp/hs r3,r1
bt ov334
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-106,r7
ov334:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-10,r7
ln333:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr333,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr333,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr333: .long group_2_exception
bf_addr333: .long basefunction
! Opcodes 80D0 - 80D7
S0D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln335
shll16 r3
cmp/hs r3,r1
bt ov336
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov336:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln335:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr335,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr335,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr335: .long group_2_exception
bf_addr335: .long basefunction
! Opcodes 80D8 - 80DF
S0D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln337
shll16 r3
cmp/hs r3,r1
bt ov338
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov338:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln337:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr337,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr337,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr337: .long group_2_exception
bf_addr337: .long basefunction
! Opcodes 80E0 - 80E7
S0E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln339
shll16 r3
cmp/hs r3,r1
bt ov340
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-112,r7
ov340:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln339:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr339,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr339,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr339: .long group_2_exception
bf_addr339: .long basefunction
! Opcodes 80E8 - 80EF
S0E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln341
shll16 r3
cmp/hs r3,r1
bt ov342
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov342:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln341:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr341,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr341,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr341: .long group_2_exception
bf_addr341: .long basefunction
! Opcodes 80F0 - 80F7
S0F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln343
shll16 r3
cmp/hs r3,r1
bt ov344
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov344:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln343:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr343,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr343,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr343: .long group_2_exception
bf_addr343: .long basefunction
! Opcode 80F8
S0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln345
shll16 r3
cmp/hs r3,r1
bt ov346
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov346:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln345:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr345,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr345,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr345: .long group_2_exception
bf_addr345: .long basefunction
! Opcode 80F9
S0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln347
shll16 r3
cmp/hs r3,r1
bt ov348
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-118,r7
ov348:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln347:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr347,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr347,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr347: .long group_2_exception
bf_addr347: .long basefunction
! Opcode 80FA
S0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln349
shll16 r3
cmp/hs r3,r1
bt ov350
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov350:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln349:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr349,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr349,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr349: .long group_2_exception
bf_addr349: .long basefunction
! Opcode 80FB
S0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln351
shll16 r3
cmp/hs r3,r1
bt ov352
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov352:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln351:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr351,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr351,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr351: .long group_2_exception
bf_addr351: .long basefunction
! Opcode 80FC
S0FC:
mov.w @r6+,r3
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln353
shll16 r3
cmp/hs r3,r1
bt ov354
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov354:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln353:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr353,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr353,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr353: .long group_2_exception
bf_addr353: .long basefunction
! Opcodes 8100 - 8107
S100:
mov r3,r4
mov.b @r13,r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd355
add #-6,r8
.nonibadd355:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop355
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop355:
exts.b r3,r3
mov r9,r8
mov.b r3,@r13
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 8108 - 810F
S108:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd356
add #-6,r8
.nonibadd356:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop356
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop356:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 8110 - 8117
S110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8118 - 811F
S118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8120 - 8127
S120:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8128 - 812F
S128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8130 - 8137
S130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8138
S138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8139
S139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8150 - 8157
S150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8158 - 815F
S158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8160 - 8167
S160:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8168 - 816F
S168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8170 - 8177
S170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8178
S178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8179
S179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8190 - 8197
S190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8198 - 819F
S198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 81A0 - 81A7
S1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 81A8 - 81AF
S1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 81B0 - 81B7
S1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 81B8
S1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 81B9
S1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 81C0 - 81C7
S1C0:
add r13,r2
mov.w @r2,r3
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln357
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck357
add #1,r1
tst r1,r1
bf ov358
ovcheck357:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-11,r7
ov358:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln357:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr357,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr357,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr357: .long group_2_exception
bf_addr357: .long basefunction
! Opcodes 81D0 - 81D7
S1D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln359
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck359
add #1,r1
tst r1,r1
bf ov360
ovcheck359:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov360:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln359:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr359,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr359,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr359: .long group_2_exception
bf_addr359: .long basefunction
! Opcodes 81D8 - 81DF
S1D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln361
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck361
add #1,r1
tst r1,r1
bf ov362
ovcheck361:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov362:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln361:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr361,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr361,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr361: .long group_2_exception
bf_addr361: .long basefunction
! Opcodes 81E0 - 81E7
S1E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln363
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck363
add #1,r1
tst r1,r1
bf ov364
ovcheck363:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-17,r7
ov364:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln363:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr363,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr363,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr363: .long group_2_exception
bf_addr363: .long basefunction
! Opcodes 81E8 - 81EF
S1E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln365
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck365
add #1,r1
tst r1,r1
bf ov366
ovcheck365:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov366:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln365:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr365,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr365,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr365: .long group_2_exception
bf_addr365: .long basefunction
! Opcodes 81F0 - 81F7
S1F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln367
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck367
add #1,r1
tst r1,r1
bf ov368
ovcheck367:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov368:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln367:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr367,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr367,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr367: .long group_2_exception
bf_addr367: .long basefunction
! Opcode 81F8
S1F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln369
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck369
add #1,r1
tst r1,r1
bf ov370
ovcheck369:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov370:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln369:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr369,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr369,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr369: .long group_2_exception
bf_addr369: .long basefunction
! Opcode 81F9
S1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln371
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck371
add #1,r1
tst r1,r1
bf ov372
ovcheck371:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-23,r7
ov372:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-28,r7
ln371:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr371,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr371,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr371: .long group_2_exception
bf_addr371: .long basefunction
! Opcode 81FA
S1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln373
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck373
add #1,r1
tst r1,r1
bf ov374
ovcheck373:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov374:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln373:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr373,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr373,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr373: .long group_2_exception
bf_addr373: .long basefunction
! Opcode 81FB
S1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln375
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck375
add #1,r1
tst r1,r1
bf ov376
ovcheck375:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov376:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln375:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr375,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr375,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr375: .long group_2_exception
bf_addr375: .long basefunction
! Opcode 81FC
S1FC:
mov.w @r6+,r3
mov.l @r13,r1
mov r3,r8
tst r8,r8
bt/s ln377
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck377
add #1,r1
tst r1,r1
bf ov378
ovcheck377:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov378:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln377:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr377,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr377,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr377: .long group_2_exception
bf_addr377: .long basefunction
! Opcodes 8200 - 8207
S200:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8210 - 8217
S210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8218 - 821F
S218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8220 - 8227
S220:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8228 - 822F
S228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8230 - 8237
S230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8238
S238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8239
S239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 823A
S23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 823B
S23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 823C
S23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8240 - 8247
S240:
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8250 - 8257
S250:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8258 - 825F
S258:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8260 - 8267
S260:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8268 - 826F
S268:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8270 - 8277
S270:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8278
S278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8279
S279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 827A
S27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 827B
S27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 827C
S27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8280 - 8287
S280:
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8290 - 8297
S290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8298 - 829F
S298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 82A0 - 82A7
S2A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 82A8 - 82AF
S2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 82B0 - 82B7
S2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 82B8
S2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 82B9
S2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 82BA
S2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 82BB
S2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 82BC
S2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 82C0 - 82C7
S2C0:
add r13,r2
mov.w @r2,r3
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln379
shll16 r3
cmp/hs r3,r1
bt ov380
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-106,r7
ov380:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-10,r7
ln379:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr379,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr379,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr379: .long group_2_exception
bf_addr379: .long basefunction
! Opcodes 82D0 - 82D7
S2D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln381
shll16 r3
cmp/hs r3,r1
bt ov382
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov382:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln381:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr381,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr381,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr381: .long group_2_exception
bf_addr381: .long basefunction
! Opcodes 82D8 - 82DF
S2D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln383
shll16 r3
cmp/hs r3,r1
bt ov384
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov384:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln383:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr383,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr383,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr383: .long group_2_exception
bf_addr383: .long basefunction
! Opcodes 82E0 - 82E7
S2E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln385
shll16 r3
cmp/hs r3,r1
bt ov386
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-112,r7
ov386:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln385:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr385,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr385,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr385: .long group_2_exception
bf_addr385: .long basefunction
! Opcodes 82E8 - 82EF
S2E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln387
shll16 r3
cmp/hs r3,r1
bt ov388
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov388:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln387:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr387,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr387,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr387: .long group_2_exception
bf_addr387: .long basefunction
! Opcodes 82F0 - 82F7
S2F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln389
shll16 r3
cmp/hs r3,r1
bt ov390
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov390:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln389:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr389,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr389,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr389: .long group_2_exception
bf_addr389: .long basefunction
! Opcode 82F8
S2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln391
shll16 r3
cmp/hs r3,r1
bt ov392
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov392:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln391:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr391,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr391,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr391: .long group_2_exception
bf_addr391: .long basefunction
! Opcode 82F9
S2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln393
shll16 r3
cmp/hs r3,r1
bt ov394
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-118,r7
ov394:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln393:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr393,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr393,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr393: .long group_2_exception
bf_addr393: .long basefunction
! Opcode 82FA
S2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln395
shll16 r3
cmp/hs r3,r1
bt ov396
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov396:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln395:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr395,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr395,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr395: .long group_2_exception
bf_addr395: .long basefunction
! Opcode 82FB
S2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln397
shll16 r3
cmp/hs r3,r1
bt ov398
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov398:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln397:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr397,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr397,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr397: .long group_2_exception
bf_addr397: .long basefunction
! Opcode 82FC
S2FC:
mov.w @r6+,r3
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln399
shll16 r3
cmp/hs r3,r1
bt ov400
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov400:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln399:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr399,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr399,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr399: .long group_2_exception
bf_addr399: .long basefunction
! Opcodes 8300 - 8307
S300:
mov r3,r4
mov #4,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd401
add #-6,r8
.nonibadd401:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop401
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop401:
exts.b r3,r3
mov r9,r8
mov #4,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 8308 - 830F
S308:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd402
add #-6,r8
.nonibadd402:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop402
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop402:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 8310 - 8317
S310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8318 - 831F
S318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8320 - 8327
S320:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8328 - 832F
S328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8330 - 8337
S330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8338
S338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8339
S339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8350 - 8357
S350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8358 - 835F
S358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8360 - 8367
S360:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8368 - 836F
S368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8370 - 8377
S370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8378
S378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8379
S379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8390 - 8397
S390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8398 - 839F
S398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 83A0 - 83A7
S3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 83A8 - 83AF
S3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 83B0 - 83B7
S3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 83B8
S3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 83B9
S3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 83C0 - 83C7
S3C0:
add r13,r2
mov.w @r2,r3
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln403
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck403
add #1,r1
tst r1,r1
bf ov404
ovcheck403:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-11,r7
ov404:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln403:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr403,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr403,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr403: .long group_2_exception
bf_addr403: .long basefunction
! Opcodes 83D0 - 83D7
S3D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln405
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck405
add #1,r1
tst r1,r1
bf ov406
ovcheck405:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov406:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln405:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr405,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr405,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr405: .long group_2_exception
bf_addr405: .long basefunction
! Opcodes 83D8 - 83DF
S3D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln407
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck407
add #1,r1
tst r1,r1
bf ov408
ovcheck407:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov408:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln407:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr407,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr407,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr407: .long group_2_exception
bf_addr407: .long basefunction
! Opcodes 83E0 - 83E7
S3E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln409
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck409
add #1,r1
tst r1,r1
bf ov410
ovcheck409:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-17,r7
ov410:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln409:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr409,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr409,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr409: .long group_2_exception
bf_addr409: .long basefunction
! Opcodes 83E8 - 83EF
S3E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln411
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck411
add #1,r1
tst r1,r1
bf ov412
ovcheck411:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov412:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln411:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr411,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr411,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr411: .long group_2_exception
bf_addr411: .long basefunction
! Opcodes 83F0 - 83F7
S3F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln413
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck413
add #1,r1
tst r1,r1
bf ov414
ovcheck413:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov414:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln413:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr413,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr413,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr413: .long group_2_exception
bf_addr413: .long basefunction
! Opcode 83F8
S3F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln415
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck415
add #1,r1
tst r1,r1
bf ov416
ovcheck415:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov416:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln415:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr415,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr415,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr415: .long group_2_exception
bf_addr415: .long basefunction
! Opcode 83F9
S3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln417
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck417
add #1,r1
tst r1,r1
bf ov418
ovcheck417:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-23,r7
ov418:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-28,r7
ln417:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr417,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr417,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr417: .long group_2_exception
bf_addr417: .long basefunction
! Opcode 83FA
S3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln419
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck419
add #1,r1
tst r1,r1
bf ov420
ovcheck419:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov420:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln419:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr419,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr419,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr419: .long group_2_exception
bf_addr419: .long basefunction
! Opcode 83FB
S3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln421
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck421
add #1,r1
tst r1,r1
bf ov422
ovcheck421:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov422:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln421:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr421,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr421,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr421: .long group_2_exception
bf_addr421: .long basefunction
! Opcode 83FC
S3FC:
mov.w @r6+,r3
mov.l @(4,r13),r1
mov r3,r8
tst r8,r8
bt/s ln423
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck423
add #1,r1
tst r1,r1
bf ov424
ovcheck423:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov424:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln423:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr423,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr423,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr423: .long group_2_exception
bf_addr423: .long basefunction
! Opcodes 8400 - 8407
S400:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8410 - 8417
S410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8418 - 841F
S418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8420 - 8427
S420:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8428 - 842F
S428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8430 - 8437
S430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8438
S438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8439
S439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 843A
S43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 843B
S43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 843C
S43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8440 - 8447
S440:
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8450 - 8457
S450:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8458 - 845F
S458:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8460 - 8467
S460:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8468 - 846F
S468:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8470 - 8477
S470:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8478
S478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8479
S479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 847A
S47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 847B
S47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 847C
S47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8480 - 8487
S480:
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8490 - 8497
S490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8498 - 849F
S498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 84A0 - 84A7
S4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 84A8 - 84AF
S4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 84B0 - 84B7
S4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 84B8
S4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 84B9
S4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 84BA
S4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 84BB
S4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 84BC
S4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 84C0 - 84C7
S4C0:
add r13,r2
mov.w @r2,r3
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln425
shll16 r3
cmp/hs r3,r1
bt ov426
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-106,r7
ov426:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-10,r7
ln425:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr425,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr425,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr425: .long group_2_exception
bf_addr425: .long basefunction
! Opcodes 84D0 - 84D7
S4D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln427
shll16 r3
cmp/hs r3,r1
bt ov428
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov428:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln427:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr427,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr427,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr427: .long group_2_exception
bf_addr427: .long basefunction
! Opcodes 84D8 - 84DF
S4D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln429
shll16 r3
cmp/hs r3,r1
bt ov430
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov430:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln429:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr429,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr429,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr429: .long group_2_exception
bf_addr429: .long basefunction
! Opcodes 84E0 - 84E7
S4E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln431
shll16 r3
cmp/hs r3,r1
bt ov432
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-112,r7
ov432:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln431:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr431,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr431,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr431: .long group_2_exception
bf_addr431: .long basefunction
! Opcodes 84E8 - 84EF
S4E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln433
shll16 r3
cmp/hs r3,r1
bt ov434
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov434:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln433:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr433,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr433,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr433: .long group_2_exception
bf_addr433: .long basefunction
! Opcodes 84F0 - 84F7
S4F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln435
shll16 r3
cmp/hs r3,r1
bt ov436
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov436:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln435:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr435,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr435,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr435: .long group_2_exception
bf_addr435: .long basefunction
! Opcode 84F8
S4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln437
shll16 r3
cmp/hs r3,r1
bt ov438
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov438:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln437:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr437,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr437,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr437: .long group_2_exception
bf_addr437: .long basefunction
! Opcode 84F9
S4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln439
shll16 r3
cmp/hs r3,r1
bt ov440
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-118,r7
ov440:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln439:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr439,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr439,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr439: .long group_2_exception
bf_addr439: .long basefunction
! Opcode 84FA
S4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln441
shll16 r3
cmp/hs r3,r1
bt ov442
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov442:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln441:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr441,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr441,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr441: .long group_2_exception
bf_addr441: .long basefunction
! Opcode 84FB
S4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln443
shll16 r3
cmp/hs r3,r1
bt ov444
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov444:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln443:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr443,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr443,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr443: .long group_2_exception
bf_addr443: .long basefunction
! Opcode 84FC
S4FC:
mov.w @r6+,r3
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln445
shll16 r3
cmp/hs r3,r1
bt ov446
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov446:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln445:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr445,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr445,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr445: .long group_2_exception
bf_addr445: .long basefunction
! Opcodes 8500 - 8507
S500:
mov r3,r4
mov #8,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd447
add #-6,r8
.nonibadd447:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop447
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop447:
exts.b r3,r3
mov r9,r8
mov #8,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 8508 - 850F
S508:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd448
add #-6,r8
.nonibadd448:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop448
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop448:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 8510 - 8517
S510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8518 - 851F
S518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8520 - 8527
S520:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8528 - 852F
S528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8530 - 8537
S530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8538
S538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8539
S539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8550 - 8557
S550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8558 - 855F
S558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8560 - 8567
S560:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8568 - 856F
S568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8570 - 8577
S570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8578
S578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8579
S579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8590 - 8597
S590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8598 - 859F
S598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 85A0 - 85A7
S5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 85A8 - 85AF
S5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 85B0 - 85B7
S5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 85B8
S5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 85B9
S5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 85C0 - 85C7
S5C0:
add r13,r2
mov.w @r2,r3
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln449
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck449
add #1,r1
tst r1,r1
bf ov450
ovcheck449:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-11,r7
ov450:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln449:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr449,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr449,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr449: .long group_2_exception
bf_addr449: .long basefunction
! Opcodes 85D0 - 85D7
S5D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln451
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck451
add #1,r1
tst r1,r1
bf ov452
ovcheck451:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov452:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln451:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr451,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr451,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr451: .long group_2_exception
bf_addr451: .long basefunction
! Opcodes 85D8 - 85DF
S5D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln453
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck453
add #1,r1
tst r1,r1
bf ov454
ovcheck453:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov454:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln453:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr453,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr453,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr453: .long group_2_exception
bf_addr453: .long basefunction
! Opcodes 85E0 - 85E7
S5E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln455
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck455
add #1,r1
tst r1,r1
bf ov456
ovcheck455:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-17,r7
ov456:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln455:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr455,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr455,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr455: .long group_2_exception
bf_addr455: .long basefunction
! Opcodes 85E8 - 85EF
S5E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln457
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck457
add #1,r1
tst r1,r1
bf ov458
ovcheck457:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov458:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln457:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr457,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr457,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr457: .long group_2_exception
bf_addr457: .long basefunction
! Opcodes 85F0 - 85F7
S5F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln459
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck459
add #1,r1
tst r1,r1
bf ov460
ovcheck459:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov460:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln459:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr459,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr459,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr459: .long group_2_exception
bf_addr459: .long basefunction
! Opcode 85F8
S5F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln461
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck461
add #1,r1
tst r1,r1
bf ov462
ovcheck461:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov462:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln461:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr461,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr461,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr461: .long group_2_exception
bf_addr461: .long basefunction
! Opcode 85F9
S5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln463
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck463
add #1,r1
tst r1,r1
bf ov464
ovcheck463:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-23,r7
ov464:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-28,r7
ln463:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr463,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr463,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr463: .long group_2_exception
bf_addr463: .long basefunction
! Opcode 85FA
S5FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln465
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck465
add #1,r1
tst r1,r1
bf ov466
ovcheck465:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov466:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln465:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr465,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr465,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr465: .long group_2_exception
bf_addr465: .long basefunction
! Opcode 85FB
S5FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln467
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck467
add #1,r1
tst r1,r1
bf ov468
ovcheck467:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov468:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln467:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr467,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr467,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr467: .long group_2_exception
bf_addr467: .long basefunction
! Opcode 85FC
S5FC:
mov.w @r6+,r3
mov.l @(8,r13),r1
mov r3,r8
tst r8,r8
bt/s ln469
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck469
add #1,r1
tst r1,r1
bf ov470
ovcheck469:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov470:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln469:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr469,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr469,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr469: .long group_2_exception
bf_addr469: .long basefunction
! Opcodes 8600 - 8607
S600:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8610 - 8617
S610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8618 - 861F
S618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8620 - 8627
S620:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8628 - 862F
S628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8630 - 8637
S630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8638
S638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8639
S639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 863A
S63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 863B
S63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 863C
S63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8640 - 8647
S640:
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8650 - 8657
S650:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8658 - 865F
S658:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8660 - 8667
S660:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8668 - 866F
S668:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8670 - 8677
S670:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8678
S678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8679
S679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 867A
S67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 867B
S67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 867C
S67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8680 - 8687
S680:
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8690 - 8697
S690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8698 - 869F
S698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 86A0 - 86A7
S6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 86A8 - 86AF
S6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 86B0 - 86B7
S6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 86B8
S6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 86B9
S6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 86BA
S6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 86BB
S6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 86BC
S6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 86C0 - 86C7
S6C0:
add r13,r2
mov.w @r2,r3
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln471
shll16 r3
cmp/hs r3,r1
bt ov472
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-106,r7
ov472:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-10,r7
ln471:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr471,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr471,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr471: .long group_2_exception
bf_addr471: .long basefunction
! Opcodes 86D0 - 86D7
S6D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln473
shll16 r3
cmp/hs r3,r1
bt ov474
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov474:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln473:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr473,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr473,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr473: .long group_2_exception
bf_addr473: .long basefunction
! Opcodes 86D8 - 86DF
S6D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln475
shll16 r3
cmp/hs r3,r1
bt ov476
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov476:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln475:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr475,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr475,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr475: .long group_2_exception
bf_addr475: .long basefunction
! Opcodes 86E0 - 86E7
S6E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln477
shll16 r3
cmp/hs r3,r1
bt ov478
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-112,r7
ov478:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln477:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr477,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr477,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr477: .long group_2_exception
bf_addr477: .long basefunction
! Opcodes 86E8 - 86EF
S6E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln479
shll16 r3
cmp/hs r3,r1
bt ov480
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov480:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln479:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr479,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr479,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr479: .long group_2_exception
bf_addr479: .long basefunction
! Opcodes 86F0 - 86F7
S6F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln481
shll16 r3
cmp/hs r3,r1
bt ov482
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov482:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln481:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr481,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr481,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr481: .long group_2_exception
bf_addr481: .long basefunction
! Opcode 86F8
S6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln483
shll16 r3
cmp/hs r3,r1
bt ov484
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov484:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln483:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr483,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr483,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr483: .long group_2_exception
bf_addr483: .long basefunction
! Opcode 86F9
S6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln485
shll16 r3
cmp/hs r3,r1
bt ov486
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-118,r7
ov486:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln485:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr485,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr485,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr485: .long group_2_exception
bf_addr485: .long basefunction
! Opcode 86FA
S6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln487
shll16 r3
cmp/hs r3,r1
bt ov488
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov488:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln487:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr487,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr487,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr487: .long group_2_exception
bf_addr487: .long basefunction
! Opcode 86FB
S6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln489
shll16 r3
cmp/hs r3,r1
bt ov490
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov490:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln489:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr489,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr489,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr489: .long group_2_exception
bf_addr489: .long basefunction
! Opcode 86FC
S6FC:
mov.w @r6+,r3
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln491
shll16 r3
cmp/hs r3,r1
bt ov492
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov492:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln491:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr491,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr491,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr491: .long group_2_exception
bf_addr491: .long basefunction
! Opcodes 8700 - 8707
S700:
mov r3,r4
mov #12,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd493
add #-6,r8
.nonibadd493:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop493
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop493:
exts.b r3,r3
mov r9,r8
mov #12,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 8708 - 870F
S708:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd494
add #-6,r8
.nonibadd494:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop494
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop494:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 8710 - 8717
S710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8718 - 871F
S718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8720 - 8727
S720:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8728 - 872F
S728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8730 - 8737
S730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8738
S738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8739
S739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8750 - 8757
S750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8758 - 875F
S758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8760 - 8767
S760:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8768 - 876F
S768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8770 - 8777
S770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8778
S778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8779
S779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8790 - 8797
S790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8798 - 879F
S798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 87A0 - 87A7
S7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 87A8 - 87AF
S7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 87B0 - 87B7
S7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 87B8
S7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 87B9
S7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 87C0 - 87C7
S7C0:
add r13,r2
mov.w @r2,r3
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln495
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck495
add #1,r1
tst r1,r1
bf ov496
ovcheck495:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-11,r7
ov496:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln495:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr495,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr495,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr495: .long group_2_exception
bf_addr495: .long basefunction
! Opcodes 87D0 - 87D7
S7D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln497
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck497
add #1,r1
tst r1,r1
bf ov498
ovcheck497:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov498:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln497:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr497,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr497,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr497: .long group_2_exception
bf_addr497: .long basefunction
! Opcodes 87D8 - 87DF
S7D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln499
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck499
add #1,r1
tst r1,r1
bf ov500
ovcheck499:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov500:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln499:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr499,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr499,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr499: .long group_2_exception
bf_addr499: .long basefunction
! Opcodes 87E0 - 87E7
S7E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln501
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck501
add #1,r1
tst r1,r1
bf ov502
ovcheck501:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-17,r7
ov502:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln501:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr501,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr501,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr501: .long group_2_exception
bf_addr501: .long basefunction
! Opcodes 87E8 - 87EF
S7E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln503
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck503
add #1,r1
tst r1,r1
bf ov504
ovcheck503:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov504:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln503:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr503,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr503,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr503: .long group_2_exception
bf_addr503: .long basefunction
! Opcodes 87F0 - 87F7
S7F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln505
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck505
add #1,r1
tst r1,r1
bf ov506
ovcheck505:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov506:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln505:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr505,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr505,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr505: .long group_2_exception
bf_addr505: .long basefunction
! Opcode 87F8
S7F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln507
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck507
add #1,r1
tst r1,r1
bf ov508
ovcheck507:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov508:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln507:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr507,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr507,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr507: .long group_2_exception
bf_addr507: .long basefunction
! Opcode 87F9
S7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln509
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck509
add #1,r1
tst r1,r1
bf ov510
ovcheck509:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-23,r7
ov510:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-28,r7
ln509:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr509,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr509,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr509: .long group_2_exception
bf_addr509: .long basefunction
! Opcode 87FA
S7FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln511
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck511
add #1,r1
tst r1,r1
bf ov512
ovcheck511:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov512:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln511:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr511,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr511,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr511: .long group_2_exception
bf_addr511: .long basefunction
! Opcode 87FB
S7FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln513
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck513
add #1,r1
tst r1,r1
bf ov514
ovcheck513:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov514:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln513:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr513,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr513,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr513: .long group_2_exception
bf_addr513: .long basefunction
! Opcode 87FC
S7FC:
mov.w @r6+,r3
mov.l @(12,r13),r1
mov r3,r8
tst r8,r8
bt/s ln515
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck515
add #1,r1
tst r1,r1
bf ov516
ovcheck515:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov516:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln515:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr515,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr515,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr515: .long group_2_exception
bf_addr515: .long basefunction
! Opcodes 8800 - 8807
S800:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8810 - 8817
S810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8818 - 881F
S818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8820 - 8827
S820:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8828 - 882F
S828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8830 - 8837
S830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8838
S838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8839
S839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 883A
S83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 883B
S83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 883C
S83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8840 - 8847
S840:
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8850 - 8857
S850:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8858 - 885F
S858:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8860 - 8867
S860:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8868 - 886F
S868:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8870 - 8877
S870:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8878
S878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8879
S879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 887A
S87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 887B
S87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 887C
S87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8880 - 8887
S880:
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8890 - 8897
S890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8898 - 889F
S898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 88A0 - 88A7
S8A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 88A8 - 88AF
S8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 88B0 - 88B7
S8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 88B8
S8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 88B9
S8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 88BA
S8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 88BB
S8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 88BC
S8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 88C0 - 88C7
S8C0:
add r13,r2
mov.w @r2,r3
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln517
shll16 r3
cmp/hs r3,r1
bt ov518
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-106,r7
ov518:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-10,r7
ln517:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr517,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr517,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr517: .long group_2_exception
bf_addr517: .long basefunction
! Opcodes 88D0 - 88D7
S8D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln519
shll16 r3
cmp/hs r3,r1
bt ov520
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov520:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln519:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr519,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr519,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr519: .long group_2_exception
bf_addr519: .long basefunction
! Opcodes 88D8 - 88DF
S8D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln521
shll16 r3
cmp/hs r3,r1
bt ov522
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov522:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln521:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr521,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr521,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr521: .long group_2_exception
bf_addr521: .long basefunction
! Opcodes 88E0 - 88E7
S8E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln523
shll16 r3
cmp/hs r3,r1
bt ov524
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-112,r7
ov524:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln523:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr523,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr523,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr523: .long group_2_exception
bf_addr523: .long basefunction
! Opcodes 88E8 - 88EF
S8E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln525
shll16 r3
cmp/hs r3,r1
bt ov526
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov526:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln525:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr525,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr525,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr525: .long group_2_exception
bf_addr525: .long basefunction
! Opcodes 88F0 - 88F7
S8F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln527
shll16 r3
cmp/hs r3,r1
bt ov528
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov528:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln527:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr527,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr527,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr527: .long group_2_exception
bf_addr527: .long basefunction
! Opcode 88F8
S8F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln529
shll16 r3
cmp/hs r3,r1
bt ov530
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov530:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln529:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr529,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr529,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr529: .long group_2_exception
bf_addr529: .long basefunction
! Opcode 88F9
S8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln531
shll16 r3
cmp/hs r3,r1
bt ov532
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-118,r7
ov532:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln531:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr531,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr531,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr531: .long group_2_exception
bf_addr531: .long basefunction
! Opcode 88FA
S8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln533
shll16 r3
cmp/hs r3,r1
bt ov534
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov534:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln533:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr533,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr533,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr533: .long group_2_exception
bf_addr533: .long basefunction
! Opcode 88FB
S8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln535
shll16 r3
cmp/hs r3,r1
bt ov536
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov536:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln535:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr535,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr535,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr535: .long group_2_exception
bf_addr535: .long basefunction
! Opcode 88FC
S8FC:
mov.w @r6+,r3
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln537
shll16 r3
cmp/hs r3,r1
bt ov538
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov538:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln537:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr537,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr537,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr537: .long group_2_exception
bf_addr537: .long basefunction
! Opcodes 8900 - 8907
S900:
mov r3,r4
mov #16,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd539
add #-6,r8
.nonibadd539:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop539
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop539:
exts.b r3,r3
mov r9,r8
mov #16,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 8908 - 890F
S908:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd540
add #-6,r8
.nonibadd540:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop540
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop540:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 8910 - 8917
S910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8918 - 891F
S918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8920 - 8927
S920:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8928 - 892F
S928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8930 - 8937
S930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8938
S938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8939
S939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8950 - 8957
S950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8958 - 895F
S958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8960 - 8967
S960:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8968 - 896F
S968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8970 - 8977
S970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8978
S978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8979
S979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8990 - 8997
S990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8998 - 899F
S998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 89A0 - 89A7
S9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 89A8 - 89AF
S9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 89B0 - 89B7
S9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 89B8
S9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 89B9
S9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 89C0 - 89C7
S9C0:
add r13,r2
mov.w @r2,r3
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln541
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck541
add #1,r1
tst r1,r1
bf ov542
ovcheck541:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-11,r7
ov542:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln541:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr541,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr541,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr541: .long group_2_exception
bf_addr541: .long basefunction
! Opcodes 89D0 - 89D7
S9D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln543
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck543
add #1,r1
tst r1,r1
bf ov544
ovcheck543:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov544:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln543:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr543,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr543,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr543: .long group_2_exception
bf_addr543: .long basefunction
! Opcodes 89D8 - 89DF
S9D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln545
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck545
add #1,r1
tst r1,r1
bf ov546
ovcheck545:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov546:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln545:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr545,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr545,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr545: .long group_2_exception
bf_addr545: .long basefunction
! Opcodes 89E0 - 89E7
S9E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln547
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck547
add #1,r1
tst r1,r1
bf ov548
ovcheck547:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-17,r7
ov548:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln547:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr547,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr547,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr547: .long group_2_exception
bf_addr547: .long basefunction
! Opcodes 89E8 - 89EF
S9E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln549
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck549
add #1,r1
tst r1,r1
bf ov550
ovcheck549:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov550:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln549:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr549,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr549,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr549: .long group_2_exception
bf_addr549: .long basefunction
! Opcodes 89F0 - 89F7
S9F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln551
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck551
add #1,r1
tst r1,r1
bf ov552
ovcheck551:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov552:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln551:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr551,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr551,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr551: .long group_2_exception
bf_addr551: .long basefunction
! Opcode 89F8
S9F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln553
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck553
add #1,r1
tst r1,r1
bf ov554
ovcheck553:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov554:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln553:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr553,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr553,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr553: .long group_2_exception
bf_addr553: .long basefunction
! Opcode 89F9
S9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln555
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck555
add #1,r1
tst r1,r1
bf ov556
ovcheck555:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-23,r7
ov556:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-28,r7
ln555:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr555,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr555,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr555: .long group_2_exception
bf_addr555: .long basefunction
! Opcode 89FA
S9FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln557
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck557
add #1,r1
tst r1,r1
bf ov558
ovcheck557:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov558:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln557:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr557,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr557,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr557: .long group_2_exception
bf_addr557: .long basefunction
! Opcode 89FB
S9FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln559
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck559
add #1,r1
tst r1,r1
bf ov560
ovcheck559:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov560:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln559:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr559,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr559,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr559: .long group_2_exception
bf_addr559: .long basefunction
! Opcode 89FC
S9FC:
mov.w @r6+,r3
mov.l @(16,r13),r1
mov r3,r8
tst r8,r8
bt/s ln561
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck561
add #1,r1
tst r1,r1
bf ov562
ovcheck561:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov562:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln561:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr561,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr561,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr561: .long group_2_exception
bf_addr561: .long basefunction
! Opcodes 8A00 - 8A07
SA00:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8A10 - 8A17
SA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8A18 - 8A1F
SA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8A20 - 8A27
SA20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8A28 - 8A2F
SA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8A30 - 8A37
SA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8A38
SA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8A39
SA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8A3A
SA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8A3B
SA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8A3C
SA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8A40 - 8A47
SA40:
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8A50 - 8A57
SA50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8A58 - 8A5F
SA58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8A60 - 8A67
SA60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8A68 - 8A6F
SA68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8A70 - 8A77
SA70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8A78
SA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8A79
SA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8A7A
SA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8A7B
SA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8A7C
SA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8A80 - 8A87
SA80:
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8A90 - 8A97
SA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8A98 - 8A9F
SA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8AA0 - 8AA7
SAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8AA8 - 8AAF
SAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 8AB0 - 8AB7
SAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 8AB8
SAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8AB9
SAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 8ABA
SABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8ABB
SABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 8ABC
SABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8AC0 - 8AC7
SAC0:
add r13,r2
mov.w @r2,r3
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln563
shll16 r3
cmp/hs r3,r1
bt ov564
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-106,r7
ov564:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-10,r7
ln563:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr563,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr563,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr563: .long group_2_exception
bf_addr563: .long basefunction
! Opcodes 8AD0 - 8AD7
SAD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln565
shll16 r3
cmp/hs r3,r1
bt ov566
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov566:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln565:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr565,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr565,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr565: .long group_2_exception
bf_addr565: .long basefunction
! Opcodes 8AD8 - 8ADF
SAD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln567
shll16 r3
cmp/hs r3,r1
bt ov568
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov568:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln567:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr567,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr567,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr567: .long group_2_exception
bf_addr567: .long basefunction
! Opcodes 8AE0 - 8AE7
SAE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln569
shll16 r3
cmp/hs r3,r1
bt ov570
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-112,r7
ov570:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln569:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr569,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr569,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr569: .long group_2_exception
bf_addr569: .long basefunction
! Opcodes 8AE8 - 8AEF
SAE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln571
shll16 r3
cmp/hs r3,r1
bt ov572
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov572:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln571:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr571,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr571,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr571: .long group_2_exception
bf_addr571: .long basefunction
! Opcodes 8AF0 - 8AF7
SAF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln573
shll16 r3
cmp/hs r3,r1
bt ov574
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov574:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln573:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr573,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr573,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr573: .long group_2_exception
bf_addr573: .long basefunction
! Opcode 8AF8
SAF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln575
shll16 r3
cmp/hs r3,r1
bt ov576
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov576:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln575:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr575,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr575,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr575: .long group_2_exception
bf_addr575: .long basefunction
! Opcode 8AF9
SAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln577
shll16 r3
cmp/hs r3,r1
bt ov578
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-118,r7
ov578:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln577:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr577,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr577,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr577: .long group_2_exception
bf_addr577: .long basefunction
! Opcode 8AFA
SAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln579
shll16 r3
cmp/hs r3,r1
bt ov580
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov580:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln579:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr579,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr579,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr579: .long group_2_exception
bf_addr579: .long basefunction
! Opcode 8AFB
SAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln581
shll16 r3
cmp/hs r3,r1
bt ov582
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov582:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln581:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr581,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr581,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr581: .long group_2_exception
bf_addr581: .long basefunction
! Opcode 8AFC
SAFC:
mov.w @r6+,r3
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln583
shll16 r3
cmp/hs r3,r1
bt ov584
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov584:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln583:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr583,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr583,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr583: .long group_2_exception
bf_addr583: .long basefunction
! Opcodes 8B00 - 8B07
SB00:
mov r3,r4
mov #20,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd585
add #-6,r8
.nonibadd585:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop585
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop585:
exts.b r3,r3
mov r9,r8
mov #20,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 8B08 - 8B0F
SB08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd586
add #-6,r8
.nonibadd586:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop586
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop586:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 8B10 - 8B17
SB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8B18 - 8B1F
SB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8B20 - 8B27
SB20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8B28 - 8B2F
SB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8B30 - 8B37
SB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8B38
SB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8B39
SB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8B50 - 8B57
SB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8B58 - 8B5F
SB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8B60 - 8B67
SB60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8B68 - 8B6F
SB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8B70 - 8B77
SB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8B78
SB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8B79
SB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8B90 - 8B97
SB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8B98 - 8B9F
SB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8BA0 - 8BA7
SBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 8BA8 - 8BAF
SBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 8BB0 - 8BB7
SBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 8BB8
SBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 8BB9
SBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 8BC0 - 8BC7
SBC0:
add r13,r2
mov.w @r2,r3
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln587
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck587
add #1,r1
tst r1,r1
bf ov588
ovcheck587:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-11,r7
ov588:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln587:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr587,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr587,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr587: .long group_2_exception
bf_addr587: .long basefunction
! Opcodes 8BD0 - 8BD7
SBD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln589
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck589
add #1,r1
tst r1,r1
bf ov590
ovcheck589:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov590:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln589:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr589,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr589,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr589: .long group_2_exception
bf_addr589: .long basefunction
! Opcodes 8BD8 - 8BDF
SBD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln591
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck591
add #1,r1
tst r1,r1
bf ov592
ovcheck591:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov592:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln591:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr591,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr591,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr591: .long group_2_exception
bf_addr591: .long basefunction
! Opcodes 8BE0 - 8BE7
SBE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln593
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck593
add #1,r1
tst r1,r1
bf ov594
ovcheck593:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-17,r7
ov594:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln593:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr593,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr593,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr593: .long group_2_exception
bf_addr593: .long basefunction
! Opcodes 8BE8 - 8BEF
SBE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln595
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck595
add #1,r1
tst r1,r1
bf ov596
ovcheck595:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov596:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln595:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr595,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr595,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr595: .long group_2_exception
bf_addr595: .long basefunction
! Opcodes 8BF0 - 8BF7
SBF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln597
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck597
add #1,r1
tst r1,r1
bf ov598
ovcheck597:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov598:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln597:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr597,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr597,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr597: .long group_2_exception
bf_addr597: .long basefunction
! Opcode 8BF8
SBF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln599
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck599
add #1,r1
tst r1,r1
bf ov600
ovcheck599:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov600:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln599:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr599,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr599,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr599: .long group_2_exception
bf_addr599: .long basefunction
! Opcode 8BF9
SBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln601
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck601
add #1,r1
tst r1,r1
bf ov602
ovcheck601:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-23,r7
ov602:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-28,r7
ln601:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr601,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr601,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr601: .long group_2_exception
bf_addr601: .long basefunction
! Opcode 8BFA
SBFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln603
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck603
add #1,r1
tst r1,r1
bf ov604
ovcheck603:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov604:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln603:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr603,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr603,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr603: .long group_2_exception
bf_addr603: .long basefunction
! Opcode 8BFB
SBFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln605
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck605
add #1,r1
tst r1,r1
bf ov606
ovcheck605:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov606:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln605:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr605,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr605,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr605: .long group_2_exception
bf_addr605: .long basefunction
! Opcode 8BFC
SBFC:
mov.w @r6+,r3
mov.l @(20,r13),r1
mov r3,r8
tst r8,r8
bt/s ln607
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck607
add #1,r1
tst r1,r1
bf ov608
ovcheck607:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov608:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln607:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr607,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr607,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr607: .long group_2_exception
bf_addr607: .long basefunction
! Opcodes 8C00 - 8C07
SC00:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8C10 - 8C17
SC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8C18 - 8C1F
SC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8C20 - 8C27
SC20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8C28 - 8C2F
SC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8C30 - 8C37
SC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8C38
SC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8C39
SC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8C3A
SC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8C3B
SC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8C3C
SC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8C40 - 8C47
SC40:
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8C50 - 8C57
SC50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8C58 - 8C5F
SC58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8C60 - 8C67
SC60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8C68 - 8C6F
SC68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8C70 - 8C77
SC70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8C78
SC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8C79
SC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8C7A
SC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8C7B
SC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8C7C
SC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8C80 - 8C87
SC80:
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8C90 - 8C97
SC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8C98 - 8C9F
SC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8CA0 - 8CA7
SCA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8CA8 - 8CAF
SCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 8CB0 - 8CB7
SCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 8CB8
SCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8CB9
SCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 8CBA
SCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8CBB
SCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 8CBC
SCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8CC0 - 8CC7
SCC0:
add r13,r2
mov.w @r2,r3
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln609
shll16 r3
cmp/hs r3,r1
bt ov610
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-106,r7
ov610:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-10,r7
ln609:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr609,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr609,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr609: .long group_2_exception
bf_addr609: .long basefunction
! Opcodes 8CD0 - 8CD7
SCD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln611
shll16 r3
cmp/hs r3,r1
bt ov612
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov612:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln611:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr611,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr611,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr611: .long group_2_exception
bf_addr611: .long basefunction
! Opcodes 8CD8 - 8CDF
SCD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln613
shll16 r3
cmp/hs r3,r1
bt ov614
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov614:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln613:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr613,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr613,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr613: .long group_2_exception
bf_addr613: .long basefunction
! Opcodes 8CE0 - 8CE7
SCE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln615
shll16 r3
cmp/hs r3,r1
bt ov616
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-112,r7
ov616:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln615:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr615,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr615,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr615: .long group_2_exception
bf_addr615: .long basefunction
! Opcodes 8CE8 - 8CEF
SCE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln617
shll16 r3
cmp/hs r3,r1
bt ov618
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov618:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln617:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr617,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr617,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr617: .long group_2_exception
bf_addr617: .long basefunction
! Opcodes 8CF0 - 8CF7
SCF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln619
shll16 r3
cmp/hs r3,r1
bt ov620
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov620:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln619:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr619,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr619,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr619: .long group_2_exception
bf_addr619: .long basefunction
! Opcode 8CF8
SCF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln621
shll16 r3
cmp/hs r3,r1
bt ov622
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov622:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln621:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr621,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr621,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr621: .long group_2_exception
bf_addr621: .long basefunction
! Opcode 8CF9
SCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln623
shll16 r3
cmp/hs r3,r1
bt ov624
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-118,r7
ov624:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln623:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr623,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr623,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr623: .long group_2_exception
bf_addr623: .long basefunction
! Opcode 8CFA
SCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln625
shll16 r3
cmp/hs r3,r1
bt ov626
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov626:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln625:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr625,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr625,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr625: .long group_2_exception
bf_addr625: .long basefunction
! Opcode 8CFB
SCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln627
shll16 r3
cmp/hs r3,r1
bt ov628
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov628:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln627:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr627,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr627,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr627: .long group_2_exception
bf_addr627: .long basefunction
! Opcode 8CFC
SCFC:
mov.w @r6+,r3
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln629
shll16 r3
cmp/hs r3,r1
bt ov630
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov630:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln629:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr629,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr629,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr629: .long group_2_exception
bf_addr629: .long basefunction
! Opcodes 8D00 - 8D07
SD00:
mov r3,r4
mov #24,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd631
add #-6,r8
.nonibadd631:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop631
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop631:
exts.b r3,r3
mov r9,r8
mov #24,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 8D08 - 8D0F
SD08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd632
add #-6,r8
.nonibadd632:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop632
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop632:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 8D10 - 8D17
SD10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8D18 - 8D1F
SD18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8D20 - 8D27
SD20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8D28 - 8D2F
SD28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8D30 - 8D37
SD30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8D38
SD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8D39
SD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8D50 - 8D57
SD50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8D58 - 8D5F
SD58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8D60 - 8D67
SD60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8D68 - 8D6F
SD68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8D70 - 8D77
SD70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8D78
SD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8D79
SD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8D90 - 8D97
SD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8D98 - 8D9F
SD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8DA0 - 8DA7
SDA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 8DA8 - 8DAF
SDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 8DB0 - 8DB7
SDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 8DB8
SDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 8DB9
SDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 8DC0 - 8DC7
SDC0:
add r13,r2
mov.w @r2,r3
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln633
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck633
add #1,r1
tst r1,r1
bf ov634
ovcheck633:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-11,r7
ov634:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln633:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr633,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr633,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr633: .long group_2_exception
bf_addr633: .long basefunction
! Opcodes 8DD0 - 8DD7
SDD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln635
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck635
add #1,r1
tst r1,r1
bf ov636
ovcheck635:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov636:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln635:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr635,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr635,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr635: .long group_2_exception
bf_addr635: .long basefunction
! Opcodes 8DD8 - 8DDF
SDD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln637
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck637
add #1,r1
tst r1,r1
bf ov638
ovcheck637:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov638:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln637:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr637,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr637,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr637: .long group_2_exception
bf_addr637: .long basefunction
! Opcodes 8DE0 - 8DE7
SDE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln639
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck639
add #1,r1
tst r1,r1
bf ov640
ovcheck639:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-17,r7
ov640:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln639:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr639,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr639,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr639: .long group_2_exception
bf_addr639: .long basefunction
! Opcodes 8DE8 - 8DEF
SDE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln641
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck641
add #1,r1
tst r1,r1
bf ov642
ovcheck641:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov642:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln641:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr641,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr641,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr641: .long group_2_exception
bf_addr641: .long basefunction
! Opcodes 8DF0 - 8DF7
SDF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln643
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck643
add #1,r1
tst r1,r1
bf ov644
ovcheck643:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov644:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln643:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr643,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr643,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr643: .long group_2_exception
bf_addr643: .long basefunction
! Opcode 8DF8
SDF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln645
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck645
add #1,r1
tst r1,r1
bf ov646
ovcheck645:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov646:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln645:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr645,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr645,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr645: .long group_2_exception
bf_addr645: .long basefunction
! Opcode 8DF9
SDF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln647
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck647
add #1,r1
tst r1,r1
bf ov648
ovcheck647:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-23,r7
ov648:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-28,r7
ln647:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr647,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr647,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr647: .long group_2_exception
bf_addr647: .long basefunction
! Opcode 8DFA
SDFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln649
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck649
add #1,r1
tst r1,r1
bf ov650
ovcheck649:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov650:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln649:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr649,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr649,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr649: .long group_2_exception
bf_addr649: .long basefunction
! Opcode 8DFB
SDFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln651
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck651
add #1,r1
tst r1,r1
bf ov652
ovcheck651:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov652:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln651:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr651,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr651,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr651: .long group_2_exception
bf_addr651: .long basefunction
! Opcode 8DFC
SDFC:
mov.w @r6+,r3
mov.l @(24,r13),r1
mov r3,r8
tst r8,r8
bt/s ln653
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck653
add #1,r1
tst r1,r1
bf ov654
ovcheck653:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov654:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln653:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr653,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr653,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr653: .long group_2_exception
bf_addr653: .long basefunction
! Opcodes 8E00 - 8E07
SE00:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8E10 - 8E17
SE10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8E18 - 8E1F
SE18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8E20 - 8E27
SE20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8E28 - 8E2F
SE28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8E30 - 8E37
SE30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8E38
SE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8E39
SE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8E3A
SE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8E3B
SE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8E3C
SE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8E40 - 8E47
SE40:
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes 8E50 - 8E57
SE50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8E58 - 8E5F
SE58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8E60 - 8E67
SE60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes 8E68 - 8E6F
SE68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8E70 - 8E77
SE70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8E78
SE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8E79
SE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8E7A
SE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode 8E7B
SE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode 8E7C
SE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8E80 - 8E87
SE80:
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes 8E90 - 8E97
SE90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8E98 - 8E9F
SE98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8EA0 - 8EA7
SEA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8EA8 - 8EAF
SEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes 8EB0 - 8EB7
SEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 8EB8
SEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8EB9
SEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode 8EBA
SEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8EBB
SEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode 8EBC
SEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8EC0 - 8EC7
SEC0:
add r13,r2
mov.w @r2,r3
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln655
shll16 r3
cmp/hs r3,r1
bt ov656
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-106,r7
ov656:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-10,r7
ln655:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr655,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr655,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr655: .long group_2_exception
bf_addr655: .long basefunction
! Opcodes 8ED0 - 8ED7
SED0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln657
shll16 r3
cmp/hs r3,r1
bt ov658
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov658:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln657:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr657,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr657,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr657: .long group_2_exception
bf_addr657: .long basefunction
! Opcodes 8ED8 - 8EDF
SED8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln659
shll16 r3
cmp/hs r3,r1
bt ov660
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov660:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln659:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr659,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr659,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr659: .long group_2_exception
bf_addr659: .long basefunction
! Opcodes 8EE0 - 8EE7
SEE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln661
shll16 r3
cmp/hs r3,r1
bt ov662
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-112,r7
ov662:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln661:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr661,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr661,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr661: .long group_2_exception
bf_addr661: .long basefunction
! Opcodes 8EE8 - 8EEF
SEE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln663
shll16 r3
cmp/hs r3,r1
bt ov664
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov664:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln663:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr663,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr663,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr663: .long group_2_exception
bf_addr663: .long basefunction
! Opcodes 8EF0 - 8EF7
SEF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln665
shll16 r3
cmp/hs r3,r1
bt ov666
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov666:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln665:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr665,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr665,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr665: .long group_2_exception
bf_addr665: .long basefunction
! Opcode 8EF8
SEF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln667
shll16 r3
cmp/hs r3,r1
bt ov668
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov668:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln667:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr667,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr667,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr667: .long group_2_exception
bf_addr667: .long basefunction
! Opcode 8EF9
SEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln669
shll16 r3
cmp/hs r3,r1
bt ov670
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-118,r7
ov670:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln669:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr669,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr669,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr669: .long group_2_exception
bf_addr669: .long basefunction
! Opcode 8EFA
SEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln671
shll16 r3
cmp/hs r3,r1
bt ov672
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-114,r7
ov672:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-18,r7
ln671:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr671,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr671,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr671: .long group_2_exception
bf_addr671: .long basefunction
! Opcode 8EFB
SEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln673
shll16 r3
cmp/hs r3,r1
bt ov674
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-116,r7
ov674:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln673:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr673,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr673,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr673: .long group_2_exception
bf_addr673: .long basefunction
! Opcode 8EFC
SEFC:
mov.w @r6+,r3
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln675
shll16 r3
cmp/hs r3,r1
bt ov676
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
jmp @r10
add #-110,r7
ov676:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-14,r7
ln675:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr675,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr675,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr675: .long group_2_exception
bf_addr675: .long basefunction
! Opcodes 8F00 - 8F07
SF00:
mov r3,r4
mov #28,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd677
add #-6,r8
.nonibadd677:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop677
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop677:
exts.b r3,r3
mov r9,r8
mov #28,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes 8F08 - 8F0F
SF08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd678
add #-6,r8
.nonibadd678:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop678
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop678:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 8F10 - 8F17
SF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8F18 - 8F1F
SF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8F20 - 8F27
SF20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8F28 - 8F2F
SF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8F30 - 8F37
SF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8F38
SF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8F39
SF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8F50 - 8F57
SF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8F58 - 8F5F
SF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes 8F60 - 8F67
SF60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes 8F68 - 8F6F
SF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes 8F70 - 8F77
SF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode 8F78
SF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode 8F79
SF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8F90 - 8F97
SF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8F98 - 8F9F
SF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes 8FA0 - 8FA7
SFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes 8FA8 - 8FAF
SFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes 8FB0 - 8FB7
SFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode 8FB8
SFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode 8FB9
SFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes 8FC0 - 8FC7
SFC0:
add r13,r2
mov.w @r2,r3
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln679
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck679
add #1,r1
tst r1,r1
bf ov680
ovcheck679:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-11,r7
ov680:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-16,r7
ln679:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr679,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr679,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-38,r7
.align 2
g2_except_addr679: .long group_2_exception
bf_addr679: .long basefunction
! Opcodes 8FD0 - 8FD7
SFD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln681
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck681
add #1,r1
tst r1,r1
bf ov682
ovcheck681:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov682:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln681:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr681,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr681,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr681: .long group_2_exception
bf_addr681: .long basefunction
! Opcodes 8FD8 - 8FDF
SFD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln683
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck683
add #1,r1
tst r1,r1
bf ov684
ovcheck683:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov684:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln683:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr683,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr683,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr683: .long group_2_exception
bf_addr683: .long basefunction
! Opcodes 8FE0 - 8FE7
SFE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln685
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck685
add #1,r1
tst r1,r1
bf ov686
ovcheck685:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-17,r7
ov686:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-22,r7
ln685:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr685,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr685,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-44,r7
.align 2
g2_except_addr685: .long group_2_exception
bf_addr685: .long basefunction
! Opcodes 8FE8 - 8FEF
SFE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln687
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck687
add #1,r1
tst r1,r1
bf ov688
ovcheck687:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov688:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln687:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr687,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr687,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr687: .long group_2_exception
bf_addr687: .long basefunction
! Opcodes 8FF0 - 8FF7
SFF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln689
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck689
add #1,r1
tst r1,r1
bf ov690
ovcheck689:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov690:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln689:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr689,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr689,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr689: .long group_2_exception
bf_addr689: .long basefunction
! Opcode 8FF8
SFF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln691
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck691
add #1,r1
tst r1,r1
bf ov692
ovcheck691:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov692:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln691:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr691,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr691,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr691: .long group_2_exception
bf_addr691: .long basefunction
! Opcode 8FF9
SFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln693
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck693
add #1,r1
tst r1,r1
bf ov694
ovcheck693:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-23,r7
ov694:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-28,r7
ln693:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr693,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr693,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-50,r7
.align 2
g2_except_addr693: .long group_2_exception
bf_addr693: .long basefunction
! Opcode 8FFA
SFFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln695
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck695
add #1,r1
tst r1,r1
bf ov696
ovcheck695:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-19,r7
ov696:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-24,r7
ln695:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr695,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr695,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-46,r7
.align 2
g2_except_addr695: .long group_2_exception
bf_addr695: .long basefunction
! Opcode 8FFB
SFFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln697
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck697
add #1,r1
tst r1,r1
bf ov698
ovcheck697:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-21,r7
ov698:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-26,r7
ln697:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr697,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr697,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-48,r7
.align 2
g2_except_addr697: .long group_2_exception
bf_addr697: .long basefunction
! Opcode 8FFC
SFFC:
mov.w @r6+,r3
mov.l @(28,r13),r1
mov r3,r8
tst r8,r8
bt/s ln699
shll16 r3
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
mov #-15,r2
shad r2,r1
tst r1,r1
bt/s ovcheck699
add #1,r1
tst r1,r1
bf ov700
ovcheck699:
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
mov #0,r8
add #-128,r7
jmp @r10
add #-15,r7
ov700:
mov #0x2,r8
mov #-1,r3
jmp @r10
add #-20,r7
ln699:
mov #0xFC,r0
and r0,r8
mov.l g2_except_addr699,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr699,r0
jsr @r0
nop
add r5,r6
jmp @r10
add #-42,r7
.align 2
g2_except_addr699: .long group_2_exception
bf_addr699: .long basefunction
! Opcodes 9000 - 9007
T000:
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9008 - 900F
T008:
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9010 - 9017
T010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9018 - 901F
T018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9020 - 9027
T020:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9028 - 902F
T028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9030 - 9037
T030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9038
T038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9039
T039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 903A
T03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 903B
T03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 903C
T03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9040 - 9047
T040:
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9048 - 904F
T048:
add r14,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9050 - 9057
T050:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9058 - 905F
T058:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9060 - 9067
T060:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9068 - 906F
T068:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9070 - 9077
T070:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9078
T078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9079
T079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 907A
T07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 907B
T07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 907C
T07C:
mov.w @r6+,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9080 - 9087
T080:
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9088 - 908F
T088:
add r14,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9090 - 9097
T090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9098 - 909F
T098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 90A0 - 90A7
T0A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 90A8 - 90AF
T0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes 90B0 - 90B7
T0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 90B8
T0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 90B9
T0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-22,r7
! Opcode 90BA
T0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 90BB
T0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 90BC
T0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 90C0 - 90C7
T0C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 90C8 - 90CF
T0C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 90D0 - 90D7
T0D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 90D8 - 90DF
T0D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 90E0 - 90E7
T0E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 90E8 - 90EF
T0E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 90F0 - 90F7
T0F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 90F8
T0F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 90F9
T0F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 90FA
T0FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 90FB
T0FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 90FC
T0FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9100 - 9107
T100:
mov r3,r4
mov.b @r13,r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r13
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9108 - 910F
T108:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9110 - 9117
T110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9118 - 911F
T118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9120 - 9127
T120:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9128 - 912F
T128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9130 - 9137
T130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9138
T138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9139
T139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9140 - 9147
T140:
mov r3,r4
mov.w @r13,r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r13
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9148 - 914F
T148:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9150 - 9157
T150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9158 - 915F
T158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9160 - 9167
T160:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9168 - 916F
T168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9170 - 9177
T170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9178
T178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9179
T179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9180 - 9187
T180:
mov r3,r4
mov.l @r13,r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@r13
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes 9188 - 918F
T188:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes 9190 - 9197
T190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9198 - 919F
T198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 91A0 - 91A7
T1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 91A8 - 91AF
T1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 91B0 - 91B7
T1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 91B8
T1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 91B9
T1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 91C0 - 91C7
T1C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 91C8 - 91CF
T1C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 91D0 - 91D7
T1D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 91D8 - 91DF
T1D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 91E0 - 91E7
T1E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 91E8 - 91EF
T1E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 91F0 - 91F7
T1F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 91F8
T1F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 91F9
T1F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 91FA
T1FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 91FB
T1FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 91FC
T1FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9200 - 9207
T200:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9208 - 920F
T208:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9210 - 9217
T210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9218 - 921F
T218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9220 - 9227
T220:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9228 - 922F
T228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9230 - 9237
T230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9238
T238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9239
T239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 923A
T23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 923B
T23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 923C
T23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9240 - 9247
T240:
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9248 - 924F
T248:
add r14,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9250 - 9257
T250:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9258 - 925F
T258:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9260 - 9267
T260:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9268 - 926F
T268:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9270 - 9277
T270:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9278
T278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9279
T279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 927A
T27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 927B
T27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 927C
T27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9280 - 9287
T280:
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9288 - 928F
T288:
add r14,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9290 - 9297
T290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9298 - 929F
T298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 92A0 - 92A7
T2A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 92A8 - 92AF
T2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes 92B0 - 92B7
T2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 92B8
T2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 92B9
T2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode 92BA
T2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 92BB
T2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 92BC
T2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 92C0 - 92C7
T2C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 92C8 - 92CF
T2C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 92D0 - 92D7
T2D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 92D8 - 92DF
T2D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 92E0 - 92E7
T2E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 92E8 - 92EF
T2E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 92F0 - 92F7
T2F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 92F8
T2F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 92F9
T2F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 92FA
T2FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 92FB
T2FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 92FC
T2FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9300 - 9307
T300:
mov r3,r4
mov #4,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #4,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9308 - 930F
T308:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9310 - 9317
T310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9318 - 931F
T318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9320 - 9327
T320:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9328 - 932F
T328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9330 - 9337
T330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9338
T338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9339
T339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9340 - 9347
T340:
mov r3,r4
mov #4,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #4,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9348 - 934F
T348:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9350 - 9357
T350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9358 - 935F
T358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9360 - 9367
T360:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9368 - 936F
T368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9370 - 9377
T370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9378
T378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9379
T379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9380 - 9387
T380:
mov r3,r4
mov.l @(4,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(4,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes 9388 - 938F
T388:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes 9390 - 9397
T390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9398 - 939F
T398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 93A0 - 93A7
T3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 93A8 - 93AF
T3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 93B0 - 93B7
T3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 93B8
T3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 93B9
T3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 93C0 - 93C7
T3C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 93C8 - 93CF
T3C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 93D0 - 93D7
T3D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 93D8 - 93DF
T3D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 93E0 - 93E7
T3E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 93E8 - 93EF
T3E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 93F0 - 93F7
T3F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 93F8
T3F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 93F9
T3F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 93FA
T3FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 93FB
T3FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 93FC
T3FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9400 - 9407
T400:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9408 - 940F
T408:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9410 - 9417
T410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9418 - 941F
T418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9420 - 9427
T420:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9428 - 942F
T428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9430 - 9437
T430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9438
T438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9439
T439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 943A
T43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 943B
T43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 943C
T43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9440 - 9447
T440:
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9448 - 944F
T448:
add r14,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9450 - 9457
T450:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9458 - 945F
T458:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9460 - 9467
T460:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9468 - 946F
T468:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9470 - 9477
T470:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9478
T478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9479
T479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 947A
T47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 947B
T47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 947C
T47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9480 - 9487
T480:
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9488 - 948F
T488:
add r14,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9490 - 9497
T490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9498 - 949F
T498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 94A0 - 94A7
T4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 94A8 - 94AF
T4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes 94B0 - 94B7
T4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 94B8
T4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 94B9
T4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode 94BA
T4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 94BB
T4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 94BC
T4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 94C0 - 94C7
T4C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 94C8 - 94CF
T4C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 94D0 - 94D7
T4D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 94D8 - 94DF
T4D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 94E0 - 94E7
T4E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 94E8 - 94EF
T4E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 94F0 - 94F7
T4F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 94F8
T4F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 94F9
T4F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 94FA
T4FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 94FB
T4FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 94FC
T4FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9500 - 9507
T500:
mov r3,r4
mov #8,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #8,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9508 - 950F
T508:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9510 - 9517
T510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9518 - 951F
T518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9520 - 9527
T520:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9528 - 952F
T528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9530 - 9537
T530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9538
T538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9539
T539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9540 - 9547
T540:
mov r3,r4
mov #8,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #8,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9548 - 954F
T548:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9550 - 9557
T550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9558 - 955F
T558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9560 - 9567
T560:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9568 - 956F
T568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9570 - 9577
T570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9578
T578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9579
T579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9580 - 9587
T580:
mov r3,r4
mov.l @(8,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(8,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes 9588 - 958F
T588:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes 9590 - 9597
T590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9598 - 959F
T598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 95A0 - 95A7
T5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 95A8 - 95AF
T5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 95B0 - 95B7
T5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 95B8
T5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 95B9
T5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 95C0 - 95C7
T5C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 95C8 - 95CF
T5C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 95D0 - 95D7
T5D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 95D8 - 95DF
T5D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 95E0 - 95E7
T5E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 95E8 - 95EF
T5E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 95F0 - 95F7
T5F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 95F8
T5F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 95F9
T5F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 95FA
T5FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 95FB
T5FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 95FC
T5FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9600 - 9607
T600:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9608 - 960F
T608:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9610 - 9617
T610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9618 - 961F
T618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9620 - 9627
T620:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9628 - 962F
T628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9630 - 9637
T630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9638
T638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9639
T639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 963A
T63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 963B
T63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 963C
T63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9640 - 9647
T640:
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9648 - 964F
T648:
add r14,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9650 - 9657
T650:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9658 - 965F
T658:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9660 - 9667
T660:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9668 - 966F
T668:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9670 - 9677
T670:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9678
T678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9679
T679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 967A
T67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 967B
T67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 967C
T67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9680 - 9687
T680:
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9688 - 968F
T688:
add r14,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9690 - 9697
T690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9698 - 969F
T698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 96A0 - 96A7
T6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 96A8 - 96AF
T6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes 96B0 - 96B7
T6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 96B8
T6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 96B9
T6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode 96BA
T6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 96BB
T6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 96BC
T6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 96C0 - 96C7
T6C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 96C8 - 96CF
T6C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 96D0 - 96D7
T6D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 96D8 - 96DF
T6D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 96E0 - 96E7
T6E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 96E8 - 96EF
T6E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 96F0 - 96F7
T6F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 96F8
T6F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 96F9
T6F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 96FA
T6FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 96FB
T6FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 96FC
T6FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9700 - 9707
T700:
mov r3,r4
mov #12,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #12,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9708 - 970F
T708:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9710 - 9717
T710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9718 - 971F
T718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9720 - 9727
T720:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9728 - 972F
T728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9730 - 9737
T730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9738
T738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9739
T739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9740 - 9747
T740:
mov r3,r4
mov #12,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #12,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9748 - 974F
T748:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9750 - 9757
T750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9758 - 975F
T758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9760 - 9767
T760:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9768 - 976F
T768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9770 - 9777
T770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9778
T778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9779
T779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9780 - 9787
T780:
mov r3,r4
mov.l @(12,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(12,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes 9788 - 978F
T788:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes 9790 - 9797
T790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9798 - 979F
T798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 97A0 - 97A7
T7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 97A8 - 97AF
T7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 97B0 - 97B7
T7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 97B8
T7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 97B9
T7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 97C0 - 97C7
T7C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 97C8 - 97CF
T7C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 97D0 - 97D7
T7D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 97D8 - 97DF
T7D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 97E0 - 97E7
T7E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 97E8 - 97EF
T7E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 97F0 - 97F7
T7F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 97F8
T7F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 97F9
T7F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 97FA
T7FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 97FB
T7FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 97FC
T7FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9800 - 9807
T800:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9808 - 980F
T808:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9810 - 9817
T810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9818 - 981F
T818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9820 - 9827
T820:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9828 - 982F
T828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9830 - 9837
T830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9838
T838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9839
T839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 983A
T83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 983B
T83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 983C
T83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9840 - 9847
T840:
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9848 - 984F
T848:
add r14,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9850 - 9857
T850:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9858 - 985F
T858:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9860 - 9867
T860:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9868 - 986F
T868:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9870 - 9877
T870:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9878
T878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9879
T879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 987A
T87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 987B
T87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 987C
T87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9880 - 9887
T880:
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9888 - 988F
T888:
add r14,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9890 - 9897
T890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9898 - 989F
T898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 98A0 - 98A7
T8A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 98A8 - 98AF
T8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes 98B0 - 98B7
T8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 98B8
T8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 98B9
T8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode 98BA
T8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 98BB
T8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 98BC
T8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 98C0 - 98C7
T8C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 98C8 - 98CF
T8C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 98D0 - 98D7
T8D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 98D8 - 98DF
T8D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 98E0 - 98E7
T8E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 98E8 - 98EF
T8E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 98F0 - 98F7
T8F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 98F8
T8F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 98F9
T8F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 98FA
T8FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 98FB
T8FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 98FC
T8FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9900 - 9907
T900:
mov r3,r4
mov #16,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #16,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9908 - 990F
T908:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9910 - 9917
T910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9918 - 991F
T918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9920 - 9927
T920:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9928 - 992F
T928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9930 - 9937
T930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9938
T938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9939
T939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9940 - 9947
T940:
mov r3,r4
mov #16,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #16,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9948 - 994F
T948:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9950 - 9957
T950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9958 - 995F
T958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9960 - 9967
T960:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9968 - 996F
T968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9970 - 9977
T970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9978
T978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9979
T979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9980 - 9987
T980:
mov r3,r4
mov.l @(16,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(16,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes 9988 - 998F
T988:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes 9990 - 9997
T990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9998 - 999F
T998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 99A0 - 99A7
T9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 99A8 - 99AF
T9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 99B0 - 99B7
T9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 99B8
T9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 99B9
T9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 99C0 - 99C7
T9C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 99C8 - 99CF
T9C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 99D0 - 99D7
T9D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 99D8 - 99DF
T9D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 99E0 - 99E7
T9E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 99E8 - 99EF
T9E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 99F0 - 99F7
T9F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 99F8
T9F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 99F9
T9F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 99FA
T9FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 99FB
T9FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 99FC
T9FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9A00 - 9A07
TA00:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9A08 - 9A0F
TA08:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9A10 - 9A17
TA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9A18 - 9A1F
TA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9A20 - 9A27
TA20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9A28 - 9A2F
TA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9A30 - 9A37
TA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9A38
TA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9A39
TA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 9A3A
TA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9A3B
TA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9A3C
TA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9A40 - 9A47
TA40:
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9A48 - 9A4F
TA48:
add r14,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9A50 - 9A57
TA50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9A58 - 9A5F
TA58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9A60 - 9A67
TA60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9A68 - 9A6F
TA68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9A70 - 9A77
TA70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9A78
TA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9A79
TA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 9A7A
TA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9A7B
TA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9A7C
TA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9A80 - 9A87
TA80:
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9A88 - 9A8F
TA88:
add r14,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9A90 - 9A97
TA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9A98 - 9A9F
TA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9AA0 - 9AA7
TAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 9AA8 - 9AAF
TAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes 9AB0 - 9AB7
TAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 9AB8
TAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 9AB9
TAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode 9ABA
TABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 9ABB
TABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 9ABC
TABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 9AC0 - 9AC7
TAC0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9AC8 - 9ACF
TAC8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9AD0 - 9AD7
TAD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9AD8 - 9ADF
TAD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9AE0 - 9AE7
TAE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9AE8 - 9AEF
TAE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9AF0 - 9AF7
TAF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9AF8
TAF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 9AF9
TAF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9AFA
TAFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 9AFB
TAFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9AFC
TAFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9B00 - 9B07
TB00:
mov r3,r4
mov #20,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #20,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9B08 - 9B0F
TB08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9B10 - 9B17
TB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9B18 - 9B1F
TB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9B20 - 9B27
TB20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9B28 - 9B2F
TB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9B30 - 9B37
TB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9B38
TB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9B39
TB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9B40 - 9B47
TB40:
mov r3,r4
mov #20,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #20,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9B48 - 9B4F
TB48:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9B50 - 9B57
TB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9B58 - 9B5F
TB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9B60 - 9B67
TB60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9B68 - 9B6F
TB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9B70 - 9B77
TB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9B78
TB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9B79
TB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9B80 - 9B87
TB80:
mov r3,r4
mov.l @(20,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(20,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes 9B88 - 9B8F
TB88:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes 9B90 - 9B97
TB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9B98 - 9B9F
TB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 9BA0 - 9BA7
TBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 9BA8 - 9BAF
TBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 9BB0 - 9BB7
TBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 9BB8
TBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 9BB9
TBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 9BC0 - 9BC7
TBC0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9BC8 - 9BCF
TBC8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9BD0 - 9BD7
TBD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9BD8 - 9BDF
TBD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9BE0 - 9BE7
TBE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9BE8 - 9BEF
TBE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 9BF0 - 9BF7
TBF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9BF8
TBF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9BF9
TBF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 9BFA
TBFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9BFB
TBFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9BFC
TBFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9C00 - 9C07
TC00:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9C08 - 9C0F
TC08:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9C10 - 9C17
TC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9C18 - 9C1F
TC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9C20 - 9C27
TC20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9C28 - 9C2F
TC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9C30 - 9C37
TC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9C38
TC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9C39
TC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 9C3A
TC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9C3B
TC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9C3C
TC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9C40 - 9C47
TC40:
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9C48 - 9C4F
TC48:
add r14,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9C50 - 9C57
TC50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9C58 - 9C5F
TC58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9C60 - 9C67
TC60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9C68 - 9C6F
TC68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9C70 - 9C77
TC70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9C78
TC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9C79
TC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 9C7A
TC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9C7B
TC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9C7C
TC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9C80 - 9C87
TC80:
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9C88 - 9C8F
TC88:
add r14,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9C90 - 9C97
TC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9C98 - 9C9F
TC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9CA0 - 9CA7
TCA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 9CA8 - 9CAF
TCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes 9CB0 - 9CB7
TCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 9CB8
TCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 9CB9
TCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode 9CBA
TCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 9CBB
TCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 9CBC
TCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 9CC0 - 9CC7
TCC0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9CC8 - 9CCF
TCC8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9CD0 - 9CD7
TCD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9CD8 - 9CDF
TCD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9CE0 - 9CE7
TCE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9CE8 - 9CEF
TCE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9CF0 - 9CF7
TCF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9CF8
TCF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 9CF9
TCF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9CFA
TCFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 9CFB
TCFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9CFC
TCFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9D00 - 9D07
TD00:
mov r3,r4
mov #24,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #24,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9D08 - 9D0F
TD08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9D10 - 9D17
TD10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9D18 - 9D1F
TD18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9D20 - 9D27
TD20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9D28 - 9D2F
TD28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9D30 - 9D37
TD30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9D38
TD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9D39
TD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9D40 - 9D47
TD40:
mov r3,r4
mov #24,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #24,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9D48 - 9D4F
TD48:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9D50 - 9D57
TD50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9D58 - 9D5F
TD58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9D60 - 9D67
TD60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9D68 - 9D6F
TD68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9D70 - 9D77
TD70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9D78
TD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9D79
TD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9D80 - 9D87
TD80:
mov r3,r4
mov.l @(24,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(24,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes 9D88 - 9D8F
TD88:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes 9D90 - 9D97
TD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9D98 - 9D9F
TD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 9DA0 - 9DA7
TDA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 9DA8 - 9DAF
TDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 9DB0 - 9DB7
TDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 9DB8
TDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 9DB9
TDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 9DC0 - 9DC7
TDC0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9DC8 - 9DCF
TDC8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9DD0 - 9DD7
TDD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9DD8 - 9DDF
TDD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9DE0 - 9DE7
TDE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9DE8 - 9DEF
TDE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 9DF0 - 9DF7
TDF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9DF8
TDF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9DF9
TDF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 9DFA
TDFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9DFB
TDFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9DFC
TDFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9E00 - 9E07
TE00:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9E08 - 9E0F
TE08:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9E10 - 9E17
TE10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9E18 - 9E1F
TE18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9E20 - 9E27
TE20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9E28 - 9E2F
TE28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9E30 - 9E37
TE30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9E38
TE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9E39
TE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 9E3A
TE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9E3B
TE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9E3C
TE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9E40 - 9E47
TE40:
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9E48 - 9E4F
TE48:
add r14,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes 9E50 - 9E57
TE50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9E58 - 9E5F
TE58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9E60 - 9E67
TE60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes 9E68 - 9E6F
TE68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes 9E70 - 9E77
TE70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9E78
TE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9E79
TE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode 9E7A
TE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode 9E7B
TE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode 9E7C
TE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9E80 - 9E87
TE80:
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9E88 - 9E8F
TE88:
add r14,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes 9E90 - 9E97
TE90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9E98 - 9E9F
TE98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes 9EA0 - 9EA7
TEA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 9EA8 - 9EAF
TEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes 9EB0 - 9EB7
TEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 9EB8
TEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 9EB9
TEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode 9EBA
TEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode 9EBB
TEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode 9EBC
TEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes 9EC0 - 9EC7
TEC0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9EC8 - 9ECF
TEC8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9ED0 - 9ED7
TED0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9ED8 - 9EDF
TED8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9EE0 - 9EE7
TEE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9EE8 - 9EEF
TEE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9EF0 - 9EF7
TEF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9EF8
TEF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 9EF9
TEF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9EFA
TEFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode 9EFB
TEFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9EFC
TEFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes 9F00 - 9F07
TF00:
mov r3,r4
mov #28,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #28,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9F08 - 9F0F
TF08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9F10 - 9F17
TF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9F18 - 9F1F
TF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9F20 - 9F27
TF20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9F28 - 9F2F
TF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9F30 - 9F37
TF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9F38
TF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9F39
TF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9F40 - 9F47
TF40:
mov r3,r4
mov #28,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #28,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes 9F48 - 9F4F
TF48:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes 9F50 - 9F57
TF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes 9F58 - 9F5F
TF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes 9F60 - 9F67
TF60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes 9F68 - 9F6F
TF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes 9F70 - 9F77
TF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode 9F78
TF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode 9F79
TF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9F80 - 9F87
TF80:
mov r3,r4
mov.l @(28,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(28,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes 9F88 - 9F8F
TF88:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
subv r1,r0
movt r8
subv r9,r0
movt r0
or r0,r8
shll r8
subc r1,r3
movt r0
clrt
subc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes 9F90 - 9F97
TF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes 9F98 - 9F9F
TF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes 9FA0 - 9FA7
TFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes 9FA8 - 9FAF
TFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes 9FB0 - 9FB7
TFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode 9FB8
TFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode 9FB9
TFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r3
movt r8
subc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes 9FC0 - 9FC7
TFC0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9FC8 - 9FCF
TFC8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes 9FD0 - 9FD7
TFD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9FD8 - 9FDF
TFD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes 9FE0 - 9FE7
TFE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes 9FE8 - 9FEF
TFE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes 9FF0 - 9FF7
TFF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9FF8
TFF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9FF9
TFF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode 9FFA
TFFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode 9FFB
TFFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode 9FFC
TFFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes A000 - AFFF
U000:
mov.l r3,@-r15
mov.l g1_except_addr749,r0
add #-2,r6
jsr @r0
mov #0x28,r4
mov.l bf_addr749,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
jmp @r10
add #-34,r7
.align 2
g1_except_addr749: .long group_1_exception
bf_addr749: .long basefunction
! Opcodes B000 - B007
V000:
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B008 - B00F
V008:
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B010 - B017
V010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B018 - B01F
V018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B020 - B027
V020:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B028 - B02F
V028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B030 - B037
V030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B038
V038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B039
V039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B03A
V03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B03B
V03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B03C
V03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B040 - B047
V040:
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B048 - B04F
V048:
add r14,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B050 - B057
V050:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B058 - B05F
V058:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B060 - B067
V060:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B068 - B06F
V068:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B070 - B077
V070:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B078
V078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B079
V079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B07A
V07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B07B
V07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B07C
V07C:
mov.w @r6+,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B080 - B087
V080:
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B088 - B08F
V088:
add r14,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B090 - B097
V090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B098 - B09F
V098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B0A0 - B0A7
V0A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes B0A8 - B0AF
V0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes B0B0 - B0B7
V0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B0B8
V0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B0B9
V0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-22,r7
! Opcode B0BA
V0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B0BB
V0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B0BC
V0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B0C0 - B0C7
V0C0:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B0C8 - B0CF
V0C8:
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B0D0 - B0D7
V0D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B0D8 - B0DF
V0D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B0E0 - B0E7
V0E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-12,r7
! Opcodes B0E8 - B0EF
V0E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B0F0 - B0F7
V0F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B0F8
V0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B0F9
V0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B0FA
V0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B0FB
V0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B0FC
V0FC:
mov.w @r6+,r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B100 - B107
V100:
mov r2,r0
mov.b @(r0,r13),r3
mov.b @r13,r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B108 - B10F
V108:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B110 - B117
V110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B118 - B11F
V118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B120 - B127
V120:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B128 - B12F
V128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B130 - B137
V130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B138
V138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B139
V139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B140 - B147
V140:
mov r2,r0
mov.w @(r0,r13),r3
mov.w @r13,r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B148 - B14F
V148:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B150 - B157
V150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B158 - B15F
V158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B160 - B167
V160:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B168 - B16F
V168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B170 - B177
V170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B178
V178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B179
V179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B180 - B187
V180:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @r13,r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes B188 - B18F
V188:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes B190 - B197
V190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B198 - B19F
V198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B1A0 - B1A7
V1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes B1A8 - B1AF
V1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes B1B0 - B1B7
V1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode B1B8
V1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode B1B9
V1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes B1C0 - B1C7
V1C0:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B1C8 - B1CF
V1C8:
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B1D0 - B1D7
V1D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B1D8 - B1DF
V1D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B1E0 - B1E7
V1E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcodes B1E8 - B1EF
V1E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcodes B1F0 - B1F7
V1F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B1F8
V1F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B1F9
V1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-22,r7
! Opcode B1FA
V1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B1FB
V1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B1FC
V1FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B200 - B207
V200:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B208 - B20F
V208:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B210 - B217
V210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B218 - B21F
V218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B220 - B227
V220:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B228 - B22F
V228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B230 - B237
V230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B238
V238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B239
V239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B23A
V23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B23B
V23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B23C
V23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B240 - B247
V240:
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B248 - B24F
V248:
add r14,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B250 - B257
V250:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B258 - B25F
V258:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B260 - B267
V260:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B268 - B26F
V268:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B270 - B277
V270:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B278
V278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B279
V279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B27A
V27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B27B
V27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B27C
V27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B280 - B287
V280:
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B288 - B28F
V288:
add r14,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B290 - B297
V290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B298 - B29F
V298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B2A0 - B2A7
V2A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes B2A8 - B2AF
V2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes B2B0 - B2B7
V2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B2B8
V2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B2B9
V2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-22,r7
! Opcode B2BA
V2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B2BB
V2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B2BC
V2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B2C0 - B2C7
V2C0:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B2C8 - B2CF
V2C8:
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B2D0 - B2D7
V2D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B2D8 - B2DF
V2D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B2E0 - B2E7
V2E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-12,r7
! Opcodes B2E8 - B2EF
V2E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B2F0 - B2F7
V2F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B2F8
V2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B2F9
V2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B2FA
V2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B2FB
V2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B2FC
V2FC:
mov.w @r6+,r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B300 - B307
V300:
mov r2,r0
mov.b @(r0,r13),r3
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B308 - B30F
V308:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B310 - B317
V310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B318 - B31F
V318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B320 - B327
V320:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B328 - B32F
V328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B330 - B337
V330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B338
V338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B339
V339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B340 - B347
V340:
mov r2,r0
mov.w @(r0,r13),r3
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B348 - B34F
V348:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B350 - B357
V350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B358 - B35F
V358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B360 - B367
V360:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B368 - B36F
V368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B370 - B377
V370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B378
V378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B379
V379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B380 - B387
V380:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(4,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes B388 - B38F
V388:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes B390 - B397
V390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B398 - B39F
V398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B3A0 - B3A7
V3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes B3A8 - B3AF
V3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes B3B0 - B3B7
V3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode B3B8
V3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode B3B9
V3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes B3C0 - B3C7
V3C0:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B3C8 - B3CF
V3C8:
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B3D0 - B3D7
V3D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B3D8 - B3DF
V3D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B3E0 - B3E7
V3E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcodes B3E8 - B3EF
V3E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcodes B3F0 - B3F7
V3F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B3F8
V3F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B3F9
V3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-22,r7
! Opcode B3FA
V3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B3FB
V3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B3FC
V3FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B400 - B407
V400:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B408 - B40F
V408:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B410 - B417
V410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B418 - B41F
V418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B420 - B427
V420:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B428 - B42F
V428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B430 - B437
V430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B438
V438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B439
V439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B43A
V43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B43B
V43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B43C
V43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B440 - B447
V440:
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B448 - B44F
V448:
add r14,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B450 - B457
V450:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B458 - B45F
V458:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B460 - B467
V460:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B468 - B46F
V468:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B470 - B477
V470:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B478
V478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B479
V479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B47A
V47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B47B
V47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B47C
V47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B480 - B487
V480:
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B488 - B48F
V488:
add r14,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B490 - B497
V490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B498 - B49F
V498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B4A0 - B4A7
V4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes B4A8 - B4AF
V4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes B4B0 - B4B7
V4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B4B8
V4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B4B9
V4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-22,r7
! Opcode B4BA
V4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B4BB
V4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B4BC
V4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B4C0 - B4C7
V4C0:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B4C8 - B4CF
V4C8:
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B4D0 - B4D7
V4D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B4D8 - B4DF
V4D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B4E0 - B4E7
V4E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-12,r7
! Opcodes B4E8 - B4EF
V4E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B4F0 - B4F7
V4F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B4F8
V4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B4F9
V4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B4FA
V4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B4FB
V4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B4FC
V4FC:
mov.w @r6+,r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B500 - B507
V500:
mov r2,r0
mov.b @(r0,r13),r3
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B508 - B50F
V508:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B510 - B517
V510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B518 - B51F
V518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B520 - B527
V520:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B528 - B52F
V528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B530 - B537
V530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B538
V538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B539
V539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B540 - B547
V540:
mov r2,r0
mov.w @(r0,r13),r3
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B548 - B54F
V548:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B550 - B557
V550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B558 - B55F
V558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B560 - B567
V560:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B568 - B56F
V568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B570 - B577
V570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B578
V578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B579
V579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B580 - B587
V580:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(8,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes B588 - B58F
V588:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes B590 - B597
V590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B598 - B59F
V598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B5A0 - B5A7
V5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes B5A8 - B5AF
V5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes B5B0 - B5B7
V5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode B5B8
V5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode B5B9
V5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes B5C0 - B5C7
V5C0:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B5C8 - B5CF
V5C8:
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B5D0 - B5D7
V5D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B5D8 - B5DF
V5D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B5E0 - B5E7
V5E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcodes B5E8 - B5EF
V5E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcodes B5F0 - B5F7
V5F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B5F8
V5F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B5F9
V5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-22,r7
! Opcode B5FA
V5FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B5FB
V5FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B5FC
V5FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B600 - B607
V600:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B608 - B60F
V608:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B610 - B617
V610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B618 - B61F
V618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B620 - B627
V620:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B628 - B62F
V628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B630 - B637
V630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B638
V638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B639
V639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B63A
V63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B63B
V63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B63C
V63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B640 - B647
V640:
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B648 - B64F
V648:
add r14,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B650 - B657
V650:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B658 - B65F
V658:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B660 - B667
V660:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B668 - B66F
V668:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B670 - B677
V670:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B678
V678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B679
V679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B67A
V67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B67B
V67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B67C
V67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B680 - B687
V680:
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B688 - B68F
V688:
add r14,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B690 - B697
V690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B698 - B69F
V698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B6A0 - B6A7
V6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes B6A8 - B6AF
V6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes B6B0 - B6B7
V6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B6B8
V6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B6B9
V6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-22,r7
! Opcode B6BA
V6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B6BB
V6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B6BC
V6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B6C0 - B6C7
V6C0:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B6C8 - B6CF
V6C8:
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B6D0 - B6D7
V6D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B6D8 - B6DF
V6D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B6E0 - B6E7
V6E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-12,r7
! Opcodes B6E8 - B6EF
V6E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B6F0 - B6F7
V6F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B6F8
V6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B6F9
V6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B6FA
V6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B6FB
V6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B6FC
V6FC:
mov.w @r6+,r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B700 - B707
V700:
mov r2,r0
mov.b @(r0,r13),r3
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B708 - B70F
V708:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B710 - B717
V710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B718 - B71F
V718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B720 - B727
V720:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B728 - B72F
V728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B730 - B737
V730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B738
V738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B739
V739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B740 - B747
V740:
mov r2,r0
mov.w @(r0,r13),r3
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B748 - B74F
V748:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B750 - B757
V750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B758 - B75F
V758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B760 - B767
V760:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B768 - B76F
V768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B770 - B777
V770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B778
V778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B779
V779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B780 - B787
V780:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(12,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes B788 - B78F
V788:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes B790 - B797
V790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B798 - B79F
V798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B7A0 - B7A7
V7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes B7A8 - B7AF
V7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes B7B0 - B7B7
V7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode B7B8
V7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode B7B9
V7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes B7C0 - B7C7
V7C0:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B7C8 - B7CF
V7C8:
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B7D0 - B7D7
V7D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B7D8 - B7DF
V7D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B7E0 - B7E7
V7E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcodes B7E8 - B7EF
V7E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcodes B7F0 - B7F7
V7F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B7F8
V7F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B7F9
V7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-22,r7
! Opcode B7FA
V7FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B7FB
V7FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B7FC
V7FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B800 - B807
V800:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B808 - B80F
V808:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B810 - B817
V810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B818 - B81F
V818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B820 - B827
V820:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B828 - B82F
V828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B830 - B837
V830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B838
V838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B839
V839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B83A
V83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B83B
V83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B83C
V83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B840 - B847
V840:
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B848 - B84F
V848:
add r14,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes B850 - B857
V850:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B858 - B85F
V858:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B860 - B867
V860:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes B868 - B86F
V868:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes B870 - B877
V870:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B878
V878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B879
V879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode B87A
V87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode B87B
V87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode B87C
V87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes B880 - B887
V880:
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B888 - B88F
V888:
add r14,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes B890 - B897
V890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B898 - B89F
V898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B8A0 - B8A7
V8A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes B8A8 - B8AF
V8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes B8B0 - B8B7
V8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B8B8
V8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B8B9
V8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-22,r7
! Opcode B8BA
V8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode B8BB
V8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode B8BC
V8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes B8C0 - B8C7
V8C0:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B8C8 - B8CF
V8C8:
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B8D0 - B8D7
V8D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B8D8 - B8DF
V8D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B8E0 - B8E7
V8E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-12,r7
! Opcodes B8E8 - B8EF
V8E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B8F0 - B8F7
V8F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B8F8
V8F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B8F9
V8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B8FA
V8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode B8FB
V8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode B8FC
V8FC:
mov.w @r6+,r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes B900 - B907
V900:
mov r2,r0
mov.b @(r0,r13),r3
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B908 - B90F
V908:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B910 - B917
V910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B918 - B91F
V918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B920 - B927
V920:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B928 - B92F
V928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B930 - B937
V930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B938
V938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B939
V939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B940 - B947
V940:
mov r2,r0
mov.w @(r0,r13),r3
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes B948 - B94F
V948:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes B950 - B957
V950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B958 - B95F
V958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes B960 - B967
V960:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes B968 - B96F
V968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes B970 - B977
V970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode B978
V978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode B979
V979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B980 - B987
V980:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(16,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes B988 - B98F
V988:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes B990 - B997
V990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B998 - B99F
V998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes B9A0 - B9A7
V9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes B9A8 - B9AF
V9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes B9B0 - B9B7
V9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode B9B8
V9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode B9B9
V9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes B9C0 - B9C7
V9C0:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B9C8 - B9CF
V9C8:
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes B9D0 - B9D7
V9D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B9D8 - B9DF
V9D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes B9E0 - B9E7
V9E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcodes B9E8 - B9EF
V9E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcodes B9F0 - B9F7
V9F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B9F8
V9F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B9F9
V9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-22,r7
! Opcode B9FA
V9FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode B9FB
V9FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode B9FC
V9FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BA00 - BA07
VA00:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BA08 - BA0F
VA08:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BA10 - BA17
VA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BA18 - BA1F
VA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BA20 - BA27
VA20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes BA28 - BA2F
VA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes BA30 - BA37
VA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BA38
VA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BA39
VA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode BA3A
VA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BA3B
VA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BA3C
VA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BA40 - BA47
VA40:
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BA48 - BA4F
VA48:
add r14,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BA50 - BA57
VA50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BA58 - BA5F
VA58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BA60 - BA67
VA60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes BA68 - BA6F
VA68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes BA70 - BA77
VA70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BA78
VA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BA79
VA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode BA7A
VA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BA7B
VA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BA7C
VA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BA80 - BA87
VA80:
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes BA88 - BA8F
VA88:
add r14,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes BA90 - BA97
VA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BA98 - BA9F
VA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BAA0 - BAA7
VAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes BAA8 - BAAF
VAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes BAB0 - BAB7
VAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode BAB8
VAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode BAB9
VAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-22,r7
! Opcode BABA
VABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode BABB
VABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode BABC
VABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BAC0 - BAC7
VAC0:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BAC8 - BACF
VAC8:
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BAD0 - BAD7
VAD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BAD8 - BADF
VAD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BAE0 - BAE7
VAE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-12,r7
! Opcodes BAE8 - BAEF
VAE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BAF0 - BAF7
VAF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode BAF8
VAF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode BAF9
VAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BAFA
VAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode BAFB
VAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode BAFC
VAFC:
mov.w @r6+,r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BB00 - BB07
VB00:
mov r2,r0
mov.b @(r0,r13),r3
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes BB08 - BB0F
VB08:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes BB10 - BB17
VB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BB18 - BB1F
VB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BB20 - BB27
VB20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes BB28 - BB2F
VB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes BB30 - BB37
VB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode BB38
VB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode BB39
VB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BB40 - BB47
VB40:
mov r2,r0
mov.w @(r0,r13),r3
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes BB48 - BB4F
VB48:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes BB50 - BB57
VB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BB58 - BB5F
VB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BB60 - BB67
VB60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes BB68 - BB6F
VB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes BB70 - BB77
VB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode BB78
VB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode BB79
VB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BB80 - BB87
VB80:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(20,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes BB88 - BB8F
VB88:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes BB90 - BB97
VB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BB98 - BB9F
VB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BBA0 - BBA7
VBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes BBA8 - BBAF
VBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes BBB0 - BBB7
VBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode BBB8
VBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode BBB9
VBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes BBC0 - BBC7
VBC0:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BBC8 - BBCF
VBC8:
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BBD0 - BBD7
VBD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BBD8 - BBDF
VBD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BBE0 - BBE7
VBE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcodes BBE8 - BBEF
VBE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcodes BBF0 - BBF7
VBF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode BBF8
VBF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BBF9
VBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-22,r7
! Opcode BBFA
VBFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BBFB
VBFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode BBFC
VBFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BC00 - BC07
VC00:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BC08 - BC0F
VC08:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BC10 - BC17
VC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BC18 - BC1F
VC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BC20 - BC27
VC20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes BC28 - BC2F
VC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes BC30 - BC37
VC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BC38
VC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BC39
VC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode BC3A
VC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BC3B
VC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BC3C
VC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BC40 - BC47
VC40:
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BC48 - BC4F
VC48:
add r14,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BC50 - BC57
VC50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BC58 - BC5F
VC58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BC60 - BC67
VC60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes BC68 - BC6F
VC68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes BC70 - BC77
VC70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BC78
VC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BC79
VC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode BC7A
VC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BC7B
VC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BC7C
VC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BC80 - BC87
VC80:
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes BC88 - BC8F
VC88:
add r14,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes BC90 - BC97
VC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BC98 - BC9F
VC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BCA0 - BCA7
VCA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes BCA8 - BCAF
VCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes BCB0 - BCB7
VCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode BCB8
VCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode BCB9
VCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-22,r7
! Opcode BCBA
VCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode BCBB
VCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode BCBC
VCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BCC0 - BCC7
VCC0:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BCC8 - BCCF
VCC8:
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BCD0 - BCD7
VCD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BCD8 - BCDF
VCD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BCE0 - BCE7
VCE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-12,r7
! Opcodes BCE8 - BCEF
VCE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BCF0 - BCF7
VCF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode BCF8
VCF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode BCF9
VCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BCFA
VCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode BCFB
VCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode BCFC
VCFC:
mov.w @r6+,r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BD00 - BD07
VD00:
mov r2,r0
mov.b @(r0,r13),r3
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes BD08 - BD0F
VD08:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes BD10 - BD17
VD10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BD18 - BD1F
VD18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BD20 - BD27
VD20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes BD28 - BD2F
VD28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes BD30 - BD37
VD30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode BD38
VD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode BD39
VD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BD40 - BD47
VD40:
mov r2,r0
mov.w @(r0,r13),r3
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes BD48 - BD4F
VD48:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes BD50 - BD57
VD50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BD58 - BD5F
VD58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BD60 - BD67
VD60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes BD68 - BD6F
VD68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes BD70 - BD77
VD70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode BD78
VD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode BD79
VD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BD80 - BD87
VD80:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(24,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes BD88 - BD8F
VD88:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes BD90 - BD97
VD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BD98 - BD9F
VD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BDA0 - BDA7
VDA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes BDA8 - BDAF
VDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes BDB0 - BDB7
VDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode BDB8
VDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode BDB9
VDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes BDC0 - BDC7
VDC0:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BDC8 - BDCF
VDC8:
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BDD0 - BDD7
VDD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BDD8 - BDDF
VDD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BDE0 - BDE7
VDE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcodes BDE8 - BDEF
VDE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcodes BDF0 - BDF7
VDF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode BDF8
VDF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BDF9
VDF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-22,r7
! Opcode BDFA
VDFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BDFB
VDFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode BDFC
VDFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BE00 - BE07
VE00:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BE08 - BE0F
VE08:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BE10 - BE17
VE10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BE18 - BE1F
VE18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BE20 - BE27
VE20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes BE28 - BE2F
VE28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes BE30 - BE37
VE30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BE38
VE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BE39
VE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode BE3A
VE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BE3B
VE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BE3C
VE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-24,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BE40 - BE47
VE40:
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BE48 - BE4F
VE48:
add r14,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes BE50 - BE57
VE50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BE58 - BE5F
VE58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BE60 - BE67
VE60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes BE68 - BE6F
VE68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes BE70 - BE77
VE70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BE78
VE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BE79
VE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-16,r7
! Opcode BE7A
VE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-12,r7
! Opcode BE7B
VE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-14,r7
! Opcode BE7C
VE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov #-16,r0
shad r0,r1
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes BE80 - BE87
VE80:
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes BE88 - BE8F
VE88:
add r14,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-6,r7
! Opcodes BE90 - BE97
VE90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BE98 - BE9F
VE98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BEA0 - BEA7
VEA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes BEA8 - BEAF
VEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes BEB0 - BEB7
VEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode BEB8
VEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode BEB9
VEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-22,r7
! Opcode BEBA
VEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-18,r7
! Opcode BEBB
VEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-20,r7
! Opcode BEBC
VEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r1
movt r8
subc r3,r0
addc r8,r8
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes BEC0 - BEC7
VEC0:
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BEC8 - BECF
VEC8:
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BED0 - BED7
VED0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BED8 - BEDF
VED8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BEE0 - BEE7
VEE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-12,r7
! Opcodes BEE8 - BEEF
VEE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BEF0 - BEF7
VEF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode BEF8
VEF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode BEF9
VEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BEFA
VEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcode BEFB
VEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcode BEFC
VEFC:
mov.w @r6+,r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-10,r7
! Opcodes BF00 - BF07
VF00:
mov r2,r0
mov.b @(r0,r13),r3
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes BF08 - BF0F
VF08:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-24,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes BF10 - BF17
VF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BF18 - BF1F
VF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BF20 - BF27
VF20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes BF28 - BF2F
VF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes BF30 - BF37
VF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode BF38
VF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode BF39
VF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BF40 - BF47
VF40:
mov r2,r0
mov.w @(r0,r13),r3
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes BF48 - BF4F
VF48:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
mov #-16,r0
shad r0,r3
jmp @r10
add #-12,r7
! Opcodes BF50 - BF57
VF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BF58 - BF5F
VF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes BF60 - BF67
VF60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes BF68 - BF6F
VF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes BF70 - BF77
VF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode BF78
VF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode BF79
VF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BF80 - BF87
VF80:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(28,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes BF88 - BF8F
VF88:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov r3,r0
subv r2,r3
movt r8
subc r2,r0
addc r8,r8
jmp @r10
add #-20,r7
! Opcodes BF90 - BF97
VF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BF98 - BF9F
VF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes BFA0 - BFA7
VFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes BFA8 - BFAF
VFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes BFB0 - BFB7
VFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode BFB8
VFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode BFB9
VFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes BFC0 - BFC7
VFC0:
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BFC8 - BFCF
VFC8:
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-6,r7
! Opcodes BFD0 - BFD7
VFD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BFD8 - BFDF
VFD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes BFE0 - BFE7
VFE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-16,r7
! Opcodes BFE8 - BFEF
VFE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcodes BFF0 - BFF7
VFF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode BFF8
VFF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BFF9
VFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-22,r7
! Opcode BFFA
VFFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-18,r7
! Opcode BFFB
VFFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-20,r7
! Opcode BFFC
VFFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
mov r0,r3
jmp @r10
add #-14,r7
! Opcodes C000 - C007
W000:
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C010 - C017
W010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C018 - C01F
W018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C020 - C027
W020:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C028 - C02F
W028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C030 - C037
W030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C038
W038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C039
W039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C03A
W03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C03B
W03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C03C
W03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C040 - C047
W040:
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C050 - C057
W050:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C058 - C05F
W058:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C060 - C067
W060:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C068 - C06F
W068:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C070 - C077
W070:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C078
W078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C079
W079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C07A
W07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C07B
W07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C07C
W07C:
mov.w @r6+,r3
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C080 - C087
W080:
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C090 - C097
W090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C098 - C09F
W098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C0A0 - C0A7
W0A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C0A8 - C0AF
W0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes C0B0 - C0B7
W0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C0B8
W0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C0B9
W0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-22,r7
! Opcode C0BA
W0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C0BB
W0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C0BC
W0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C0C0 - C0C7
W0C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C0D0 - C0D7
W0D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C0D8 - C0DF
W0D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C0E0 - C0E7
W0E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C0E8 - C0EF
W0E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C0F0 - C0F7
W0F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C0F8
W0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C0F9
W0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C0FA
W0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C0FB
W0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C0FC
W0FC:
mov.w @r6+,r3
add #-16,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C100 - C107
W100:
mov r3,r4
mov.b @r13,r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd761
add #6,r8
.nonibadd761:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop761
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop761:
exts.b r3,r3
mov r9,r8
mov.b r3,@r13
or r4,r3
jmp @r10
add #-6,r7
! Opcodes C108 - C10F
W108:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd762
add #6,r8
.nonibadd762:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop762
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop762:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes C110 - C117
W110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C118 - C11F
W118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C120 - C127
W120:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C128 - C12F
W128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C130 - C137
W130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C138
W138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C139
W139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C140 - C147
W140:
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @r13,r3
mov.l r3,@r2
mov.l r1,@r13
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C148 - C14F
W148:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(32,r13),r3
mov.l r3,@r2
mov.l r1,@(32,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C150 - C157
W150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C158 - C15F
W158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C160 - C167
W160:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C168 - C16F
W168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C170 - C177
W170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C178
W178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C179
W179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C188 - C18F
W188:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @r13,r3
mov.l r3,@r2
mov.l r1,@r13
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C190 - C197
W190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C198 - C19F
W198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C1A0 - C1A7
W1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes C1A8 - C1AF
W1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes C1B0 - C1B7
W1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode C1B8
W1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode C1B9
W1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes C1C0 - C1C7
W1C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C1D0 - C1D7
W1D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C1D8 - C1DF
W1D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C1E0 - C1E7
W1E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C1E8 - C1EF
W1E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C1F0 - C1F7
W1F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C1F8
W1F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C1F9
W1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C1FA
W1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C1FB
W1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C1FC
W1FC:
mov.w @r6+,r3
add #-8,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C200 - C207
W200:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C210 - C217
W210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C218 - C21F
W218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C220 - C227
W220:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C228 - C22F
W228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C230 - C237
W230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C238
W238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C239
W239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C23A
W23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C23B
W23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C23C
W23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C240 - C247
W240:
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C250 - C257
W250:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C258 - C25F
W258:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C260 - C267
W260:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C268 - C26F
W268:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C270 - C277
W270:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C278
W278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C279
W279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C27A
W27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C27B
W27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C27C
W27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C280 - C287
W280:
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C290 - C297
W290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C298 - C29F
W298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C2A0 - C2A7
W2A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C2A8 - C2AF
W2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes C2B0 - C2B7
W2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C2B8
W2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C2B9
W2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode C2BA
W2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C2BB
W2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C2BC
W2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C2C0 - C2C7
W2C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C2D0 - C2D7
W2D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C2D8 - C2DF
W2D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C2E0 - C2E7
W2E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C2E8 - C2EF
W2E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C2F0 - C2F7
W2F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C2F8
W2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C2F9
W2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C2FA
W2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C2FB
W2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C2FC
W2FC:
mov.w @r6+,r3
add #-16,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C300 - C307
W300:
mov r3,r4
mov #4,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd785
add #6,r8
.nonibadd785:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop785
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop785:
exts.b r3,r3
mov r9,r8
mov #4,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes C308 - C30F
W308:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd786
add #6,r8
.nonibadd786:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop786
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop786:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes C310 - C317
W310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C318 - C31F
W318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C320 - C327
W320:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C328 - C32F
W328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C330 - C337
W330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C338
W338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C339
W339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C340 - C347
W340:
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(4,r13),r3
mov.l r3,@r2
mov.l r1,@(4,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C348 - C34F
W348:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(36,r13),r3
mov.l r3,@r2
mov.l r1,@(36,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C350 - C357
W350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C358 - C35F
W358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C360 - C367
W360:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C368 - C36F
W368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C370 - C377
W370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C378
W378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C379
W379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C388 - C38F
W388:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(4,r13),r3
mov.l r3,@r2
mov.l r1,@(4,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C390 - C397
W390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C398 - C39F
W398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C3A0 - C3A7
W3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes C3A8 - C3AF
W3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes C3B0 - C3B7
W3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode C3B8
W3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode C3B9
W3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes C3C0 - C3C7
W3C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C3D0 - C3D7
W3D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C3D8 - C3DF
W3D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C3E0 - C3E7
W3E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C3E8 - C3EF
W3E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C3F0 - C3F7
W3F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C3F8
W3F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C3F9
W3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C3FA
W3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C3FB
W3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C3FC
W3FC:
mov.w @r6+,r3
add #-8,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C400 - C407
W400:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C410 - C417
W410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C418 - C41F
W418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C420 - C427
W420:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C428 - C42F
W428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C430 - C437
W430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C438
W438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C439
W439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C43A
W43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C43B
W43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C43C
W43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C440 - C447
W440:
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C450 - C457
W450:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C458 - C45F
W458:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C460 - C467
W460:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C468 - C46F
W468:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C470 - C477
W470:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C478
W478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C479
W479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C47A
W47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C47B
W47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C47C
W47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C480 - C487
W480:
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C490 - C497
W490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C498 - C49F
W498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C4A0 - C4A7
W4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C4A8 - C4AF
W4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes C4B0 - C4B7
W4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C4B8
W4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C4B9
W4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode C4BA
W4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C4BB
W4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C4BC
W4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C4C0 - C4C7
W4C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C4D0 - C4D7
W4D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C4D8 - C4DF
W4D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C4E0 - C4E7
W4E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C4E8 - C4EF
W4E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C4F0 - C4F7
W4F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C4F8
W4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C4F9
W4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C4FA
W4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C4FB
W4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C4FC
W4FC:
mov.w @r6+,r3
add #-16,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C500 - C507
W500:
mov r3,r4
mov #8,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd809
add #6,r8
.nonibadd809:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop809
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop809:
exts.b r3,r3
mov r9,r8
mov #8,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes C508 - C50F
W508:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd810
add #6,r8
.nonibadd810:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop810
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop810:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes C510 - C517
W510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C518 - C51F
W518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C520 - C527
W520:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C528 - C52F
W528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C530 - C537
W530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C538
W538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C539
W539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C540 - C547
W540:
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(8,r13),r3
mov.l r3,@r2
mov.l r1,@(8,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C548 - C54F
W548:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(40,r13),r3
mov.l r3,@r2
mov.l r1,@(40,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C550 - C557
W550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C558 - C55F
W558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C560 - C567
W560:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C568 - C56F
W568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C570 - C577
W570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C578
W578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C579
W579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C588 - C58F
W588:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(8,r13),r3
mov.l r3,@r2
mov.l r1,@(8,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C590 - C597
W590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C598 - C59F
W598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C5A0 - C5A7
W5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes C5A8 - C5AF
W5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes C5B0 - C5B7
W5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode C5B8
W5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode C5B9
W5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes C5C0 - C5C7
W5C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C5D0 - C5D7
W5D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C5D8 - C5DF
W5D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C5E0 - C5E7
W5E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C5E8 - C5EF
W5E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C5F0 - C5F7
W5F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C5F8
W5F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C5F9
W5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C5FA
W5FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C5FB
W5FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C5FC
W5FC:
mov.w @r6+,r3
add #-8,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C600 - C607
W600:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C610 - C617
W610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C618 - C61F
W618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C620 - C627
W620:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C628 - C62F
W628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C630 - C637
W630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C638
W638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C639
W639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C63A
W63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C63B
W63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C63C
W63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C640 - C647
W640:
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C650 - C657
W650:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C658 - C65F
W658:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C660 - C667
W660:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C668 - C66F
W668:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C670 - C677
W670:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C678
W678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C679
W679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C67A
W67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C67B
W67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C67C
W67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C680 - C687
W680:
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C690 - C697
W690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C698 - C69F
W698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C6A0 - C6A7
W6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C6A8 - C6AF
W6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes C6B0 - C6B7
W6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C6B8
W6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C6B9
W6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode C6BA
W6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C6BB
W6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C6BC
W6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C6C0 - C6C7
W6C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C6D0 - C6D7
W6D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C6D8 - C6DF
W6D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C6E0 - C6E7
W6E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C6E8 - C6EF
W6E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C6F0 - C6F7
W6F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C6F8
W6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C6F9
W6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C6FA
W6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C6FB
W6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C6FC
W6FC:
mov.w @r6+,r3
add #-16,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C700 - C707
W700:
mov r3,r4
mov #12,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd833
add #6,r8
.nonibadd833:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop833
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop833:
exts.b r3,r3
mov r9,r8
mov #12,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes C708 - C70F
W708:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd834
add #6,r8
.nonibadd834:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop834
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop834:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes C710 - C717
W710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C718 - C71F
W718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C720 - C727
W720:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C728 - C72F
W728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C730 - C737
W730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C738
W738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C739
W739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C740 - C747
W740:
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(12,r13),r3
mov.l r3,@r2
mov.l r1,@(12,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C748 - C74F
W748:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(44,r13),r3
mov.l r3,@r2
mov.l r1,@(44,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C750 - C757
W750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C758 - C75F
W758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C760 - C767
W760:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C768 - C76F
W768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C770 - C777
W770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C778
W778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C779
W779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C788 - C78F
W788:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(12,r13),r3
mov.l r3,@r2
mov.l r1,@(12,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C790 - C797
W790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C798 - C79F
W798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C7A0 - C7A7
W7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes C7A8 - C7AF
W7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes C7B0 - C7B7
W7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode C7B8
W7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode C7B9
W7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes C7C0 - C7C7
W7C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C7D0 - C7D7
W7D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C7D8 - C7DF
W7D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C7E0 - C7E7
W7E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C7E8 - C7EF
W7E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C7F0 - C7F7
W7F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C7F8
W7F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C7F9
W7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C7FA
W7FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C7FB
W7FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C7FC
W7FC:
mov.w @r6+,r3
add #-8,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C800 - C807
W800:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C810 - C817
W810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C818 - C81F
W818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C820 - C827
W820:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C828 - C82F
W828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C830 - C837
W830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C838
W838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C839
W839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C83A
W83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C83B
W83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C83C
W83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C840 - C847
W840:
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes C850 - C857
W850:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C858 - C85F
W858:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C860 - C867
W860:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes C868 - C86F
W868:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C870 - C877
W870:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C878
W878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C879
W879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C87A
W87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode C87B
W87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode C87C
W87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C880 - C887
W880:
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes C890 - C897
W890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C898 - C89F
W898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C8A0 - C8A7
W8A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C8A8 - C8AF
W8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes C8B0 - C8B7
W8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C8B8
W8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C8B9
W8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode C8BA
W8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C8BB
W8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode C8BC
W8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C8C0 - C8C7
W8C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C8D0 - C8D7
W8D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C8D8 - C8DF
W8D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C8E0 - C8E7
W8E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C8E8 - C8EF
W8E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C8F0 - C8F7
W8F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C8F8
W8F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C8F9
W8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C8FA
W8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C8FB
W8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C8FC
W8FC:
mov.w @r6+,r3
add #-16,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C900 - C907
W900:
mov r3,r4
mov #16,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd857
add #6,r8
.nonibadd857:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop857
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop857:
exts.b r3,r3
mov r9,r8
mov #16,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes C908 - C90F
W908:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd858
add #6,r8
.nonibadd858:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop858
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop858:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes C910 - C917
W910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C918 - C91F
W918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C920 - C927
W920:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C928 - C92F
W928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C930 - C937
W930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C938
W938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C939
W939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C940 - C947
W940:
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(16,r13),r3
mov.l r3,@r2
mov.l r1,@(16,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C948 - C94F
W948:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(48,r13),r3
mov.l r3,@r2
mov.l r1,@(48,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C950 - C957
W950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C958 - C95F
W958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes C960 - C967
W960:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes C968 - C96F
W968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes C970 - C977
W970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode C978
W978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode C979
W979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C988 - C98F
W988:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(16,r13),r3
mov.l r3,@r2
mov.l r1,@(16,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes C990 - C997
W990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C998 - C99F
W998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes C9A0 - C9A7
W9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes C9A8 - C9AF
W9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes C9B0 - C9B7
W9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode C9B8
W9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode C9B9
W9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes C9C0 - C9C7
W9C0:
mov r2,r0
mov.w @(r0,r13),r3
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes C9D0 - C9D7
W9D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C9D8 - C9DF
W9D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes C9E0 - C9E7
W9E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes C9E8 - C9EF
W9E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes C9F0 - C9F7
W9F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C9F8
W9F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C9F9
W9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode C9FA
W9FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode C9FB
W9FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode C9FC
W9FC:
mov.w @r6+,r3
add #-8,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CA00 - CA07
WA00:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes CA10 - CA17
WA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CA18 - CA1F
WA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CA20 - CA27
WA20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes CA28 - CA2F
WA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CA30 - CA37
WA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CA38
WA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CA39
WA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CA3A
WA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CA3B
WA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CA3C
WA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CA40 - CA47
WA40:
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes CA50 - CA57
WA50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CA58 - CA5F
WA58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CA60 - CA67
WA60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes CA68 - CA6F
WA68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CA70 - CA77
WA70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CA78
WA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CA79
WA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CA7A
WA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CA7B
WA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CA7C
WA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CA80 - CA87
WA80:
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CA90 - CA97
WA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CA98 - CA9F
WA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CAA0 - CAA7
WAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CAA8 - CAAF
WAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes CAB0 - CAB7
WAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode CAB8
WAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CAB9
WAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode CABA
WABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CABB
WABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode CABC
WABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CAC0 - CAC7
WAC0:
mov r2,r0
mov.w @(r0,r13),r3
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes CAD0 - CAD7
WAD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CAD8 - CADF
WAD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CAE0 - CAE7
WAE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes CAE8 - CAEF
WAE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes CAF0 - CAF7
WAF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CAF8
WAF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CAF9
WAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode CAFA
WAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CAFB
WAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CAFC
WAFC:
mov.w @r6+,r3
add #-16,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CB00 - CB07
WB00:
mov r3,r4
mov #20,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd881
add #6,r8
.nonibadd881:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop881
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop881:
exts.b r3,r3
mov r9,r8
mov #20,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes CB08 - CB0F
WB08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd882
add #6,r8
.nonibadd882:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop882
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop882:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes CB10 - CB17
WB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CB18 - CB1F
WB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CB20 - CB27
WB20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CB28 - CB2F
WB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CB30 - CB37
WB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CB38
WB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CB39
WB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CB40 - CB47
WB40:
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(20,r13),r3
mov.l r3,@r2
mov.l r1,@(20,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CB48 - CB4F
WB48:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(52,r13),r3
mov.l r3,@r2
mov.l r1,@(52,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CB50 - CB57
WB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CB58 - CB5F
WB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CB60 - CB67
WB60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CB68 - CB6F
WB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CB70 - CB77
WB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CB78
WB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CB79
WB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CB88 - CB8F
WB88:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(20,r13),r3
mov.l r3,@r2
mov.l r1,@(20,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CB90 - CB97
WB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CB98 - CB9F
WB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CBA0 - CBA7
WBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes CBA8 - CBAF
WBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes CBB0 - CBB7
WBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode CBB8
WBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode CBB9
WBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes CBC0 - CBC7
WBC0:
mov r2,r0
mov.w @(r0,r13),r3
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes CBD0 - CBD7
WBD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CBD8 - CBDF
WBD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CBE0 - CBE7
WBE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes CBE8 - CBEF
WBE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes CBF0 - CBF7
WBF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CBF8
WBF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CBF9
WBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode CBFA
WBFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CBFB
WBFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CBFC
WBFC:
mov.w @r6+,r3
add #-8,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CC00 - CC07
WC00:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes CC10 - CC17
WC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CC18 - CC1F
WC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CC20 - CC27
WC20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes CC28 - CC2F
WC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CC30 - CC37
WC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CC38
WC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CC39
WC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CC3A
WC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CC3B
WC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CC3C
WC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CC40 - CC47
WC40:
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes CC50 - CC57
WC50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CC58 - CC5F
WC58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CC60 - CC67
WC60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes CC68 - CC6F
WC68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CC70 - CC77
WC70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CC78
WC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CC79
WC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CC7A
WC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CC7B
WC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CC7C
WC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CC80 - CC87
WC80:
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CC90 - CC97
WC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CC98 - CC9F
WC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CCA0 - CCA7
WCA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CCA8 - CCAF
WCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes CCB0 - CCB7
WCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode CCB8
WCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CCB9
WCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode CCBA
WCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CCBB
WCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode CCBC
WCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CCC0 - CCC7
WCC0:
mov r2,r0
mov.w @(r0,r13),r3
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes CCD0 - CCD7
WCD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CCD8 - CCDF
WCD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CCE0 - CCE7
WCE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes CCE8 - CCEF
WCE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes CCF0 - CCF7
WCF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CCF8
WCF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CCF9
WCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode CCFA
WCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CCFB
WCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CCFC
WCFC:
mov.w @r6+,r3
add #-16,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CD00 - CD07
WD00:
mov r3,r4
mov #24,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd905
add #6,r8
.nonibadd905:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop905
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop905:
exts.b r3,r3
mov r9,r8
mov #24,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes CD08 - CD0F
WD08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd906
add #6,r8
.nonibadd906:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop906
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop906:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes CD10 - CD17
WD10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CD18 - CD1F
WD18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CD20 - CD27
WD20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CD28 - CD2F
WD28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CD30 - CD37
WD30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CD38
WD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CD39
WD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CD40 - CD47
WD40:
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(24,r13),r3
mov.l r3,@r2
mov.l r1,@(24,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CD48 - CD4F
WD48:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(56,r13),r3
mov.l r3,@r2
mov.l r1,@(56,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CD50 - CD57
WD50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CD58 - CD5F
WD58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CD60 - CD67
WD60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CD68 - CD6F
WD68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CD70 - CD77
WD70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CD78
WD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CD79
WD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CD88 - CD8F
WD88:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(24,r13),r3
mov.l r3,@r2
mov.l r1,@(24,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CD90 - CD97
WD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CD98 - CD9F
WD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CDA0 - CDA7
WDA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes CDA8 - CDAF
WDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes CDB0 - CDB7
WDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode CDB8
WDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode CDB9
WDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes CDC0 - CDC7
WDC0:
mov r2,r0
mov.w @(r0,r13),r3
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes CDD0 - CDD7
WDD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CDD8 - CDDF
WDD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CDE0 - CDE7
WDE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes CDE8 - CDEF
WDE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes CDF0 - CDF7
WDF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CDF8
WDF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CDF9
WDF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode CDFA
WDFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CDFB
WDFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CDFC
WDFC:
mov.w @r6+,r3
add #-8,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CE00 - CE07
WE00:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes CE10 - CE17
WE10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CE18 - CE1F
WE18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CE20 - CE27
WE20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes CE28 - CE2F
WE28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CE30 - CE37
WE30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CE38
WE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CE39
WE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CE3A
WE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CE3B
WE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CE3C
WE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CE40 - CE47
WE40:
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-4,r7
! Opcodes CE50 - CE57
WE50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CE58 - CE5F
WE58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CE60 - CE67
WE60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-10,r7
! Opcodes CE68 - CE6F
WE68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CE70 - CE77
WE70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CE78
WE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CE79
WE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CE7A
WE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-12,r7
! Opcode CE7B
WE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcode CE7C
WE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CE80 - CE87
WE80:
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-8,r7
! Opcodes CE90 - CE97
WE90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CE98 - CE9F
WE98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CEA0 - CEA7
WEA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CEA8 - CEAF
WEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcodes CEB0 - CEB7
WEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode CEB8
WEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CEB9
WEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-22,r7
! Opcode CEBA
WEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CEBB
WEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-20,r7
! Opcode CEBC
WEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CEC0 - CEC7
WEC0:
mov r2,r0
mov.w @(r0,r13),r3
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes CED0 - CED7
WED0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CED8 - CEDF
WED8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CEE0 - CEE7
WEE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes CEE8 - CEEF
WEE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes CEF0 - CEF7
WEF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CEF8
WEF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CEF9
WEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode CEFA
WEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CEFB
WEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CEFC
WEFC:
mov.w @r6+,r3
add #-16,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CF00 - CF07
WF00:
mov r3,r4
mov #28,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd929
add #6,r8
.nonibadd929:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop929
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop929:
exts.b r3,r3
mov r9,r8
mov #28,r0
mov.b r3,@(r0,r13)
or r4,r3
jmp @r10
add #-6,r7
! Opcodes CF08 - CF0F
WF08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd930
add #6,r8
.nonibadd930:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop930
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop930:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes CF10 - CF17
WF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CF18 - CF1F
WF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CF20 - CF27
WF20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CF28 - CF2F
WF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CF30 - CF37
WF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CF38
WF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CF39
WF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CF40 - CF47
WF40:
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(28,r13),r3
mov.l r3,@r2
mov.l r1,@(28,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CF48 - CF4F
WF48:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(60,r13),r3
mov.l r3,@r2
mov.l r1,@(60,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CF50 - CF57
WF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CF58 - CF5F
WF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-12,r7
! Opcodes CF60 - CF67
WF60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-14,r7
! Opcodes CF68 - CF6F
WF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcodes CF70 - CF77
WF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-18,r7
! Opcode CF78
WF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-16,r7
! Opcode CF79
WF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CF88 - CF8F
WF88:
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(28,r13),r3
mov.l r3,@r2
mov.l r1,@(28,r13)
mov r4,r3
jmp @r10
add #-6,r7
! Opcodes CF90 - CF97
WF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CF98 - CF9F
WF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-20,r7
! Opcodes CFA0 - CFA7
WFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r8
jmp @r10
add #-22,r7
! Opcodes CFA8 - CFAF
WFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcodes CFB0 - CFB7
WFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-26,r7
! Opcode CFB8
WFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-24,r7
! Opcode CFB9
WFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r8
jmp @r10
add #-28,r7
! Opcodes CFC0 - CFC7
WFC0:
mov r2,r0
mov.w @(r0,r13),r3
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-38,r7
! Opcodes CFD0 - CFD7
WFD0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CFD8 - CFDF
WFD8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes CFE0 - CFE7
WFE0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-44,r7
! Opcodes CFE8 - CFEF
WFE8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcodes CFF0 - CFF7
WFF0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CFF8
WFF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CFF9
WFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-50,r7
! Opcode CFFA
WFFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-46,r7
! Opcode CFFB
WFFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-48,r7
! Opcode CFFC
WFFC:
mov.w @r6+,r3
add #-8,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
mov #0,r8
jmp @r10
add #-42,r7
! Opcodes D000 - D007
X000:
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D008 - D00F
X008:
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D010 - D017
X010:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D018 - D01F
X018:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D020 - D027
X020:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D028 - D02F
X028:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D030 - D037
X030:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D038
X038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D039
X039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D03A
X03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D03B
X03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D03C
X03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D040 - D047
X040:
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D048 - D04F
X048:
add r14,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D050 - D057
X050:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D058 - D05F
X058:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D060 - D067
X060:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D068 - D06F
X068:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D070 - D077
X070:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D078
X078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D079
X079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D07A
X07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D07B
X07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D07C
X07C:
mov.w @r6+,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D080 - D087
X080:
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D088 - D08F
X088:
add r14,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D090 - D097
X090:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D098 - D09F
X098:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D0A0 - D0A7
X0A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D0A8 - D0AF
X0A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes D0B0 - D0B7
X0B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D0B8
X0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D0B9
X0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-22,r7
! Opcode D0BA
X0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D0BB
X0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D0BC
X0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@r13
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D0C0 - D0C7
X0C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D0C8 - D0CF
X0C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D0D0 - D0D7
X0D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D0D8 - D0DF
X0D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D0E0 - D0E7
X0E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D0E8 - D0EF
X0E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D0F0 - D0F7
X0F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D0F8
X0F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D0F9
X0F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D0FA
X0FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D0FB
X0FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D0FC
X0FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D100 - D107
X100:
mov r3,r4
mov.b @r13,r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r13
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D108 - D10F
X108:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D110 - D117
X110:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D118 - D11F
X118:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D120 - D127
X120:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D128 - D12F
X128:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D130 - D137
X130:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D138
X138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D139
X139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D140 - D147
X140:
mov r3,r4
mov.w @r13,r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r13
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D148 - D14F
X148:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D150 - D157
X150:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D158 - D15F
X158:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D160 - D167
X160:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D168 - D16F
X168:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D170 - D177
X170:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D178
X178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D179
X179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D180 - D187
X180:
mov r3,r4
mov.l @r13,r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@r13
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes D188 - D18F
X188:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes D190 - D197
X190:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D198 - D19F
X198:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes D1A0 - D1A7
X1A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes D1A8 - D1AF
X1A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes D1B0 - D1B7
X1B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode D1B8
X1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode D1B9
X1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes D1C0 - D1C7
X1C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D1C8 - D1CF
X1C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D1D0 - D1D7
X1D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D1D8 - D1DF
X1D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D1E0 - D1E7
X1E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D1E8 - D1EF
X1E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes D1F0 - D1F7
X1F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D1F8
X1F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D1F9
X1F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode D1FA
X1FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D1FB
X1FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D1FC
X1FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D200 - D207
X200:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D208 - D20F
X208:
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D210 - D217
X210:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D218 - D21F
X218:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D220 - D227
X220:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D228 - D22F
X228:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D230 - D237
X230:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D238
X238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D239
X239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D23A
X23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D23B
X23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D23C
X23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D240 - D247
X240:
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D248 - D24F
X248:
add r14,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D250 - D257
X250:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D258 - D25F
X258:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D260 - D267
X260:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D268 - D26F
X268:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D270 - D277
X270:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D278
X278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D279
X279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D27A
X27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D27B
X27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D27C
X27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D280 - D287
X280:
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D288 - D28F
X288:
add r14,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D290 - D297
X290:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D298 - D29F
X298:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D2A0 - D2A7
X2A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D2A8 - D2AF
X2A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes D2B0 - D2B7
X2B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D2B8
X2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D2B9
X2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode D2BA
X2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D2BB
X2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D2BC
X2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(4,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D2C0 - D2C7
X2C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D2C8 - D2CF
X2C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D2D0 - D2D7
X2D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D2D8 - D2DF
X2D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D2E0 - D2E7
X2E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D2E8 - D2EF
X2E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D2F0 - D2F7
X2F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D2F8
X2F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D2F9
X2F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D2FA
X2FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D2FB
X2FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D2FC
X2FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D300 - D307
X300:
mov r3,r4
mov #4,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #4,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D308 - D30F
X308:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D310 - D317
X310:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D318 - D31F
X318:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D320 - D327
X320:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D328 - D32F
X328:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D330 - D337
X330:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D338
X338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D339
X339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D340 - D347
X340:
mov r3,r4
mov #4,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #4,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D348 - D34F
X348:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D350 - D357
X350:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D358 - D35F
X358:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D360 - D367
X360:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D368 - D36F
X368:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D370 - D377
X370:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D378
X378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D379
X379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D380 - D387
X380:
mov r3,r4
mov.l @(4,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(4,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes D388 - D38F
X388:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes D390 - D397
X390:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D398 - D39F
X398:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes D3A0 - D3A7
X3A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes D3A8 - D3AF
X3A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes D3B0 - D3B7
X3B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode D3B8
X3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode D3B9
X3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes D3C0 - D3C7
X3C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D3C8 - D3CF
X3C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D3D0 - D3D7
X3D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D3D8 - D3DF
X3D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D3E0 - D3E7
X3E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D3E8 - D3EF
X3E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes D3F0 - D3F7
X3F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D3F8
X3F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D3F9
X3F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode D3FA
X3FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D3FB
X3FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D3FC
X3FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D400 - D407
X400:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D408 - D40F
X408:
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D410 - D417
X410:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D418 - D41F
X418:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D420 - D427
X420:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D428 - D42F
X428:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D430 - D437
X430:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D438
X438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D439
X439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D43A
X43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D43B
X43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D43C
X43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D440 - D447
X440:
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D448 - D44F
X448:
add r14,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D450 - D457
X450:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D458 - D45F
X458:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D460 - D467
X460:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D468 - D46F
X468:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D470 - D477
X470:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D478
X478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D479
X479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D47A
X47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D47B
X47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D47C
X47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D480 - D487
X480:
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D488 - D48F
X488:
add r14,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D490 - D497
X490:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D498 - D49F
X498:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D4A0 - D4A7
X4A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D4A8 - D4AF
X4A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes D4B0 - D4B7
X4B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D4B8
X4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D4B9
X4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode D4BA
X4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D4BB
X4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D4BC
X4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(8,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D4C0 - D4C7
X4C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D4C8 - D4CF
X4C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D4D0 - D4D7
X4D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D4D8 - D4DF
X4D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D4E0 - D4E7
X4E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D4E8 - D4EF
X4E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D4F0 - D4F7
X4F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D4F8
X4F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D4F9
X4F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D4FA
X4FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D4FB
X4FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D4FC
X4FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D500 - D507
X500:
mov r3,r4
mov #8,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #8,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D508 - D50F
X508:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D510 - D517
X510:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D518 - D51F
X518:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D520 - D527
X520:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D528 - D52F
X528:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D530 - D537
X530:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D538
X538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D539
X539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D540 - D547
X540:
mov r3,r4
mov #8,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #8,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D548 - D54F
X548:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D550 - D557
X550:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D558 - D55F
X558:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D560 - D567
X560:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D568 - D56F
X568:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D570 - D577
X570:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D578
X578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D579
X579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D580 - D587
X580:
mov r3,r4
mov.l @(8,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(8,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes D588 - D58F
X588:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes D590 - D597
X590:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D598 - D59F
X598:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes D5A0 - D5A7
X5A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes D5A8 - D5AF
X5A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes D5B0 - D5B7
X5B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode D5B8
X5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode D5B9
X5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes D5C0 - D5C7
X5C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D5C8 - D5CF
X5C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D5D0 - D5D7
X5D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D5D8 - D5DF
X5D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D5E0 - D5E7
X5E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D5E8 - D5EF
X5E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes D5F0 - D5F7
X5F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D5F8
X5F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D5F9
X5F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode D5FA
X5FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D5FB
X5FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D5FC
X5FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D600 - D607
X600:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D608 - D60F
X608:
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D610 - D617
X610:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D618 - D61F
X618:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D620 - D627
X620:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D628 - D62F
X628:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D630 - D637
X630:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D638
X638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D639
X639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D63A
X63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D63B
X63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D63C
X63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D640 - D647
X640:
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D648 - D64F
X648:
add r14,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D650 - D657
X650:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D658 - D65F
X658:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D660 - D667
X660:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D668 - D66F
X668:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D670 - D677
X670:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D678
X678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D679
X679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D67A
X67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D67B
X67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D67C
X67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D680 - D687
X680:
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D688 - D68F
X688:
add r14,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D690 - D697
X690:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D698 - D69F
X698:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D6A0 - D6A7
X6A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D6A8 - D6AF
X6A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes D6B0 - D6B7
X6B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D6B8
X6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D6B9
X6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode D6BA
X6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D6BB
X6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D6BC
X6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(12,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D6C0 - D6C7
X6C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D6C8 - D6CF
X6C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D6D0 - D6D7
X6D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D6D8 - D6DF
X6D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D6E0 - D6E7
X6E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D6E8 - D6EF
X6E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D6F0 - D6F7
X6F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D6F8
X6F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D6F9
X6F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D6FA
X6FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D6FB
X6FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D6FC
X6FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D700 - D707
X700:
mov r3,r4
mov #12,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #12,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D708 - D70F
X708:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D710 - D717
X710:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D718 - D71F
X718:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D720 - D727
X720:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D728 - D72F
X728:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D730 - D737
X730:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D738
X738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D739
X739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D740 - D747
X740:
mov r3,r4
mov #12,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #12,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D748 - D74F
X748:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D750 - D757
X750:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D758 - D75F
X758:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D760 - D767
X760:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D768 - D76F
X768:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D770 - D777
X770:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D778
X778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D779
X779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D780 - D787
X780:
mov r3,r4
mov.l @(12,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(12,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes D788 - D78F
X788:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes D790 - D797
X790:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D798 - D79F
X798:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes D7A0 - D7A7
X7A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes D7A8 - D7AF
X7A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes D7B0 - D7B7
X7B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode D7B8
X7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode D7B9
X7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes D7C0 - D7C7
X7C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D7C8 - D7CF
X7C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D7D0 - D7D7
X7D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D7D8 - D7DF
X7D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D7E0 - D7E7
X7E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D7E8 - D7EF
X7E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes D7F0 - D7F7
X7F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D7F8
X7F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D7F9
X7F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode D7FA
X7FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D7FB
X7FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D7FC
X7FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D800 - D807
X800:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D808 - D80F
X808:
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D810 - D817
X810:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D818 - D81F
X818:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D820 - D827
X820:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D828 - D82F
X828:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D830 - D837
X830:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D838
X838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D839
X839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D83A
X83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D83B
X83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D83C
X83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D840 - D847
X840:
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D848 - D84F
X848:
add r14,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes D850 - D857
X850:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D858 - D85F
X858:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D860 - D867
X860:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes D868 - D86F
X868:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes D870 - D877
X870:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D878
X878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D879
X879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode D87A
X87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode D87B
X87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode D87C
X87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D880 - D887
X880:
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D888 - D88F
X888:
add r14,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes D890 - D897
X890:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D898 - D89F
X898:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes D8A0 - D8A7
X8A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D8A8 - D8AF
X8A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes D8B0 - D8B7
X8B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D8B8
X8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D8B9
X8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode D8BA
X8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode D8BB
X8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode D8BC
X8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(16,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes D8C0 - D8C7
X8C0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D8C8 - D8CF
X8C8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D8D0 - D8D7
X8D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D8D8 - D8DF
X8D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D8E0 - D8E7
X8E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D8E8 - D8EF
X8E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D8F0 - D8F7
X8F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D8F8
X8F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D8F9
X8F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D8FA
X8FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode D8FB
X8FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D8FC
X8FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes D900 - D907
X900:
mov r3,r4
mov #16,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #16,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D908 - D90F
X908:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D910 - D917
X910:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D918 - D91F
X918:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D920 - D927
X920:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D928 - D92F
X928:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D930 - D937
X930:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D938
X938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D939
X939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D940 - D947
X940:
mov r3,r4
mov #16,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #16,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes D948 - D94F
X948:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes D950 - D957
X950:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes D958 - D95F
X958:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes D960 - D967
X960:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes D968 - D96F
X968:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes D970 - D977
X970:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode D978
X978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode D979
X979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D980 - D987
X980:
mov r3,r4
mov.l @(16,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(16,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes D988 - D98F
X988:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes D990 - D997
X990:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes D998 - D99F
X998:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes D9A0 - D9A7
X9A0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes D9A8 - D9AF
X9A8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes D9B0 - D9B7
X9B0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode D9B8
X9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode D9B9
X9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes D9C0 - D9C7
X9C0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D9C8 - D9CF
X9C8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes D9D0 - D9D7
X9D0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D9D8 - D9DF
X9D8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes D9E0 - D9E7
X9E0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes D9E8 - D9EF
X9E8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes D9F0 - D9F7
X9F0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D9F8
X9F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D9F9
X9F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode D9FA
X9FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode D9FB
X9FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode D9FC
X9FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DA00 - DA07
XA00:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DA08 - DA0F
XA08:
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DA10 - DA17
XA10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DA18 - DA1F
XA18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DA20 - DA27
XA20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes DA28 - DA2F
XA28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes DA30 - DA37
XA30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DA38
XA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DA39
XA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode DA3A
XA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DA3B
XA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DA3C
XA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DA40 - DA47
XA40:
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DA48 - DA4F
XA48:
add r14,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DA50 - DA57
XA50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DA58 - DA5F
XA58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DA60 - DA67
XA60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes DA68 - DA6F
XA68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes DA70 - DA77
XA70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DA78
XA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DA79
XA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode DA7A
XA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DA7B
XA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DA7C
XA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DA80 - DA87
XA80:
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DA88 - DA8F
XA88:
add r14,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DA90 - DA97
XA90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes DA98 - DA9F
XA98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes DAA0 - DAA7
XAA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes DAA8 - DAAF
XAA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes DAB0 - DAB7
XAB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode DAB8
XAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode DAB9
XAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode DABA
XABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode DABB
XABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode DABC
XABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(20,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes DAC0 - DAC7
XAC0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DAC8 - DACF
XAC8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DAD0 - DAD7
XAD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DAD8 - DADF
XAD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DAE0 - DAE7
XAE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DAE8 - DAEF
XAE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DAF0 - DAF7
XAF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DAF8
XAF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode DAF9
XAF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DAFA
XAFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode DAFB
XAFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DAFC
XAFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DB00 - DB07
XB00:
mov r3,r4
mov #20,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #20,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes DB08 - DB0F
XB08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes DB10 - DB17
XB10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes DB18 - DB1F
XB18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes DB20 - DB27
XB20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes DB28 - DB2F
XB28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes DB30 - DB37
XB30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode DB38
XB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode DB39
XB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DB40 - DB47
XB40:
mov r3,r4
mov #20,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #20,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes DB48 - DB4F
XB48:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes DB50 - DB57
XB50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes DB58 - DB5F
XB58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes DB60 - DB67
XB60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes DB68 - DB6F
XB68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes DB70 - DB77
XB70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode DB78
XB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode DB79
XB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DB80 - DB87
XB80:
mov r3,r4
mov.l @(20,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(20,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes DB88 - DB8F
XB88:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes DB90 - DB97
XB90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DB98 - DB9F
XB98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes DBA0 - DBA7
XBA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes DBA8 - DBAF
XBA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes DBB0 - DBB7
XBB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode DBB8
XBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode DBB9
XBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes DBC0 - DBC7
XBC0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DBC8 - DBCF
XBC8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DBD0 - DBD7
XBD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DBD8 - DBDF
XBD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DBE0 - DBE7
XBE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DBE8 - DBEF
XBE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes DBF0 - DBF7
XBF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DBF8
XBF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DBF9
XBF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode DBFA
XBFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DBFB
XBFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DBFC
XBFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DC00 - DC07
XC00:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DC08 - DC0F
XC08:
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DC10 - DC17
XC10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DC18 - DC1F
XC18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DC20 - DC27
XC20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes DC28 - DC2F
XC28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes DC30 - DC37
XC30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DC38
XC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DC39
XC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode DC3A
XC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DC3B
XC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DC3C
XC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DC40 - DC47
XC40:
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DC48 - DC4F
XC48:
add r14,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DC50 - DC57
XC50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DC58 - DC5F
XC58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DC60 - DC67
XC60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes DC68 - DC6F
XC68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes DC70 - DC77
XC70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DC78
XC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DC79
XC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode DC7A
XC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DC7B
XC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DC7C
XC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DC80 - DC87
XC80:
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DC88 - DC8F
XC88:
add r14,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DC90 - DC97
XC90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes DC98 - DC9F
XC98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes DCA0 - DCA7
XCA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes DCA8 - DCAF
XCA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes DCB0 - DCB7
XCB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode DCB8
XCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode DCB9
XCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode DCBA
XCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode DCBB
XCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode DCBC
XCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(24,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes DCC0 - DCC7
XCC0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DCC8 - DCCF
XCC8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DCD0 - DCD7
XCD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DCD8 - DCDF
XCD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DCE0 - DCE7
XCE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DCE8 - DCEF
XCE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DCF0 - DCF7
XCF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DCF8
XCF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode DCF9
XCF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DCFA
XCFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode DCFB
XCFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DCFC
XCFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DD00 - DD07
XD00:
mov r3,r4
mov #24,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #24,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes DD08 - DD0F
XD08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
add #-1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes DD10 - DD17
XD10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes DD18 - DD1F
XD18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes DD20 - DD27
XD20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes DD28 - DD2F
XD28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes DD30 - DD37
XD30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode DD38
XD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode DD39
XD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DD40 - DD47
XD40:
mov r3,r4
mov #24,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #24,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes DD48 - DD4F
XD48:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes DD50 - DD57
XD50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes DD58 - DD5F
XD58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes DD60 - DD67
XD60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes DD68 - DD6F
XD68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes DD70 - DD77
XD70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode DD78
XD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode DD79
XD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DD80 - DD87
XD80:
mov r3,r4
mov.l @(24,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(24,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes DD88 - DD8F
XD88:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes DD90 - DD97
XD90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DD98 - DD9F
XD98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes DDA0 - DDA7
XDA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes DDA8 - DDAF
XDA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes DDB0 - DDB7
XDB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode DDB8
XDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode DDB9
XDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes DDC0 - DDC7
XDC0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DDC8 - DDCF
XDC8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DDD0 - DDD7
XDD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DDD8 - DDDF
XDD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DDE0 - DDE7
XDE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DDE8 - DDEF
XDE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes DDF0 - DDF7
XDF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DDF8
XDF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DDF9
XDF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode DDFA
XDFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DDFB
XDFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DDFC
XDFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DE00 - DE07
XE00:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DE08 - DE0F
XE08:
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DE10 - DE17
XE10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DE18 - DE1F
XE18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DE20 - DE27
XE20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes DE28 - DE2F
XE28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes DE30 - DE37
XE30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DE38
XE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DE39
XE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode DE3A
XE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DE3B
XE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DE3C
XE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DE40 - DE47
XE40:
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DE48 - DE4F
XE48:
add r14,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-4,r7
! Opcodes DE50 - DE57
XE50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DE58 - DE5F
XE58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DE60 - DE67
XE60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-10,r7
! Opcodes DE68 - DE6F
XE68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcodes DE70 - DE77
XE70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DE78
XE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DE79
XE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcode DE7A
XE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-12,r7
! Opcode DE7B
XE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcode DE7C
XE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DE80 - DE87
XE80:
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DE88 - DE8F
XE88:
add r14,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-8,r7
! Opcodes DE90 - DE97
XE90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes DE98 - DE9F
XE98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-14,r7
! Opcodes DEA0 - DEA7
XEA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes DEA8 - DEAF
XEA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcodes DEB0 - DEB7
XEB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode DEB8
XEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode DEB9
XEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-22,r7
! Opcode DEBA
XEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-18,r7
! Opcode DEBB
XEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-20,r7
! Opcode DEBC
XEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
mov r1,r0
addv r3,r1
movt r8
addc r3,r0
movt r9
addc r8,r8
mov.l r1,@(28,r13)
mov r1,r3
jmp @r10
add #-16,r7
! Opcodes DEC0 - DEC7
XEC0:
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DEC8 - DECF
XEC8:
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DED0 - DED7
XED0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DED8 - DEDF
XED8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DEE0 - DEE7
XEE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DEE8 - DEEF
XEE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DEF0 - DEF7
XEF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DEF8
XEF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode DEF9
XEF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DEFA
XEFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcode DEFB
XEFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DEFC
XEFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-12,r7
! Opcodes DF00 - DF07
XF00:
mov r3,r4
mov #28,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov #28,r0
mov.b r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes DF08 - DF0F
XF08:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov #24,r0
shld r0,r3
shld r0,r1
shld r0,r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes DF10 - DF17
XF10:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes DF18 - DF1F
XF18:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
cmp/eq #28,r0
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes DF20 - DF27
XF20:
mov r2,r0
mov.l @(r0,r14),r4
mov r2,r0
cmp/eq #28,r0
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes DF28 - DF2F
XF28:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes DF30 - DF37
XF30:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode DF38
XF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode DF39
XF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DF40 - DF47
XF40:
mov r3,r4
mov #28,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov #28,r0
mov.w r3,@(r0,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-4,r7
! Opcodes DF48 - DF4F
XF48:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
shll16 r3
shll16 r1
shll16 r9
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-18,r7
! Opcodes DF50 - DF57
XF50:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-12,r7
! Opcodes DF58 - DF5F
XF58:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-12,r7
! Opcodes DF60 - DF67
XF60:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-14,r7
! Opcodes DF68 - DF6F
XF68:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcodes DF70 - DF77
XF70:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-18,r7
! Opcode DF78
XF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-16,r7
! Opcode DF79
XF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DF80 - DF87
XF80:
mov r3,r4
mov.l @(28,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l r3,@(28,r13)
tst r4,r4
movt r4
dt r4
shlr r4
or r4,r3
jmp @r10
add #-8,r7
! Opcodes DF88 - DF8F
XF88:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r1
mov r3,r0
addv r1,r0
movt r8
addv r9,r0
movt r0
or r0,r8
shll r8
addc r1,r3
movt r0
clrt
addc r9,r3
movt r9
or r0,r9
or r9,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
tst r2,r2
movt r2
dt r2
shlr r2
or r2,r3
jmp @r10
add #-30,r7
! Opcodes DF90 - DF97
XF90:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-20,r7
! Opcodes DF98 - DF9F
XF98:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-20,r7
! Opcodes DFA0 - DFA7
XFA0:
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
jmp @r10
add #-22,r7
! Opcodes DFA8 - DFAF
XFA8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcodes DFB0 - DFB7
XFB0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-26,r7
! Opcode DFB8
XFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-24,r7
! Opcode DFB9
XFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r3
movt r8
addc r1,r0
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
jmp @r10
add #-28,r7
! Opcodes DFC0 - DFC7
XFC0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DFC8 - DFCF
XFC8:
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-8,r7
! Opcodes DFD0 - DFD7
XFD0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DFD8 - DFDF
XFD8:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-14,r7
! Opcodes DFE0 - DFE7
XFE0:
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes DFE8 - DFEF
XFE8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcodes DFF0 - DFF7
XFF0:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DFF8
XFF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DFF9
XFF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-22,r7
! Opcode DFFA
XFFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-18,r7
! Opcode DFFB
XFFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r6,r1
jsr @r4
sub r5,r1
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-20,r7
! Opcode DFFC
XFFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
jmp @r10
add #-16,r7
! Opcodes E000 - E007
Y000:
add r13,r2
mov.b @r2,r3
mov #-7,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-22,r7
! Opcodes E008 - E00F
Y008:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-7,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-22,r7
! Opcodes E010 - E017
Y010:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #8,r0
extu.b r3,r3
ln995:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln995
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-22,r7
! Opcodes E018 - E01F
Y018:
add r13,r2
mov.b @r2,r3
clrt
mov #8,r0
extu.b r3,r3
ln997:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln997
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-22,r7
! Opcodes E020 - E027
Y020:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln998
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln998:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover999
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover999:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E028 - E02F
Y028:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1000
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1000:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1001
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1001:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E030 - E037
Y030:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1002
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1002:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln1003:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1003
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E038 - E03F
Y038:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1004
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1004:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln1005:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1005
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E040 - E047
Y040:
add r13,r2
mov.w @r2,r3
mov #-7,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-22,r7
! Opcodes E048 - E04F
Y048:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-7,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-22,r7
! Opcodes E050 - E057
Y050:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #8,r0
extu.w r3,r3
ln1011:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1011
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-22,r7
! Opcodes E058 - E05F
Y058:
add r13,r2
mov.w @r2,r3
clrt
mov #8,r0
extu.w r3,r3
ln1013:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1013
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-22,r7
! Opcodes E060 - E067
Y060:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1014
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1014:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1015
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1015:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E068 - E06F
Y068:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1016
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1016:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1017
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1017:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E070 - E077
Y070:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1018
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1018:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln1019:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1019
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E078 - E07F
Y078:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1020
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1020:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln1021:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1021
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E080 - E087
Y080:
add r13,r2
mov.l @r2,r3
mov #-7,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-24,r7
! Opcodes E088 - E08F
Y088:
add r13,r2
mov.l @r2,r3
mov #-7,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-24,r7
! Opcodes E090 - E097
Y090:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #8,r0
ln1027:
rotcr r3
movt r8
dt r0
bf/s ln1027
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-24,r7
! Opcodes E098 - E09F
Y098:
add r13,r2
mov.l @r2,r3
clrt
mov #8,r0
ln1029:
rotr r3
movt r8
dt r0
bf ln1029
mov.l r3,@r2
jmp @r10
add #-24,r7
! Opcodes E0A0 - E0A7
Y0A0:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1030
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1030:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1031
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1031:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E0A8 - E0AF
Y0A8:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1032
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1032:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1033
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1033:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E0B0 - E0B7
Y0B0:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1034
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1034:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1035:
rotcr r3
movt r8
dt r0
bf/s ln1035
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E0B8 - E0BF
Y0B8:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1036
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1036:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1037:
rotr r3
movt r8
dt r0
bf ln1037
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E0D0 - E0D7
Y0D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shar r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E0D8 - E0DF
Y0D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shar r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E0E0 - E0E7
Y0E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shar r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-14,r7
! Opcodes E0E8 - E0EF
Y0E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shar r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcodes E0F0 - E0F7
Y0F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shar r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-18,r7
! Opcode E0F8
Y0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shar r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcode E0F9
Y0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shar r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-20,r7
! Opcodes E100 - E107
Y100:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-22,r7
! Opcodes E108 - E10F
Y108:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #7,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-22,r7
! Opcodes E110 - E117
Y110:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #8,r0
ln1043:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1043
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-22,r7
! Opcodes E118 - E11F
Y118:
add r13,r2
mov.b @r2,r3
clrt
mov #8,r0
ln1045:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1045
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-22,r7
! Opcodes E120 - E127
Y120:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1046
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1046:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln1047:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1047
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E128 - E12F
Y128:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1048
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1048:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1049
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1049:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E130 - E137
Y130:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1050
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1050:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln1051:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1051
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E138 - E13F
Y138:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1052
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1052:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln1053:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1053
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E140 - E147
Y140:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-22,r7
! Opcodes E148 - E14F
Y148:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #7,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-22,r7
! Opcodes E150 - E157
Y150:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #8,r0
ln1059:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1059
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-22,r7
! Opcodes E158 - E15F
Y158:
add r13,r2
mov.w @r2,r3
clrt
mov #8,r0
ln1061:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1061
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-22,r7
! Opcodes E160 - E167
Y160:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1062
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1062:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln1063:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1063
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E168 - E16F
Y168:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1064
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1064:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1065
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1065:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E170 - E177
Y170:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1066
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1066:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln1067:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1067
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E178 - E17F
Y178:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1068
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1068:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln1069:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1069
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E180 - E187
Y180:
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-24,r7
! Opcodes E188 - E18F
Y188:
add r13,r2
mov.l @r2,r3
mov #7,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-24,r7
! Opcodes E190 - E197
Y190:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #8,r0
ln1075:
rotcl r3
movt r8
dt r0
bf/s ln1075
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-24,r7
! Opcodes E198 - E19F
Y198:
add r13,r2
mov.l @r2,r3
clrt
mov #8,r0
ln1077:
rotl r3
movt r8
dt r0
bf ln1077
mov.l r3,@r2
jmp @r10
add #-24,r7
! Opcodes E1A0 - E1A7
Y1A0:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1078
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1078:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln1079:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1079
cmp/pl r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E1A8 - E1AF
Y1A8:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1080
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1080:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1081
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1081:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E1B0 - E1B7
Y1B0:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1082
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1082:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1083:
rotcl r3
movt r8
dt r0
bf/s ln1083
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E1B8 - E1BF
Y1B8:
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln1084
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1084:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1085:
rotl r3
movt r8
dt r0
bf ln1085
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E1D0 - E1D7
Y1D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
jmp @r10
add #-12,r7
! Opcodes E1D8 - E1DF
Y1D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
jmp @r10
add #-12,r7
! Opcodes E1E0 - E1E7
Y1E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
jmp @r10
add #-14,r7
! Opcodes E1E8 - E1EF
Y1E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
jmp @r10
add #-16,r7
! Opcodes E1F0 - E1F7
Y1F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
jmp @r10
add #-18,r7
! Opcode E1F8
Y1F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
jmp @r10
add #-16,r7
! Opcode E1F9
Y1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
jmp @r10
add #-20,r7
! Opcodes E200 - E207
Y200:
add r13,r2
mov.b @r2,r3
mov #0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes E208 - E20F
Y208:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes E210 - E217
Y210:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #1,r0
extu.b r3,r3
ln1091:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1091
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes E218 - E21F
Y218:
add r13,r2
mov.b @r2,r3
clrt
mov #1,r0
extu.b r3,r3
ln1093:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1093
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes E220 - E227
Y220:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1094
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1094:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1095
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1095:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E228 - E22F
Y228:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1096
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1096:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1097
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1097:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E230 - E237
Y230:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1098
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1098:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln1099:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1099
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E238 - E23F
Y238:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1100
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1100:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln1101:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1101
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E240 - E247
Y240:
add r13,r2
mov.w @r2,r3
mov #0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes E248 - E24F
Y248:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes E250 - E257
Y250:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #1,r0
extu.w r3,r3
ln1107:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1107
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes E258 - E25F
Y258:
add r13,r2
mov.w @r2,r3
clrt
mov #1,r0
extu.w r3,r3
ln1109:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1109
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes E260 - E267
Y260:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1110
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1110:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1111
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1111:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E268 - E26F
Y268:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1112
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1112:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1113
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1113:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E270 - E277
Y270:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1114
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1114:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln1115:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1115
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E278 - E27F
Y278:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1116
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1116:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln1117:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1117
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E280 - E287
Y280:
add r13,r2
mov.l @r2,r3
mov #0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-10,r7
! Opcodes E288 - E28F
Y288:
add r13,r2
mov.l @r2,r3
mov #0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-10,r7
! Opcodes E290 - E297
Y290:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #1,r0
ln1123:
rotcr r3
movt r8
dt r0
bf/s ln1123
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-10,r7
! Opcodes E298 - E29F
Y298:
add r13,r2
mov.l @r2,r3
clrt
mov #1,r0
ln1125:
rotr r3
movt r8
dt r0
bf ln1125
mov.l r3,@r2
jmp @r10
add #-10,r7
! Opcodes E2A0 - E2A7
Y2A0:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1126
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1126:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1127
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1127:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E2A8 - E2AF
Y2A8:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1128
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1128:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1129
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1129:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E2B0 - E2B7
Y2B0:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1130
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1130:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1131:
rotcr r3
movt r8
dt r0
bf/s ln1131
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E2B8 - E2BF
Y2B8:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1132
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1132:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1133:
rotr r3
movt r8
dt r0
bf ln1133
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E2D0 - E2D7
Y2D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E2D8 - E2DF
Y2D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E2E0 - E2E7
Y2E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-14,r7
! Opcodes E2E8 - E2EF
Y2E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcodes E2F0 - E2F7
Y2F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-18,r7
! Opcode E2F8
Y2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcode E2F9
Y2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-20,r7
! Opcodes E300 - E307
Y300:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
addv r3,r3
movt r8
shal r1
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes E308 - E30F
Y308:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes E310 - E317
Y310:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #1,r0
ln1139:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1139
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes E318 - E31F
Y318:
add r13,r2
mov.b @r2,r3
clrt
mov #1,r0
ln1141:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1141
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-8,r7
! Opcodes E320 - E327
Y320:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1142
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1142:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln1143:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1143
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E328 - E32F
Y328:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1144
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1144:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1145
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1145:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E330 - E337
Y330:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1146
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1146:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln1147:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1147
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E338 - E33F
Y338:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1148
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1148:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln1149:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1149
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E340 - E347
Y340:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
addv r3,r3
movt r8
shal r1
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes E348 - E34F
Y348:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes E350 - E357
Y350:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #1,r0
ln1155:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1155
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes E358 - E35F
Y358:
add r13,r2
mov.w @r2,r3
clrt
mov #1,r0
ln1157:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1157
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-8,r7
! Opcodes E360 - E367
Y360:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1158
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1158:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln1159:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1159
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E368 - E36F
Y368:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1160
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1160:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1161
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1161:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E370 - E377
Y370:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1162
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1162:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln1163:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1163
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E378 - E37F
Y378:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1164
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1164:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln1165:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1165
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E380 - E387
Y380:
add r13,r2
mov.l @r2,r3
mov r3,r1
addv r3,r3
movt r8
shal r1
movt r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-10,r7
! Opcodes E388 - E38F
Y388:
add r13,r2
mov.l @r2,r3
mov #0,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-10,r7
! Opcodes E390 - E397
Y390:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #1,r0
ln1171:
rotcl r3
movt r8
dt r0
bf/s ln1171
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-10,r7
! Opcodes E398 - E39F
Y398:
add r13,r2
mov.l @r2,r3
clrt
mov #1,r0
ln1173:
rotl r3
movt r8
dt r0
bf ln1173
mov.l r3,@r2
jmp @r10
add #-10,r7
! Opcodes E3A0 - E3A7
Y3A0:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1174
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1174:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln1175:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1175
cmp/pl r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E3A8 - E3AF
Y3A8:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1176
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1176:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1177
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1177:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E3B0 - E3B7
Y3B0:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1178
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1178:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1179:
rotcl r3
movt r8
dt r0
bf/s ln1179
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E3B8 - E3BF
Y3B8:
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1180
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1180:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1181:
rotl r3
movt r8
dt r0
bf ln1181
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E3D0 - E3D7
Y3D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E3D8 - E3DF
Y3D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E3E0 - E3E7
Y3E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-14,r7
! Opcodes E3E8 - E3EF
Y3E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcodes E3F0 - E3F7
Y3F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-18,r7
! Opcode E3F8
Y3F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcode E3F9
Y3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-20,r7
! Opcodes E400 - E407
Y400:
add r13,r2
mov.b @r2,r3
mov #-1,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-10,r7
! Opcodes E408 - E40F
Y408:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-1,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-10,r7
! Opcodes E410 - E417
Y410:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #2,r0
extu.b r3,r3
ln1187:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1187
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-10,r7
! Opcodes E418 - E41F
Y418:
add r13,r2
mov.b @r2,r3
clrt
mov #2,r0
extu.b r3,r3
ln1189:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1189
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-10,r7
! Opcodes E420 - E427
Y420:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1190
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1190:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1191
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1191:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E428 - E42F
Y428:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1192
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1192:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1193
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1193:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E430 - E437
Y430:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1194
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1194:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln1195:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1195
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E438 - E43F
Y438:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1196
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1196:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln1197:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1197
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E440 - E447
Y440:
add r13,r2
mov.w @r2,r3
mov #-1,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-10,r7
! Opcodes E448 - E44F
Y448:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-1,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-10,r7
! Opcodes E450 - E457
Y450:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #2,r0
extu.w r3,r3
ln1203:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1203
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-10,r7
! Opcodes E458 - E45F
Y458:
add r13,r2
mov.w @r2,r3
clrt
mov #2,r0
extu.w r3,r3
ln1205:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1205
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-10,r7
! Opcodes E460 - E467
Y460:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1206
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1206:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1207
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1207:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E468 - E46F
Y468:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1208
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1208:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1209
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1209:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E470 - E477
Y470:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1210
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1210:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln1211:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1211
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E478 - E47F
Y478:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1212
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1212:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln1213:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1213
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E480 - E487
Y480:
add r13,r2
mov.l @r2,r3
mov #-1,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-12,r7
! Opcodes E488 - E48F
Y488:
add r13,r2
mov.l @r2,r3
mov #-1,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-12,r7
! Opcodes E490 - E497
Y490:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #2,r0
ln1219:
rotcr r3
movt r8
dt r0
bf/s ln1219
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-12,r7
! Opcodes E498 - E49F
Y498:
add r13,r2
mov.l @r2,r3
clrt
mov #2,r0
ln1221:
rotr r3
movt r8
dt r0
bf ln1221
mov.l r3,@r2
jmp @r10
add #-12,r7
! Opcodes E4A0 - E4A7
Y4A0:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1222
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1222:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1223
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1223:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E4A8 - E4AF
Y4A8:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1224
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1224:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1225
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1225:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E4B0 - E4B7
Y4B0:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1226
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1226:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1227:
rotcr r3
movt r8
dt r0
bf/s ln1227
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E4B8 - E4BF
Y4B8:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1228
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1228:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1229:
rotr r3
movt r8
dt r0
bf ln1229
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E4D0 - E4D7
Y4D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E4D8 - E4DF
Y4D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E4E0 - E4E7
Y4E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-14,r7
! Opcodes E4E8 - E4EF
Y4E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcodes E4F0 - E4F7
Y4F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-18,r7
! Opcode E4F8
Y4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcode E4F9
Y4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-20,r7
! Opcodes E500 - E507
Y500:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-10,r7
! Opcodes E508 - E50F
Y508:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #1,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-10,r7
! Opcodes E510 - E517
Y510:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #2,r0
ln1235:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1235
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-10,r7
! Opcodes E518 - E51F
Y518:
add r13,r2
mov.b @r2,r3
clrt
mov #2,r0
ln1237:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1237
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-10,r7
! Opcodes E520 - E527
Y520:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1238
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1238:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln1239:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1239
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E528 - E52F
Y528:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1240
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1240:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1241
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1241:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E530 - E537
Y530:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1242
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1242:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln1243:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1243
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E538 - E53F
Y538:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1244
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1244:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln1245:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1245
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E540 - E547
Y540:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-10,r7
! Opcodes E548 - E54F
Y548:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #1,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-10,r7
! Opcodes E550 - E557
Y550:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #2,r0
ln1251:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1251
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-10,r7
! Opcodes E558 - E55F
Y558:
add r13,r2
mov.w @r2,r3
clrt
mov #2,r0
ln1253:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1253
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-10,r7
! Opcodes E560 - E567
Y560:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1254
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1254:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln1255:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1255
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E568 - E56F
Y568:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1256
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1256:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1257
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1257:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E570 - E577
Y570:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1258
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1258:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln1259:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1259
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E578 - E57F
Y578:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1260
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1260:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln1261:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1261
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E580 - E587
Y580:
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-12,r7
! Opcodes E588 - E58F
Y588:
add r13,r2
mov.l @r2,r3
mov #1,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-12,r7
! Opcodes E590 - E597
Y590:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #2,r0
ln1267:
rotcl r3
movt r8
dt r0
bf/s ln1267
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-12,r7
! Opcodes E598 - E59F
Y598:
add r13,r2
mov.l @r2,r3
clrt
mov #2,r0
ln1269:
rotl r3
movt r8
dt r0
bf ln1269
mov.l r3,@r2
jmp @r10
add #-12,r7
! Opcodes E5A0 - E5A7
Y5A0:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1270
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1270:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln1271:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1271
cmp/pl r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E5A8 - E5AF
Y5A8:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1272
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1272:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1273
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1273:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E5B0 - E5B7
Y5B0:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1274
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1274:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1275:
rotcl r3
movt r8
dt r0
bf/s ln1275
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E5B8 - E5BF
Y5B8:
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1276
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1276:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1277:
rotl r3
movt r8
dt r0
bf ln1277
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E5D0 - E5D7
Y5D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E5D8 - E5DF
Y5D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E5E0 - E5E7
Y5E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-14,r7
! Opcodes E5E8 - E5EF
Y5E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcodes E5F0 - E5F7
Y5F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-18,r7
! Opcode E5F8
Y5F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcode E5F9
Y5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
mov r8,r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-20,r7
! Opcodes E600 - E607
Y600:
add r13,r2
mov.b @r2,r3
mov #-2,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-12,r7
! Opcodes E608 - E60F
Y608:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-2,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-12,r7
! Opcodes E610 - E617
Y610:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #3,r0
extu.b r3,r3
ln1283:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1283
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-12,r7
! Opcodes E618 - E61F
Y618:
add r13,r2
mov.b @r2,r3
clrt
mov #3,r0
extu.b r3,r3
ln1285:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1285
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-12,r7
! Opcodes E620 - E627
Y620:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1286
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1286:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1287
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1287:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E628 - E62F
Y628:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1288
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1288:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1289
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1289:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E630 - E637
Y630:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1290
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1290:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln1291:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1291
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E638 - E63F
Y638:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1292
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1292:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln1293:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1293
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E640 - E647
Y640:
add r13,r2
mov.w @r2,r3
mov #-2,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-12,r7
! Opcodes E648 - E64F
Y648:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-2,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-12,r7
! Opcodes E650 - E657
Y650:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #3,r0
extu.w r3,r3
ln1299:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1299
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-12,r7
! Opcodes E658 - E65F
Y658:
add r13,r2
mov.w @r2,r3
clrt
mov #3,r0
extu.w r3,r3
ln1301:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1301
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-12,r7
! Opcodes E660 - E667
Y660:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1302
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1302:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1303
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1303:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E668 - E66F
Y668:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1304
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1304:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1305
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1305:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E670 - E677
Y670:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1306
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1306:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln1307:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1307
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E678 - E67F
Y678:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1308
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1308:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln1309:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1309
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E680 - E687
Y680:
add r13,r2
mov.l @r2,r3
mov #-2,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-14,r7
! Opcodes E688 - E68F
Y688:
add r13,r2
mov.l @r2,r3
mov #-2,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-14,r7
! Opcodes E690 - E697
Y690:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #3,r0
ln1315:
rotcr r3
movt r8
dt r0
bf/s ln1315
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-14,r7
! Opcodes E698 - E69F
Y698:
add r13,r2
mov.l @r2,r3
clrt
mov #3,r0
ln1317:
rotr r3
movt r8
dt r0
bf ln1317
mov.l r3,@r2
jmp @r10
add #-14,r7
! Opcodes E6A0 - E6A7
Y6A0:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1318
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1318:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1319
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1319:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E6A8 - E6AF
Y6A8:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1320
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1320:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1321
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1321:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E6B0 - E6B7
Y6B0:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1322
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1322:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1323:
rotcr r3
movt r8
dt r0
bf/s ln1323
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E6B8 - E6BF
Y6B8:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1324
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1324:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1325:
rotr r3
movt r8
dt r0
bf ln1325
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E6D0 - E6D7
Y6D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E6D8 - E6DF
Y6D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E6E0 - E6E7
Y6E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-14,r7
! Opcodes E6E8 - E6EF
Y6E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcodes E6F0 - E6F7
Y6F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-18,r7
! Opcode E6F8
Y6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcode E6F9
Y6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-20,r7
! Opcodes E700 - E707
Y700:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-12,r7
! Opcodes E708 - E70F
Y708:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #2,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-12,r7
! Opcodes E710 - E717
Y710:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #3,r0
ln1331:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1331
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-12,r7
! Opcodes E718 - E71F
Y718:
add r13,r2
mov.b @r2,r3
clrt
mov #3,r0
ln1333:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1333
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-12,r7
! Opcodes E720 - E727
Y720:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1334
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1334:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln1335:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1335
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E728 - E72F
Y728:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1336
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1336:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1337
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1337:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E730 - E737
Y730:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1338
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1338:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln1339:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1339
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E738 - E73F
Y738:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1340
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1340:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln1341:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1341
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E740 - E747
Y740:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-12,r7
! Opcodes E748 - E74F
Y748:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #2,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-12,r7
! Opcodes E750 - E757
Y750:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #3,r0
ln1347:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1347
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-12,r7
! Opcodes E758 - E75F
Y758:
add r13,r2
mov.w @r2,r3
clrt
mov #3,r0
ln1349:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1349
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-12,r7
! Opcodes E760 - E767
Y760:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1350
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1350:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln1351:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1351
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E768 - E76F
Y768:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1352
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1352:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1353
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1353:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E770 - E777
Y770:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1354
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1354:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln1355:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1355
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E778 - E77F
Y778:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1356
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1356:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln1357:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1357
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E780 - E787
Y780:
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-14,r7
! Opcodes E788 - E78F
Y788:
add r13,r2
mov.l @r2,r3
mov #2,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-14,r7
! Opcodes E790 - E797
Y790:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #3,r0
ln1363:
rotcl r3
movt r8
dt r0
bf/s ln1363
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-14,r7
! Opcodes E798 - E79F
Y798:
add r13,r2
mov.l @r2,r3
clrt
mov #3,r0
ln1365:
rotl r3
movt r8
dt r0
bf ln1365
mov.l r3,@r2
jmp @r10
add #-14,r7
! Opcodes E7A0 - E7A7
Y7A0:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1366
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1366:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln1367:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1367
cmp/pl r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E7A8 - E7AF
Y7A8:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1368
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1368:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1369
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1369:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E7B0 - E7B7
Y7B0:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1370
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1370:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1371:
rotcl r3
movt r8
dt r0
bf/s ln1371
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E7B8 - E7BF
Y7B8:
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1372
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1372:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1373:
rotl r3
movt r8
dt r0
bf ln1373
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E7D0 - E7D7
Y7D0:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E7D8 - E7DF
Y7D8:
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-12,r7
! Opcodes E7E0 - E7E7
Y7E0:
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
jmp @r10
add #-14,r7
! Opcodes E7E8 - E7EF
Y7E8:
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcodes E7F0 - E7F7
Y7F0:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
mov r2,r0
jsr @r4
mov.l @(r0,r14),r1
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-18,r7
! Opcode E7F8
Y7F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-16,r7
! Opcode E7F9
Y7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
jmp @r10
add #-20,r7
! Opcodes E800 - E807
Y800:
add r13,r2
mov.b @r2,r3
mov #-3,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-14,r7
! Opcodes E808 - E80F
Y808:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-3,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-14,r7
! Opcodes E810 - E817
Y810:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #4,r0
extu.b r3,r3
ln1379:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1379
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-14,r7
! Opcodes E818 - E81F
Y818:
add r13,r2
mov.b @r2,r3
clrt
mov #4,r0
extu.b r3,r3
ln1381:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1381
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-14,r7
! Opcodes E820 - E827
Y820:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1382
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1382:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1383
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1383:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E828 - E82F
Y828:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1384
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1384:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1385
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1385:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E830 - E837
Y830:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1386
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1386:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln1387:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1387
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E838 - E83F
Y838:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1388
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1388:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln1389:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1389
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E840 - E847
Y840:
add r13,r2
mov.w @r2,r3
mov #-3,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-14,r7
! Opcodes E848 - E84F
Y848:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-3,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-14,r7
! Opcodes E850 - E857
Y850:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #4,r0
extu.w r3,r3
ln1395:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1395
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-14,r7
! Opcodes E858 - E85F
Y858:
add r13,r2
mov.w @r2,r3
clrt
mov #4,r0
extu.w r3,r3
ln1397:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1397
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-14,r7
! Opcodes E860 - E867
Y860:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1398
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1398:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1399
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1399:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E868 - E86F
Y868:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1400
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1400:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1401
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1401:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E870 - E877
Y870:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1402
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1402:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln1403:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1403
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E878 - E87F
Y878:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1404
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1404:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln1405:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1405
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E880 - E887
Y880:
add r13,r2
mov.l @r2,r3
mov #-3,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes E888 - E88F
Y888:
add r13,r2
mov.l @r2,r3
mov #-3,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes E890 - E897
Y890:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #4,r0
ln1411:
rotcr r3
movt r8
dt r0
bf/s ln1411
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes E898 - E89F
Y898:
add r13,r2
mov.l @r2,r3
clrt
mov #4,r0
ln1413:
rotr r3
movt r8
dt r0
bf ln1413
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes E8A0 - E8A7
Y8A0:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1414
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1414:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1415
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1415:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E8A8 - E8AF
Y8A8:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1416
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1416:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1417
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1417:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E8B0 - E8B7
Y8B0:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1418
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1418:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1419:
rotcr r3
movt r8
dt r0
bf/s ln1419
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E8B8 - E8BF
Y8B8:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1420
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1420:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1421:
rotr r3
movt r8
dt r0
bf ln1421
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E900 - E907
Y900:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-14,r7
! Opcodes E908 - E90F
Y908:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #3,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-14,r7
! Opcodes E910 - E917
Y910:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #4,r0
ln1427:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1427
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-14,r7
! Opcodes E918 - E91F
Y918:
add r13,r2
mov.b @r2,r3
clrt
mov #4,r0
ln1429:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1429
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-14,r7
! Opcodes E920 - E927
Y920:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1430
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1430:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln1431:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1431
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E928 - E92F
Y928:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1432
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1432:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1433
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1433:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E930 - E937
Y930:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1434
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1434:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln1435:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1435
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E938 - E93F
Y938:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1436
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1436:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln1437:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1437
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes E940 - E947
Y940:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-14,r7
! Opcodes E948 - E94F
Y948:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #3,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-14,r7
! Opcodes E950 - E957
Y950:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #4,r0
ln1443:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1443
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-14,r7
! Opcodes E958 - E95F
Y958:
add r13,r2
mov.w @r2,r3
clrt
mov #4,r0
ln1445:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1445
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-14,r7
! Opcodes E960 - E967
Y960:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1446
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1446:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln1447:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1447
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E968 - E96F
Y968:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1448
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1448:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1449
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1449:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E970 - E977
Y970:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1450
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1450:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln1451:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1451
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E978 - E97F
Y978:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1452
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1452:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln1453:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1453
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes E980 - E987
Y980:
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes E988 - E98F
Y988:
add r13,r2
mov.l @r2,r3
mov #3,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes E990 - E997
Y990:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #4,r0
ln1459:
rotcl r3
movt r8
dt r0
bf/s ln1459
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes E998 - E99F
Y998:
add r13,r2
mov.l @r2,r3
clrt
mov #4,r0
ln1461:
rotl r3
movt r8
dt r0
bf ln1461
mov.l r3,@r2
jmp @r10
add #-16,r7
! Opcodes E9A0 - E9A7
Y9A0:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1462
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1462:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln1463:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1463
cmp/pl r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E9A8 - E9AF
Y9A8:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1464
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1464:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1465
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1465:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E9B0 - E9B7
Y9B0:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1466
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1466:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1467:
rotcl r3
movt r8
dt r0
bf/s ln1467
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes E9B8 - E9BF
Y9B8:
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1468
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1468:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1469:
rotl r3
movt r8
dt r0
bf ln1469
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EA00 - EA07
YA00:
add r13,r2
mov.b @r2,r3
mov #-4,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-16,r7
! Opcodes EA08 - EA0F
YA08:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-4,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-16,r7
! Opcodes EA10 - EA17
YA10:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #5,r0
extu.b r3,r3
ln1475:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1475
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-16,r7
! Opcodes EA18 - EA1F
YA18:
add r13,r2
mov.b @r2,r3
clrt
mov #5,r0
extu.b r3,r3
ln1477:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1477
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-16,r7
! Opcodes EA20 - EA27
YA20:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1478
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1478:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1479
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1479:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EA28 - EA2F
YA28:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1480
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1480:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1481
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1481:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EA30 - EA37
YA30:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1482
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1482:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln1483:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1483
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EA38 - EA3F
YA38:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1484
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1484:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln1485:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1485
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EA40 - EA47
YA40:
add r13,r2
mov.w @r2,r3
mov #-4,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-16,r7
! Opcodes EA48 - EA4F
YA48:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-4,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-16,r7
! Opcodes EA50 - EA57
YA50:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #5,r0
extu.w r3,r3
ln1491:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1491
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-16,r7
! Opcodes EA58 - EA5F
YA58:
add r13,r2
mov.w @r2,r3
clrt
mov #5,r0
extu.w r3,r3
ln1493:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1493
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-16,r7
! Opcodes EA60 - EA67
YA60:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1494
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1494:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1495
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1495:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EA68 - EA6F
YA68:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1496
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1496:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1497
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1497:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EA70 - EA77
YA70:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1498
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1498:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln1499:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1499
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EA78 - EA7F
YA78:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1500
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1500:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln1501:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1501
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EA80 - EA87
YA80:
add r13,r2
mov.l @r2,r3
mov #-4,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-18,r7
! Opcodes EA88 - EA8F
YA88:
add r13,r2
mov.l @r2,r3
mov #-4,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-18,r7
! Opcodes EA90 - EA97
YA90:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #5,r0
ln1507:
rotcr r3
movt r8
dt r0
bf/s ln1507
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-18,r7
! Opcodes EA98 - EA9F
YA98:
add r13,r2
mov.l @r2,r3
clrt
mov #5,r0
ln1509:
rotr r3
movt r8
dt r0
bf ln1509
mov.l r3,@r2
jmp @r10
add #-18,r7
! Opcodes EAA0 - EAA7
YAA0:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1510
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1510:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1511
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1511:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EAA8 - EAAF
YAA8:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1512
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1512:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1513
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1513:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EAB0 - EAB7
YAB0:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1514
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1514:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1515:
rotcr r3
movt r8
dt r0
bf/s ln1515
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EAB8 - EABF
YAB8:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1516
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1516:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1517:
rotr r3
movt r8
dt r0
bf ln1517
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EB00 - EB07
YB00:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-16,r7
! Opcodes EB08 - EB0F
YB08:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #4,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-16,r7
! Opcodes EB10 - EB17
YB10:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #5,r0
ln1523:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1523
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-16,r7
! Opcodes EB18 - EB1F
YB18:
add r13,r2
mov.b @r2,r3
clrt
mov #5,r0
ln1525:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1525
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-16,r7
! Opcodes EB20 - EB27
YB20:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1526
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1526:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln1527:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1527
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EB28 - EB2F
YB28:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1528
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1528:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1529
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1529:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EB30 - EB37
YB30:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1530
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1530:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln1531:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1531
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EB38 - EB3F
YB38:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1532
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1532:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln1533:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1533
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EB40 - EB47
YB40:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-16,r7
! Opcodes EB48 - EB4F
YB48:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #4,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-16,r7
! Opcodes EB50 - EB57
YB50:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #5,r0
ln1539:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1539
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-16,r7
! Opcodes EB58 - EB5F
YB58:
add r13,r2
mov.w @r2,r3
clrt
mov #5,r0
ln1541:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1541
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-16,r7
! Opcodes EB60 - EB67
YB60:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1542
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1542:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln1543:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1543
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EB68 - EB6F
YB68:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1544
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1544:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1545
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1545:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EB70 - EB77
YB70:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1546
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1546:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln1547:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1547
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EB78 - EB7F
YB78:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1548
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1548:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln1549:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1549
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EB80 - EB87
YB80:
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-18,r7
! Opcodes EB88 - EB8F
YB88:
add r13,r2
mov.l @r2,r3
mov #4,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-18,r7
! Opcodes EB90 - EB97
YB90:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #5,r0
ln1555:
rotcl r3
movt r8
dt r0
bf/s ln1555
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-18,r7
! Opcodes EB98 - EB9F
YB98:
add r13,r2
mov.l @r2,r3
clrt
mov #5,r0
ln1557:
rotl r3
movt r8
dt r0
bf ln1557
mov.l r3,@r2
jmp @r10
add #-18,r7
! Opcodes EBA0 - EBA7
YBA0:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1558
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1558:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln1559:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1559
cmp/pl r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EBA8 - EBAF
YBA8:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1560
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1560:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1561
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1561:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EBB0 - EBB7
YBB0:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1562
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1562:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1563:
rotcl r3
movt r8
dt r0
bf/s ln1563
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EBB8 - EBBF
YBB8:
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1564
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1564:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1565:
rotl r3
movt r8
dt r0
bf ln1565
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EC00 - EC07
YC00:
add r13,r2
mov.b @r2,r3
mov #-5,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-18,r7
! Opcodes EC08 - EC0F
YC08:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-5,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-18,r7
! Opcodes EC10 - EC17
YC10:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #6,r0
extu.b r3,r3
ln1571:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1571
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-18,r7
! Opcodes EC18 - EC1F
YC18:
add r13,r2
mov.b @r2,r3
clrt
mov #6,r0
extu.b r3,r3
ln1573:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1573
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-18,r7
! Opcodes EC20 - EC27
YC20:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1574
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1574:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1575
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1575:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EC28 - EC2F
YC28:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1576
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1576:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1577
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1577:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EC30 - EC37
YC30:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1578
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1578:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln1579:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1579
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EC38 - EC3F
YC38:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1580
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1580:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln1581:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1581
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EC40 - EC47
YC40:
add r13,r2
mov.w @r2,r3
mov #-5,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-18,r7
! Opcodes EC48 - EC4F
YC48:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-5,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-18,r7
! Opcodes EC50 - EC57
YC50:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #6,r0
extu.w r3,r3
ln1587:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1587
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-18,r7
! Opcodes EC58 - EC5F
YC58:
add r13,r2
mov.w @r2,r3
clrt
mov #6,r0
extu.w r3,r3
ln1589:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1589
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-18,r7
! Opcodes EC60 - EC67
YC60:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1590
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1590:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1591
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1591:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EC68 - EC6F
YC68:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1592
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1592:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1593
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1593:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EC70 - EC77
YC70:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1594
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1594:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln1595:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1595
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EC78 - EC7F
YC78:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1596
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1596:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln1597:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1597
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EC80 - EC87
YC80:
add r13,r2
mov.l @r2,r3
mov #-5,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-20,r7
! Opcodes EC88 - EC8F
YC88:
add r13,r2
mov.l @r2,r3
mov #-5,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-20,r7
! Opcodes EC90 - EC97
YC90:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #6,r0
ln1603:
rotcr r3
movt r8
dt r0
bf/s ln1603
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-20,r7
! Opcodes EC98 - EC9F
YC98:
add r13,r2
mov.l @r2,r3
clrt
mov #6,r0
ln1605:
rotr r3
movt r8
dt r0
bf ln1605
mov.l r3,@r2
jmp @r10
add #-20,r7
! Opcodes ECA0 - ECA7
YCA0:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1606
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1606:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1607
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1607:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes ECA8 - ECAF
YCA8:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1608
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1608:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1609
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1609:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes ECB0 - ECB7
YCB0:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1610
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1610:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1611:
rotcr r3
movt r8
dt r0
bf/s ln1611
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes ECB8 - ECBF
YCB8:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1612
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1612:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1613:
rotr r3
movt r8
dt r0
bf ln1613
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes ED00 - ED07
YD00:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-18,r7
! Opcodes ED08 - ED0F
YD08:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #5,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-18,r7
! Opcodes ED10 - ED17
YD10:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #6,r0
ln1619:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1619
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-18,r7
! Opcodes ED18 - ED1F
YD18:
add r13,r2
mov.b @r2,r3
clrt
mov #6,r0
ln1621:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1621
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-18,r7
! Opcodes ED20 - ED27
YD20:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1622
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1622:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln1623:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1623
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes ED28 - ED2F
YD28:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1624
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1624:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1625
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1625:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes ED30 - ED37
YD30:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1626
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1626:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln1627:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1627
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes ED38 - ED3F
YD38:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1628
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1628:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln1629:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1629
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes ED40 - ED47
YD40:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-18,r7
! Opcodes ED48 - ED4F
YD48:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #5,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-18,r7
! Opcodes ED50 - ED57
YD50:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #6,r0
ln1635:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1635
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-18,r7
! Opcodes ED58 - ED5F
YD58:
add r13,r2
mov.w @r2,r3
clrt
mov #6,r0
ln1637:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1637
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-18,r7
! Opcodes ED60 - ED67
YD60:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1638
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1638:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln1639:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1639
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes ED68 - ED6F
YD68:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1640
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1640:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1641
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1641:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes ED70 - ED77
YD70:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1642
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1642:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln1643:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1643
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes ED78 - ED7F
YD78:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1644
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1644:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln1645:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1645
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes ED80 - ED87
YD80:
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-20,r7
! Opcodes ED88 - ED8F
YD88:
add r13,r2
mov.l @r2,r3
mov #5,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-20,r7
! Opcodes ED90 - ED97
YD90:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #6,r0
ln1651:
rotcl r3
movt r8
dt r0
bf/s ln1651
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-20,r7
! Opcodes ED98 - ED9F
YD98:
add r13,r2
mov.l @r2,r3
clrt
mov #6,r0
ln1653:
rotl r3
movt r8
dt r0
bf ln1653
mov.l r3,@r2
jmp @r10
add #-20,r7
! Opcodes EDA0 - EDA7
YDA0:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1654
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1654:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln1655:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1655
cmp/pl r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EDA8 - EDAF
YDA8:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1656
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1656:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1657
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1657:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EDB0 - EDB7
YDB0:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1658
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1658:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1659:
rotcl r3
movt r8
dt r0
bf/s ln1659
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EDB8 - EDBF
YDB8:
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1660
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1660:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1661:
rotl r3
movt r8
dt r0
bf ln1661
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EE00 - EE07
YE00:
add r13,r2
mov.b @r2,r3
mov #-6,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-20,r7
! Opcodes EE08 - EE0F
YE08:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-6,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-20,r7
! Opcodes EE10 - EE17
YE10:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #7,r0
extu.b r3,r3
ln1667:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1667
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-20,r7
! Opcodes EE18 - EE1F
YE18:
add r13,r2
mov.b @r2,r3
clrt
mov #7,r0
extu.b r3,r3
ln1669:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1669
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-20,r7
! Opcodes EE20 - EE27
YE20:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1670
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1670:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1671
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1671:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EE28 - EE2F
YE28:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1672
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1672:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1673
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1673:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EE30 - EE37
YE30:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1674
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1674:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln1675:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf/s ln1675
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EE38 - EE3F
YE38:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1676
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1676:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln1677:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
extu.b r3,r3
bf ln1677
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EE40 - EE47
YE40:
add r13,r2
mov.w @r2,r3
mov #-6,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-20,r7
! Opcodes EE48 - EE4F
YE48:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-6,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-20,r7
! Opcodes EE50 - EE57
YE50:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #7,r0
extu.w r3,r3
ln1683:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1683
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-20,r7
! Opcodes EE58 - EE5F
YE58:
add r13,r2
mov.w @r2,r3
clrt
mov #7,r0
extu.w r3,r3
ln1685:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1685
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-20,r7
! Opcodes EE60 - EE67
YE60:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1686
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1686:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1687
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1687:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EE68 - EE6F
YE68:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1688
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1688:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1689
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1689:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EE70 - EE77
YE70:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1690
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1690:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln1691:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf/s ln1691
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EE78 - EE7F
YE78:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1692
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1692:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln1693:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
extu.w r3,r3
bf ln1693
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EE80 - EE87
YE80:
add r13,r2
mov.l @r2,r3
mov #-6,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-22,r7
! Opcodes EE88 - EE8F
YE88:
add r13,r2
mov.l @r2,r3
mov #-6,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-22,r7
! Opcodes EE90 - EE97
YE90:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #7,r0
ln1699:
rotcr r3
movt r8
dt r0
bf/s ln1699
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-22,r7
! Opcodes EE98 - EE9F
YE98:
add r13,r2
mov.l @r2,r3
clrt
mov #7,r0
ln1701:
rotr r3
movt r8
dt r0
bf ln1701
mov.l r3,@r2
jmp @r10
add #-22,r7
! Opcodes EEA0 - EEA7
YEA0:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1702
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1702:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1703
add #-31,r0
mov #-31,r1
shad r1,r3
nobitover1703:
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EEA8 - EEAF
YEA8:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1704
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1704:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1705
add #-31,r0
mov #-31,r1
shld r1,r3
nobitover1705:
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EEB0 - EEB7
YEB0:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1706
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1706:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1707:
rotcr r3
movt r8
dt r0
bf/s ln1707
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EEB8 - EEBF
YEB8:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1708
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1708:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1709:
rotr r3
movt r8
dt r0
bf ln1709
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EF00 - EF07
YF00:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-20,r7
! Opcodes EF08 - EF0F
YF08:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #6,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-20,r7
! Opcodes EF10 - EF17
YF10:
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #7,r0
ln1715:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1715
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-20,r7
! Opcodes EF18 - EF1F
YF18:
add r13,r2
mov.b @r2,r3
clrt
mov #7,r0
ln1717:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1717
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-20,r7
! Opcodes EF20 - EF27
YF20:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1718
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1718:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln1719:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1719
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EF28 - EF2F
YF28:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1720
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1720:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1721
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1721:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EF30 - EF37
YF30:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1722
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1722:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln1723:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln1723
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EF38 - EF3F
YF38:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1724
mov r2,r0
mov.b @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1724:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln1725:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln1725
exts.b r3,r3
mov.b r3,@r2
jmp @r10
add #-6,r7
! Opcodes EF40 - EF47
YF40:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-20,r7
! Opcodes EF48 - EF4F
YF48:
add r13,r2
mov.w @r2,r3
shll16 r3
mov #6,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-20,r7
! Opcodes EF50 - EF57
YF50:
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #7,r0
ln1731:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1731
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-20,r7
! Opcodes EF58 - EF5F
YF58:
add r13,r2
mov.w @r2,r3
clrt
mov #7,r0
ln1733:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1733
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-20,r7
! Opcodes EF60 - EF67
YF60:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1734
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1734:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln1735:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1735
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EF68 - EF6F
YF68:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1736
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1736:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
shll16 r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1737
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1737:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EF70 - EF77
YF70:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1738
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
jmp @r10
add #-6,r7
ln1738:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln1739:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln1739
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EF78 - EF7F
YF78:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1740
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r8
jmp @r10
add #-6,r7
ln1740:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln1741:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln1741
exts.w r3,r3
mov.w r3,@r2
jmp @r10
add #-6,r7
! Opcodes EF80 - EF87
YF80:
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-22,r7
! Opcodes EF88 - EF8F
YF88:
add r13,r2
mov.l @r2,r3
mov #6,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-22,r7
! Opcodes EF90 - EF97
YF90:
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #7,r0
ln1747:
rotcl r3
movt r8
dt r0
bf/s ln1747
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-22,r7
! Opcodes EF98 - EF9F
YF98:
add r13,r2
mov.l @r2,r3
clrt
mov #7,r0
ln1749:
rotl r3
movt r8
dt r0
bf ln1749
mov.l r3,@r2
jmp @r10
add #-22,r7
! Opcodes EFA0 - EFA7
YFA0:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1750
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1750:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln1751:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln1751
cmp/pl r9
rotcl r8
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EFA8 - EFAF
YFA8:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1752
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1752:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
mov #32,r1
cmp/hi r1,r0
bf nobitover1753
add #-31,r0
mov #31,r1
shld r1,r3
nobitover1753:
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EFB0 - EFB7
YFB0:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1754
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
jmp @r10
add #-8,r7
ln1754:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln1755:
rotcl r3
movt r8
dt r0
bf/s ln1755
cmp/pl r8
mov r8,r9
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes EFB8 - EFBF
YFB8:
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln1756
mov r2,r0
mov.l @(r0,r13),r3
mov #0,r8
jmp @r10
add #-8,r7
ln1756:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln1757:
rotl r3
movt r8
dt r0
bf ln1757
mov.l r3,@r2
jmp @r10
add #-8,r7
! Opcodes F000 - FFFF
Z000:
mov.l r3,@-r15
mov.l g1_except_addr1758,r0
add #-2,r6
jsr @r0
mov #0x2C,r4
mov.l bf_addr1758,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
jmp @r10
add #-34,r7
.align 2
g1_except_addr1758: .long group_1_exception
bf_addr1758: .long basefunction
.data
.align 5
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S000
.long S000
.long S000
.long S000
.long S000
.long S000
.long S000
.long S000
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S010
.long S010
.long S010
.long S010
.long S010
.long S010
.long S010
.long S010
.long S018
.long S018
.long S018
.long S018
.long S018
.long S018
.long S018
.long S018
.long S020
.long S020
.long S020
.long S020
.long S020
.long S020
.long S020
.long S020
.long S028
.long S028
.long S028
.long S028
.long S028
.long S028
.long S028
.long S028
.long S030
.long S030
.long S030
.long S030
.long S030
.long S030
.long S030
.long S030
.long S038
.long S039
.long S03A
.long S03B
.long S03C
.long r_illegal
.long r_illegal
.long r_illegal
.long S040
.long S040
.long S040
.long S040
.long S040
.long S040
.long S040
.long S040
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S050
.long S050
.long S050
.long S050
.long S050
.long S050
.long S050
.long S050
.long S058
.long S058
.long S058
.long S058
.long S058
.long S058
.long S058
.long S058
.long S060
.long S060
.long S060
.long S060
.long S060
.long S060
.long S060
.long S060
.long S068
.long S068
.long S068
.long S068
.long S068
.long S068
.long S068
.long S068
.long S070
.long S070
.long S070
.long S070
.long S070
.long S070
.long S070
.long S070
.long S078
.long S079
.long S07A
.long S07B
.long S07C
.long r_illegal
.long r_illegal
.long r_illegal
.long S080
.long S080
.long S080
.long S080
.long S080
.long S080
.long S080
.long S080
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S090
.long S090
.long S090
.long S090
.long S090
.long S090
.long S090
.long S090
.long S098
.long S098
.long S098
.long S098
.long S098
.long S098
.long S098
.long S098
.long S0A0
.long S0A0
.long S0A0
.long S0A0
.long S0A0
.long S0A0
.long S0A0
.long S0A0
.long S0A8
.long S0A8
.long S0A8
.long S0A8
.long S0A8
.long S0A8
.long S0A8
.long S0A8
.long S0B0
.long S0B0
.long S0B0
.long S0B0
.long S0B0
.long S0B0
.long S0B0
.long S0B0
.long S0B8
.long S0B9
.long S0BA
.long S0BB
.long S0BC
.long r_illegal
.long r_illegal
.long r_illegal
.long S0C0
.long S0C0
.long S0C0
.long S0C0
.long S0C0
.long S0C0
.long S0C0
.long S0C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S0D0
.long S0D0
.long S0D0
.long S0D0
.long S0D0
.long S0D0
.long S0D0
.long S0D0
.long S0D8
.long S0D8
.long S0D8
.long S0D8
.long S0D8
.long S0D8
.long S0D8
.long S0D8
.long S0E0
.long S0E0
.long S0E0
.long S0E0
.long S0E0
.long S0E0
.long S0E0
.long S0E0
.long S0E8
.long S0E8
.long S0E8
.long S0E8
.long S0E8
.long S0E8
.long S0E8
.long S0E8
.long S0F0
.long S0F0
.long S0F0
.long S0F0
.long S0F0
.long S0F0
.long S0F0
.long S0F0
.long S0F8
.long S0F9
.long S0FA
.long S0FB
.long S0FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S100
.long S100
.long S100
.long S100
.long S100
.long S100
.long S100
.long S100
.long S108
.long S108
.long S108
.long S108
.long S108
.long S108
.long S108
.long S108
.long S110
.long S110
.long S110
.long S110
.long S110
.long S110
.long S110
.long S110
.long S118
.long S118
.long S118
.long S118
.long S118
.long S118
.long S118
.long S118
.long S120
.long S120
.long S120
.long S120
.long S120
.long S120
.long S120
.long S120
.long S128
.long S128
.long S128
.long S128
.long S128
.long S128
.long S128
.long S128
.long S130
.long S130
.long S130
.long S130
.long S130
.long S130
.long S130
.long S130
.long S138
.long S139
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S150
.long S150
.long S150
.long S150
.long S150
.long S150
.long S150
.long S150
.long S158
.long S158
.long S158
.long S158
.long S158
.long S158
.long S158
.long S158
.long S160
.long S160
.long S160
.long S160
.long S160
.long S160
.long S160
.long S160
.long S168
.long S168
.long S168
.long S168
.long S168
.long S168
.long S168
.long S168
.long S170
.long S170
.long S170
.long S170
.long S170
.long S170
.long S170
.long S170
.long S178
.long S179
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S190
.long S190
.long S190
.long S190
.long S190
.long S190
.long S190
.long S190
.long S198
.long S198
.long S198
.long S198
.long S198
.long S198
.long S198
.long S198
.long S1A0
.long S1A0
.long S1A0
.long S1A0
.long S1A0
.long S1A0
.long S1A0
.long S1A0
.long S1A8
.long S1A8
.long S1A8
.long S1A8
.long S1A8
.long S1A8
.long S1A8
.long S1A8
.long S1B0
.long S1B0
.long S1B0
.long S1B0
.long S1B0
.long S1B0
.long S1B0
.long S1B0
.long S1B8
.long S1B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S1C0
.long S1C0
.long S1C0
.long S1C0
.long S1C0
.long S1C0
.long S1C0
.long S1C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S1D0
.long S1D0
.long S1D0
.long S1D0
.long S1D0
.long S1D0
.long S1D0
.long S1D0
.long S1D8
.long S1D8
.long S1D8
.long S1D8
.long S1D8
.long S1D8
.long S1D8
.long S1D8
.long S1E0
.long S1E0
.long S1E0
.long S1E0
.long S1E0
.long S1E0
.long S1E0
.long S1E0
.long S1E8
.long S1E8
.long S1E8
.long S1E8
.long S1E8
.long S1E8
.long S1E8
.long S1E8
.long S1F0
.long S1F0
.long S1F0
.long S1F0
.long S1F0
.long S1F0
.long S1F0
.long S1F0
.long S1F8
.long S1F9
.long S1FA
.long S1FB
.long S1FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S200
.long S200
.long S200
.long S200
.long S200
.long S200
.long S200
.long S200
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S210
.long S210
.long S210
.long S210
.long S210
.long S210
.long S210
.long S210
.long S218
.long S218
.long S218
.long S218
.long S218
.long S218
.long S218
.long S218
.long S220
.long S220
.long S220
.long S220
.long S220
.long S220
.long S220
.long S220
.long S228
.long S228
.long S228
.long S228
.long S228
.long S228
.long S228
.long S228
.long S230
.long S230
.long S230
.long S230
.long S230
.long S230
.long S230
.long S230
.long S238
.long S239
.long S23A
.long S23B
.long S23C
.long r_illegal
.long r_illegal
.long r_illegal
.long S240
.long S240
.long S240
.long S240
.long S240
.long S240
.long S240
.long S240
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S250
.long S250
.long S250
.long S250
.long S250
.long S250
.long S250
.long S250
.long S258
.long S258
.long S258
.long S258
.long S258
.long S258
.long S258
.long S258
.long S260
.long S260
.long S260
.long S260
.long S260
.long S260
.long S260
.long S260
.long S268
.long S268
.long S268
.long S268
.long S268
.long S268
.long S268
.long S268
.long S270
.long S270
.long S270
.long S270
.long S270
.long S270
.long S270
.long S270
.long S278
.long S279
.long S27A
.long S27B
.long S27C
.long r_illegal
.long r_illegal
.long r_illegal
.long S280
.long S280
.long S280
.long S280
.long S280
.long S280
.long S280
.long S280
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S290
.long S290
.long S290
.long S290
.long S290
.long S290
.long S290
.long S290
.long S298
.long S298
.long S298
.long S298
.long S298
.long S298
.long S298
.long S298
.long S2A0
.long S2A0
.long S2A0
.long S2A0
.long S2A0
.long S2A0
.long S2A0
.long S2A0
.long S2A8
.long S2A8
.long S2A8
.long S2A8
.long S2A8
.long S2A8
.long S2A8
.long S2A8
.long S2B0
.long S2B0
.long S2B0
.long S2B0
.long S2B0
.long S2B0
.long S2B0
.long S2B0
.long S2B8
.long S2B9
.long S2BA
.long S2BB
.long S2BC
.long r_illegal
.long r_illegal
.long r_illegal
.long S2C0
.long S2C0
.long S2C0
.long S2C0
.long S2C0
.long S2C0
.long S2C0
.long S2C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S2D0
.long S2D0
.long S2D0
.long S2D0
.long S2D0
.long S2D0
.long S2D0
.long S2D0
.long S2D8
.long S2D8
.long S2D8
.long S2D8
.long S2D8
.long S2D8
.long S2D8
.long S2D8
.long S2E0
.long S2E0
.long S2E0
.long S2E0
.long S2E0
.long S2E0
.long S2E0
.long S2E0
.long S2E8
.long S2E8
.long S2E8
.long S2E8
.long S2E8
.long S2E8
.long S2E8
.long S2E8
.long S2F0
.long S2F0
.long S2F0
.long S2F0
.long S2F0
.long S2F0
.long S2F0
.long S2F0
.long S2F8
.long S2F9
.long S2FA
.long S2FB
.long S2FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S300
.long S300
.long S300
.long S300
.long S300
.long S300
.long S300
.long S300
.long S308
.long S308
.long S308
.long S308
.long S308
.long S308
.long S308
.long S308
.long S310
.long S310
.long S310
.long S310
.long S310
.long S310
.long S310
.long S310
.long S318
.long S318
.long S318
.long S318
.long S318
.long S318
.long S318
.long S318
.long S320
.long S320
.long S320
.long S320
.long S320
.long S320
.long S320
.long S320
.long S328
.long S328
.long S328
.long S328
.long S328
.long S328
.long S328
.long S328
.long S330
.long S330
.long S330
.long S330
.long S330
.long S330
.long S330
.long S330
.long S338
.long S339
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S350
.long S350
.long S350
.long S350
.long S350
.long S350
.long S350
.long S350
.long S358
.long S358
.long S358
.long S358
.long S358
.long S358
.long S358
.long S358
.long S360
.long S360
.long S360
.long S360
.long S360
.long S360
.long S360
.long S360
.long S368
.long S368
.long S368
.long S368
.long S368
.long S368
.long S368
.long S368
.long S370
.long S370
.long S370
.long S370
.long S370
.long S370
.long S370
.long S370
.long S378
.long S379
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S390
.long S390
.long S390
.long S390
.long S390
.long S390
.long S390
.long S390
.long S398
.long S398
.long S398
.long S398
.long S398
.long S398
.long S398
.long S398
.long S3A0
.long S3A0
.long S3A0
.long S3A0
.long S3A0
.long S3A0
.long S3A0
.long S3A0
.long S3A8
.long S3A8
.long S3A8
.long S3A8
.long S3A8
.long S3A8
.long S3A8
.long S3A8
.long S3B0
.long S3B0
.long S3B0
.long S3B0
.long S3B0
.long S3B0
.long S3B0
.long S3B0
.long S3B8
.long S3B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S3C0
.long S3C0
.long S3C0
.long S3C0
.long S3C0
.long S3C0
.long S3C0
.long S3C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S3D0
.long S3D0
.long S3D0
.long S3D0
.long S3D0
.long S3D0
.long S3D0
.long S3D0
.long S3D8
.long S3D8
.long S3D8
.long S3D8
.long S3D8
.long S3D8
.long S3D8
.long S3D8
.long S3E0
.long S3E0
.long S3E0
.long S3E0
.long S3E0
.long S3E0
.long S3E0
.long S3E0
.long S3E8
.long S3E8
.long S3E8
.long S3E8
.long S3E8
.long S3E8
.long S3E8
.long S3E8
.long S3F0
.long S3F0
.long S3F0
.long S3F0
.long S3F0
.long S3F0
.long S3F0
.long S3F0
.long S3F8
.long S3F9
.long S3FA
.long S3FB
.long S3FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S400
.long S400
.long S400
.long S400
.long S400
.long S400
.long S400
.long S400
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S410
.long S410
.long S410
.long S410
.long S410
.long S410
.long S410
.long S410
.long S418
.long S418
.long S418
.long S418
.long S418
.long S418
.long S418
.long S418
.long S420
.long S420
.long S420
.long S420
.long S420
.long S420
.long S420
.long S420
.long S428
.long S428
.long S428
.long S428
.long S428
.long S428
.long S428
.long S428
.long S430
.long S430
.long S430
.long S430
.long S430
.long S430
.long S430
.long S430
.long S438
.long S439
.long S43A
.long S43B
.long S43C
.long r_illegal
.long r_illegal
.long r_illegal
.long S440
.long S440
.long S440
.long S440
.long S440
.long S440
.long S440
.long S440
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S450
.long S450
.long S450
.long S450
.long S450
.long S450
.long S450
.long S450
.long S458
.long S458
.long S458
.long S458
.long S458
.long S458
.long S458
.long S458
.long S460
.long S460
.long S460
.long S460
.long S460
.long S460
.long S460
.long S460
.long S468
.long S468
.long S468
.long S468
.long S468
.long S468
.long S468
.long S468
.long S470
.long S470
.long S470
.long S470
.long S470
.long S470
.long S470
.long S470
.long S478
.long S479
.long S47A
.long S47B
.long S47C
.long r_illegal
.long r_illegal
.long r_illegal
.long S480
.long S480
.long S480
.long S480
.long S480
.long S480
.long S480
.long S480
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S490
.long S490
.long S490
.long S490
.long S490
.long S490
.long S490
.long S490
.long S498
.long S498
.long S498
.long S498
.long S498
.long S498
.long S498
.long S498
.long S4A0
.long S4A0
.long S4A0
.long S4A0
.long S4A0
.long S4A0
.long S4A0
.long S4A0
.long S4A8
.long S4A8
.long S4A8
.long S4A8
.long S4A8
.long S4A8
.long S4A8
.long S4A8
.long S4B0
.long S4B0
.long S4B0
.long S4B0
.long S4B0
.long S4B0
.long S4B0
.long S4B0
.long S4B8
.long S4B9
.long S4BA
.long S4BB
.long S4BC
.long r_illegal
.long r_illegal
.long r_illegal
.long S4C0
.long S4C0
.long S4C0
.long S4C0
.long S4C0
.long S4C0
.long S4C0
.long S4C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S4D0
.long S4D0
.long S4D0
.long S4D0
.long S4D0
.long S4D0
.long S4D0
.long S4D0
.long S4D8
.long S4D8
.long S4D8
.long S4D8
.long S4D8
.long S4D8
.long S4D8
.long S4D8
.long S4E0
.long S4E0
.long S4E0
.long S4E0
.long S4E0
.long S4E0
.long S4E0
.long S4E0
.long S4E8
.long S4E8
.long S4E8
.long S4E8
.long S4E8
.long S4E8
.long S4E8
.long S4E8
.long S4F0
.long S4F0
.long S4F0
.long S4F0
.long S4F0
.long S4F0
.long S4F0
.long S4F0
.long S4F8
.long S4F9
.long S4FA
.long S4FB
.long S4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S500
.long S500
.long S500
.long S500
.long S500
.long S500
.long S500
.long S500
.long S508
.long S508
.long S508
.long S508
.long S508
.long S508
.long S508
.long S508
.long S510
.long S510
.long S510
.long S510
.long S510
.long S510
.long S510
.long S510
.long S518
.long S518
.long S518
.long S518
.long S518
.long S518
.long S518
.long S518
.long S520
.long S520
.long S520
.long S520
.long S520
.long S520
.long S520
.long S520
.long S528
.long S528
.long S528
.long S528
.long S528
.long S528
.long S528
.long S528
.long S530
.long S530
.long S530
.long S530
.long S530
.long S530
.long S530
.long S530
.long S538
.long S539
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S550
.long S550
.long S550
.long S550
.long S550
.long S550
.long S550
.long S550
.long S558
.long S558
.long S558
.long S558
.long S558
.long S558
.long S558
.long S558
.long S560
.long S560
.long S560
.long S560
.long S560
.long S560
.long S560
.long S560
.long S568
.long S568
.long S568
.long S568
.long S568
.long S568
.long S568
.long S568
.long S570
.long S570
.long S570
.long S570
.long S570
.long S570
.long S570
.long S570
.long S578
.long S579
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S590
.long S590
.long S590
.long S590
.long S590
.long S590
.long S590
.long S590
.long S598
.long S598
.long S598
.long S598
.long S598
.long S598
.long S598
.long S598
.long S5A0
.long S5A0
.long S5A0
.long S5A0
.long S5A0
.long S5A0
.long S5A0
.long S5A0
.long S5A8
.long S5A8
.long S5A8
.long S5A8
.long S5A8
.long S5A8
.long S5A8
.long S5A8
.long S5B0
.long S5B0
.long S5B0
.long S5B0
.long S5B0
.long S5B0
.long S5B0
.long S5B0
.long S5B8
.long S5B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S5C0
.long S5C0
.long S5C0
.long S5C0
.long S5C0
.long S5C0
.long S5C0
.long S5C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S5D0
.long S5D0
.long S5D0
.long S5D0
.long S5D0
.long S5D0
.long S5D0
.long S5D0
.long S5D8
.long S5D8
.long S5D8
.long S5D8
.long S5D8
.long S5D8
.long S5D8
.long S5D8
.long S5E0
.long S5E0
.long S5E0
.long S5E0
.long S5E0
.long S5E0
.long S5E0
.long S5E0
.long S5E8
.long S5E8
.long S5E8
.long S5E8
.long S5E8
.long S5E8
.long S5E8
.long S5E8
.long S5F0
.long S5F0
.long S5F0
.long S5F0
.long S5F0
.long S5F0
.long S5F0
.long S5F0
.long S5F8
.long S5F9
.long S5FA
.long S5FB
.long S5FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S600
.long S600
.long S600
.long S600
.long S600
.long S600
.long S600
.long S600
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S610
.long S610
.long S610
.long S610
.long S610
.long S610
.long S610
.long S610
.long S618
.long S618
.long S618
.long S618
.long S618
.long S618
.long S618
.long S618
.long S620
.long S620
.long S620
.long S620
.long S620
.long S620
.long S620
.long S620
.long S628
.long S628
.long S628
.long S628
.long S628
.long S628
.long S628
.long S628
.long S630
.long S630
.long S630
.long S630
.long S630
.long S630
.long S630
.long S630
.long S638
.long S639
.long S63A
.long S63B
.long S63C
.long r_illegal
.long r_illegal
.long r_illegal
.long S640
.long S640
.long S640
.long S640
.long S640
.long S640
.long S640
.long S640
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S650
.long S650
.long S650
.long S650
.long S650
.long S650
.long S650
.long S650
.long S658
.long S658
.long S658
.long S658
.long S658
.long S658
.long S658
.long S658
.long S660
.long S660
.long S660
.long S660
.long S660
.long S660
.long S660
.long S660
.long S668
.long S668
.long S668
.long S668
.long S668
.long S668
.long S668
.long S668
.long S670
.long S670
.long S670
.long S670
.long S670
.long S670
.long S670
.long S670
.long S678
.long S679
.long S67A
.long S67B
.long S67C
.long r_illegal
.long r_illegal
.long r_illegal
.long S680
.long S680
.long S680
.long S680
.long S680
.long S680
.long S680
.long S680
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S690
.long S690
.long S690
.long S690
.long S690
.long S690
.long S690
.long S690
.long S698
.long S698
.long S698
.long S698
.long S698
.long S698
.long S698
.long S698
.long S6A0
.long S6A0
.long S6A0
.long S6A0
.long S6A0
.long S6A0
.long S6A0
.long S6A0
.long S6A8
.long S6A8
.long S6A8
.long S6A8
.long S6A8
.long S6A8
.long S6A8
.long S6A8
.long S6B0
.long S6B0
.long S6B0
.long S6B0
.long S6B0
.long S6B0
.long S6B0
.long S6B0
.long S6B8
.long S6B9
.long S6BA
.long S6BB
.long S6BC
.long r_illegal
.long r_illegal
.long r_illegal
.long S6C0
.long S6C0
.long S6C0
.long S6C0
.long S6C0
.long S6C0
.long S6C0
.long S6C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S6D0
.long S6D0
.long S6D0
.long S6D0
.long S6D0
.long S6D0
.long S6D0
.long S6D0
.long S6D8
.long S6D8
.long S6D8
.long S6D8
.long S6D8
.long S6D8
.long S6D8
.long S6D8
.long S6E0
.long S6E0
.long S6E0
.long S6E0
.long S6E0
.long S6E0
.long S6E0
.long S6E0
.long S6E8
.long S6E8
.long S6E8
.long S6E8
.long S6E8
.long S6E8
.long S6E8
.long S6E8
.long S6F0
.long S6F0
.long S6F0
.long S6F0
.long S6F0
.long S6F0
.long S6F0
.long S6F0
.long S6F8
.long S6F9
.long S6FA
.long S6FB
.long S6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S700
.long S700
.long S700
.long S700
.long S700
.long S700
.long S700
.long S700
.long S708
.long S708
.long S708
.long S708
.long S708
.long S708
.long S708
.long S708
.long S710
.long S710
.long S710
.long S710
.long S710
.long S710
.long S710
.long S710
.long S718
.long S718
.long S718
.long S718
.long S718
.long S718
.long S718
.long S718
.long S720
.long S720
.long S720
.long S720
.long S720
.long S720
.long S720
.long S720
.long S728
.long S728
.long S728
.long S728
.long S728
.long S728
.long S728
.long S728
.long S730
.long S730
.long S730
.long S730
.long S730
.long S730
.long S730
.long S730
.long S738
.long S739
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S750
.long S750
.long S750
.long S750
.long S750
.long S750
.long S750
.long S750
.long S758
.long S758
.long S758
.long S758
.long S758
.long S758
.long S758
.long S758
.long S760
.long S760
.long S760
.long S760
.long S760
.long S760
.long S760
.long S760
.long S768
.long S768
.long S768
.long S768
.long S768
.long S768
.long S768
.long S768
.long S770
.long S770
.long S770
.long S770
.long S770
.long S770
.long S770
.long S770
.long S778
.long S779
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S790
.long S790
.long S790
.long S790
.long S790
.long S790
.long S790
.long S790
.long S798
.long S798
.long S798
.long S798
.long S798
.long S798
.long S798
.long S798
.long S7A0
.long S7A0
.long S7A0
.long S7A0
.long S7A0
.long S7A0
.long S7A0
.long S7A0
.long S7A8
.long S7A8
.long S7A8
.long S7A8
.long S7A8
.long S7A8
.long S7A8
.long S7A8
.long S7B0
.long S7B0
.long S7B0
.long S7B0
.long S7B0
.long S7B0
.long S7B0
.long S7B0
.long S7B8
.long S7B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S7C0
.long S7C0
.long S7C0
.long S7C0
.long S7C0
.long S7C0
.long S7C0
.long S7C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S7D0
.long S7D0
.long S7D0
.long S7D0
.long S7D0
.long S7D0
.long S7D0
.long S7D0
.long S7D8
.long S7D8
.long S7D8
.long S7D8
.long S7D8
.long S7D8
.long S7D8
.long S7D8
.long S7E0
.long S7E0
.long S7E0
.long S7E0
.long S7E0
.long S7E0
.long S7E0
.long S7E0
.long S7E8
.long S7E8
.long S7E8
.long S7E8
.long S7E8
.long S7E8
.long S7E8
.long S7E8
.long S7F0
.long S7F0
.long S7F0
.long S7F0
.long S7F0
.long S7F0
.long S7F0
.long S7F0
.long S7F8
.long S7F9
.long S7FA
.long S7FB
.long S7FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S800
.long S800
.long S800
.long S800
.long S800
.long S800
.long S800
.long S800
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S810
.long S810
.long S810
.long S810
.long S810
.long S810
.long S810
.long S810
.long S818
.long S818
.long S818
.long S818
.long S818
.long S818
.long S818
.long S818
.long S820
.long S820
.long S820
.long S820
.long S820
.long S820
.long S820
.long S820
.long S828
.long S828
.long S828
.long S828
.long S828
.long S828
.long S828
.long S828
.long S830
.long S830
.long S830
.long S830
.long S830
.long S830
.long S830
.long S830
.long S838
.long S839
.long S83A
.long S83B
.long S83C
.long r_illegal
.long r_illegal
.long r_illegal
.long S840
.long S840
.long S840
.long S840
.long S840
.long S840
.long S840
.long S840
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S850
.long S850
.long S850
.long S850
.long S850
.long S850
.long S850
.long S850
.long S858
.long S858
.long S858
.long S858
.long S858
.long S858
.long S858
.long S858
.long S860
.long S860
.long S860
.long S860
.long S860
.long S860
.long S860
.long S860
.long S868
.long S868
.long S868
.long S868
.long S868
.long S868
.long S868
.long S868
.long S870
.long S870
.long S870
.long S870
.long S870
.long S870
.long S870
.long S870
.long S878
.long S879
.long S87A
.long S87B
.long S87C
.long r_illegal
.long r_illegal
.long r_illegal
.long S880
.long S880
.long S880
.long S880
.long S880
.long S880
.long S880
.long S880
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S890
.long S890
.long S890
.long S890
.long S890
.long S890
.long S890
.long S890
.long S898
.long S898
.long S898
.long S898
.long S898
.long S898
.long S898
.long S898
.long S8A0
.long S8A0
.long S8A0
.long S8A0
.long S8A0
.long S8A0
.long S8A0
.long S8A0
.long S8A8
.long S8A8
.long S8A8
.long S8A8
.long S8A8
.long S8A8
.long S8A8
.long S8A8
.long S8B0
.long S8B0
.long S8B0
.long S8B0
.long S8B0
.long S8B0
.long S8B0
.long S8B0
.long S8B8
.long S8B9
.long S8BA
.long S8BB
.long S8BC
.long r_illegal
.long r_illegal
.long r_illegal
.long S8C0
.long S8C0
.long S8C0
.long S8C0
.long S8C0
.long S8C0
.long S8C0
.long S8C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S8D0
.long S8D0
.long S8D0
.long S8D0
.long S8D0
.long S8D0
.long S8D0
.long S8D0
.long S8D8
.long S8D8
.long S8D8
.long S8D8
.long S8D8
.long S8D8
.long S8D8
.long S8D8
.long S8E0
.long S8E0
.long S8E0
.long S8E0
.long S8E0
.long S8E0
.long S8E0
.long S8E0
.long S8E8
.long S8E8
.long S8E8
.long S8E8
.long S8E8
.long S8E8
.long S8E8
.long S8E8
.long S8F0
.long S8F0
.long S8F0
.long S8F0
.long S8F0
.long S8F0
.long S8F0
.long S8F0
.long S8F8
.long S8F9
.long S8FA
.long S8FB
.long S8FC
.long r_illegal
.long r_illegal
.long r_illegal
.long S900
.long S900
.long S900
.long S900
.long S900
.long S900
.long S900
.long S900
.long S908
.long S908
.long S908
.long S908
.long S908
.long S908
.long S908
.long S908
.long S910
.long S910
.long S910
.long S910
.long S910
.long S910
.long S910
.long S910
.long S918
.long S918
.long S918
.long S918
.long S918
.long S918
.long S918
.long S918
.long S920
.long S920
.long S920
.long S920
.long S920
.long S920
.long S920
.long S920
.long S928
.long S928
.long S928
.long S928
.long S928
.long S928
.long S928
.long S928
.long S930
.long S930
.long S930
.long S930
.long S930
.long S930
.long S930
.long S930
.long S938
.long S939
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S950
.long S950
.long S950
.long S950
.long S950
.long S950
.long S950
.long S950
.long S958
.long S958
.long S958
.long S958
.long S958
.long S958
.long S958
.long S958
.long S960
.long S960
.long S960
.long S960
.long S960
.long S960
.long S960
.long S960
.long S968
.long S968
.long S968
.long S968
.long S968
.long S968
.long S968
.long S968
.long S970
.long S970
.long S970
.long S970
.long S970
.long S970
.long S970
.long S970
.long S978
.long S979
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S990
.long S990
.long S990
.long S990
.long S990
.long S990
.long S990
.long S990
.long S998
.long S998
.long S998
.long S998
.long S998
.long S998
.long S998
.long S998
.long S9A0
.long S9A0
.long S9A0
.long S9A0
.long S9A0
.long S9A0
.long S9A0
.long S9A0
.long S9A8
.long S9A8
.long S9A8
.long S9A8
.long S9A8
.long S9A8
.long S9A8
.long S9A8
.long S9B0
.long S9B0
.long S9B0
.long S9B0
.long S9B0
.long S9B0
.long S9B0
.long S9B0
.long S9B8
.long S9B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S9C0
.long S9C0
.long S9C0
.long S9C0
.long S9C0
.long S9C0
.long S9C0
.long S9C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long S9D0
.long S9D0
.long S9D0
.long S9D0
.long S9D0
.long S9D0
.long S9D0
.long S9D0
.long S9D8
.long S9D8
.long S9D8
.long S9D8
.long S9D8
.long S9D8
.long S9D8
.long S9D8
.long S9E0
.long S9E0
.long S9E0
.long S9E0
.long S9E0
.long S9E0
.long S9E0
.long S9E0
.long S9E8
.long S9E8
.long S9E8
.long S9E8
.long S9E8
.long S9E8
.long S9E8
.long S9E8
.long S9F0
.long S9F0
.long S9F0
.long S9F0
.long S9F0
.long S9F0
.long S9F0
.long S9F0
.long S9F8
.long S9F9
.long S9FA
.long S9FB
.long S9FC
.long r_illegal
.long r_illegal
.long r_illegal
.long SA00
.long SA00
.long SA00
.long SA00
.long SA00
.long SA00
.long SA00
.long SA00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SA10
.long SA10
.long SA10
.long SA10
.long SA10
.long SA10
.long SA10
.long SA10
.long SA18
.long SA18
.long SA18
.long SA18
.long SA18
.long SA18
.long SA18
.long SA18
.long SA20
.long SA20
.long SA20
.long SA20
.long SA20
.long SA20
.long SA20
.long SA20
.long SA28
.long SA28
.long SA28
.long SA28
.long SA28
.long SA28
.long SA28
.long SA28
.long SA30
.long SA30
.long SA30
.long SA30
.long SA30
.long SA30
.long SA30
.long SA30
.long SA38
.long SA39
.long SA3A
.long SA3B
.long SA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long SA40
.long SA40
.long SA40
.long SA40
.long SA40
.long SA40
.long SA40
.long SA40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SA50
.long SA50
.long SA50
.long SA50
.long SA50
.long SA50
.long SA50
.long SA50
.long SA58
.long SA58
.long SA58
.long SA58
.long SA58
.long SA58
.long SA58
.long SA58
.long SA60
.long SA60
.long SA60
.long SA60
.long SA60
.long SA60
.long SA60
.long SA60
.long SA68
.long SA68
.long SA68
.long SA68
.long SA68
.long SA68
.long SA68
.long SA68
.long SA70
.long SA70
.long SA70
.long SA70
.long SA70
.long SA70
.long SA70
.long SA70
.long SA78
.long SA79
.long SA7A
.long SA7B
.long SA7C
.long r_illegal
.long r_illegal
.long r_illegal
.long SA80
.long SA80
.long SA80
.long SA80
.long SA80
.long SA80
.long SA80
.long SA80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SA90
.long SA90
.long SA90
.long SA90
.long SA90
.long SA90
.long SA90
.long SA90
.long SA98
.long SA98
.long SA98
.long SA98
.long SA98
.long SA98
.long SA98
.long SA98
.long SAA0
.long SAA0
.long SAA0
.long SAA0
.long SAA0
.long SAA0
.long SAA0
.long SAA0
.long SAA8
.long SAA8
.long SAA8
.long SAA8
.long SAA8
.long SAA8
.long SAA8
.long SAA8
.long SAB0
.long SAB0
.long SAB0
.long SAB0
.long SAB0
.long SAB0
.long SAB0
.long SAB0
.long SAB8
.long SAB9
.long SABA
.long SABB
.long SABC
.long r_illegal
.long r_illegal
.long r_illegal
.long SAC0
.long SAC0
.long SAC0
.long SAC0
.long SAC0
.long SAC0
.long SAC0
.long SAC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SAD0
.long SAD0
.long SAD0
.long SAD0
.long SAD0
.long SAD0
.long SAD0
.long SAD0
.long SAD8
.long SAD8
.long SAD8
.long SAD8
.long SAD8
.long SAD8
.long SAD8
.long SAD8
.long SAE0
.long SAE0
.long SAE0
.long SAE0
.long SAE0
.long SAE0
.long SAE0
.long SAE0
.long SAE8
.long SAE8
.long SAE8
.long SAE8
.long SAE8
.long SAE8
.long SAE8
.long SAE8
.long SAF0
.long SAF0
.long SAF0
.long SAF0
.long SAF0
.long SAF0
.long SAF0
.long SAF0
.long SAF8
.long SAF9
.long SAFA
.long SAFB
.long SAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long SB00
.long SB00
.long SB00
.long SB00
.long SB00
.long SB00
.long SB00
.long SB00
.long SB08
.long SB08
.long SB08
.long SB08
.long SB08
.long SB08
.long SB08
.long SB08
.long SB10
.long SB10
.long SB10
.long SB10
.long SB10
.long SB10
.long SB10
.long SB10
.long SB18
.long SB18
.long SB18
.long SB18
.long SB18
.long SB18
.long SB18
.long SB18
.long SB20
.long SB20
.long SB20
.long SB20
.long SB20
.long SB20
.long SB20
.long SB20
.long SB28
.long SB28
.long SB28
.long SB28
.long SB28
.long SB28
.long SB28
.long SB28
.long SB30
.long SB30
.long SB30
.long SB30
.long SB30
.long SB30
.long SB30
.long SB30
.long SB38
.long SB39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SB50
.long SB50
.long SB50
.long SB50
.long SB50
.long SB50
.long SB50
.long SB50
.long SB58
.long SB58
.long SB58
.long SB58
.long SB58
.long SB58
.long SB58
.long SB58
.long SB60
.long SB60
.long SB60
.long SB60
.long SB60
.long SB60
.long SB60
.long SB60
.long SB68
.long SB68
.long SB68
.long SB68
.long SB68
.long SB68
.long SB68
.long SB68
.long SB70
.long SB70
.long SB70
.long SB70
.long SB70
.long SB70
.long SB70
.long SB70
.long SB78
.long SB79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SB90
.long SB90
.long SB90
.long SB90
.long SB90
.long SB90
.long SB90
.long SB90
.long SB98
.long SB98
.long SB98
.long SB98
.long SB98
.long SB98
.long SB98
.long SB98
.long SBA0
.long SBA0
.long SBA0
.long SBA0
.long SBA0
.long SBA0
.long SBA0
.long SBA0
.long SBA8
.long SBA8
.long SBA8
.long SBA8
.long SBA8
.long SBA8
.long SBA8
.long SBA8
.long SBB0
.long SBB0
.long SBB0
.long SBB0
.long SBB0
.long SBB0
.long SBB0
.long SBB0
.long SBB8
.long SBB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SBC0
.long SBC0
.long SBC0
.long SBC0
.long SBC0
.long SBC0
.long SBC0
.long SBC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SBD0
.long SBD0
.long SBD0
.long SBD0
.long SBD0
.long SBD0
.long SBD0
.long SBD0
.long SBD8
.long SBD8
.long SBD8
.long SBD8
.long SBD8
.long SBD8
.long SBD8
.long SBD8
.long SBE0
.long SBE0
.long SBE0
.long SBE0
.long SBE0
.long SBE0
.long SBE0
.long SBE0
.long SBE8
.long SBE8
.long SBE8
.long SBE8
.long SBE8
.long SBE8
.long SBE8
.long SBE8
.long SBF0
.long SBF0
.long SBF0
.long SBF0
.long SBF0
.long SBF0
.long SBF0
.long SBF0
.long SBF8
.long SBF9
.long SBFA
.long SBFB
.long SBFC
.long r_illegal
.long r_illegal
.long r_illegal
.long SC00
.long SC00
.long SC00
.long SC00
.long SC00
.long SC00
.long SC00
.long SC00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SC10
.long SC10
.long SC10
.long SC10
.long SC10
.long SC10
.long SC10
.long SC10
.long SC18
.long SC18
.long SC18
.long SC18
.long SC18
.long SC18
.long SC18
.long SC18
.long SC20
.long SC20
.long SC20
.long SC20
.long SC20
.long SC20
.long SC20
.long SC20
.long SC28
.long SC28
.long SC28
.long SC28
.long SC28
.long SC28
.long SC28
.long SC28
.long SC30
.long SC30
.long SC30
.long SC30
.long SC30
.long SC30
.long SC30
.long SC30
.long SC38
.long SC39
.long SC3A
.long SC3B
.long SC3C
.long r_illegal
.long r_illegal
.long r_illegal
.long SC40
.long SC40
.long SC40
.long SC40
.long SC40
.long SC40
.long SC40
.long SC40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SC50
.long SC50
.long SC50
.long SC50
.long SC50
.long SC50
.long SC50
.long SC50
.long SC58
.long SC58
.long SC58
.long SC58
.long SC58
.long SC58
.long SC58
.long SC58
.long SC60
.long SC60
.long SC60
.long SC60
.long SC60
.long SC60
.long SC60
.long SC60
.long SC68
.long SC68
.long SC68
.long SC68
.long SC68
.long SC68
.long SC68
.long SC68
.long SC70
.long SC70
.long SC70
.long SC70
.long SC70
.long SC70
.long SC70
.long SC70
.long SC78
.long SC79
.long SC7A
.long SC7B
.long SC7C
.long r_illegal
.long r_illegal
.long r_illegal
.long SC80
.long SC80
.long SC80
.long SC80
.long SC80
.long SC80
.long SC80
.long SC80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SC90
.long SC90
.long SC90
.long SC90
.long SC90
.long SC90
.long SC90
.long SC90
.long SC98
.long SC98
.long SC98
.long SC98
.long SC98
.long SC98
.long SC98
.long SC98
.long SCA0
.long SCA0
.long SCA0
.long SCA0
.long SCA0
.long SCA0
.long SCA0
.long SCA0
.long SCA8
.long SCA8
.long SCA8
.long SCA8
.long SCA8
.long SCA8
.long SCA8
.long SCA8
.long SCB0
.long SCB0
.long SCB0
.long SCB0
.long SCB0
.long SCB0
.long SCB0
.long SCB0
.long SCB8
.long SCB9
.long SCBA
.long SCBB
.long SCBC
.long r_illegal
.long r_illegal
.long r_illegal
.long SCC0
.long SCC0
.long SCC0
.long SCC0
.long SCC0
.long SCC0
.long SCC0
.long SCC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SCD0
.long SCD0
.long SCD0
.long SCD0
.long SCD0
.long SCD0
.long SCD0
.long SCD0
.long SCD8
.long SCD8
.long SCD8
.long SCD8
.long SCD8
.long SCD8
.long SCD8
.long SCD8
.long SCE0
.long SCE0
.long SCE0
.long SCE0
.long SCE0
.long SCE0
.long SCE0
.long SCE0
.long SCE8
.long SCE8
.long SCE8
.long SCE8
.long SCE8
.long SCE8
.long SCE8
.long SCE8
.long SCF0
.long SCF0
.long SCF0
.long SCF0
.long SCF0
.long SCF0
.long SCF0
.long SCF0
.long SCF8
.long SCF9
.long SCFA
.long SCFB
.long SCFC
.long r_illegal
.long r_illegal
.long r_illegal
.long SD00
.long SD00
.long SD00
.long SD00
.long SD00
.long SD00
.long SD00
.long SD00
.long SD08
.long SD08
.long SD08
.long SD08
.long SD08
.long SD08
.long SD08
.long SD08
.long SD10
.long SD10
.long SD10
.long SD10
.long SD10
.long SD10
.long SD10
.long SD10
.long SD18
.long SD18
.long SD18
.long SD18
.long SD18
.long SD18
.long SD18
.long SD18
.long SD20
.long SD20
.long SD20
.long SD20
.long SD20
.long SD20
.long SD20
.long SD20
.long SD28
.long SD28
.long SD28
.long SD28
.long SD28
.long SD28
.long SD28
.long SD28
.long SD30
.long SD30
.long SD30
.long SD30
.long SD30
.long SD30
.long SD30
.long SD30
.long SD38
.long SD39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SD50
.long SD50
.long SD50
.long SD50
.long SD50
.long SD50
.long SD50
.long SD50
.long SD58
.long SD58
.long SD58
.long SD58
.long SD58
.long SD58
.long SD58
.long SD58
.long SD60
.long SD60
.long SD60
.long SD60
.long SD60
.long SD60
.long SD60
.long SD60
.long SD68
.long SD68
.long SD68
.long SD68
.long SD68
.long SD68
.long SD68
.long SD68
.long SD70
.long SD70
.long SD70
.long SD70
.long SD70
.long SD70
.long SD70
.long SD70
.long SD78
.long SD79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SD90
.long SD90
.long SD90
.long SD90
.long SD90
.long SD90
.long SD90
.long SD90
.long SD98
.long SD98
.long SD98
.long SD98
.long SD98
.long SD98
.long SD98
.long SD98
.long SDA0
.long SDA0
.long SDA0
.long SDA0
.long SDA0
.long SDA0
.long SDA0
.long SDA0
.long SDA8
.long SDA8
.long SDA8
.long SDA8
.long SDA8
.long SDA8
.long SDA8
.long SDA8
.long SDB0
.long SDB0
.long SDB0
.long SDB0
.long SDB0
.long SDB0
.long SDB0
.long SDB0
.long SDB8
.long SDB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SDC0
.long SDC0
.long SDC0
.long SDC0
.long SDC0
.long SDC0
.long SDC0
.long SDC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SDD0
.long SDD0
.long SDD0
.long SDD0
.long SDD0
.long SDD0
.long SDD0
.long SDD0
.long SDD8
.long SDD8
.long SDD8
.long SDD8
.long SDD8
.long SDD8
.long SDD8
.long SDD8
.long SDE0
.long SDE0
.long SDE0
.long SDE0
.long SDE0
.long SDE0
.long SDE0
.long SDE0
.long SDE8
.long SDE8
.long SDE8
.long SDE8
.long SDE8
.long SDE8
.long SDE8
.long SDE8
.long SDF0
.long SDF0
.long SDF0
.long SDF0
.long SDF0
.long SDF0
.long SDF0
.long SDF0
.long SDF8
.long SDF9
.long SDFA
.long SDFB
.long SDFC
.long r_illegal
.long r_illegal
.long r_illegal
.long SE00
.long SE00
.long SE00
.long SE00
.long SE00
.long SE00
.long SE00
.long SE00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SE10
.long SE10
.long SE10
.long SE10
.long SE10
.long SE10
.long SE10
.long SE10
.long SE18
.long SE18
.long SE18
.long SE18
.long SE18
.long SE18
.long SE18
.long SE18
.long SE20
.long SE20
.long SE20
.long SE20
.long SE20
.long SE20
.long SE20
.long SE20
.long SE28
.long SE28
.long SE28
.long SE28
.long SE28
.long SE28
.long SE28
.long SE28
.long SE30
.long SE30
.long SE30
.long SE30
.long SE30
.long SE30
.long SE30
.long SE30
.long SE38
.long SE39
.long SE3A
.long SE3B
.long SE3C
.long r_illegal
.long r_illegal
.long r_illegal
.long SE40
.long SE40
.long SE40
.long SE40
.long SE40
.long SE40
.long SE40
.long SE40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SE50
.long SE50
.long SE50
.long SE50
.long SE50
.long SE50
.long SE50
.long SE50
.long SE58
.long SE58
.long SE58
.long SE58
.long SE58
.long SE58
.long SE58
.long SE58
.long SE60
.long SE60
.long SE60
.long SE60
.long SE60
.long SE60
.long SE60
.long SE60
.long SE68
.long SE68
.long SE68
.long SE68
.long SE68
.long SE68
.long SE68
.long SE68
.long SE70
.long SE70
.long SE70
.long SE70
.long SE70
.long SE70
.long SE70
.long SE70
.long SE78
.long SE79
.long SE7A
.long SE7B
.long SE7C
.long r_illegal
.long r_illegal
.long r_illegal
.long SE80
.long SE80
.long SE80
.long SE80
.long SE80
.long SE80
.long SE80
.long SE80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SE90
.long SE90
.long SE90
.long SE90
.long SE90
.long SE90
.long SE90
.long SE90
.long SE98
.long SE98
.long SE98
.long SE98
.long SE98
.long SE98
.long SE98
.long SE98
.long SEA0
.long SEA0
.long SEA0
.long SEA0
.long SEA0
.long SEA0
.long SEA0
.long SEA0
.long SEA8
.long SEA8
.long SEA8
.long SEA8
.long SEA8
.long SEA8
.long SEA8
.long SEA8
.long SEB0
.long SEB0
.long SEB0
.long SEB0
.long SEB0
.long SEB0
.long SEB0
.long SEB0
.long SEB8
.long SEB9
.long SEBA
.long SEBB
.long SEBC
.long r_illegal
.long r_illegal
.long r_illegal
.long SEC0
.long SEC0
.long SEC0
.long SEC0
.long SEC0
.long SEC0
.long SEC0
.long SEC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SED0
.long SED0
.long SED0
.long SED0
.long SED0
.long SED0
.long SED0
.long SED0
.long SED8
.long SED8
.long SED8
.long SED8
.long SED8
.long SED8
.long SED8
.long SED8
.long SEE0
.long SEE0
.long SEE0
.long SEE0
.long SEE0
.long SEE0
.long SEE0
.long SEE0
.long SEE8
.long SEE8
.long SEE8
.long SEE8
.long SEE8
.long SEE8
.long SEE8
.long SEE8
.long SEF0
.long SEF0
.long SEF0
.long SEF0
.long SEF0
.long SEF0
.long SEF0
.long SEF0
.long SEF8
.long SEF9
.long SEFA
.long SEFB
.long SEFC
.long r_illegal
.long r_illegal
.long r_illegal
.long SF00
.long SF00
.long SF00
.long SF00
.long SF00
.long SF00
.long SF00
.long SF00
.long SF08
.long SF08
.long SF08
.long SF08
.long SF08
.long SF08
.long SF08
.long SF08
.long SF10
.long SF10
.long SF10
.long SF10
.long SF10
.long SF10
.long SF10
.long SF10
.long SF18
.long SF18
.long SF18
.long SF18
.long SF18
.long SF18
.long SF18
.long SF18
.long SF20
.long SF20
.long SF20
.long SF20
.long SF20
.long SF20
.long SF20
.long SF20
.long SF28
.long SF28
.long SF28
.long SF28
.long SF28
.long SF28
.long SF28
.long SF28
.long SF30
.long SF30
.long SF30
.long SF30
.long SF30
.long SF30
.long SF30
.long SF30
.long SF38
.long SF39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SF50
.long SF50
.long SF50
.long SF50
.long SF50
.long SF50
.long SF50
.long SF50
.long SF58
.long SF58
.long SF58
.long SF58
.long SF58
.long SF58
.long SF58
.long SF58
.long SF60
.long SF60
.long SF60
.long SF60
.long SF60
.long SF60
.long SF60
.long SF60
.long SF68
.long SF68
.long SF68
.long SF68
.long SF68
.long SF68
.long SF68
.long SF68
.long SF70
.long SF70
.long SF70
.long SF70
.long SF70
.long SF70
.long SF70
.long SF70
.long SF78
.long SF79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SF90
.long SF90
.long SF90
.long SF90
.long SF90
.long SF90
.long SF90
.long SF90
.long SF98
.long SF98
.long SF98
.long SF98
.long SF98
.long SF98
.long SF98
.long SF98
.long SFA0
.long SFA0
.long SFA0
.long SFA0
.long SFA0
.long SFA0
.long SFA0
.long SFA0
.long SFA8
.long SFA8
.long SFA8
.long SFA8
.long SFA8
.long SFA8
.long SFA8
.long SFA8
.long SFB0
.long SFB0
.long SFB0
.long SFB0
.long SFB0
.long SFB0
.long SFB0
.long SFB0
.long SFB8
.long SFB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SFC0
.long SFC0
.long SFC0
.long SFC0
.long SFC0
.long SFC0
.long SFC0
.long SFC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long SFD0
.long SFD0
.long SFD0
.long SFD0
.long SFD0
.long SFD0
.long SFD0
.long SFD0
.long SFD8
.long SFD8
.long SFD8
.long SFD8
.long SFD8
.long SFD8
.long SFD8
.long SFD8
.long SFE0
.long SFE0
.long SFE0
.long SFE0
.long SFE0
.long SFE0
.long SFE0
.long SFE0
.long SFE8
.long SFE8
.long SFE8
.long SFE8
.long SFE8
.long SFE8
.long SFE8
.long SFE8
.long SFF0
.long SFF0
.long SFF0
.long SFF0
.long SFF0
.long SFF0
.long SFF0
.long SFF0
.long SFF8
.long SFF9
.long SFFA
.long SFFB
.long SFFC
.long r_illegal
.long r_illegal
.long r_illegal
.long T000
.long T000
.long T000
.long T000
.long T000
.long T000
.long T000
.long T000
.long T008
.long T008
.long T008
.long T008
.long T008
.long T008
.long T008
.long T008
.long T010
.long T010
.long T010
.long T010
.long T010
.long T010
.long T010
.long T010
.long T018
.long T018
.long T018
.long T018
.long T018
.long T018
.long T018
.long T018
.long T020
.long T020
.long T020
.long T020
.long T020
.long T020
.long T020
.long T020
.long T028
.long T028
.long T028
.long T028
.long T028
.long T028
.long T028
.long T028
.long T030
.long T030
.long T030
.long T030
.long T030
.long T030
.long T030
.long T030
.long T038
.long T039
.long T03A
.long T03B
.long T03C
.long r_illegal
.long r_illegal
.long r_illegal
.long T040
.long T040
.long T040
.long T040
.long T040
.long T040
.long T040
.long T040
.long T048
.long T048
.long T048
.long T048
.long T048
.long T048
.long T048
.long T048
.long T050
.long T050
.long T050
.long T050
.long T050
.long T050
.long T050
.long T050
.long T058
.long T058
.long T058
.long T058
.long T058
.long T058
.long T058
.long T058
.long T060
.long T060
.long T060
.long T060
.long T060
.long T060
.long T060
.long T060
.long T068
.long T068
.long T068
.long T068
.long T068
.long T068
.long T068
.long T068
.long T070
.long T070
.long T070
.long T070
.long T070
.long T070
.long T070
.long T070
.long T078
.long T079
.long T07A
.long T07B
.long T07C
.long r_illegal
.long r_illegal
.long r_illegal
.long T080
.long T080
.long T080
.long T080
.long T080
.long T080
.long T080
.long T080
.long T088
.long T088
.long T088
.long T088
.long T088
.long T088
.long T088
.long T088
.long T090
.long T090
.long T090
.long T090
.long T090
.long T090
.long T090
.long T090
.long T098
.long T098
.long T098
.long T098
.long T098
.long T098
.long T098
.long T098
.long T0A0
.long T0A0
.long T0A0
.long T0A0
.long T0A0
.long T0A0
.long T0A0
.long T0A0
.long T0A8
.long T0A8
.long T0A8
.long T0A8
.long T0A8
.long T0A8
.long T0A8
.long T0A8
.long T0B0
.long T0B0
.long T0B0
.long T0B0
.long T0B0
.long T0B0
.long T0B0
.long T0B0
.long T0B8
.long T0B9
.long T0BA
.long T0BB
.long T0BC
.long r_illegal
.long r_illegal
.long r_illegal
.long T0C0
.long T0C0
.long T0C0
.long T0C0
.long T0C0
.long T0C0
.long T0C0
.long T0C0
.long T0C8
.long T0C8
.long T0C8
.long T0C8
.long T0C8
.long T0C8
.long T0C8
.long T0C8
.long T0D0
.long T0D0
.long T0D0
.long T0D0
.long T0D0
.long T0D0
.long T0D0
.long T0D0
.long T0D8
.long T0D8
.long T0D8
.long T0D8
.long T0D8
.long T0D8
.long T0D8
.long T0D8
.long T0E0
.long T0E0
.long T0E0
.long T0E0
.long T0E0
.long T0E0
.long T0E0
.long T0E0
.long T0E8
.long T0E8
.long T0E8
.long T0E8
.long T0E8
.long T0E8
.long T0E8
.long T0E8
.long T0F0
.long T0F0
.long T0F0
.long T0F0
.long T0F0
.long T0F0
.long T0F0
.long T0F0
.long T0F8
.long T0F9
.long T0FA
.long T0FB
.long T0FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T100
.long T100
.long T100
.long T100
.long T100
.long T100
.long T100
.long T100
.long T108
.long T108
.long T108
.long T108
.long T108
.long T108
.long T108
.long T108
.long T110
.long T110
.long T110
.long T110
.long T110
.long T110
.long T110
.long T110
.long T118
.long T118
.long T118
.long T118
.long T118
.long T118
.long T118
.long T118
.long T120
.long T120
.long T120
.long T120
.long T120
.long T120
.long T120
.long T120
.long T128
.long T128
.long T128
.long T128
.long T128
.long T128
.long T128
.long T128
.long T130
.long T130
.long T130
.long T130
.long T130
.long T130
.long T130
.long T130
.long T138
.long T139
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T140
.long T140
.long T140
.long T140
.long T140
.long T140
.long T140
.long T140
.long T148
.long T148
.long T148
.long T148
.long T148
.long T148
.long T148
.long T148
.long T150
.long T150
.long T150
.long T150
.long T150
.long T150
.long T150
.long T150
.long T158
.long T158
.long T158
.long T158
.long T158
.long T158
.long T158
.long T158
.long T160
.long T160
.long T160
.long T160
.long T160
.long T160
.long T160
.long T160
.long T168
.long T168
.long T168
.long T168
.long T168
.long T168
.long T168
.long T168
.long T170
.long T170
.long T170
.long T170
.long T170
.long T170
.long T170
.long T170
.long T178
.long T179
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T180
.long T180
.long T180
.long T180
.long T180
.long T180
.long T180
.long T180
.long T188
.long T188
.long T188
.long T188
.long T188
.long T188
.long T188
.long T188
.long T190
.long T190
.long T190
.long T190
.long T190
.long T190
.long T190
.long T190
.long T198
.long T198
.long T198
.long T198
.long T198
.long T198
.long T198
.long T198
.long T1A0
.long T1A0
.long T1A0
.long T1A0
.long T1A0
.long T1A0
.long T1A0
.long T1A0
.long T1A8
.long T1A8
.long T1A8
.long T1A8
.long T1A8
.long T1A8
.long T1A8
.long T1A8
.long T1B0
.long T1B0
.long T1B0
.long T1B0
.long T1B0
.long T1B0
.long T1B0
.long T1B0
.long T1B8
.long T1B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T1C0
.long T1C0
.long T1C0
.long T1C0
.long T1C0
.long T1C0
.long T1C0
.long T1C0
.long T1C8
.long T1C8
.long T1C8
.long T1C8
.long T1C8
.long T1C8
.long T1C8
.long T1C8
.long T1D0
.long T1D0
.long T1D0
.long T1D0
.long T1D0
.long T1D0
.long T1D0
.long T1D0
.long T1D8
.long T1D8
.long T1D8
.long T1D8
.long T1D8
.long T1D8
.long T1D8
.long T1D8
.long T1E0
.long T1E0
.long T1E0
.long T1E0
.long T1E0
.long T1E0
.long T1E0
.long T1E0
.long T1E8
.long T1E8
.long T1E8
.long T1E8
.long T1E8
.long T1E8
.long T1E8
.long T1E8
.long T1F0
.long T1F0
.long T1F0
.long T1F0
.long T1F0
.long T1F0
.long T1F0
.long T1F0
.long T1F8
.long T1F9
.long T1FA
.long T1FB
.long T1FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T200
.long T200
.long T200
.long T200
.long T200
.long T200
.long T200
.long T200
.long T208
.long T208
.long T208
.long T208
.long T208
.long T208
.long T208
.long T208
.long T210
.long T210
.long T210
.long T210
.long T210
.long T210
.long T210
.long T210
.long T218
.long T218
.long T218
.long T218
.long T218
.long T218
.long T218
.long T218
.long T220
.long T220
.long T220
.long T220
.long T220
.long T220
.long T220
.long T220
.long T228
.long T228
.long T228
.long T228
.long T228
.long T228
.long T228
.long T228
.long T230
.long T230
.long T230
.long T230
.long T230
.long T230
.long T230
.long T230
.long T238
.long T239
.long T23A
.long T23B
.long T23C
.long r_illegal
.long r_illegal
.long r_illegal
.long T240
.long T240
.long T240
.long T240
.long T240
.long T240
.long T240
.long T240
.long T248
.long T248
.long T248
.long T248
.long T248
.long T248
.long T248
.long T248
.long T250
.long T250
.long T250
.long T250
.long T250
.long T250
.long T250
.long T250
.long T258
.long T258
.long T258
.long T258
.long T258
.long T258
.long T258
.long T258
.long T260
.long T260
.long T260
.long T260
.long T260
.long T260
.long T260
.long T260
.long T268
.long T268
.long T268
.long T268
.long T268
.long T268
.long T268
.long T268
.long T270
.long T270
.long T270
.long T270
.long T270
.long T270
.long T270
.long T270
.long T278
.long T279
.long T27A
.long T27B
.long T27C
.long r_illegal
.long r_illegal
.long r_illegal
.long T280
.long T280
.long T280
.long T280
.long T280
.long T280
.long T280
.long T280
.long T288
.long T288
.long T288
.long T288
.long T288
.long T288
.long T288
.long T288
.long T290
.long T290
.long T290
.long T290
.long T290
.long T290
.long T290
.long T290
.long T298
.long T298
.long T298
.long T298
.long T298
.long T298
.long T298
.long T298
.long T2A0
.long T2A0
.long T2A0
.long T2A0
.long T2A0
.long T2A0
.long T2A0
.long T2A0
.long T2A8
.long T2A8
.long T2A8
.long T2A8
.long T2A8
.long T2A8
.long T2A8
.long T2A8
.long T2B0
.long T2B0
.long T2B0
.long T2B0
.long T2B0
.long T2B0
.long T2B0
.long T2B0
.long T2B8
.long T2B9
.long T2BA
.long T2BB
.long T2BC
.long r_illegal
.long r_illegal
.long r_illegal
.long T2C0
.long T2C0
.long T2C0
.long T2C0
.long T2C0
.long T2C0
.long T2C0
.long T2C0
.long T2C8
.long T2C8
.long T2C8
.long T2C8
.long T2C8
.long T2C8
.long T2C8
.long T2C8
.long T2D0
.long T2D0
.long T2D0
.long T2D0
.long T2D0
.long T2D0
.long T2D0
.long T2D0
.long T2D8
.long T2D8
.long T2D8
.long T2D8
.long T2D8
.long T2D8
.long T2D8
.long T2D8
.long T2E0
.long T2E0
.long T2E0
.long T2E0
.long T2E0
.long T2E0
.long T2E0
.long T2E0
.long T2E8
.long T2E8
.long T2E8
.long T2E8
.long T2E8
.long T2E8
.long T2E8
.long T2E8
.long T2F0
.long T2F0
.long T2F0
.long T2F0
.long T2F0
.long T2F0
.long T2F0
.long T2F0
.long T2F8
.long T2F9
.long T2FA
.long T2FB
.long T2FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T300
.long T300
.long T300
.long T300
.long T300
.long T300
.long T300
.long T300
.long T308
.long T308
.long T308
.long T308
.long T308
.long T308
.long T308
.long T308
.long T310
.long T310
.long T310
.long T310
.long T310
.long T310
.long T310
.long T310
.long T318
.long T318
.long T318
.long T318
.long T318
.long T318
.long T318
.long T318
.long T320
.long T320
.long T320
.long T320
.long T320
.long T320
.long T320
.long T320
.long T328
.long T328
.long T328
.long T328
.long T328
.long T328
.long T328
.long T328
.long T330
.long T330
.long T330
.long T330
.long T330
.long T330
.long T330
.long T330
.long T338
.long T339
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T340
.long T340
.long T340
.long T340
.long T340
.long T340
.long T340
.long T340
.long T348
.long T348
.long T348
.long T348
.long T348
.long T348
.long T348
.long T348
.long T350
.long T350
.long T350
.long T350
.long T350
.long T350
.long T350
.long T350
.long T358
.long T358
.long T358
.long T358
.long T358
.long T358
.long T358
.long T358
.long T360
.long T360
.long T360
.long T360
.long T360
.long T360
.long T360
.long T360
.long T368
.long T368
.long T368
.long T368
.long T368
.long T368
.long T368
.long T368
.long T370
.long T370
.long T370
.long T370
.long T370
.long T370
.long T370
.long T370
.long T378
.long T379
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T380
.long T380
.long T380
.long T380
.long T380
.long T380
.long T380
.long T380
.long T388
.long T388
.long T388
.long T388
.long T388
.long T388
.long T388
.long T388
.long T390
.long T390
.long T390
.long T390
.long T390
.long T390
.long T390
.long T390
.long T398
.long T398
.long T398
.long T398
.long T398
.long T398
.long T398
.long T398
.long T3A0
.long T3A0
.long T3A0
.long T3A0
.long T3A0
.long T3A0
.long T3A0
.long T3A0
.long T3A8
.long T3A8
.long T3A8
.long T3A8
.long T3A8
.long T3A8
.long T3A8
.long T3A8
.long T3B0
.long T3B0
.long T3B0
.long T3B0
.long T3B0
.long T3B0
.long T3B0
.long T3B0
.long T3B8
.long T3B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T3C0
.long T3C0
.long T3C0
.long T3C0
.long T3C0
.long T3C0
.long T3C0
.long T3C0
.long T3C8
.long T3C8
.long T3C8
.long T3C8
.long T3C8
.long T3C8
.long T3C8
.long T3C8
.long T3D0
.long T3D0
.long T3D0
.long T3D0
.long T3D0
.long T3D0
.long T3D0
.long T3D0
.long T3D8
.long T3D8
.long T3D8
.long T3D8
.long T3D8
.long T3D8
.long T3D8
.long T3D8
.long T3E0
.long T3E0
.long T3E0
.long T3E0
.long T3E0
.long T3E0
.long T3E0
.long T3E0
.long T3E8
.long T3E8
.long T3E8
.long T3E8
.long T3E8
.long T3E8
.long T3E8
.long T3E8
.long T3F0
.long T3F0
.long T3F0
.long T3F0
.long T3F0
.long T3F0
.long T3F0
.long T3F0
.long T3F8
.long T3F9
.long T3FA
.long T3FB
.long T3FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T400
.long T400
.long T400
.long T400
.long T400
.long T400
.long T400
.long T400
.long T408
.long T408
.long T408
.long T408
.long T408
.long T408
.long T408
.long T408
.long T410
.long T410
.long T410
.long T410
.long T410
.long T410
.long T410
.long T410
.long T418
.long T418
.long T418
.long T418
.long T418
.long T418
.long T418
.long T418
.long T420
.long T420
.long T420
.long T420
.long T420
.long T420
.long T420
.long T420
.long T428
.long T428
.long T428
.long T428
.long T428
.long T428
.long T428
.long T428
.long T430
.long T430
.long T430
.long T430
.long T430
.long T430
.long T430
.long T430
.long T438
.long T439
.long T43A
.long T43B
.long T43C
.long r_illegal
.long r_illegal
.long r_illegal
.long T440
.long T440
.long T440
.long T440
.long T440
.long T440
.long T440
.long T440
.long T448
.long T448
.long T448
.long T448
.long T448
.long T448
.long T448
.long T448
.long T450
.long T450
.long T450
.long T450
.long T450
.long T450
.long T450
.long T450
.long T458
.long T458
.long T458
.long T458
.long T458
.long T458
.long T458
.long T458
.long T460
.long T460
.long T460
.long T460
.long T460
.long T460
.long T460
.long T460
.long T468
.long T468
.long T468
.long T468
.long T468
.long T468
.long T468
.long T468
.long T470
.long T470
.long T470
.long T470
.long T470
.long T470
.long T470
.long T470
.long T478
.long T479
.long T47A
.long T47B
.long T47C
.long r_illegal
.long r_illegal
.long r_illegal
.long T480
.long T480
.long T480
.long T480
.long T480
.long T480
.long T480
.long T480
.long T488
.long T488
.long T488
.long T488
.long T488
.long T488
.long T488
.long T488
.long T490
.long T490
.long T490
.long T490
.long T490
.long T490
.long T490
.long T490
.long T498
.long T498
.long T498
.long T498
.long T498
.long T498
.long T498
.long T498
.long T4A0
.long T4A0
.long T4A0
.long T4A0
.long T4A0
.long T4A0
.long T4A0
.long T4A0
.long T4A8
.long T4A8
.long T4A8
.long T4A8
.long T4A8
.long T4A8
.long T4A8
.long T4A8
.long T4B0
.long T4B0
.long T4B0
.long T4B0
.long T4B0
.long T4B0
.long T4B0
.long T4B0
.long T4B8
.long T4B9
.long T4BA
.long T4BB
.long T4BC
.long r_illegal
.long r_illegal
.long r_illegal
.long T4C0
.long T4C0
.long T4C0
.long T4C0
.long T4C0
.long T4C0
.long T4C0
.long T4C0
.long T4C8
.long T4C8
.long T4C8
.long T4C8
.long T4C8
.long T4C8
.long T4C8
.long T4C8
.long T4D0
.long T4D0
.long T4D0
.long T4D0
.long T4D0
.long T4D0
.long T4D0
.long T4D0
.long T4D8
.long T4D8
.long T4D8
.long T4D8
.long T4D8
.long T4D8
.long T4D8
.long T4D8
.long T4E0
.long T4E0
.long T4E0
.long T4E0
.long T4E0
.long T4E0
.long T4E0
.long T4E0
.long T4E8
.long T4E8
.long T4E8
.long T4E8
.long T4E8
.long T4E8
.long T4E8
.long T4E8
.long T4F0
.long T4F0
.long T4F0
.long T4F0
.long T4F0
.long T4F0
.long T4F0
.long T4F0
.long T4F8
.long T4F9
.long T4FA
.long T4FB
.long T4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T500
.long T500
.long T500
.long T500
.long T500
.long T500
.long T500
.long T500
.long T508
.long T508
.long T508
.long T508
.long T508
.long T508
.long T508
.long T508
.long T510
.long T510
.long T510
.long T510
.long T510
.long T510
.long T510
.long T510
.long T518
.long T518
.long T518
.long T518
.long T518
.long T518
.long T518
.long T518
.long T520
.long T520
.long T520
.long T520
.long T520
.long T520
.long T520
.long T520
.long T528
.long T528
.long T528
.long T528
.long T528
.long T528
.long T528
.long T528
.long T530
.long T530
.long T530
.long T530
.long T530
.long T530
.long T530
.long T530
.long T538
.long T539
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T540
.long T540
.long T540
.long T540
.long T540
.long T540
.long T540
.long T540
.long T548
.long T548
.long T548
.long T548
.long T548
.long T548
.long T548
.long T548
.long T550
.long T550
.long T550
.long T550
.long T550
.long T550
.long T550
.long T550
.long T558
.long T558
.long T558
.long T558
.long T558
.long T558
.long T558
.long T558
.long T560
.long T560
.long T560
.long T560
.long T560
.long T560
.long T560
.long T560
.long T568
.long T568
.long T568
.long T568
.long T568
.long T568
.long T568
.long T568
.long T570
.long T570
.long T570
.long T570
.long T570
.long T570
.long T570
.long T570
.long T578
.long T579
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T580
.long T580
.long T580
.long T580
.long T580
.long T580
.long T580
.long T580
.long T588
.long T588
.long T588
.long T588
.long T588
.long T588
.long T588
.long T588
.long T590
.long T590
.long T590
.long T590
.long T590
.long T590
.long T590
.long T590
.long T598
.long T598
.long T598
.long T598
.long T598
.long T598
.long T598
.long T598
.long T5A0
.long T5A0
.long T5A0
.long T5A0
.long T5A0
.long T5A0
.long T5A0
.long T5A0
.long T5A8
.long T5A8
.long T5A8
.long T5A8
.long T5A8
.long T5A8
.long T5A8
.long T5A8
.long T5B0
.long T5B0
.long T5B0
.long T5B0
.long T5B0
.long T5B0
.long T5B0
.long T5B0
.long T5B8
.long T5B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T5C0
.long T5C0
.long T5C0
.long T5C0
.long T5C0
.long T5C0
.long T5C0
.long T5C0
.long T5C8
.long T5C8
.long T5C8
.long T5C8
.long T5C8
.long T5C8
.long T5C8
.long T5C8
.long T5D0
.long T5D0
.long T5D0
.long T5D0
.long T5D0
.long T5D0
.long T5D0
.long T5D0
.long T5D8
.long T5D8
.long T5D8
.long T5D8
.long T5D8
.long T5D8
.long T5D8
.long T5D8
.long T5E0
.long T5E0
.long T5E0
.long T5E0
.long T5E0
.long T5E0
.long T5E0
.long T5E0
.long T5E8
.long T5E8
.long T5E8
.long T5E8
.long T5E8
.long T5E8
.long T5E8
.long T5E8
.long T5F0
.long T5F0
.long T5F0
.long T5F0
.long T5F0
.long T5F0
.long T5F0
.long T5F0
.long T5F8
.long T5F9
.long T5FA
.long T5FB
.long T5FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T600
.long T600
.long T600
.long T600
.long T600
.long T600
.long T600
.long T600
.long T608
.long T608
.long T608
.long T608
.long T608
.long T608
.long T608
.long T608
.long T610
.long T610
.long T610
.long T610
.long T610
.long T610
.long T610
.long T610
.long T618
.long T618
.long T618
.long T618
.long T618
.long T618
.long T618
.long T618
.long T620
.long T620
.long T620
.long T620
.long T620
.long T620
.long T620
.long T620
.long T628
.long T628
.long T628
.long T628
.long T628
.long T628
.long T628
.long T628
.long T630
.long T630
.long T630
.long T630
.long T630
.long T630
.long T630
.long T630
.long T638
.long T639
.long T63A
.long T63B
.long T63C
.long r_illegal
.long r_illegal
.long r_illegal
.long T640
.long T640
.long T640
.long T640
.long T640
.long T640
.long T640
.long T640
.long T648
.long T648
.long T648
.long T648
.long T648
.long T648
.long T648
.long T648
.long T650
.long T650
.long T650
.long T650
.long T650
.long T650
.long T650
.long T650
.long T658
.long T658
.long T658
.long T658
.long T658
.long T658
.long T658
.long T658
.long T660
.long T660
.long T660
.long T660
.long T660
.long T660
.long T660
.long T660
.long T668
.long T668
.long T668
.long T668
.long T668
.long T668
.long T668
.long T668
.long T670
.long T670
.long T670
.long T670
.long T670
.long T670
.long T670
.long T670
.long T678
.long T679
.long T67A
.long T67B
.long T67C
.long r_illegal
.long r_illegal
.long r_illegal
.long T680
.long T680
.long T680
.long T680
.long T680
.long T680
.long T680
.long T680
.long T688
.long T688
.long T688
.long T688
.long T688
.long T688
.long T688
.long T688
.long T690
.long T690
.long T690
.long T690
.long T690
.long T690
.long T690
.long T690
.long T698
.long T698
.long T698
.long T698
.long T698
.long T698
.long T698
.long T698
.long T6A0
.long T6A0
.long T6A0
.long T6A0
.long T6A0
.long T6A0
.long T6A0
.long T6A0
.long T6A8
.long T6A8
.long T6A8
.long T6A8
.long T6A8
.long T6A8
.long T6A8
.long T6A8
.long T6B0
.long T6B0
.long T6B0
.long T6B0
.long T6B0
.long T6B0
.long T6B0
.long T6B0
.long T6B8
.long T6B9
.long T6BA
.long T6BB
.long T6BC
.long r_illegal
.long r_illegal
.long r_illegal
.long T6C0
.long T6C0
.long T6C0
.long T6C0
.long T6C0
.long T6C0
.long T6C0
.long T6C0
.long T6C8
.long T6C8
.long T6C8
.long T6C8
.long T6C8
.long T6C8
.long T6C8
.long T6C8
.long T6D0
.long T6D0
.long T6D0
.long T6D0
.long T6D0
.long T6D0
.long T6D0
.long T6D0
.long T6D8
.long T6D8
.long T6D8
.long T6D8
.long T6D8
.long T6D8
.long T6D8
.long T6D8
.long T6E0
.long T6E0
.long T6E0
.long T6E0
.long T6E0
.long T6E0
.long T6E0
.long T6E0
.long T6E8
.long T6E8
.long T6E8
.long T6E8
.long T6E8
.long T6E8
.long T6E8
.long T6E8
.long T6F0
.long T6F0
.long T6F0
.long T6F0
.long T6F0
.long T6F0
.long T6F0
.long T6F0
.long T6F8
.long T6F9
.long T6FA
.long T6FB
.long T6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T700
.long T700
.long T700
.long T700
.long T700
.long T700
.long T700
.long T700
.long T708
.long T708
.long T708
.long T708
.long T708
.long T708
.long T708
.long T708
.long T710
.long T710
.long T710
.long T710
.long T710
.long T710
.long T710
.long T710
.long T718
.long T718
.long T718
.long T718
.long T718
.long T718
.long T718
.long T718
.long T720
.long T720
.long T720
.long T720
.long T720
.long T720
.long T720
.long T720
.long T728
.long T728
.long T728
.long T728
.long T728
.long T728
.long T728
.long T728
.long T730
.long T730
.long T730
.long T730
.long T730
.long T730
.long T730
.long T730
.long T738
.long T739
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T740
.long T740
.long T740
.long T740
.long T740
.long T740
.long T740
.long T740
.long T748
.long T748
.long T748
.long T748
.long T748
.long T748
.long T748
.long T748
.long T750
.long T750
.long T750
.long T750
.long T750
.long T750
.long T750
.long T750
.long T758
.long T758
.long T758
.long T758
.long T758
.long T758
.long T758
.long T758
.long T760
.long T760
.long T760
.long T760
.long T760
.long T760
.long T760
.long T760
.long T768
.long T768
.long T768
.long T768
.long T768
.long T768
.long T768
.long T768
.long T770
.long T770
.long T770
.long T770
.long T770
.long T770
.long T770
.long T770
.long T778
.long T779
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T780
.long T780
.long T780
.long T780
.long T780
.long T780
.long T780
.long T780
.long T788
.long T788
.long T788
.long T788
.long T788
.long T788
.long T788
.long T788
.long T790
.long T790
.long T790
.long T790
.long T790
.long T790
.long T790
.long T790
.long T798
.long T798
.long T798
.long T798
.long T798
.long T798
.long T798
.long T798
.long T7A0
.long T7A0
.long T7A0
.long T7A0
.long T7A0
.long T7A0
.long T7A0
.long T7A0
.long T7A8
.long T7A8
.long T7A8
.long T7A8
.long T7A8
.long T7A8
.long T7A8
.long T7A8
.long T7B0
.long T7B0
.long T7B0
.long T7B0
.long T7B0
.long T7B0
.long T7B0
.long T7B0
.long T7B8
.long T7B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T7C0
.long T7C0
.long T7C0
.long T7C0
.long T7C0
.long T7C0
.long T7C0
.long T7C0
.long T7C8
.long T7C8
.long T7C8
.long T7C8
.long T7C8
.long T7C8
.long T7C8
.long T7C8
.long T7D0
.long T7D0
.long T7D0
.long T7D0
.long T7D0
.long T7D0
.long T7D0
.long T7D0
.long T7D8
.long T7D8
.long T7D8
.long T7D8
.long T7D8
.long T7D8
.long T7D8
.long T7D8
.long T7E0
.long T7E0
.long T7E0
.long T7E0
.long T7E0
.long T7E0
.long T7E0
.long T7E0
.long T7E8
.long T7E8
.long T7E8
.long T7E8
.long T7E8
.long T7E8
.long T7E8
.long T7E8
.long T7F0
.long T7F0
.long T7F0
.long T7F0
.long T7F0
.long T7F0
.long T7F0
.long T7F0
.long T7F8
.long T7F9
.long T7FA
.long T7FB
.long T7FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T800
.long T800
.long T800
.long T800
.long T800
.long T800
.long T800
.long T800
.long T808
.long T808
.long T808
.long T808
.long T808
.long T808
.long T808
.long T808
.long T810
.long T810
.long T810
.long T810
.long T810
.long T810
.long T810
.long T810
.long T818
.long T818
.long T818
.long T818
.long T818
.long T818
.long T818
.long T818
.long T820
.long T820
.long T820
.long T820
.long T820
.long T820
.long T820
.long T820
.long T828
.long T828
.long T828
.long T828
.long T828
.long T828
.long T828
.long T828
.long T830
.long T830
.long T830
.long T830
.long T830
.long T830
.long T830
.long T830
.long T838
.long T839
.long T83A
.long T83B
.long T83C
.long r_illegal
.long r_illegal
.long r_illegal
.long T840
.long T840
.long T840
.long T840
.long T840
.long T840
.long T840
.long T840
.long T848
.long T848
.long T848
.long T848
.long T848
.long T848
.long T848
.long T848
.long T850
.long T850
.long T850
.long T850
.long T850
.long T850
.long T850
.long T850
.long T858
.long T858
.long T858
.long T858
.long T858
.long T858
.long T858
.long T858
.long T860
.long T860
.long T860
.long T860
.long T860
.long T860
.long T860
.long T860
.long T868
.long T868
.long T868
.long T868
.long T868
.long T868
.long T868
.long T868
.long T870
.long T870
.long T870
.long T870
.long T870
.long T870
.long T870
.long T870
.long T878
.long T879
.long T87A
.long T87B
.long T87C
.long r_illegal
.long r_illegal
.long r_illegal
.long T880
.long T880
.long T880
.long T880
.long T880
.long T880
.long T880
.long T880
.long T888
.long T888
.long T888
.long T888
.long T888
.long T888
.long T888
.long T888
.long T890
.long T890
.long T890
.long T890
.long T890
.long T890
.long T890
.long T890
.long T898
.long T898
.long T898
.long T898
.long T898
.long T898
.long T898
.long T898
.long T8A0
.long T8A0
.long T8A0
.long T8A0
.long T8A0
.long T8A0
.long T8A0
.long T8A0
.long T8A8
.long T8A8
.long T8A8
.long T8A8
.long T8A8
.long T8A8
.long T8A8
.long T8A8
.long T8B0
.long T8B0
.long T8B0
.long T8B0
.long T8B0
.long T8B0
.long T8B0
.long T8B0
.long T8B8
.long T8B9
.long T8BA
.long T8BB
.long T8BC
.long r_illegal
.long r_illegal
.long r_illegal
.long T8C0
.long T8C0
.long T8C0
.long T8C0
.long T8C0
.long T8C0
.long T8C0
.long T8C0
.long T8C8
.long T8C8
.long T8C8
.long T8C8
.long T8C8
.long T8C8
.long T8C8
.long T8C8
.long T8D0
.long T8D0
.long T8D0
.long T8D0
.long T8D0
.long T8D0
.long T8D0
.long T8D0
.long T8D8
.long T8D8
.long T8D8
.long T8D8
.long T8D8
.long T8D8
.long T8D8
.long T8D8
.long T8E0
.long T8E0
.long T8E0
.long T8E0
.long T8E0
.long T8E0
.long T8E0
.long T8E0
.long T8E8
.long T8E8
.long T8E8
.long T8E8
.long T8E8
.long T8E8
.long T8E8
.long T8E8
.long T8F0
.long T8F0
.long T8F0
.long T8F0
.long T8F0
.long T8F0
.long T8F0
.long T8F0
.long T8F8
.long T8F9
.long T8FA
.long T8FB
.long T8FC
.long r_illegal
.long r_illegal
.long r_illegal
.long T900
.long T900
.long T900
.long T900
.long T900
.long T900
.long T900
.long T900
.long T908
.long T908
.long T908
.long T908
.long T908
.long T908
.long T908
.long T908
.long T910
.long T910
.long T910
.long T910
.long T910
.long T910
.long T910
.long T910
.long T918
.long T918
.long T918
.long T918
.long T918
.long T918
.long T918
.long T918
.long T920
.long T920
.long T920
.long T920
.long T920
.long T920
.long T920
.long T920
.long T928
.long T928
.long T928
.long T928
.long T928
.long T928
.long T928
.long T928
.long T930
.long T930
.long T930
.long T930
.long T930
.long T930
.long T930
.long T930
.long T938
.long T939
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T940
.long T940
.long T940
.long T940
.long T940
.long T940
.long T940
.long T940
.long T948
.long T948
.long T948
.long T948
.long T948
.long T948
.long T948
.long T948
.long T950
.long T950
.long T950
.long T950
.long T950
.long T950
.long T950
.long T950
.long T958
.long T958
.long T958
.long T958
.long T958
.long T958
.long T958
.long T958
.long T960
.long T960
.long T960
.long T960
.long T960
.long T960
.long T960
.long T960
.long T968
.long T968
.long T968
.long T968
.long T968
.long T968
.long T968
.long T968
.long T970
.long T970
.long T970
.long T970
.long T970
.long T970
.long T970
.long T970
.long T978
.long T979
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T980
.long T980
.long T980
.long T980
.long T980
.long T980
.long T980
.long T980
.long T988
.long T988
.long T988
.long T988
.long T988
.long T988
.long T988
.long T988
.long T990
.long T990
.long T990
.long T990
.long T990
.long T990
.long T990
.long T990
.long T998
.long T998
.long T998
.long T998
.long T998
.long T998
.long T998
.long T998
.long T9A0
.long T9A0
.long T9A0
.long T9A0
.long T9A0
.long T9A0
.long T9A0
.long T9A0
.long T9A8
.long T9A8
.long T9A8
.long T9A8
.long T9A8
.long T9A8
.long T9A8
.long T9A8
.long T9B0
.long T9B0
.long T9B0
.long T9B0
.long T9B0
.long T9B0
.long T9B0
.long T9B0
.long T9B8
.long T9B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long T9C0
.long T9C0
.long T9C0
.long T9C0
.long T9C0
.long T9C0
.long T9C0
.long T9C0
.long T9C8
.long T9C8
.long T9C8
.long T9C8
.long T9C8
.long T9C8
.long T9C8
.long T9C8
.long T9D0
.long T9D0
.long T9D0
.long T9D0
.long T9D0
.long T9D0
.long T9D0
.long T9D0
.long T9D8
.long T9D8
.long T9D8
.long T9D8
.long T9D8
.long T9D8
.long T9D8
.long T9D8
.long T9E0
.long T9E0
.long T9E0
.long T9E0
.long T9E0
.long T9E0
.long T9E0
.long T9E0
.long T9E8
.long T9E8
.long T9E8
.long T9E8
.long T9E8
.long T9E8
.long T9E8
.long T9E8
.long T9F0
.long T9F0
.long T9F0
.long T9F0
.long T9F0
.long T9F0
.long T9F0
.long T9F0
.long T9F8
.long T9F9
.long T9FA
.long T9FB
.long T9FC
.long r_illegal
.long r_illegal
.long r_illegal
.long TA00
.long TA00
.long TA00
.long TA00
.long TA00
.long TA00
.long TA00
.long TA00
.long TA08
.long TA08
.long TA08
.long TA08
.long TA08
.long TA08
.long TA08
.long TA08
.long TA10
.long TA10
.long TA10
.long TA10
.long TA10
.long TA10
.long TA10
.long TA10
.long TA18
.long TA18
.long TA18
.long TA18
.long TA18
.long TA18
.long TA18
.long TA18
.long TA20
.long TA20
.long TA20
.long TA20
.long TA20
.long TA20
.long TA20
.long TA20
.long TA28
.long TA28
.long TA28
.long TA28
.long TA28
.long TA28
.long TA28
.long TA28
.long TA30
.long TA30
.long TA30
.long TA30
.long TA30
.long TA30
.long TA30
.long TA30
.long TA38
.long TA39
.long TA3A
.long TA3B
.long TA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long TA40
.long TA40
.long TA40
.long TA40
.long TA40
.long TA40
.long TA40
.long TA40
.long TA48
.long TA48
.long TA48
.long TA48
.long TA48
.long TA48
.long TA48
.long TA48
.long TA50
.long TA50
.long TA50
.long TA50
.long TA50
.long TA50
.long TA50
.long TA50
.long TA58
.long TA58
.long TA58
.long TA58
.long TA58
.long TA58
.long TA58
.long TA58
.long TA60
.long TA60
.long TA60
.long TA60
.long TA60
.long TA60
.long TA60
.long TA60
.long TA68
.long TA68
.long TA68
.long TA68
.long TA68
.long TA68
.long TA68
.long TA68
.long TA70
.long TA70
.long TA70
.long TA70
.long TA70
.long TA70
.long TA70
.long TA70
.long TA78
.long TA79
.long TA7A
.long TA7B
.long TA7C
.long r_illegal
.long r_illegal
.long r_illegal
.long TA80
.long TA80
.long TA80
.long TA80
.long TA80
.long TA80
.long TA80
.long TA80
.long TA88
.long TA88
.long TA88
.long TA88
.long TA88
.long TA88
.long TA88
.long TA88
.long TA90
.long TA90
.long TA90
.long TA90
.long TA90
.long TA90
.long TA90
.long TA90
.long TA98
.long TA98
.long TA98
.long TA98
.long TA98
.long TA98
.long TA98
.long TA98
.long TAA0
.long TAA0
.long TAA0
.long TAA0
.long TAA0
.long TAA0
.long TAA0
.long TAA0
.long TAA8
.long TAA8
.long TAA8
.long TAA8
.long TAA8
.long TAA8
.long TAA8
.long TAA8
.long TAB0
.long TAB0
.long TAB0
.long TAB0
.long TAB0
.long TAB0
.long TAB0
.long TAB0
.long TAB8
.long TAB9
.long TABA
.long TABB
.long TABC
.long r_illegal
.long r_illegal
.long r_illegal
.long TAC0
.long TAC0
.long TAC0
.long TAC0
.long TAC0
.long TAC0
.long TAC0
.long TAC0
.long TAC8
.long TAC8
.long TAC8
.long TAC8
.long TAC8
.long TAC8
.long TAC8
.long TAC8
.long TAD0
.long TAD0
.long TAD0
.long TAD0
.long TAD0
.long TAD0
.long TAD0
.long TAD0
.long TAD8
.long TAD8
.long TAD8
.long TAD8
.long TAD8
.long TAD8
.long TAD8
.long TAD8
.long TAE0
.long TAE0
.long TAE0
.long TAE0
.long TAE0
.long TAE0
.long TAE0
.long TAE0
.long TAE8
.long TAE8
.long TAE8
.long TAE8
.long TAE8
.long TAE8
.long TAE8
.long TAE8
.long TAF0
.long TAF0
.long TAF0
.long TAF0
.long TAF0
.long TAF0
.long TAF0
.long TAF0
.long TAF8
.long TAF9
.long TAFA
.long TAFB
.long TAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long TB00
.long TB00
.long TB00
.long TB00
.long TB00
.long TB00
.long TB00
.long TB00
.long TB08
.long TB08
.long TB08
.long TB08
.long TB08
.long TB08
.long TB08
.long TB08
.long TB10
.long TB10
.long TB10
.long TB10
.long TB10
.long TB10
.long TB10
.long TB10
.long TB18
.long TB18
.long TB18
.long TB18
.long TB18
.long TB18
.long TB18
.long TB18
.long TB20
.long TB20
.long TB20
.long TB20
.long TB20
.long TB20
.long TB20
.long TB20
.long TB28
.long TB28
.long TB28
.long TB28
.long TB28
.long TB28
.long TB28
.long TB28
.long TB30
.long TB30
.long TB30
.long TB30
.long TB30
.long TB30
.long TB30
.long TB30
.long TB38
.long TB39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TB40
.long TB40
.long TB40
.long TB40
.long TB40
.long TB40
.long TB40
.long TB40
.long TB48
.long TB48
.long TB48
.long TB48
.long TB48
.long TB48
.long TB48
.long TB48
.long TB50
.long TB50
.long TB50
.long TB50
.long TB50
.long TB50
.long TB50
.long TB50
.long TB58
.long TB58
.long TB58
.long TB58
.long TB58
.long TB58
.long TB58
.long TB58
.long TB60
.long TB60
.long TB60
.long TB60
.long TB60
.long TB60
.long TB60
.long TB60
.long TB68
.long TB68
.long TB68
.long TB68
.long TB68
.long TB68
.long TB68
.long TB68
.long TB70
.long TB70
.long TB70
.long TB70
.long TB70
.long TB70
.long TB70
.long TB70
.long TB78
.long TB79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TB80
.long TB80
.long TB80
.long TB80
.long TB80
.long TB80
.long TB80
.long TB80
.long TB88
.long TB88
.long TB88
.long TB88
.long TB88
.long TB88
.long TB88
.long TB88
.long TB90
.long TB90
.long TB90
.long TB90
.long TB90
.long TB90
.long TB90
.long TB90
.long TB98
.long TB98
.long TB98
.long TB98
.long TB98
.long TB98
.long TB98
.long TB98
.long TBA0
.long TBA0
.long TBA0
.long TBA0
.long TBA0
.long TBA0
.long TBA0
.long TBA0
.long TBA8
.long TBA8
.long TBA8
.long TBA8
.long TBA8
.long TBA8
.long TBA8
.long TBA8
.long TBB0
.long TBB0
.long TBB0
.long TBB0
.long TBB0
.long TBB0
.long TBB0
.long TBB0
.long TBB8
.long TBB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TBC0
.long TBC0
.long TBC0
.long TBC0
.long TBC0
.long TBC0
.long TBC0
.long TBC0
.long TBC8
.long TBC8
.long TBC8
.long TBC8
.long TBC8
.long TBC8
.long TBC8
.long TBC8
.long TBD0
.long TBD0
.long TBD0
.long TBD0
.long TBD0
.long TBD0
.long TBD0
.long TBD0
.long TBD8
.long TBD8
.long TBD8
.long TBD8
.long TBD8
.long TBD8
.long TBD8
.long TBD8
.long TBE0
.long TBE0
.long TBE0
.long TBE0
.long TBE0
.long TBE0
.long TBE0
.long TBE0
.long TBE8
.long TBE8
.long TBE8
.long TBE8
.long TBE8
.long TBE8
.long TBE8
.long TBE8
.long TBF0
.long TBF0
.long TBF0
.long TBF0
.long TBF0
.long TBF0
.long TBF0
.long TBF0
.long TBF8
.long TBF9
.long TBFA
.long TBFB
.long TBFC
.long r_illegal
.long r_illegal
.long r_illegal
.long TC00
.long TC00
.long TC00
.long TC00
.long TC00
.long TC00
.long TC00
.long TC00
.long TC08
.long TC08
.long TC08
.long TC08
.long TC08
.long TC08
.long TC08
.long TC08
.long TC10
.long TC10
.long TC10
.long TC10
.long TC10
.long TC10
.long TC10
.long TC10
.long TC18
.long TC18
.long TC18
.long TC18
.long TC18
.long TC18
.long TC18
.long TC18
.long TC20
.long TC20
.long TC20
.long TC20
.long TC20
.long TC20
.long TC20
.long TC20
.long TC28
.long TC28
.long TC28
.long TC28
.long TC28
.long TC28
.long TC28
.long TC28
.long TC30
.long TC30
.long TC30
.long TC30
.long TC30
.long TC30
.long TC30
.long TC30
.long TC38
.long TC39
.long TC3A
.long TC3B
.long TC3C
.long r_illegal
.long r_illegal
.long r_illegal
.long TC40
.long TC40
.long TC40
.long TC40
.long TC40
.long TC40
.long TC40
.long TC40
.long TC48
.long TC48
.long TC48
.long TC48
.long TC48
.long TC48
.long TC48
.long TC48
.long TC50
.long TC50
.long TC50
.long TC50
.long TC50
.long TC50
.long TC50
.long TC50
.long TC58
.long TC58
.long TC58
.long TC58
.long TC58
.long TC58
.long TC58
.long TC58
.long TC60
.long TC60
.long TC60
.long TC60
.long TC60
.long TC60
.long TC60
.long TC60
.long TC68
.long TC68
.long TC68
.long TC68
.long TC68
.long TC68
.long TC68
.long TC68
.long TC70
.long TC70
.long TC70
.long TC70
.long TC70
.long TC70
.long TC70
.long TC70
.long TC78
.long TC79
.long TC7A
.long TC7B
.long TC7C
.long r_illegal
.long r_illegal
.long r_illegal
.long TC80
.long TC80
.long TC80
.long TC80
.long TC80
.long TC80
.long TC80
.long TC80
.long TC88
.long TC88
.long TC88
.long TC88
.long TC88
.long TC88
.long TC88
.long TC88
.long TC90
.long TC90
.long TC90
.long TC90
.long TC90
.long TC90
.long TC90
.long TC90
.long TC98
.long TC98
.long TC98
.long TC98
.long TC98
.long TC98
.long TC98
.long TC98
.long TCA0
.long TCA0
.long TCA0
.long TCA0
.long TCA0
.long TCA0
.long TCA0
.long TCA0
.long TCA8
.long TCA8
.long TCA8
.long TCA8
.long TCA8
.long TCA8
.long TCA8
.long TCA8
.long TCB0
.long TCB0
.long TCB0
.long TCB0
.long TCB0
.long TCB0
.long TCB0
.long TCB0
.long TCB8
.long TCB9
.long TCBA
.long TCBB
.long TCBC
.long r_illegal
.long r_illegal
.long r_illegal
.long TCC0
.long TCC0
.long TCC0
.long TCC0
.long TCC0
.long TCC0
.long TCC0
.long TCC0
.long TCC8
.long TCC8
.long TCC8
.long TCC8
.long TCC8
.long TCC8
.long TCC8
.long TCC8
.long TCD0
.long TCD0
.long TCD0
.long TCD0
.long TCD0
.long TCD0
.long TCD0
.long TCD0
.long TCD8
.long TCD8
.long TCD8
.long TCD8
.long TCD8
.long TCD8
.long TCD8
.long TCD8
.long TCE0
.long TCE0
.long TCE0
.long TCE0
.long TCE0
.long TCE0
.long TCE0
.long TCE0
.long TCE8
.long TCE8
.long TCE8
.long TCE8
.long TCE8
.long TCE8
.long TCE8
.long TCE8
.long TCF0
.long TCF0
.long TCF0
.long TCF0
.long TCF0
.long TCF0
.long TCF0
.long TCF0
.long TCF8
.long TCF9
.long TCFA
.long TCFB
.long TCFC
.long r_illegal
.long r_illegal
.long r_illegal
.long TD00
.long TD00
.long TD00
.long TD00
.long TD00
.long TD00
.long TD00
.long TD00
.long TD08
.long TD08
.long TD08
.long TD08
.long TD08
.long TD08
.long TD08
.long TD08
.long TD10
.long TD10
.long TD10
.long TD10
.long TD10
.long TD10
.long TD10
.long TD10
.long TD18
.long TD18
.long TD18
.long TD18
.long TD18
.long TD18
.long TD18
.long TD18
.long TD20
.long TD20
.long TD20
.long TD20
.long TD20
.long TD20
.long TD20
.long TD20
.long TD28
.long TD28
.long TD28
.long TD28
.long TD28
.long TD28
.long TD28
.long TD28
.long TD30
.long TD30
.long TD30
.long TD30
.long TD30
.long TD30
.long TD30
.long TD30
.long TD38
.long TD39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TD40
.long TD40
.long TD40
.long TD40
.long TD40
.long TD40
.long TD40
.long TD40
.long TD48
.long TD48
.long TD48
.long TD48
.long TD48
.long TD48
.long TD48
.long TD48
.long TD50
.long TD50
.long TD50
.long TD50
.long TD50
.long TD50
.long TD50
.long TD50
.long TD58
.long TD58
.long TD58
.long TD58
.long TD58
.long TD58
.long TD58
.long TD58
.long TD60
.long TD60
.long TD60
.long TD60
.long TD60
.long TD60
.long TD60
.long TD60
.long TD68
.long TD68
.long TD68
.long TD68
.long TD68
.long TD68
.long TD68
.long TD68
.long TD70
.long TD70
.long TD70
.long TD70
.long TD70
.long TD70
.long TD70
.long TD70
.long TD78
.long TD79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TD80
.long TD80
.long TD80
.long TD80
.long TD80
.long TD80
.long TD80
.long TD80
.long TD88
.long TD88
.long TD88
.long TD88
.long TD88
.long TD88
.long TD88
.long TD88
.long TD90
.long TD90
.long TD90
.long TD90
.long TD90
.long TD90
.long TD90
.long TD90
.long TD98
.long TD98
.long TD98
.long TD98
.long TD98
.long TD98
.long TD98
.long TD98
.long TDA0
.long TDA0
.long TDA0
.long TDA0
.long TDA0
.long TDA0
.long TDA0
.long TDA0
.long TDA8
.long TDA8
.long TDA8
.long TDA8
.long TDA8
.long TDA8
.long TDA8
.long TDA8
.long TDB0
.long TDB0
.long TDB0
.long TDB0
.long TDB0
.long TDB0
.long TDB0
.long TDB0
.long TDB8
.long TDB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TDC0
.long TDC0
.long TDC0
.long TDC0
.long TDC0
.long TDC0
.long TDC0
.long TDC0
.long TDC8
.long TDC8
.long TDC8
.long TDC8
.long TDC8
.long TDC8
.long TDC8
.long TDC8
.long TDD0
.long TDD0
.long TDD0
.long TDD0
.long TDD0
.long TDD0
.long TDD0
.long TDD0
.long TDD8
.long TDD8
.long TDD8
.long TDD8
.long TDD8
.long TDD8
.long TDD8
.long TDD8
.long TDE0
.long TDE0
.long TDE0
.long TDE0
.long TDE0
.long TDE0
.long TDE0
.long TDE0
.long TDE8
.long TDE8
.long TDE8
.long TDE8
.long TDE8
.long TDE8
.long TDE8
.long TDE8
.long TDF0
.long TDF0
.long TDF0
.long TDF0
.long TDF0
.long TDF0
.long TDF0
.long TDF0
.long TDF8
.long TDF9
.long TDFA
.long TDFB
.long TDFC
.long r_illegal
.long r_illegal
.long r_illegal
.long TE00
.long TE00
.long TE00
.long TE00
.long TE00
.long TE00
.long TE00
.long TE00
.long TE08
.long TE08
.long TE08
.long TE08
.long TE08
.long TE08
.long TE08
.long TE08
.long TE10
.long TE10
.long TE10
.long TE10
.long TE10
.long TE10
.long TE10
.long TE10
.long TE18
.long TE18
.long TE18
.long TE18
.long TE18
.long TE18
.long TE18
.long TE18
.long TE20
.long TE20
.long TE20
.long TE20
.long TE20
.long TE20
.long TE20
.long TE20
.long TE28
.long TE28
.long TE28
.long TE28
.long TE28
.long TE28
.long TE28
.long TE28
.long TE30
.long TE30
.long TE30
.long TE30
.long TE30
.long TE30
.long TE30
.long TE30
.long TE38
.long TE39
.long TE3A
.long TE3B
.long TE3C
.long r_illegal
.long r_illegal
.long r_illegal
.long TE40
.long TE40
.long TE40
.long TE40
.long TE40
.long TE40
.long TE40
.long TE40
.long TE48
.long TE48
.long TE48
.long TE48
.long TE48
.long TE48
.long TE48
.long TE48
.long TE50
.long TE50
.long TE50
.long TE50
.long TE50
.long TE50
.long TE50
.long TE50
.long TE58
.long TE58
.long TE58
.long TE58
.long TE58
.long TE58
.long TE58
.long TE58
.long TE60
.long TE60
.long TE60
.long TE60
.long TE60
.long TE60
.long TE60
.long TE60
.long TE68
.long TE68
.long TE68
.long TE68
.long TE68
.long TE68
.long TE68
.long TE68
.long TE70
.long TE70
.long TE70
.long TE70
.long TE70
.long TE70
.long TE70
.long TE70
.long TE78
.long TE79
.long TE7A
.long TE7B
.long TE7C
.long r_illegal
.long r_illegal
.long r_illegal
.long TE80
.long TE80
.long TE80
.long TE80
.long TE80
.long TE80
.long TE80
.long TE80
.long TE88
.long TE88
.long TE88
.long TE88
.long TE88
.long TE88
.long TE88
.long TE88
.long TE90
.long TE90
.long TE90
.long TE90
.long TE90
.long TE90
.long TE90
.long TE90
.long TE98
.long TE98
.long TE98
.long TE98
.long TE98
.long TE98
.long TE98
.long TE98
.long TEA0
.long TEA0
.long TEA0
.long TEA0
.long TEA0
.long TEA0
.long TEA0
.long TEA0
.long TEA8
.long TEA8
.long TEA8
.long TEA8
.long TEA8
.long TEA8
.long TEA8
.long TEA8
.long TEB0
.long TEB0
.long TEB0
.long TEB0
.long TEB0
.long TEB0
.long TEB0
.long TEB0
.long TEB8
.long TEB9
.long TEBA
.long TEBB
.long TEBC
.long r_illegal
.long r_illegal
.long r_illegal
.long TEC0
.long TEC0
.long TEC0
.long TEC0
.long TEC0
.long TEC0
.long TEC0
.long TEC0
.long TEC8
.long TEC8
.long TEC8
.long TEC8
.long TEC8
.long TEC8
.long TEC8
.long TEC8
.long TED0
.long TED0
.long TED0
.long TED0
.long TED0
.long TED0
.long TED0
.long TED0
.long TED8
.long TED8
.long TED8
.long TED8
.long TED8
.long TED8
.long TED8
.long TED8
.long TEE0
.long TEE0
.long TEE0
.long TEE0
.long TEE0
.long TEE0
.long TEE0
.long TEE0
.long TEE8
.long TEE8
.long TEE8
.long TEE8
.long TEE8
.long TEE8
.long TEE8
.long TEE8
.long TEF0
.long TEF0
.long TEF0
.long TEF0
.long TEF0
.long TEF0
.long TEF0
.long TEF0
.long TEF8
.long TEF9
.long TEFA
.long TEFB
.long TEFC
.long r_illegal
.long r_illegal
.long r_illegal
.long TF00
.long TF00
.long TF00
.long TF00
.long TF00
.long TF00
.long TF00
.long TF00
.long TF08
.long TF08
.long TF08
.long TF08
.long TF08
.long TF08
.long TF08
.long TF08
.long TF10
.long TF10
.long TF10
.long TF10
.long TF10
.long TF10
.long TF10
.long TF10
.long TF18
.long TF18
.long TF18
.long TF18
.long TF18
.long TF18
.long TF18
.long TF18
.long TF20
.long TF20
.long TF20
.long TF20
.long TF20
.long TF20
.long TF20
.long TF20
.long TF28
.long TF28
.long TF28
.long TF28
.long TF28
.long TF28
.long TF28
.long TF28
.long TF30
.long TF30
.long TF30
.long TF30
.long TF30
.long TF30
.long TF30
.long TF30
.long TF38
.long TF39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TF40
.long TF40
.long TF40
.long TF40
.long TF40
.long TF40
.long TF40
.long TF40
.long TF48
.long TF48
.long TF48
.long TF48
.long TF48
.long TF48
.long TF48
.long TF48
.long TF50
.long TF50
.long TF50
.long TF50
.long TF50
.long TF50
.long TF50
.long TF50
.long TF58
.long TF58
.long TF58
.long TF58
.long TF58
.long TF58
.long TF58
.long TF58
.long TF60
.long TF60
.long TF60
.long TF60
.long TF60
.long TF60
.long TF60
.long TF60
.long TF68
.long TF68
.long TF68
.long TF68
.long TF68
.long TF68
.long TF68
.long TF68
.long TF70
.long TF70
.long TF70
.long TF70
.long TF70
.long TF70
.long TF70
.long TF70
.long TF78
.long TF79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TF80
.long TF80
.long TF80
.long TF80
.long TF80
.long TF80
.long TF80
.long TF80
.long TF88
.long TF88
.long TF88
.long TF88
.long TF88
.long TF88
.long TF88
.long TF88
.long TF90
.long TF90
.long TF90
.long TF90
.long TF90
.long TF90
.long TF90
.long TF90
.long TF98
.long TF98
.long TF98
.long TF98
.long TF98
.long TF98
.long TF98
.long TF98
.long TFA0
.long TFA0
.long TFA0
.long TFA0
.long TFA0
.long TFA0
.long TFA0
.long TFA0
.long TFA8
.long TFA8
.long TFA8
.long TFA8
.long TFA8
.long TFA8
.long TFA8
.long TFA8
.long TFB0
.long TFB0
.long TFB0
.long TFB0
.long TFB0
.long TFB0
.long TFB0
.long TFB0
.long TFB8
.long TFB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long TFC0
.long TFC0
.long TFC0
.long TFC0
.long TFC0
.long TFC0
.long TFC0
.long TFC0
.long TFC8
.long TFC8
.long TFC8
.long TFC8
.long TFC8
.long TFC8
.long TFC8
.long TFC8
.long TFD0
.long TFD0
.long TFD0
.long TFD0
.long TFD0
.long TFD0
.long TFD0
.long TFD0
.long TFD8
.long TFD8
.long TFD8
.long TFD8
.long TFD8
.long TFD8
.long TFD8
.long TFD8
.long TFE0
.long TFE0
.long TFE0
.long TFE0
.long TFE0
.long TFE0
.long TFE0
.long TFE0
.long TFE8
.long TFE8
.long TFE8
.long TFE8
.long TFE8
.long TFE8
.long TFE8
.long TFE8
.long TFF0
.long TFF0
.long TFF0
.long TFF0
.long TFF0
.long TFF0
.long TFF0
.long TFF0
.long TFF8
.long TFF9
.long TFFA
.long TFFB
.long TFFC
.long r_illegal
.long r_illegal
.long r_illegal
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long U000
.long V000
.long V000
.long V000
.long V000
.long V000
.long V000
.long V000
.long V000
.long V008
.long V008
.long V008
.long V008
.long V008
.long V008
.long V008
.long V008
.long V010
.long V010
.long V010
.long V010
.long V010
.long V010
.long V010
.long V010
.long V018
.long V018
.long V018
.long V018
.long V018
.long V018
.long V018
.long V018
.long V020
.long V020
.long V020
.long V020
.long V020
.long V020
.long V020
.long V020
.long V028
.long V028
.long V028
.long V028
.long V028
.long V028
.long V028
.long V028
.long V030
.long V030
.long V030
.long V030
.long V030
.long V030
.long V030
.long V030
.long V038
.long V039
.long V03A
.long V03B
.long V03C
.long r_illegal
.long r_illegal
.long r_illegal
.long V040
.long V040
.long V040
.long V040
.long V040
.long V040
.long V040
.long V040
.long V048
.long V048
.long V048
.long V048
.long V048
.long V048
.long V048
.long V048
.long V050
.long V050
.long V050
.long V050
.long V050
.long V050
.long V050
.long V050
.long V058
.long V058
.long V058
.long V058
.long V058
.long V058
.long V058
.long V058
.long V060
.long V060
.long V060
.long V060
.long V060
.long V060
.long V060
.long V060
.long V068
.long V068
.long V068
.long V068
.long V068
.long V068
.long V068
.long V068
.long V070
.long V070
.long V070
.long V070
.long V070
.long V070
.long V070
.long V070
.long V078
.long V079
.long V07A
.long V07B
.long V07C
.long r_illegal
.long r_illegal
.long r_illegal
.long V080
.long V080
.long V080
.long V080
.long V080
.long V080
.long V080
.long V080
.long V088
.long V088
.long V088
.long V088
.long V088
.long V088
.long V088
.long V088
.long V090
.long V090
.long V090
.long V090
.long V090
.long V090
.long V090
.long V090
.long V098
.long V098
.long V098
.long V098
.long V098
.long V098
.long V098
.long V098
.long V0A0
.long V0A0
.long V0A0
.long V0A0
.long V0A0
.long V0A0
.long V0A0
.long V0A0
.long V0A8
.long V0A8
.long V0A8
.long V0A8
.long V0A8
.long V0A8
.long V0A8
.long V0A8
.long V0B0
.long V0B0
.long V0B0
.long V0B0
.long V0B0
.long V0B0
.long V0B0
.long V0B0
.long V0B8
.long V0B9
.long V0BA
.long V0BB
.long V0BC
.long r_illegal
.long r_illegal
.long r_illegal
.long V0C0
.long V0C0
.long V0C0
.long V0C0
.long V0C0
.long V0C0
.long V0C0
.long V0C0
.long V0C8
.long V0C8
.long V0C8
.long V0C8
.long V0C8
.long V0C8
.long V0C8
.long V0C8
.long V0D0
.long V0D0
.long V0D0
.long V0D0
.long V0D0
.long V0D0
.long V0D0
.long V0D0
.long V0D8
.long V0D8
.long V0D8
.long V0D8
.long V0D8
.long V0D8
.long V0D8
.long V0D8
.long V0E0
.long V0E0
.long V0E0
.long V0E0
.long V0E0
.long V0E0
.long V0E0
.long V0E0
.long V0E8
.long V0E8
.long V0E8
.long V0E8
.long V0E8
.long V0E8
.long V0E8
.long V0E8
.long V0F0
.long V0F0
.long V0F0
.long V0F0
.long V0F0
.long V0F0
.long V0F0
.long V0F0
.long V0F8
.long V0F9
.long V0FA
.long V0FB
.long V0FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V100
.long V100
.long V100
.long V100
.long V100
.long V100
.long V100
.long V100
.long V108
.long V108
.long V108
.long V108
.long V108
.long V108
.long V108
.long V108
.long V110
.long V110
.long V110
.long V110
.long V110
.long V110
.long V110
.long V110
.long V118
.long V118
.long V118
.long V118
.long V118
.long V118
.long V118
.long V118
.long V120
.long V120
.long V120
.long V120
.long V120
.long V120
.long V120
.long V120
.long V128
.long V128
.long V128
.long V128
.long V128
.long V128
.long V128
.long V128
.long V130
.long V130
.long V130
.long V130
.long V130
.long V130
.long V130
.long V130
.long V138
.long V139
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V140
.long V140
.long V140
.long V140
.long V140
.long V140
.long V140
.long V140
.long V148
.long V148
.long V148
.long V148
.long V148
.long V148
.long V148
.long V148
.long V150
.long V150
.long V150
.long V150
.long V150
.long V150
.long V150
.long V150
.long V158
.long V158
.long V158
.long V158
.long V158
.long V158
.long V158
.long V158
.long V160
.long V160
.long V160
.long V160
.long V160
.long V160
.long V160
.long V160
.long V168
.long V168
.long V168
.long V168
.long V168
.long V168
.long V168
.long V168
.long V170
.long V170
.long V170
.long V170
.long V170
.long V170
.long V170
.long V170
.long V178
.long V179
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V180
.long V180
.long V180
.long V180
.long V180
.long V180
.long V180
.long V180
.long V188
.long V188
.long V188
.long V188
.long V188
.long V188
.long V188
.long V188
.long V190
.long V190
.long V190
.long V190
.long V190
.long V190
.long V190
.long V190
.long V198
.long V198
.long V198
.long V198
.long V198
.long V198
.long V198
.long V198
.long V1A0
.long V1A0
.long V1A0
.long V1A0
.long V1A0
.long V1A0
.long V1A0
.long V1A0
.long V1A8
.long V1A8
.long V1A8
.long V1A8
.long V1A8
.long V1A8
.long V1A8
.long V1A8
.long V1B0
.long V1B0
.long V1B0
.long V1B0
.long V1B0
.long V1B0
.long V1B0
.long V1B0
.long V1B8
.long V1B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V1C0
.long V1C0
.long V1C0
.long V1C0
.long V1C0
.long V1C0
.long V1C0
.long V1C0
.long V1C8
.long V1C8
.long V1C8
.long V1C8
.long V1C8
.long V1C8
.long V1C8
.long V1C8
.long V1D0
.long V1D0
.long V1D0
.long V1D0
.long V1D0
.long V1D0
.long V1D0
.long V1D0
.long V1D8
.long V1D8
.long V1D8
.long V1D8
.long V1D8
.long V1D8
.long V1D8
.long V1D8
.long V1E0
.long V1E0
.long V1E0
.long V1E0
.long V1E0
.long V1E0
.long V1E0
.long V1E0
.long V1E8
.long V1E8
.long V1E8
.long V1E8
.long V1E8
.long V1E8
.long V1E8
.long V1E8
.long V1F0
.long V1F0
.long V1F0
.long V1F0
.long V1F0
.long V1F0
.long V1F0
.long V1F0
.long V1F8
.long V1F9
.long V1FA
.long V1FB
.long V1FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V200
.long V200
.long V200
.long V200
.long V200
.long V200
.long V200
.long V200
.long V208
.long V208
.long V208
.long V208
.long V208
.long V208
.long V208
.long V208
.long V210
.long V210
.long V210
.long V210
.long V210
.long V210
.long V210
.long V210
.long V218
.long V218
.long V218
.long V218
.long V218
.long V218
.long V218
.long V218
.long V220
.long V220
.long V220
.long V220
.long V220
.long V220
.long V220
.long V220
.long V228
.long V228
.long V228
.long V228
.long V228
.long V228
.long V228
.long V228
.long V230
.long V230
.long V230
.long V230
.long V230
.long V230
.long V230
.long V230
.long V238
.long V239
.long V23A
.long V23B
.long V23C
.long r_illegal
.long r_illegal
.long r_illegal
.long V240
.long V240
.long V240
.long V240
.long V240
.long V240
.long V240
.long V240
.long V248
.long V248
.long V248
.long V248
.long V248
.long V248
.long V248
.long V248
.long V250
.long V250
.long V250
.long V250
.long V250
.long V250
.long V250
.long V250
.long V258
.long V258
.long V258
.long V258
.long V258
.long V258
.long V258
.long V258
.long V260
.long V260
.long V260
.long V260
.long V260
.long V260
.long V260
.long V260
.long V268
.long V268
.long V268
.long V268
.long V268
.long V268
.long V268
.long V268
.long V270
.long V270
.long V270
.long V270
.long V270
.long V270
.long V270
.long V270
.long V278
.long V279
.long V27A
.long V27B
.long V27C
.long r_illegal
.long r_illegal
.long r_illegal
.long V280
.long V280
.long V280
.long V280
.long V280
.long V280
.long V280
.long V280
.long V288
.long V288
.long V288
.long V288
.long V288
.long V288
.long V288
.long V288
.long V290
.long V290
.long V290
.long V290
.long V290
.long V290
.long V290
.long V290
.long V298
.long V298
.long V298
.long V298
.long V298
.long V298
.long V298
.long V298
.long V2A0
.long V2A0
.long V2A0
.long V2A0
.long V2A0
.long V2A0
.long V2A0
.long V2A0
.long V2A8
.long V2A8
.long V2A8
.long V2A8
.long V2A8
.long V2A8
.long V2A8
.long V2A8
.long V2B0
.long V2B0
.long V2B0
.long V2B0
.long V2B0
.long V2B0
.long V2B0
.long V2B0
.long V2B8
.long V2B9
.long V2BA
.long V2BB
.long V2BC
.long r_illegal
.long r_illegal
.long r_illegal
.long V2C0
.long V2C0
.long V2C0
.long V2C0
.long V2C0
.long V2C0
.long V2C0
.long V2C0
.long V2C8
.long V2C8
.long V2C8
.long V2C8
.long V2C8
.long V2C8
.long V2C8
.long V2C8
.long V2D0
.long V2D0
.long V2D0
.long V2D0
.long V2D0
.long V2D0
.long V2D0
.long V2D0
.long V2D8
.long V2D8
.long V2D8
.long V2D8
.long V2D8
.long V2D8
.long V2D8
.long V2D8
.long V2E0
.long V2E0
.long V2E0
.long V2E0
.long V2E0
.long V2E0
.long V2E0
.long V2E0
.long V2E8
.long V2E8
.long V2E8
.long V2E8
.long V2E8
.long V2E8
.long V2E8
.long V2E8
.long V2F0
.long V2F0
.long V2F0
.long V2F0
.long V2F0
.long V2F0
.long V2F0
.long V2F0
.long V2F8
.long V2F9
.long V2FA
.long V2FB
.long V2FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V300
.long V300
.long V300
.long V300
.long V300
.long V300
.long V300
.long V300
.long V308
.long V308
.long V308
.long V308
.long V308
.long V308
.long V308
.long V308
.long V310
.long V310
.long V310
.long V310
.long V310
.long V310
.long V310
.long V310
.long V318
.long V318
.long V318
.long V318
.long V318
.long V318
.long V318
.long V318
.long V320
.long V320
.long V320
.long V320
.long V320
.long V320
.long V320
.long V320
.long V328
.long V328
.long V328
.long V328
.long V328
.long V328
.long V328
.long V328
.long V330
.long V330
.long V330
.long V330
.long V330
.long V330
.long V330
.long V330
.long V338
.long V339
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V340
.long V340
.long V340
.long V340
.long V340
.long V340
.long V340
.long V340
.long V348
.long V348
.long V348
.long V348
.long V348
.long V348
.long V348
.long V348
.long V350
.long V350
.long V350
.long V350
.long V350
.long V350
.long V350
.long V350
.long V358
.long V358
.long V358
.long V358
.long V358
.long V358
.long V358
.long V358
.long V360
.long V360
.long V360
.long V360
.long V360
.long V360
.long V360
.long V360
.long V368
.long V368
.long V368
.long V368
.long V368
.long V368
.long V368
.long V368
.long V370
.long V370
.long V370
.long V370
.long V370
.long V370
.long V370
.long V370
.long V378
.long V379
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V380
.long V380
.long V380
.long V380
.long V380
.long V380
.long V380
.long V380
.long V388
.long V388
.long V388
.long V388
.long V388
.long V388
.long V388
.long V388
.long V390
.long V390
.long V390
.long V390
.long V390
.long V390
.long V390
.long V390
.long V398
.long V398
.long V398
.long V398
.long V398
.long V398
.long V398
.long V398
.long V3A0
.long V3A0
.long V3A0
.long V3A0
.long V3A0
.long V3A0
.long V3A0
.long V3A0
.long V3A8
.long V3A8
.long V3A8
.long V3A8
.long V3A8
.long V3A8
.long V3A8
.long V3A8
.long V3B0
.long V3B0
.long V3B0
.long V3B0
.long V3B0
.long V3B0
.long V3B0
.long V3B0
.long V3B8
.long V3B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V3C0
.long V3C0
.long V3C0
.long V3C0
.long V3C0
.long V3C0
.long V3C0
.long V3C0
.long V3C8
.long V3C8
.long V3C8
.long V3C8
.long V3C8
.long V3C8
.long V3C8
.long V3C8
.long V3D0
.long V3D0
.long V3D0
.long V3D0
.long V3D0
.long V3D0
.long V3D0
.long V3D0
.long V3D8
.long V3D8
.long V3D8
.long V3D8
.long V3D8
.long V3D8
.long V3D8
.long V3D8
.long V3E0
.long V3E0
.long V3E0
.long V3E0
.long V3E0
.long V3E0
.long V3E0
.long V3E0
.long V3E8
.long V3E8
.long V3E8
.long V3E8
.long V3E8
.long V3E8
.long V3E8
.long V3E8
.long V3F0
.long V3F0
.long V3F0
.long V3F0
.long V3F0
.long V3F0
.long V3F0
.long V3F0
.long V3F8
.long V3F9
.long V3FA
.long V3FB
.long V3FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V400
.long V400
.long V400
.long V400
.long V400
.long V400
.long V400
.long V400
.long V408
.long V408
.long V408
.long V408
.long V408
.long V408
.long V408
.long V408
.long V410
.long V410
.long V410
.long V410
.long V410
.long V410
.long V410
.long V410
.long V418
.long V418
.long V418
.long V418
.long V418
.long V418
.long V418
.long V418
.long V420
.long V420
.long V420
.long V420
.long V420
.long V420
.long V420
.long V420
.long V428
.long V428
.long V428
.long V428
.long V428
.long V428
.long V428
.long V428
.long V430
.long V430
.long V430
.long V430
.long V430
.long V430
.long V430
.long V430
.long V438
.long V439
.long V43A
.long V43B
.long V43C
.long r_illegal
.long r_illegal
.long r_illegal
.long V440
.long V440
.long V440
.long V440
.long V440
.long V440
.long V440
.long V440
.long V448
.long V448
.long V448
.long V448
.long V448
.long V448
.long V448
.long V448
.long V450
.long V450
.long V450
.long V450
.long V450
.long V450
.long V450
.long V450
.long V458
.long V458
.long V458
.long V458
.long V458
.long V458
.long V458
.long V458
.long V460
.long V460
.long V460
.long V460
.long V460
.long V460
.long V460
.long V460
.long V468
.long V468
.long V468
.long V468
.long V468
.long V468
.long V468
.long V468
.long V470
.long V470
.long V470
.long V470
.long V470
.long V470
.long V470
.long V470
.long V478
.long V479
.long V47A
.long V47B
.long V47C
.long r_illegal
.long r_illegal
.long r_illegal
.long V480
.long V480
.long V480
.long V480
.long V480
.long V480
.long V480
.long V480
.long V488
.long V488
.long V488
.long V488
.long V488
.long V488
.long V488
.long V488
.long V490
.long V490
.long V490
.long V490
.long V490
.long V490
.long V490
.long V490
.long V498
.long V498
.long V498
.long V498
.long V498
.long V498
.long V498
.long V498
.long V4A0
.long V4A0
.long V4A0
.long V4A0
.long V4A0
.long V4A0
.long V4A0
.long V4A0
.long V4A8
.long V4A8
.long V4A8
.long V4A8
.long V4A8
.long V4A8
.long V4A8
.long V4A8
.long V4B0
.long V4B0
.long V4B0
.long V4B0
.long V4B0
.long V4B0
.long V4B0
.long V4B0
.long V4B8
.long V4B9
.long V4BA
.long V4BB
.long V4BC
.long r_illegal
.long r_illegal
.long r_illegal
.long V4C0
.long V4C0
.long V4C0
.long V4C0
.long V4C0
.long V4C0
.long V4C0
.long V4C0
.long V4C8
.long V4C8
.long V4C8
.long V4C8
.long V4C8
.long V4C8
.long V4C8
.long V4C8
.long V4D0
.long V4D0
.long V4D0
.long V4D0
.long V4D0
.long V4D0
.long V4D0
.long V4D0
.long V4D8
.long V4D8
.long V4D8
.long V4D8
.long V4D8
.long V4D8
.long V4D8
.long V4D8
.long V4E0
.long V4E0
.long V4E0
.long V4E0
.long V4E0
.long V4E0
.long V4E0
.long V4E0
.long V4E8
.long V4E8
.long V4E8
.long V4E8
.long V4E8
.long V4E8
.long V4E8
.long V4E8
.long V4F0
.long V4F0
.long V4F0
.long V4F0
.long V4F0
.long V4F0
.long V4F0
.long V4F0
.long V4F8
.long V4F9
.long V4FA
.long V4FB
.long V4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V500
.long V500
.long V500
.long V500
.long V500
.long V500
.long V500
.long V500
.long V508
.long V508
.long V508
.long V508
.long V508
.long V508
.long V508
.long V508
.long V510
.long V510
.long V510
.long V510
.long V510
.long V510
.long V510
.long V510
.long V518
.long V518
.long V518
.long V518
.long V518
.long V518
.long V518
.long V518
.long V520
.long V520
.long V520
.long V520
.long V520
.long V520
.long V520
.long V520
.long V528
.long V528
.long V528
.long V528
.long V528
.long V528
.long V528
.long V528
.long V530
.long V530
.long V530
.long V530
.long V530
.long V530
.long V530
.long V530
.long V538
.long V539
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V540
.long V540
.long V540
.long V540
.long V540
.long V540
.long V540
.long V540
.long V548
.long V548
.long V548
.long V548
.long V548
.long V548
.long V548
.long V548
.long V550
.long V550
.long V550
.long V550
.long V550
.long V550
.long V550
.long V550
.long V558
.long V558
.long V558
.long V558
.long V558
.long V558
.long V558
.long V558
.long V560
.long V560
.long V560
.long V560
.long V560
.long V560
.long V560
.long V560
.long V568
.long V568
.long V568
.long V568
.long V568
.long V568
.long V568
.long V568
.long V570
.long V570
.long V570
.long V570
.long V570
.long V570
.long V570
.long V570
.long V578
.long V579
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V580
.long V580
.long V580
.long V580
.long V580
.long V580
.long V580
.long V580
.long V588
.long V588
.long V588
.long V588
.long V588
.long V588
.long V588
.long V588
.long V590
.long V590
.long V590
.long V590
.long V590
.long V590
.long V590
.long V590
.long V598
.long V598
.long V598
.long V598
.long V598
.long V598
.long V598
.long V598
.long V5A0
.long V5A0
.long V5A0
.long V5A0
.long V5A0
.long V5A0
.long V5A0
.long V5A0
.long V5A8
.long V5A8
.long V5A8
.long V5A8
.long V5A8
.long V5A8
.long V5A8
.long V5A8
.long V5B0
.long V5B0
.long V5B0
.long V5B0
.long V5B0
.long V5B0
.long V5B0
.long V5B0
.long V5B8
.long V5B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V5C0
.long V5C0
.long V5C0
.long V5C0
.long V5C0
.long V5C0
.long V5C0
.long V5C0
.long V5C8
.long V5C8
.long V5C8
.long V5C8
.long V5C8
.long V5C8
.long V5C8
.long V5C8
.long V5D0
.long V5D0
.long V5D0
.long V5D0
.long V5D0
.long V5D0
.long V5D0
.long V5D0
.long V5D8
.long V5D8
.long V5D8
.long V5D8
.long V5D8
.long V5D8
.long V5D8
.long V5D8
.long V5E0
.long V5E0
.long V5E0
.long V5E0
.long V5E0
.long V5E0
.long V5E0
.long V5E0
.long V5E8
.long V5E8
.long V5E8
.long V5E8
.long V5E8
.long V5E8
.long V5E8
.long V5E8
.long V5F0
.long V5F0
.long V5F0
.long V5F0
.long V5F0
.long V5F0
.long V5F0
.long V5F0
.long V5F8
.long V5F9
.long V5FA
.long V5FB
.long V5FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V600
.long V600
.long V600
.long V600
.long V600
.long V600
.long V600
.long V600
.long V608
.long V608
.long V608
.long V608
.long V608
.long V608
.long V608
.long V608
.long V610
.long V610
.long V610
.long V610
.long V610
.long V610
.long V610
.long V610
.long V618
.long V618
.long V618
.long V618
.long V618
.long V618
.long V618
.long V618
.long V620
.long V620
.long V620
.long V620
.long V620
.long V620
.long V620
.long V620
.long V628
.long V628
.long V628
.long V628
.long V628
.long V628
.long V628
.long V628
.long V630
.long V630
.long V630
.long V630
.long V630
.long V630
.long V630
.long V630
.long V638
.long V639
.long V63A
.long V63B
.long V63C
.long r_illegal
.long r_illegal
.long r_illegal
.long V640
.long V640
.long V640
.long V640
.long V640
.long V640
.long V640
.long V640
.long V648
.long V648
.long V648
.long V648
.long V648
.long V648
.long V648
.long V648
.long V650
.long V650
.long V650
.long V650
.long V650
.long V650
.long V650
.long V650
.long V658
.long V658
.long V658
.long V658
.long V658
.long V658
.long V658
.long V658
.long V660
.long V660
.long V660
.long V660
.long V660
.long V660
.long V660
.long V660
.long V668
.long V668
.long V668
.long V668
.long V668
.long V668
.long V668
.long V668
.long V670
.long V670
.long V670
.long V670
.long V670
.long V670
.long V670
.long V670
.long V678
.long V679
.long V67A
.long V67B
.long V67C
.long r_illegal
.long r_illegal
.long r_illegal
.long V680
.long V680
.long V680
.long V680
.long V680
.long V680
.long V680
.long V680
.long V688
.long V688
.long V688
.long V688
.long V688
.long V688
.long V688
.long V688
.long V690
.long V690
.long V690
.long V690
.long V690
.long V690
.long V690
.long V690
.long V698
.long V698
.long V698
.long V698
.long V698
.long V698
.long V698
.long V698
.long V6A0
.long V6A0
.long V6A0
.long V6A0
.long V6A0
.long V6A0
.long V6A0
.long V6A0
.long V6A8
.long V6A8
.long V6A8
.long V6A8
.long V6A8
.long V6A8
.long V6A8
.long V6A8
.long V6B0
.long V6B0
.long V6B0
.long V6B0
.long V6B0
.long V6B0
.long V6B0
.long V6B0
.long V6B8
.long V6B9
.long V6BA
.long V6BB
.long V6BC
.long r_illegal
.long r_illegal
.long r_illegal
.long V6C0
.long V6C0
.long V6C0
.long V6C0
.long V6C0
.long V6C0
.long V6C0
.long V6C0
.long V6C8
.long V6C8
.long V6C8
.long V6C8
.long V6C8
.long V6C8
.long V6C8
.long V6C8
.long V6D0
.long V6D0
.long V6D0
.long V6D0
.long V6D0
.long V6D0
.long V6D0
.long V6D0
.long V6D8
.long V6D8
.long V6D8
.long V6D8
.long V6D8
.long V6D8
.long V6D8
.long V6D8
.long V6E0
.long V6E0
.long V6E0
.long V6E0
.long V6E0
.long V6E0
.long V6E0
.long V6E0
.long V6E8
.long V6E8
.long V6E8
.long V6E8
.long V6E8
.long V6E8
.long V6E8
.long V6E8
.long V6F0
.long V6F0
.long V6F0
.long V6F0
.long V6F0
.long V6F0
.long V6F0
.long V6F0
.long V6F8
.long V6F9
.long V6FA
.long V6FB
.long V6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V700
.long V700
.long V700
.long V700
.long V700
.long V700
.long V700
.long V700
.long V708
.long V708
.long V708
.long V708
.long V708
.long V708
.long V708
.long V708
.long V710
.long V710
.long V710
.long V710
.long V710
.long V710
.long V710
.long V710
.long V718
.long V718
.long V718
.long V718
.long V718
.long V718
.long V718
.long V718
.long V720
.long V720
.long V720
.long V720
.long V720
.long V720
.long V720
.long V720
.long V728
.long V728
.long V728
.long V728
.long V728
.long V728
.long V728
.long V728
.long V730
.long V730
.long V730
.long V730
.long V730
.long V730
.long V730
.long V730
.long V738
.long V739
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V740
.long V740
.long V740
.long V740
.long V740
.long V740
.long V740
.long V740
.long V748
.long V748
.long V748
.long V748
.long V748
.long V748
.long V748
.long V748
.long V750
.long V750
.long V750
.long V750
.long V750
.long V750
.long V750
.long V750
.long V758
.long V758
.long V758
.long V758
.long V758
.long V758
.long V758
.long V758
.long V760
.long V760
.long V760
.long V760
.long V760
.long V760
.long V760
.long V760
.long V768
.long V768
.long V768
.long V768
.long V768
.long V768
.long V768
.long V768
.long V770
.long V770
.long V770
.long V770
.long V770
.long V770
.long V770
.long V770
.long V778
.long V779
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V780
.long V780
.long V780
.long V780
.long V780
.long V780
.long V780
.long V780
.long V788
.long V788
.long V788
.long V788
.long V788
.long V788
.long V788
.long V788
.long V790
.long V790
.long V790
.long V790
.long V790
.long V790
.long V790
.long V790
.long V798
.long V798
.long V798
.long V798
.long V798
.long V798
.long V798
.long V798
.long V7A0
.long V7A0
.long V7A0
.long V7A0
.long V7A0
.long V7A0
.long V7A0
.long V7A0
.long V7A8
.long V7A8
.long V7A8
.long V7A8
.long V7A8
.long V7A8
.long V7A8
.long V7A8
.long V7B0
.long V7B0
.long V7B0
.long V7B0
.long V7B0
.long V7B0
.long V7B0
.long V7B0
.long V7B8
.long V7B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V7C0
.long V7C0
.long V7C0
.long V7C0
.long V7C0
.long V7C0
.long V7C0
.long V7C0
.long V7C8
.long V7C8
.long V7C8
.long V7C8
.long V7C8
.long V7C8
.long V7C8
.long V7C8
.long V7D0
.long V7D0
.long V7D0
.long V7D0
.long V7D0
.long V7D0
.long V7D0
.long V7D0
.long V7D8
.long V7D8
.long V7D8
.long V7D8
.long V7D8
.long V7D8
.long V7D8
.long V7D8
.long V7E0
.long V7E0
.long V7E0
.long V7E0
.long V7E0
.long V7E0
.long V7E0
.long V7E0
.long V7E8
.long V7E8
.long V7E8
.long V7E8
.long V7E8
.long V7E8
.long V7E8
.long V7E8
.long V7F0
.long V7F0
.long V7F0
.long V7F0
.long V7F0
.long V7F0
.long V7F0
.long V7F0
.long V7F8
.long V7F9
.long V7FA
.long V7FB
.long V7FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V800
.long V800
.long V800
.long V800
.long V800
.long V800
.long V800
.long V800
.long V808
.long V808
.long V808
.long V808
.long V808
.long V808
.long V808
.long V808
.long V810
.long V810
.long V810
.long V810
.long V810
.long V810
.long V810
.long V810
.long V818
.long V818
.long V818
.long V818
.long V818
.long V818
.long V818
.long V818
.long V820
.long V820
.long V820
.long V820
.long V820
.long V820
.long V820
.long V820
.long V828
.long V828
.long V828
.long V828
.long V828
.long V828
.long V828
.long V828
.long V830
.long V830
.long V830
.long V830
.long V830
.long V830
.long V830
.long V830
.long V838
.long V839
.long V83A
.long V83B
.long V83C
.long r_illegal
.long r_illegal
.long r_illegal
.long V840
.long V840
.long V840
.long V840
.long V840
.long V840
.long V840
.long V840
.long V848
.long V848
.long V848
.long V848
.long V848
.long V848
.long V848
.long V848
.long V850
.long V850
.long V850
.long V850
.long V850
.long V850
.long V850
.long V850
.long V858
.long V858
.long V858
.long V858
.long V858
.long V858
.long V858
.long V858
.long V860
.long V860
.long V860
.long V860
.long V860
.long V860
.long V860
.long V860
.long V868
.long V868
.long V868
.long V868
.long V868
.long V868
.long V868
.long V868
.long V870
.long V870
.long V870
.long V870
.long V870
.long V870
.long V870
.long V870
.long V878
.long V879
.long V87A
.long V87B
.long V87C
.long r_illegal
.long r_illegal
.long r_illegal
.long V880
.long V880
.long V880
.long V880
.long V880
.long V880
.long V880
.long V880
.long V888
.long V888
.long V888
.long V888
.long V888
.long V888
.long V888
.long V888
.long V890
.long V890
.long V890
.long V890
.long V890
.long V890
.long V890
.long V890
.long V898
.long V898
.long V898
.long V898
.long V898
.long V898
.long V898
.long V898
.long V8A0
.long V8A0
.long V8A0
.long V8A0
.long V8A0
.long V8A0
.long V8A0
.long V8A0
.long V8A8
.long V8A8
.long V8A8
.long V8A8
.long V8A8
.long V8A8
.long V8A8
.long V8A8
.long V8B0
.long V8B0
.long V8B0
.long V8B0
.long V8B0
.long V8B0
.long V8B0
.long V8B0
.long V8B8
.long V8B9
.long V8BA
.long V8BB
.long V8BC
.long r_illegal
.long r_illegal
.long r_illegal
.long V8C0
.long V8C0
.long V8C0
.long V8C0
.long V8C0
.long V8C0
.long V8C0
.long V8C0
.long V8C8
.long V8C8
.long V8C8
.long V8C8
.long V8C8
.long V8C8
.long V8C8
.long V8C8
.long V8D0
.long V8D0
.long V8D0
.long V8D0
.long V8D0
.long V8D0
.long V8D0
.long V8D0
.long V8D8
.long V8D8
.long V8D8
.long V8D8
.long V8D8
.long V8D8
.long V8D8
.long V8D8
.long V8E0
.long V8E0
.long V8E0
.long V8E0
.long V8E0
.long V8E0
.long V8E0
.long V8E0
.long V8E8
.long V8E8
.long V8E8
.long V8E8
.long V8E8
.long V8E8
.long V8E8
.long V8E8
.long V8F0
.long V8F0
.long V8F0
.long V8F0
.long V8F0
.long V8F0
.long V8F0
.long V8F0
.long V8F8
.long V8F9
.long V8FA
.long V8FB
.long V8FC
.long r_illegal
.long r_illegal
.long r_illegal
.long V900
.long V900
.long V900
.long V900
.long V900
.long V900
.long V900
.long V900
.long V908
.long V908
.long V908
.long V908
.long V908
.long V908
.long V908
.long V908
.long V910
.long V910
.long V910
.long V910
.long V910
.long V910
.long V910
.long V910
.long V918
.long V918
.long V918
.long V918
.long V918
.long V918
.long V918
.long V918
.long V920
.long V920
.long V920
.long V920
.long V920
.long V920
.long V920
.long V920
.long V928
.long V928
.long V928
.long V928
.long V928
.long V928
.long V928
.long V928
.long V930
.long V930
.long V930
.long V930
.long V930
.long V930
.long V930
.long V930
.long V938
.long V939
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V940
.long V940
.long V940
.long V940
.long V940
.long V940
.long V940
.long V940
.long V948
.long V948
.long V948
.long V948
.long V948
.long V948
.long V948
.long V948
.long V950
.long V950
.long V950
.long V950
.long V950
.long V950
.long V950
.long V950
.long V958
.long V958
.long V958
.long V958
.long V958
.long V958
.long V958
.long V958
.long V960
.long V960
.long V960
.long V960
.long V960
.long V960
.long V960
.long V960
.long V968
.long V968
.long V968
.long V968
.long V968
.long V968
.long V968
.long V968
.long V970
.long V970
.long V970
.long V970
.long V970
.long V970
.long V970
.long V970
.long V978
.long V979
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V980
.long V980
.long V980
.long V980
.long V980
.long V980
.long V980
.long V980
.long V988
.long V988
.long V988
.long V988
.long V988
.long V988
.long V988
.long V988
.long V990
.long V990
.long V990
.long V990
.long V990
.long V990
.long V990
.long V990
.long V998
.long V998
.long V998
.long V998
.long V998
.long V998
.long V998
.long V998
.long V9A0
.long V9A0
.long V9A0
.long V9A0
.long V9A0
.long V9A0
.long V9A0
.long V9A0
.long V9A8
.long V9A8
.long V9A8
.long V9A8
.long V9A8
.long V9A8
.long V9A8
.long V9A8
.long V9B0
.long V9B0
.long V9B0
.long V9B0
.long V9B0
.long V9B0
.long V9B0
.long V9B0
.long V9B8
.long V9B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long V9C0
.long V9C0
.long V9C0
.long V9C0
.long V9C0
.long V9C0
.long V9C0
.long V9C0
.long V9C8
.long V9C8
.long V9C8
.long V9C8
.long V9C8
.long V9C8
.long V9C8
.long V9C8
.long V9D0
.long V9D0
.long V9D0
.long V9D0
.long V9D0
.long V9D0
.long V9D0
.long V9D0
.long V9D8
.long V9D8
.long V9D8
.long V9D8
.long V9D8
.long V9D8
.long V9D8
.long V9D8
.long V9E0
.long V9E0
.long V9E0
.long V9E0
.long V9E0
.long V9E0
.long V9E0
.long V9E0
.long V9E8
.long V9E8
.long V9E8
.long V9E8
.long V9E8
.long V9E8
.long V9E8
.long V9E8
.long V9F0
.long V9F0
.long V9F0
.long V9F0
.long V9F0
.long V9F0
.long V9F0
.long V9F0
.long V9F8
.long V9F9
.long V9FA
.long V9FB
.long V9FC
.long r_illegal
.long r_illegal
.long r_illegal
.long VA00
.long VA00
.long VA00
.long VA00
.long VA00
.long VA00
.long VA00
.long VA00
.long VA08
.long VA08
.long VA08
.long VA08
.long VA08
.long VA08
.long VA08
.long VA08
.long VA10
.long VA10
.long VA10
.long VA10
.long VA10
.long VA10
.long VA10
.long VA10
.long VA18
.long VA18
.long VA18
.long VA18
.long VA18
.long VA18
.long VA18
.long VA18
.long VA20
.long VA20
.long VA20
.long VA20
.long VA20
.long VA20
.long VA20
.long VA20
.long VA28
.long VA28
.long VA28
.long VA28
.long VA28
.long VA28
.long VA28
.long VA28
.long VA30
.long VA30
.long VA30
.long VA30
.long VA30
.long VA30
.long VA30
.long VA30
.long VA38
.long VA39
.long VA3A
.long VA3B
.long VA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long VA40
.long VA40
.long VA40
.long VA40
.long VA40
.long VA40
.long VA40
.long VA40
.long VA48
.long VA48
.long VA48
.long VA48
.long VA48
.long VA48
.long VA48
.long VA48
.long VA50
.long VA50
.long VA50
.long VA50
.long VA50
.long VA50
.long VA50
.long VA50
.long VA58
.long VA58
.long VA58
.long VA58
.long VA58
.long VA58
.long VA58
.long VA58
.long VA60
.long VA60
.long VA60
.long VA60
.long VA60
.long VA60
.long VA60
.long VA60
.long VA68
.long VA68
.long VA68
.long VA68
.long VA68
.long VA68
.long VA68
.long VA68
.long VA70
.long VA70
.long VA70
.long VA70
.long VA70
.long VA70
.long VA70
.long VA70
.long VA78
.long VA79
.long VA7A
.long VA7B
.long VA7C
.long r_illegal
.long r_illegal
.long r_illegal
.long VA80
.long VA80
.long VA80
.long VA80
.long VA80
.long VA80
.long VA80
.long VA80
.long VA88
.long VA88
.long VA88
.long VA88
.long VA88
.long VA88
.long VA88
.long VA88
.long VA90
.long VA90
.long VA90
.long VA90
.long VA90
.long VA90
.long VA90
.long VA90
.long VA98
.long VA98
.long VA98
.long VA98
.long VA98
.long VA98
.long VA98
.long VA98
.long VAA0
.long VAA0
.long VAA0
.long VAA0
.long VAA0
.long VAA0
.long VAA0
.long VAA0
.long VAA8
.long VAA8
.long VAA8
.long VAA8
.long VAA8
.long VAA8
.long VAA8
.long VAA8
.long VAB0
.long VAB0
.long VAB0
.long VAB0
.long VAB0
.long VAB0
.long VAB0
.long VAB0
.long VAB8
.long VAB9
.long VABA
.long VABB
.long VABC
.long r_illegal
.long r_illegal
.long r_illegal
.long VAC0
.long VAC0
.long VAC0
.long VAC0
.long VAC0
.long VAC0
.long VAC0
.long VAC0
.long VAC8
.long VAC8
.long VAC8
.long VAC8
.long VAC8
.long VAC8
.long VAC8
.long VAC8
.long VAD0
.long VAD0
.long VAD0
.long VAD0
.long VAD0
.long VAD0
.long VAD0
.long VAD0
.long VAD8
.long VAD8
.long VAD8
.long VAD8
.long VAD8
.long VAD8
.long VAD8
.long VAD8
.long VAE0
.long VAE0
.long VAE0
.long VAE0
.long VAE0
.long VAE0
.long VAE0
.long VAE0
.long VAE8
.long VAE8
.long VAE8
.long VAE8
.long VAE8
.long VAE8
.long VAE8
.long VAE8
.long VAF0
.long VAF0
.long VAF0
.long VAF0
.long VAF0
.long VAF0
.long VAF0
.long VAF0
.long VAF8
.long VAF9
.long VAFA
.long VAFB
.long VAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long VB00
.long VB00
.long VB00
.long VB00
.long VB00
.long VB00
.long VB00
.long VB00
.long VB08
.long VB08
.long VB08
.long VB08
.long VB08
.long VB08
.long VB08
.long VB08
.long VB10
.long VB10
.long VB10
.long VB10
.long VB10
.long VB10
.long VB10
.long VB10
.long VB18
.long VB18
.long VB18
.long VB18
.long VB18
.long VB18
.long VB18
.long VB18
.long VB20
.long VB20
.long VB20
.long VB20
.long VB20
.long VB20
.long VB20
.long VB20
.long VB28
.long VB28
.long VB28
.long VB28
.long VB28
.long VB28
.long VB28
.long VB28
.long VB30
.long VB30
.long VB30
.long VB30
.long VB30
.long VB30
.long VB30
.long VB30
.long VB38
.long VB39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VB40
.long VB40
.long VB40
.long VB40
.long VB40
.long VB40
.long VB40
.long VB40
.long VB48
.long VB48
.long VB48
.long VB48
.long VB48
.long VB48
.long VB48
.long VB48
.long VB50
.long VB50
.long VB50
.long VB50
.long VB50
.long VB50
.long VB50
.long VB50
.long VB58
.long VB58
.long VB58
.long VB58
.long VB58
.long VB58
.long VB58
.long VB58
.long VB60
.long VB60
.long VB60
.long VB60
.long VB60
.long VB60
.long VB60
.long VB60
.long VB68
.long VB68
.long VB68
.long VB68
.long VB68
.long VB68
.long VB68
.long VB68
.long VB70
.long VB70
.long VB70
.long VB70
.long VB70
.long VB70
.long VB70
.long VB70
.long VB78
.long VB79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VB80
.long VB80
.long VB80
.long VB80
.long VB80
.long VB80
.long VB80
.long VB80
.long VB88
.long VB88
.long VB88
.long VB88
.long VB88
.long VB88
.long VB88
.long VB88
.long VB90
.long VB90
.long VB90
.long VB90
.long VB90
.long VB90
.long VB90
.long VB90
.long VB98
.long VB98
.long VB98
.long VB98
.long VB98
.long VB98
.long VB98
.long VB98
.long VBA0
.long VBA0
.long VBA0
.long VBA0
.long VBA0
.long VBA0
.long VBA0
.long VBA0
.long VBA8
.long VBA8
.long VBA8
.long VBA8
.long VBA8
.long VBA8
.long VBA8
.long VBA8
.long VBB0
.long VBB0
.long VBB0
.long VBB0
.long VBB0
.long VBB0
.long VBB0
.long VBB0
.long VBB8
.long VBB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VBC0
.long VBC0
.long VBC0
.long VBC0
.long VBC0
.long VBC0
.long VBC0
.long VBC0
.long VBC8
.long VBC8
.long VBC8
.long VBC8
.long VBC8
.long VBC8
.long VBC8
.long VBC8
.long VBD0
.long VBD0
.long VBD0
.long VBD0
.long VBD0
.long VBD0
.long VBD0
.long VBD0
.long VBD8
.long VBD8
.long VBD8
.long VBD8
.long VBD8
.long VBD8
.long VBD8
.long VBD8
.long VBE0
.long VBE0
.long VBE0
.long VBE0
.long VBE0
.long VBE0
.long VBE0
.long VBE0
.long VBE8
.long VBE8
.long VBE8
.long VBE8
.long VBE8
.long VBE8
.long VBE8
.long VBE8
.long VBF0
.long VBF0
.long VBF0
.long VBF0
.long VBF0
.long VBF0
.long VBF0
.long VBF0
.long VBF8
.long VBF9
.long VBFA
.long VBFB
.long VBFC
.long r_illegal
.long r_illegal
.long r_illegal
.long VC00
.long VC00
.long VC00
.long VC00
.long VC00
.long VC00
.long VC00
.long VC00
.long VC08
.long VC08
.long VC08
.long VC08
.long VC08
.long VC08
.long VC08
.long VC08
.long VC10
.long VC10
.long VC10
.long VC10
.long VC10
.long VC10
.long VC10
.long VC10
.long VC18
.long VC18
.long VC18
.long VC18
.long VC18
.long VC18
.long VC18
.long VC18
.long VC20
.long VC20
.long VC20
.long VC20
.long VC20
.long VC20
.long VC20
.long VC20
.long VC28
.long VC28
.long VC28
.long VC28
.long VC28
.long VC28
.long VC28
.long VC28
.long VC30
.long VC30
.long VC30
.long VC30
.long VC30
.long VC30
.long VC30
.long VC30
.long VC38
.long VC39
.long VC3A
.long VC3B
.long VC3C
.long r_illegal
.long r_illegal
.long r_illegal
.long VC40
.long VC40
.long VC40
.long VC40
.long VC40
.long VC40
.long VC40
.long VC40
.long VC48
.long VC48
.long VC48
.long VC48
.long VC48
.long VC48
.long VC48
.long VC48
.long VC50
.long VC50
.long VC50
.long VC50
.long VC50
.long VC50
.long VC50
.long VC50
.long VC58
.long VC58
.long VC58
.long VC58
.long VC58
.long VC58
.long VC58
.long VC58
.long VC60
.long VC60
.long VC60
.long VC60
.long VC60
.long VC60
.long VC60
.long VC60
.long VC68
.long VC68
.long VC68
.long VC68
.long VC68
.long VC68
.long VC68
.long VC68
.long VC70
.long VC70
.long VC70
.long VC70
.long VC70
.long VC70
.long VC70
.long VC70
.long VC78
.long VC79
.long VC7A
.long VC7B
.long VC7C
.long r_illegal
.long r_illegal
.long r_illegal
.long VC80
.long VC80
.long VC80
.long VC80
.long VC80
.long VC80
.long VC80
.long VC80
.long VC88
.long VC88
.long VC88
.long VC88
.long VC88
.long VC88
.long VC88
.long VC88
.long VC90
.long VC90
.long VC90
.long VC90
.long VC90
.long VC90
.long VC90
.long VC90
.long VC98
.long VC98
.long VC98
.long VC98
.long VC98
.long VC98
.long VC98
.long VC98
.long VCA0
.long VCA0
.long VCA0
.long VCA0
.long VCA0
.long VCA0
.long VCA0
.long VCA0
.long VCA8
.long VCA8
.long VCA8
.long VCA8
.long VCA8
.long VCA8
.long VCA8
.long VCA8
.long VCB0
.long VCB0
.long VCB0
.long VCB0
.long VCB0
.long VCB0
.long VCB0
.long VCB0
.long VCB8
.long VCB9
.long VCBA
.long VCBB
.long VCBC
.long r_illegal
.long r_illegal
.long r_illegal
.long VCC0
.long VCC0
.long VCC0
.long VCC0
.long VCC0
.long VCC0
.long VCC0
.long VCC0
.long VCC8
.long VCC8
.long VCC8
.long VCC8
.long VCC8
.long VCC8
.long VCC8
.long VCC8
.long VCD0
.long VCD0
.long VCD0
.long VCD0
.long VCD0
.long VCD0
.long VCD0
.long VCD0
.long VCD8
.long VCD8
.long VCD8
.long VCD8
.long VCD8
.long VCD8
.long VCD8
.long VCD8
.long VCE0
.long VCE0
.long VCE0
.long VCE0
.long VCE0
.long VCE0
.long VCE0
.long VCE0
.long VCE8
.long VCE8
.long VCE8
.long VCE8
.long VCE8
.long VCE8
.long VCE8
.long VCE8
.long VCF0
.long VCF0
.long VCF0
.long VCF0
.long VCF0
.long VCF0
.long VCF0
.long VCF0
.long VCF8
.long VCF9
.long VCFA
.long VCFB
.long VCFC
.long r_illegal
.long r_illegal
.long r_illegal
.long VD00
.long VD00
.long VD00
.long VD00
.long VD00
.long VD00
.long VD00
.long VD00
.long VD08
.long VD08
.long VD08
.long VD08
.long VD08
.long VD08
.long VD08
.long VD08
.long VD10
.long VD10
.long VD10
.long VD10
.long VD10
.long VD10
.long VD10
.long VD10
.long VD18
.long VD18
.long VD18
.long VD18
.long VD18
.long VD18
.long VD18
.long VD18
.long VD20
.long VD20
.long VD20
.long VD20
.long VD20
.long VD20
.long VD20
.long VD20
.long VD28
.long VD28
.long VD28
.long VD28
.long VD28
.long VD28
.long VD28
.long VD28
.long VD30
.long VD30
.long VD30
.long VD30
.long VD30
.long VD30
.long VD30
.long VD30
.long VD38
.long VD39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VD40
.long VD40
.long VD40
.long VD40
.long VD40
.long VD40
.long VD40
.long VD40
.long VD48
.long VD48
.long VD48
.long VD48
.long VD48
.long VD48
.long VD48
.long VD48
.long VD50
.long VD50
.long VD50
.long VD50
.long VD50
.long VD50
.long VD50
.long VD50
.long VD58
.long VD58
.long VD58
.long VD58
.long VD58
.long VD58
.long VD58
.long VD58
.long VD60
.long VD60
.long VD60
.long VD60
.long VD60
.long VD60
.long VD60
.long VD60
.long VD68
.long VD68
.long VD68
.long VD68
.long VD68
.long VD68
.long VD68
.long VD68
.long VD70
.long VD70
.long VD70
.long VD70
.long VD70
.long VD70
.long VD70
.long VD70
.long VD78
.long VD79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VD80
.long VD80
.long VD80
.long VD80
.long VD80
.long VD80
.long VD80
.long VD80
.long VD88
.long VD88
.long VD88
.long VD88
.long VD88
.long VD88
.long VD88
.long VD88
.long VD90
.long VD90
.long VD90
.long VD90
.long VD90
.long VD90
.long VD90
.long VD90
.long VD98
.long VD98
.long VD98
.long VD98
.long VD98
.long VD98
.long VD98
.long VD98
.long VDA0
.long VDA0
.long VDA0
.long VDA0
.long VDA0
.long VDA0
.long VDA0
.long VDA0
.long VDA8
.long VDA8
.long VDA8
.long VDA8
.long VDA8
.long VDA8
.long VDA8
.long VDA8
.long VDB0
.long VDB0
.long VDB0
.long VDB0
.long VDB0
.long VDB0
.long VDB0
.long VDB0
.long VDB8
.long VDB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VDC0
.long VDC0
.long VDC0
.long VDC0
.long VDC0
.long VDC0
.long VDC0
.long VDC0
.long VDC8
.long VDC8
.long VDC8
.long VDC8
.long VDC8
.long VDC8
.long VDC8
.long VDC8
.long VDD0
.long VDD0
.long VDD0
.long VDD0
.long VDD0
.long VDD0
.long VDD0
.long VDD0
.long VDD8
.long VDD8
.long VDD8
.long VDD8
.long VDD8
.long VDD8
.long VDD8
.long VDD8
.long VDE0
.long VDE0
.long VDE0
.long VDE0
.long VDE0
.long VDE0
.long VDE0
.long VDE0
.long VDE8
.long VDE8
.long VDE8
.long VDE8
.long VDE8
.long VDE8
.long VDE8
.long VDE8
.long VDF0
.long VDF0
.long VDF0
.long VDF0
.long VDF0
.long VDF0
.long VDF0
.long VDF0
.long VDF8
.long VDF9
.long VDFA
.long VDFB
.long VDFC
.long r_illegal
.long r_illegal
.long r_illegal
.long VE00
.long VE00
.long VE00
.long VE00
.long VE00
.long VE00
.long VE00
.long VE00
.long VE08
.long VE08
.long VE08
.long VE08
.long VE08
.long VE08
.long VE08
.long VE08
.long VE10
.long VE10
.long VE10
.long VE10
.long VE10
.long VE10
.long VE10
.long VE10
.long VE18
.long VE18
.long VE18
.long VE18
.long VE18
.long VE18
.long VE18
.long VE18
.long VE20
.long VE20
.long VE20
.long VE20
.long VE20
.long VE20
.long VE20
.long VE20
.long VE28
.long VE28
.long VE28
.long VE28
.long VE28
.long VE28
.long VE28
.long VE28
.long VE30
.long VE30
.long VE30
.long VE30
.long VE30
.long VE30
.long VE30
.long VE30
.long VE38
.long VE39
.long VE3A
.long VE3B
.long VE3C
.long r_illegal
.long r_illegal
.long r_illegal
.long VE40
.long VE40
.long VE40
.long VE40
.long VE40
.long VE40
.long VE40
.long VE40
.long VE48
.long VE48
.long VE48
.long VE48
.long VE48
.long VE48
.long VE48
.long VE48
.long VE50
.long VE50
.long VE50
.long VE50
.long VE50
.long VE50
.long VE50
.long VE50
.long VE58
.long VE58
.long VE58
.long VE58
.long VE58
.long VE58
.long VE58
.long VE58
.long VE60
.long VE60
.long VE60
.long VE60
.long VE60
.long VE60
.long VE60
.long VE60
.long VE68
.long VE68
.long VE68
.long VE68
.long VE68
.long VE68
.long VE68
.long VE68
.long VE70
.long VE70
.long VE70
.long VE70
.long VE70
.long VE70
.long VE70
.long VE70
.long VE78
.long VE79
.long VE7A
.long VE7B
.long VE7C
.long r_illegal
.long r_illegal
.long r_illegal
.long VE80
.long VE80
.long VE80
.long VE80
.long VE80
.long VE80
.long VE80
.long VE80
.long VE88
.long VE88
.long VE88
.long VE88
.long VE88
.long VE88
.long VE88
.long VE88
.long VE90
.long VE90
.long VE90
.long VE90
.long VE90
.long VE90
.long VE90
.long VE90
.long VE98
.long VE98
.long VE98
.long VE98
.long VE98
.long VE98
.long VE98
.long VE98
.long VEA0
.long VEA0
.long VEA0
.long VEA0
.long VEA0
.long VEA0
.long VEA0
.long VEA0
.long VEA8
.long VEA8
.long VEA8
.long VEA8
.long VEA8
.long VEA8
.long VEA8
.long VEA8
.long VEB0
.long VEB0
.long VEB0
.long VEB0
.long VEB0
.long VEB0
.long VEB0
.long VEB0
.long VEB8
.long VEB9
.long VEBA
.long VEBB
.long VEBC
.long r_illegal
.long r_illegal
.long r_illegal
.long VEC0
.long VEC0
.long VEC0
.long VEC0
.long VEC0
.long VEC0
.long VEC0
.long VEC0
.long VEC8
.long VEC8
.long VEC8
.long VEC8
.long VEC8
.long VEC8
.long VEC8
.long VEC8
.long VED0
.long VED0
.long VED0
.long VED0
.long VED0
.long VED0
.long VED0
.long VED0
.long VED8
.long VED8
.long VED8
.long VED8
.long VED8
.long VED8
.long VED8
.long VED8
.long VEE0
.long VEE0
.long VEE0
.long VEE0
.long VEE0
.long VEE0
.long VEE0
.long VEE0
.long VEE8
.long VEE8
.long VEE8
.long VEE8
.long VEE8
.long VEE8
.long VEE8
.long VEE8
.long VEF0
.long VEF0
.long VEF0
.long VEF0
.long VEF0
.long VEF0
.long VEF0
.long VEF0
.long VEF8
.long VEF9
.long VEFA
.long VEFB
.long VEFC
.long r_illegal
.long r_illegal
.long r_illegal
.long VF00
.long VF00
.long VF00
.long VF00
.long VF00
.long VF00
.long VF00
.long VF00
.long VF08
.long VF08
.long VF08
.long VF08
.long VF08
.long VF08
.long VF08
.long VF08
.long VF10
.long VF10
.long VF10
.long VF10
.long VF10
.long VF10
.long VF10
.long VF10
.long VF18
.long VF18
.long VF18
.long VF18
.long VF18
.long VF18
.long VF18
.long VF18
.long VF20
.long VF20
.long VF20
.long VF20
.long VF20
.long VF20
.long VF20
.long VF20
.long VF28
.long VF28
.long VF28
.long VF28
.long VF28
.long VF28
.long VF28
.long VF28
.long VF30
.long VF30
.long VF30
.long VF30
.long VF30
.long VF30
.long VF30
.long VF30
.long VF38
.long VF39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VF40
.long VF40
.long VF40
.long VF40
.long VF40
.long VF40
.long VF40
.long VF40
.long VF48
.long VF48
.long VF48
.long VF48
.long VF48
.long VF48
.long VF48
.long VF48
.long VF50
.long VF50
.long VF50
.long VF50
.long VF50
.long VF50
.long VF50
.long VF50
.long VF58
.long VF58
.long VF58
.long VF58
.long VF58
.long VF58
.long VF58
.long VF58
.long VF60
.long VF60
.long VF60
.long VF60
.long VF60
.long VF60
.long VF60
.long VF60
.long VF68
.long VF68
.long VF68
.long VF68
.long VF68
.long VF68
.long VF68
.long VF68
.long VF70
.long VF70
.long VF70
.long VF70
.long VF70
.long VF70
.long VF70
.long VF70
.long VF78
.long VF79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VF80
.long VF80
.long VF80
.long VF80
.long VF80
.long VF80
.long VF80
.long VF80
.long VF88
.long VF88
.long VF88
.long VF88
.long VF88
.long VF88
.long VF88
.long VF88
.long VF90
.long VF90
.long VF90
.long VF90
.long VF90
.long VF90
.long VF90
.long VF90
.long VF98
.long VF98
.long VF98
.long VF98
.long VF98
.long VF98
.long VF98
.long VF98
.long VFA0
.long VFA0
.long VFA0
.long VFA0
.long VFA0
.long VFA0
.long VFA0
.long VFA0
.long VFA8
.long VFA8
.long VFA8
.long VFA8
.long VFA8
.long VFA8
.long VFA8
.long VFA8
.long VFB0
.long VFB0
.long VFB0
.long VFB0
.long VFB0
.long VFB0
.long VFB0
.long VFB0
.long VFB8
.long VFB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long VFC0
.long VFC0
.long VFC0
.long VFC0
.long VFC0
.long VFC0
.long VFC0
.long VFC0
.long VFC8
.long VFC8
.long VFC8
.long VFC8
.long VFC8
.long VFC8
.long VFC8
.long VFC8
.long VFD0
.long VFD0
.long VFD0
.long VFD0
.long VFD0
.long VFD0
.long VFD0
.long VFD0
.long VFD8
.long VFD8
.long VFD8
.long VFD8
.long VFD8
.long VFD8
.long VFD8
.long VFD8
.long VFE0
.long VFE0
.long VFE0
.long VFE0
.long VFE0
.long VFE0
.long VFE0
.long VFE0
.long VFE8
.long VFE8
.long VFE8
.long VFE8
.long VFE8
.long VFE8
.long VFE8
.long VFE8
.long VFF0
.long VFF0
.long VFF0
.long VFF0
.long VFF0
.long VFF0
.long VFF0
.long VFF0
.long VFF8
.long VFF9
.long VFFA
.long VFFB
.long VFFC
.long r_illegal
.long r_illegal
.long r_illegal
.long W000
.long W000
.long W000
.long W000
.long W000
.long W000
.long W000
.long W000
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W010
.long W010
.long W010
.long W010
.long W010
.long W010
.long W010
.long W010
.long W018
.long W018
.long W018
.long W018
.long W018
.long W018
.long W018
.long W018
.long W020
.long W020
.long W020
.long W020
.long W020
.long W020
.long W020
.long W020
.long W028
.long W028
.long W028
.long W028
.long W028
.long W028
.long W028
.long W028
.long W030
.long W030
.long W030
.long W030
.long W030
.long W030
.long W030
.long W030
.long W038
.long W039
.long W03A
.long W03B
.long W03C
.long r_illegal
.long r_illegal
.long r_illegal
.long W040
.long W040
.long W040
.long W040
.long W040
.long W040
.long W040
.long W040
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W050
.long W050
.long W050
.long W050
.long W050
.long W050
.long W050
.long W050
.long W058
.long W058
.long W058
.long W058
.long W058
.long W058
.long W058
.long W058
.long W060
.long W060
.long W060
.long W060
.long W060
.long W060
.long W060
.long W060
.long W068
.long W068
.long W068
.long W068
.long W068
.long W068
.long W068
.long W068
.long W070
.long W070
.long W070
.long W070
.long W070
.long W070
.long W070
.long W070
.long W078
.long W079
.long W07A
.long W07B
.long W07C
.long r_illegal
.long r_illegal
.long r_illegal
.long W080
.long W080
.long W080
.long W080
.long W080
.long W080
.long W080
.long W080
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W090
.long W090
.long W090
.long W090
.long W090
.long W090
.long W090
.long W090
.long W098
.long W098
.long W098
.long W098
.long W098
.long W098
.long W098
.long W098
.long W0A0
.long W0A0
.long W0A0
.long W0A0
.long W0A0
.long W0A0
.long W0A0
.long W0A0
.long W0A8
.long W0A8
.long W0A8
.long W0A8
.long W0A8
.long W0A8
.long W0A8
.long W0A8
.long W0B0
.long W0B0
.long W0B0
.long W0B0
.long W0B0
.long W0B0
.long W0B0
.long W0B0
.long W0B8
.long W0B9
.long W0BA
.long W0BB
.long W0BC
.long r_illegal
.long r_illegal
.long r_illegal
.long W0C0
.long W0C0
.long W0C0
.long W0C0
.long W0C0
.long W0C0
.long W0C0
.long W0C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W0D0
.long W0D0
.long W0D0
.long W0D0
.long W0D0
.long W0D0
.long W0D0
.long W0D0
.long W0D8
.long W0D8
.long W0D8
.long W0D8
.long W0D8
.long W0D8
.long W0D8
.long W0D8
.long W0E0
.long W0E0
.long W0E0
.long W0E0
.long W0E0
.long W0E0
.long W0E0
.long W0E0
.long W0E8
.long W0E8
.long W0E8
.long W0E8
.long W0E8
.long W0E8
.long W0E8
.long W0E8
.long W0F0
.long W0F0
.long W0F0
.long W0F0
.long W0F0
.long W0F0
.long W0F0
.long W0F0
.long W0F8
.long W0F9
.long W0FA
.long W0FB
.long W0FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W100
.long W100
.long W100
.long W100
.long W100
.long W100
.long W100
.long W100
.long W108
.long W108
.long W108
.long W108
.long W108
.long W108
.long W108
.long W108
.long W110
.long W110
.long W110
.long W110
.long W110
.long W110
.long W110
.long W110
.long W118
.long W118
.long W118
.long W118
.long W118
.long W118
.long W118
.long W118
.long W120
.long W120
.long W120
.long W120
.long W120
.long W120
.long W120
.long W120
.long W128
.long W128
.long W128
.long W128
.long W128
.long W128
.long W128
.long W128
.long W130
.long W130
.long W130
.long W130
.long W130
.long W130
.long W130
.long W130
.long W138
.long W139
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W140
.long W140
.long W140
.long W140
.long W140
.long W140
.long W140
.long W140
.long W148
.long W148
.long W148
.long W148
.long W148
.long W148
.long W148
.long W148
.long W150
.long W150
.long W150
.long W150
.long W150
.long W150
.long W150
.long W150
.long W158
.long W158
.long W158
.long W158
.long W158
.long W158
.long W158
.long W158
.long W160
.long W160
.long W160
.long W160
.long W160
.long W160
.long W160
.long W160
.long W168
.long W168
.long W168
.long W168
.long W168
.long W168
.long W168
.long W168
.long W170
.long W170
.long W170
.long W170
.long W170
.long W170
.long W170
.long W170
.long W178
.long W179
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W188
.long W188
.long W188
.long W188
.long W188
.long W188
.long W188
.long W188
.long W190
.long W190
.long W190
.long W190
.long W190
.long W190
.long W190
.long W190
.long W198
.long W198
.long W198
.long W198
.long W198
.long W198
.long W198
.long W198
.long W1A0
.long W1A0
.long W1A0
.long W1A0
.long W1A0
.long W1A0
.long W1A0
.long W1A0
.long W1A8
.long W1A8
.long W1A8
.long W1A8
.long W1A8
.long W1A8
.long W1A8
.long W1A8
.long W1B0
.long W1B0
.long W1B0
.long W1B0
.long W1B0
.long W1B0
.long W1B0
.long W1B0
.long W1B8
.long W1B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W1C0
.long W1C0
.long W1C0
.long W1C0
.long W1C0
.long W1C0
.long W1C0
.long W1C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W1D0
.long W1D0
.long W1D0
.long W1D0
.long W1D0
.long W1D0
.long W1D0
.long W1D0
.long W1D8
.long W1D8
.long W1D8
.long W1D8
.long W1D8
.long W1D8
.long W1D8
.long W1D8
.long W1E0
.long W1E0
.long W1E0
.long W1E0
.long W1E0
.long W1E0
.long W1E0
.long W1E0
.long W1E8
.long W1E8
.long W1E8
.long W1E8
.long W1E8
.long W1E8
.long W1E8
.long W1E8
.long W1F0
.long W1F0
.long W1F0
.long W1F0
.long W1F0
.long W1F0
.long W1F0
.long W1F0
.long W1F8
.long W1F9
.long W1FA
.long W1FB
.long W1FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W200
.long W200
.long W200
.long W200
.long W200
.long W200
.long W200
.long W200
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W210
.long W210
.long W210
.long W210
.long W210
.long W210
.long W210
.long W210
.long W218
.long W218
.long W218
.long W218
.long W218
.long W218
.long W218
.long W218
.long W220
.long W220
.long W220
.long W220
.long W220
.long W220
.long W220
.long W220
.long W228
.long W228
.long W228
.long W228
.long W228
.long W228
.long W228
.long W228
.long W230
.long W230
.long W230
.long W230
.long W230
.long W230
.long W230
.long W230
.long W238
.long W239
.long W23A
.long W23B
.long W23C
.long r_illegal
.long r_illegal
.long r_illegal
.long W240
.long W240
.long W240
.long W240
.long W240
.long W240
.long W240
.long W240
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W250
.long W250
.long W250
.long W250
.long W250
.long W250
.long W250
.long W250
.long W258
.long W258
.long W258
.long W258
.long W258
.long W258
.long W258
.long W258
.long W260
.long W260
.long W260
.long W260
.long W260
.long W260
.long W260
.long W260
.long W268
.long W268
.long W268
.long W268
.long W268
.long W268
.long W268
.long W268
.long W270
.long W270
.long W270
.long W270
.long W270
.long W270
.long W270
.long W270
.long W278
.long W279
.long W27A
.long W27B
.long W27C
.long r_illegal
.long r_illegal
.long r_illegal
.long W280
.long W280
.long W280
.long W280
.long W280
.long W280
.long W280
.long W280
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W290
.long W290
.long W290
.long W290
.long W290
.long W290
.long W290
.long W290
.long W298
.long W298
.long W298
.long W298
.long W298
.long W298
.long W298
.long W298
.long W2A0
.long W2A0
.long W2A0
.long W2A0
.long W2A0
.long W2A0
.long W2A0
.long W2A0
.long W2A8
.long W2A8
.long W2A8
.long W2A8
.long W2A8
.long W2A8
.long W2A8
.long W2A8
.long W2B0
.long W2B0
.long W2B0
.long W2B0
.long W2B0
.long W2B0
.long W2B0
.long W2B0
.long W2B8
.long W2B9
.long W2BA
.long W2BB
.long W2BC
.long r_illegal
.long r_illegal
.long r_illegal
.long W2C0
.long W2C0
.long W2C0
.long W2C0
.long W2C0
.long W2C0
.long W2C0
.long W2C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W2D0
.long W2D0
.long W2D0
.long W2D0
.long W2D0
.long W2D0
.long W2D0
.long W2D0
.long W2D8
.long W2D8
.long W2D8
.long W2D8
.long W2D8
.long W2D8
.long W2D8
.long W2D8
.long W2E0
.long W2E0
.long W2E0
.long W2E0
.long W2E0
.long W2E0
.long W2E0
.long W2E0
.long W2E8
.long W2E8
.long W2E8
.long W2E8
.long W2E8
.long W2E8
.long W2E8
.long W2E8
.long W2F0
.long W2F0
.long W2F0
.long W2F0
.long W2F0
.long W2F0
.long W2F0
.long W2F0
.long W2F8
.long W2F9
.long W2FA
.long W2FB
.long W2FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W300
.long W300
.long W300
.long W300
.long W300
.long W300
.long W300
.long W300
.long W308
.long W308
.long W308
.long W308
.long W308
.long W308
.long W308
.long W308
.long W310
.long W310
.long W310
.long W310
.long W310
.long W310
.long W310
.long W310
.long W318
.long W318
.long W318
.long W318
.long W318
.long W318
.long W318
.long W318
.long W320
.long W320
.long W320
.long W320
.long W320
.long W320
.long W320
.long W320
.long W328
.long W328
.long W328
.long W328
.long W328
.long W328
.long W328
.long W328
.long W330
.long W330
.long W330
.long W330
.long W330
.long W330
.long W330
.long W330
.long W338
.long W339
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W340
.long W340
.long W340
.long W340
.long W340
.long W340
.long W340
.long W340
.long W348
.long W348
.long W348
.long W348
.long W348
.long W348
.long W348
.long W348
.long W350
.long W350
.long W350
.long W350
.long W350
.long W350
.long W350
.long W350
.long W358
.long W358
.long W358
.long W358
.long W358
.long W358
.long W358
.long W358
.long W360
.long W360
.long W360
.long W360
.long W360
.long W360
.long W360
.long W360
.long W368
.long W368
.long W368
.long W368
.long W368
.long W368
.long W368
.long W368
.long W370
.long W370
.long W370
.long W370
.long W370
.long W370
.long W370
.long W370
.long W378
.long W379
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W388
.long W388
.long W388
.long W388
.long W388
.long W388
.long W388
.long W388
.long W390
.long W390
.long W390
.long W390
.long W390
.long W390
.long W390
.long W390
.long W398
.long W398
.long W398
.long W398
.long W398
.long W398
.long W398
.long W398
.long W3A0
.long W3A0
.long W3A0
.long W3A0
.long W3A0
.long W3A0
.long W3A0
.long W3A0
.long W3A8
.long W3A8
.long W3A8
.long W3A8
.long W3A8
.long W3A8
.long W3A8
.long W3A8
.long W3B0
.long W3B0
.long W3B0
.long W3B0
.long W3B0
.long W3B0
.long W3B0
.long W3B0
.long W3B8
.long W3B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W3C0
.long W3C0
.long W3C0
.long W3C0
.long W3C0
.long W3C0
.long W3C0
.long W3C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W3D0
.long W3D0
.long W3D0
.long W3D0
.long W3D0
.long W3D0
.long W3D0
.long W3D0
.long W3D8
.long W3D8
.long W3D8
.long W3D8
.long W3D8
.long W3D8
.long W3D8
.long W3D8
.long W3E0
.long W3E0
.long W3E0
.long W3E0
.long W3E0
.long W3E0
.long W3E0
.long W3E0
.long W3E8
.long W3E8
.long W3E8
.long W3E8
.long W3E8
.long W3E8
.long W3E8
.long W3E8
.long W3F0
.long W3F0
.long W3F0
.long W3F0
.long W3F0
.long W3F0
.long W3F0
.long W3F0
.long W3F8
.long W3F9
.long W3FA
.long W3FB
.long W3FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W400
.long W400
.long W400
.long W400
.long W400
.long W400
.long W400
.long W400
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W410
.long W410
.long W410
.long W410
.long W410
.long W410
.long W410
.long W410
.long W418
.long W418
.long W418
.long W418
.long W418
.long W418
.long W418
.long W418
.long W420
.long W420
.long W420
.long W420
.long W420
.long W420
.long W420
.long W420
.long W428
.long W428
.long W428
.long W428
.long W428
.long W428
.long W428
.long W428
.long W430
.long W430
.long W430
.long W430
.long W430
.long W430
.long W430
.long W430
.long W438
.long W439
.long W43A
.long W43B
.long W43C
.long r_illegal
.long r_illegal
.long r_illegal
.long W440
.long W440
.long W440
.long W440
.long W440
.long W440
.long W440
.long W440
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W450
.long W450
.long W450
.long W450
.long W450
.long W450
.long W450
.long W450
.long W458
.long W458
.long W458
.long W458
.long W458
.long W458
.long W458
.long W458
.long W460
.long W460
.long W460
.long W460
.long W460
.long W460
.long W460
.long W460
.long W468
.long W468
.long W468
.long W468
.long W468
.long W468
.long W468
.long W468
.long W470
.long W470
.long W470
.long W470
.long W470
.long W470
.long W470
.long W470
.long W478
.long W479
.long W47A
.long W47B
.long W47C
.long r_illegal
.long r_illegal
.long r_illegal
.long W480
.long W480
.long W480
.long W480
.long W480
.long W480
.long W480
.long W480
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W490
.long W490
.long W490
.long W490
.long W490
.long W490
.long W490
.long W490
.long W498
.long W498
.long W498
.long W498
.long W498
.long W498
.long W498
.long W498
.long W4A0
.long W4A0
.long W4A0
.long W4A0
.long W4A0
.long W4A0
.long W4A0
.long W4A0
.long W4A8
.long W4A8
.long W4A8
.long W4A8
.long W4A8
.long W4A8
.long W4A8
.long W4A8
.long W4B0
.long W4B0
.long W4B0
.long W4B0
.long W4B0
.long W4B0
.long W4B0
.long W4B0
.long W4B8
.long W4B9
.long W4BA
.long W4BB
.long W4BC
.long r_illegal
.long r_illegal
.long r_illegal
.long W4C0
.long W4C0
.long W4C0
.long W4C0
.long W4C0
.long W4C0
.long W4C0
.long W4C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W4D0
.long W4D0
.long W4D0
.long W4D0
.long W4D0
.long W4D0
.long W4D0
.long W4D0
.long W4D8
.long W4D8
.long W4D8
.long W4D8
.long W4D8
.long W4D8
.long W4D8
.long W4D8
.long W4E0
.long W4E0
.long W4E0
.long W4E0
.long W4E0
.long W4E0
.long W4E0
.long W4E0
.long W4E8
.long W4E8
.long W4E8
.long W4E8
.long W4E8
.long W4E8
.long W4E8
.long W4E8
.long W4F0
.long W4F0
.long W4F0
.long W4F0
.long W4F0
.long W4F0
.long W4F0
.long W4F0
.long W4F8
.long W4F9
.long W4FA
.long W4FB
.long W4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W500
.long W500
.long W500
.long W500
.long W500
.long W500
.long W500
.long W500
.long W508
.long W508
.long W508
.long W508
.long W508
.long W508
.long W508
.long W508
.long W510
.long W510
.long W510
.long W510
.long W510
.long W510
.long W510
.long W510
.long W518
.long W518
.long W518
.long W518
.long W518
.long W518
.long W518
.long W518
.long W520
.long W520
.long W520
.long W520
.long W520
.long W520
.long W520
.long W520
.long W528
.long W528
.long W528
.long W528
.long W528
.long W528
.long W528
.long W528
.long W530
.long W530
.long W530
.long W530
.long W530
.long W530
.long W530
.long W530
.long W538
.long W539
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W540
.long W540
.long W540
.long W540
.long W540
.long W540
.long W540
.long W540
.long W548
.long W548
.long W548
.long W548
.long W548
.long W548
.long W548
.long W548
.long W550
.long W550
.long W550
.long W550
.long W550
.long W550
.long W550
.long W550
.long W558
.long W558
.long W558
.long W558
.long W558
.long W558
.long W558
.long W558
.long W560
.long W560
.long W560
.long W560
.long W560
.long W560
.long W560
.long W560
.long W568
.long W568
.long W568
.long W568
.long W568
.long W568
.long W568
.long W568
.long W570
.long W570
.long W570
.long W570
.long W570
.long W570
.long W570
.long W570
.long W578
.long W579
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W588
.long W588
.long W588
.long W588
.long W588
.long W588
.long W588
.long W588
.long W590
.long W590
.long W590
.long W590
.long W590
.long W590
.long W590
.long W590
.long W598
.long W598
.long W598
.long W598
.long W598
.long W598
.long W598
.long W598
.long W5A0
.long W5A0
.long W5A0
.long W5A0
.long W5A0
.long W5A0
.long W5A0
.long W5A0
.long W5A8
.long W5A8
.long W5A8
.long W5A8
.long W5A8
.long W5A8
.long W5A8
.long W5A8
.long W5B0
.long W5B0
.long W5B0
.long W5B0
.long W5B0
.long W5B0
.long W5B0
.long W5B0
.long W5B8
.long W5B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W5C0
.long W5C0
.long W5C0
.long W5C0
.long W5C0
.long W5C0
.long W5C0
.long W5C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W5D0
.long W5D0
.long W5D0
.long W5D0
.long W5D0
.long W5D0
.long W5D0
.long W5D0
.long W5D8
.long W5D8
.long W5D8
.long W5D8
.long W5D8
.long W5D8
.long W5D8
.long W5D8
.long W5E0
.long W5E0
.long W5E0
.long W5E0
.long W5E0
.long W5E0
.long W5E0
.long W5E0
.long W5E8
.long W5E8
.long W5E8
.long W5E8
.long W5E8
.long W5E8
.long W5E8
.long W5E8
.long W5F0
.long W5F0
.long W5F0
.long W5F0
.long W5F0
.long W5F0
.long W5F0
.long W5F0
.long W5F8
.long W5F9
.long W5FA
.long W5FB
.long W5FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W600
.long W600
.long W600
.long W600
.long W600
.long W600
.long W600
.long W600
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W610
.long W610
.long W610
.long W610
.long W610
.long W610
.long W610
.long W610
.long W618
.long W618
.long W618
.long W618
.long W618
.long W618
.long W618
.long W618
.long W620
.long W620
.long W620
.long W620
.long W620
.long W620
.long W620
.long W620
.long W628
.long W628
.long W628
.long W628
.long W628
.long W628
.long W628
.long W628
.long W630
.long W630
.long W630
.long W630
.long W630
.long W630
.long W630
.long W630
.long W638
.long W639
.long W63A
.long W63B
.long W63C
.long r_illegal
.long r_illegal
.long r_illegal
.long W640
.long W640
.long W640
.long W640
.long W640
.long W640
.long W640
.long W640
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W650
.long W650
.long W650
.long W650
.long W650
.long W650
.long W650
.long W650
.long W658
.long W658
.long W658
.long W658
.long W658
.long W658
.long W658
.long W658
.long W660
.long W660
.long W660
.long W660
.long W660
.long W660
.long W660
.long W660
.long W668
.long W668
.long W668
.long W668
.long W668
.long W668
.long W668
.long W668
.long W670
.long W670
.long W670
.long W670
.long W670
.long W670
.long W670
.long W670
.long W678
.long W679
.long W67A
.long W67B
.long W67C
.long r_illegal
.long r_illegal
.long r_illegal
.long W680
.long W680
.long W680
.long W680
.long W680
.long W680
.long W680
.long W680
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W690
.long W690
.long W690
.long W690
.long W690
.long W690
.long W690
.long W690
.long W698
.long W698
.long W698
.long W698
.long W698
.long W698
.long W698
.long W698
.long W6A0
.long W6A0
.long W6A0
.long W6A0
.long W6A0
.long W6A0
.long W6A0
.long W6A0
.long W6A8
.long W6A8
.long W6A8
.long W6A8
.long W6A8
.long W6A8
.long W6A8
.long W6A8
.long W6B0
.long W6B0
.long W6B0
.long W6B0
.long W6B0
.long W6B0
.long W6B0
.long W6B0
.long W6B8
.long W6B9
.long W6BA
.long W6BB
.long W6BC
.long r_illegal
.long r_illegal
.long r_illegal
.long W6C0
.long W6C0
.long W6C0
.long W6C0
.long W6C0
.long W6C0
.long W6C0
.long W6C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W6D0
.long W6D0
.long W6D0
.long W6D0
.long W6D0
.long W6D0
.long W6D0
.long W6D0
.long W6D8
.long W6D8
.long W6D8
.long W6D8
.long W6D8
.long W6D8
.long W6D8
.long W6D8
.long W6E0
.long W6E0
.long W6E0
.long W6E0
.long W6E0
.long W6E0
.long W6E0
.long W6E0
.long W6E8
.long W6E8
.long W6E8
.long W6E8
.long W6E8
.long W6E8
.long W6E8
.long W6E8
.long W6F0
.long W6F0
.long W6F0
.long W6F0
.long W6F0
.long W6F0
.long W6F0
.long W6F0
.long W6F8
.long W6F9
.long W6FA
.long W6FB
.long W6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W700
.long W700
.long W700
.long W700
.long W700
.long W700
.long W700
.long W700
.long W708
.long W708
.long W708
.long W708
.long W708
.long W708
.long W708
.long W708
.long W710
.long W710
.long W710
.long W710
.long W710
.long W710
.long W710
.long W710
.long W718
.long W718
.long W718
.long W718
.long W718
.long W718
.long W718
.long W718
.long W720
.long W720
.long W720
.long W720
.long W720
.long W720
.long W720
.long W720
.long W728
.long W728
.long W728
.long W728
.long W728
.long W728
.long W728
.long W728
.long W730
.long W730
.long W730
.long W730
.long W730
.long W730
.long W730
.long W730
.long W738
.long W739
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W740
.long W740
.long W740
.long W740
.long W740
.long W740
.long W740
.long W740
.long W748
.long W748
.long W748
.long W748
.long W748
.long W748
.long W748
.long W748
.long W750
.long W750
.long W750
.long W750
.long W750
.long W750
.long W750
.long W750
.long W758
.long W758
.long W758
.long W758
.long W758
.long W758
.long W758
.long W758
.long W760
.long W760
.long W760
.long W760
.long W760
.long W760
.long W760
.long W760
.long W768
.long W768
.long W768
.long W768
.long W768
.long W768
.long W768
.long W768
.long W770
.long W770
.long W770
.long W770
.long W770
.long W770
.long W770
.long W770
.long W778
.long W779
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W788
.long W788
.long W788
.long W788
.long W788
.long W788
.long W788
.long W788
.long W790
.long W790
.long W790
.long W790
.long W790
.long W790
.long W790
.long W790
.long W798
.long W798
.long W798
.long W798
.long W798
.long W798
.long W798
.long W798
.long W7A0
.long W7A0
.long W7A0
.long W7A0
.long W7A0
.long W7A0
.long W7A0
.long W7A0
.long W7A8
.long W7A8
.long W7A8
.long W7A8
.long W7A8
.long W7A8
.long W7A8
.long W7A8
.long W7B0
.long W7B0
.long W7B0
.long W7B0
.long W7B0
.long W7B0
.long W7B0
.long W7B0
.long W7B8
.long W7B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W7C0
.long W7C0
.long W7C0
.long W7C0
.long W7C0
.long W7C0
.long W7C0
.long W7C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W7D0
.long W7D0
.long W7D0
.long W7D0
.long W7D0
.long W7D0
.long W7D0
.long W7D0
.long W7D8
.long W7D8
.long W7D8
.long W7D8
.long W7D8
.long W7D8
.long W7D8
.long W7D8
.long W7E0
.long W7E0
.long W7E0
.long W7E0
.long W7E0
.long W7E0
.long W7E0
.long W7E0
.long W7E8
.long W7E8
.long W7E8
.long W7E8
.long W7E8
.long W7E8
.long W7E8
.long W7E8
.long W7F0
.long W7F0
.long W7F0
.long W7F0
.long W7F0
.long W7F0
.long W7F0
.long W7F0
.long W7F8
.long W7F9
.long W7FA
.long W7FB
.long W7FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W800
.long W800
.long W800
.long W800
.long W800
.long W800
.long W800
.long W800
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W810
.long W810
.long W810
.long W810
.long W810
.long W810
.long W810
.long W810
.long W818
.long W818
.long W818
.long W818
.long W818
.long W818
.long W818
.long W818
.long W820
.long W820
.long W820
.long W820
.long W820
.long W820
.long W820
.long W820
.long W828
.long W828
.long W828
.long W828
.long W828
.long W828
.long W828
.long W828
.long W830
.long W830
.long W830
.long W830
.long W830
.long W830
.long W830
.long W830
.long W838
.long W839
.long W83A
.long W83B
.long W83C
.long r_illegal
.long r_illegal
.long r_illegal
.long W840
.long W840
.long W840
.long W840
.long W840
.long W840
.long W840
.long W840
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W850
.long W850
.long W850
.long W850
.long W850
.long W850
.long W850
.long W850
.long W858
.long W858
.long W858
.long W858
.long W858
.long W858
.long W858
.long W858
.long W860
.long W860
.long W860
.long W860
.long W860
.long W860
.long W860
.long W860
.long W868
.long W868
.long W868
.long W868
.long W868
.long W868
.long W868
.long W868
.long W870
.long W870
.long W870
.long W870
.long W870
.long W870
.long W870
.long W870
.long W878
.long W879
.long W87A
.long W87B
.long W87C
.long r_illegal
.long r_illegal
.long r_illegal
.long W880
.long W880
.long W880
.long W880
.long W880
.long W880
.long W880
.long W880
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W890
.long W890
.long W890
.long W890
.long W890
.long W890
.long W890
.long W890
.long W898
.long W898
.long W898
.long W898
.long W898
.long W898
.long W898
.long W898
.long W8A0
.long W8A0
.long W8A0
.long W8A0
.long W8A0
.long W8A0
.long W8A0
.long W8A0
.long W8A8
.long W8A8
.long W8A8
.long W8A8
.long W8A8
.long W8A8
.long W8A8
.long W8A8
.long W8B0
.long W8B0
.long W8B0
.long W8B0
.long W8B0
.long W8B0
.long W8B0
.long W8B0
.long W8B8
.long W8B9
.long W8BA
.long W8BB
.long W8BC
.long r_illegal
.long r_illegal
.long r_illegal
.long W8C0
.long W8C0
.long W8C0
.long W8C0
.long W8C0
.long W8C0
.long W8C0
.long W8C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W8D0
.long W8D0
.long W8D0
.long W8D0
.long W8D0
.long W8D0
.long W8D0
.long W8D0
.long W8D8
.long W8D8
.long W8D8
.long W8D8
.long W8D8
.long W8D8
.long W8D8
.long W8D8
.long W8E0
.long W8E0
.long W8E0
.long W8E0
.long W8E0
.long W8E0
.long W8E0
.long W8E0
.long W8E8
.long W8E8
.long W8E8
.long W8E8
.long W8E8
.long W8E8
.long W8E8
.long W8E8
.long W8F0
.long W8F0
.long W8F0
.long W8F0
.long W8F0
.long W8F0
.long W8F0
.long W8F0
.long W8F8
.long W8F9
.long W8FA
.long W8FB
.long W8FC
.long r_illegal
.long r_illegal
.long r_illegal
.long W900
.long W900
.long W900
.long W900
.long W900
.long W900
.long W900
.long W900
.long W908
.long W908
.long W908
.long W908
.long W908
.long W908
.long W908
.long W908
.long W910
.long W910
.long W910
.long W910
.long W910
.long W910
.long W910
.long W910
.long W918
.long W918
.long W918
.long W918
.long W918
.long W918
.long W918
.long W918
.long W920
.long W920
.long W920
.long W920
.long W920
.long W920
.long W920
.long W920
.long W928
.long W928
.long W928
.long W928
.long W928
.long W928
.long W928
.long W928
.long W930
.long W930
.long W930
.long W930
.long W930
.long W930
.long W930
.long W930
.long W938
.long W939
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W940
.long W940
.long W940
.long W940
.long W940
.long W940
.long W940
.long W940
.long W948
.long W948
.long W948
.long W948
.long W948
.long W948
.long W948
.long W948
.long W950
.long W950
.long W950
.long W950
.long W950
.long W950
.long W950
.long W950
.long W958
.long W958
.long W958
.long W958
.long W958
.long W958
.long W958
.long W958
.long W960
.long W960
.long W960
.long W960
.long W960
.long W960
.long W960
.long W960
.long W968
.long W968
.long W968
.long W968
.long W968
.long W968
.long W968
.long W968
.long W970
.long W970
.long W970
.long W970
.long W970
.long W970
.long W970
.long W970
.long W978
.long W979
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W988
.long W988
.long W988
.long W988
.long W988
.long W988
.long W988
.long W988
.long W990
.long W990
.long W990
.long W990
.long W990
.long W990
.long W990
.long W990
.long W998
.long W998
.long W998
.long W998
.long W998
.long W998
.long W998
.long W998
.long W9A0
.long W9A0
.long W9A0
.long W9A0
.long W9A0
.long W9A0
.long W9A0
.long W9A0
.long W9A8
.long W9A8
.long W9A8
.long W9A8
.long W9A8
.long W9A8
.long W9A8
.long W9A8
.long W9B0
.long W9B0
.long W9B0
.long W9B0
.long W9B0
.long W9B0
.long W9B0
.long W9B0
.long W9B8
.long W9B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W9C0
.long W9C0
.long W9C0
.long W9C0
.long W9C0
.long W9C0
.long W9C0
.long W9C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long W9D0
.long W9D0
.long W9D0
.long W9D0
.long W9D0
.long W9D0
.long W9D0
.long W9D0
.long W9D8
.long W9D8
.long W9D8
.long W9D8
.long W9D8
.long W9D8
.long W9D8
.long W9D8
.long W9E0
.long W9E0
.long W9E0
.long W9E0
.long W9E0
.long W9E0
.long W9E0
.long W9E0
.long W9E8
.long W9E8
.long W9E8
.long W9E8
.long W9E8
.long W9E8
.long W9E8
.long W9E8
.long W9F0
.long W9F0
.long W9F0
.long W9F0
.long W9F0
.long W9F0
.long W9F0
.long W9F0
.long W9F8
.long W9F9
.long W9FA
.long W9FB
.long W9FC
.long r_illegal
.long r_illegal
.long r_illegal
.long WA00
.long WA00
.long WA00
.long WA00
.long WA00
.long WA00
.long WA00
.long WA00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WA10
.long WA10
.long WA10
.long WA10
.long WA10
.long WA10
.long WA10
.long WA10
.long WA18
.long WA18
.long WA18
.long WA18
.long WA18
.long WA18
.long WA18
.long WA18
.long WA20
.long WA20
.long WA20
.long WA20
.long WA20
.long WA20
.long WA20
.long WA20
.long WA28
.long WA28
.long WA28
.long WA28
.long WA28
.long WA28
.long WA28
.long WA28
.long WA30
.long WA30
.long WA30
.long WA30
.long WA30
.long WA30
.long WA30
.long WA30
.long WA38
.long WA39
.long WA3A
.long WA3B
.long WA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long WA40
.long WA40
.long WA40
.long WA40
.long WA40
.long WA40
.long WA40
.long WA40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WA50
.long WA50
.long WA50
.long WA50
.long WA50
.long WA50
.long WA50
.long WA50
.long WA58
.long WA58
.long WA58
.long WA58
.long WA58
.long WA58
.long WA58
.long WA58
.long WA60
.long WA60
.long WA60
.long WA60
.long WA60
.long WA60
.long WA60
.long WA60
.long WA68
.long WA68
.long WA68
.long WA68
.long WA68
.long WA68
.long WA68
.long WA68
.long WA70
.long WA70
.long WA70
.long WA70
.long WA70
.long WA70
.long WA70
.long WA70
.long WA78
.long WA79
.long WA7A
.long WA7B
.long WA7C
.long r_illegal
.long r_illegal
.long r_illegal
.long WA80
.long WA80
.long WA80
.long WA80
.long WA80
.long WA80
.long WA80
.long WA80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WA90
.long WA90
.long WA90
.long WA90
.long WA90
.long WA90
.long WA90
.long WA90
.long WA98
.long WA98
.long WA98
.long WA98
.long WA98
.long WA98
.long WA98
.long WA98
.long WAA0
.long WAA0
.long WAA0
.long WAA0
.long WAA0
.long WAA0
.long WAA0
.long WAA0
.long WAA8
.long WAA8
.long WAA8
.long WAA8
.long WAA8
.long WAA8
.long WAA8
.long WAA8
.long WAB0
.long WAB0
.long WAB0
.long WAB0
.long WAB0
.long WAB0
.long WAB0
.long WAB0
.long WAB8
.long WAB9
.long WABA
.long WABB
.long WABC
.long r_illegal
.long r_illegal
.long r_illegal
.long WAC0
.long WAC0
.long WAC0
.long WAC0
.long WAC0
.long WAC0
.long WAC0
.long WAC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WAD0
.long WAD0
.long WAD0
.long WAD0
.long WAD0
.long WAD0
.long WAD0
.long WAD0
.long WAD8
.long WAD8
.long WAD8
.long WAD8
.long WAD8
.long WAD8
.long WAD8
.long WAD8
.long WAE0
.long WAE0
.long WAE0
.long WAE0
.long WAE0
.long WAE0
.long WAE0
.long WAE0
.long WAE8
.long WAE8
.long WAE8
.long WAE8
.long WAE8
.long WAE8
.long WAE8
.long WAE8
.long WAF0
.long WAF0
.long WAF0
.long WAF0
.long WAF0
.long WAF0
.long WAF0
.long WAF0
.long WAF8
.long WAF9
.long WAFA
.long WAFB
.long WAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long WB00
.long WB00
.long WB00
.long WB00
.long WB00
.long WB00
.long WB00
.long WB00
.long WB08
.long WB08
.long WB08
.long WB08
.long WB08
.long WB08
.long WB08
.long WB08
.long WB10
.long WB10
.long WB10
.long WB10
.long WB10
.long WB10
.long WB10
.long WB10
.long WB18
.long WB18
.long WB18
.long WB18
.long WB18
.long WB18
.long WB18
.long WB18
.long WB20
.long WB20
.long WB20
.long WB20
.long WB20
.long WB20
.long WB20
.long WB20
.long WB28
.long WB28
.long WB28
.long WB28
.long WB28
.long WB28
.long WB28
.long WB28
.long WB30
.long WB30
.long WB30
.long WB30
.long WB30
.long WB30
.long WB30
.long WB30
.long WB38
.long WB39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WB40
.long WB40
.long WB40
.long WB40
.long WB40
.long WB40
.long WB40
.long WB40
.long WB48
.long WB48
.long WB48
.long WB48
.long WB48
.long WB48
.long WB48
.long WB48
.long WB50
.long WB50
.long WB50
.long WB50
.long WB50
.long WB50
.long WB50
.long WB50
.long WB58
.long WB58
.long WB58
.long WB58
.long WB58
.long WB58
.long WB58
.long WB58
.long WB60
.long WB60
.long WB60
.long WB60
.long WB60
.long WB60
.long WB60
.long WB60
.long WB68
.long WB68
.long WB68
.long WB68
.long WB68
.long WB68
.long WB68
.long WB68
.long WB70
.long WB70
.long WB70
.long WB70
.long WB70
.long WB70
.long WB70
.long WB70
.long WB78
.long WB79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WB88
.long WB88
.long WB88
.long WB88
.long WB88
.long WB88
.long WB88
.long WB88
.long WB90
.long WB90
.long WB90
.long WB90
.long WB90
.long WB90
.long WB90
.long WB90
.long WB98
.long WB98
.long WB98
.long WB98
.long WB98
.long WB98
.long WB98
.long WB98
.long WBA0
.long WBA0
.long WBA0
.long WBA0
.long WBA0
.long WBA0
.long WBA0
.long WBA0
.long WBA8
.long WBA8
.long WBA8
.long WBA8
.long WBA8
.long WBA8
.long WBA8
.long WBA8
.long WBB0
.long WBB0
.long WBB0
.long WBB0
.long WBB0
.long WBB0
.long WBB0
.long WBB0
.long WBB8
.long WBB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WBC0
.long WBC0
.long WBC0
.long WBC0
.long WBC0
.long WBC0
.long WBC0
.long WBC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WBD0
.long WBD0
.long WBD0
.long WBD0
.long WBD0
.long WBD0
.long WBD0
.long WBD0
.long WBD8
.long WBD8
.long WBD8
.long WBD8
.long WBD8
.long WBD8
.long WBD8
.long WBD8
.long WBE0
.long WBE0
.long WBE0
.long WBE0
.long WBE0
.long WBE0
.long WBE0
.long WBE0
.long WBE8
.long WBE8
.long WBE8
.long WBE8
.long WBE8
.long WBE8
.long WBE8
.long WBE8
.long WBF0
.long WBF0
.long WBF0
.long WBF0
.long WBF0
.long WBF0
.long WBF0
.long WBF0
.long WBF8
.long WBF9
.long WBFA
.long WBFB
.long WBFC
.long r_illegal
.long r_illegal
.long r_illegal
.long WC00
.long WC00
.long WC00
.long WC00
.long WC00
.long WC00
.long WC00
.long WC00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WC10
.long WC10
.long WC10
.long WC10
.long WC10
.long WC10
.long WC10
.long WC10
.long WC18
.long WC18
.long WC18
.long WC18
.long WC18
.long WC18
.long WC18
.long WC18
.long WC20
.long WC20
.long WC20
.long WC20
.long WC20
.long WC20
.long WC20
.long WC20
.long WC28
.long WC28
.long WC28
.long WC28
.long WC28
.long WC28
.long WC28
.long WC28
.long WC30
.long WC30
.long WC30
.long WC30
.long WC30
.long WC30
.long WC30
.long WC30
.long WC38
.long WC39
.long WC3A
.long WC3B
.long WC3C
.long r_illegal
.long r_illegal
.long r_illegal
.long WC40
.long WC40
.long WC40
.long WC40
.long WC40
.long WC40
.long WC40
.long WC40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WC50
.long WC50
.long WC50
.long WC50
.long WC50
.long WC50
.long WC50
.long WC50
.long WC58
.long WC58
.long WC58
.long WC58
.long WC58
.long WC58
.long WC58
.long WC58
.long WC60
.long WC60
.long WC60
.long WC60
.long WC60
.long WC60
.long WC60
.long WC60
.long WC68
.long WC68
.long WC68
.long WC68
.long WC68
.long WC68
.long WC68
.long WC68
.long WC70
.long WC70
.long WC70
.long WC70
.long WC70
.long WC70
.long WC70
.long WC70
.long WC78
.long WC79
.long WC7A
.long WC7B
.long WC7C
.long r_illegal
.long r_illegal
.long r_illegal
.long WC80
.long WC80
.long WC80
.long WC80
.long WC80
.long WC80
.long WC80
.long WC80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WC90
.long WC90
.long WC90
.long WC90
.long WC90
.long WC90
.long WC90
.long WC90
.long WC98
.long WC98
.long WC98
.long WC98
.long WC98
.long WC98
.long WC98
.long WC98
.long WCA0
.long WCA0
.long WCA0
.long WCA0
.long WCA0
.long WCA0
.long WCA0
.long WCA0
.long WCA8
.long WCA8
.long WCA8
.long WCA8
.long WCA8
.long WCA8
.long WCA8
.long WCA8
.long WCB0
.long WCB0
.long WCB0
.long WCB0
.long WCB0
.long WCB0
.long WCB0
.long WCB0
.long WCB8
.long WCB9
.long WCBA
.long WCBB
.long WCBC
.long r_illegal
.long r_illegal
.long r_illegal
.long WCC0
.long WCC0
.long WCC0
.long WCC0
.long WCC0
.long WCC0
.long WCC0
.long WCC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WCD0
.long WCD0
.long WCD0
.long WCD0
.long WCD0
.long WCD0
.long WCD0
.long WCD0
.long WCD8
.long WCD8
.long WCD8
.long WCD8
.long WCD8
.long WCD8
.long WCD8
.long WCD8
.long WCE0
.long WCE0
.long WCE0
.long WCE0
.long WCE0
.long WCE0
.long WCE0
.long WCE0
.long WCE8
.long WCE8
.long WCE8
.long WCE8
.long WCE8
.long WCE8
.long WCE8
.long WCE8
.long WCF0
.long WCF0
.long WCF0
.long WCF0
.long WCF0
.long WCF0
.long WCF0
.long WCF0
.long WCF8
.long WCF9
.long WCFA
.long WCFB
.long WCFC
.long r_illegal
.long r_illegal
.long r_illegal
.long WD00
.long WD00
.long WD00
.long WD00
.long WD00
.long WD00
.long WD00
.long WD00
.long WD08
.long WD08
.long WD08
.long WD08
.long WD08
.long WD08
.long WD08
.long WD08
.long WD10
.long WD10
.long WD10
.long WD10
.long WD10
.long WD10
.long WD10
.long WD10
.long WD18
.long WD18
.long WD18
.long WD18
.long WD18
.long WD18
.long WD18
.long WD18
.long WD20
.long WD20
.long WD20
.long WD20
.long WD20
.long WD20
.long WD20
.long WD20
.long WD28
.long WD28
.long WD28
.long WD28
.long WD28
.long WD28
.long WD28
.long WD28
.long WD30
.long WD30
.long WD30
.long WD30
.long WD30
.long WD30
.long WD30
.long WD30
.long WD38
.long WD39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WD40
.long WD40
.long WD40
.long WD40
.long WD40
.long WD40
.long WD40
.long WD40
.long WD48
.long WD48
.long WD48
.long WD48
.long WD48
.long WD48
.long WD48
.long WD48
.long WD50
.long WD50
.long WD50
.long WD50
.long WD50
.long WD50
.long WD50
.long WD50
.long WD58
.long WD58
.long WD58
.long WD58
.long WD58
.long WD58
.long WD58
.long WD58
.long WD60
.long WD60
.long WD60
.long WD60
.long WD60
.long WD60
.long WD60
.long WD60
.long WD68
.long WD68
.long WD68
.long WD68
.long WD68
.long WD68
.long WD68
.long WD68
.long WD70
.long WD70
.long WD70
.long WD70
.long WD70
.long WD70
.long WD70
.long WD70
.long WD78
.long WD79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WD88
.long WD88
.long WD88
.long WD88
.long WD88
.long WD88
.long WD88
.long WD88
.long WD90
.long WD90
.long WD90
.long WD90
.long WD90
.long WD90
.long WD90
.long WD90
.long WD98
.long WD98
.long WD98
.long WD98
.long WD98
.long WD98
.long WD98
.long WD98
.long WDA0
.long WDA0
.long WDA0
.long WDA0
.long WDA0
.long WDA0
.long WDA0
.long WDA0
.long WDA8
.long WDA8
.long WDA8
.long WDA8
.long WDA8
.long WDA8
.long WDA8
.long WDA8
.long WDB0
.long WDB0
.long WDB0
.long WDB0
.long WDB0
.long WDB0
.long WDB0
.long WDB0
.long WDB8
.long WDB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WDC0
.long WDC0
.long WDC0
.long WDC0
.long WDC0
.long WDC0
.long WDC0
.long WDC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WDD0
.long WDD0
.long WDD0
.long WDD0
.long WDD0
.long WDD0
.long WDD0
.long WDD0
.long WDD8
.long WDD8
.long WDD8
.long WDD8
.long WDD8
.long WDD8
.long WDD8
.long WDD8
.long WDE0
.long WDE0
.long WDE0
.long WDE0
.long WDE0
.long WDE0
.long WDE0
.long WDE0
.long WDE8
.long WDE8
.long WDE8
.long WDE8
.long WDE8
.long WDE8
.long WDE8
.long WDE8
.long WDF0
.long WDF0
.long WDF0
.long WDF0
.long WDF0
.long WDF0
.long WDF0
.long WDF0
.long WDF8
.long WDF9
.long WDFA
.long WDFB
.long WDFC
.long r_illegal
.long r_illegal
.long r_illegal
.long WE00
.long WE00
.long WE00
.long WE00
.long WE00
.long WE00
.long WE00
.long WE00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WE10
.long WE10
.long WE10
.long WE10
.long WE10
.long WE10
.long WE10
.long WE10
.long WE18
.long WE18
.long WE18
.long WE18
.long WE18
.long WE18
.long WE18
.long WE18
.long WE20
.long WE20
.long WE20
.long WE20
.long WE20
.long WE20
.long WE20
.long WE20
.long WE28
.long WE28
.long WE28
.long WE28
.long WE28
.long WE28
.long WE28
.long WE28
.long WE30
.long WE30
.long WE30
.long WE30
.long WE30
.long WE30
.long WE30
.long WE30
.long WE38
.long WE39
.long WE3A
.long WE3B
.long WE3C
.long r_illegal
.long r_illegal
.long r_illegal
.long WE40
.long WE40
.long WE40
.long WE40
.long WE40
.long WE40
.long WE40
.long WE40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WE50
.long WE50
.long WE50
.long WE50
.long WE50
.long WE50
.long WE50
.long WE50
.long WE58
.long WE58
.long WE58
.long WE58
.long WE58
.long WE58
.long WE58
.long WE58
.long WE60
.long WE60
.long WE60
.long WE60
.long WE60
.long WE60
.long WE60
.long WE60
.long WE68
.long WE68
.long WE68
.long WE68
.long WE68
.long WE68
.long WE68
.long WE68
.long WE70
.long WE70
.long WE70
.long WE70
.long WE70
.long WE70
.long WE70
.long WE70
.long WE78
.long WE79
.long WE7A
.long WE7B
.long WE7C
.long r_illegal
.long r_illegal
.long r_illegal
.long WE80
.long WE80
.long WE80
.long WE80
.long WE80
.long WE80
.long WE80
.long WE80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WE90
.long WE90
.long WE90
.long WE90
.long WE90
.long WE90
.long WE90
.long WE90
.long WE98
.long WE98
.long WE98
.long WE98
.long WE98
.long WE98
.long WE98
.long WE98
.long WEA0
.long WEA0
.long WEA0
.long WEA0
.long WEA0
.long WEA0
.long WEA0
.long WEA0
.long WEA8
.long WEA8
.long WEA8
.long WEA8
.long WEA8
.long WEA8
.long WEA8
.long WEA8
.long WEB0
.long WEB0
.long WEB0
.long WEB0
.long WEB0
.long WEB0
.long WEB0
.long WEB0
.long WEB8
.long WEB9
.long WEBA
.long WEBB
.long WEBC
.long r_illegal
.long r_illegal
.long r_illegal
.long WEC0
.long WEC0
.long WEC0
.long WEC0
.long WEC0
.long WEC0
.long WEC0
.long WEC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WED0
.long WED0
.long WED0
.long WED0
.long WED0
.long WED0
.long WED0
.long WED0
.long WED8
.long WED8
.long WED8
.long WED8
.long WED8
.long WED8
.long WED8
.long WED8
.long WEE0
.long WEE0
.long WEE0
.long WEE0
.long WEE0
.long WEE0
.long WEE0
.long WEE0
.long WEE8
.long WEE8
.long WEE8
.long WEE8
.long WEE8
.long WEE8
.long WEE8
.long WEE8
.long WEF0
.long WEF0
.long WEF0
.long WEF0
.long WEF0
.long WEF0
.long WEF0
.long WEF0
.long WEF8
.long WEF9
.long WEFA
.long WEFB
.long WEFC
.long r_illegal
.long r_illegal
.long r_illegal
.long WF00
.long WF00
.long WF00
.long WF00
.long WF00
.long WF00
.long WF00
.long WF00
.long WF08
.long WF08
.long WF08
.long WF08
.long WF08
.long WF08
.long WF08
.long WF08
.long WF10
.long WF10
.long WF10
.long WF10
.long WF10
.long WF10
.long WF10
.long WF10
.long WF18
.long WF18
.long WF18
.long WF18
.long WF18
.long WF18
.long WF18
.long WF18
.long WF20
.long WF20
.long WF20
.long WF20
.long WF20
.long WF20
.long WF20
.long WF20
.long WF28
.long WF28
.long WF28
.long WF28
.long WF28
.long WF28
.long WF28
.long WF28
.long WF30
.long WF30
.long WF30
.long WF30
.long WF30
.long WF30
.long WF30
.long WF30
.long WF38
.long WF39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WF40
.long WF40
.long WF40
.long WF40
.long WF40
.long WF40
.long WF40
.long WF40
.long WF48
.long WF48
.long WF48
.long WF48
.long WF48
.long WF48
.long WF48
.long WF48
.long WF50
.long WF50
.long WF50
.long WF50
.long WF50
.long WF50
.long WF50
.long WF50
.long WF58
.long WF58
.long WF58
.long WF58
.long WF58
.long WF58
.long WF58
.long WF58
.long WF60
.long WF60
.long WF60
.long WF60
.long WF60
.long WF60
.long WF60
.long WF60
.long WF68
.long WF68
.long WF68
.long WF68
.long WF68
.long WF68
.long WF68
.long WF68
.long WF70
.long WF70
.long WF70
.long WF70
.long WF70
.long WF70
.long WF70
.long WF70
.long WF78
.long WF79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WF88
.long WF88
.long WF88
.long WF88
.long WF88
.long WF88
.long WF88
.long WF88
.long WF90
.long WF90
.long WF90
.long WF90
.long WF90
.long WF90
.long WF90
.long WF90
.long WF98
.long WF98
.long WF98
.long WF98
.long WF98
.long WF98
.long WF98
.long WF98
.long WFA0
.long WFA0
.long WFA0
.long WFA0
.long WFA0
.long WFA0
.long WFA0
.long WFA0
.long WFA8
.long WFA8
.long WFA8
.long WFA8
.long WFA8
.long WFA8
.long WFA8
.long WFA8
.long WFB0
.long WFB0
.long WFB0
.long WFB0
.long WFB0
.long WFB0
.long WFB0
.long WFB0
.long WFB8
.long WFB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WFC0
.long WFC0
.long WFC0
.long WFC0
.long WFC0
.long WFC0
.long WFC0
.long WFC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long WFD0
.long WFD0
.long WFD0
.long WFD0
.long WFD0
.long WFD0
.long WFD0
.long WFD0
.long WFD8
.long WFD8
.long WFD8
.long WFD8
.long WFD8
.long WFD8
.long WFD8
.long WFD8
.long WFE0
.long WFE0
.long WFE0
.long WFE0
.long WFE0
.long WFE0
.long WFE0
.long WFE0
.long WFE8
.long WFE8
.long WFE8
.long WFE8
.long WFE8
.long WFE8
.long WFE8
.long WFE8
.long WFF0
.long WFF0
.long WFF0
.long WFF0
.long WFF0
.long WFF0
.long WFF0
.long WFF0
.long WFF8
.long WFF9
.long WFFA
.long WFFB
.long WFFC
.long r_illegal
.long r_illegal
.long r_illegal
.long X000
.long X000
.long X000
.long X000
.long X000
.long X000
.long X000
.long X000
.long X008
.long X008
.long X008
.long X008
.long X008
.long X008
.long X008
.long X008
.long X010
.long X010
.long X010
.long X010
.long X010
.long X010
.long X010
.long X010
.long X018
.long X018
.long X018
.long X018
.long X018
.long X018
.long X018
.long X018
.long X020
.long X020
.long X020
.long X020
.long X020
.long X020
.long X020
.long X020
.long X028
.long X028
.long X028
.long X028
.long X028
.long X028
.long X028
.long X028
.long X030
.long X030
.long X030
.long X030
.long X030
.long X030
.long X030
.long X030
.long X038
.long X039
.long X03A
.long X03B
.long X03C
.long r_illegal
.long r_illegal
.long r_illegal
.long X040
.long X040
.long X040
.long X040
.long X040
.long X040
.long X040
.long X040
.long X048
.long X048
.long X048
.long X048
.long X048
.long X048
.long X048
.long X048
.long X050
.long X050
.long X050
.long X050
.long X050
.long X050
.long X050
.long X050
.long X058
.long X058
.long X058
.long X058
.long X058
.long X058
.long X058
.long X058
.long X060
.long X060
.long X060
.long X060
.long X060
.long X060
.long X060
.long X060
.long X068
.long X068
.long X068
.long X068
.long X068
.long X068
.long X068
.long X068
.long X070
.long X070
.long X070
.long X070
.long X070
.long X070
.long X070
.long X070
.long X078
.long X079
.long X07A
.long X07B
.long X07C
.long r_illegal
.long r_illegal
.long r_illegal
.long X080
.long X080
.long X080
.long X080
.long X080
.long X080
.long X080
.long X080
.long X088
.long X088
.long X088
.long X088
.long X088
.long X088
.long X088
.long X088
.long X090
.long X090
.long X090
.long X090
.long X090
.long X090
.long X090
.long X090
.long X098
.long X098
.long X098
.long X098
.long X098
.long X098
.long X098
.long X098
.long X0A0
.long X0A0
.long X0A0
.long X0A0
.long X0A0
.long X0A0
.long X0A0
.long X0A0
.long X0A8
.long X0A8
.long X0A8
.long X0A8
.long X0A8
.long X0A8
.long X0A8
.long X0A8
.long X0B0
.long X0B0
.long X0B0
.long X0B0
.long X0B0
.long X0B0
.long X0B0
.long X0B0
.long X0B8
.long X0B9
.long X0BA
.long X0BB
.long X0BC
.long r_illegal
.long r_illegal
.long r_illegal
.long X0C0
.long X0C0
.long X0C0
.long X0C0
.long X0C0
.long X0C0
.long X0C0
.long X0C0
.long X0C8
.long X0C8
.long X0C8
.long X0C8
.long X0C8
.long X0C8
.long X0C8
.long X0C8
.long X0D0
.long X0D0
.long X0D0
.long X0D0
.long X0D0
.long X0D0
.long X0D0
.long X0D0
.long X0D8
.long X0D8
.long X0D8
.long X0D8
.long X0D8
.long X0D8
.long X0D8
.long X0D8
.long X0E0
.long X0E0
.long X0E0
.long X0E0
.long X0E0
.long X0E0
.long X0E0
.long X0E0
.long X0E8
.long X0E8
.long X0E8
.long X0E8
.long X0E8
.long X0E8
.long X0E8
.long X0E8
.long X0F0
.long X0F0
.long X0F0
.long X0F0
.long X0F0
.long X0F0
.long X0F0
.long X0F0
.long X0F8
.long X0F9
.long X0FA
.long X0FB
.long X0FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X100
.long X100
.long X100
.long X100
.long X100
.long X100
.long X100
.long X100
.long X108
.long X108
.long X108
.long X108
.long X108
.long X108
.long X108
.long X108
.long X110
.long X110
.long X110
.long X110
.long X110
.long X110
.long X110
.long X110
.long X118
.long X118
.long X118
.long X118
.long X118
.long X118
.long X118
.long X118
.long X120
.long X120
.long X120
.long X120
.long X120
.long X120
.long X120
.long X120
.long X128
.long X128
.long X128
.long X128
.long X128
.long X128
.long X128
.long X128
.long X130
.long X130
.long X130
.long X130
.long X130
.long X130
.long X130
.long X130
.long X138
.long X139
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X140
.long X140
.long X140
.long X140
.long X140
.long X140
.long X140
.long X140
.long X148
.long X148
.long X148
.long X148
.long X148
.long X148
.long X148
.long X148
.long X150
.long X150
.long X150
.long X150
.long X150
.long X150
.long X150
.long X150
.long X158
.long X158
.long X158
.long X158
.long X158
.long X158
.long X158
.long X158
.long X160
.long X160
.long X160
.long X160
.long X160
.long X160
.long X160
.long X160
.long X168
.long X168
.long X168
.long X168
.long X168
.long X168
.long X168
.long X168
.long X170
.long X170
.long X170
.long X170
.long X170
.long X170
.long X170
.long X170
.long X178
.long X179
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X180
.long X180
.long X180
.long X180
.long X180
.long X180
.long X180
.long X180
.long X188
.long X188
.long X188
.long X188
.long X188
.long X188
.long X188
.long X188
.long X190
.long X190
.long X190
.long X190
.long X190
.long X190
.long X190
.long X190
.long X198
.long X198
.long X198
.long X198
.long X198
.long X198
.long X198
.long X198
.long X1A0
.long X1A0
.long X1A0
.long X1A0
.long X1A0
.long X1A0
.long X1A0
.long X1A0
.long X1A8
.long X1A8
.long X1A8
.long X1A8
.long X1A8
.long X1A8
.long X1A8
.long X1A8
.long X1B0
.long X1B0
.long X1B0
.long X1B0
.long X1B0
.long X1B0
.long X1B0
.long X1B0
.long X1B8
.long X1B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X1C0
.long X1C0
.long X1C0
.long X1C0
.long X1C0
.long X1C0
.long X1C0
.long X1C0
.long X1C8
.long X1C8
.long X1C8
.long X1C8
.long X1C8
.long X1C8
.long X1C8
.long X1C8
.long X1D0
.long X1D0
.long X1D0
.long X1D0
.long X1D0
.long X1D0
.long X1D0
.long X1D0
.long X1D8
.long X1D8
.long X1D8
.long X1D8
.long X1D8
.long X1D8
.long X1D8
.long X1D8
.long X1E0
.long X1E0
.long X1E0
.long X1E0
.long X1E0
.long X1E0
.long X1E0
.long X1E0
.long X1E8
.long X1E8
.long X1E8
.long X1E8
.long X1E8
.long X1E8
.long X1E8
.long X1E8
.long X1F0
.long X1F0
.long X1F0
.long X1F0
.long X1F0
.long X1F0
.long X1F0
.long X1F0
.long X1F8
.long X1F9
.long X1FA
.long X1FB
.long X1FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X200
.long X200
.long X200
.long X200
.long X200
.long X200
.long X200
.long X200
.long X208
.long X208
.long X208
.long X208
.long X208
.long X208
.long X208
.long X208
.long X210
.long X210
.long X210
.long X210
.long X210
.long X210
.long X210
.long X210
.long X218
.long X218
.long X218
.long X218
.long X218
.long X218
.long X218
.long X218
.long X220
.long X220
.long X220
.long X220
.long X220
.long X220
.long X220
.long X220
.long X228
.long X228
.long X228
.long X228
.long X228
.long X228
.long X228
.long X228
.long X230
.long X230
.long X230
.long X230
.long X230
.long X230
.long X230
.long X230
.long X238
.long X239
.long X23A
.long X23B
.long X23C
.long r_illegal
.long r_illegal
.long r_illegal
.long X240
.long X240
.long X240
.long X240
.long X240
.long X240
.long X240
.long X240
.long X248
.long X248
.long X248
.long X248
.long X248
.long X248
.long X248
.long X248
.long X250
.long X250
.long X250
.long X250
.long X250
.long X250
.long X250
.long X250
.long X258
.long X258
.long X258
.long X258
.long X258
.long X258
.long X258
.long X258
.long X260
.long X260
.long X260
.long X260
.long X260
.long X260
.long X260
.long X260
.long X268
.long X268
.long X268
.long X268
.long X268
.long X268
.long X268
.long X268
.long X270
.long X270
.long X270
.long X270
.long X270
.long X270
.long X270
.long X270
.long X278
.long X279
.long X27A
.long X27B
.long X27C
.long r_illegal
.long r_illegal
.long r_illegal
.long X280
.long X280
.long X280
.long X280
.long X280
.long X280
.long X280
.long X280
.long X288
.long X288
.long X288
.long X288
.long X288
.long X288
.long X288
.long X288
.long X290
.long X290
.long X290
.long X290
.long X290
.long X290
.long X290
.long X290
.long X298
.long X298
.long X298
.long X298
.long X298
.long X298
.long X298
.long X298
.long X2A0
.long X2A0
.long X2A0
.long X2A0
.long X2A0
.long X2A0
.long X2A0
.long X2A0
.long X2A8
.long X2A8
.long X2A8
.long X2A8
.long X2A8
.long X2A8
.long X2A8
.long X2A8
.long X2B0
.long X2B0
.long X2B0
.long X2B0
.long X2B0
.long X2B0
.long X2B0
.long X2B0
.long X2B8
.long X2B9
.long X2BA
.long X2BB
.long X2BC
.long r_illegal
.long r_illegal
.long r_illegal
.long X2C0
.long X2C0
.long X2C0
.long X2C0
.long X2C0
.long X2C0
.long X2C0
.long X2C0
.long X2C8
.long X2C8
.long X2C8
.long X2C8
.long X2C8
.long X2C8
.long X2C8
.long X2C8
.long X2D0
.long X2D0
.long X2D0
.long X2D0
.long X2D0
.long X2D0
.long X2D0
.long X2D0
.long X2D8
.long X2D8
.long X2D8
.long X2D8
.long X2D8
.long X2D8
.long X2D8
.long X2D8
.long X2E0
.long X2E0
.long X2E0
.long X2E0
.long X2E0
.long X2E0
.long X2E0
.long X2E0
.long X2E8
.long X2E8
.long X2E8
.long X2E8
.long X2E8
.long X2E8
.long X2E8
.long X2E8
.long X2F0
.long X2F0
.long X2F0
.long X2F0
.long X2F0
.long X2F0
.long X2F0
.long X2F0
.long X2F8
.long X2F9
.long X2FA
.long X2FB
.long X2FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X300
.long X300
.long X300
.long X300
.long X300
.long X300
.long X300
.long X300
.long X308
.long X308
.long X308
.long X308
.long X308
.long X308
.long X308
.long X308
.long X310
.long X310
.long X310
.long X310
.long X310
.long X310
.long X310
.long X310
.long X318
.long X318
.long X318
.long X318
.long X318
.long X318
.long X318
.long X318
.long X320
.long X320
.long X320
.long X320
.long X320
.long X320
.long X320
.long X320
.long X328
.long X328
.long X328
.long X328
.long X328
.long X328
.long X328
.long X328
.long X330
.long X330
.long X330
.long X330
.long X330
.long X330
.long X330
.long X330
.long X338
.long X339
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X340
.long X340
.long X340
.long X340
.long X340
.long X340
.long X340
.long X340
.long X348
.long X348
.long X348
.long X348
.long X348
.long X348
.long X348
.long X348
.long X350
.long X350
.long X350
.long X350
.long X350
.long X350
.long X350
.long X350
.long X358
.long X358
.long X358
.long X358
.long X358
.long X358
.long X358
.long X358
.long X360
.long X360
.long X360
.long X360
.long X360
.long X360
.long X360
.long X360
.long X368
.long X368
.long X368
.long X368
.long X368
.long X368
.long X368
.long X368
.long X370
.long X370
.long X370
.long X370
.long X370
.long X370
.long X370
.long X370
.long X378
.long X379
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X380
.long X380
.long X380
.long X380
.long X380
.long X380
.long X380
.long X380
.long X388
.long X388
.long X388
.long X388
.long X388
.long X388
.long X388
.long X388
.long X390
.long X390
.long X390
.long X390
.long X390
.long X390
.long X390
.long X390
.long X398
.long X398
.long X398
.long X398
.long X398
.long X398
.long X398
.long X398
.long X3A0
.long X3A0
.long X3A0
.long X3A0
.long X3A0
.long X3A0
.long X3A0
.long X3A0
.long X3A8
.long X3A8
.long X3A8
.long X3A8
.long X3A8
.long X3A8
.long X3A8
.long X3A8
.long X3B0
.long X3B0
.long X3B0
.long X3B0
.long X3B0
.long X3B0
.long X3B0
.long X3B0
.long X3B8
.long X3B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X3C0
.long X3C0
.long X3C0
.long X3C0
.long X3C0
.long X3C0
.long X3C0
.long X3C0
.long X3C8
.long X3C8
.long X3C8
.long X3C8
.long X3C8
.long X3C8
.long X3C8
.long X3C8
.long X3D0
.long X3D0
.long X3D0
.long X3D0
.long X3D0
.long X3D0
.long X3D0
.long X3D0
.long X3D8
.long X3D8
.long X3D8
.long X3D8
.long X3D8
.long X3D8
.long X3D8
.long X3D8
.long X3E0
.long X3E0
.long X3E0
.long X3E0
.long X3E0
.long X3E0
.long X3E0
.long X3E0
.long X3E8
.long X3E8
.long X3E8
.long X3E8
.long X3E8
.long X3E8
.long X3E8
.long X3E8
.long X3F0
.long X3F0
.long X3F0
.long X3F0
.long X3F0
.long X3F0
.long X3F0
.long X3F0
.long X3F8
.long X3F9
.long X3FA
.long X3FB
.long X3FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X400
.long X400
.long X400
.long X400
.long X400
.long X400
.long X400
.long X400
.long X408
.long X408
.long X408
.long X408
.long X408
.long X408
.long X408
.long X408
.long X410
.long X410
.long X410
.long X410
.long X410
.long X410
.long X410
.long X410
.long X418
.long X418
.long X418
.long X418
.long X418
.long X418
.long X418
.long X418
.long X420
.long X420
.long X420
.long X420
.long X420
.long X420
.long X420
.long X420
.long X428
.long X428
.long X428
.long X428
.long X428
.long X428
.long X428
.long X428
.long X430
.long X430
.long X430
.long X430
.long X430
.long X430
.long X430
.long X430
.long X438
.long X439
.long X43A
.long X43B
.long X43C
.long r_illegal
.long r_illegal
.long r_illegal
.long X440
.long X440
.long X440
.long X440
.long X440
.long X440
.long X440
.long X440
.long X448
.long X448
.long X448
.long X448
.long X448
.long X448
.long X448
.long X448
.long X450
.long X450
.long X450
.long X450
.long X450
.long X450
.long X450
.long X450
.long X458
.long X458
.long X458
.long X458
.long X458
.long X458
.long X458
.long X458
.long X460
.long X460
.long X460
.long X460
.long X460
.long X460
.long X460
.long X460
.long X468
.long X468
.long X468
.long X468
.long X468
.long X468
.long X468
.long X468
.long X470
.long X470
.long X470
.long X470
.long X470
.long X470
.long X470
.long X470
.long X478
.long X479
.long X47A
.long X47B
.long X47C
.long r_illegal
.long r_illegal
.long r_illegal
.long X480
.long X480
.long X480
.long X480
.long X480
.long X480
.long X480
.long X480
.long X488
.long X488
.long X488
.long X488
.long X488
.long X488
.long X488
.long X488
.long X490
.long X490
.long X490
.long X490
.long X490
.long X490
.long X490
.long X490
.long X498
.long X498
.long X498
.long X498
.long X498
.long X498
.long X498
.long X498
.long X4A0
.long X4A0
.long X4A0
.long X4A0
.long X4A0
.long X4A0
.long X4A0
.long X4A0
.long X4A8
.long X4A8
.long X4A8
.long X4A8
.long X4A8
.long X4A8
.long X4A8
.long X4A8
.long X4B0
.long X4B0
.long X4B0
.long X4B0
.long X4B0
.long X4B0
.long X4B0
.long X4B0
.long X4B8
.long X4B9
.long X4BA
.long X4BB
.long X4BC
.long r_illegal
.long r_illegal
.long r_illegal
.long X4C0
.long X4C0
.long X4C0
.long X4C0
.long X4C0
.long X4C0
.long X4C0
.long X4C0
.long X4C8
.long X4C8
.long X4C8
.long X4C8
.long X4C8
.long X4C8
.long X4C8
.long X4C8
.long X4D0
.long X4D0
.long X4D0
.long X4D0
.long X4D0
.long X4D0
.long X4D0
.long X4D0
.long X4D8
.long X4D8
.long X4D8
.long X4D8
.long X4D8
.long X4D8
.long X4D8
.long X4D8
.long X4E0
.long X4E0
.long X4E0
.long X4E0
.long X4E0
.long X4E0
.long X4E0
.long X4E0
.long X4E8
.long X4E8
.long X4E8
.long X4E8
.long X4E8
.long X4E8
.long X4E8
.long X4E8
.long X4F0
.long X4F0
.long X4F0
.long X4F0
.long X4F0
.long X4F0
.long X4F0
.long X4F0
.long X4F8
.long X4F9
.long X4FA
.long X4FB
.long X4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X500
.long X500
.long X500
.long X500
.long X500
.long X500
.long X500
.long X500
.long X508
.long X508
.long X508
.long X508
.long X508
.long X508
.long X508
.long X508
.long X510
.long X510
.long X510
.long X510
.long X510
.long X510
.long X510
.long X510
.long X518
.long X518
.long X518
.long X518
.long X518
.long X518
.long X518
.long X518
.long X520
.long X520
.long X520
.long X520
.long X520
.long X520
.long X520
.long X520
.long X528
.long X528
.long X528
.long X528
.long X528
.long X528
.long X528
.long X528
.long X530
.long X530
.long X530
.long X530
.long X530
.long X530
.long X530
.long X530
.long X538
.long X539
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X540
.long X540
.long X540
.long X540
.long X540
.long X540
.long X540
.long X540
.long X548
.long X548
.long X548
.long X548
.long X548
.long X548
.long X548
.long X548
.long X550
.long X550
.long X550
.long X550
.long X550
.long X550
.long X550
.long X550
.long X558
.long X558
.long X558
.long X558
.long X558
.long X558
.long X558
.long X558
.long X560
.long X560
.long X560
.long X560
.long X560
.long X560
.long X560
.long X560
.long X568
.long X568
.long X568
.long X568
.long X568
.long X568
.long X568
.long X568
.long X570
.long X570
.long X570
.long X570
.long X570
.long X570
.long X570
.long X570
.long X578
.long X579
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X580
.long X580
.long X580
.long X580
.long X580
.long X580
.long X580
.long X580
.long X588
.long X588
.long X588
.long X588
.long X588
.long X588
.long X588
.long X588
.long X590
.long X590
.long X590
.long X590
.long X590
.long X590
.long X590
.long X590
.long X598
.long X598
.long X598
.long X598
.long X598
.long X598
.long X598
.long X598
.long X5A0
.long X5A0
.long X5A0
.long X5A0
.long X5A0
.long X5A0
.long X5A0
.long X5A0
.long X5A8
.long X5A8
.long X5A8
.long X5A8
.long X5A8
.long X5A8
.long X5A8
.long X5A8
.long X5B0
.long X5B0
.long X5B0
.long X5B0
.long X5B0
.long X5B0
.long X5B0
.long X5B0
.long X5B8
.long X5B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X5C0
.long X5C0
.long X5C0
.long X5C0
.long X5C0
.long X5C0
.long X5C0
.long X5C0
.long X5C8
.long X5C8
.long X5C8
.long X5C8
.long X5C8
.long X5C8
.long X5C8
.long X5C8
.long X5D0
.long X5D0
.long X5D0
.long X5D0
.long X5D0
.long X5D0
.long X5D0
.long X5D0
.long X5D8
.long X5D8
.long X5D8
.long X5D8
.long X5D8
.long X5D8
.long X5D8
.long X5D8
.long X5E0
.long X5E0
.long X5E0
.long X5E0
.long X5E0
.long X5E0
.long X5E0
.long X5E0
.long X5E8
.long X5E8
.long X5E8
.long X5E8
.long X5E8
.long X5E8
.long X5E8
.long X5E8
.long X5F0
.long X5F0
.long X5F0
.long X5F0
.long X5F0
.long X5F0
.long X5F0
.long X5F0
.long X5F8
.long X5F9
.long X5FA
.long X5FB
.long X5FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X600
.long X600
.long X600
.long X600
.long X600
.long X600
.long X600
.long X600
.long X608
.long X608
.long X608
.long X608
.long X608
.long X608
.long X608
.long X608
.long X610
.long X610
.long X610
.long X610
.long X610
.long X610
.long X610
.long X610
.long X618
.long X618
.long X618
.long X618
.long X618
.long X618
.long X618
.long X618
.long X620
.long X620
.long X620
.long X620
.long X620
.long X620
.long X620
.long X620
.long X628
.long X628
.long X628
.long X628
.long X628
.long X628
.long X628
.long X628
.long X630
.long X630
.long X630
.long X630
.long X630
.long X630
.long X630
.long X630
.long X638
.long X639
.long X63A
.long X63B
.long X63C
.long r_illegal
.long r_illegal
.long r_illegal
.long X640
.long X640
.long X640
.long X640
.long X640
.long X640
.long X640
.long X640
.long X648
.long X648
.long X648
.long X648
.long X648
.long X648
.long X648
.long X648
.long X650
.long X650
.long X650
.long X650
.long X650
.long X650
.long X650
.long X650
.long X658
.long X658
.long X658
.long X658
.long X658
.long X658
.long X658
.long X658
.long X660
.long X660
.long X660
.long X660
.long X660
.long X660
.long X660
.long X660
.long X668
.long X668
.long X668
.long X668
.long X668
.long X668
.long X668
.long X668
.long X670
.long X670
.long X670
.long X670
.long X670
.long X670
.long X670
.long X670
.long X678
.long X679
.long X67A
.long X67B
.long X67C
.long r_illegal
.long r_illegal
.long r_illegal
.long X680
.long X680
.long X680
.long X680
.long X680
.long X680
.long X680
.long X680
.long X688
.long X688
.long X688
.long X688
.long X688
.long X688
.long X688
.long X688
.long X690
.long X690
.long X690
.long X690
.long X690
.long X690
.long X690
.long X690
.long X698
.long X698
.long X698
.long X698
.long X698
.long X698
.long X698
.long X698
.long X6A0
.long X6A0
.long X6A0
.long X6A0
.long X6A0
.long X6A0
.long X6A0
.long X6A0
.long X6A8
.long X6A8
.long X6A8
.long X6A8
.long X6A8
.long X6A8
.long X6A8
.long X6A8
.long X6B0
.long X6B0
.long X6B0
.long X6B0
.long X6B0
.long X6B0
.long X6B0
.long X6B0
.long X6B8
.long X6B9
.long X6BA
.long X6BB
.long X6BC
.long r_illegal
.long r_illegal
.long r_illegal
.long X6C0
.long X6C0
.long X6C0
.long X6C0
.long X6C0
.long X6C0
.long X6C0
.long X6C0
.long X6C8
.long X6C8
.long X6C8
.long X6C8
.long X6C8
.long X6C8
.long X6C8
.long X6C8
.long X6D0
.long X6D0
.long X6D0
.long X6D0
.long X6D0
.long X6D0
.long X6D0
.long X6D0
.long X6D8
.long X6D8
.long X6D8
.long X6D8
.long X6D8
.long X6D8
.long X6D8
.long X6D8
.long X6E0
.long X6E0
.long X6E0
.long X6E0
.long X6E0
.long X6E0
.long X6E0
.long X6E0
.long X6E8
.long X6E8
.long X6E8
.long X6E8
.long X6E8
.long X6E8
.long X6E8
.long X6E8
.long X6F0
.long X6F0
.long X6F0
.long X6F0
.long X6F0
.long X6F0
.long X6F0
.long X6F0
.long X6F8
.long X6F9
.long X6FA
.long X6FB
.long X6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X700
.long X700
.long X700
.long X700
.long X700
.long X700
.long X700
.long X700
.long X708
.long X708
.long X708
.long X708
.long X708
.long X708
.long X708
.long X708
.long X710
.long X710
.long X710
.long X710
.long X710
.long X710
.long X710
.long X710
.long X718
.long X718
.long X718
.long X718
.long X718
.long X718
.long X718
.long X718
.long X720
.long X720
.long X720
.long X720
.long X720
.long X720
.long X720
.long X720
.long X728
.long X728
.long X728
.long X728
.long X728
.long X728
.long X728
.long X728
.long X730
.long X730
.long X730
.long X730
.long X730
.long X730
.long X730
.long X730
.long X738
.long X739
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X740
.long X740
.long X740
.long X740
.long X740
.long X740
.long X740
.long X740
.long X748
.long X748
.long X748
.long X748
.long X748
.long X748
.long X748
.long X748
.long X750
.long X750
.long X750
.long X750
.long X750
.long X750
.long X750
.long X750
.long X758
.long X758
.long X758
.long X758
.long X758
.long X758
.long X758
.long X758
.long X760
.long X760
.long X760
.long X760
.long X760
.long X760
.long X760
.long X760
.long X768
.long X768
.long X768
.long X768
.long X768
.long X768
.long X768
.long X768
.long X770
.long X770
.long X770
.long X770
.long X770
.long X770
.long X770
.long X770
.long X778
.long X779
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X780
.long X780
.long X780
.long X780
.long X780
.long X780
.long X780
.long X780
.long X788
.long X788
.long X788
.long X788
.long X788
.long X788
.long X788
.long X788
.long X790
.long X790
.long X790
.long X790
.long X790
.long X790
.long X790
.long X790
.long X798
.long X798
.long X798
.long X798
.long X798
.long X798
.long X798
.long X798
.long X7A0
.long X7A0
.long X7A0
.long X7A0
.long X7A0
.long X7A0
.long X7A0
.long X7A0
.long X7A8
.long X7A8
.long X7A8
.long X7A8
.long X7A8
.long X7A8
.long X7A8
.long X7A8
.long X7B0
.long X7B0
.long X7B0
.long X7B0
.long X7B0
.long X7B0
.long X7B0
.long X7B0
.long X7B8
.long X7B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X7C0
.long X7C0
.long X7C0
.long X7C0
.long X7C0
.long X7C0
.long X7C0
.long X7C0
.long X7C8
.long X7C8
.long X7C8
.long X7C8
.long X7C8
.long X7C8
.long X7C8
.long X7C8
.long X7D0
.long X7D0
.long X7D0
.long X7D0
.long X7D0
.long X7D0
.long X7D0
.long X7D0
.long X7D8
.long X7D8
.long X7D8
.long X7D8
.long X7D8
.long X7D8
.long X7D8
.long X7D8
.long X7E0
.long X7E0
.long X7E0
.long X7E0
.long X7E0
.long X7E0
.long X7E0
.long X7E0
.long X7E8
.long X7E8
.long X7E8
.long X7E8
.long X7E8
.long X7E8
.long X7E8
.long X7E8
.long X7F0
.long X7F0
.long X7F0
.long X7F0
.long X7F0
.long X7F0
.long X7F0
.long X7F0
.long X7F8
.long X7F9
.long X7FA
.long X7FB
.long X7FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X800
.long X800
.long X800
.long X800
.long X800
.long X800
.long X800
.long X800
.long X808
.long X808
.long X808
.long X808
.long X808
.long X808
.long X808
.long X808
.long X810
.long X810
.long X810
.long X810
.long X810
.long X810
.long X810
.long X810
.long X818
.long X818
.long X818
.long X818
.long X818
.long X818
.long X818
.long X818
.long X820
.long X820
.long X820
.long X820
.long X820
.long X820
.long X820
.long X820
.long X828
.long X828
.long X828
.long X828
.long X828
.long X828
.long X828
.long X828
.long X830
.long X830
.long X830
.long X830
.long X830
.long X830
.long X830
.long X830
.long X838
.long X839
.long X83A
.long X83B
.long X83C
.long r_illegal
.long r_illegal
.long r_illegal
.long X840
.long X840
.long X840
.long X840
.long X840
.long X840
.long X840
.long X840
.long X848
.long X848
.long X848
.long X848
.long X848
.long X848
.long X848
.long X848
.long X850
.long X850
.long X850
.long X850
.long X850
.long X850
.long X850
.long X850
.long X858
.long X858
.long X858
.long X858
.long X858
.long X858
.long X858
.long X858
.long X860
.long X860
.long X860
.long X860
.long X860
.long X860
.long X860
.long X860
.long X868
.long X868
.long X868
.long X868
.long X868
.long X868
.long X868
.long X868
.long X870
.long X870
.long X870
.long X870
.long X870
.long X870
.long X870
.long X870
.long X878
.long X879
.long X87A
.long X87B
.long X87C
.long r_illegal
.long r_illegal
.long r_illegal
.long X880
.long X880
.long X880
.long X880
.long X880
.long X880
.long X880
.long X880
.long X888
.long X888
.long X888
.long X888
.long X888
.long X888
.long X888
.long X888
.long X890
.long X890
.long X890
.long X890
.long X890
.long X890
.long X890
.long X890
.long X898
.long X898
.long X898
.long X898
.long X898
.long X898
.long X898
.long X898
.long X8A0
.long X8A0
.long X8A0
.long X8A0
.long X8A0
.long X8A0
.long X8A0
.long X8A0
.long X8A8
.long X8A8
.long X8A8
.long X8A8
.long X8A8
.long X8A8
.long X8A8
.long X8A8
.long X8B0
.long X8B0
.long X8B0
.long X8B0
.long X8B0
.long X8B0
.long X8B0
.long X8B0
.long X8B8
.long X8B9
.long X8BA
.long X8BB
.long X8BC
.long r_illegal
.long r_illegal
.long r_illegal
.long X8C0
.long X8C0
.long X8C0
.long X8C0
.long X8C0
.long X8C0
.long X8C0
.long X8C0
.long X8C8
.long X8C8
.long X8C8
.long X8C8
.long X8C8
.long X8C8
.long X8C8
.long X8C8
.long X8D0
.long X8D0
.long X8D0
.long X8D0
.long X8D0
.long X8D0
.long X8D0
.long X8D0
.long X8D8
.long X8D8
.long X8D8
.long X8D8
.long X8D8
.long X8D8
.long X8D8
.long X8D8
.long X8E0
.long X8E0
.long X8E0
.long X8E0
.long X8E0
.long X8E0
.long X8E0
.long X8E0
.long X8E8
.long X8E8
.long X8E8
.long X8E8
.long X8E8
.long X8E8
.long X8E8
.long X8E8
.long X8F0
.long X8F0
.long X8F0
.long X8F0
.long X8F0
.long X8F0
.long X8F0
.long X8F0
.long X8F8
.long X8F9
.long X8FA
.long X8FB
.long X8FC
.long r_illegal
.long r_illegal
.long r_illegal
.long X900
.long X900
.long X900
.long X900
.long X900
.long X900
.long X900
.long X900
.long X908
.long X908
.long X908
.long X908
.long X908
.long X908
.long X908
.long X908
.long X910
.long X910
.long X910
.long X910
.long X910
.long X910
.long X910
.long X910
.long X918
.long X918
.long X918
.long X918
.long X918
.long X918
.long X918
.long X918
.long X920
.long X920
.long X920
.long X920
.long X920
.long X920
.long X920
.long X920
.long X928
.long X928
.long X928
.long X928
.long X928
.long X928
.long X928
.long X928
.long X930
.long X930
.long X930
.long X930
.long X930
.long X930
.long X930
.long X930
.long X938
.long X939
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X940
.long X940
.long X940
.long X940
.long X940
.long X940
.long X940
.long X940
.long X948
.long X948
.long X948
.long X948
.long X948
.long X948
.long X948
.long X948
.long X950
.long X950
.long X950
.long X950
.long X950
.long X950
.long X950
.long X950
.long X958
.long X958
.long X958
.long X958
.long X958
.long X958
.long X958
.long X958
.long X960
.long X960
.long X960
.long X960
.long X960
.long X960
.long X960
.long X960
.long X968
.long X968
.long X968
.long X968
.long X968
.long X968
.long X968
.long X968
.long X970
.long X970
.long X970
.long X970
.long X970
.long X970
.long X970
.long X970
.long X978
.long X979
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X980
.long X980
.long X980
.long X980
.long X980
.long X980
.long X980
.long X980
.long X988
.long X988
.long X988
.long X988
.long X988
.long X988
.long X988
.long X988
.long X990
.long X990
.long X990
.long X990
.long X990
.long X990
.long X990
.long X990
.long X998
.long X998
.long X998
.long X998
.long X998
.long X998
.long X998
.long X998
.long X9A0
.long X9A0
.long X9A0
.long X9A0
.long X9A0
.long X9A0
.long X9A0
.long X9A0
.long X9A8
.long X9A8
.long X9A8
.long X9A8
.long X9A8
.long X9A8
.long X9A8
.long X9A8
.long X9B0
.long X9B0
.long X9B0
.long X9B0
.long X9B0
.long X9B0
.long X9B0
.long X9B0
.long X9B8
.long X9B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long X9C0
.long X9C0
.long X9C0
.long X9C0
.long X9C0
.long X9C0
.long X9C0
.long X9C0
.long X9C8
.long X9C8
.long X9C8
.long X9C8
.long X9C8
.long X9C8
.long X9C8
.long X9C8
.long X9D0
.long X9D0
.long X9D0
.long X9D0
.long X9D0
.long X9D0
.long X9D0
.long X9D0
.long X9D8
.long X9D8
.long X9D8
.long X9D8
.long X9D8
.long X9D8
.long X9D8
.long X9D8
.long X9E0
.long X9E0
.long X9E0
.long X9E0
.long X9E0
.long X9E0
.long X9E0
.long X9E0
.long X9E8
.long X9E8
.long X9E8
.long X9E8
.long X9E8
.long X9E8
.long X9E8
.long X9E8
.long X9F0
.long X9F0
.long X9F0
.long X9F0
.long X9F0
.long X9F0
.long X9F0
.long X9F0
.long X9F8
.long X9F9
.long X9FA
.long X9FB
.long X9FC
.long r_illegal
.long r_illegal
.long r_illegal
.long XA00
.long XA00
.long XA00
.long XA00
.long XA00
.long XA00
.long XA00
.long XA00
.long XA08
.long XA08
.long XA08
.long XA08
.long XA08
.long XA08
.long XA08
.long XA08
.long XA10
.long XA10
.long XA10
.long XA10
.long XA10
.long XA10
.long XA10
.long XA10
.long XA18
.long XA18
.long XA18
.long XA18
.long XA18
.long XA18
.long XA18
.long XA18
.long XA20
.long XA20
.long XA20
.long XA20
.long XA20
.long XA20
.long XA20
.long XA20
.long XA28
.long XA28
.long XA28
.long XA28
.long XA28
.long XA28
.long XA28
.long XA28
.long XA30
.long XA30
.long XA30
.long XA30
.long XA30
.long XA30
.long XA30
.long XA30
.long XA38
.long XA39
.long XA3A
.long XA3B
.long XA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long XA40
.long XA40
.long XA40
.long XA40
.long XA40
.long XA40
.long XA40
.long XA40
.long XA48
.long XA48
.long XA48
.long XA48
.long XA48
.long XA48
.long XA48
.long XA48
.long XA50
.long XA50
.long XA50
.long XA50
.long XA50
.long XA50
.long XA50
.long XA50
.long XA58
.long XA58
.long XA58
.long XA58
.long XA58
.long XA58
.long XA58
.long XA58
.long XA60
.long XA60
.long XA60
.long XA60
.long XA60
.long XA60
.long XA60
.long XA60
.long XA68
.long XA68
.long XA68
.long XA68
.long XA68
.long XA68
.long XA68
.long XA68
.long XA70
.long XA70
.long XA70
.long XA70
.long XA70
.long XA70
.long XA70
.long XA70
.long XA78
.long XA79
.long XA7A
.long XA7B
.long XA7C
.long r_illegal
.long r_illegal
.long r_illegal
.long XA80
.long XA80
.long XA80
.long XA80
.long XA80
.long XA80
.long XA80
.long XA80
.long XA88
.long XA88
.long XA88
.long XA88
.long XA88
.long XA88
.long XA88
.long XA88
.long XA90
.long XA90
.long XA90
.long XA90
.long XA90
.long XA90
.long XA90
.long XA90
.long XA98
.long XA98
.long XA98
.long XA98
.long XA98
.long XA98
.long XA98
.long XA98
.long XAA0
.long XAA0
.long XAA0
.long XAA0
.long XAA0
.long XAA0
.long XAA0
.long XAA0
.long XAA8
.long XAA8
.long XAA8
.long XAA8
.long XAA8
.long XAA8
.long XAA8
.long XAA8
.long XAB0
.long XAB0
.long XAB0
.long XAB0
.long XAB0
.long XAB0
.long XAB0
.long XAB0
.long XAB8
.long XAB9
.long XABA
.long XABB
.long XABC
.long r_illegal
.long r_illegal
.long r_illegal
.long XAC0
.long XAC0
.long XAC0
.long XAC0
.long XAC0
.long XAC0
.long XAC0
.long XAC0
.long XAC8
.long XAC8
.long XAC8
.long XAC8
.long XAC8
.long XAC8
.long XAC8
.long XAC8
.long XAD0
.long XAD0
.long XAD0
.long XAD0
.long XAD0
.long XAD0
.long XAD0
.long XAD0
.long XAD8
.long XAD8
.long XAD8
.long XAD8
.long XAD8
.long XAD8
.long XAD8
.long XAD8
.long XAE0
.long XAE0
.long XAE0
.long XAE0
.long XAE0
.long XAE0
.long XAE0
.long XAE0
.long XAE8
.long XAE8
.long XAE8
.long XAE8
.long XAE8
.long XAE8
.long XAE8
.long XAE8
.long XAF0
.long XAF0
.long XAF0
.long XAF0
.long XAF0
.long XAF0
.long XAF0
.long XAF0
.long XAF8
.long XAF9
.long XAFA
.long XAFB
.long XAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long XB00
.long XB00
.long XB00
.long XB00
.long XB00
.long XB00
.long XB00
.long XB00
.long XB08
.long XB08
.long XB08
.long XB08
.long XB08
.long XB08
.long XB08
.long XB08
.long XB10
.long XB10
.long XB10
.long XB10
.long XB10
.long XB10
.long XB10
.long XB10
.long XB18
.long XB18
.long XB18
.long XB18
.long XB18
.long XB18
.long XB18
.long XB18
.long XB20
.long XB20
.long XB20
.long XB20
.long XB20
.long XB20
.long XB20
.long XB20
.long XB28
.long XB28
.long XB28
.long XB28
.long XB28
.long XB28
.long XB28
.long XB28
.long XB30
.long XB30
.long XB30
.long XB30
.long XB30
.long XB30
.long XB30
.long XB30
.long XB38
.long XB39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XB40
.long XB40
.long XB40
.long XB40
.long XB40
.long XB40
.long XB40
.long XB40
.long XB48
.long XB48
.long XB48
.long XB48
.long XB48
.long XB48
.long XB48
.long XB48
.long XB50
.long XB50
.long XB50
.long XB50
.long XB50
.long XB50
.long XB50
.long XB50
.long XB58
.long XB58
.long XB58
.long XB58
.long XB58
.long XB58
.long XB58
.long XB58
.long XB60
.long XB60
.long XB60
.long XB60
.long XB60
.long XB60
.long XB60
.long XB60
.long XB68
.long XB68
.long XB68
.long XB68
.long XB68
.long XB68
.long XB68
.long XB68
.long XB70
.long XB70
.long XB70
.long XB70
.long XB70
.long XB70
.long XB70
.long XB70
.long XB78
.long XB79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XB80
.long XB80
.long XB80
.long XB80
.long XB80
.long XB80
.long XB80
.long XB80
.long XB88
.long XB88
.long XB88
.long XB88
.long XB88
.long XB88
.long XB88
.long XB88
.long XB90
.long XB90
.long XB90
.long XB90
.long XB90
.long XB90
.long XB90
.long XB90
.long XB98
.long XB98
.long XB98
.long XB98
.long XB98
.long XB98
.long XB98
.long XB98
.long XBA0
.long XBA0
.long XBA0
.long XBA0
.long XBA0
.long XBA0
.long XBA0
.long XBA0
.long XBA8
.long XBA8
.long XBA8
.long XBA8
.long XBA8
.long XBA8
.long XBA8
.long XBA8
.long XBB0
.long XBB0
.long XBB0
.long XBB0
.long XBB0
.long XBB0
.long XBB0
.long XBB0
.long XBB8
.long XBB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XBC0
.long XBC0
.long XBC0
.long XBC0
.long XBC0
.long XBC0
.long XBC0
.long XBC0
.long XBC8
.long XBC8
.long XBC8
.long XBC8
.long XBC8
.long XBC8
.long XBC8
.long XBC8
.long XBD0
.long XBD0
.long XBD0
.long XBD0
.long XBD0
.long XBD0
.long XBD0
.long XBD0
.long XBD8
.long XBD8
.long XBD8
.long XBD8
.long XBD8
.long XBD8
.long XBD8
.long XBD8
.long XBE0
.long XBE0
.long XBE0
.long XBE0
.long XBE0
.long XBE0
.long XBE0
.long XBE0
.long XBE8
.long XBE8
.long XBE8
.long XBE8
.long XBE8
.long XBE8
.long XBE8
.long XBE8
.long XBF0
.long XBF0
.long XBF0
.long XBF0
.long XBF0
.long XBF0
.long XBF0
.long XBF0
.long XBF8
.long XBF9
.long XBFA
.long XBFB
.long XBFC
.long r_illegal
.long r_illegal
.long r_illegal
.long XC00
.long XC00
.long XC00
.long XC00
.long XC00
.long XC00
.long XC00
.long XC00
.long XC08
.long XC08
.long XC08
.long XC08
.long XC08
.long XC08
.long XC08
.long XC08
.long XC10
.long XC10
.long XC10
.long XC10
.long XC10
.long XC10
.long XC10
.long XC10
.long XC18
.long XC18
.long XC18
.long XC18
.long XC18
.long XC18
.long XC18
.long XC18
.long XC20
.long XC20
.long XC20
.long XC20
.long XC20
.long XC20
.long XC20
.long XC20
.long XC28
.long XC28
.long XC28
.long XC28
.long XC28
.long XC28
.long XC28
.long XC28
.long XC30
.long XC30
.long XC30
.long XC30
.long XC30
.long XC30
.long XC30
.long XC30
.long XC38
.long XC39
.long XC3A
.long XC3B
.long XC3C
.long r_illegal
.long r_illegal
.long r_illegal
.long XC40
.long XC40
.long XC40
.long XC40
.long XC40
.long XC40
.long XC40
.long XC40
.long XC48
.long XC48
.long XC48
.long XC48
.long XC48
.long XC48
.long XC48
.long XC48
.long XC50
.long XC50
.long XC50
.long XC50
.long XC50
.long XC50
.long XC50
.long XC50
.long XC58
.long XC58
.long XC58
.long XC58
.long XC58
.long XC58
.long XC58
.long XC58
.long XC60
.long XC60
.long XC60
.long XC60
.long XC60
.long XC60
.long XC60
.long XC60
.long XC68
.long XC68
.long XC68
.long XC68
.long XC68
.long XC68
.long XC68
.long XC68
.long XC70
.long XC70
.long XC70
.long XC70
.long XC70
.long XC70
.long XC70
.long XC70
.long XC78
.long XC79
.long XC7A
.long XC7B
.long XC7C
.long r_illegal
.long r_illegal
.long r_illegal
.long XC80
.long XC80
.long XC80
.long XC80
.long XC80
.long XC80
.long XC80
.long XC80
.long XC88
.long XC88
.long XC88
.long XC88
.long XC88
.long XC88
.long XC88
.long XC88
.long XC90
.long XC90
.long XC90
.long XC90
.long XC90
.long XC90
.long XC90
.long XC90
.long XC98
.long XC98
.long XC98
.long XC98
.long XC98
.long XC98
.long XC98
.long XC98
.long XCA0
.long XCA0
.long XCA0
.long XCA0
.long XCA0
.long XCA0
.long XCA0
.long XCA0
.long XCA8
.long XCA8
.long XCA8
.long XCA8
.long XCA8
.long XCA8
.long XCA8
.long XCA8
.long XCB0
.long XCB0
.long XCB0
.long XCB0
.long XCB0
.long XCB0
.long XCB0
.long XCB0
.long XCB8
.long XCB9
.long XCBA
.long XCBB
.long XCBC
.long r_illegal
.long r_illegal
.long r_illegal
.long XCC0
.long XCC0
.long XCC0
.long XCC0
.long XCC0
.long XCC0
.long XCC0
.long XCC0
.long XCC8
.long XCC8
.long XCC8
.long XCC8
.long XCC8
.long XCC8
.long XCC8
.long XCC8
.long XCD0
.long XCD0
.long XCD0
.long XCD0
.long XCD0
.long XCD0
.long XCD0
.long XCD0
.long XCD8
.long XCD8
.long XCD8
.long XCD8
.long XCD8
.long XCD8
.long XCD8
.long XCD8
.long XCE0
.long XCE0
.long XCE0
.long XCE0
.long XCE0
.long XCE0
.long XCE0
.long XCE0
.long XCE8
.long XCE8
.long XCE8
.long XCE8
.long XCE8
.long XCE8
.long XCE8
.long XCE8
.long XCF0
.long XCF0
.long XCF0
.long XCF0
.long XCF0
.long XCF0
.long XCF0
.long XCF0
.long XCF8
.long XCF9
.long XCFA
.long XCFB
.long XCFC
.long r_illegal
.long r_illegal
.long r_illegal
.long XD00
.long XD00
.long XD00
.long XD00
.long XD00
.long XD00
.long XD00
.long XD00
.long XD08
.long XD08
.long XD08
.long XD08
.long XD08
.long XD08
.long XD08
.long XD08
.long XD10
.long XD10
.long XD10
.long XD10
.long XD10
.long XD10
.long XD10
.long XD10
.long XD18
.long XD18
.long XD18
.long XD18
.long XD18
.long XD18
.long XD18
.long XD18
.long XD20
.long XD20
.long XD20
.long XD20
.long XD20
.long XD20
.long XD20
.long XD20
.long XD28
.long XD28
.long XD28
.long XD28
.long XD28
.long XD28
.long XD28
.long XD28
.long XD30
.long XD30
.long XD30
.long XD30
.long XD30
.long XD30
.long XD30
.long XD30
.long XD38
.long XD39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XD40
.long XD40
.long XD40
.long XD40
.long XD40
.long XD40
.long XD40
.long XD40
.long XD48
.long XD48
.long XD48
.long XD48
.long XD48
.long XD48
.long XD48
.long XD48
.long XD50
.long XD50
.long XD50
.long XD50
.long XD50
.long XD50
.long XD50
.long XD50
.long XD58
.long XD58
.long XD58
.long XD58
.long XD58
.long XD58
.long XD58
.long XD58
.long XD60
.long XD60
.long XD60
.long XD60
.long XD60
.long XD60
.long XD60
.long XD60
.long XD68
.long XD68
.long XD68
.long XD68
.long XD68
.long XD68
.long XD68
.long XD68
.long XD70
.long XD70
.long XD70
.long XD70
.long XD70
.long XD70
.long XD70
.long XD70
.long XD78
.long XD79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XD80
.long XD80
.long XD80
.long XD80
.long XD80
.long XD80
.long XD80
.long XD80
.long XD88
.long XD88
.long XD88
.long XD88
.long XD88
.long XD88
.long XD88
.long XD88
.long XD90
.long XD90
.long XD90
.long XD90
.long XD90
.long XD90
.long XD90
.long XD90
.long XD98
.long XD98
.long XD98
.long XD98
.long XD98
.long XD98
.long XD98
.long XD98
.long XDA0
.long XDA0
.long XDA0
.long XDA0
.long XDA0
.long XDA0
.long XDA0
.long XDA0
.long XDA8
.long XDA8
.long XDA8
.long XDA8
.long XDA8
.long XDA8
.long XDA8
.long XDA8
.long XDB0
.long XDB0
.long XDB0
.long XDB0
.long XDB0
.long XDB0
.long XDB0
.long XDB0
.long XDB8
.long XDB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XDC0
.long XDC0
.long XDC0
.long XDC0
.long XDC0
.long XDC0
.long XDC0
.long XDC0
.long XDC8
.long XDC8
.long XDC8
.long XDC8
.long XDC8
.long XDC8
.long XDC8
.long XDC8
.long XDD0
.long XDD0
.long XDD0
.long XDD0
.long XDD0
.long XDD0
.long XDD0
.long XDD0
.long XDD8
.long XDD8
.long XDD8
.long XDD8
.long XDD8
.long XDD8
.long XDD8
.long XDD8
.long XDE0
.long XDE0
.long XDE0
.long XDE0
.long XDE0
.long XDE0
.long XDE0
.long XDE0
.long XDE8
.long XDE8
.long XDE8
.long XDE8
.long XDE8
.long XDE8
.long XDE8
.long XDE8
.long XDF0
.long XDF0
.long XDF0
.long XDF0
.long XDF0
.long XDF0
.long XDF0
.long XDF0
.long XDF8
.long XDF9
.long XDFA
.long XDFB
.long XDFC
.long r_illegal
.long r_illegal
.long r_illegal
.long XE00
.long XE00
.long XE00
.long XE00
.long XE00
.long XE00
.long XE00
.long XE00
.long XE08
.long XE08
.long XE08
.long XE08
.long XE08
.long XE08
.long XE08
.long XE08
.long XE10
.long XE10
.long XE10
.long XE10
.long XE10
.long XE10
.long XE10
.long XE10
.long XE18
.long XE18
.long XE18
.long XE18
.long XE18
.long XE18
.long XE18
.long XE18
.long XE20
.long XE20
.long XE20
.long XE20
.long XE20
.long XE20
.long XE20
.long XE20
.long XE28
.long XE28
.long XE28
.long XE28
.long XE28
.long XE28
.long XE28
.long XE28
.long XE30
.long XE30
.long XE30
.long XE30
.long XE30
.long XE30
.long XE30
.long XE30
.long XE38
.long XE39
.long XE3A
.long XE3B
.long XE3C
.long r_illegal
.long r_illegal
.long r_illegal
.long XE40
.long XE40
.long XE40
.long XE40
.long XE40
.long XE40
.long XE40
.long XE40
.long XE48
.long XE48
.long XE48
.long XE48
.long XE48
.long XE48
.long XE48
.long XE48
.long XE50
.long XE50
.long XE50
.long XE50
.long XE50
.long XE50
.long XE50
.long XE50
.long XE58
.long XE58
.long XE58
.long XE58
.long XE58
.long XE58
.long XE58
.long XE58
.long XE60
.long XE60
.long XE60
.long XE60
.long XE60
.long XE60
.long XE60
.long XE60
.long XE68
.long XE68
.long XE68
.long XE68
.long XE68
.long XE68
.long XE68
.long XE68
.long XE70
.long XE70
.long XE70
.long XE70
.long XE70
.long XE70
.long XE70
.long XE70
.long XE78
.long XE79
.long XE7A
.long XE7B
.long XE7C
.long r_illegal
.long r_illegal
.long r_illegal
.long XE80
.long XE80
.long XE80
.long XE80
.long XE80
.long XE80
.long XE80
.long XE80
.long XE88
.long XE88
.long XE88
.long XE88
.long XE88
.long XE88
.long XE88
.long XE88
.long XE90
.long XE90
.long XE90
.long XE90
.long XE90
.long XE90
.long XE90
.long XE90
.long XE98
.long XE98
.long XE98
.long XE98
.long XE98
.long XE98
.long XE98
.long XE98
.long XEA0
.long XEA0
.long XEA0
.long XEA0
.long XEA0
.long XEA0
.long XEA0
.long XEA0
.long XEA8
.long XEA8
.long XEA8
.long XEA8
.long XEA8
.long XEA8
.long XEA8
.long XEA8
.long XEB0
.long XEB0
.long XEB0
.long XEB0
.long XEB0
.long XEB0
.long XEB0
.long XEB0
.long XEB8
.long XEB9
.long XEBA
.long XEBB
.long XEBC
.long r_illegal
.long r_illegal
.long r_illegal
.long XEC0
.long XEC0
.long XEC0
.long XEC0
.long XEC0
.long XEC0
.long XEC0
.long XEC0
.long XEC8
.long XEC8
.long XEC8
.long XEC8
.long XEC8
.long XEC8
.long XEC8
.long XEC8
.long XED0
.long XED0
.long XED0
.long XED0
.long XED0
.long XED0
.long XED0
.long XED0
.long XED8
.long XED8
.long XED8
.long XED8
.long XED8
.long XED8
.long XED8
.long XED8
.long XEE0
.long XEE0
.long XEE0
.long XEE0
.long XEE0
.long XEE0
.long XEE0
.long XEE0
.long XEE8
.long XEE8
.long XEE8
.long XEE8
.long XEE8
.long XEE8
.long XEE8
.long XEE8
.long XEF0
.long XEF0
.long XEF0
.long XEF0
.long XEF0
.long XEF0
.long XEF0
.long XEF0
.long XEF8
.long XEF9
.long XEFA
.long XEFB
.long XEFC
.long r_illegal
.long r_illegal
.long r_illegal
.long XF00
.long XF00
.long XF00
.long XF00
.long XF00
.long XF00
.long XF00
.long XF00
.long XF08
.long XF08
.long XF08
.long XF08
.long XF08
.long XF08
.long XF08
.long XF08
.long XF10
.long XF10
.long XF10
.long XF10
.long XF10
.long XF10
.long XF10
.long XF10
.long XF18
.long XF18
.long XF18
.long XF18
.long XF18
.long XF18
.long XF18
.long XF18
.long XF20
.long XF20
.long XF20
.long XF20
.long XF20
.long XF20
.long XF20
.long XF20
.long XF28
.long XF28
.long XF28
.long XF28
.long XF28
.long XF28
.long XF28
.long XF28
.long XF30
.long XF30
.long XF30
.long XF30
.long XF30
.long XF30
.long XF30
.long XF30
.long XF38
.long XF39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XF40
.long XF40
.long XF40
.long XF40
.long XF40
.long XF40
.long XF40
.long XF40
.long XF48
.long XF48
.long XF48
.long XF48
.long XF48
.long XF48
.long XF48
.long XF48
.long XF50
.long XF50
.long XF50
.long XF50
.long XF50
.long XF50
.long XF50
.long XF50
.long XF58
.long XF58
.long XF58
.long XF58
.long XF58
.long XF58
.long XF58
.long XF58
.long XF60
.long XF60
.long XF60
.long XF60
.long XF60
.long XF60
.long XF60
.long XF60
.long XF68
.long XF68
.long XF68
.long XF68
.long XF68
.long XF68
.long XF68
.long XF68
.long XF70
.long XF70
.long XF70
.long XF70
.long XF70
.long XF70
.long XF70
.long XF70
.long XF78
.long XF79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XF80
.long XF80
.long XF80
.long XF80
.long XF80
.long XF80
.long XF80
.long XF80
.long XF88
.long XF88
.long XF88
.long XF88
.long XF88
.long XF88
.long XF88
.long XF88
.long XF90
.long XF90
.long XF90
.long XF90
.long XF90
.long XF90
.long XF90
.long XF90
.long XF98
.long XF98
.long XF98
.long XF98
.long XF98
.long XF98
.long XF98
.long XF98
.long XFA0
.long XFA0
.long XFA0
.long XFA0
.long XFA0
.long XFA0
.long XFA0
.long XFA0
.long XFA8
.long XFA8
.long XFA8
.long XFA8
.long XFA8
.long XFA8
.long XFA8
.long XFA8
.long XFB0
.long XFB0
.long XFB0
.long XFB0
.long XFB0
.long XFB0
.long XFB0
.long XFB0
.long XFB8
.long XFB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long XFC0
.long XFC0
.long XFC0
.long XFC0
.long XFC0
.long XFC0
.long XFC0
.long XFC0
.long XFC8
.long XFC8
.long XFC8
.long XFC8
.long XFC8
.long XFC8
.long XFC8
.long XFC8
.long XFD0
.long XFD0
.long XFD0
.long XFD0
.long XFD0
.long XFD0
.long XFD0
.long XFD0
.long XFD8
.long XFD8
.long XFD8
.long XFD8
.long XFD8
.long XFD8
.long XFD8
.long XFD8
.long XFE0
.long XFE0
.long XFE0
.long XFE0
.long XFE0
.long XFE0
.long XFE0
.long XFE0
.long XFE8
.long XFE8
.long XFE8
.long XFE8
.long XFE8
.long XFE8
.long XFE8
.long XFE8
.long XFF0
.long XFF0
.long XFF0
.long XFF0
.long XFF0
.long XFF0
.long XFF0
.long XFF0
.long XFF8
.long XFF9
.long XFFA
.long XFFB
.long XFFC
.long r_illegal
.long r_illegal
.long r_illegal
.long Y000
.long Y000
.long Y000
.long Y000
.long Y000
.long Y000
.long Y000
.long Y000
.long Y008
.long Y008
.long Y008
.long Y008
.long Y008
.long Y008
.long Y008
.long Y008
.long Y010
.long Y010
.long Y010
.long Y010
.long Y010
.long Y010
.long Y010
.long Y010
.long Y018
.long Y018
.long Y018
.long Y018
.long Y018
.long Y018
.long Y018
.long Y018
.long Y020
.long Y020
.long Y020
.long Y020
.long Y020
.long Y020
.long Y020
.long Y020
.long Y028
.long Y028
.long Y028
.long Y028
.long Y028
.long Y028
.long Y028
.long Y028
.long Y030
.long Y030
.long Y030
.long Y030
.long Y030
.long Y030
.long Y030
.long Y030
.long Y038
.long Y038
.long Y038
.long Y038
.long Y038
.long Y038
.long Y038
.long Y038
.long Y040
.long Y040
.long Y040
.long Y040
.long Y040
.long Y040
.long Y040
.long Y040
.long Y048
.long Y048
.long Y048
.long Y048
.long Y048
.long Y048
.long Y048
.long Y048
.long Y050
.long Y050
.long Y050
.long Y050
.long Y050
.long Y050
.long Y050
.long Y050
.long Y058
.long Y058
.long Y058
.long Y058
.long Y058
.long Y058
.long Y058
.long Y058
.long Y060
.long Y060
.long Y060
.long Y060
.long Y060
.long Y060
.long Y060
.long Y060
.long Y068
.long Y068
.long Y068
.long Y068
.long Y068
.long Y068
.long Y068
.long Y068
.long Y070
.long Y070
.long Y070
.long Y070
.long Y070
.long Y070
.long Y070
.long Y070
.long Y078
.long Y078
.long Y078
.long Y078
.long Y078
.long Y078
.long Y078
.long Y078
.long Y080
.long Y080
.long Y080
.long Y080
.long Y080
.long Y080
.long Y080
.long Y080
.long Y088
.long Y088
.long Y088
.long Y088
.long Y088
.long Y088
.long Y088
.long Y088
.long Y090
.long Y090
.long Y090
.long Y090
.long Y090
.long Y090
.long Y090
.long Y090
.long Y098
.long Y098
.long Y098
.long Y098
.long Y098
.long Y098
.long Y098
.long Y098
.long Y0A0
.long Y0A0
.long Y0A0
.long Y0A0
.long Y0A0
.long Y0A0
.long Y0A0
.long Y0A0
.long Y0A8
.long Y0A8
.long Y0A8
.long Y0A8
.long Y0A8
.long Y0A8
.long Y0A8
.long Y0A8
.long Y0B0
.long Y0B0
.long Y0B0
.long Y0B0
.long Y0B0
.long Y0B0
.long Y0B0
.long Y0B0
.long Y0B8
.long Y0B8
.long Y0B8
.long Y0B8
.long Y0B8
.long Y0B8
.long Y0B8
.long Y0B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y0D0
.long Y0D0
.long Y0D0
.long Y0D0
.long Y0D0
.long Y0D0
.long Y0D0
.long Y0D0
.long Y0D8
.long Y0D8
.long Y0D8
.long Y0D8
.long Y0D8
.long Y0D8
.long Y0D8
.long Y0D8
.long Y0E0
.long Y0E0
.long Y0E0
.long Y0E0
.long Y0E0
.long Y0E0
.long Y0E0
.long Y0E0
.long Y0E8
.long Y0E8
.long Y0E8
.long Y0E8
.long Y0E8
.long Y0E8
.long Y0E8
.long Y0E8
.long Y0F0
.long Y0F0
.long Y0F0
.long Y0F0
.long Y0F0
.long Y0F0
.long Y0F0
.long Y0F0
.long Y0F8
.long Y0F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y100
.long Y100
.long Y100
.long Y100
.long Y100
.long Y100
.long Y100
.long Y100
.long Y108
.long Y108
.long Y108
.long Y108
.long Y108
.long Y108
.long Y108
.long Y108
.long Y110
.long Y110
.long Y110
.long Y110
.long Y110
.long Y110
.long Y110
.long Y110
.long Y118
.long Y118
.long Y118
.long Y118
.long Y118
.long Y118
.long Y118
.long Y118
.long Y120
.long Y120
.long Y120
.long Y120
.long Y120
.long Y120
.long Y120
.long Y120
.long Y128
.long Y128
.long Y128
.long Y128
.long Y128
.long Y128
.long Y128
.long Y128
.long Y130
.long Y130
.long Y130
.long Y130
.long Y130
.long Y130
.long Y130
.long Y130
.long Y138
.long Y138
.long Y138
.long Y138
.long Y138
.long Y138
.long Y138
.long Y138
.long Y140
.long Y140
.long Y140
.long Y140
.long Y140
.long Y140
.long Y140
.long Y140
.long Y148
.long Y148
.long Y148
.long Y148
.long Y148
.long Y148
.long Y148
.long Y148
.long Y150
.long Y150
.long Y150
.long Y150
.long Y150
.long Y150
.long Y150
.long Y150
.long Y158
.long Y158
.long Y158
.long Y158
.long Y158
.long Y158
.long Y158
.long Y158
.long Y160
.long Y160
.long Y160
.long Y160
.long Y160
.long Y160
.long Y160
.long Y160
.long Y168
.long Y168
.long Y168
.long Y168
.long Y168
.long Y168
.long Y168
.long Y168
.long Y170
.long Y170
.long Y170
.long Y170
.long Y170
.long Y170
.long Y170
.long Y170
.long Y178
.long Y178
.long Y178
.long Y178
.long Y178
.long Y178
.long Y178
.long Y178
.long Y180
.long Y180
.long Y180
.long Y180
.long Y180
.long Y180
.long Y180
.long Y180
.long Y188
.long Y188
.long Y188
.long Y188
.long Y188
.long Y188
.long Y188
.long Y188
.long Y190
.long Y190
.long Y190
.long Y190
.long Y190
.long Y190
.long Y190
.long Y190
.long Y198
.long Y198
.long Y198
.long Y198
.long Y198
.long Y198
.long Y198
.long Y198
.long Y1A0
.long Y1A0
.long Y1A0
.long Y1A0
.long Y1A0
.long Y1A0
.long Y1A0
.long Y1A0
.long Y1A8
.long Y1A8
.long Y1A8
.long Y1A8
.long Y1A8
.long Y1A8
.long Y1A8
.long Y1A8
.long Y1B0
.long Y1B0
.long Y1B0
.long Y1B0
.long Y1B0
.long Y1B0
.long Y1B0
.long Y1B0
.long Y1B8
.long Y1B8
.long Y1B8
.long Y1B8
.long Y1B8
.long Y1B8
.long Y1B8
.long Y1B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y1D0
.long Y1D0
.long Y1D0
.long Y1D0
.long Y1D0
.long Y1D0
.long Y1D0
.long Y1D0
.long Y1D8
.long Y1D8
.long Y1D8
.long Y1D8
.long Y1D8
.long Y1D8
.long Y1D8
.long Y1D8
.long Y1E0
.long Y1E0
.long Y1E0
.long Y1E0
.long Y1E0
.long Y1E0
.long Y1E0
.long Y1E0
.long Y1E8
.long Y1E8
.long Y1E8
.long Y1E8
.long Y1E8
.long Y1E8
.long Y1E8
.long Y1E8
.long Y1F0
.long Y1F0
.long Y1F0
.long Y1F0
.long Y1F0
.long Y1F0
.long Y1F0
.long Y1F0
.long Y1F8
.long Y1F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y200
.long Y200
.long Y200
.long Y200
.long Y200
.long Y200
.long Y200
.long Y200
.long Y208
.long Y208
.long Y208
.long Y208
.long Y208
.long Y208
.long Y208
.long Y208
.long Y210
.long Y210
.long Y210
.long Y210
.long Y210
.long Y210
.long Y210
.long Y210
.long Y218
.long Y218
.long Y218
.long Y218
.long Y218
.long Y218
.long Y218
.long Y218
.long Y220
.long Y220
.long Y220
.long Y220
.long Y220
.long Y220
.long Y220
.long Y220
.long Y228
.long Y228
.long Y228
.long Y228
.long Y228
.long Y228
.long Y228
.long Y228
.long Y230
.long Y230
.long Y230
.long Y230
.long Y230
.long Y230
.long Y230
.long Y230
.long Y238
.long Y238
.long Y238
.long Y238
.long Y238
.long Y238
.long Y238
.long Y238
.long Y240
.long Y240
.long Y240
.long Y240
.long Y240
.long Y240
.long Y240
.long Y240
.long Y248
.long Y248
.long Y248
.long Y248
.long Y248
.long Y248
.long Y248
.long Y248
.long Y250
.long Y250
.long Y250
.long Y250
.long Y250
.long Y250
.long Y250
.long Y250
.long Y258
.long Y258
.long Y258
.long Y258
.long Y258
.long Y258
.long Y258
.long Y258
.long Y260
.long Y260
.long Y260
.long Y260
.long Y260
.long Y260
.long Y260
.long Y260
.long Y268
.long Y268
.long Y268
.long Y268
.long Y268
.long Y268
.long Y268
.long Y268
.long Y270
.long Y270
.long Y270
.long Y270
.long Y270
.long Y270
.long Y270
.long Y270
.long Y278
.long Y278
.long Y278
.long Y278
.long Y278
.long Y278
.long Y278
.long Y278
.long Y280
.long Y280
.long Y280
.long Y280
.long Y280
.long Y280
.long Y280
.long Y280
.long Y288
.long Y288
.long Y288
.long Y288
.long Y288
.long Y288
.long Y288
.long Y288
.long Y290
.long Y290
.long Y290
.long Y290
.long Y290
.long Y290
.long Y290
.long Y290
.long Y298
.long Y298
.long Y298
.long Y298
.long Y298
.long Y298
.long Y298
.long Y298
.long Y2A0
.long Y2A0
.long Y2A0
.long Y2A0
.long Y2A0
.long Y2A0
.long Y2A0
.long Y2A0
.long Y2A8
.long Y2A8
.long Y2A8
.long Y2A8
.long Y2A8
.long Y2A8
.long Y2A8
.long Y2A8
.long Y2B0
.long Y2B0
.long Y2B0
.long Y2B0
.long Y2B0
.long Y2B0
.long Y2B0
.long Y2B0
.long Y2B8
.long Y2B8
.long Y2B8
.long Y2B8
.long Y2B8
.long Y2B8
.long Y2B8
.long Y2B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y2D0
.long Y2D0
.long Y2D0
.long Y2D0
.long Y2D0
.long Y2D0
.long Y2D0
.long Y2D0
.long Y2D8
.long Y2D8
.long Y2D8
.long Y2D8
.long Y2D8
.long Y2D8
.long Y2D8
.long Y2D8
.long Y2E0
.long Y2E0
.long Y2E0
.long Y2E0
.long Y2E0
.long Y2E0
.long Y2E0
.long Y2E0
.long Y2E8
.long Y2E8
.long Y2E8
.long Y2E8
.long Y2E8
.long Y2E8
.long Y2E8
.long Y2E8
.long Y2F0
.long Y2F0
.long Y2F0
.long Y2F0
.long Y2F0
.long Y2F0
.long Y2F0
.long Y2F0
.long Y2F8
.long Y2F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y300
.long Y300
.long Y300
.long Y300
.long Y300
.long Y300
.long Y300
.long Y300
.long Y308
.long Y308
.long Y308
.long Y308
.long Y308
.long Y308
.long Y308
.long Y308
.long Y310
.long Y310
.long Y310
.long Y310
.long Y310
.long Y310
.long Y310
.long Y310
.long Y318
.long Y318
.long Y318
.long Y318
.long Y318
.long Y318
.long Y318
.long Y318
.long Y320
.long Y320
.long Y320
.long Y320
.long Y320
.long Y320
.long Y320
.long Y320
.long Y328
.long Y328
.long Y328
.long Y328
.long Y328
.long Y328
.long Y328
.long Y328
.long Y330
.long Y330
.long Y330
.long Y330
.long Y330
.long Y330
.long Y330
.long Y330
.long Y338
.long Y338
.long Y338
.long Y338
.long Y338
.long Y338
.long Y338
.long Y338
.long Y340
.long Y340
.long Y340
.long Y340
.long Y340
.long Y340
.long Y340
.long Y340
.long Y348
.long Y348
.long Y348
.long Y348
.long Y348
.long Y348
.long Y348
.long Y348
.long Y350
.long Y350
.long Y350
.long Y350
.long Y350
.long Y350
.long Y350
.long Y350
.long Y358
.long Y358
.long Y358
.long Y358
.long Y358
.long Y358
.long Y358
.long Y358
.long Y360
.long Y360
.long Y360
.long Y360
.long Y360
.long Y360
.long Y360
.long Y360
.long Y368
.long Y368
.long Y368
.long Y368
.long Y368
.long Y368
.long Y368
.long Y368
.long Y370
.long Y370
.long Y370
.long Y370
.long Y370
.long Y370
.long Y370
.long Y370
.long Y378
.long Y378
.long Y378
.long Y378
.long Y378
.long Y378
.long Y378
.long Y378
.long Y380
.long Y380
.long Y380
.long Y380
.long Y380
.long Y380
.long Y380
.long Y380
.long Y388
.long Y388
.long Y388
.long Y388
.long Y388
.long Y388
.long Y388
.long Y388
.long Y390
.long Y390
.long Y390
.long Y390
.long Y390
.long Y390
.long Y390
.long Y390
.long Y398
.long Y398
.long Y398
.long Y398
.long Y398
.long Y398
.long Y398
.long Y398
.long Y3A0
.long Y3A0
.long Y3A0
.long Y3A0
.long Y3A0
.long Y3A0
.long Y3A0
.long Y3A0
.long Y3A8
.long Y3A8
.long Y3A8
.long Y3A8
.long Y3A8
.long Y3A8
.long Y3A8
.long Y3A8
.long Y3B0
.long Y3B0
.long Y3B0
.long Y3B0
.long Y3B0
.long Y3B0
.long Y3B0
.long Y3B0
.long Y3B8
.long Y3B8
.long Y3B8
.long Y3B8
.long Y3B8
.long Y3B8
.long Y3B8
.long Y3B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y3D0
.long Y3D0
.long Y3D0
.long Y3D0
.long Y3D0
.long Y3D0
.long Y3D0
.long Y3D0
.long Y3D8
.long Y3D8
.long Y3D8
.long Y3D8
.long Y3D8
.long Y3D8
.long Y3D8
.long Y3D8
.long Y3E0
.long Y3E0
.long Y3E0
.long Y3E0
.long Y3E0
.long Y3E0
.long Y3E0
.long Y3E0
.long Y3E8
.long Y3E8
.long Y3E8
.long Y3E8
.long Y3E8
.long Y3E8
.long Y3E8
.long Y3E8
.long Y3F0
.long Y3F0
.long Y3F0
.long Y3F0
.long Y3F0
.long Y3F0
.long Y3F0
.long Y3F0
.long Y3F8
.long Y3F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y400
.long Y400
.long Y400
.long Y400
.long Y400
.long Y400
.long Y400
.long Y400
.long Y408
.long Y408
.long Y408
.long Y408
.long Y408
.long Y408
.long Y408
.long Y408
.long Y410
.long Y410
.long Y410
.long Y410
.long Y410
.long Y410
.long Y410
.long Y410
.long Y418
.long Y418
.long Y418
.long Y418
.long Y418
.long Y418
.long Y418
.long Y418
.long Y420
.long Y420
.long Y420
.long Y420
.long Y420
.long Y420
.long Y420
.long Y420
.long Y428
.long Y428
.long Y428
.long Y428
.long Y428
.long Y428
.long Y428
.long Y428
.long Y430
.long Y430
.long Y430
.long Y430
.long Y430
.long Y430
.long Y430
.long Y430
.long Y438
.long Y438
.long Y438
.long Y438
.long Y438
.long Y438
.long Y438
.long Y438
.long Y440
.long Y440
.long Y440
.long Y440
.long Y440
.long Y440
.long Y440
.long Y440
.long Y448
.long Y448
.long Y448
.long Y448
.long Y448
.long Y448
.long Y448
.long Y448
.long Y450
.long Y450
.long Y450
.long Y450
.long Y450
.long Y450
.long Y450
.long Y450
.long Y458
.long Y458
.long Y458
.long Y458
.long Y458
.long Y458
.long Y458
.long Y458
.long Y460
.long Y460
.long Y460
.long Y460
.long Y460
.long Y460
.long Y460
.long Y460
.long Y468
.long Y468
.long Y468
.long Y468
.long Y468
.long Y468
.long Y468
.long Y468
.long Y470
.long Y470
.long Y470
.long Y470
.long Y470
.long Y470
.long Y470
.long Y470
.long Y478
.long Y478
.long Y478
.long Y478
.long Y478
.long Y478
.long Y478
.long Y478
.long Y480
.long Y480
.long Y480
.long Y480
.long Y480
.long Y480
.long Y480
.long Y480
.long Y488
.long Y488
.long Y488
.long Y488
.long Y488
.long Y488
.long Y488
.long Y488
.long Y490
.long Y490
.long Y490
.long Y490
.long Y490
.long Y490
.long Y490
.long Y490
.long Y498
.long Y498
.long Y498
.long Y498
.long Y498
.long Y498
.long Y498
.long Y498
.long Y4A0
.long Y4A0
.long Y4A0
.long Y4A0
.long Y4A0
.long Y4A0
.long Y4A0
.long Y4A0
.long Y4A8
.long Y4A8
.long Y4A8
.long Y4A8
.long Y4A8
.long Y4A8
.long Y4A8
.long Y4A8
.long Y4B0
.long Y4B0
.long Y4B0
.long Y4B0
.long Y4B0
.long Y4B0
.long Y4B0
.long Y4B0
.long Y4B8
.long Y4B8
.long Y4B8
.long Y4B8
.long Y4B8
.long Y4B8
.long Y4B8
.long Y4B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y4D0
.long Y4D0
.long Y4D0
.long Y4D0
.long Y4D0
.long Y4D0
.long Y4D0
.long Y4D0
.long Y4D8
.long Y4D8
.long Y4D8
.long Y4D8
.long Y4D8
.long Y4D8
.long Y4D8
.long Y4D8
.long Y4E0
.long Y4E0
.long Y4E0
.long Y4E0
.long Y4E0
.long Y4E0
.long Y4E0
.long Y4E0
.long Y4E8
.long Y4E8
.long Y4E8
.long Y4E8
.long Y4E8
.long Y4E8
.long Y4E8
.long Y4E8
.long Y4F0
.long Y4F0
.long Y4F0
.long Y4F0
.long Y4F0
.long Y4F0
.long Y4F0
.long Y4F0
.long Y4F8
.long Y4F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y500
.long Y500
.long Y500
.long Y500
.long Y500
.long Y500
.long Y500
.long Y500
.long Y508
.long Y508
.long Y508
.long Y508
.long Y508
.long Y508
.long Y508
.long Y508
.long Y510
.long Y510
.long Y510
.long Y510
.long Y510
.long Y510
.long Y510
.long Y510
.long Y518
.long Y518
.long Y518
.long Y518
.long Y518
.long Y518
.long Y518
.long Y518
.long Y520
.long Y520
.long Y520
.long Y520
.long Y520
.long Y520
.long Y520
.long Y520
.long Y528
.long Y528
.long Y528
.long Y528
.long Y528
.long Y528
.long Y528
.long Y528
.long Y530
.long Y530
.long Y530
.long Y530
.long Y530
.long Y530
.long Y530
.long Y530
.long Y538
.long Y538
.long Y538
.long Y538
.long Y538
.long Y538
.long Y538
.long Y538
.long Y540
.long Y540
.long Y540
.long Y540
.long Y540
.long Y540
.long Y540
.long Y540
.long Y548
.long Y548
.long Y548
.long Y548
.long Y548
.long Y548
.long Y548
.long Y548
.long Y550
.long Y550
.long Y550
.long Y550
.long Y550
.long Y550
.long Y550
.long Y550
.long Y558
.long Y558
.long Y558
.long Y558
.long Y558
.long Y558
.long Y558
.long Y558
.long Y560
.long Y560
.long Y560
.long Y560
.long Y560
.long Y560
.long Y560
.long Y560
.long Y568
.long Y568
.long Y568
.long Y568
.long Y568
.long Y568
.long Y568
.long Y568
.long Y570
.long Y570
.long Y570
.long Y570
.long Y570
.long Y570
.long Y570
.long Y570
.long Y578
.long Y578
.long Y578
.long Y578
.long Y578
.long Y578
.long Y578
.long Y578
.long Y580
.long Y580
.long Y580
.long Y580
.long Y580
.long Y580
.long Y580
.long Y580
.long Y588
.long Y588
.long Y588
.long Y588
.long Y588
.long Y588
.long Y588
.long Y588
.long Y590
.long Y590
.long Y590
.long Y590
.long Y590
.long Y590
.long Y590
.long Y590
.long Y598
.long Y598
.long Y598
.long Y598
.long Y598
.long Y598
.long Y598
.long Y598
.long Y5A0
.long Y5A0
.long Y5A0
.long Y5A0
.long Y5A0
.long Y5A0
.long Y5A0
.long Y5A0
.long Y5A8
.long Y5A8
.long Y5A8
.long Y5A8
.long Y5A8
.long Y5A8
.long Y5A8
.long Y5A8
.long Y5B0
.long Y5B0
.long Y5B0
.long Y5B0
.long Y5B0
.long Y5B0
.long Y5B0
.long Y5B0
.long Y5B8
.long Y5B8
.long Y5B8
.long Y5B8
.long Y5B8
.long Y5B8
.long Y5B8
.long Y5B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y5D0
.long Y5D0
.long Y5D0
.long Y5D0
.long Y5D0
.long Y5D0
.long Y5D0
.long Y5D0
.long Y5D8
.long Y5D8
.long Y5D8
.long Y5D8
.long Y5D8
.long Y5D8
.long Y5D8
.long Y5D8
.long Y5E0
.long Y5E0
.long Y5E0
.long Y5E0
.long Y5E0
.long Y5E0
.long Y5E0
.long Y5E0
.long Y5E8
.long Y5E8
.long Y5E8
.long Y5E8
.long Y5E8
.long Y5E8
.long Y5E8
.long Y5E8
.long Y5F0
.long Y5F0
.long Y5F0
.long Y5F0
.long Y5F0
.long Y5F0
.long Y5F0
.long Y5F0
.long Y5F8
.long Y5F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y600
.long Y600
.long Y600
.long Y600
.long Y600
.long Y600
.long Y600
.long Y600
.long Y608
.long Y608
.long Y608
.long Y608
.long Y608
.long Y608
.long Y608
.long Y608
.long Y610
.long Y610
.long Y610
.long Y610
.long Y610
.long Y610
.long Y610
.long Y610
.long Y618
.long Y618
.long Y618
.long Y618
.long Y618
.long Y618
.long Y618
.long Y618
.long Y620
.long Y620
.long Y620
.long Y620
.long Y620
.long Y620
.long Y620
.long Y620
.long Y628
.long Y628
.long Y628
.long Y628
.long Y628
.long Y628
.long Y628
.long Y628
.long Y630
.long Y630
.long Y630
.long Y630
.long Y630
.long Y630
.long Y630
.long Y630
.long Y638
.long Y638
.long Y638
.long Y638
.long Y638
.long Y638
.long Y638
.long Y638
.long Y640
.long Y640
.long Y640
.long Y640
.long Y640
.long Y640
.long Y640
.long Y640
.long Y648
.long Y648
.long Y648
.long Y648
.long Y648
.long Y648
.long Y648
.long Y648
.long Y650
.long Y650
.long Y650
.long Y650
.long Y650
.long Y650
.long Y650
.long Y650
.long Y658
.long Y658
.long Y658
.long Y658
.long Y658
.long Y658
.long Y658
.long Y658
.long Y660
.long Y660
.long Y660
.long Y660
.long Y660
.long Y660
.long Y660
.long Y660
.long Y668
.long Y668
.long Y668
.long Y668
.long Y668
.long Y668
.long Y668
.long Y668
.long Y670
.long Y670
.long Y670
.long Y670
.long Y670
.long Y670
.long Y670
.long Y670
.long Y678
.long Y678
.long Y678
.long Y678
.long Y678
.long Y678
.long Y678
.long Y678
.long Y680
.long Y680
.long Y680
.long Y680
.long Y680
.long Y680
.long Y680
.long Y680
.long Y688
.long Y688
.long Y688
.long Y688
.long Y688
.long Y688
.long Y688
.long Y688
.long Y690
.long Y690
.long Y690
.long Y690
.long Y690
.long Y690
.long Y690
.long Y690
.long Y698
.long Y698
.long Y698
.long Y698
.long Y698
.long Y698
.long Y698
.long Y698
.long Y6A0
.long Y6A0
.long Y6A0
.long Y6A0
.long Y6A0
.long Y6A0
.long Y6A0
.long Y6A0
.long Y6A8
.long Y6A8
.long Y6A8
.long Y6A8
.long Y6A8
.long Y6A8
.long Y6A8
.long Y6A8
.long Y6B0
.long Y6B0
.long Y6B0
.long Y6B0
.long Y6B0
.long Y6B0
.long Y6B0
.long Y6B0
.long Y6B8
.long Y6B8
.long Y6B8
.long Y6B8
.long Y6B8
.long Y6B8
.long Y6B8
.long Y6B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y6D0
.long Y6D0
.long Y6D0
.long Y6D0
.long Y6D0
.long Y6D0
.long Y6D0
.long Y6D0
.long Y6D8
.long Y6D8
.long Y6D8
.long Y6D8
.long Y6D8
.long Y6D8
.long Y6D8
.long Y6D8
.long Y6E0
.long Y6E0
.long Y6E0
.long Y6E0
.long Y6E0
.long Y6E0
.long Y6E0
.long Y6E0
.long Y6E8
.long Y6E8
.long Y6E8
.long Y6E8
.long Y6E8
.long Y6E8
.long Y6E8
.long Y6E8
.long Y6F0
.long Y6F0
.long Y6F0
.long Y6F0
.long Y6F0
.long Y6F0
.long Y6F0
.long Y6F0
.long Y6F8
.long Y6F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y700
.long Y700
.long Y700
.long Y700
.long Y700
.long Y700
.long Y700
.long Y700
.long Y708
.long Y708
.long Y708
.long Y708
.long Y708
.long Y708
.long Y708
.long Y708
.long Y710
.long Y710
.long Y710
.long Y710
.long Y710
.long Y710
.long Y710
.long Y710
.long Y718
.long Y718
.long Y718
.long Y718
.long Y718
.long Y718
.long Y718
.long Y718
.long Y720
.long Y720
.long Y720
.long Y720
.long Y720
.long Y720
.long Y720
.long Y720
.long Y728
.long Y728
.long Y728
.long Y728
.long Y728
.long Y728
.long Y728
.long Y728
.long Y730
.long Y730
.long Y730
.long Y730
.long Y730
.long Y730
.long Y730
.long Y730
.long Y738
.long Y738
.long Y738
.long Y738
.long Y738
.long Y738
.long Y738
.long Y738
.long Y740
.long Y740
.long Y740
.long Y740
.long Y740
.long Y740
.long Y740
.long Y740
.long Y748
.long Y748
.long Y748
.long Y748
.long Y748
.long Y748
.long Y748
.long Y748
.long Y750
.long Y750
.long Y750
.long Y750
.long Y750
.long Y750
.long Y750
.long Y750
.long Y758
.long Y758
.long Y758
.long Y758
.long Y758
.long Y758
.long Y758
.long Y758
.long Y760
.long Y760
.long Y760
.long Y760
.long Y760
.long Y760
.long Y760
.long Y760
.long Y768
.long Y768
.long Y768
.long Y768
.long Y768
.long Y768
.long Y768
.long Y768
.long Y770
.long Y770
.long Y770
.long Y770
.long Y770
.long Y770
.long Y770
.long Y770
.long Y778
.long Y778
.long Y778
.long Y778
.long Y778
.long Y778
.long Y778
.long Y778
.long Y780
.long Y780
.long Y780
.long Y780
.long Y780
.long Y780
.long Y780
.long Y780
.long Y788
.long Y788
.long Y788
.long Y788
.long Y788
.long Y788
.long Y788
.long Y788
.long Y790
.long Y790
.long Y790
.long Y790
.long Y790
.long Y790
.long Y790
.long Y790
.long Y798
.long Y798
.long Y798
.long Y798
.long Y798
.long Y798
.long Y798
.long Y798
.long Y7A0
.long Y7A0
.long Y7A0
.long Y7A0
.long Y7A0
.long Y7A0
.long Y7A0
.long Y7A0
.long Y7A8
.long Y7A8
.long Y7A8
.long Y7A8
.long Y7A8
.long Y7A8
.long Y7A8
.long Y7A8
.long Y7B0
.long Y7B0
.long Y7B0
.long Y7B0
.long Y7B0
.long Y7B0
.long Y7B0
.long Y7B0
.long Y7B8
.long Y7B8
.long Y7B8
.long Y7B8
.long Y7B8
.long Y7B8
.long Y7B8
.long Y7B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y7D0
.long Y7D0
.long Y7D0
.long Y7D0
.long Y7D0
.long Y7D0
.long Y7D0
.long Y7D0
.long Y7D8
.long Y7D8
.long Y7D8
.long Y7D8
.long Y7D8
.long Y7D8
.long Y7D8
.long Y7D8
.long Y7E0
.long Y7E0
.long Y7E0
.long Y7E0
.long Y7E0
.long Y7E0
.long Y7E0
.long Y7E0
.long Y7E8
.long Y7E8
.long Y7E8
.long Y7E8
.long Y7E8
.long Y7E8
.long Y7E8
.long Y7E8
.long Y7F0
.long Y7F0
.long Y7F0
.long Y7F0
.long Y7F0
.long Y7F0
.long Y7F0
.long Y7F0
.long Y7F8
.long Y7F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y800
.long Y800
.long Y800
.long Y800
.long Y800
.long Y800
.long Y800
.long Y800
.long Y808
.long Y808
.long Y808
.long Y808
.long Y808
.long Y808
.long Y808
.long Y808
.long Y810
.long Y810
.long Y810
.long Y810
.long Y810
.long Y810
.long Y810
.long Y810
.long Y818
.long Y818
.long Y818
.long Y818
.long Y818
.long Y818
.long Y818
.long Y818
.long Y820
.long Y820
.long Y820
.long Y820
.long Y820
.long Y820
.long Y820
.long Y820
.long Y828
.long Y828
.long Y828
.long Y828
.long Y828
.long Y828
.long Y828
.long Y828
.long Y830
.long Y830
.long Y830
.long Y830
.long Y830
.long Y830
.long Y830
.long Y830
.long Y838
.long Y838
.long Y838
.long Y838
.long Y838
.long Y838
.long Y838
.long Y838
.long Y840
.long Y840
.long Y840
.long Y840
.long Y840
.long Y840
.long Y840
.long Y840
.long Y848
.long Y848
.long Y848
.long Y848
.long Y848
.long Y848
.long Y848
.long Y848
.long Y850
.long Y850
.long Y850
.long Y850
.long Y850
.long Y850
.long Y850
.long Y850
.long Y858
.long Y858
.long Y858
.long Y858
.long Y858
.long Y858
.long Y858
.long Y858
.long Y860
.long Y860
.long Y860
.long Y860
.long Y860
.long Y860
.long Y860
.long Y860
.long Y868
.long Y868
.long Y868
.long Y868
.long Y868
.long Y868
.long Y868
.long Y868
.long Y870
.long Y870
.long Y870
.long Y870
.long Y870
.long Y870
.long Y870
.long Y870
.long Y878
.long Y878
.long Y878
.long Y878
.long Y878
.long Y878
.long Y878
.long Y878
.long Y880
.long Y880
.long Y880
.long Y880
.long Y880
.long Y880
.long Y880
.long Y880
.long Y888
.long Y888
.long Y888
.long Y888
.long Y888
.long Y888
.long Y888
.long Y888
.long Y890
.long Y890
.long Y890
.long Y890
.long Y890
.long Y890
.long Y890
.long Y890
.long Y898
.long Y898
.long Y898
.long Y898
.long Y898
.long Y898
.long Y898
.long Y898
.long Y8A0
.long Y8A0
.long Y8A0
.long Y8A0
.long Y8A0
.long Y8A0
.long Y8A0
.long Y8A0
.long Y8A8
.long Y8A8
.long Y8A8
.long Y8A8
.long Y8A8
.long Y8A8
.long Y8A8
.long Y8A8
.long Y8B0
.long Y8B0
.long Y8B0
.long Y8B0
.long Y8B0
.long Y8B0
.long Y8B0
.long Y8B0
.long Y8B8
.long Y8B8
.long Y8B8
.long Y8B8
.long Y8B8
.long Y8B8
.long Y8B8
.long Y8B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Y900
.long Y900
.long Y900
.long Y900
.long Y900
.long Y900
.long Y900
.long Y900
.long Y908
.long Y908
.long Y908
.long Y908
.long Y908
.long Y908
.long Y908
.long Y908
.long Y910
.long Y910
.long Y910
.long Y910
.long Y910
.long Y910
.long Y910
.long Y910
.long Y918
.long Y918
.long Y918
.long Y918
.long Y918
.long Y918
.long Y918
.long Y918
.long Y920
.long Y920
.long Y920
.long Y920
.long Y920
.long Y920
.long Y920
.long Y920
.long Y928
.long Y928
.long Y928
.long Y928
.long Y928
.long Y928
.long Y928
.long Y928
.long Y930
.long Y930
.long Y930
.long Y930
.long Y930
.long Y930
.long Y930
.long Y930
.long Y938
.long Y938
.long Y938
.long Y938
.long Y938
.long Y938
.long Y938
.long Y938
.long Y940
.long Y940
.long Y940
.long Y940
.long Y940
.long Y940
.long Y940
.long Y940
.long Y948
.long Y948
.long Y948
.long Y948
.long Y948
.long Y948
.long Y948
.long Y948
.long Y950
.long Y950
.long Y950
.long Y950
.long Y950
.long Y950
.long Y950
.long Y950
.long Y958
.long Y958
.long Y958
.long Y958
.long Y958
.long Y958
.long Y958
.long Y958
.long Y960
.long Y960
.long Y960
.long Y960
.long Y960
.long Y960
.long Y960
.long Y960
.long Y968
.long Y968
.long Y968
.long Y968
.long Y968
.long Y968
.long Y968
.long Y968
.long Y970
.long Y970
.long Y970
.long Y970
.long Y970
.long Y970
.long Y970
.long Y970
.long Y978
.long Y978
.long Y978
.long Y978
.long Y978
.long Y978
.long Y978
.long Y978
.long Y980
.long Y980
.long Y980
.long Y980
.long Y980
.long Y980
.long Y980
.long Y980
.long Y988
.long Y988
.long Y988
.long Y988
.long Y988
.long Y988
.long Y988
.long Y988
.long Y990
.long Y990
.long Y990
.long Y990
.long Y990
.long Y990
.long Y990
.long Y990
.long Y998
.long Y998
.long Y998
.long Y998
.long Y998
.long Y998
.long Y998
.long Y998
.long Y9A0
.long Y9A0
.long Y9A0
.long Y9A0
.long Y9A0
.long Y9A0
.long Y9A0
.long Y9A0
.long Y9A8
.long Y9A8
.long Y9A8
.long Y9A8
.long Y9A8
.long Y9A8
.long Y9A8
.long Y9A8
.long Y9B0
.long Y9B0
.long Y9B0
.long Y9B0
.long Y9B0
.long Y9B0
.long Y9B0
.long Y9B0
.long Y9B8
.long Y9B8
.long Y9B8
.long Y9B8
.long Y9B8
.long Y9B8
.long Y9B8
.long Y9B8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long YA00
.long YA00
.long YA00
.long YA00
.long YA00
.long YA00
.long YA00
.long YA00
.long YA08
.long YA08
.long YA08
.long YA08
.long YA08
.long YA08
.long YA08
.long YA08
.long YA10
.long YA10
.long YA10
.long YA10
.long YA10
.long YA10
.long YA10
.long YA10
.long YA18
.long YA18
.long YA18
.long YA18
.long YA18
.long YA18
.long YA18
.long YA18
.long YA20
.long YA20
.long YA20
.long YA20
.long YA20
.long YA20
.long YA20
.long YA20
.long YA28
.long YA28
.long YA28
.long YA28
.long YA28
.long YA28
.long YA28
.long YA28
.long YA30
.long YA30
.long YA30
.long YA30
.long YA30
.long YA30
.long YA30
.long YA30
.long YA38
.long YA38
.long YA38
.long YA38
.long YA38
.long YA38
.long YA38
.long YA38
.long YA40
.long YA40
.long YA40
.long YA40
.long YA40
.long YA40
.long YA40
.long YA40
.long YA48
.long YA48
.long YA48
.long YA48
.long YA48
.long YA48
.long YA48
.long YA48
.long YA50
.long YA50
.long YA50
.long YA50
.long YA50
.long YA50
.long YA50
.long YA50
.long YA58
.long YA58
.long YA58
.long YA58
.long YA58
.long YA58
.long YA58
.long YA58
.long YA60
.long YA60
.long YA60
.long YA60
.long YA60
.long YA60
.long YA60
.long YA60
.long YA68
.long YA68
.long YA68
.long YA68
.long YA68
.long YA68
.long YA68
.long YA68
.long YA70
.long YA70
.long YA70
.long YA70
.long YA70
.long YA70
.long YA70
.long YA70
.long YA78
.long YA78
.long YA78
.long YA78
.long YA78
.long YA78
.long YA78
.long YA78
.long YA80
.long YA80
.long YA80
.long YA80
.long YA80
.long YA80
.long YA80
.long YA80
.long YA88
.long YA88
.long YA88
.long YA88
.long YA88
.long YA88
.long YA88
.long YA88
.long YA90
.long YA90
.long YA90
.long YA90
.long YA90
.long YA90
.long YA90
.long YA90
.long YA98
.long YA98
.long YA98
.long YA98
.long YA98
.long YA98
.long YA98
.long YA98
.long YAA0
.long YAA0
.long YAA0
.long YAA0
.long YAA0
.long YAA0
.long YAA0
.long YAA0
.long YAA8
.long YAA8
.long YAA8
.long YAA8
.long YAA8
.long YAA8
.long YAA8
.long YAA8
.long YAB0
.long YAB0
.long YAB0
.long YAB0
.long YAB0
.long YAB0
.long YAB0
.long YAB0
.long YAB8
.long YAB8
.long YAB8
.long YAB8
.long YAB8
.long YAB8
.long YAB8
.long YAB8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long YB00
.long YB00
.long YB00
.long YB00
.long YB00
.long YB00
.long YB00
.long YB00
.long YB08
.long YB08
.long YB08
.long YB08
.long YB08
.long YB08
.long YB08
.long YB08
.long YB10
.long YB10
.long YB10
.long YB10
.long YB10
.long YB10
.long YB10
.long YB10
.long YB18
.long YB18
.long YB18
.long YB18
.long YB18
.long YB18
.long YB18
.long YB18
.long YB20
.long YB20
.long YB20
.long YB20
.long YB20
.long YB20
.long YB20
.long YB20
.long YB28
.long YB28
.long YB28
.long YB28
.long YB28
.long YB28
.long YB28
.long YB28
.long YB30
.long YB30
.long YB30
.long YB30
.long YB30
.long YB30
.long YB30
.long YB30
.long YB38
.long YB38
.long YB38
.long YB38
.long YB38
.long YB38
.long YB38
.long YB38
.long YB40
.long YB40
.long YB40
.long YB40
.long YB40
.long YB40
.long YB40
.long YB40
.long YB48
.long YB48
.long YB48
.long YB48
.long YB48
.long YB48
.long YB48
.long YB48
.long YB50
.long YB50
.long YB50
.long YB50
.long YB50
.long YB50
.long YB50
.long YB50
.long YB58
.long YB58
.long YB58
.long YB58
.long YB58
.long YB58
.long YB58
.long YB58
.long YB60
.long YB60
.long YB60
.long YB60
.long YB60
.long YB60
.long YB60
.long YB60
.long YB68
.long YB68
.long YB68
.long YB68
.long YB68
.long YB68
.long YB68
.long YB68
.long YB70
.long YB70
.long YB70
.long YB70
.long YB70
.long YB70
.long YB70
.long YB70
.long YB78
.long YB78
.long YB78
.long YB78
.long YB78
.long YB78
.long YB78
.long YB78
.long YB80
.long YB80
.long YB80
.long YB80
.long YB80
.long YB80
.long YB80
.long YB80
.long YB88
.long YB88
.long YB88
.long YB88
.long YB88
.long YB88
.long YB88
.long YB88
.long YB90
.long YB90
.long YB90
.long YB90
.long YB90
.long YB90
.long YB90
.long YB90
.long YB98
.long YB98
.long YB98
.long YB98
.long YB98
.long YB98
.long YB98
.long YB98
.long YBA0
.long YBA0
.long YBA0
.long YBA0
.long YBA0
.long YBA0
.long YBA0
.long YBA0
.long YBA8
.long YBA8
.long YBA8
.long YBA8
.long YBA8
.long YBA8
.long YBA8
.long YBA8
.long YBB0
.long YBB0
.long YBB0
.long YBB0
.long YBB0
.long YBB0
.long YBB0
.long YBB0
.long YBB8
.long YBB8
.long YBB8
.long YBB8
.long YBB8
.long YBB8
.long YBB8
.long YBB8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long YC00
.long YC00
.long YC00
.long YC00
.long YC00
.long YC00
.long YC00
.long YC00
.long YC08
.long YC08
.long YC08
.long YC08
.long YC08
.long YC08
.long YC08
.long YC08
.long YC10
.long YC10
.long YC10
.long YC10
.long YC10
.long YC10
.long YC10
.long YC10
.long YC18
.long YC18
.long YC18
.long YC18
.long YC18
.long YC18
.long YC18
.long YC18
.long YC20
.long YC20
.long YC20
.long YC20
.long YC20
.long YC20
.long YC20
.long YC20
.long YC28
.long YC28
.long YC28
.long YC28
.long YC28
.long YC28
.long YC28
.long YC28
.long YC30
.long YC30
.long YC30
.long YC30
.long YC30
.long YC30
.long YC30
.long YC30
.long YC38
.long YC38
.long YC38
.long YC38
.long YC38
.long YC38
.long YC38
.long YC38
.long YC40
.long YC40
.long YC40
.long YC40
.long YC40
.long YC40
.long YC40
.long YC40
.long YC48
.long YC48
.long YC48
.long YC48
.long YC48
.long YC48
.long YC48
.long YC48
.long YC50
.long YC50
.long YC50
.long YC50
.long YC50
.long YC50
.long YC50
.long YC50
.long YC58
.long YC58
.long YC58
.long YC58
.long YC58
.long YC58
.long YC58
.long YC58
.long YC60
.long YC60
.long YC60
.long YC60
.long YC60
.long YC60
.long YC60
.long YC60
.long YC68
.long YC68
.long YC68
.long YC68
.long YC68
.long YC68
.long YC68
.long YC68
.long YC70
.long YC70
.long YC70
.long YC70
.long YC70
.long YC70
.long YC70
.long YC70
.long YC78
.long YC78
.long YC78
.long YC78
.long YC78
.long YC78
.long YC78
.long YC78
.long YC80
.long YC80
.long YC80
.long YC80
.long YC80
.long YC80
.long YC80
.long YC80
.long YC88
.long YC88
.long YC88
.long YC88
.long YC88
.long YC88
.long YC88
.long YC88
.long YC90
.long YC90
.long YC90
.long YC90
.long YC90
.long YC90
.long YC90
.long YC90
.long YC98
.long YC98
.long YC98
.long YC98
.long YC98
.long YC98
.long YC98
.long YC98
.long YCA0
.long YCA0
.long YCA0
.long YCA0
.long YCA0
.long YCA0
.long YCA0
.long YCA0
.long YCA8
.long YCA8
.long YCA8
.long YCA8
.long YCA8
.long YCA8
.long YCA8
.long YCA8
.long YCB0
.long YCB0
.long YCB0
.long YCB0
.long YCB0
.long YCB0
.long YCB0
.long YCB0
.long YCB8
.long YCB8
.long YCB8
.long YCB8
.long YCB8
.long YCB8
.long YCB8
.long YCB8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long YD00
.long YD00
.long YD00
.long YD00
.long YD00
.long YD00
.long YD00
.long YD00
.long YD08
.long YD08
.long YD08
.long YD08
.long YD08
.long YD08
.long YD08
.long YD08
.long YD10
.long YD10
.long YD10
.long YD10
.long YD10
.long YD10
.long YD10
.long YD10
.long YD18
.long YD18
.long YD18
.long YD18
.long YD18
.long YD18
.long YD18
.long YD18
.long YD20
.long YD20
.long YD20
.long YD20
.long YD20
.long YD20
.long YD20
.long YD20
.long YD28
.long YD28
.long YD28
.long YD28
.long YD28
.long YD28
.long YD28
.long YD28
.long YD30
.long YD30
.long YD30
.long YD30
.long YD30
.long YD30
.long YD30
.long YD30
.long YD38
.long YD38
.long YD38
.long YD38
.long YD38
.long YD38
.long YD38
.long YD38
.long YD40
.long YD40
.long YD40
.long YD40
.long YD40
.long YD40
.long YD40
.long YD40
.long YD48
.long YD48
.long YD48
.long YD48
.long YD48
.long YD48
.long YD48
.long YD48
.long YD50
.long YD50
.long YD50
.long YD50
.long YD50
.long YD50
.long YD50
.long YD50
.long YD58
.long YD58
.long YD58
.long YD58
.long YD58
.long YD58
.long YD58
.long YD58
.long YD60
.long YD60
.long YD60
.long YD60
.long YD60
.long YD60
.long YD60
.long YD60
.long YD68
.long YD68
.long YD68
.long YD68
.long YD68
.long YD68
.long YD68
.long YD68
.long YD70
.long YD70
.long YD70
.long YD70
.long YD70
.long YD70
.long YD70
.long YD70
.long YD78
.long YD78
.long YD78
.long YD78
.long YD78
.long YD78
.long YD78
.long YD78
.long YD80
.long YD80
.long YD80
.long YD80
.long YD80
.long YD80
.long YD80
.long YD80
.long YD88
.long YD88
.long YD88
.long YD88
.long YD88
.long YD88
.long YD88
.long YD88
.long YD90
.long YD90
.long YD90
.long YD90
.long YD90
.long YD90
.long YD90
.long YD90
.long YD98
.long YD98
.long YD98
.long YD98
.long YD98
.long YD98
.long YD98
.long YD98
.long YDA0
.long YDA0
.long YDA0
.long YDA0
.long YDA0
.long YDA0
.long YDA0
.long YDA0
.long YDA8
.long YDA8
.long YDA8
.long YDA8
.long YDA8
.long YDA8
.long YDA8
.long YDA8
.long YDB0
.long YDB0
.long YDB0
.long YDB0
.long YDB0
.long YDB0
.long YDB0
.long YDB0
.long YDB8
.long YDB8
.long YDB8
.long YDB8
.long YDB8
.long YDB8
.long YDB8
.long YDB8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long YE00
.long YE00
.long YE00
.long YE00
.long YE00
.long YE00
.long YE00
.long YE00
.long YE08
.long YE08
.long YE08
.long YE08
.long YE08
.long YE08
.long YE08
.long YE08
.long YE10
.long YE10
.long YE10
.long YE10
.long YE10
.long YE10
.long YE10
.long YE10
.long YE18
.long YE18
.long YE18
.long YE18
.long YE18
.long YE18
.long YE18
.long YE18
.long YE20
.long YE20
.long YE20
.long YE20
.long YE20
.long YE20
.long YE20
.long YE20
.long YE28
.long YE28
.long YE28
.long YE28
.long YE28
.long YE28
.long YE28
.long YE28
.long YE30
.long YE30
.long YE30
.long YE30
.long YE30
.long YE30
.long YE30
.long YE30
.long YE38
.long YE38
.long YE38
.long YE38
.long YE38
.long YE38
.long YE38
.long YE38
.long YE40
.long YE40
.long YE40
.long YE40
.long YE40
.long YE40
.long YE40
.long YE40
.long YE48
.long YE48
.long YE48
.long YE48
.long YE48
.long YE48
.long YE48
.long YE48
.long YE50
.long YE50
.long YE50
.long YE50
.long YE50
.long YE50
.long YE50
.long YE50
.long YE58
.long YE58
.long YE58
.long YE58
.long YE58
.long YE58
.long YE58
.long YE58
.long YE60
.long YE60
.long YE60
.long YE60
.long YE60
.long YE60
.long YE60
.long YE60
.long YE68
.long YE68
.long YE68
.long YE68
.long YE68
.long YE68
.long YE68
.long YE68
.long YE70
.long YE70
.long YE70
.long YE70
.long YE70
.long YE70
.long YE70
.long YE70
.long YE78
.long YE78
.long YE78
.long YE78
.long YE78
.long YE78
.long YE78
.long YE78
.long YE80
.long YE80
.long YE80
.long YE80
.long YE80
.long YE80
.long YE80
.long YE80
.long YE88
.long YE88
.long YE88
.long YE88
.long YE88
.long YE88
.long YE88
.long YE88
.long YE90
.long YE90
.long YE90
.long YE90
.long YE90
.long YE90
.long YE90
.long YE90
.long YE98
.long YE98
.long YE98
.long YE98
.long YE98
.long YE98
.long YE98
.long YE98
.long YEA0
.long YEA0
.long YEA0
.long YEA0
.long YEA0
.long YEA0
.long YEA0
.long YEA0
.long YEA8
.long YEA8
.long YEA8
.long YEA8
.long YEA8
.long YEA8
.long YEA8
.long YEA8
.long YEB0
.long YEB0
.long YEB0
.long YEB0
.long YEB0
.long YEB0
.long YEB0
.long YEB0
.long YEB8
.long YEB8
.long YEB8
.long YEB8
.long YEB8
.long YEB8
.long YEB8
.long YEB8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long YF00
.long YF00
.long YF00
.long YF00
.long YF00
.long YF00
.long YF00
.long YF00
.long YF08
.long YF08
.long YF08
.long YF08
.long YF08
.long YF08
.long YF08
.long YF08
.long YF10
.long YF10
.long YF10
.long YF10
.long YF10
.long YF10
.long YF10
.long YF10
.long YF18
.long YF18
.long YF18
.long YF18
.long YF18
.long YF18
.long YF18
.long YF18
.long YF20
.long YF20
.long YF20
.long YF20
.long YF20
.long YF20
.long YF20
.long YF20
.long YF28
.long YF28
.long YF28
.long YF28
.long YF28
.long YF28
.long YF28
.long YF28
.long YF30
.long YF30
.long YF30
.long YF30
.long YF30
.long YF30
.long YF30
.long YF30
.long YF38
.long YF38
.long YF38
.long YF38
.long YF38
.long YF38
.long YF38
.long YF38
.long YF40
.long YF40
.long YF40
.long YF40
.long YF40
.long YF40
.long YF40
.long YF40
.long YF48
.long YF48
.long YF48
.long YF48
.long YF48
.long YF48
.long YF48
.long YF48
.long YF50
.long YF50
.long YF50
.long YF50
.long YF50
.long YF50
.long YF50
.long YF50
.long YF58
.long YF58
.long YF58
.long YF58
.long YF58
.long YF58
.long YF58
.long YF58
.long YF60
.long YF60
.long YF60
.long YF60
.long YF60
.long YF60
.long YF60
.long YF60
.long YF68
.long YF68
.long YF68
.long YF68
.long YF68
.long YF68
.long YF68
.long YF68
.long YF70
.long YF70
.long YF70
.long YF70
.long YF70
.long YF70
.long YF70
.long YF70
.long YF78
.long YF78
.long YF78
.long YF78
.long YF78
.long YF78
.long YF78
.long YF78
.long YF80
.long YF80
.long YF80
.long YF80
.long YF80
.long YF80
.long YF80
.long YF80
.long YF88
.long YF88
.long YF88
.long YF88
.long YF88
.long YF88
.long YF88
.long YF88
.long YF90
.long YF90
.long YF90
.long YF90
.long YF90
.long YF90
.long YF90
.long YF90
.long YF98
.long YF98
.long YF98
.long YF98
.long YF98
.long YF98
.long YF98
.long YF98
.long YFA0
.long YFA0
.long YFA0
.long YFA0
.long YFA0
.long YFA0
.long YFA0
.long YFA0
.long YFA8
.long YFA8
.long YFA8
.long YFA8
.long YFA8
.long YFA8
.long YFA8
.long YFA8
.long YFB0
.long YFB0
.long YFB0
.long YFB0
.long YFB0
.long YFB0
.long YFB0
.long YFB0
.long YFB8
.long YFB8
.long YFB8
.long YFB8
.long YFB8
.long YFB8
.long YFB8
.long YFB8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
.long Z000
jmptbl:
.long K000
.long K000
.long K000
.long K000
.long K000
.long K000
.long K000
.long K000
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K010
.long K010
.long K010
.long K010
.long K010
.long K010
.long K010
.long K010
.long K018
.long K018
.long K018
.long K018
.long K018
.long K018
.long K018
.long K018
.long K020
.long K020
.long K020
.long K020
.long K020
.long K020
.long K020
.long K020
.long K028
.long K028
.long K028
.long K028
.long K028
.long K028
.long K028
.long K028
.long K030
.long K030
.long K030
.long K030
.long K030
.long K030
.long K030
.long K030
.long K038
.long K039
.long r_illegal
.long r_illegal
.long K03C
.long r_illegal
.long r_illegal
.long r_illegal
.long K040
.long K040
.long K040
.long K040
.long K040
.long K040
.long K040
.long K040
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K050
.long K050
.long K050
.long K050
.long K050
.long K050
.long K050
.long K050
.long K058
.long K058
.long K058
.long K058
.long K058
.long K058
.long K058
.long K058
.long K060
.long K060
.long K060
.long K060
.long K060
.long K060
.long K060
.long K060
.long K068
.long K068
.long K068
.long K068
.long K068
.long K068
.long K068
.long K068
.long K070
.long K070
.long K070
.long K070
.long K070
.long K070
.long K070
.long K070
.long K078
.long K079
.long r_illegal
.long r_illegal
.long K07C
.long r_illegal
.long r_illegal
.long r_illegal
.long K080
.long K080
.long K080
.long K080
.long K080
.long K080
.long K080
.long K080
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K090
.long K090
.long K090
.long K090
.long K090
.long K090
.long K090
.long K090
.long K098
.long K098
.long K098
.long K098
.long K098
.long K098
.long K098
.long K098
.long K0A0
.long K0A0
.long K0A0
.long K0A0
.long K0A0
.long K0A0
.long K0A0
.long K0A0
.long K0A8
.long K0A8
.long K0A8
.long K0A8
.long K0A8
.long K0A8
.long K0A8
.long K0A8
.long K0B0
.long K0B0
.long K0B0
.long K0B0
.long K0B0
.long K0B0
.long K0B0
.long K0B0
.long K0B8
.long K0B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K100
.long K100
.long K100
.long K100
.long K100
.long K100
.long K100
.long K100
.long K108
.long K108
.long K108
.long K108
.long K108
.long K108
.long K108
.long K108
.long K110
.long K110
.long K110
.long K110
.long K110
.long K110
.long K110
.long K110
.long K118
.long K118
.long K118
.long K118
.long K118
.long K118
.long K118
.long K118
.long K120
.long K120
.long K120
.long K120
.long K120
.long K120
.long K120
.long K120
.long K128
.long K128
.long K128
.long K128
.long K128
.long K128
.long K128
.long K128
.long K130
.long K130
.long K130
.long K130
.long K130
.long K130
.long K130
.long K130
.long K138
.long K139
.long K13A
.long K13B
.long K13C
.long r_illegal
.long r_illegal
.long r_illegal
.long K140
.long K140
.long K140
.long K140
.long K140
.long K140
.long K140
.long K140
.long K148
.long K148
.long K148
.long K148
.long K148
.long K148
.long K148
.long K148
.long K150
.long K150
.long K150
.long K150
.long K150
.long K150
.long K150
.long K150
.long K158
.long K158
.long K158
.long K158
.long K158
.long K158
.long K158
.long K158
.long K160
.long K160
.long K160
.long K160
.long K160
.long K160
.long K160
.long K160
.long K168
.long K168
.long K168
.long K168
.long K168
.long K168
.long K168
.long K168
.long K170
.long K170
.long K170
.long K170
.long K170
.long K170
.long K170
.long K170
.long K178
.long K179
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K180
.long K180
.long K180
.long K180
.long K180
.long K180
.long K180
.long K180
.long K188
.long K188
.long K188
.long K188
.long K188
.long K188
.long K188
.long K188
.long K190
.long K190
.long K190
.long K190
.long K190
.long K190
.long K190
.long K190
.long K198
.long K198
.long K198
.long K198
.long K198
.long K198
.long K198
.long K198
.long K1A0
.long K1A0
.long K1A0
.long K1A0
.long K1A0
.long K1A0
.long K1A0
.long K1A0
.long K1A8
.long K1A8
.long K1A8
.long K1A8
.long K1A8
.long K1A8
.long K1A8
.long K1A8
.long K1B0
.long K1B0
.long K1B0
.long K1B0
.long K1B0
.long K1B0
.long K1B0
.long K1B0
.long K1B8
.long K1B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K1C0
.long K1C0
.long K1C0
.long K1C0
.long K1C0
.long K1C0
.long K1C0
.long K1C0
.long K1C8
.long K1C8
.long K1C8
.long K1C8
.long K1C8
.long K1C8
.long K1C8
.long K1C8
.long K1D0
.long K1D0
.long K1D0
.long K1D0
.long K1D0
.long K1D0
.long K1D0
.long K1D0
.long K1D8
.long K1D8
.long K1D8
.long K1D8
.long K1D8
.long K1D8
.long K1D8
.long K1D8
.long K1E0
.long K1E0
.long K1E0
.long K1E0
.long K1E0
.long K1E0
.long K1E0
.long K1E0
.long K1E8
.long K1E8
.long K1E8
.long K1E8
.long K1E8
.long K1E8
.long K1E8
.long K1E8
.long K1F0
.long K1F0
.long K1F0
.long K1F0
.long K1F0
.long K1F0
.long K1F0
.long K1F0
.long K1F8
.long K1F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K200
.long K200
.long K200
.long K200
.long K200
.long K200
.long K200
.long K200
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K210
.long K210
.long K210
.long K210
.long K210
.long K210
.long K210
.long K210
.long K218
.long K218
.long K218
.long K218
.long K218
.long K218
.long K218
.long K218
.long K220
.long K220
.long K220
.long K220
.long K220
.long K220
.long K220
.long K220
.long K228
.long K228
.long K228
.long K228
.long K228
.long K228
.long K228
.long K228
.long K230
.long K230
.long K230
.long K230
.long K230
.long K230
.long K230
.long K230
.long K238
.long K239
.long r_illegal
.long r_illegal
.long K23C
.long r_illegal
.long r_illegal
.long r_illegal
.long K240
.long K240
.long K240
.long K240
.long K240
.long K240
.long K240
.long K240
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K250
.long K250
.long K250
.long K250
.long K250
.long K250
.long K250
.long K250
.long K258
.long K258
.long K258
.long K258
.long K258
.long K258
.long K258
.long K258
.long K260
.long K260
.long K260
.long K260
.long K260
.long K260
.long K260
.long K260
.long K268
.long K268
.long K268
.long K268
.long K268
.long K268
.long K268
.long K268
.long K270
.long K270
.long K270
.long K270
.long K270
.long K270
.long K270
.long K270
.long K278
.long K279
.long r_illegal
.long r_illegal
.long K27C
.long r_illegal
.long r_illegal
.long r_illegal
.long K280
.long K280
.long K280
.long K280
.long K280
.long K280
.long K280
.long K280
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K290
.long K290
.long K290
.long K290
.long K290
.long K290
.long K290
.long K290
.long K298
.long K298
.long K298
.long K298
.long K298
.long K298
.long K298
.long K298
.long K2A0
.long K2A0
.long K2A0
.long K2A0
.long K2A0
.long K2A0
.long K2A0
.long K2A0
.long K2A8
.long K2A8
.long K2A8
.long K2A8
.long K2A8
.long K2A8
.long K2A8
.long K2A8
.long K2B0
.long K2B0
.long K2B0
.long K2B0
.long K2B0
.long K2B0
.long K2B0
.long K2B0
.long K2B8
.long K2B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K300
.long K300
.long K300
.long K300
.long K300
.long K300
.long K300
.long K300
.long K308
.long K308
.long K308
.long K308
.long K308
.long K308
.long K308
.long K308
.long K310
.long K310
.long K310
.long K310
.long K310
.long K310
.long K310
.long K310
.long K318
.long K318
.long K318
.long K318
.long K318
.long K318
.long K318
.long K318
.long K320
.long K320
.long K320
.long K320
.long K320
.long K320
.long K320
.long K320
.long K328
.long K328
.long K328
.long K328
.long K328
.long K328
.long K328
.long K328
.long K330
.long K330
.long K330
.long K330
.long K330
.long K330
.long K330
.long K330
.long K338
.long K339
.long K33A
.long K33B
.long K33C
.long r_illegal
.long r_illegal
.long r_illegal
.long K340
.long K340
.long K340
.long K340
.long K340
.long K340
.long K340
.long K340
.long K348
.long K348
.long K348
.long K348
.long K348
.long K348
.long K348
.long K348
.long K350
.long K350
.long K350
.long K350
.long K350
.long K350
.long K350
.long K350
.long K358
.long K358
.long K358
.long K358
.long K358
.long K358
.long K358
.long K358
.long K360
.long K360
.long K360
.long K360
.long K360
.long K360
.long K360
.long K360
.long K368
.long K368
.long K368
.long K368
.long K368
.long K368
.long K368
.long K368
.long K370
.long K370
.long K370
.long K370
.long K370
.long K370
.long K370
.long K370
.long K378
.long K379
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K380
.long K380
.long K380
.long K380
.long K380
.long K380
.long K380
.long K380
.long K388
.long K388
.long K388
.long K388
.long K388
.long K388
.long K388
.long K388
.long K390
.long K390
.long K390
.long K390
.long K390
.long K390
.long K390
.long K390
.long K398
.long K398
.long K398
.long K398
.long K398
.long K398
.long K398
.long K398
.long K3A0
.long K3A0
.long K3A0
.long K3A0
.long K3A0
.long K3A0
.long K3A0
.long K3A0
.long K3A8
.long K3A8
.long K3A8
.long K3A8
.long K3A8
.long K3A8
.long K3A8
.long K3A8
.long K3B0
.long K3B0
.long K3B0
.long K3B0
.long K3B0
.long K3B0
.long K3B0
.long K3B0
.long K3B8
.long K3B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K3C0
.long K3C0
.long K3C0
.long K3C0
.long K3C0
.long K3C0
.long K3C0
.long K3C0
.long K3C8
.long K3C8
.long K3C8
.long K3C8
.long K3C8
.long K3C8
.long K3C8
.long K3C8
.long K3D0
.long K3D0
.long K3D0
.long K3D0
.long K3D0
.long K3D0
.long K3D0
.long K3D0
.long K3D8
.long K3D8
.long K3D8
.long K3D8
.long K3D8
.long K3D8
.long K3D8
.long K3D8
.long K3E0
.long K3E0
.long K3E0
.long K3E0
.long K3E0
.long K3E0
.long K3E0
.long K3E0
.long K3E8
.long K3E8
.long K3E8
.long K3E8
.long K3E8
.long K3E8
.long K3E8
.long K3E8
.long K3F0
.long K3F0
.long K3F0
.long K3F0
.long K3F0
.long K3F0
.long K3F0
.long K3F0
.long K3F8
.long K3F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K400
.long K400
.long K400
.long K400
.long K400
.long K400
.long K400
.long K400
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K410
.long K410
.long K410
.long K410
.long K410
.long K410
.long K410
.long K410
.long K418
.long K418
.long K418
.long K418
.long K418
.long K418
.long K418
.long K418
.long K420
.long K420
.long K420
.long K420
.long K420
.long K420
.long K420
.long K420
.long K428
.long K428
.long K428
.long K428
.long K428
.long K428
.long K428
.long K428
.long K430
.long K430
.long K430
.long K430
.long K430
.long K430
.long K430
.long K430
.long K438
.long K439
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K440
.long K440
.long K440
.long K440
.long K440
.long K440
.long K440
.long K440
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K450
.long K450
.long K450
.long K450
.long K450
.long K450
.long K450
.long K450
.long K458
.long K458
.long K458
.long K458
.long K458
.long K458
.long K458
.long K458
.long K460
.long K460
.long K460
.long K460
.long K460
.long K460
.long K460
.long K460
.long K468
.long K468
.long K468
.long K468
.long K468
.long K468
.long K468
.long K468
.long K470
.long K470
.long K470
.long K470
.long K470
.long K470
.long K470
.long K470
.long K478
.long K479
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K480
.long K480
.long K480
.long K480
.long K480
.long K480
.long K480
.long K480
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K490
.long K490
.long K490
.long K490
.long K490
.long K490
.long K490
.long K490
.long K498
.long K498
.long K498
.long K498
.long K498
.long K498
.long K498
.long K498
.long K4A0
.long K4A0
.long K4A0
.long K4A0
.long K4A0
.long K4A0
.long K4A0
.long K4A0
.long K4A8
.long K4A8
.long K4A8
.long K4A8
.long K4A8
.long K4A8
.long K4A8
.long K4A8
.long K4B0
.long K4B0
.long K4B0
.long K4B0
.long K4B0
.long K4B0
.long K4B0
.long K4B0
.long K4B8
.long K4B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K500
.long K500
.long K500
.long K500
.long K500
.long K500
.long K500
.long K500
.long K508
.long K508
.long K508
.long K508
.long K508
.long K508
.long K508
.long K508
.long K510
.long K510
.long K510
.long K510
.long K510
.long K510
.long K510
.long K510
.long K518
.long K518
.long K518
.long K518
.long K518
.long K518
.long K518
.long K518
.long K520
.long K520
.long K520
.long K520
.long K520
.long K520
.long K520
.long K520
.long K528
.long K528
.long K528
.long K528
.long K528
.long K528
.long K528
.long K528
.long K530
.long K530
.long K530
.long K530
.long K530
.long K530
.long K530
.long K530
.long K538
.long K539
.long K53A
.long K53B
.long K53C
.long r_illegal
.long r_illegal
.long r_illegal
.long K540
.long K540
.long K540
.long K540
.long K540
.long K540
.long K540
.long K540
.long K548
.long K548
.long K548
.long K548
.long K548
.long K548
.long K548
.long K548
.long K550
.long K550
.long K550
.long K550
.long K550
.long K550
.long K550
.long K550
.long K558
.long K558
.long K558
.long K558
.long K558
.long K558
.long K558
.long K558
.long K560
.long K560
.long K560
.long K560
.long K560
.long K560
.long K560
.long K560
.long K568
.long K568
.long K568
.long K568
.long K568
.long K568
.long K568
.long K568
.long K570
.long K570
.long K570
.long K570
.long K570
.long K570
.long K570
.long K570
.long K578
.long K579
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K580
.long K580
.long K580
.long K580
.long K580
.long K580
.long K580
.long K580
.long K588
.long K588
.long K588
.long K588
.long K588
.long K588
.long K588
.long K588
.long K590
.long K590
.long K590
.long K590
.long K590
.long K590
.long K590
.long K590
.long K598
.long K598
.long K598
.long K598
.long K598
.long K598
.long K598
.long K598
.long K5A0
.long K5A0
.long K5A0
.long K5A0
.long K5A0
.long K5A0
.long K5A0
.long K5A0
.long K5A8
.long K5A8
.long K5A8
.long K5A8
.long K5A8
.long K5A8
.long K5A8
.long K5A8
.long K5B0
.long K5B0
.long K5B0
.long K5B0
.long K5B0
.long K5B0
.long K5B0
.long K5B0
.long K5B8
.long K5B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K5C0
.long K5C0
.long K5C0
.long K5C0
.long K5C0
.long K5C0
.long K5C0
.long K5C0
.long K5C8
.long K5C8
.long K5C8
.long K5C8
.long K5C8
.long K5C8
.long K5C8
.long K5C8
.long K5D0
.long K5D0
.long K5D0
.long K5D0
.long K5D0
.long K5D0
.long K5D0
.long K5D0
.long K5D8
.long K5D8
.long K5D8
.long K5D8
.long K5D8
.long K5D8
.long K5D8
.long K5D8
.long K5E0
.long K5E0
.long K5E0
.long K5E0
.long K5E0
.long K5E0
.long K5E0
.long K5E0
.long K5E8
.long K5E8
.long K5E8
.long K5E8
.long K5E8
.long K5E8
.long K5E8
.long K5E8
.long K5F0
.long K5F0
.long K5F0
.long K5F0
.long K5F0
.long K5F0
.long K5F0
.long K5F0
.long K5F8
.long K5F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K600
.long K600
.long K600
.long K600
.long K600
.long K600
.long K600
.long K600
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K610
.long K610
.long K610
.long K610
.long K610
.long K610
.long K610
.long K610
.long K618
.long K618
.long K618
.long K618
.long K618
.long K618
.long K618
.long K618
.long K620
.long K620
.long K620
.long K620
.long K620
.long K620
.long K620
.long K620
.long K628
.long K628
.long K628
.long K628
.long K628
.long K628
.long K628
.long K628
.long K630
.long K630
.long K630
.long K630
.long K630
.long K630
.long K630
.long K630
.long K638
.long K639
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K640
.long K640
.long K640
.long K640
.long K640
.long K640
.long K640
.long K640
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K650
.long K650
.long K650
.long K650
.long K650
.long K650
.long K650
.long K650
.long K658
.long K658
.long K658
.long K658
.long K658
.long K658
.long K658
.long K658
.long K660
.long K660
.long K660
.long K660
.long K660
.long K660
.long K660
.long K660
.long K668
.long K668
.long K668
.long K668
.long K668
.long K668
.long K668
.long K668
.long K670
.long K670
.long K670
.long K670
.long K670
.long K670
.long K670
.long K670
.long K678
.long K679
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K680
.long K680
.long K680
.long K680
.long K680
.long K680
.long K680
.long K680
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K690
.long K690
.long K690
.long K690
.long K690
.long K690
.long K690
.long K690
.long K698
.long K698
.long K698
.long K698
.long K698
.long K698
.long K698
.long K698
.long K6A0
.long K6A0
.long K6A0
.long K6A0
.long K6A0
.long K6A0
.long K6A0
.long K6A0
.long K6A8
.long K6A8
.long K6A8
.long K6A8
.long K6A8
.long K6A8
.long K6A8
.long K6A8
.long K6B0
.long K6B0
.long K6B0
.long K6B0
.long K6B0
.long K6B0
.long K6B0
.long K6B0
.long K6B8
.long K6B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K700
.long K700
.long K700
.long K700
.long K700
.long K700
.long K700
.long K700
.long K708
.long K708
.long K708
.long K708
.long K708
.long K708
.long K708
.long K708
.long K710
.long K710
.long K710
.long K710
.long K710
.long K710
.long K710
.long K710
.long K718
.long K718
.long K718
.long K718
.long K718
.long K718
.long K718
.long K718
.long K720
.long K720
.long K720
.long K720
.long K720
.long K720
.long K720
.long K720
.long K728
.long K728
.long K728
.long K728
.long K728
.long K728
.long K728
.long K728
.long K730
.long K730
.long K730
.long K730
.long K730
.long K730
.long K730
.long K730
.long K738
.long K739
.long K73A
.long K73B
.long K73C
.long r_illegal
.long r_illegal
.long r_illegal
.long K740
.long K740
.long K740
.long K740
.long K740
.long K740
.long K740
.long K740
.long K748
.long K748
.long K748
.long K748
.long K748
.long K748
.long K748
.long K748
.long K750
.long K750
.long K750
.long K750
.long K750
.long K750
.long K750
.long K750
.long K758
.long K758
.long K758
.long K758
.long K758
.long K758
.long K758
.long K758
.long K760
.long K760
.long K760
.long K760
.long K760
.long K760
.long K760
.long K760
.long K768
.long K768
.long K768
.long K768
.long K768
.long K768
.long K768
.long K768
.long K770
.long K770
.long K770
.long K770
.long K770
.long K770
.long K770
.long K770
.long K778
.long K779
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K780
.long K780
.long K780
.long K780
.long K780
.long K780
.long K780
.long K780
.long K788
.long K788
.long K788
.long K788
.long K788
.long K788
.long K788
.long K788
.long K790
.long K790
.long K790
.long K790
.long K790
.long K790
.long K790
.long K790
.long K798
.long K798
.long K798
.long K798
.long K798
.long K798
.long K798
.long K798
.long K7A0
.long K7A0
.long K7A0
.long K7A0
.long K7A0
.long K7A0
.long K7A0
.long K7A0
.long K7A8
.long K7A8
.long K7A8
.long K7A8
.long K7A8
.long K7A8
.long K7A8
.long K7A8
.long K7B0
.long K7B0
.long K7B0
.long K7B0
.long K7B0
.long K7B0
.long K7B0
.long K7B0
.long K7B8
.long K7B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K7C0
.long K7C0
.long K7C0
.long K7C0
.long K7C0
.long K7C0
.long K7C0
.long K7C0
.long K7C8
.long K7C8
.long K7C8
.long K7C8
.long K7C8
.long K7C8
.long K7C8
.long K7C8
.long K7D0
.long K7D0
.long K7D0
.long K7D0
.long K7D0
.long K7D0
.long K7D0
.long K7D0
.long K7D8
.long K7D8
.long K7D8
.long K7D8
.long K7D8
.long K7D8
.long K7D8
.long K7D8
.long K7E0
.long K7E0
.long K7E0
.long K7E0
.long K7E0
.long K7E0
.long K7E0
.long K7E0
.long K7E8
.long K7E8
.long K7E8
.long K7E8
.long K7E8
.long K7E8
.long K7E8
.long K7E8
.long K7F0
.long K7F0
.long K7F0
.long K7F0
.long K7F0
.long K7F0
.long K7F0
.long K7F0
.long K7F8
.long K7F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K800
.long K800
.long K800
.long K800
.long K800
.long K800
.long K800
.long K800
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K810
.long K810
.long K810
.long K810
.long K810
.long K810
.long K810
.long K810
.long K818
.long K818
.long K818
.long K818
.long K818
.long K818
.long K818
.long K818
.long K820
.long K820
.long K820
.long K820
.long K820
.long K820
.long K820
.long K820
.long K828
.long K828
.long K828
.long K828
.long K828
.long K828
.long K828
.long K828
.long K830
.long K830
.long K830
.long K830
.long K830
.long K830
.long K830
.long K830
.long K838
.long K839
.long K83A
.long K83B
.long K83C
.long r_illegal
.long r_illegal
.long r_illegal
.long K840
.long K840
.long K840
.long K840
.long K840
.long K840
.long K840
.long K840
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K850
.long K850
.long K850
.long K850
.long K850
.long K850
.long K850
.long K850
.long K858
.long K858
.long K858
.long K858
.long K858
.long K858
.long K858
.long K858
.long K860
.long K860
.long K860
.long K860
.long K860
.long K860
.long K860
.long K860
.long K868
.long K868
.long K868
.long K868
.long K868
.long K868
.long K868
.long K868
.long K870
.long K870
.long K870
.long K870
.long K870
.long K870
.long K870
.long K870
.long K878
.long K879
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K880
.long K880
.long K880
.long K880
.long K880
.long K880
.long K880
.long K880
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K890
.long K890
.long K890
.long K890
.long K890
.long K890
.long K890
.long K890
.long K898
.long K898
.long K898
.long K898
.long K898
.long K898
.long K898
.long K898
.long K8A0
.long K8A0
.long K8A0
.long K8A0
.long K8A0
.long K8A0
.long K8A0
.long K8A0
.long K8A8
.long K8A8
.long K8A8
.long K8A8
.long K8A8
.long K8A8
.long K8A8
.long K8A8
.long K8B0
.long K8B0
.long K8B0
.long K8B0
.long K8B0
.long K8B0
.long K8B0
.long K8B0
.long K8B8
.long K8B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K8C0
.long K8C0
.long K8C0
.long K8C0
.long K8C0
.long K8C0
.long K8C0
.long K8C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K8D0
.long K8D0
.long K8D0
.long K8D0
.long K8D0
.long K8D0
.long K8D0
.long K8D0
.long K8D8
.long K8D8
.long K8D8
.long K8D8
.long K8D8
.long K8D8
.long K8D8
.long K8D8
.long K8E0
.long K8E0
.long K8E0
.long K8E0
.long K8E0
.long K8E0
.long K8E0
.long K8E0
.long K8E8
.long K8E8
.long K8E8
.long K8E8
.long K8E8
.long K8E8
.long K8E8
.long K8E8
.long K8F0
.long K8F0
.long K8F0
.long K8F0
.long K8F0
.long K8F0
.long K8F0
.long K8F0
.long K8F8
.long K8F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K900
.long K900
.long K900
.long K900
.long K900
.long K900
.long K900
.long K900
.long K908
.long K908
.long K908
.long K908
.long K908
.long K908
.long K908
.long K908
.long K910
.long K910
.long K910
.long K910
.long K910
.long K910
.long K910
.long K910
.long K918
.long K918
.long K918
.long K918
.long K918
.long K918
.long K918
.long K918
.long K920
.long K920
.long K920
.long K920
.long K920
.long K920
.long K920
.long K920
.long K928
.long K928
.long K928
.long K928
.long K928
.long K928
.long K928
.long K928
.long K930
.long K930
.long K930
.long K930
.long K930
.long K930
.long K930
.long K930
.long K938
.long K939
.long K93A
.long K93B
.long K93C
.long r_illegal
.long r_illegal
.long r_illegal
.long K940
.long K940
.long K940
.long K940
.long K940
.long K940
.long K940
.long K940
.long K948
.long K948
.long K948
.long K948
.long K948
.long K948
.long K948
.long K948
.long K950
.long K950
.long K950
.long K950
.long K950
.long K950
.long K950
.long K950
.long K958
.long K958
.long K958
.long K958
.long K958
.long K958
.long K958
.long K958
.long K960
.long K960
.long K960
.long K960
.long K960
.long K960
.long K960
.long K960
.long K968
.long K968
.long K968
.long K968
.long K968
.long K968
.long K968
.long K968
.long K970
.long K970
.long K970
.long K970
.long K970
.long K970
.long K970
.long K970
.long K978
.long K979
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K980
.long K980
.long K980
.long K980
.long K980
.long K980
.long K980
.long K980
.long K988
.long K988
.long K988
.long K988
.long K988
.long K988
.long K988
.long K988
.long K990
.long K990
.long K990
.long K990
.long K990
.long K990
.long K990
.long K990
.long K998
.long K998
.long K998
.long K998
.long K998
.long K998
.long K998
.long K998
.long K9A0
.long K9A0
.long K9A0
.long K9A0
.long K9A0
.long K9A0
.long K9A0
.long K9A0
.long K9A8
.long K9A8
.long K9A8
.long K9A8
.long K9A8
.long K9A8
.long K9A8
.long K9A8
.long K9B0
.long K9B0
.long K9B0
.long K9B0
.long K9B0
.long K9B0
.long K9B0
.long K9B0
.long K9B8
.long K9B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long K9C0
.long K9C0
.long K9C0
.long K9C0
.long K9C0
.long K9C0
.long K9C0
.long K9C0
.long K9C8
.long K9C8
.long K9C8
.long K9C8
.long K9C8
.long K9C8
.long K9C8
.long K9C8
.long K9D0
.long K9D0
.long K9D0
.long K9D0
.long K9D0
.long K9D0
.long K9D0
.long K9D0
.long K9D8
.long K9D8
.long K9D8
.long K9D8
.long K9D8
.long K9D8
.long K9D8
.long K9D8
.long K9E0
.long K9E0
.long K9E0
.long K9E0
.long K9E0
.long K9E0
.long K9E0
.long K9E0
.long K9E8
.long K9E8
.long K9E8
.long K9E8
.long K9E8
.long K9E8
.long K9E8
.long K9E8
.long K9F0
.long K9F0
.long K9F0
.long K9F0
.long K9F0
.long K9F0
.long K9F0
.long K9F0
.long K9F8
.long K9F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KA00
.long KA00
.long KA00
.long KA00
.long KA00
.long KA00
.long KA00
.long KA00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KA10
.long KA10
.long KA10
.long KA10
.long KA10
.long KA10
.long KA10
.long KA10
.long KA18
.long KA18
.long KA18
.long KA18
.long KA18
.long KA18
.long KA18
.long KA18
.long KA20
.long KA20
.long KA20
.long KA20
.long KA20
.long KA20
.long KA20
.long KA20
.long KA28
.long KA28
.long KA28
.long KA28
.long KA28
.long KA28
.long KA28
.long KA28
.long KA30
.long KA30
.long KA30
.long KA30
.long KA30
.long KA30
.long KA30
.long KA30
.long KA38
.long KA39
.long r_illegal
.long r_illegal
.long KA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long KA40
.long KA40
.long KA40
.long KA40
.long KA40
.long KA40
.long KA40
.long KA40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KA50
.long KA50
.long KA50
.long KA50
.long KA50
.long KA50
.long KA50
.long KA50
.long KA58
.long KA58
.long KA58
.long KA58
.long KA58
.long KA58
.long KA58
.long KA58
.long KA60
.long KA60
.long KA60
.long KA60
.long KA60
.long KA60
.long KA60
.long KA60
.long KA68
.long KA68
.long KA68
.long KA68
.long KA68
.long KA68
.long KA68
.long KA68
.long KA70
.long KA70
.long KA70
.long KA70
.long KA70
.long KA70
.long KA70
.long KA70
.long KA78
.long KA79
.long r_illegal
.long r_illegal
.long KA7C
.long r_illegal
.long r_illegal
.long r_illegal
.long KA80
.long KA80
.long KA80
.long KA80
.long KA80
.long KA80
.long KA80
.long KA80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KA90
.long KA90
.long KA90
.long KA90
.long KA90
.long KA90
.long KA90
.long KA90
.long KA98
.long KA98
.long KA98
.long KA98
.long KA98
.long KA98
.long KA98
.long KA98
.long KAA0
.long KAA0
.long KAA0
.long KAA0
.long KAA0
.long KAA0
.long KAA0
.long KAA0
.long KAA8
.long KAA8
.long KAA8
.long KAA8
.long KAA8
.long KAA8
.long KAA8
.long KAA8
.long KAB0
.long KAB0
.long KAB0
.long KAB0
.long KAB0
.long KAB0
.long KAB0
.long KAB0
.long KAB8
.long KAB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KB00
.long KB00
.long KB00
.long KB00
.long KB00
.long KB00
.long KB00
.long KB00
.long KB08
.long KB08
.long KB08
.long KB08
.long KB08
.long KB08
.long KB08
.long KB08
.long KB10
.long KB10
.long KB10
.long KB10
.long KB10
.long KB10
.long KB10
.long KB10
.long KB18
.long KB18
.long KB18
.long KB18
.long KB18
.long KB18
.long KB18
.long KB18
.long KB20
.long KB20
.long KB20
.long KB20
.long KB20
.long KB20
.long KB20
.long KB20
.long KB28
.long KB28
.long KB28
.long KB28
.long KB28
.long KB28
.long KB28
.long KB28
.long KB30
.long KB30
.long KB30
.long KB30
.long KB30
.long KB30
.long KB30
.long KB30
.long KB38
.long KB39
.long KB3A
.long KB3B
.long KB3C
.long r_illegal
.long r_illegal
.long r_illegal
.long KB40
.long KB40
.long KB40
.long KB40
.long KB40
.long KB40
.long KB40
.long KB40
.long KB48
.long KB48
.long KB48
.long KB48
.long KB48
.long KB48
.long KB48
.long KB48
.long KB50
.long KB50
.long KB50
.long KB50
.long KB50
.long KB50
.long KB50
.long KB50
.long KB58
.long KB58
.long KB58
.long KB58
.long KB58
.long KB58
.long KB58
.long KB58
.long KB60
.long KB60
.long KB60
.long KB60
.long KB60
.long KB60
.long KB60
.long KB60
.long KB68
.long KB68
.long KB68
.long KB68
.long KB68
.long KB68
.long KB68
.long KB68
.long KB70
.long KB70
.long KB70
.long KB70
.long KB70
.long KB70
.long KB70
.long KB70
.long KB78
.long KB79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KB80
.long KB80
.long KB80
.long KB80
.long KB80
.long KB80
.long KB80
.long KB80
.long KB88
.long KB88
.long KB88
.long KB88
.long KB88
.long KB88
.long KB88
.long KB88
.long KB90
.long KB90
.long KB90
.long KB90
.long KB90
.long KB90
.long KB90
.long KB90
.long KB98
.long KB98
.long KB98
.long KB98
.long KB98
.long KB98
.long KB98
.long KB98
.long KBA0
.long KBA0
.long KBA0
.long KBA0
.long KBA0
.long KBA0
.long KBA0
.long KBA0
.long KBA8
.long KBA8
.long KBA8
.long KBA8
.long KBA8
.long KBA8
.long KBA8
.long KBA8
.long KBB0
.long KBB0
.long KBB0
.long KBB0
.long KBB0
.long KBB0
.long KBB0
.long KBB0
.long KBB8
.long KBB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KBC0
.long KBC0
.long KBC0
.long KBC0
.long KBC0
.long KBC0
.long KBC0
.long KBC0
.long KBC8
.long KBC8
.long KBC8
.long KBC8
.long KBC8
.long KBC8
.long KBC8
.long KBC8
.long KBD0
.long KBD0
.long KBD0
.long KBD0
.long KBD0
.long KBD0
.long KBD0
.long KBD0
.long KBD8
.long KBD8
.long KBD8
.long KBD8
.long KBD8
.long KBD8
.long KBD8
.long KBD8
.long KBE0
.long KBE0
.long KBE0
.long KBE0
.long KBE0
.long KBE0
.long KBE0
.long KBE0
.long KBE8
.long KBE8
.long KBE8
.long KBE8
.long KBE8
.long KBE8
.long KBE8
.long KBE8
.long KBF0
.long KBF0
.long KBF0
.long KBF0
.long KBF0
.long KBF0
.long KBF0
.long KBF0
.long KBF8
.long KBF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KC00
.long KC00
.long KC00
.long KC00
.long KC00
.long KC00
.long KC00
.long KC00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KC10
.long KC10
.long KC10
.long KC10
.long KC10
.long KC10
.long KC10
.long KC10
.long KC18
.long KC18
.long KC18
.long KC18
.long KC18
.long KC18
.long KC18
.long KC18
.long KC20
.long KC20
.long KC20
.long KC20
.long KC20
.long KC20
.long KC20
.long KC20
.long KC28
.long KC28
.long KC28
.long KC28
.long KC28
.long KC28
.long KC28
.long KC28
.long KC30
.long KC30
.long KC30
.long KC30
.long KC30
.long KC30
.long KC30
.long KC30
.long KC38
.long KC39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KC40
.long KC40
.long KC40
.long KC40
.long KC40
.long KC40
.long KC40
.long KC40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KC50
.long KC50
.long KC50
.long KC50
.long KC50
.long KC50
.long KC50
.long KC50
.long KC58
.long KC58
.long KC58
.long KC58
.long KC58
.long KC58
.long KC58
.long KC58
.long KC60
.long KC60
.long KC60
.long KC60
.long KC60
.long KC60
.long KC60
.long KC60
.long KC68
.long KC68
.long KC68
.long KC68
.long KC68
.long KC68
.long KC68
.long KC68
.long KC70
.long KC70
.long KC70
.long KC70
.long KC70
.long KC70
.long KC70
.long KC70
.long KC78
.long KC79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KC80
.long KC80
.long KC80
.long KC80
.long KC80
.long KC80
.long KC80
.long KC80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KC90
.long KC90
.long KC90
.long KC90
.long KC90
.long KC90
.long KC90
.long KC90
.long KC98
.long KC98
.long KC98
.long KC98
.long KC98
.long KC98
.long KC98
.long KC98
.long KCA0
.long KCA0
.long KCA0
.long KCA0
.long KCA0
.long KCA0
.long KCA0
.long KCA0
.long KCA8
.long KCA8
.long KCA8
.long KCA8
.long KCA8
.long KCA8
.long KCA8
.long KCA8
.long KCB0
.long KCB0
.long KCB0
.long KCB0
.long KCB0
.long KCB0
.long KCB0
.long KCB0
.long KCB8
.long KCB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KD00
.long KD00
.long KD00
.long KD00
.long KD00
.long KD00
.long KD00
.long KD00
.long KD08
.long KD08
.long KD08
.long KD08
.long KD08
.long KD08
.long KD08
.long KD08
.long KD10
.long KD10
.long KD10
.long KD10
.long KD10
.long KD10
.long KD10
.long KD10
.long KD18
.long KD18
.long KD18
.long KD18
.long KD18
.long KD18
.long KD18
.long KD18
.long KD20
.long KD20
.long KD20
.long KD20
.long KD20
.long KD20
.long KD20
.long KD20
.long KD28
.long KD28
.long KD28
.long KD28
.long KD28
.long KD28
.long KD28
.long KD28
.long KD30
.long KD30
.long KD30
.long KD30
.long KD30
.long KD30
.long KD30
.long KD30
.long KD38
.long KD39
.long KD3A
.long KD3B
.long KD3C
.long r_illegal
.long r_illegal
.long r_illegal
.long KD40
.long KD40
.long KD40
.long KD40
.long KD40
.long KD40
.long KD40
.long KD40
.long KD48
.long KD48
.long KD48
.long KD48
.long KD48
.long KD48
.long KD48
.long KD48
.long KD50
.long KD50
.long KD50
.long KD50
.long KD50
.long KD50
.long KD50
.long KD50
.long KD58
.long KD58
.long KD58
.long KD58
.long KD58
.long KD58
.long KD58
.long KD58
.long KD60
.long KD60
.long KD60
.long KD60
.long KD60
.long KD60
.long KD60
.long KD60
.long KD68
.long KD68
.long KD68
.long KD68
.long KD68
.long KD68
.long KD68
.long KD68
.long KD70
.long KD70
.long KD70
.long KD70
.long KD70
.long KD70
.long KD70
.long KD70
.long KD78
.long KD79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KD80
.long KD80
.long KD80
.long KD80
.long KD80
.long KD80
.long KD80
.long KD80
.long KD88
.long KD88
.long KD88
.long KD88
.long KD88
.long KD88
.long KD88
.long KD88
.long KD90
.long KD90
.long KD90
.long KD90
.long KD90
.long KD90
.long KD90
.long KD90
.long KD98
.long KD98
.long KD98
.long KD98
.long KD98
.long KD98
.long KD98
.long KD98
.long KDA0
.long KDA0
.long KDA0
.long KDA0
.long KDA0
.long KDA0
.long KDA0
.long KDA0
.long KDA8
.long KDA8
.long KDA8
.long KDA8
.long KDA8
.long KDA8
.long KDA8
.long KDA8
.long KDB0
.long KDB0
.long KDB0
.long KDB0
.long KDB0
.long KDB0
.long KDB0
.long KDB0
.long KDB8
.long KDB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KDC0
.long KDC0
.long KDC0
.long KDC0
.long KDC0
.long KDC0
.long KDC0
.long KDC0
.long KDC8
.long KDC8
.long KDC8
.long KDC8
.long KDC8
.long KDC8
.long KDC8
.long KDC8
.long KDD0
.long KDD0
.long KDD0
.long KDD0
.long KDD0
.long KDD0
.long KDD0
.long KDD0
.long KDD8
.long KDD8
.long KDD8
.long KDD8
.long KDD8
.long KDD8
.long KDD8
.long KDD8
.long KDE0
.long KDE0
.long KDE0
.long KDE0
.long KDE0
.long KDE0
.long KDE0
.long KDE0
.long KDE8
.long KDE8
.long KDE8
.long KDE8
.long KDE8
.long KDE8
.long KDE8
.long KDE8
.long KDF0
.long KDF0
.long KDF0
.long KDF0
.long KDF0
.long KDF0
.long KDF0
.long KDF0
.long KDF8
.long KDF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KF00
.long KF00
.long KF00
.long KF00
.long KF00
.long KF00
.long KF00
.long KF00
.long KF08
.long KF08
.long KF08
.long KF08
.long KF08
.long KF08
.long KF08
.long KF08
.long KF10
.long KF10
.long KF10
.long KF10
.long KF10
.long KF10
.long KF10
.long KF10
.long KF18
.long KF18
.long KF18
.long KF18
.long KF18
.long KF18
.long KF18
.long KF18
.long KF20
.long KF20
.long KF20
.long KF20
.long KF20
.long KF20
.long KF20
.long KF20
.long KF28
.long KF28
.long KF28
.long KF28
.long KF28
.long KF28
.long KF28
.long KF28
.long KF30
.long KF30
.long KF30
.long KF30
.long KF30
.long KF30
.long KF30
.long KF30
.long KF38
.long KF39
.long KF3A
.long KF3B
.long KF3C
.long r_illegal
.long r_illegal
.long r_illegal
.long KF40
.long KF40
.long KF40
.long KF40
.long KF40
.long KF40
.long KF40
.long KF40
.long KF48
.long KF48
.long KF48
.long KF48
.long KF48
.long KF48
.long KF48
.long KF48
.long KF50
.long KF50
.long KF50
.long KF50
.long KF50
.long KF50
.long KF50
.long KF50
.long KF58
.long KF58
.long KF58
.long KF58
.long KF58
.long KF58
.long KF58
.long KF58
.long KF60
.long KF60
.long KF60
.long KF60
.long KF60
.long KF60
.long KF60
.long KF60
.long KF68
.long KF68
.long KF68
.long KF68
.long KF68
.long KF68
.long KF68
.long KF68
.long KF70
.long KF70
.long KF70
.long KF70
.long KF70
.long KF70
.long KF70
.long KF70
.long KF78
.long KF79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KF80
.long KF80
.long KF80
.long KF80
.long KF80
.long KF80
.long KF80
.long KF80
.long KF88
.long KF88
.long KF88
.long KF88
.long KF88
.long KF88
.long KF88
.long KF88
.long KF90
.long KF90
.long KF90
.long KF90
.long KF90
.long KF90
.long KF90
.long KF90
.long KF98
.long KF98
.long KF98
.long KF98
.long KF98
.long KF98
.long KF98
.long KF98
.long KFA0
.long KFA0
.long KFA0
.long KFA0
.long KFA0
.long KFA0
.long KFA0
.long KFA0
.long KFA8
.long KFA8
.long KFA8
.long KFA8
.long KFA8
.long KFA8
.long KFA8
.long KFA8
.long KFB0
.long KFB0
.long KFB0
.long KFB0
.long KFB0
.long KFB0
.long KFB0
.long KFB0
.long KFB8
.long KFB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long KFC0
.long KFC0
.long KFC0
.long KFC0
.long KFC0
.long KFC0
.long KFC0
.long KFC0
.long KFC8
.long KFC8
.long KFC8
.long KFC8
.long KFC8
.long KFC8
.long KFC8
.long KFC8
.long KFD0
.long KFD0
.long KFD0
.long KFD0
.long KFD0
.long KFD0
.long KFD0
.long KFD0
.long KFD8
.long KFD8
.long KFD8
.long KFD8
.long KFD8
.long KFD8
.long KFD8
.long KFD8
.long KFE0
.long KFE0
.long KFE0
.long KFE0
.long KFE0
.long KFE0
.long KFE0
.long KFE0
.long KFE8
.long KFE8
.long KFE8
.long KFE8
.long KFE8
.long KFE8
.long KFE8
.long KFE8
.long KFF0
.long KFF0
.long KFF0
.long KFF0
.long KFF0
.long KFF0
.long KFF0
.long KFF0
.long KFF8
.long KFF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long L000
.long L000
.long L000
.long L000
.long L000
.long L000
.long L000
.long L000
.long L008
.long L008
.long L008
.long L008
.long L008
.long L008
.long L008
.long L008
.long L010
.long L010
.long L010
.long L010
.long L010
.long L010
.long L010
.long L010
.long L018
.long L018
.long L018
.long L018
.long L018
.long L018
.long L018
.long L018
.long L020
.long L020
.long L020
.long L020
.long L020
.long L020
.long L020
.long L020
.long L028
.long L028
.long L028
.long L028
.long L028
.long L028
.long L028
.long L028
.long L030
.long L030
.long L030
.long L030
.long L030
.long L030
.long L030
.long L030
.long L038
.long L039
.long L03A
.long L03B
.long L03C
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long L080
.long L080
.long L080
.long L080
.long L080
.long L080
.long L080
.long L080
.long L088
.long L088
.long L088
.long L088
.long L088
.long L088
.long L088
.long L088
.long L090
.long L090
.long L090
.long L090
.long L090
.long L090
.long L090
.long L090
.long L098
.long L098
.long L098
.long L098
.long L098
.long L098
.long L098
.long L098
.long L0A0
.long L0A0
.long L0A0
.long L0A0
.long L0A0
.long L0A0
.long L0A0
.long L0A0
.long L0A8
.long L0A8
.long L0A8
.long L0A8
.long L0A8
.long L0A8
.long L0A8
.long L0A8
.long L0B0
.long L0B0
.long L0B0
.long L0B0
.long L0B0
.long L0B0
.long L0B0
.long L0B0
.long L0B8
.long L0B9
.long L0BA
.long L0BB
.long L0BC
.long r_illegal
.long r_illegal
.long r_illegal
.long L0C0
.long L0C0
.long L0C0
.long L0C0
.long L0C0
.long L0C0
.long L0C0
.long L0C0
.long L0C8
.long L0C8
.long L0C8
.long L0C8
.long L0C8
.long L0C8
.long L0C8
.long L0C8
.long L0D0
.long L0D0
.long L0D0
.long L0D0
.long L0D0
.long L0D0
.long L0D0
.long L0D0
.long L0D8
.long L0D8
.long L0D8
.long L0D8
.long L0D8
.long L0D8
.long L0D8
.long L0D8
.long L0E0
.long L0E0
.long L0E0
.long L0E0
.long L0E0
.long L0E0
.long L0E0
.long L0E0
.long L0E8
.long L0E8
.long L0E8
.long L0E8
.long L0E8
.long L0E8
.long L0E8
.long L0E8
.long L0F0
.long L0F0
.long L0F0
.long L0F0
.long L0F0
.long L0F0
.long L0F0
.long L0F0
.long L0F8
.long L0F9
.long L0FA
.long L0FB
.long L0FC
.long r_illegal
.long r_illegal
.long r_illegal
.long L100
.long L100
.long L100
.long L100
.long L100
.long L100
.long L100
.long L100
.long L108
.long L108
.long L108
.long L108
.long L108
.long L108
.long L108
.long L108
.long L110
.long L110
.long L110
.long L110
.long L110
.long L110
.long L110
.long L110
.long L118
.long L118
.long L118
.long L118
.long L118
.long L118
.long L118
.long L118
.long L120
.long L120
.long L120
.long L120
.long L120
.long L120
.long L120
.long L120
.long L128
.long L128
.long L128
.long L128
.long L128
.long L128
.long L128
.long L128
.long L130
.long L130
.long L130
.long L130
.long L130
.long L130
.long L130
.long L130
.long L138
.long L139
.long L13A
.long L13B
.long L13C
.long r_illegal
.long r_illegal
.long r_illegal
.long L140
.long L140
.long L140
.long L140
.long L140
.long L140
.long L140
.long L140
.long L148
.long L148
.long L148
.long L148
.long L148
.long L148
.long L148
.long L148
.long L150
.long L150
.long L150
.long L150
.long L150
.long L150
.long L150
.long L150
.long L158
.long L158
.long L158
.long L158
.long L158
.long L158
.long L158
.long L158
.long L160
.long L160
.long L160
.long L160
.long L160
.long L160
.long L160
.long L160
.long L168
.long L168
.long L168
.long L168
.long L168
.long L168
.long L168
.long L168
.long L170
.long L170
.long L170
.long L170
.long L170
.long L170
.long L170
.long L170
.long L178
.long L179
.long L17A
.long L17B
.long L17C
.long r_illegal
.long r_illegal
.long r_illegal
.long L180
.long L180
.long L180
.long L180
.long L180
.long L180
.long L180
.long L180
.long L188
.long L188
.long L188
.long L188
.long L188
.long L188
.long L188
.long L188
.long L190
.long L190
.long L190
.long L190
.long L190
.long L190
.long L190
.long L190
.long L198
.long L198
.long L198
.long L198
.long L198
.long L198
.long L198
.long L198
.long L1A0
.long L1A0
.long L1A0
.long L1A0
.long L1A0
.long L1A0
.long L1A0
.long L1A0
.long L1A8
.long L1A8
.long L1A8
.long L1A8
.long L1A8
.long L1A8
.long L1A8
.long L1A8
.long L1B0
.long L1B0
.long L1B0
.long L1B0
.long L1B0
.long L1B0
.long L1B0
.long L1B0
.long L1B8
.long L1B9
.long L1BA
.long L1BB
.long L1BC
.long r_illegal
.long r_illegal
.long r_illegal
.long L1C0
.long L1C0
.long L1C0
.long L1C0
.long L1C0
.long L1C0
.long L1C0
.long L1C0
.long L1C8
.long L1C8
.long L1C8
.long L1C8
.long L1C8
.long L1C8
.long L1C8
.long L1C8
.long L1D0
.long L1D0
.long L1D0
.long L1D0
.long L1D0
.long L1D0
.long L1D0
.long L1D0
.long L1D8
.long L1D8
.long L1D8
.long L1D8
.long L1D8
.long L1D8
.long L1D8
.long L1D8
.long L1E0
.long L1E0
.long L1E0
.long L1E0
.long L1E0
.long L1E0
.long L1E0
.long L1E0
.long L1E8
.long L1E8
.long L1E8
.long L1E8
.long L1E8
.long L1E8
.long L1E8
.long L1E8
.long L1F0
.long L1F0
.long L1F0
.long L1F0
.long L1F0
.long L1F0
.long L1F0
.long L1F0
.long L1F8
.long L1F9
.long L1FA
.long L1FB
.long L1FC
.long r_illegal
.long r_illegal
.long r_illegal
.long L200
.long L200
.long L200
.long L200
.long L200
.long L200
.long L200
.long L200
.long L208
.long L208
.long L208
.long L208
.long L208
.long L208
.long L208
.long L208
.long L210
.long L210
.long L210
.long L210
.long L210
.long L210
.long L210
.long L210
.long L218
.long L218
.long L218
.long L218
.long L218
.long L218
.long L218
.long L218
.long L220
.long L220
.long L220
.long L220
.long L220
.long L220
.long L220
.long L220
.long L228
.long L228
.long L228
.long L228
.long L228
.long L228
.long L228
.long L228
.long L230
.long L230
.long L230
.long L230
.long L230
.long L230
.long L230
.long L230
.long L238
.long L239
.long L23A
.long L23B
.long L23C
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long L280
.long L280
.long L280
.long L280
.long L280
.long L280
.long L280
.long L280
.long L288
.long L288
.long L288
.long L288
.long L288
.long L288
.long L288
.long L288
.long L290
.long L290
.long L290
.long L290
.long L290
.long L290
.long L290
.long L290
.long L298
.long L298
.long L298
.long L298
.long L298
.long L298
.long L298
.long L298
.long L2A0
.long L2A0
.long L2A0
.long L2A0
.long L2A0
.long L2A0
.long L2A0
.long L2A0
.long L2A8
.long L2A8
.long L2A8
.long L2A8
.long L2A8
.long L2A8
.long L2A8
.long L2A8
.long L2B0
.long L2B0
.long L2B0
.long L2B0
.long L2B0
.long L2B0
.long L2B0
.long L2B0
.long L2B8
.long L2B9
.long L2BA
.long L2BB
.long L2BC
.long r_illegal
.long r_illegal
.long r_illegal
.long L2C0
.long L2C0
.long L2C0
.long L2C0
.long L2C0
.long L2C0
.long L2C0
.long L2C0
.long L2C8
.long L2C8
.long L2C8
.long L2C8
.long L2C8
.long L2C8
.long L2C8
.long L2C8
.long L2D0
.long L2D0
.long L2D0
.long L2D0
.long L2D0
.long L2D0
.long L2D0
.long L2D0
.long L2D8
.long L2D8
.long L2D8
.long L2D8
.long L2D8
.long L2D8
.long L2D8
.long L2D8
.long L2E0
.long L2E0
.long L2E0
.long L2E0
.long L2E0
.long L2E0
.long L2E0
.long L2E0
.long L2E8
.long L2E8
.long L2E8
.long L2E8
.long L2E8
.long L2E8
.long L2E8
.long L2E8
.long L2F0
.long L2F0
.long L2F0
.long L2F0
.long L2F0
.long L2F0
.long L2F0
.long L2F0
.long L2F8
.long L2F9
.long L2FA
.long L2FB
.long L2FC
.long r_illegal
.long r_illegal
.long r_illegal
.long L300
.long L300
.long L300
.long L300
.long L300
.long L300
.long L300
.long L300
.long L308
.long L308
.long L308
.long L308
.long L308
.long L308
.long L308
.long L308
.long L310
.long L310
.long L310
.long L310
.long L310
.long L310
.long L310
.long L310
.long L318
.long L318
.long L318
.long L318
.long L318
.long L318
.long L318
.long L318
.long L320
.long L320
.long L320
.long L320
.long L320
.long L320
.long L320
.long L320
.long L328
.long L328
.long L328
.long L328
.long L328
.long L328
.long L328
.long L328
.long L330
.long L330
.long L330
.long L330
.long L330
.long L330
.long L330
.long L330
.long L338
.long L339
.long L33A
.long L33B
.long L33C
.long r_illegal
.long r_illegal
.long r_illegal
.long L340
.long L340
.long L340
.long L340
.long L340
.long L340
.long L340
.long L340
.long L348
.long L348
.long L348
.long L348
.long L348
.long L348
.long L348
.long L348
.long L350
.long L350
.long L350
.long L350
.long L350
.long L350
.long L350
.long L350
.long L358
.long L358
.long L358
.long L358
.long L358
.long L358
.long L358
.long L358
.long L360
.long L360
.long L360
.long L360
.long L360
.long L360
.long L360
.long L360
.long L368
.long L368
.long L368
.long L368
.long L368
.long L368
.long L368
.long L368
.long L370
.long L370
.long L370
.long L370
.long L370
.long L370
.long L370
.long L370
.long L378
.long L379
.long L37A
.long L37B
.long L37C
.long r_illegal
.long r_illegal
.long r_illegal
.long L380
.long L380
.long L380
.long L380
.long L380
.long L380
.long L380
.long L380
.long L388
.long L388
.long L388
.long L388
.long L388
.long L388
.long L388
.long L388
.long L390
.long L390
.long L390
.long L390
.long L390
.long L390
.long L390
.long L390
.long L398
.long L398
.long L398
.long L398
.long L398
.long L398
.long L398
.long L398
.long L3A0
.long L3A0
.long L3A0
.long L3A0
.long L3A0
.long L3A0
.long L3A0
.long L3A0
.long L3A8
.long L3A8
.long L3A8
.long L3A8
.long L3A8
.long L3A8
.long L3A8
.long L3A8
.long L3B0
.long L3B0
.long L3B0
.long L3B0
.long L3B0
.long L3B0
.long L3B0
.long L3B0
.long L3B8
.long L3B9
.long L3BA
.long L3BB
.long L3BC
.long r_illegal
.long r_illegal
.long r_illegal
.long L3C0
.long L3C0
.long L3C0
.long L3C0
.long L3C0
.long L3C0
.long L3C0
.long L3C0
.long L3C8
.long L3C8
.long L3C8
.long L3C8
.long L3C8
.long L3C8
.long L3C8
.long L3C8
.long L3D0
.long L3D0
.long L3D0
.long L3D0
.long L3D0
.long L3D0
.long L3D0
.long L3D0
.long L3D8
.long L3D8
.long L3D8
.long L3D8
.long L3D8
.long L3D8
.long L3D8
.long L3D8
.long L3E0
.long L3E0
.long L3E0
.long L3E0
.long L3E0
.long L3E0
.long L3E0
.long L3E0
.long L3E8
.long L3E8
.long L3E8
.long L3E8
.long L3E8
.long L3E8
.long L3E8
.long L3E8
.long L3F0
.long L3F0
.long L3F0
.long L3F0
.long L3F0
.long L3F0
.long L3F0
.long L3F0
.long L3F8
.long L3F9
.long L3FA
.long L3FB
.long L3FC
.long r_illegal
.long r_illegal
.long r_illegal
.long L400
.long L400
.long L400
.long L400
.long L400
.long L400
.long L400
.long L400
.long L408
.long L408
.long L408
.long L408
.long L408
.long L408
.long L408
.long L408
.long L410
.long L410
.long L410
.long L410
.long L410
.long L410
.long L410
.long L410
.long L418
.long L418
.long L418
.long L418
.long L418
.long L418
.long L418
.long L418
.long L420
.long L420
.long L420
.long L420
.long L420
.long L420
.long L420
.long L420
.long L428
.long L428
.long L428
.long L428
.long L428
.long L428
.long L428
.long L428
.long L430
.long L430
.long L430
.long L430
.long L430
.long L430
.long L430
.long L430
.long L438
.long L439
.long L43A
.long L43B
.long L43C
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long L480
.long L480
.long L480
.long L480
.long L480
.long L480
.long L480
.long L480
.long L488
.long L488
.long L488
.long L488
.long L488
.long L488
.long L488
.long L488
.long L490
.long L490
.long L490
.long L490
.long L490
.long L490
.long L490
.long L490
.long L498
.long L498
.long L498
.long L498
.long L498
.long L498
.long L498
.long L498
.long L4A0
.long L4A0
.long L4A0
.long L4A0
.long L4A0
.long L4A0
.long L4A0
.long L4A0
.long L4A8
.long L4A8
.long L4A8
.long L4A8
.long L4A8
.long L4A8
.long L4A8
.long L4A8
.long L4B0
.long L4B0
.long L4B0
.long L4B0
.long L4B0
.long L4B0
.long L4B0
.long L4B0
.long L4B8
.long L4B9
.long L4BA
.long L4BB
.long L4BC
.long r_illegal
.long r_illegal
.long r_illegal
.long L4C0
.long L4C0
.long L4C0
.long L4C0
.long L4C0
.long L4C0
.long L4C0
.long L4C0
.long L4C8
.long L4C8
.long L4C8
.long L4C8
.long L4C8
.long L4C8
.long L4C8
.long L4C8
.long L4D0
.long L4D0
.long L4D0
.long L4D0
.long L4D0
.long L4D0
.long L4D0
.long L4D0
.long L4D8
.long L4D8
.long L4D8
.long L4D8
.long L4D8
.long L4D8
.long L4D8
.long L4D8
.long L4E0
.long L4E0
.long L4E0
.long L4E0
.long L4E0
.long L4E0
.long L4E0
.long L4E0
.long L4E8
.long L4E8
.long L4E8
.long L4E8
.long L4E8
.long L4E8
.long L4E8
.long L4E8
.long L4F0
.long L4F0
.long L4F0
.long L4F0
.long L4F0
.long L4F0
.long L4F0
.long L4F0
.long L4F8
.long L4F9
.long L4FA
.long L4FB
.long L4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long L500
.long L500
.long L500
.long L500
.long L500
.long L500
.long L500
.long L500
.long L508
.long L508
.long L508
.long L508
.long L508
.long L508
.long L508
.long L508
.long L510
.long L510
.long L510
.long L510
.long L510
.long L510
.long L510
.long L510
.long L518
.long L518
.long L518
.long L518
.long L518
.long L518
.long L518
.long L518
.long L520
.long L520
.long L520
.long L520
.long L520
.long L520
.long L520
.long L520
.long L528
.long L528
.long L528
.long L528
.long L528
.long L528
.long L528
.long L528
.long L530
.long L530
.long L530
.long L530
.long L530
.long L530
.long L530
.long L530
.long L538
.long L539
.long L53A
.long L53B
.long L53C
.long r_illegal
.long r_illegal
.long r_illegal
.long L540
.long L540
.long L540
.long L540
.long L540
.long L540
.long L540
.long L540
.long L548
.long L548
.long L548
.long L548
.long L548
.long L548
.long L548
.long L548
.long L550
.long L550
.long L550
.long L550
.long L550
.long L550
.long L550
.long L550
.long L558
.long L558
.long L558
.long L558
.long L558
.long L558
.long L558
.long L558
.long L560
.long L560
.long L560
.long L560
.long L560
.long L560
.long L560
.long L560
.long L568
.long L568
.long L568
.long L568
.long L568
.long L568
.long L568
.long L568
.long L570
.long L570
.long L570
.long L570
.long L570
.long L570
.long L570
.long L570
.long L578
.long L579
.long L57A
.long L57B
.long L57C
.long r_illegal
.long r_illegal
.long r_illegal
.long L580
.long L580
.long L580
.long L580
.long L580
.long L580
.long L580
.long L580
.long L588
.long L588
.long L588
.long L588
.long L588
.long L588
.long L588
.long L588
.long L590
.long L590
.long L590
.long L590
.long L590
.long L590
.long L590
.long L590
.long L598
.long L598
.long L598
.long L598
.long L598
.long L598
.long L598
.long L598
.long L5A0
.long L5A0
.long L5A0
.long L5A0
.long L5A0
.long L5A0
.long L5A0
.long L5A0
.long L5A8
.long L5A8
.long L5A8
.long L5A8
.long L5A8
.long L5A8
.long L5A8
.long L5A8
.long L5B0
.long L5B0
.long L5B0
.long L5B0
.long L5B0
.long L5B0
.long L5B0
.long L5B0
.long L5B8
.long L5B9
.long L5BA
.long L5BB
.long L5BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long L600
.long L600
.long L600
.long L600
.long L600
.long L600
.long L600
.long L600
.long L608
.long L608
.long L608
.long L608
.long L608
.long L608
.long L608
.long L608
.long L610
.long L610
.long L610
.long L610
.long L610
.long L610
.long L610
.long L610
.long L618
.long L618
.long L618
.long L618
.long L618
.long L618
.long L618
.long L618
.long L620
.long L620
.long L620
.long L620
.long L620
.long L620
.long L620
.long L620
.long L628
.long L628
.long L628
.long L628
.long L628
.long L628
.long L628
.long L628
.long L630
.long L630
.long L630
.long L630
.long L630
.long L630
.long L630
.long L630
.long L638
.long L639
.long L63A
.long L63B
.long L63C
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long L680
.long L680
.long L680
.long L680
.long L680
.long L680
.long L680
.long L680
.long L688
.long L688
.long L688
.long L688
.long L688
.long L688
.long L688
.long L688
.long L690
.long L690
.long L690
.long L690
.long L690
.long L690
.long L690
.long L690
.long L698
.long L698
.long L698
.long L698
.long L698
.long L698
.long L698
.long L698
.long L6A0
.long L6A0
.long L6A0
.long L6A0
.long L6A0
.long L6A0
.long L6A0
.long L6A0
.long L6A8
.long L6A8
.long L6A8
.long L6A8
.long L6A8
.long L6A8
.long L6A8
.long L6A8
.long L6B0
.long L6B0
.long L6B0
.long L6B0
.long L6B0
.long L6B0
.long L6B0
.long L6B0
.long L6B8
.long L6B9
.long L6BA
.long L6BB
.long L6BC
.long r_illegal
.long r_illegal
.long r_illegal
.long L6C0
.long L6C0
.long L6C0
.long L6C0
.long L6C0
.long L6C0
.long L6C0
.long L6C0
.long L6C8
.long L6C8
.long L6C8
.long L6C8
.long L6C8
.long L6C8
.long L6C8
.long L6C8
.long L6D0
.long L6D0
.long L6D0
.long L6D0
.long L6D0
.long L6D0
.long L6D0
.long L6D0
.long L6D8
.long L6D8
.long L6D8
.long L6D8
.long L6D8
.long L6D8
.long L6D8
.long L6D8
.long L6E0
.long L6E0
.long L6E0
.long L6E0
.long L6E0
.long L6E0
.long L6E0
.long L6E0
.long L6E8
.long L6E8
.long L6E8
.long L6E8
.long L6E8
.long L6E8
.long L6E8
.long L6E8
.long L6F0
.long L6F0
.long L6F0
.long L6F0
.long L6F0
.long L6F0
.long L6F0
.long L6F0
.long L6F8
.long L6F9
.long L6FA
.long L6FB
.long L6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long L700
.long L700
.long L700
.long L700
.long L700
.long L700
.long L700
.long L700
.long L708
.long L708
.long L708
.long L708
.long L708
.long L708
.long L708
.long L708
.long L710
.long L710
.long L710
.long L710
.long L710
.long L710
.long L710
.long L710
.long L718
.long L718
.long L718
.long L718
.long L718
.long L718
.long L718
.long L718
.long L720
.long L720
.long L720
.long L720
.long L720
.long L720
.long L720
.long L720
.long L728
.long L728
.long L728
.long L728
.long L728
.long L728
.long L728
.long L728
.long L730
.long L730
.long L730
.long L730
.long L730
.long L730
.long L730
.long L730
.long L738
.long L739
.long L73A
.long L73B
.long L73C
.long r_illegal
.long r_illegal
.long r_illegal
.long L740
.long L740
.long L740
.long L740
.long L740
.long L740
.long L740
.long L740
.long L748
.long L748
.long L748
.long L748
.long L748
.long L748
.long L748
.long L748
.long L750
.long L750
.long L750
.long L750
.long L750
.long L750
.long L750
.long L750
.long L758
.long L758
.long L758
.long L758
.long L758
.long L758
.long L758
.long L758
.long L760
.long L760
.long L760
.long L760
.long L760
.long L760
.long L760
.long L760
.long L768
.long L768
.long L768
.long L768
.long L768
.long L768
.long L768
.long L768
.long L770
.long L770
.long L770
.long L770
.long L770
.long L770
.long L770
.long L770
.long L778
.long L779
.long L77A
.long L77B
.long L77C
.long r_illegal
.long r_illegal
.long r_illegal
.long L780
.long L780
.long L780
.long L780
.long L780
.long L780
.long L780
.long L780
.long L788
.long L788
.long L788
.long L788
.long L788
.long L788
.long L788
.long L788
.long L790
.long L790
.long L790
.long L790
.long L790
.long L790
.long L790
.long L790
.long L798
.long L798
.long L798
.long L798
.long L798
.long L798
.long L798
.long L798
.long L7A0
.long L7A0
.long L7A0
.long L7A0
.long L7A0
.long L7A0
.long L7A0
.long L7A0
.long L7A8
.long L7A8
.long L7A8
.long L7A8
.long L7A8
.long L7A8
.long L7A8
.long L7A8
.long L7B0
.long L7B0
.long L7B0
.long L7B0
.long L7B0
.long L7B0
.long L7B0
.long L7B0
.long L7B8
.long L7B9
.long L7BA
.long L7BB
.long L7BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long L800
.long L800
.long L800
.long L800
.long L800
.long L800
.long L800
.long L800
.long L808
.long L808
.long L808
.long L808
.long L808
.long L808
.long L808
.long L808
.long L810
.long L810
.long L810
.long L810
.long L810
.long L810
.long L810
.long L810
.long L818
.long L818
.long L818
.long L818
.long L818
.long L818
.long L818
.long L818
.long L820
.long L820
.long L820
.long L820
.long L820
.long L820
.long L820
.long L820
.long L828
.long L828
.long L828
.long L828
.long L828
.long L828
.long L828
.long L828
.long L830
.long L830
.long L830
.long L830
.long L830
.long L830
.long L830
.long L830
.long L838
.long L839
.long L83A
.long L83B
.long L83C
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long L880
.long L880
.long L880
.long L880
.long L880
.long L880
.long L880
.long L880
.long L888
.long L888
.long L888
.long L888
.long L888
.long L888
.long L888
.long L888
.long L890
.long L890
.long L890
.long L890
.long L890
.long L890
.long L890
.long L890
.long L898
.long L898
.long L898
.long L898
.long L898
.long L898
.long L898
.long L898
.long L8A0
.long L8A0
.long L8A0
.long L8A0
.long L8A0
.long L8A0
.long L8A0
.long L8A0
.long L8A8
.long L8A8
.long L8A8
.long L8A8
.long L8A8
.long L8A8
.long L8A8
.long L8A8
.long L8B0
.long L8B0
.long L8B0
.long L8B0
.long L8B0
.long L8B0
.long L8B0
.long L8B0
.long L8B8
.long L8B9
.long L8BA
.long L8BB
.long L8BC
.long r_illegal
.long r_illegal
.long r_illegal
.long L8C0
.long L8C0
.long L8C0
.long L8C0
.long L8C0
.long L8C0
.long L8C0
.long L8C0
.long L8C8
.long L8C8
.long L8C8
.long L8C8
.long L8C8
.long L8C8
.long L8C8
.long L8C8
.long L8D0
.long L8D0
.long L8D0
.long L8D0
.long L8D0
.long L8D0
.long L8D0
.long L8D0
.long L8D8
.long L8D8
.long L8D8
.long L8D8
.long L8D8
.long L8D8
.long L8D8
.long L8D8
.long L8E0
.long L8E0
.long L8E0
.long L8E0
.long L8E0
.long L8E0
.long L8E0
.long L8E0
.long L8E8
.long L8E8
.long L8E8
.long L8E8
.long L8E8
.long L8E8
.long L8E8
.long L8E8
.long L8F0
.long L8F0
.long L8F0
.long L8F0
.long L8F0
.long L8F0
.long L8F0
.long L8F0
.long L8F8
.long L8F9
.long L8FA
.long L8FB
.long L8FC
.long r_illegal
.long r_illegal
.long r_illegal
.long L900
.long L900
.long L900
.long L900
.long L900
.long L900
.long L900
.long L900
.long L908
.long L908
.long L908
.long L908
.long L908
.long L908
.long L908
.long L908
.long L910
.long L910
.long L910
.long L910
.long L910
.long L910
.long L910
.long L910
.long L918
.long L918
.long L918
.long L918
.long L918
.long L918
.long L918
.long L918
.long L920
.long L920
.long L920
.long L920
.long L920
.long L920
.long L920
.long L920
.long L928
.long L928
.long L928
.long L928
.long L928
.long L928
.long L928
.long L928
.long L930
.long L930
.long L930
.long L930
.long L930
.long L930
.long L930
.long L930
.long L938
.long L939
.long L93A
.long L93B
.long L93C
.long r_illegal
.long r_illegal
.long r_illegal
.long L940
.long L940
.long L940
.long L940
.long L940
.long L940
.long L940
.long L940
.long L948
.long L948
.long L948
.long L948
.long L948
.long L948
.long L948
.long L948
.long L950
.long L950
.long L950
.long L950
.long L950
.long L950
.long L950
.long L950
.long L958
.long L958
.long L958
.long L958
.long L958
.long L958
.long L958
.long L958
.long L960
.long L960
.long L960
.long L960
.long L960
.long L960
.long L960
.long L960
.long L968
.long L968
.long L968
.long L968
.long L968
.long L968
.long L968
.long L968
.long L970
.long L970
.long L970
.long L970
.long L970
.long L970
.long L970
.long L970
.long L978
.long L979
.long L97A
.long L97B
.long L97C
.long r_illegal
.long r_illegal
.long r_illegal
.long L980
.long L980
.long L980
.long L980
.long L980
.long L980
.long L980
.long L980
.long L988
.long L988
.long L988
.long L988
.long L988
.long L988
.long L988
.long L988
.long L990
.long L990
.long L990
.long L990
.long L990
.long L990
.long L990
.long L990
.long L998
.long L998
.long L998
.long L998
.long L998
.long L998
.long L998
.long L998
.long L9A0
.long L9A0
.long L9A0
.long L9A0
.long L9A0
.long L9A0
.long L9A0
.long L9A0
.long L9A8
.long L9A8
.long L9A8
.long L9A8
.long L9A8
.long L9A8
.long L9A8
.long L9A8
.long L9B0
.long L9B0
.long L9B0
.long L9B0
.long L9B0
.long L9B0
.long L9B0
.long L9B0
.long L9B8
.long L9B9
.long L9BA
.long L9BB
.long L9BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long LA00
.long LA00
.long LA00
.long LA00
.long LA00
.long LA00
.long LA00
.long LA00
.long LA08
.long LA08
.long LA08
.long LA08
.long LA08
.long LA08
.long LA08
.long LA08
.long LA10
.long LA10
.long LA10
.long LA10
.long LA10
.long LA10
.long LA10
.long LA10
.long LA18
.long LA18
.long LA18
.long LA18
.long LA18
.long LA18
.long LA18
.long LA18
.long LA20
.long LA20
.long LA20
.long LA20
.long LA20
.long LA20
.long LA20
.long LA20
.long LA28
.long LA28
.long LA28
.long LA28
.long LA28
.long LA28
.long LA28
.long LA28
.long LA30
.long LA30
.long LA30
.long LA30
.long LA30
.long LA30
.long LA30
.long LA30
.long LA38
.long LA39
.long LA3A
.long LA3B
.long LA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long LA80
.long LA80
.long LA80
.long LA80
.long LA80
.long LA80
.long LA80
.long LA80
.long LA88
.long LA88
.long LA88
.long LA88
.long LA88
.long LA88
.long LA88
.long LA88
.long LA90
.long LA90
.long LA90
.long LA90
.long LA90
.long LA90
.long LA90
.long LA90
.long LA98
.long LA98
.long LA98
.long LA98
.long LA98
.long LA98
.long LA98
.long LA98
.long LAA0
.long LAA0
.long LAA0
.long LAA0
.long LAA0
.long LAA0
.long LAA0
.long LAA0
.long LAA8
.long LAA8
.long LAA8
.long LAA8
.long LAA8
.long LAA8
.long LAA8
.long LAA8
.long LAB0
.long LAB0
.long LAB0
.long LAB0
.long LAB0
.long LAB0
.long LAB0
.long LAB0
.long LAB8
.long LAB9
.long LABA
.long LABB
.long LABC
.long r_illegal
.long r_illegal
.long r_illegal
.long LAC0
.long LAC0
.long LAC0
.long LAC0
.long LAC0
.long LAC0
.long LAC0
.long LAC0
.long LAC8
.long LAC8
.long LAC8
.long LAC8
.long LAC8
.long LAC8
.long LAC8
.long LAC8
.long LAD0
.long LAD0
.long LAD0
.long LAD0
.long LAD0
.long LAD0
.long LAD0
.long LAD0
.long LAD8
.long LAD8
.long LAD8
.long LAD8
.long LAD8
.long LAD8
.long LAD8
.long LAD8
.long LAE0
.long LAE0
.long LAE0
.long LAE0
.long LAE0
.long LAE0
.long LAE0
.long LAE0
.long LAE8
.long LAE8
.long LAE8
.long LAE8
.long LAE8
.long LAE8
.long LAE8
.long LAE8
.long LAF0
.long LAF0
.long LAF0
.long LAF0
.long LAF0
.long LAF0
.long LAF0
.long LAF0
.long LAF8
.long LAF9
.long LAFA
.long LAFB
.long LAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long LB00
.long LB00
.long LB00
.long LB00
.long LB00
.long LB00
.long LB00
.long LB00
.long LB08
.long LB08
.long LB08
.long LB08
.long LB08
.long LB08
.long LB08
.long LB08
.long LB10
.long LB10
.long LB10
.long LB10
.long LB10
.long LB10
.long LB10
.long LB10
.long LB18
.long LB18
.long LB18
.long LB18
.long LB18
.long LB18
.long LB18
.long LB18
.long LB20
.long LB20
.long LB20
.long LB20
.long LB20
.long LB20
.long LB20
.long LB20
.long LB28
.long LB28
.long LB28
.long LB28
.long LB28
.long LB28
.long LB28
.long LB28
.long LB30
.long LB30
.long LB30
.long LB30
.long LB30
.long LB30
.long LB30
.long LB30
.long LB38
.long LB39
.long LB3A
.long LB3B
.long LB3C
.long r_illegal
.long r_illegal
.long r_illegal
.long LB40
.long LB40
.long LB40
.long LB40
.long LB40
.long LB40
.long LB40
.long LB40
.long LB48
.long LB48
.long LB48
.long LB48
.long LB48
.long LB48
.long LB48
.long LB48
.long LB50
.long LB50
.long LB50
.long LB50
.long LB50
.long LB50
.long LB50
.long LB50
.long LB58
.long LB58
.long LB58
.long LB58
.long LB58
.long LB58
.long LB58
.long LB58
.long LB60
.long LB60
.long LB60
.long LB60
.long LB60
.long LB60
.long LB60
.long LB60
.long LB68
.long LB68
.long LB68
.long LB68
.long LB68
.long LB68
.long LB68
.long LB68
.long LB70
.long LB70
.long LB70
.long LB70
.long LB70
.long LB70
.long LB70
.long LB70
.long LB78
.long LB79
.long LB7A
.long LB7B
.long LB7C
.long r_illegal
.long r_illegal
.long r_illegal
.long LB80
.long LB80
.long LB80
.long LB80
.long LB80
.long LB80
.long LB80
.long LB80
.long LB88
.long LB88
.long LB88
.long LB88
.long LB88
.long LB88
.long LB88
.long LB88
.long LB90
.long LB90
.long LB90
.long LB90
.long LB90
.long LB90
.long LB90
.long LB90
.long LB98
.long LB98
.long LB98
.long LB98
.long LB98
.long LB98
.long LB98
.long LB98
.long LBA0
.long LBA0
.long LBA0
.long LBA0
.long LBA0
.long LBA0
.long LBA0
.long LBA0
.long LBA8
.long LBA8
.long LBA8
.long LBA8
.long LBA8
.long LBA8
.long LBA8
.long LBA8
.long LBB0
.long LBB0
.long LBB0
.long LBB0
.long LBB0
.long LBB0
.long LBB0
.long LBB0
.long LBB8
.long LBB9
.long LBBA
.long LBBB
.long LBBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long LC00
.long LC00
.long LC00
.long LC00
.long LC00
.long LC00
.long LC00
.long LC00
.long LC08
.long LC08
.long LC08
.long LC08
.long LC08
.long LC08
.long LC08
.long LC08
.long LC10
.long LC10
.long LC10
.long LC10
.long LC10
.long LC10
.long LC10
.long LC10
.long LC18
.long LC18
.long LC18
.long LC18
.long LC18
.long LC18
.long LC18
.long LC18
.long LC20
.long LC20
.long LC20
.long LC20
.long LC20
.long LC20
.long LC20
.long LC20
.long LC28
.long LC28
.long LC28
.long LC28
.long LC28
.long LC28
.long LC28
.long LC28
.long LC30
.long LC30
.long LC30
.long LC30
.long LC30
.long LC30
.long LC30
.long LC30
.long LC38
.long LC39
.long LC3A
.long LC3B
.long LC3C
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long LC80
.long LC80
.long LC80
.long LC80
.long LC80
.long LC80
.long LC80
.long LC80
.long LC88
.long LC88
.long LC88
.long LC88
.long LC88
.long LC88
.long LC88
.long LC88
.long LC90
.long LC90
.long LC90
.long LC90
.long LC90
.long LC90
.long LC90
.long LC90
.long LC98
.long LC98
.long LC98
.long LC98
.long LC98
.long LC98
.long LC98
.long LC98
.long LCA0
.long LCA0
.long LCA0
.long LCA0
.long LCA0
.long LCA0
.long LCA0
.long LCA0
.long LCA8
.long LCA8
.long LCA8
.long LCA8
.long LCA8
.long LCA8
.long LCA8
.long LCA8
.long LCB0
.long LCB0
.long LCB0
.long LCB0
.long LCB0
.long LCB0
.long LCB0
.long LCB0
.long LCB8
.long LCB9
.long LCBA
.long LCBB
.long LCBC
.long r_illegal
.long r_illegal
.long r_illegal
.long LCC0
.long LCC0
.long LCC0
.long LCC0
.long LCC0
.long LCC0
.long LCC0
.long LCC0
.long LCC8
.long LCC8
.long LCC8
.long LCC8
.long LCC8
.long LCC8
.long LCC8
.long LCC8
.long LCD0
.long LCD0
.long LCD0
.long LCD0
.long LCD0
.long LCD0
.long LCD0
.long LCD0
.long LCD8
.long LCD8
.long LCD8
.long LCD8
.long LCD8
.long LCD8
.long LCD8
.long LCD8
.long LCE0
.long LCE0
.long LCE0
.long LCE0
.long LCE0
.long LCE0
.long LCE0
.long LCE0
.long LCE8
.long LCE8
.long LCE8
.long LCE8
.long LCE8
.long LCE8
.long LCE8
.long LCE8
.long LCF0
.long LCF0
.long LCF0
.long LCF0
.long LCF0
.long LCF0
.long LCF0
.long LCF0
.long LCF8
.long LCF9
.long LCFA
.long LCFB
.long LCFC
.long r_illegal
.long r_illegal
.long r_illegal
.long LD00
.long LD00
.long LD00
.long LD00
.long LD00
.long LD00
.long LD00
.long LD00
.long LD08
.long LD08
.long LD08
.long LD08
.long LD08
.long LD08
.long LD08
.long LD08
.long LD10
.long LD10
.long LD10
.long LD10
.long LD10
.long LD10
.long LD10
.long LD10
.long LD18
.long LD18
.long LD18
.long LD18
.long LD18
.long LD18
.long LD18
.long LD18
.long LD20
.long LD20
.long LD20
.long LD20
.long LD20
.long LD20
.long LD20
.long LD20
.long LD28
.long LD28
.long LD28
.long LD28
.long LD28
.long LD28
.long LD28
.long LD28
.long LD30
.long LD30
.long LD30
.long LD30
.long LD30
.long LD30
.long LD30
.long LD30
.long LD38
.long LD39
.long LD3A
.long LD3B
.long LD3C
.long r_illegal
.long r_illegal
.long r_illegal
.long LD40
.long LD40
.long LD40
.long LD40
.long LD40
.long LD40
.long LD40
.long LD40
.long LD48
.long LD48
.long LD48
.long LD48
.long LD48
.long LD48
.long LD48
.long LD48
.long LD50
.long LD50
.long LD50
.long LD50
.long LD50
.long LD50
.long LD50
.long LD50
.long LD58
.long LD58
.long LD58
.long LD58
.long LD58
.long LD58
.long LD58
.long LD58
.long LD60
.long LD60
.long LD60
.long LD60
.long LD60
.long LD60
.long LD60
.long LD60
.long LD68
.long LD68
.long LD68
.long LD68
.long LD68
.long LD68
.long LD68
.long LD68
.long LD70
.long LD70
.long LD70
.long LD70
.long LD70
.long LD70
.long LD70
.long LD70
.long LD78
.long LD79
.long LD7A
.long LD7B
.long LD7C
.long r_illegal
.long r_illegal
.long r_illegal
.long LD80
.long LD80
.long LD80
.long LD80
.long LD80
.long LD80
.long LD80
.long LD80
.long LD88
.long LD88
.long LD88
.long LD88
.long LD88
.long LD88
.long LD88
.long LD88
.long LD90
.long LD90
.long LD90
.long LD90
.long LD90
.long LD90
.long LD90
.long LD90
.long LD98
.long LD98
.long LD98
.long LD98
.long LD98
.long LD98
.long LD98
.long LD98
.long LDA0
.long LDA0
.long LDA0
.long LDA0
.long LDA0
.long LDA0
.long LDA0
.long LDA0
.long LDA8
.long LDA8
.long LDA8
.long LDA8
.long LDA8
.long LDA8
.long LDA8
.long LDA8
.long LDB0
.long LDB0
.long LDB0
.long LDB0
.long LDB0
.long LDB0
.long LDB0
.long LDB0
.long LDB8
.long LDB9
.long LDBA
.long LDBB
.long LDBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long LE00
.long LE00
.long LE00
.long LE00
.long LE00
.long LE00
.long LE00
.long LE00
.long LE08
.long LE08
.long LE08
.long LE08
.long LE08
.long LE08
.long LE08
.long LE08
.long LE10
.long LE10
.long LE10
.long LE10
.long LE10
.long LE10
.long LE10
.long LE10
.long LE18
.long LE18
.long LE18
.long LE18
.long LE18
.long LE18
.long LE18
.long LE18
.long LE20
.long LE20
.long LE20
.long LE20
.long LE20
.long LE20
.long LE20
.long LE20
.long LE28
.long LE28
.long LE28
.long LE28
.long LE28
.long LE28
.long LE28
.long LE28
.long LE30
.long LE30
.long LE30
.long LE30
.long LE30
.long LE30
.long LE30
.long LE30
.long LE38
.long LE39
.long LE3A
.long LE3B
.long LE3C
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long LE80
.long LE80
.long LE80
.long LE80
.long LE80
.long LE80
.long LE80
.long LE80
.long LE88
.long LE88
.long LE88
.long LE88
.long LE88
.long LE88
.long LE88
.long LE88
.long LE90
.long LE90
.long LE90
.long LE90
.long LE90
.long LE90
.long LE90
.long LE90
.long LE98
.long LE98
.long LE98
.long LE98
.long LE98
.long LE98
.long LE98
.long LE98
.long LEA0
.long LEA0
.long LEA0
.long LEA0
.long LEA0
.long LEA0
.long LEA0
.long LEA0
.long LEA8
.long LEA8
.long LEA8
.long LEA8
.long LEA8
.long LEA8
.long LEA8
.long LEA8
.long LEB0
.long LEB0
.long LEB0
.long LEB0
.long LEB0
.long LEB0
.long LEB0
.long LEB0
.long LEB8
.long LEB9
.long LEBA
.long LEBB
.long LEBC
.long r_illegal
.long r_illegal
.long r_illegal
.long LEC0
.long LEC0
.long LEC0
.long LEC0
.long LEC0
.long LEC0
.long LEC0
.long LEC0
.long LEC8
.long LEC8
.long LEC8
.long LEC8
.long LEC8
.long LEC8
.long LEC8
.long LEC8
.long LED0
.long LED0
.long LED0
.long LED0
.long LED0
.long LED0
.long LED0
.long LED0
.long LED8
.long LED8
.long LED8
.long LED8
.long LED8
.long LED8
.long LED8
.long LED8
.long LEE0
.long LEE0
.long LEE0
.long LEE0
.long LEE0
.long LEE0
.long LEE0
.long LEE0
.long LEE8
.long LEE8
.long LEE8
.long LEE8
.long LEE8
.long LEE8
.long LEE8
.long LEE8
.long LEF0
.long LEF0
.long LEF0
.long LEF0
.long LEF0
.long LEF0
.long LEF0
.long LEF0
.long LEF8
.long LEF9
.long LEFA
.long LEFB
.long LEFC
.long r_illegal
.long r_illegal
.long r_illegal
.long LF00
.long LF00
.long LF00
.long LF00
.long LF00
.long LF00
.long LF00
.long LF00
.long LF08
.long LF08
.long LF08
.long LF08
.long LF08
.long LF08
.long LF08
.long LF08
.long LF10
.long LF10
.long LF10
.long LF10
.long LF10
.long LF10
.long LF10
.long LF10
.long LF18
.long LF18
.long LF18
.long LF18
.long LF18
.long LF18
.long LF18
.long LF18
.long LF20
.long LF20
.long LF20
.long LF20
.long LF20
.long LF20
.long LF20
.long LF20
.long LF28
.long LF28
.long LF28
.long LF28
.long LF28
.long LF28
.long LF28
.long LF28
.long LF30
.long LF30
.long LF30
.long LF30
.long LF30
.long LF30
.long LF30
.long LF30
.long LF38
.long LF39
.long LF3A
.long LF3B
.long LF3C
.long r_illegal
.long r_illegal
.long r_illegal
.long LF40
.long LF40
.long LF40
.long LF40
.long LF40
.long LF40
.long LF40
.long LF40
.long LF48
.long LF48
.long LF48
.long LF48
.long LF48
.long LF48
.long LF48
.long LF48
.long LF50
.long LF50
.long LF50
.long LF50
.long LF50
.long LF50
.long LF50
.long LF50
.long LF58
.long LF58
.long LF58
.long LF58
.long LF58
.long LF58
.long LF58
.long LF58
.long LF60
.long LF60
.long LF60
.long LF60
.long LF60
.long LF60
.long LF60
.long LF60
.long LF68
.long LF68
.long LF68
.long LF68
.long LF68
.long LF68
.long LF68
.long LF68
.long LF70
.long LF70
.long LF70
.long LF70
.long LF70
.long LF70
.long LF70
.long LF70
.long LF78
.long LF79
.long LF7A
.long LF7B
.long LF7C
.long r_illegal
.long r_illegal
.long r_illegal
.long LF80
.long LF80
.long LF80
.long LF80
.long LF80
.long LF80
.long LF80
.long LF80
.long LF88
.long LF88
.long LF88
.long LF88
.long LF88
.long LF88
.long LF88
.long LF88
.long LF90
.long LF90
.long LF90
.long LF90
.long LF90
.long LF90
.long LF90
.long LF90
.long LF98
.long LF98
.long LF98
.long LF98
.long LF98
.long LF98
.long LF98
.long LF98
.long LFA0
.long LFA0
.long LFA0
.long LFA0
.long LFA0
.long LFA0
.long LFA0
.long LFA0
.long LFA8
.long LFA8
.long LFA8
.long LFA8
.long LFA8
.long LFA8
.long LFA8
.long LFA8
.long LFB0
.long LFB0
.long LFB0
.long LFB0
.long LFB0
.long LFB0
.long LFB0
.long LFB0
.long LFB8
.long LFB9
.long LFBA
.long LFBB
.long LFBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long M000
.long M000
.long M000
.long M000
.long M000
.long M000
.long M000
.long M000
.long M008
.long M008
.long M008
.long M008
.long M008
.long M008
.long M008
.long M008
.long M010
.long M010
.long M010
.long M010
.long M010
.long M010
.long M010
.long M010
.long M018
.long M018
.long M018
.long M018
.long M018
.long M018
.long M018
.long M018
.long M020
.long M020
.long M020
.long M020
.long M020
.long M020
.long M020
.long M020
.long M028
.long M028
.long M028
.long M028
.long M028
.long M028
.long M028
.long M028
.long M030
.long M030
.long M030
.long M030
.long M030
.long M030
.long M030
.long M030
.long M038
.long M039
.long M03A
.long M03B
.long M03C
.long r_illegal
.long r_illegal
.long r_illegal
.long M040
.long M040
.long M040
.long M040
.long M040
.long M040
.long M040
.long M040
.long M048
.long M048
.long M048
.long M048
.long M048
.long M048
.long M048
.long M048
.long M050
.long M050
.long M050
.long M050
.long M050
.long M050
.long M050
.long M050
.long M058
.long M058
.long M058
.long M058
.long M058
.long M058
.long M058
.long M058
.long M060
.long M060
.long M060
.long M060
.long M060
.long M060
.long M060
.long M060
.long M068
.long M068
.long M068
.long M068
.long M068
.long M068
.long M068
.long M068
.long M070
.long M070
.long M070
.long M070
.long M070
.long M070
.long M070
.long M070
.long M078
.long M079
.long M07A
.long M07B
.long M07C
.long r_illegal
.long r_illegal
.long r_illegal
.long M080
.long M080
.long M080
.long M080
.long M080
.long M080
.long M080
.long M080
.long M088
.long M088
.long M088
.long M088
.long M088
.long M088
.long M088
.long M088
.long M090
.long M090
.long M090
.long M090
.long M090
.long M090
.long M090
.long M090
.long M098
.long M098
.long M098
.long M098
.long M098
.long M098
.long M098
.long M098
.long M0A0
.long M0A0
.long M0A0
.long M0A0
.long M0A0
.long M0A0
.long M0A0
.long M0A0
.long M0A8
.long M0A8
.long M0A8
.long M0A8
.long M0A8
.long M0A8
.long M0A8
.long M0A8
.long M0B0
.long M0B0
.long M0B0
.long M0B0
.long M0B0
.long M0B0
.long M0B0
.long M0B0
.long M0B8
.long M0B9
.long M0BA
.long M0BB
.long M0BC
.long r_illegal
.long r_illegal
.long r_illegal
.long M0C0
.long M0C0
.long M0C0
.long M0C0
.long M0C0
.long M0C0
.long M0C0
.long M0C0
.long M0C8
.long M0C8
.long M0C8
.long M0C8
.long M0C8
.long M0C8
.long M0C8
.long M0C8
.long M0D0
.long M0D0
.long M0D0
.long M0D0
.long M0D0
.long M0D0
.long M0D0
.long M0D0
.long M0D8
.long M0D8
.long M0D8
.long M0D8
.long M0D8
.long M0D8
.long M0D8
.long M0D8
.long M0E0
.long M0E0
.long M0E0
.long M0E0
.long M0E0
.long M0E0
.long M0E0
.long M0E0
.long M0E8
.long M0E8
.long M0E8
.long M0E8
.long M0E8
.long M0E8
.long M0E8
.long M0E8
.long M0F0
.long M0F0
.long M0F0
.long M0F0
.long M0F0
.long M0F0
.long M0F0
.long M0F0
.long M0F8
.long M0F9
.long M0FA
.long M0FB
.long M0FC
.long r_illegal
.long r_illegal
.long r_illegal
.long M100
.long M100
.long M100
.long M100
.long M100
.long M100
.long M100
.long M100
.long M108
.long M108
.long M108
.long M108
.long M108
.long M108
.long M108
.long M108
.long M110
.long M110
.long M110
.long M110
.long M110
.long M110
.long M110
.long M110
.long M118
.long M118
.long M118
.long M118
.long M118
.long M118
.long M118
.long M118
.long M120
.long M120
.long M120
.long M120
.long M120
.long M120
.long M120
.long M120
.long M128
.long M128
.long M128
.long M128
.long M128
.long M128
.long M128
.long M128
.long M130
.long M130
.long M130
.long M130
.long M130
.long M130
.long M130
.long M130
.long M138
.long M139
.long M13A
.long M13B
.long M13C
.long r_illegal
.long r_illegal
.long r_illegal
.long M140
.long M140
.long M140
.long M140
.long M140
.long M140
.long M140
.long M140
.long M148
.long M148
.long M148
.long M148
.long M148
.long M148
.long M148
.long M148
.long M150
.long M150
.long M150
.long M150
.long M150
.long M150
.long M150
.long M150
.long M158
.long M158
.long M158
.long M158
.long M158
.long M158
.long M158
.long M158
.long M160
.long M160
.long M160
.long M160
.long M160
.long M160
.long M160
.long M160
.long M168
.long M168
.long M168
.long M168
.long M168
.long M168
.long M168
.long M168
.long M170
.long M170
.long M170
.long M170
.long M170
.long M170
.long M170
.long M170
.long M178
.long M179
.long M17A
.long M17B
.long M17C
.long r_illegal
.long r_illegal
.long r_illegal
.long M180
.long M180
.long M180
.long M180
.long M180
.long M180
.long M180
.long M180
.long M188
.long M188
.long M188
.long M188
.long M188
.long M188
.long M188
.long M188
.long M190
.long M190
.long M190
.long M190
.long M190
.long M190
.long M190
.long M190
.long M198
.long M198
.long M198
.long M198
.long M198
.long M198
.long M198
.long M198
.long M1A0
.long M1A0
.long M1A0
.long M1A0
.long M1A0
.long M1A0
.long M1A0
.long M1A0
.long M1A8
.long M1A8
.long M1A8
.long M1A8
.long M1A8
.long M1A8
.long M1A8
.long M1A8
.long M1B0
.long M1B0
.long M1B0
.long M1B0
.long M1B0
.long M1B0
.long M1B0
.long M1B0
.long M1B8
.long M1B9
.long M1BA
.long M1BB
.long M1BC
.long r_illegal
.long r_illegal
.long r_illegal
.long M1C0
.long M1C0
.long M1C0
.long M1C0
.long M1C0
.long M1C0
.long M1C0
.long M1C0
.long M1C8
.long M1C8
.long M1C8
.long M1C8
.long M1C8
.long M1C8
.long M1C8
.long M1C8
.long M1D0
.long M1D0
.long M1D0
.long M1D0
.long M1D0
.long M1D0
.long M1D0
.long M1D0
.long M1D8
.long M1D8
.long M1D8
.long M1D8
.long M1D8
.long M1D8
.long M1D8
.long M1D8
.long M1E0
.long M1E0
.long M1E0
.long M1E0
.long M1E0
.long M1E0
.long M1E0
.long M1E0
.long M1E8
.long M1E8
.long M1E8
.long M1E8
.long M1E8
.long M1E8
.long M1E8
.long M1E8
.long M1F0
.long M1F0
.long M1F0
.long M1F0
.long M1F0
.long M1F0
.long M1F0
.long M1F0
.long M1F8
.long M1F9
.long M1FA
.long M1FB
.long M1FC
.long r_illegal
.long r_illegal
.long r_illegal
.long M200
.long M200
.long M200
.long M200
.long M200
.long M200
.long M200
.long M200
.long M208
.long M208
.long M208
.long M208
.long M208
.long M208
.long M208
.long M208
.long M210
.long M210
.long M210
.long M210
.long M210
.long M210
.long M210
.long M210
.long M218
.long M218
.long M218
.long M218
.long M218
.long M218
.long M218
.long M218
.long M220
.long M220
.long M220
.long M220
.long M220
.long M220
.long M220
.long M220
.long M228
.long M228
.long M228
.long M228
.long M228
.long M228
.long M228
.long M228
.long M230
.long M230
.long M230
.long M230
.long M230
.long M230
.long M230
.long M230
.long M238
.long M239
.long M23A
.long M23B
.long M23C
.long r_illegal
.long r_illegal
.long r_illegal
.long M240
.long M240
.long M240
.long M240
.long M240
.long M240
.long M240
.long M240
.long M248
.long M248
.long M248
.long M248
.long M248
.long M248
.long M248
.long M248
.long M250
.long M250
.long M250
.long M250
.long M250
.long M250
.long M250
.long M250
.long M258
.long M258
.long M258
.long M258
.long M258
.long M258
.long M258
.long M258
.long M260
.long M260
.long M260
.long M260
.long M260
.long M260
.long M260
.long M260
.long M268
.long M268
.long M268
.long M268
.long M268
.long M268
.long M268
.long M268
.long M270
.long M270
.long M270
.long M270
.long M270
.long M270
.long M270
.long M270
.long M278
.long M279
.long M27A
.long M27B
.long M27C
.long r_illegal
.long r_illegal
.long r_illegal
.long M280
.long M280
.long M280
.long M280
.long M280
.long M280
.long M280
.long M280
.long M288
.long M288
.long M288
.long M288
.long M288
.long M288
.long M288
.long M288
.long M290
.long M290
.long M290
.long M290
.long M290
.long M290
.long M290
.long M290
.long M298
.long M298
.long M298
.long M298
.long M298
.long M298
.long M298
.long M298
.long M2A0
.long M2A0
.long M2A0
.long M2A0
.long M2A0
.long M2A0
.long M2A0
.long M2A0
.long M2A8
.long M2A8
.long M2A8
.long M2A8
.long M2A8
.long M2A8
.long M2A8
.long M2A8
.long M2B0
.long M2B0
.long M2B0
.long M2B0
.long M2B0
.long M2B0
.long M2B0
.long M2B0
.long M2B8
.long M2B9
.long M2BA
.long M2BB
.long M2BC
.long r_illegal
.long r_illegal
.long r_illegal
.long M2C0
.long M2C0
.long M2C0
.long M2C0
.long M2C0
.long M2C0
.long M2C0
.long M2C0
.long M2C8
.long M2C8
.long M2C8
.long M2C8
.long M2C8
.long M2C8
.long M2C8
.long M2C8
.long M2D0
.long M2D0
.long M2D0
.long M2D0
.long M2D0
.long M2D0
.long M2D0
.long M2D0
.long M2D8
.long M2D8
.long M2D8
.long M2D8
.long M2D8
.long M2D8
.long M2D8
.long M2D8
.long M2E0
.long M2E0
.long M2E0
.long M2E0
.long M2E0
.long M2E0
.long M2E0
.long M2E0
.long M2E8
.long M2E8
.long M2E8
.long M2E8
.long M2E8
.long M2E8
.long M2E8
.long M2E8
.long M2F0
.long M2F0
.long M2F0
.long M2F0
.long M2F0
.long M2F0
.long M2F0
.long M2F0
.long M2F8
.long M2F9
.long M2FA
.long M2FB
.long M2FC
.long r_illegal
.long r_illegal
.long r_illegal
.long M300
.long M300
.long M300
.long M300
.long M300
.long M300
.long M300
.long M300
.long M308
.long M308
.long M308
.long M308
.long M308
.long M308
.long M308
.long M308
.long M310
.long M310
.long M310
.long M310
.long M310
.long M310
.long M310
.long M310
.long M318
.long M318
.long M318
.long M318
.long M318
.long M318
.long M318
.long M318
.long M320
.long M320
.long M320
.long M320
.long M320
.long M320
.long M320
.long M320
.long M328
.long M328
.long M328
.long M328
.long M328
.long M328
.long M328
.long M328
.long M330
.long M330
.long M330
.long M330
.long M330
.long M330
.long M330
.long M330
.long M338
.long M339
.long M33A
.long M33B
.long M33C
.long r_illegal
.long r_illegal
.long r_illegal
.long M340
.long M340
.long M340
.long M340
.long M340
.long M340
.long M340
.long M340
.long M348
.long M348
.long M348
.long M348
.long M348
.long M348
.long M348
.long M348
.long M350
.long M350
.long M350
.long M350
.long M350
.long M350
.long M350
.long M350
.long M358
.long M358
.long M358
.long M358
.long M358
.long M358
.long M358
.long M358
.long M360
.long M360
.long M360
.long M360
.long M360
.long M360
.long M360
.long M360
.long M368
.long M368
.long M368
.long M368
.long M368
.long M368
.long M368
.long M368
.long M370
.long M370
.long M370
.long M370
.long M370
.long M370
.long M370
.long M370
.long M378
.long M379
.long M37A
.long M37B
.long M37C
.long r_illegal
.long r_illegal
.long r_illegal
.long M380
.long M380
.long M380
.long M380
.long M380
.long M380
.long M380
.long M380
.long M388
.long M388
.long M388
.long M388
.long M388
.long M388
.long M388
.long M388
.long M390
.long M390
.long M390
.long M390
.long M390
.long M390
.long M390
.long M390
.long M398
.long M398
.long M398
.long M398
.long M398
.long M398
.long M398
.long M398
.long M3A0
.long M3A0
.long M3A0
.long M3A0
.long M3A0
.long M3A0
.long M3A0
.long M3A0
.long M3A8
.long M3A8
.long M3A8
.long M3A8
.long M3A8
.long M3A8
.long M3A8
.long M3A8
.long M3B0
.long M3B0
.long M3B0
.long M3B0
.long M3B0
.long M3B0
.long M3B0
.long M3B0
.long M3B8
.long M3B9
.long M3BA
.long M3BB
.long M3BC
.long r_illegal
.long r_illegal
.long r_illegal
.long M3C0
.long M3C0
.long M3C0
.long M3C0
.long M3C0
.long M3C0
.long M3C0
.long M3C0
.long M3C8
.long M3C8
.long M3C8
.long M3C8
.long M3C8
.long M3C8
.long M3C8
.long M3C8
.long M3D0
.long M3D0
.long M3D0
.long M3D0
.long M3D0
.long M3D0
.long M3D0
.long M3D0
.long M3D8
.long M3D8
.long M3D8
.long M3D8
.long M3D8
.long M3D8
.long M3D8
.long M3D8
.long M3E0
.long M3E0
.long M3E0
.long M3E0
.long M3E0
.long M3E0
.long M3E0
.long M3E0
.long M3E8
.long M3E8
.long M3E8
.long M3E8
.long M3E8
.long M3E8
.long M3E8
.long M3E8
.long M3F0
.long M3F0
.long M3F0
.long M3F0
.long M3F0
.long M3F0
.long M3F0
.long M3F0
.long M3F8
.long M3F9
.long M3FA
.long M3FB
.long M3FC
.long r_illegal
.long r_illegal
.long r_illegal
.long M400
.long M400
.long M400
.long M400
.long M400
.long M400
.long M400
.long M400
.long M408
.long M408
.long M408
.long M408
.long M408
.long M408
.long M408
.long M408
.long M410
.long M410
.long M410
.long M410
.long M410
.long M410
.long M410
.long M410
.long M418
.long M418
.long M418
.long M418
.long M418
.long M418
.long M418
.long M418
.long M420
.long M420
.long M420
.long M420
.long M420
.long M420
.long M420
.long M420
.long M428
.long M428
.long M428
.long M428
.long M428
.long M428
.long M428
.long M428
.long M430
.long M430
.long M430
.long M430
.long M430
.long M430
.long M430
.long M430
.long M438
.long M439
.long M43A
.long M43B
.long M43C
.long r_illegal
.long r_illegal
.long r_illegal
.long M440
.long M440
.long M440
.long M440
.long M440
.long M440
.long M440
.long M440
.long M448
.long M448
.long M448
.long M448
.long M448
.long M448
.long M448
.long M448
.long M450
.long M450
.long M450
.long M450
.long M450
.long M450
.long M450
.long M450
.long M458
.long M458
.long M458
.long M458
.long M458
.long M458
.long M458
.long M458
.long M460
.long M460
.long M460
.long M460
.long M460
.long M460
.long M460
.long M460
.long M468
.long M468
.long M468
.long M468
.long M468
.long M468
.long M468
.long M468
.long M470
.long M470
.long M470
.long M470
.long M470
.long M470
.long M470
.long M470
.long M478
.long M479
.long M47A
.long M47B
.long M47C
.long r_illegal
.long r_illegal
.long r_illegal
.long M480
.long M480
.long M480
.long M480
.long M480
.long M480
.long M480
.long M480
.long M488
.long M488
.long M488
.long M488
.long M488
.long M488
.long M488
.long M488
.long M490
.long M490
.long M490
.long M490
.long M490
.long M490
.long M490
.long M490
.long M498
.long M498
.long M498
.long M498
.long M498
.long M498
.long M498
.long M498
.long M4A0
.long M4A0
.long M4A0
.long M4A0
.long M4A0
.long M4A0
.long M4A0
.long M4A0
.long M4A8
.long M4A8
.long M4A8
.long M4A8
.long M4A8
.long M4A8
.long M4A8
.long M4A8
.long M4B0
.long M4B0
.long M4B0
.long M4B0
.long M4B0
.long M4B0
.long M4B0
.long M4B0
.long M4B8
.long M4B9
.long M4BA
.long M4BB
.long M4BC
.long r_illegal
.long r_illegal
.long r_illegal
.long M4C0
.long M4C0
.long M4C0
.long M4C0
.long M4C0
.long M4C0
.long M4C0
.long M4C0
.long M4C8
.long M4C8
.long M4C8
.long M4C8
.long M4C8
.long M4C8
.long M4C8
.long M4C8
.long M4D0
.long M4D0
.long M4D0
.long M4D0
.long M4D0
.long M4D0
.long M4D0
.long M4D0
.long M4D8
.long M4D8
.long M4D8
.long M4D8
.long M4D8
.long M4D8
.long M4D8
.long M4D8
.long M4E0
.long M4E0
.long M4E0
.long M4E0
.long M4E0
.long M4E0
.long M4E0
.long M4E0
.long M4E8
.long M4E8
.long M4E8
.long M4E8
.long M4E8
.long M4E8
.long M4E8
.long M4E8
.long M4F0
.long M4F0
.long M4F0
.long M4F0
.long M4F0
.long M4F0
.long M4F0
.long M4F0
.long M4F8
.long M4F9
.long M4FA
.long M4FB
.long M4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long M500
.long M500
.long M500
.long M500
.long M500
.long M500
.long M500
.long M500
.long M508
.long M508
.long M508
.long M508
.long M508
.long M508
.long M508
.long M508
.long M510
.long M510
.long M510
.long M510
.long M510
.long M510
.long M510
.long M510
.long M518
.long M518
.long M518
.long M518
.long M518
.long M518
.long M518
.long M518
.long M520
.long M520
.long M520
.long M520
.long M520
.long M520
.long M520
.long M520
.long M528
.long M528
.long M528
.long M528
.long M528
.long M528
.long M528
.long M528
.long M530
.long M530
.long M530
.long M530
.long M530
.long M530
.long M530
.long M530
.long M538
.long M539
.long M53A
.long M53B
.long M53C
.long r_illegal
.long r_illegal
.long r_illegal
.long M540
.long M540
.long M540
.long M540
.long M540
.long M540
.long M540
.long M540
.long M548
.long M548
.long M548
.long M548
.long M548
.long M548
.long M548
.long M548
.long M550
.long M550
.long M550
.long M550
.long M550
.long M550
.long M550
.long M550
.long M558
.long M558
.long M558
.long M558
.long M558
.long M558
.long M558
.long M558
.long M560
.long M560
.long M560
.long M560
.long M560
.long M560
.long M560
.long M560
.long M568
.long M568
.long M568
.long M568
.long M568
.long M568
.long M568
.long M568
.long M570
.long M570
.long M570
.long M570
.long M570
.long M570
.long M570
.long M570
.long M578
.long M579
.long M57A
.long M57B
.long M57C
.long r_illegal
.long r_illegal
.long r_illegal
.long M580
.long M580
.long M580
.long M580
.long M580
.long M580
.long M580
.long M580
.long M588
.long M588
.long M588
.long M588
.long M588
.long M588
.long M588
.long M588
.long M590
.long M590
.long M590
.long M590
.long M590
.long M590
.long M590
.long M590
.long M598
.long M598
.long M598
.long M598
.long M598
.long M598
.long M598
.long M598
.long M5A0
.long M5A0
.long M5A0
.long M5A0
.long M5A0
.long M5A0
.long M5A0
.long M5A0
.long M5A8
.long M5A8
.long M5A8
.long M5A8
.long M5A8
.long M5A8
.long M5A8
.long M5A8
.long M5B0
.long M5B0
.long M5B0
.long M5B0
.long M5B0
.long M5B0
.long M5B0
.long M5B0
.long M5B8
.long M5B9
.long M5BA
.long M5BB
.long M5BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long M600
.long M600
.long M600
.long M600
.long M600
.long M600
.long M600
.long M600
.long M608
.long M608
.long M608
.long M608
.long M608
.long M608
.long M608
.long M608
.long M610
.long M610
.long M610
.long M610
.long M610
.long M610
.long M610
.long M610
.long M618
.long M618
.long M618
.long M618
.long M618
.long M618
.long M618
.long M618
.long M620
.long M620
.long M620
.long M620
.long M620
.long M620
.long M620
.long M620
.long M628
.long M628
.long M628
.long M628
.long M628
.long M628
.long M628
.long M628
.long M630
.long M630
.long M630
.long M630
.long M630
.long M630
.long M630
.long M630
.long M638
.long M639
.long M63A
.long M63B
.long M63C
.long r_illegal
.long r_illegal
.long r_illegal
.long M640
.long M640
.long M640
.long M640
.long M640
.long M640
.long M640
.long M640
.long M648
.long M648
.long M648
.long M648
.long M648
.long M648
.long M648
.long M648
.long M650
.long M650
.long M650
.long M650
.long M650
.long M650
.long M650
.long M650
.long M658
.long M658
.long M658
.long M658
.long M658
.long M658
.long M658
.long M658
.long M660
.long M660
.long M660
.long M660
.long M660
.long M660
.long M660
.long M660
.long M668
.long M668
.long M668
.long M668
.long M668
.long M668
.long M668
.long M668
.long M670
.long M670
.long M670
.long M670
.long M670
.long M670
.long M670
.long M670
.long M678
.long M679
.long M67A
.long M67B
.long M67C
.long r_illegal
.long r_illegal
.long r_illegal
.long M680
.long M680
.long M680
.long M680
.long M680
.long M680
.long M680
.long M680
.long M688
.long M688
.long M688
.long M688
.long M688
.long M688
.long M688
.long M688
.long M690
.long M690
.long M690
.long M690
.long M690
.long M690
.long M690
.long M690
.long M698
.long M698
.long M698
.long M698
.long M698
.long M698
.long M698
.long M698
.long M6A0
.long M6A0
.long M6A0
.long M6A0
.long M6A0
.long M6A0
.long M6A0
.long M6A0
.long M6A8
.long M6A8
.long M6A8
.long M6A8
.long M6A8
.long M6A8
.long M6A8
.long M6A8
.long M6B0
.long M6B0
.long M6B0
.long M6B0
.long M6B0
.long M6B0
.long M6B0
.long M6B0
.long M6B8
.long M6B9
.long M6BA
.long M6BB
.long M6BC
.long r_illegal
.long r_illegal
.long r_illegal
.long M6C0
.long M6C0
.long M6C0
.long M6C0
.long M6C0
.long M6C0
.long M6C0
.long M6C0
.long M6C8
.long M6C8
.long M6C8
.long M6C8
.long M6C8
.long M6C8
.long M6C8
.long M6C8
.long M6D0
.long M6D0
.long M6D0
.long M6D0
.long M6D0
.long M6D0
.long M6D0
.long M6D0
.long M6D8
.long M6D8
.long M6D8
.long M6D8
.long M6D8
.long M6D8
.long M6D8
.long M6D8
.long M6E0
.long M6E0
.long M6E0
.long M6E0
.long M6E0
.long M6E0
.long M6E0
.long M6E0
.long M6E8
.long M6E8
.long M6E8
.long M6E8
.long M6E8
.long M6E8
.long M6E8
.long M6E8
.long M6F0
.long M6F0
.long M6F0
.long M6F0
.long M6F0
.long M6F0
.long M6F0
.long M6F0
.long M6F8
.long M6F9
.long M6FA
.long M6FB
.long M6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long M700
.long M700
.long M700
.long M700
.long M700
.long M700
.long M700
.long M700
.long M708
.long M708
.long M708
.long M708
.long M708
.long M708
.long M708
.long M708
.long M710
.long M710
.long M710
.long M710
.long M710
.long M710
.long M710
.long M710
.long M718
.long M718
.long M718
.long M718
.long M718
.long M718
.long M718
.long M718
.long M720
.long M720
.long M720
.long M720
.long M720
.long M720
.long M720
.long M720
.long M728
.long M728
.long M728
.long M728
.long M728
.long M728
.long M728
.long M728
.long M730
.long M730
.long M730
.long M730
.long M730
.long M730
.long M730
.long M730
.long M738
.long M739
.long M73A
.long M73B
.long M73C
.long r_illegal
.long r_illegal
.long r_illegal
.long M740
.long M740
.long M740
.long M740
.long M740
.long M740
.long M740
.long M740
.long M748
.long M748
.long M748
.long M748
.long M748
.long M748
.long M748
.long M748
.long M750
.long M750
.long M750
.long M750
.long M750
.long M750
.long M750
.long M750
.long M758
.long M758
.long M758
.long M758
.long M758
.long M758
.long M758
.long M758
.long M760
.long M760
.long M760
.long M760
.long M760
.long M760
.long M760
.long M760
.long M768
.long M768
.long M768
.long M768
.long M768
.long M768
.long M768
.long M768
.long M770
.long M770
.long M770
.long M770
.long M770
.long M770
.long M770
.long M770
.long M778
.long M779
.long M77A
.long M77B
.long M77C
.long r_illegal
.long r_illegal
.long r_illegal
.long M780
.long M780
.long M780
.long M780
.long M780
.long M780
.long M780
.long M780
.long M788
.long M788
.long M788
.long M788
.long M788
.long M788
.long M788
.long M788
.long M790
.long M790
.long M790
.long M790
.long M790
.long M790
.long M790
.long M790
.long M798
.long M798
.long M798
.long M798
.long M798
.long M798
.long M798
.long M798
.long M7A0
.long M7A0
.long M7A0
.long M7A0
.long M7A0
.long M7A0
.long M7A0
.long M7A0
.long M7A8
.long M7A8
.long M7A8
.long M7A8
.long M7A8
.long M7A8
.long M7A8
.long M7A8
.long M7B0
.long M7B0
.long M7B0
.long M7B0
.long M7B0
.long M7B0
.long M7B0
.long M7B0
.long M7B8
.long M7B9
.long M7BA
.long M7BB
.long M7BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long M800
.long M800
.long M800
.long M800
.long M800
.long M800
.long M800
.long M800
.long M808
.long M808
.long M808
.long M808
.long M808
.long M808
.long M808
.long M808
.long M810
.long M810
.long M810
.long M810
.long M810
.long M810
.long M810
.long M810
.long M818
.long M818
.long M818
.long M818
.long M818
.long M818
.long M818
.long M818
.long M820
.long M820
.long M820
.long M820
.long M820
.long M820
.long M820
.long M820
.long M828
.long M828
.long M828
.long M828
.long M828
.long M828
.long M828
.long M828
.long M830
.long M830
.long M830
.long M830
.long M830
.long M830
.long M830
.long M830
.long M838
.long M839
.long M83A
.long M83B
.long M83C
.long r_illegal
.long r_illegal
.long r_illegal
.long M840
.long M840
.long M840
.long M840
.long M840
.long M840
.long M840
.long M840
.long M848
.long M848
.long M848
.long M848
.long M848
.long M848
.long M848
.long M848
.long M850
.long M850
.long M850
.long M850
.long M850
.long M850
.long M850
.long M850
.long M858
.long M858
.long M858
.long M858
.long M858
.long M858
.long M858
.long M858
.long M860
.long M860
.long M860
.long M860
.long M860
.long M860
.long M860
.long M860
.long M868
.long M868
.long M868
.long M868
.long M868
.long M868
.long M868
.long M868
.long M870
.long M870
.long M870
.long M870
.long M870
.long M870
.long M870
.long M870
.long M878
.long M879
.long M87A
.long M87B
.long M87C
.long r_illegal
.long r_illegal
.long r_illegal
.long M880
.long M880
.long M880
.long M880
.long M880
.long M880
.long M880
.long M880
.long M888
.long M888
.long M888
.long M888
.long M888
.long M888
.long M888
.long M888
.long M890
.long M890
.long M890
.long M890
.long M890
.long M890
.long M890
.long M890
.long M898
.long M898
.long M898
.long M898
.long M898
.long M898
.long M898
.long M898
.long M8A0
.long M8A0
.long M8A0
.long M8A0
.long M8A0
.long M8A0
.long M8A0
.long M8A0
.long M8A8
.long M8A8
.long M8A8
.long M8A8
.long M8A8
.long M8A8
.long M8A8
.long M8A8
.long M8B0
.long M8B0
.long M8B0
.long M8B0
.long M8B0
.long M8B0
.long M8B0
.long M8B0
.long M8B8
.long M8B9
.long M8BA
.long M8BB
.long M8BC
.long r_illegal
.long r_illegal
.long r_illegal
.long M8C0
.long M8C0
.long M8C0
.long M8C0
.long M8C0
.long M8C0
.long M8C0
.long M8C0
.long M8C8
.long M8C8
.long M8C8
.long M8C8
.long M8C8
.long M8C8
.long M8C8
.long M8C8
.long M8D0
.long M8D0
.long M8D0
.long M8D0
.long M8D0
.long M8D0
.long M8D0
.long M8D0
.long M8D8
.long M8D8
.long M8D8
.long M8D8
.long M8D8
.long M8D8
.long M8D8
.long M8D8
.long M8E0
.long M8E0
.long M8E0
.long M8E0
.long M8E0
.long M8E0
.long M8E0
.long M8E0
.long M8E8
.long M8E8
.long M8E8
.long M8E8
.long M8E8
.long M8E8
.long M8E8
.long M8E8
.long M8F0
.long M8F0
.long M8F0
.long M8F0
.long M8F0
.long M8F0
.long M8F0
.long M8F0
.long M8F8
.long M8F9
.long M8FA
.long M8FB
.long M8FC
.long r_illegal
.long r_illegal
.long r_illegal
.long M900
.long M900
.long M900
.long M900
.long M900
.long M900
.long M900
.long M900
.long M908
.long M908
.long M908
.long M908
.long M908
.long M908
.long M908
.long M908
.long M910
.long M910
.long M910
.long M910
.long M910
.long M910
.long M910
.long M910
.long M918
.long M918
.long M918
.long M918
.long M918
.long M918
.long M918
.long M918
.long M920
.long M920
.long M920
.long M920
.long M920
.long M920
.long M920
.long M920
.long M928
.long M928
.long M928
.long M928
.long M928
.long M928
.long M928
.long M928
.long M930
.long M930
.long M930
.long M930
.long M930
.long M930
.long M930
.long M930
.long M938
.long M939
.long M93A
.long M93B
.long M93C
.long r_illegal
.long r_illegal
.long r_illegal
.long M940
.long M940
.long M940
.long M940
.long M940
.long M940
.long M940
.long M940
.long M948
.long M948
.long M948
.long M948
.long M948
.long M948
.long M948
.long M948
.long M950
.long M950
.long M950
.long M950
.long M950
.long M950
.long M950
.long M950
.long M958
.long M958
.long M958
.long M958
.long M958
.long M958
.long M958
.long M958
.long M960
.long M960
.long M960
.long M960
.long M960
.long M960
.long M960
.long M960
.long M968
.long M968
.long M968
.long M968
.long M968
.long M968
.long M968
.long M968
.long M970
.long M970
.long M970
.long M970
.long M970
.long M970
.long M970
.long M970
.long M978
.long M979
.long M97A
.long M97B
.long M97C
.long r_illegal
.long r_illegal
.long r_illegal
.long M980
.long M980
.long M980
.long M980
.long M980
.long M980
.long M980
.long M980
.long M988
.long M988
.long M988
.long M988
.long M988
.long M988
.long M988
.long M988
.long M990
.long M990
.long M990
.long M990
.long M990
.long M990
.long M990
.long M990
.long M998
.long M998
.long M998
.long M998
.long M998
.long M998
.long M998
.long M998
.long M9A0
.long M9A0
.long M9A0
.long M9A0
.long M9A0
.long M9A0
.long M9A0
.long M9A0
.long M9A8
.long M9A8
.long M9A8
.long M9A8
.long M9A8
.long M9A8
.long M9A8
.long M9A8
.long M9B0
.long M9B0
.long M9B0
.long M9B0
.long M9B0
.long M9B0
.long M9B0
.long M9B0
.long M9B8
.long M9B9
.long M9BA
.long M9BB
.long M9BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long MA00
.long MA00
.long MA00
.long MA00
.long MA00
.long MA00
.long MA00
.long MA00
.long MA08
.long MA08
.long MA08
.long MA08
.long MA08
.long MA08
.long MA08
.long MA08
.long MA10
.long MA10
.long MA10
.long MA10
.long MA10
.long MA10
.long MA10
.long MA10
.long MA18
.long MA18
.long MA18
.long MA18
.long MA18
.long MA18
.long MA18
.long MA18
.long MA20
.long MA20
.long MA20
.long MA20
.long MA20
.long MA20
.long MA20
.long MA20
.long MA28
.long MA28
.long MA28
.long MA28
.long MA28
.long MA28
.long MA28
.long MA28
.long MA30
.long MA30
.long MA30
.long MA30
.long MA30
.long MA30
.long MA30
.long MA30
.long MA38
.long MA39
.long MA3A
.long MA3B
.long MA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long MA40
.long MA40
.long MA40
.long MA40
.long MA40
.long MA40
.long MA40
.long MA40
.long MA48
.long MA48
.long MA48
.long MA48
.long MA48
.long MA48
.long MA48
.long MA48
.long MA50
.long MA50
.long MA50
.long MA50
.long MA50
.long MA50
.long MA50
.long MA50
.long MA58
.long MA58
.long MA58
.long MA58
.long MA58
.long MA58
.long MA58
.long MA58
.long MA60
.long MA60
.long MA60
.long MA60
.long MA60
.long MA60
.long MA60
.long MA60
.long MA68
.long MA68
.long MA68
.long MA68
.long MA68
.long MA68
.long MA68
.long MA68
.long MA70
.long MA70
.long MA70
.long MA70
.long MA70
.long MA70
.long MA70
.long MA70
.long MA78
.long MA79
.long MA7A
.long MA7B
.long MA7C
.long r_illegal
.long r_illegal
.long r_illegal
.long MA80
.long MA80
.long MA80
.long MA80
.long MA80
.long MA80
.long MA80
.long MA80
.long MA88
.long MA88
.long MA88
.long MA88
.long MA88
.long MA88
.long MA88
.long MA88
.long MA90
.long MA90
.long MA90
.long MA90
.long MA90
.long MA90
.long MA90
.long MA90
.long MA98
.long MA98
.long MA98
.long MA98
.long MA98
.long MA98
.long MA98
.long MA98
.long MAA0
.long MAA0
.long MAA0
.long MAA0
.long MAA0
.long MAA0
.long MAA0
.long MAA0
.long MAA8
.long MAA8
.long MAA8
.long MAA8
.long MAA8
.long MAA8
.long MAA8
.long MAA8
.long MAB0
.long MAB0
.long MAB0
.long MAB0
.long MAB0
.long MAB0
.long MAB0
.long MAB0
.long MAB8
.long MAB9
.long MABA
.long MABB
.long MABC
.long r_illegal
.long r_illegal
.long r_illegal
.long MAC0
.long MAC0
.long MAC0
.long MAC0
.long MAC0
.long MAC0
.long MAC0
.long MAC0
.long MAC8
.long MAC8
.long MAC8
.long MAC8
.long MAC8
.long MAC8
.long MAC8
.long MAC8
.long MAD0
.long MAD0
.long MAD0
.long MAD0
.long MAD0
.long MAD0
.long MAD0
.long MAD0
.long MAD8
.long MAD8
.long MAD8
.long MAD8
.long MAD8
.long MAD8
.long MAD8
.long MAD8
.long MAE0
.long MAE0
.long MAE0
.long MAE0
.long MAE0
.long MAE0
.long MAE0
.long MAE0
.long MAE8
.long MAE8
.long MAE8
.long MAE8
.long MAE8
.long MAE8
.long MAE8
.long MAE8
.long MAF0
.long MAF0
.long MAF0
.long MAF0
.long MAF0
.long MAF0
.long MAF0
.long MAF0
.long MAF8
.long MAF9
.long MAFA
.long MAFB
.long MAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long MB00
.long MB00
.long MB00
.long MB00
.long MB00
.long MB00
.long MB00
.long MB00
.long MB08
.long MB08
.long MB08
.long MB08
.long MB08
.long MB08
.long MB08
.long MB08
.long MB10
.long MB10
.long MB10
.long MB10
.long MB10
.long MB10
.long MB10
.long MB10
.long MB18
.long MB18
.long MB18
.long MB18
.long MB18
.long MB18
.long MB18
.long MB18
.long MB20
.long MB20
.long MB20
.long MB20
.long MB20
.long MB20
.long MB20
.long MB20
.long MB28
.long MB28
.long MB28
.long MB28
.long MB28
.long MB28
.long MB28
.long MB28
.long MB30
.long MB30
.long MB30
.long MB30
.long MB30
.long MB30
.long MB30
.long MB30
.long MB38
.long MB39
.long MB3A
.long MB3B
.long MB3C
.long r_illegal
.long r_illegal
.long r_illegal
.long MB40
.long MB40
.long MB40
.long MB40
.long MB40
.long MB40
.long MB40
.long MB40
.long MB48
.long MB48
.long MB48
.long MB48
.long MB48
.long MB48
.long MB48
.long MB48
.long MB50
.long MB50
.long MB50
.long MB50
.long MB50
.long MB50
.long MB50
.long MB50
.long MB58
.long MB58
.long MB58
.long MB58
.long MB58
.long MB58
.long MB58
.long MB58
.long MB60
.long MB60
.long MB60
.long MB60
.long MB60
.long MB60
.long MB60
.long MB60
.long MB68
.long MB68
.long MB68
.long MB68
.long MB68
.long MB68
.long MB68
.long MB68
.long MB70
.long MB70
.long MB70
.long MB70
.long MB70
.long MB70
.long MB70
.long MB70
.long MB78
.long MB79
.long MB7A
.long MB7B
.long MB7C
.long r_illegal
.long r_illegal
.long r_illegal
.long MB80
.long MB80
.long MB80
.long MB80
.long MB80
.long MB80
.long MB80
.long MB80
.long MB88
.long MB88
.long MB88
.long MB88
.long MB88
.long MB88
.long MB88
.long MB88
.long MB90
.long MB90
.long MB90
.long MB90
.long MB90
.long MB90
.long MB90
.long MB90
.long MB98
.long MB98
.long MB98
.long MB98
.long MB98
.long MB98
.long MB98
.long MB98
.long MBA0
.long MBA0
.long MBA0
.long MBA0
.long MBA0
.long MBA0
.long MBA0
.long MBA0
.long MBA8
.long MBA8
.long MBA8
.long MBA8
.long MBA8
.long MBA8
.long MBA8
.long MBA8
.long MBB0
.long MBB0
.long MBB0
.long MBB0
.long MBB0
.long MBB0
.long MBB0
.long MBB0
.long MBB8
.long MBB9
.long MBBA
.long MBBB
.long MBBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long MC00
.long MC00
.long MC00
.long MC00
.long MC00
.long MC00
.long MC00
.long MC00
.long MC08
.long MC08
.long MC08
.long MC08
.long MC08
.long MC08
.long MC08
.long MC08
.long MC10
.long MC10
.long MC10
.long MC10
.long MC10
.long MC10
.long MC10
.long MC10
.long MC18
.long MC18
.long MC18
.long MC18
.long MC18
.long MC18
.long MC18
.long MC18
.long MC20
.long MC20
.long MC20
.long MC20
.long MC20
.long MC20
.long MC20
.long MC20
.long MC28
.long MC28
.long MC28
.long MC28
.long MC28
.long MC28
.long MC28
.long MC28
.long MC30
.long MC30
.long MC30
.long MC30
.long MC30
.long MC30
.long MC30
.long MC30
.long MC38
.long MC39
.long MC3A
.long MC3B
.long MC3C
.long r_illegal
.long r_illegal
.long r_illegal
.long MC40
.long MC40
.long MC40
.long MC40
.long MC40
.long MC40
.long MC40
.long MC40
.long MC48
.long MC48
.long MC48
.long MC48
.long MC48
.long MC48
.long MC48
.long MC48
.long MC50
.long MC50
.long MC50
.long MC50
.long MC50
.long MC50
.long MC50
.long MC50
.long MC58
.long MC58
.long MC58
.long MC58
.long MC58
.long MC58
.long MC58
.long MC58
.long MC60
.long MC60
.long MC60
.long MC60
.long MC60
.long MC60
.long MC60
.long MC60
.long MC68
.long MC68
.long MC68
.long MC68
.long MC68
.long MC68
.long MC68
.long MC68
.long MC70
.long MC70
.long MC70
.long MC70
.long MC70
.long MC70
.long MC70
.long MC70
.long MC78
.long MC79
.long MC7A
.long MC7B
.long MC7C
.long r_illegal
.long r_illegal
.long r_illegal
.long MC80
.long MC80
.long MC80
.long MC80
.long MC80
.long MC80
.long MC80
.long MC80
.long MC88
.long MC88
.long MC88
.long MC88
.long MC88
.long MC88
.long MC88
.long MC88
.long MC90
.long MC90
.long MC90
.long MC90
.long MC90
.long MC90
.long MC90
.long MC90
.long MC98
.long MC98
.long MC98
.long MC98
.long MC98
.long MC98
.long MC98
.long MC98
.long MCA0
.long MCA0
.long MCA0
.long MCA0
.long MCA0
.long MCA0
.long MCA0
.long MCA0
.long MCA8
.long MCA8
.long MCA8
.long MCA8
.long MCA8
.long MCA8
.long MCA8
.long MCA8
.long MCB0
.long MCB0
.long MCB0
.long MCB0
.long MCB0
.long MCB0
.long MCB0
.long MCB0
.long MCB8
.long MCB9
.long MCBA
.long MCBB
.long MCBC
.long r_illegal
.long r_illegal
.long r_illegal
.long MCC0
.long MCC0
.long MCC0
.long MCC0
.long MCC0
.long MCC0
.long MCC0
.long MCC0
.long MCC8
.long MCC8
.long MCC8
.long MCC8
.long MCC8
.long MCC8
.long MCC8
.long MCC8
.long MCD0
.long MCD0
.long MCD0
.long MCD0
.long MCD0
.long MCD0
.long MCD0
.long MCD0
.long MCD8
.long MCD8
.long MCD8
.long MCD8
.long MCD8
.long MCD8
.long MCD8
.long MCD8
.long MCE0
.long MCE0
.long MCE0
.long MCE0
.long MCE0
.long MCE0
.long MCE0
.long MCE0
.long MCE8
.long MCE8
.long MCE8
.long MCE8
.long MCE8
.long MCE8
.long MCE8
.long MCE8
.long MCF0
.long MCF0
.long MCF0
.long MCF0
.long MCF0
.long MCF0
.long MCF0
.long MCF0
.long MCF8
.long MCF9
.long MCFA
.long MCFB
.long MCFC
.long r_illegal
.long r_illegal
.long r_illegal
.long MD00
.long MD00
.long MD00
.long MD00
.long MD00
.long MD00
.long MD00
.long MD00
.long MD08
.long MD08
.long MD08
.long MD08
.long MD08
.long MD08
.long MD08
.long MD08
.long MD10
.long MD10
.long MD10
.long MD10
.long MD10
.long MD10
.long MD10
.long MD10
.long MD18
.long MD18
.long MD18
.long MD18
.long MD18
.long MD18
.long MD18
.long MD18
.long MD20
.long MD20
.long MD20
.long MD20
.long MD20
.long MD20
.long MD20
.long MD20
.long MD28
.long MD28
.long MD28
.long MD28
.long MD28
.long MD28
.long MD28
.long MD28
.long MD30
.long MD30
.long MD30
.long MD30
.long MD30
.long MD30
.long MD30
.long MD30
.long MD38
.long MD39
.long MD3A
.long MD3B
.long MD3C
.long r_illegal
.long r_illegal
.long r_illegal
.long MD40
.long MD40
.long MD40
.long MD40
.long MD40
.long MD40
.long MD40
.long MD40
.long MD48
.long MD48
.long MD48
.long MD48
.long MD48
.long MD48
.long MD48
.long MD48
.long MD50
.long MD50
.long MD50
.long MD50
.long MD50
.long MD50
.long MD50
.long MD50
.long MD58
.long MD58
.long MD58
.long MD58
.long MD58
.long MD58
.long MD58
.long MD58
.long MD60
.long MD60
.long MD60
.long MD60
.long MD60
.long MD60
.long MD60
.long MD60
.long MD68
.long MD68
.long MD68
.long MD68
.long MD68
.long MD68
.long MD68
.long MD68
.long MD70
.long MD70
.long MD70
.long MD70
.long MD70
.long MD70
.long MD70
.long MD70
.long MD78
.long MD79
.long MD7A
.long MD7B
.long MD7C
.long r_illegal
.long r_illegal
.long r_illegal
.long MD80
.long MD80
.long MD80
.long MD80
.long MD80
.long MD80
.long MD80
.long MD80
.long MD88
.long MD88
.long MD88
.long MD88
.long MD88
.long MD88
.long MD88
.long MD88
.long MD90
.long MD90
.long MD90
.long MD90
.long MD90
.long MD90
.long MD90
.long MD90
.long MD98
.long MD98
.long MD98
.long MD98
.long MD98
.long MD98
.long MD98
.long MD98
.long MDA0
.long MDA0
.long MDA0
.long MDA0
.long MDA0
.long MDA0
.long MDA0
.long MDA0
.long MDA8
.long MDA8
.long MDA8
.long MDA8
.long MDA8
.long MDA8
.long MDA8
.long MDA8
.long MDB0
.long MDB0
.long MDB0
.long MDB0
.long MDB0
.long MDB0
.long MDB0
.long MDB0
.long MDB8
.long MDB9
.long MDBA
.long MDBB
.long MDBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long ME00
.long ME00
.long ME00
.long ME00
.long ME00
.long ME00
.long ME00
.long ME00
.long ME08
.long ME08
.long ME08
.long ME08
.long ME08
.long ME08
.long ME08
.long ME08
.long ME10
.long ME10
.long ME10
.long ME10
.long ME10
.long ME10
.long ME10
.long ME10
.long ME18
.long ME18
.long ME18
.long ME18
.long ME18
.long ME18
.long ME18
.long ME18
.long ME20
.long ME20
.long ME20
.long ME20
.long ME20
.long ME20
.long ME20
.long ME20
.long ME28
.long ME28
.long ME28
.long ME28
.long ME28
.long ME28
.long ME28
.long ME28
.long ME30
.long ME30
.long ME30
.long ME30
.long ME30
.long ME30
.long ME30
.long ME30
.long ME38
.long ME39
.long ME3A
.long ME3B
.long ME3C
.long r_illegal
.long r_illegal
.long r_illegal
.long ME40
.long ME40
.long ME40
.long ME40
.long ME40
.long ME40
.long ME40
.long ME40
.long ME48
.long ME48
.long ME48
.long ME48
.long ME48
.long ME48
.long ME48
.long ME48
.long ME50
.long ME50
.long ME50
.long ME50
.long ME50
.long ME50
.long ME50
.long ME50
.long ME58
.long ME58
.long ME58
.long ME58
.long ME58
.long ME58
.long ME58
.long ME58
.long ME60
.long ME60
.long ME60
.long ME60
.long ME60
.long ME60
.long ME60
.long ME60
.long ME68
.long ME68
.long ME68
.long ME68
.long ME68
.long ME68
.long ME68
.long ME68
.long ME70
.long ME70
.long ME70
.long ME70
.long ME70
.long ME70
.long ME70
.long ME70
.long ME78
.long ME79
.long ME7A
.long ME7B
.long ME7C
.long r_illegal
.long r_illegal
.long r_illegal
.long ME80
.long ME80
.long ME80
.long ME80
.long ME80
.long ME80
.long ME80
.long ME80
.long ME88
.long ME88
.long ME88
.long ME88
.long ME88
.long ME88
.long ME88
.long ME88
.long ME90
.long ME90
.long ME90
.long ME90
.long ME90
.long ME90
.long ME90
.long ME90
.long ME98
.long ME98
.long ME98
.long ME98
.long ME98
.long ME98
.long ME98
.long ME98
.long MEA0
.long MEA0
.long MEA0
.long MEA0
.long MEA0
.long MEA0
.long MEA0
.long MEA0
.long MEA8
.long MEA8
.long MEA8
.long MEA8
.long MEA8
.long MEA8
.long MEA8
.long MEA8
.long MEB0
.long MEB0
.long MEB0
.long MEB0
.long MEB0
.long MEB0
.long MEB0
.long MEB0
.long MEB8
.long MEB9
.long MEBA
.long MEBB
.long MEBC
.long r_illegal
.long r_illegal
.long r_illegal
.long MEC0
.long MEC0
.long MEC0
.long MEC0
.long MEC0
.long MEC0
.long MEC0
.long MEC0
.long MEC8
.long MEC8
.long MEC8
.long MEC8
.long MEC8
.long MEC8
.long MEC8
.long MEC8
.long MED0
.long MED0
.long MED0
.long MED0
.long MED0
.long MED0
.long MED0
.long MED0
.long MED8
.long MED8
.long MED8
.long MED8
.long MED8
.long MED8
.long MED8
.long MED8
.long MEE0
.long MEE0
.long MEE0
.long MEE0
.long MEE0
.long MEE0
.long MEE0
.long MEE0
.long MEE8
.long MEE8
.long MEE8
.long MEE8
.long MEE8
.long MEE8
.long MEE8
.long MEE8
.long MEF0
.long MEF0
.long MEF0
.long MEF0
.long MEF0
.long MEF0
.long MEF0
.long MEF0
.long MEF8
.long MEF9
.long MEFA
.long MEFB
.long MEFC
.long r_illegal
.long r_illegal
.long r_illegal
.long MF00
.long MF00
.long MF00
.long MF00
.long MF00
.long MF00
.long MF00
.long MF00
.long MF08
.long MF08
.long MF08
.long MF08
.long MF08
.long MF08
.long MF08
.long MF08
.long MF10
.long MF10
.long MF10
.long MF10
.long MF10
.long MF10
.long MF10
.long MF10
.long MF18
.long MF18
.long MF18
.long MF18
.long MF18
.long MF18
.long MF18
.long MF18
.long MF20
.long MF20
.long MF20
.long MF20
.long MF20
.long MF20
.long MF20
.long MF20
.long MF28
.long MF28
.long MF28
.long MF28
.long MF28
.long MF28
.long MF28
.long MF28
.long MF30
.long MF30
.long MF30
.long MF30
.long MF30
.long MF30
.long MF30
.long MF30
.long MF38
.long MF39
.long MF3A
.long MF3B
.long MF3C
.long r_illegal
.long r_illegal
.long r_illegal
.long MF40
.long MF40
.long MF40
.long MF40
.long MF40
.long MF40
.long MF40
.long MF40
.long MF48
.long MF48
.long MF48
.long MF48
.long MF48
.long MF48
.long MF48
.long MF48
.long MF50
.long MF50
.long MF50
.long MF50
.long MF50
.long MF50
.long MF50
.long MF50
.long MF58
.long MF58
.long MF58
.long MF58
.long MF58
.long MF58
.long MF58
.long MF58
.long MF60
.long MF60
.long MF60
.long MF60
.long MF60
.long MF60
.long MF60
.long MF60
.long MF68
.long MF68
.long MF68
.long MF68
.long MF68
.long MF68
.long MF68
.long MF68
.long MF70
.long MF70
.long MF70
.long MF70
.long MF70
.long MF70
.long MF70
.long MF70
.long MF78
.long MF79
.long MF7A
.long MF7B
.long MF7C
.long r_illegal
.long r_illegal
.long r_illegal
.long MF80
.long MF80
.long MF80
.long MF80
.long MF80
.long MF80
.long MF80
.long MF80
.long MF88
.long MF88
.long MF88
.long MF88
.long MF88
.long MF88
.long MF88
.long MF88
.long MF90
.long MF90
.long MF90
.long MF90
.long MF90
.long MF90
.long MF90
.long MF90
.long MF98
.long MF98
.long MF98
.long MF98
.long MF98
.long MF98
.long MF98
.long MF98
.long MFA0
.long MFA0
.long MFA0
.long MFA0
.long MFA0
.long MFA0
.long MFA0
.long MFA0
.long MFA8
.long MFA8
.long MFA8
.long MFA8
.long MFA8
.long MFA8
.long MFA8
.long MFA8
.long MFB0
.long MFB0
.long MFB0
.long MFB0
.long MFB0
.long MFB0
.long MFB0
.long MFB0
.long MFB8
.long MFB9
.long MFBA
.long MFBB
.long MFBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long N000
.long N000
.long N000
.long N000
.long N000
.long N000
.long N000
.long N000
.long N008
.long N008
.long N008
.long N008
.long N008
.long N008
.long N008
.long N008
.long N010
.long N010
.long N010
.long N010
.long N010
.long N010
.long N010
.long N010
.long N018
.long N018
.long N018
.long N018
.long N018
.long N018
.long N018
.long N018
.long N020
.long N020
.long N020
.long N020
.long N020
.long N020
.long N020
.long N020
.long N028
.long N028
.long N028
.long N028
.long N028
.long N028
.long N028
.long N028
.long N030
.long N030
.long N030
.long N030
.long N030
.long N030
.long N030
.long N030
.long N038
.long N039
.long N03A
.long N03B
.long N03C
.long r_illegal
.long r_illegal
.long r_illegal
.long N040
.long N040
.long N040
.long N040
.long N040
.long N040
.long N040
.long N040
.long N048
.long N048
.long N048
.long N048
.long N048
.long N048
.long N048
.long N048
.long N050
.long N050
.long N050
.long N050
.long N050
.long N050
.long N050
.long N050
.long N058
.long N058
.long N058
.long N058
.long N058
.long N058
.long N058
.long N058
.long N060
.long N060
.long N060
.long N060
.long N060
.long N060
.long N060
.long N060
.long N068
.long N068
.long N068
.long N068
.long N068
.long N068
.long N068
.long N068
.long N070
.long N070
.long N070
.long N070
.long N070
.long N070
.long N070
.long N070
.long N078
.long N079
.long N07A
.long N07B
.long N07C
.long r_illegal
.long r_illegal
.long r_illegal
.long N080
.long N080
.long N080
.long N080
.long N080
.long N080
.long N080
.long N080
.long N088
.long N088
.long N088
.long N088
.long N088
.long N088
.long N088
.long N088
.long N090
.long N090
.long N090
.long N090
.long N090
.long N090
.long N090
.long N090
.long N098
.long N098
.long N098
.long N098
.long N098
.long N098
.long N098
.long N098
.long N0A0
.long N0A0
.long N0A0
.long N0A0
.long N0A0
.long N0A0
.long N0A0
.long N0A0
.long N0A8
.long N0A8
.long N0A8
.long N0A8
.long N0A8
.long N0A8
.long N0A8
.long N0A8
.long N0B0
.long N0B0
.long N0B0
.long N0B0
.long N0B0
.long N0B0
.long N0B0
.long N0B0
.long N0B8
.long N0B9
.long N0BA
.long N0BB
.long N0BC
.long r_illegal
.long r_illegal
.long r_illegal
.long N0C0
.long N0C0
.long N0C0
.long N0C0
.long N0C0
.long N0C0
.long N0C0
.long N0C0
.long N0C8
.long N0C8
.long N0C8
.long N0C8
.long N0C8
.long N0C8
.long N0C8
.long N0C8
.long N0D0
.long N0D0
.long N0D0
.long N0D0
.long N0D0
.long N0D0
.long N0D0
.long N0D0
.long N0D8
.long N0D8
.long N0D8
.long N0D8
.long N0D8
.long N0D8
.long N0D8
.long N0D8
.long N0E0
.long N0E0
.long N0E0
.long N0E0
.long N0E0
.long N0E0
.long N0E0
.long N0E0
.long N0E8
.long N0E8
.long N0E8
.long N0E8
.long N0E8
.long N0E8
.long N0E8
.long N0E8
.long N0F0
.long N0F0
.long N0F0
.long N0F0
.long N0F0
.long N0F0
.long N0F0
.long N0F0
.long N0F8
.long N0F9
.long N0FA
.long N0FB
.long N0FC
.long r_illegal
.long r_illegal
.long r_illegal
.long N100
.long N100
.long N100
.long N100
.long N100
.long N100
.long N100
.long N100
.long N108
.long N108
.long N108
.long N108
.long N108
.long N108
.long N108
.long N108
.long N110
.long N110
.long N110
.long N110
.long N110
.long N110
.long N110
.long N110
.long N118
.long N118
.long N118
.long N118
.long N118
.long N118
.long N118
.long N118
.long N120
.long N120
.long N120
.long N120
.long N120
.long N120
.long N120
.long N120
.long N128
.long N128
.long N128
.long N128
.long N128
.long N128
.long N128
.long N128
.long N130
.long N130
.long N130
.long N130
.long N130
.long N130
.long N130
.long N130
.long N138
.long N139
.long N13A
.long N13B
.long N13C
.long r_illegal
.long r_illegal
.long r_illegal
.long N140
.long N140
.long N140
.long N140
.long N140
.long N140
.long N140
.long N140
.long N148
.long N148
.long N148
.long N148
.long N148
.long N148
.long N148
.long N148
.long N150
.long N150
.long N150
.long N150
.long N150
.long N150
.long N150
.long N150
.long N158
.long N158
.long N158
.long N158
.long N158
.long N158
.long N158
.long N158
.long N160
.long N160
.long N160
.long N160
.long N160
.long N160
.long N160
.long N160
.long N168
.long N168
.long N168
.long N168
.long N168
.long N168
.long N168
.long N168
.long N170
.long N170
.long N170
.long N170
.long N170
.long N170
.long N170
.long N170
.long N178
.long N179
.long N17A
.long N17B
.long N17C
.long r_illegal
.long r_illegal
.long r_illegal
.long N180
.long N180
.long N180
.long N180
.long N180
.long N180
.long N180
.long N180
.long N188
.long N188
.long N188
.long N188
.long N188
.long N188
.long N188
.long N188
.long N190
.long N190
.long N190
.long N190
.long N190
.long N190
.long N190
.long N190
.long N198
.long N198
.long N198
.long N198
.long N198
.long N198
.long N198
.long N198
.long N1A0
.long N1A0
.long N1A0
.long N1A0
.long N1A0
.long N1A0
.long N1A0
.long N1A0
.long N1A8
.long N1A8
.long N1A8
.long N1A8
.long N1A8
.long N1A8
.long N1A8
.long N1A8
.long N1B0
.long N1B0
.long N1B0
.long N1B0
.long N1B0
.long N1B0
.long N1B0
.long N1B0
.long N1B8
.long N1B9
.long N1BA
.long N1BB
.long N1BC
.long r_illegal
.long r_illegal
.long r_illegal
.long N1C0
.long N1C0
.long N1C0
.long N1C0
.long N1C0
.long N1C0
.long N1C0
.long N1C0
.long N1C8
.long N1C8
.long N1C8
.long N1C8
.long N1C8
.long N1C8
.long N1C8
.long N1C8
.long N1D0
.long N1D0
.long N1D0
.long N1D0
.long N1D0
.long N1D0
.long N1D0
.long N1D0
.long N1D8
.long N1D8
.long N1D8
.long N1D8
.long N1D8
.long N1D8
.long N1D8
.long N1D8
.long N1E0
.long N1E0
.long N1E0
.long N1E0
.long N1E0
.long N1E0
.long N1E0
.long N1E0
.long N1E8
.long N1E8
.long N1E8
.long N1E8
.long N1E8
.long N1E8
.long N1E8
.long N1E8
.long N1F0
.long N1F0
.long N1F0
.long N1F0
.long N1F0
.long N1F0
.long N1F0
.long N1F0
.long N1F8
.long N1F9
.long N1FA
.long N1FB
.long N1FC
.long r_illegal
.long r_illegal
.long r_illegal
.long N200
.long N200
.long N200
.long N200
.long N200
.long N200
.long N200
.long N200
.long N208
.long N208
.long N208
.long N208
.long N208
.long N208
.long N208
.long N208
.long N210
.long N210
.long N210
.long N210
.long N210
.long N210
.long N210
.long N210
.long N218
.long N218
.long N218
.long N218
.long N218
.long N218
.long N218
.long N218
.long N220
.long N220
.long N220
.long N220
.long N220
.long N220
.long N220
.long N220
.long N228
.long N228
.long N228
.long N228
.long N228
.long N228
.long N228
.long N228
.long N230
.long N230
.long N230
.long N230
.long N230
.long N230
.long N230
.long N230
.long N238
.long N239
.long N23A
.long N23B
.long N23C
.long r_illegal
.long r_illegal
.long r_illegal
.long N240
.long N240
.long N240
.long N240
.long N240
.long N240
.long N240
.long N240
.long N248
.long N248
.long N248
.long N248
.long N248
.long N248
.long N248
.long N248
.long N250
.long N250
.long N250
.long N250
.long N250
.long N250
.long N250
.long N250
.long N258
.long N258
.long N258
.long N258
.long N258
.long N258
.long N258
.long N258
.long N260
.long N260
.long N260
.long N260
.long N260
.long N260
.long N260
.long N260
.long N268
.long N268
.long N268
.long N268
.long N268
.long N268
.long N268
.long N268
.long N270
.long N270
.long N270
.long N270
.long N270
.long N270
.long N270
.long N270
.long N278
.long N279
.long N27A
.long N27B
.long N27C
.long r_illegal
.long r_illegal
.long r_illegal
.long N280
.long N280
.long N280
.long N280
.long N280
.long N280
.long N280
.long N280
.long N288
.long N288
.long N288
.long N288
.long N288
.long N288
.long N288
.long N288
.long N290
.long N290
.long N290
.long N290
.long N290
.long N290
.long N290
.long N290
.long N298
.long N298
.long N298
.long N298
.long N298
.long N298
.long N298
.long N298
.long N2A0
.long N2A0
.long N2A0
.long N2A0
.long N2A0
.long N2A0
.long N2A0
.long N2A0
.long N2A8
.long N2A8
.long N2A8
.long N2A8
.long N2A8
.long N2A8
.long N2A8
.long N2A8
.long N2B0
.long N2B0
.long N2B0
.long N2B0
.long N2B0
.long N2B0
.long N2B0
.long N2B0
.long N2B8
.long N2B9
.long N2BA
.long N2BB
.long N2BC
.long r_illegal
.long r_illegal
.long r_illegal
.long N2C0
.long N2C0
.long N2C0
.long N2C0
.long N2C0
.long N2C0
.long N2C0
.long N2C0
.long N2C8
.long N2C8
.long N2C8
.long N2C8
.long N2C8
.long N2C8
.long N2C8
.long N2C8
.long N2D0
.long N2D0
.long N2D0
.long N2D0
.long N2D0
.long N2D0
.long N2D0
.long N2D0
.long N2D8
.long N2D8
.long N2D8
.long N2D8
.long N2D8
.long N2D8
.long N2D8
.long N2D8
.long N2E0
.long N2E0
.long N2E0
.long N2E0
.long N2E0
.long N2E0
.long N2E0
.long N2E0
.long N2E8
.long N2E8
.long N2E8
.long N2E8
.long N2E8
.long N2E8
.long N2E8
.long N2E8
.long N2F0
.long N2F0
.long N2F0
.long N2F0
.long N2F0
.long N2F0
.long N2F0
.long N2F0
.long N2F8
.long N2F9
.long N2FA
.long N2FB
.long N2FC
.long r_illegal
.long r_illegal
.long r_illegal
.long N300
.long N300
.long N300
.long N300
.long N300
.long N300
.long N300
.long N300
.long N308
.long N308
.long N308
.long N308
.long N308
.long N308
.long N308
.long N308
.long N310
.long N310
.long N310
.long N310
.long N310
.long N310
.long N310
.long N310
.long N318
.long N318
.long N318
.long N318
.long N318
.long N318
.long N318
.long N318
.long N320
.long N320
.long N320
.long N320
.long N320
.long N320
.long N320
.long N320
.long N328
.long N328
.long N328
.long N328
.long N328
.long N328
.long N328
.long N328
.long N330
.long N330
.long N330
.long N330
.long N330
.long N330
.long N330
.long N330
.long N338
.long N339
.long N33A
.long N33B
.long N33C
.long r_illegal
.long r_illegal
.long r_illegal
.long N340
.long N340
.long N340
.long N340
.long N340
.long N340
.long N340
.long N340
.long N348
.long N348
.long N348
.long N348
.long N348
.long N348
.long N348
.long N348
.long N350
.long N350
.long N350
.long N350
.long N350
.long N350
.long N350
.long N350
.long N358
.long N358
.long N358
.long N358
.long N358
.long N358
.long N358
.long N358
.long N360
.long N360
.long N360
.long N360
.long N360
.long N360
.long N360
.long N360
.long N368
.long N368
.long N368
.long N368
.long N368
.long N368
.long N368
.long N368
.long N370
.long N370
.long N370
.long N370
.long N370
.long N370
.long N370
.long N370
.long N378
.long N379
.long N37A
.long N37B
.long N37C
.long r_illegal
.long r_illegal
.long r_illegal
.long N380
.long N380
.long N380
.long N380
.long N380
.long N380
.long N380
.long N380
.long N388
.long N388
.long N388
.long N388
.long N388
.long N388
.long N388
.long N388
.long N390
.long N390
.long N390
.long N390
.long N390
.long N390
.long N390
.long N390
.long N398
.long N398
.long N398
.long N398
.long N398
.long N398
.long N398
.long N398
.long N3A0
.long N3A0
.long N3A0
.long N3A0
.long N3A0
.long N3A0
.long N3A0
.long N3A0
.long N3A8
.long N3A8
.long N3A8
.long N3A8
.long N3A8
.long N3A8
.long N3A8
.long N3A8
.long N3B0
.long N3B0
.long N3B0
.long N3B0
.long N3B0
.long N3B0
.long N3B0
.long N3B0
.long N3B8
.long N3B9
.long N3BA
.long N3BB
.long N3BC
.long r_illegal
.long r_illegal
.long r_illegal
.long N3C0
.long N3C0
.long N3C0
.long N3C0
.long N3C0
.long N3C0
.long N3C0
.long N3C0
.long N3C8
.long N3C8
.long N3C8
.long N3C8
.long N3C8
.long N3C8
.long N3C8
.long N3C8
.long N3D0
.long N3D0
.long N3D0
.long N3D0
.long N3D0
.long N3D0
.long N3D0
.long N3D0
.long N3D8
.long N3D8
.long N3D8
.long N3D8
.long N3D8
.long N3D8
.long N3D8
.long N3D8
.long N3E0
.long N3E0
.long N3E0
.long N3E0
.long N3E0
.long N3E0
.long N3E0
.long N3E0
.long N3E8
.long N3E8
.long N3E8
.long N3E8
.long N3E8
.long N3E8
.long N3E8
.long N3E8
.long N3F0
.long N3F0
.long N3F0
.long N3F0
.long N3F0
.long N3F0
.long N3F0
.long N3F0
.long N3F8
.long N3F9
.long N3FA
.long N3FB
.long N3FC
.long r_illegal
.long r_illegal
.long r_illegal
.long N400
.long N400
.long N400
.long N400
.long N400
.long N400
.long N400
.long N400
.long N408
.long N408
.long N408
.long N408
.long N408
.long N408
.long N408
.long N408
.long N410
.long N410
.long N410
.long N410
.long N410
.long N410
.long N410
.long N410
.long N418
.long N418
.long N418
.long N418
.long N418
.long N418
.long N418
.long N418
.long N420
.long N420
.long N420
.long N420
.long N420
.long N420
.long N420
.long N420
.long N428
.long N428
.long N428
.long N428
.long N428
.long N428
.long N428
.long N428
.long N430
.long N430
.long N430
.long N430
.long N430
.long N430
.long N430
.long N430
.long N438
.long N439
.long N43A
.long N43B
.long N43C
.long r_illegal
.long r_illegal
.long r_illegal
.long N440
.long N440
.long N440
.long N440
.long N440
.long N440
.long N440
.long N440
.long N448
.long N448
.long N448
.long N448
.long N448
.long N448
.long N448
.long N448
.long N450
.long N450
.long N450
.long N450
.long N450
.long N450
.long N450
.long N450
.long N458
.long N458
.long N458
.long N458
.long N458
.long N458
.long N458
.long N458
.long N460
.long N460
.long N460
.long N460
.long N460
.long N460
.long N460
.long N460
.long N468
.long N468
.long N468
.long N468
.long N468
.long N468
.long N468
.long N468
.long N470
.long N470
.long N470
.long N470
.long N470
.long N470
.long N470
.long N470
.long N478
.long N479
.long N47A
.long N47B
.long N47C
.long r_illegal
.long r_illegal
.long r_illegal
.long N480
.long N480
.long N480
.long N480
.long N480
.long N480
.long N480
.long N480
.long N488
.long N488
.long N488
.long N488
.long N488
.long N488
.long N488
.long N488
.long N490
.long N490
.long N490
.long N490
.long N490
.long N490
.long N490
.long N490
.long N498
.long N498
.long N498
.long N498
.long N498
.long N498
.long N498
.long N498
.long N4A0
.long N4A0
.long N4A0
.long N4A0
.long N4A0
.long N4A0
.long N4A0
.long N4A0
.long N4A8
.long N4A8
.long N4A8
.long N4A8
.long N4A8
.long N4A8
.long N4A8
.long N4A8
.long N4B0
.long N4B0
.long N4B0
.long N4B0
.long N4B0
.long N4B0
.long N4B0
.long N4B0
.long N4B8
.long N4B9
.long N4BA
.long N4BB
.long N4BC
.long r_illegal
.long r_illegal
.long r_illegal
.long N4C0
.long N4C0
.long N4C0
.long N4C0
.long N4C0
.long N4C0
.long N4C0
.long N4C0
.long N4C8
.long N4C8
.long N4C8
.long N4C8
.long N4C8
.long N4C8
.long N4C8
.long N4C8
.long N4D0
.long N4D0
.long N4D0
.long N4D0
.long N4D0
.long N4D0
.long N4D0
.long N4D0
.long N4D8
.long N4D8
.long N4D8
.long N4D8
.long N4D8
.long N4D8
.long N4D8
.long N4D8
.long N4E0
.long N4E0
.long N4E0
.long N4E0
.long N4E0
.long N4E0
.long N4E0
.long N4E0
.long N4E8
.long N4E8
.long N4E8
.long N4E8
.long N4E8
.long N4E8
.long N4E8
.long N4E8
.long N4F0
.long N4F0
.long N4F0
.long N4F0
.long N4F0
.long N4F0
.long N4F0
.long N4F0
.long N4F8
.long N4F9
.long N4FA
.long N4FB
.long N4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long N500
.long N500
.long N500
.long N500
.long N500
.long N500
.long N500
.long N500
.long N508
.long N508
.long N508
.long N508
.long N508
.long N508
.long N508
.long N508
.long N510
.long N510
.long N510
.long N510
.long N510
.long N510
.long N510
.long N510
.long N518
.long N518
.long N518
.long N518
.long N518
.long N518
.long N518
.long N518
.long N520
.long N520
.long N520
.long N520
.long N520
.long N520
.long N520
.long N520
.long N528
.long N528
.long N528
.long N528
.long N528
.long N528
.long N528
.long N528
.long N530
.long N530
.long N530
.long N530
.long N530
.long N530
.long N530
.long N530
.long N538
.long N539
.long N53A
.long N53B
.long N53C
.long r_illegal
.long r_illegal
.long r_illegal
.long N540
.long N540
.long N540
.long N540
.long N540
.long N540
.long N540
.long N540
.long N548
.long N548
.long N548
.long N548
.long N548
.long N548
.long N548
.long N548
.long N550
.long N550
.long N550
.long N550
.long N550
.long N550
.long N550
.long N550
.long N558
.long N558
.long N558
.long N558
.long N558
.long N558
.long N558
.long N558
.long N560
.long N560
.long N560
.long N560
.long N560
.long N560
.long N560
.long N560
.long N568
.long N568
.long N568
.long N568
.long N568
.long N568
.long N568
.long N568
.long N570
.long N570
.long N570
.long N570
.long N570
.long N570
.long N570
.long N570
.long N578
.long N579
.long N57A
.long N57B
.long N57C
.long r_illegal
.long r_illegal
.long r_illegal
.long N580
.long N580
.long N580
.long N580
.long N580
.long N580
.long N580
.long N580
.long N588
.long N588
.long N588
.long N588
.long N588
.long N588
.long N588
.long N588
.long N590
.long N590
.long N590
.long N590
.long N590
.long N590
.long N590
.long N590
.long N598
.long N598
.long N598
.long N598
.long N598
.long N598
.long N598
.long N598
.long N5A0
.long N5A0
.long N5A0
.long N5A0
.long N5A0
.long N5A0
.long N5A0
.long N5A0
.long N5A8
.long N5A8
.long N5A8
.long N5A8
.long N5A8
.long N5A8
.long N5A8
.long N5A8
.long N5B0
.long N5B0
.long N5B0
.long N5B0
.long N5B0
.long N5B0
.long N5B0
.long N5B0
.long N5B8
.long N5B9
.long N5BA
.long N5BB
.long N5BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long N600
.long N600
.long N600
.long N600
.long N600
.long N600
.long N600
.long N600
.long N608
.long N608
.long N608
.long N608
.long N608
.long N608
.long N608
.long N608
.long N610
.long N610
.long N610
.long N610
.long N610
.long N610
.long N610
.long N610
.long N618
.long N618
.long N618
.long N618
.long N618
.long N618
.long N618
.long N618
.long N620
.long N620
.long N620
.long N620
.long N620
.long N620
.long N620
.long N620
.long N628
.long N628
.long N628
.long N628
.long N628
.long N628
.long N628
.long N628
.long N630
.long N630
.long N630
.long N630
.long N630
.long N630
.long N630
.long N630
.long N638
.long N639
.long N63A
.long N63B
.long N63C
.long r_illegal
.long r_illegal
.long r_illegal
.long N640
.long N640
.long N640
.long N640
.long N640
.long N640
.long N640
.long N640
.long N648
.long N648
.long N648
.long N648
.long N648
.long N648
.long N648
.long N648
.long N650
.long N650
.long N650
.long N650
.long N650
.long N650
.long N650
.long N650
.long N658
.long N658
.long N658
.long N658
.long N658
.long N658
.long N658
.long N658
.long N660
.long N660
.long N660
.long N660
.long N660
.long N660
.long N660
.long N660
.long N668
.long N668
.long N668
.long N668
.long N668
.long N668
.long N668
.long N668
.long N670
.long N670
.long N670
.long N670
.long N670
.long N670
.long N670
.long N670
.long N678
.long N679
.long N67A
.long N67B
.long N67C
.long r_illegal
.long r_illegal
.long r_illegal
.long N680
.long N680
.long N680
.long N680
.long N680
.long N680
.long N680
.long N680
.long N688
.long N688
.long N688
.long N688
.long N688
.long N688
.long N688
.long N688
.long N690
.long N690
.long N690
.long N690
.long N690
.long N690
.long N690
.long N690
.long N698
.long N698
.long N698
.long N698
.long N698
.long N698
.long N698
.long N698
.long N6A0
.long N6A0
.long N6A0
.long N6A0
.long N6A0
.long N6A0
.long N6A0
.long N6A0
.long N6A8
.long N6A8
.long N6A8
.long N6A8
.long N6A8
.long N6A8
.long N6A8
.long N6A8
.long N6B0
.long N6B0
.long N6B0
.long N6B0
.long N6B0
.long N6B0
.long N6B0
.long N6B0
.long N6B8
.long N6B9
.long N6BA
.long N6BB
.long N6BC
.long r_illegal
.long r_illegal
.long r_illegal
.long N6C0
.long N6C0
.long N6C0
.long N6C0
.long N6C0
.long N6C0
.long N6C0
.long N6C0
.long N6C8
.long N6C8
.long N6C8
.long N6C8
.long N6C8
.long N6C8
.long N6C8
.long N6C8
.long N6D0
.long N6D0
.long N6D0
.long N6D0
.long N6D0
.long N6D0
.long N6D0
.long N6D0
.long N6D8
.long N6D8
.long N6D8
.long N6D8
.long N6D8
.long N6D8
.long N6D8
.long N6D8
.long N6E0
.long N6E0
.long N6E0
.long N6E0
.long N6E0
.long N6E0
.long N6E0
.long N6E0
.long N6E8
.long N6E8
.long N6E8
.long N6E8
.long N6E8
.long N6E8
.long N6E8
.long N6E8
.long N6F0
.long N6F0
.long N6F0
.long N6F0
.long N6F0
.long N6F0
.long N6F0
.long N6F0
.long N6F8
.long N6F9
.long N6FA
.long N6FB
.long N6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long N700
.long N700
.long N700
.long N700
.long N700
.long N700
.long N700
.long N700
.long N708
.long N708
.long N708
.long N708
.long N708
.long N708
.long N708
.long N708
.long N710
.long N710
.long N710
.long N710
.long N710
.long N710
.long N710
.long N710
.long N718
.long N718
.long N718
.long N718
.long N718
.long N718
.long N718
.long N718
.long N720
.long N720
.long N720
.long N720
.long N720
.long N720
.long N720
.long N720
.long N728
.long N728
.long N728
.long N728
.long N728
.long N728
.long N728
.long N728
.long N730
.long N730
.long N730
.long N730
.long N730
.long N730
.long N730
.long N730
.long N738
.long N739
.long N73A
.long N73B
.long N73C
.long r_illegal
.long r_illegal
.long r_illegal
.long N740
.long N740
.long N740
.long N740
.long N740
.long N740
.long N740
.long N740
.long N748
.long N748
.long N748
.long N748
.long N748
.long N748
.long N748
.long N748
.long N750
.long N750
.long N750
.long N750
.long N750
.long N750
.long N750
.long N750
.long N758
.long N758
.long N758
.long N758
.long N758
.long N758
.long N758
.long N758
.long N760
.long N760
.long N760
.long N760
.long N760
.long N760
.long N760
.long N760
.long N768
.long N768
.long N768
.long N768
.long N768
.long N768
.long N768
.long N768
.long N770
.long N770
.long N770
.long N770
.long N770
.long N770
.long N770
.long N770
.long N778
.long N779
.long N77A
.long N77B
.long N77C
.long r_illegal
.long r_illegal
.long r_illegal
.long N780
.long N780
.long N780
.long N780
.long N780
.long N780
.long N780
.long N780
.long N788
.long N788
.long N788
.long N788
.long N788
.long N788
.long N788
.long N788
.long N790
.long N790
.long N790
.long N790
.long N790
.long N790
.long N790
.long N790
.long N798
.long N798
.long N798
.long N798
.long N798
.long N798
.long N798
.long N798
.long N7A0
.long N7A0
.long N7A0
.long N7A0
.long N7A0
.long N7A0
.long N7A0
.long N7A0
.long N7A8
.long N7A8
.long N7A8
.long N7A8
.long N7A8
.long N7A8
.long N7A8
.long N7A8
.long N7B0
.long N7B0
.long N7B0
.long N7B0
.long N7B0
.long N7B0
.long N7B0
.long N7B0
.long N7B8
.long N7B9
.long N7BA
.long N7BB
.long N7BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long N800
.long N800
.long N800
.long N800
.long N800
.long N800
.long N800
.long N800
.long N808
.long N808
.long N808
.long N808
.long N808
.long N808
.long N808
.long N808
.long N810
.long N810
.long N810
.long N810
.long N810
.long N810
.long N810
.long N810
.long N818
.long N818
.long N818
.long N818
.long N818
.long N818
.long N818
.long N818
.long N820
.long N820
.long N820
.long N820
.long N820
.long N820
.long N820
.long N820
.long N828
.long N828
.long N828
.long N828
.long N828
.long N828
.long N828
.long N828
.long N830
.long N830
.long N830
.long N830
.long N830
.long N830
.long N830
.long N830
.long N838
.long N839
.long N83A
.long N83B
.long N83C
.long r_illegal
.long r_illegal
.long r_illegal
.long N840
.long N840
.long N840
.long N840
.long N840
.long N840
.long N840
.long N840
.long N848
.long N848
.long N848
.long N848
.long N848
.long N848
.long N848
.long N848
.long N850
.long N850
.long N850
.long N850
.long N850
.long N850
.long N850
.long N850
.long N858
.long N858
.long N858
.long N858
.long N858
.long N858
.long N858
.long N858
.long N860
.long N860
.long N860
.long N860
.long N860
.long N860
.long N860
.long N860
.long N868
.long N868
.long N868
.long N868
.long N868
.long N868
.long N868
.long N868
.long N870
.long N870
.long N870
.long N870
.long N870
.long N870
.long N870
.long N870
.long N878
.long N879
.long N87A
.long N87B
.long N87C
.long r_illegal
.long r_illegal
.long r_illegal
.long N880
.long N880
.long N880
.long N880
.long N880
.long N880
.long N880
.long N880
.long N888
.long N888
.long N888
.long N888
.long N888
.long N888
.long N888
.long N888
.long N890
.long N890
.long N890
.long N890
.long N890
.long N890
.long N890
.long N890
.long N898
.long N898
.long N898
.long N898
.long N898
.long N898
.long N898
.long N898
.long N8A0
.long N8A0
.long N8A0
.long N8A0
.long N8A0
.long N8A0
.long N8A0
.long N8A0
.long N8A8
.long N8A8
.long N8A8
.long N8A8
.long N8A8
.long N8A8
.long N8A8
.long N8A8
.long N8B0
.long N8B0
.long N8B0
.long N8B0
.long N8B0
.long N8B0
.long N8B0
.long N8B0
.long N8B8
.long N8B9
.long N8BA
.long N8BB
.long N8BC
.long r_illegal
.long r_illegal
.long r_illegal
.long N8C0
.long N8C0
.long N8C0
.long N8C0
.long N8C0
.long N8C0
.long N8C0
.long N8C0
.long N8C8
.long N8C8
.long N8C8
.long N8C8
.long N8C8
.long N8C8
.long N8C8
.long N8C8
.long N8D0
.long N8D0
.long N8D0
.long N8D0
.long N8D0
.long N8D0
.long N8D0
.long N8D0
.long N8D8
.long N8D8
.long N8D8
.long N8D8
.long N8D8
.long N8D8
.long N8D8
.long N8D8
.long N8E0
.long N8E0
.long N8E0
.long N8E0
.long N8E0
.long N8E0
.long N8E0
.long N8E0
.long N8E8
.long N8E8
.long N8E8
.long N8E8
.long N8E8
.long N8E8
.long N8E8
.long N8E8
.long N8F0
.long N8F0
.long N8F0
.long N8F0
.long N8F0
.long N8F0
.long N8F0
.long N8F0
.long N8F8
.long N8F9
.long N8FA
.long N8FB
.long N8FC
.long r_illegal
.long r_illegal
.long r_illegal
.long N900
.long N900
.long N900
.long N900
.long N900
.long N900
.long N900
.long N900
.long N908
.long N908
.long N908
.long N908
.long N908
.long N908
.long N908
.long N908
.long N910
.long N910
.long N910
.long N910
.long N910
.long N910
.long N910
.long N910
.long N918
.long N918
.long N918
.long N918
.long N918
.long N918
.long N918
.long N918
.long N920
.long N920
.long N920
.long N920
.long N920
.long N920
.long N920
.long N920
.long N928
.long N928
.long N928
.long N928
.long N928
.long N928
.long N928
.long N928
.long N930
.long N930
.long N930
.long N930
.long N930
.long N930
.long N930
.long N930
.long N938
.long N939
.long N93A
.long N93B
.long N93C
.long r_illegal
.long r_illegal
.long r_illegal
.long N940
.long N940
.long N940
.long N940
.long N940
.long N940
.long N940
.long N940
.long N948
.long N948
.long N948
.long N948
.long N948
.long N948
.long N948
.long N948
.long N950
.long N950
.long N950
.long N950
.long N950
.long N950
.long N950
.long N950
.long N958
.long N958
.long N958
.long N958
.long N958
.long N958
.long N958
.long N958
.long N960
.long N960
.long N960
.long N960
.long N960
.long N960
.long N960
.long N960
.long N968
.long N968
.long N968
.long N968
.long N968
.long N968
.long N968
.long N968
.long N970
.long N970
.long N970
.long N970
.long N970
.long N970
.long N970
.long N970
.long N978
.long N979
.long N97A
.long N97B
.long N97C
.long r_illegal
.long r_illegal
.long r_illegal
.long N980
.long N980
.long N980
.long N980
.long N980
.long N980
.long N980
.long N980
.long N988
.long N988
.long N988
.long N988
.long N988
.long N988
.long N988
.long N988
.long N990
.long N990
.long N990
.long N990
.long N990
.long N990
.long N990
.long N990
.long N998
.long N998
.long N998
.long N998
.long N998
.long N998
.long N998
.long N998
.long N9A0
.long N9A0
.long N9A0
.long N9A0
.long N9A0
.long N9A0
.long N9A0
.long N9A0
.long N9A8
.long N9A8
.long N9A8
.long N9A8
.long N9A8
.long N9A8
.long N9A8
.long N9A8
.long N9B0
.long N9B0
.long N9B0
.long N9B0
.long N9B0
.long N9B0
.long N9B0
.long N9B0
.long N9B8
.long N9B9
.long N9BA
.long N9BB
.long N9BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long NA00
.long NA00
.long NA00
.long NA00
.long NA00
.long NA00
.long NA00
.long NA00
.long NA08
.long NA08
.long NA08
.long NA08
.long NA08
.long NA08
.long NA08
.long NA08
.long NA10
.long NA10
.long NA10
.long NA10
.long NA10
.long NA10
.long NA10
.long NA10
.long NA18
.long NA18
.long NA18
.long NA18
.long NA18
.long NA18
.long NA18
.long NA18
.long NA20
.long NA20
.long NA20
.long NA20
.long NA20
.long NA20
.long NA20
.long NA20
.long NA28
.long NA28
.long NA28
.long NA28
.long NA28
.long NA28
.long NA28
.long NA28
.long NA30
.long NA30
.long NA30
.long NA30
.long NA30
.long NA30
.long NA30
.long NA30
.long NA38
.long NA39
.long NA3A
.long NA3B
.long NA3C
.long r_illegal
.long r_illegal
.long r_illegal
.long NA40
.long NA40
.long NA40
.long NA40
.long NA40
.long NA40
.long NA40
.long NA40
.long NA48
.long NA48
.long NA48
.long NA48
.long NA48
.long NA48
.long NA48
.long NA48
.long NA50
.long NA50
.long NA50
.long NA50
.long NA50
.long NA50
.long NA50
.long NA50
.long NA58
.long NA58
.long NA58
.long NA58
.long NA58
.long NA58
.long NA58
.long NA58
.long NA60
.long NA60
.long NA60
.long NA60
.long NA60
.long NA60
.long NA60
.long NA60
.long NA68
.long NA68
.long NA68
.long NA68
.long NA68
.long NA68
.long NA68
.long NA68
.long NA70
.long NA70
.long NA70
.long NA70
.long NA70
.long NA70
.long NA70
.long NA70
.long NA78
.long NA79
.long NA7A
.long NA7B
.long NA7C
.long r_illegal
.long r_illegal
.long r_illegal
.long NA80
.long NA80
.long NA80
.long NA80
.long NA80
.long NA80
.long NA80
.long NA80
.long NA88
.long NA88
.long NA88
.long NA88
.long NA88
.long NA88
.long NA88
.long NA88
.long NA90
.long NA90
.long NA90
.long NA90
.long NA90
.long NA90
.long NA90
.long NA90
.long NA98
.long NA98
.long NA98
.long NA98
.long NA98
.long NA98
.long NA98
.long NA98
.long NAA0
.long NAA0
.long NAA0
.long NAA0
.long NAA0
.long NAA0
.long NAA0
.long NAA0
.long NAA8
.long NAA8
.long NAA8
.long NAA8
.long NAA8
.long NAA8
.long NAA8
.long NAA8
.long NAB0
.long NAB0
.long NAB0
.long NAB0
.long NAB0
.long NAB0
.long NAB0
.long NAB0
.long NAB8
.long NAB9
.long NABA
.long NABB
.long NABC
.long r_illegal
.long r_illegal
.long r_illegal
.long NAC0
.long NAC0
.long NAC0
.long NAC0
.long NAC0
.long NAC0
.long NAC0
.long NAC0
.long NAC8
.long NAC8
.long NAC8
.long NAC8
.long NAC8
.long NAC8
.long NAC8
.long NAC8
.long NAD0
.long NAD0
.long NAD0
.long NAD0
.long NAD0
.long NAD0
.long NAD0
.long NAD0
.long NAD8
.long NAD8
.long NAD8
.long NAD8
.long NAD8
.long NAD8
.long NAD8
.long NAD8
.long NAE0
.long NAE0
.long NAE0
.long NAE0
.long NAE0
.long NAE0
.long NAE0
.long NAE0
.long NAE8
.long NAE8
.long NAE8
.long NAE8
.long NAE8
.long NAE8
.long NAE8
.long NAE8
.long NAF0
.long NAF0
.long NAF0
.long NAF0
.long NAF0
.long NAF0
.long NAF0
.long NAF0
.long NAF8
.long NAF9
.long NAFA
.long NAFB
.long NAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long NB00
.long NB00
.long NB00
.long NB00
.long NB00
.long NB00
.long NB00
.long NB00
.long NB08
.long NB08
.long NB08
.long NB08
.long NB08
.long NB08
.long NB08
.long NB08
.long NB10
.long NB10
.long NB10
.long NB10
.long NB10
.long NB10
.long NB10
.long NB10
.long NB18
.long NB18
.long NB18
.long NB18
.long NB18
.long NB18
.long NB18
.long NB18
.long NB20
.long NB20
.long NB20
.long NB20
.long NB20
.long NB20
.long NB20
.long NB20
.long NB28
.long NB28
.long NB28
.long NB28
.long NB28
.long NB28
.long NB28
.long NB28
.long NB30
.long NB30
.long NB30
.long NB30
.long NB30
.long NB30
.long NB30
.long NB30
.long NB38
.long NB39
.long NB3A
.long NB3B
.long NB3C
.long r_illegal
.long r_illegal
.long r_illegal
.long NB40
.long NB40
.long NB40
.long NB40
.long NB40
.long NB40
.long NB40
.long NB40
.long NB48
.long NB48
.long NB48
.long NB48
.long NB48
.long NB48
.long NB48
.long NB48
.long NB50
.long NB50
.long NB50
.long NB50
.long NB50
.long NB50
.long NB50
.long NB50
.long NB58
.long NB58
.long NB58
.long NB58
.long NB58
.long NB58
.long NB58
.long NB58
.long NB60
.long NB60
.long NB60
.long NB60
.long NB60
.long NB60
.long NB60
.long NB60
.long NB68
.long NB68
.long NB68
.long NB68
.long NB68
.long NB68
.long NB68
.long NB68
.long NB70
.long NB70
.long NB70
.long NB70
.long NB70
.long NB70
.long NB70
.long NB70
.long NB78
.long NB79
.long NB7A
.long NB7B
.long NB7C
.long r_illegal
.long r_illegal
.long r_illegal
.long NB80
.long NB80
.long NB80
.long NB80
.long NB80
.long NB80
.long NB80
.long NB80
.long NB88
.long NB88
.long NB88
.long NB88
.long NB88
.long NB88
.long NB88
.long NB88
.long NB90
.long NB90
.long NB90
.long NB90
.long NB90
.long NB90
.long NB90
.long NB90
.long NB98
.long NB98
.long NB98
.long NB98
.long NB98
.long NB98
.long NB98
.long NB98
.long NBA0
.long NBA0
.long NBA0
.long NBA0
.long NBA0
.long NBA0
.long NBA0
.long NBA0
.long NBA8
.long NBA8
.long NBA8
.long NBA8
.long NBA8
.long NBA8
.long NBA8
.long NBA8
.long NBB0
.long NBB0
.long NBB0
.long NBB0
.long NBB0
.long NBB0
.long NBB0
.long NBB0
.long NBB8
.long NBB9
.long NBBA
.long NBBB
.long NBBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long NC00
.long NC00
.long NC00
.long NC00
.long NC00
.long NC00
.long NC00
.long NC00
.long NC08
.long NC08
.long NC08
.long NC08
.long NC08
.long NC08
.long NC08
.long NC08
.long NC10
.long NC10
.long NC10
.long NC10
.long NC10
.long NC10
.long NC10
.long NC10
.long NC18
.long NC18
.long NC18
.long NC18
.long NC18
.long NC18
.long NC18
.long NC18
.long NC20
.long NC20
.long NC20
.long NC20
.long NC20
.long NC20
.long NC20
.long NC20
.long NC28
.long NC28
.long NC28
.long NC28
.long NC28
.long NC28
.long NC28
.long NC28
.long NC30
.long NC30
.long NC30
.long NC30
.long NC30
.long NC30
.long NC30
.long NC30
.long NC38
.long NC39
.long NC3A
.long NC3B
.long NC3C
.long r_illegal
.long r_illegal
.long r_illegal
.long NC40
.long NC40
.long NC40
.long NC40
.long NC40
.long NC40
.long NC40
.long NC40
.long NC48
.long NC48
.long NC48
.long NC48
.long NC48
.long NC48
.long NC48
.long NC48
.long NC50
.long NC50
.long NC50
.long NC50
.long NC50
.long NC50
.long NC50
.long NC50
.long NC58
.long NC58
.long NC58
.long NC58
.long NC58
.long NC58
.long NC58
.long NC58
.long NC60
.long NC60
.long NC60
.long NC60
.long NC60
.long NC60
.long NC60
.long NC60
.long NC68
.long NC68
.long NC68
.long NC68
.long NC68
.long NC68
.long NC68
.long NC68
.long NC70
.long NC70
.long NC70
.long NC70
.long NC70
.long NC70
.long NC70
.long NC70
.long NC78
.long NC79
.long NC7A
.long NC7B
.long NC7C
.long r_illegal
.long r_illegal
.long r_illegal
.long NC80
.long NC80
.long NC80
.long NC80
.long NC80
.long NC80
.long NC80
.long NC80
.long NC88
.long NC88
.long NC88
.long NC88
.long NC88
.long NC88
.long NC88
.long NC88
.long NC90
.long NC90
.long NC90
.long NC90
.long NC90
.long NC90
.long NC90
.long NC90
.long NC98
.long NC98
.long NC98
.long NC98
.long NC98
.long NC98
.long NC98
.long NC98
.long NCA0
.long NCA0
.long NCA0
.long NCA0
.long NCA0
.long NCA0
.long NCA0
.long NCA0
.long NCA8
.long NCA8
.long NCA8
.long NCA8
.long NCA8
.long NCA8
.long NCA8
.long NCA8
.long NCB0
.long NCB0
.long NCB0
.long NCB0
.long NCB0
.long NCB0
.long NCB0
.long NCB0
.long NCB8
.long NCB9
.long NCBA
.long NCBB
.long NCBC
.long r_illegal
.long r_illegal
.long r_illegal
.long NCC0
.long NCC0
.long NCC0
.long NCC0
.long NCC0
.long NCC0
.long NCC0
.long NCC0
.long NCC8
.long NCC8
.long NCC8
.long NCC8
.long NCC8
.long NCC8
.long NCC8
.long NCC8
.long NCD0
.long NCD0
.long NCD0
.long NCD0
.long NCD0
.long NCD0
.long NCD0
.long NCD0
.long NCD8
.long NCD8
.long NCD8
.long NCD8
.long NCD8
.long NCD8
.long NCD8
.long NCD8
.long NCE0
.long NCE0
.long NCE0
.long NCE0
.long NCE0
.long NCE0
.long NCE0
.long NCE0
.long NCE8
.long NCE8
.long NCE8
.long NCE8
.long NCE8
.long NCE8
.long NCE8
.long NCE8
.long NCF0
.long NCF0
.long NCF0
.long NCF0
.long NCF0
.long NCF0
.long NCF0
.long NCF0
.long NCF8
.long NCF9
.long NCFA
.long NCFB
.long NCFC
.long r_illegal
.long r_illegal
.long r_illegal
.long ND00
.long ND00
.long ND00
.long ND00
.long ND00
.long ND00
.long ND00
.long ND00
.long ND08
.long ND08
.long ND08
.long ND08
.long ND08
.long ND08
.long ND08
.long ND08
.long ND10
.long ND10
.long ND10
.long ND10
.long ND10
.long ND10
.long ND10
.long ND10
.long ND18
.long ND18
.long ND18
.long ND18
.long ND18
.long ND18
.long ND18
.long ND18
.long ND20
.long ND20
.long ND20
.long ND20
.long ND20
.long ND20
.long ND20
.long ND20
.long ND28
.long ND28
.long ND28
.long ND28
.long ND28
.long ND28
.long ND28
.long ND28
.long ND30
.long ND30
.long ND30
.long ND30
.long ND30
.long ND30
.long ND30
.long ND30
.long ND38
.long ND39
.long ND3A
.long ND3B
.long ND3C
.long r_illegal
.long r_illegal
.long r_illegal
.long ND40
.long ND40
.long ND40
.long ND40
.long ND40
.long ND40
.long ND40
.long ND40
.long ND48
.long ND48
.long ND48
.long ND48
.long ND48
.long ND48
.long ND48
.long ND48
.long ND50
.long ND50
.long ND50
.long ND50
.long ND50
.long ND50
.long ND50
.long ND50
.long ND58
.long ND58
.long ND58
.long ND58
.long ND58
.long ND58
.long ND58
.long ND58
.long ND60
.long ND60
.long ND60
.long ND60
.long ND60
.long ND60
.long ND60
.long ND60
.long ND68
.long ND68
.long ND68
.long ND68
.long ND68
.long ND68
.long ND68
.long ND68
.long ND70
.long ND70
.long ND70
.long ND70
.long ND70
.long ND70
.long ND70
.long ND70
.long ND78
.long ND79
.long ND7A
.long ND7B
.long ND7C
.long r_illegal
.long r_illegal
.long r_illegal
.long ND80
.long ND80
.long ND80
.long ND80
.long ND80
.long ND80
.long ND80
.long ND80
.long ND88
.long ND88
.long ND88
.long ND88
.long ND88
.long ND88
.long ND88
.long ND88
.long ND90
.long ND90
.long ND90
.long ND90
.long ND90
.long ND90
.long ND90
.long ND90
.long ND98
.long ND98
.long ND98
.long ND98
.long ND98
.long ND98
.long ND98
.long ND98
.long NDA0
.long NDA0
.long NDA0
.long NDA0
.long NDA0
.long NDA0
.long NDA0
.long NDA0
.long NDA8
.long NDA8
.long NDA8
.long NDA8
.long NDA8
.long NDA8
.long NDA8
.long NDA8
.long NDB0
.long NDB0
.long NDB0
.long NDB0
.long NDB0
.long NDB0
.long NDB0
.long NDB0
.long NDB8
.long NDB9
.long NDBA
.long NDBB
.long NDBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long NE00
.long NE00
.long NE00
.long NE00
.long NE00
.long NE00
.long NE00
.long NE00
.long NE08
.long NE08
.long NE08
.long NE08
.long NE08
.long NE08
.long NE08
.long NE08
.long NE10
.long NE10
.long NE10
.long NE10
.long NE10
.long NE10
.long NE10
.long NE10
.long NE18
.long NE18
.long NE18
.long NE18
.long NE18
.long NE18
.long NE18
.long NE18
.long NE20
.long NE20
.long NE20
.long NE20
.long NE20
.long NE20
.long NE20
.long NE20
.long NE28
.long NE28
.long NE28
.long NE28
.long NE28
.long NE28
.long NE28
.long NE28
.long NE30
.long NE30
.long NE30
.long NE30
.long NE30
.long NE30
.long NE30
.long NE30
.long NE38
.long NE39
.long NE3A
.long NE3B
.long NE3C
.long r_illegal
.long r_illegal
.long r_illegal
.long NE40
.long NE40
.long NE40
.long NE40
.long NE40
.long NE40
.long NE40
.long NE40
.long NE48
.long NE48
.long NE48
.long NE48
.long NE48
.long NE48
.long NE48
.long NE48
.long NE50
.long NE50
.long NE50
.long NE50
.long NE50
.long NE50
.long NE50
.long NE50
.long NE58
.long NE58
.long NE58
.long NE58
.long NE58
.long NE58
.long NE58
.long NE58
.long NE60
.long NE60
.long NE60
.long NE60
.long NE60
.long NE60
.long NE60
.long NE60
.long NE68
.long NE68
.long NE68
.long NE68
.long NE68
.long NE68
.long NE68
.long NE68
.long NE70
.long NE70
.long NE70
.long NE70
.long NE70
.long NE70
.long NE70
.long NE70
.long NE78
.long NE79
.long NE7A
.long NE7B
.long NE7C
.long r_illegal
.long r_illegal
.long r_illegal
.long NE80
.long NE80
.long NE80
.long NE80
.long NE80
.long NE80
.long NE80
.long NE80
.long NE88
.long NE88
.long NE88
.long NE88
.long NE88
.long NE88
.long NE88
.long NE88
.long NE90
.long NE90
.long NE90
.long NE90
.long NE90
.long NE90
.long NE90
.long NE90
.long NE98
.long NE98
.long NE98
.long NE98
.long NE98
.long NE98
.long NE98
.long NE98
.long NEA0
.long NEA0
.long NEA0
.long NEA0
.long NEA0
.long NEA0
.long NEA0
.long NEA0
.long NEA8
.long NEA8
.long NEA8
.long NEA8
.long NEA8
.long NEA8
.long NEA8
.long NEA8
.long NEB0
.long NEB0
.long NEB0
.long NEB0
.long NEB0
.long NEB0
.long NEB0
.long NEB0
.long NEB8
.long NEB9
.long NEBA
.long NEBB
.long NEBC
.long r_illegal
.long r_illegal
.long r_illegal
.long NEC0
.long NEC0
.long NEC0
.long NEC0
.long NEC0
.long NEC0
.long NEC0
.long NEC0
.long NEC8
.long NEC8
.long NEC8
.long NEC8
.long NEC8
.long NEC8
.long NEC8
.long NEC8
.long NED0
.long NED0
.long NED0
.long NED0
.long NED0
.long NED0
.long NED0
.long NED0
.long NED8
.long NED8
.long NED8
.long NED8
.long NED8
.long NED8
.long NED8
.long NED8
.long NEE0
.long NEE0
.long NEE0
.long NEE0
.long NEE0
.long NEE0
.long NEE0
.long NEE0
.long NEE8
.long NEE8
.long NEE8
.long NEE8
.long NEE8
.long NEE8
.long NEE8
.long NEE8
.long NEF0
.long NEF0
.long NEF0
.long NEF0
.long NEF0
.long NEF0
.long NEF0
.long NEF0
.long NEF8
.long NEF9
.long NEFA
.long NEFB
.long NEFC
.long r_illegal
.long r_illegal
.long r_illegal
.long NF00
.long NF00
.long NF00
.long NF00
.long NF00
.long NF00
.long NF00
.long NF00
.long NF08
.long NF08
.long NF08
.long NF08
.long NF08
.long NF08
.long NF08
.long NF08
.long NF10
.long NF10
.long NF10
.long NF10
.long NF10
.long NF10
.long NF10
.long NF10
.long NF18
.long NF18
.long NF18
.long NF18
.long NF18
.long NF18
.long NF18
.long NF18
.long NF20
.long NF20
.long NF20
.long NF20
.long NF20
.long NF20
.long NF20
.long NF20
.long NF28
.long NF28
.long NF28
.long NF28
.long NF28
.long NF28
.long NF28
.long NF28
.long NF30
.long NF30
.long NF30
.long NF30
.long NF30
.long NF30
.long NF30
.long NF30
.long NF38
.long NF39
.long NF3A
.long NF3B
.long NF3C
.long r_illegal
.long r_illegal
.long r_illegal
.long NF40
.long NF40
.long NF40
.long NF40
.long NF40
.long NF40
.long NF40
.long NF40
.long NF48
.long NF48
.long NF48
.long NF48
.long NF48
.long NF48
.long NF48
.long NF48
.long NF50
.long NF50
.long NF50
.long NF50
.long NF50
.long NF50
.long NF50
.long NF50
.long NF58
.long NF58
.long NF58
.long NF58
.long NF58
.long NF58
.long NF58
.long NF58
.long NF60
.long NF60
.long NF60
.long NF60
.long NF60
.long NF60
.long NF60
.long NF60
.long NF68
.long NF68
.long NF68
.long NF68
.long NF68
.long NF68
.long NF68
.long NF68
.long NF70
.long NF70
.long NF70
.long NF70
.long NF70
.long NF70
.long NF70
.long NF70
.long NF78
.long NF79
.long NF7A
.long NF7B
.long NF7C
.long r_illegal
.long r_illegal
.long r_illegal
.long NF80
.long NF80
.long NF80
.long NF80
.long NF80
.long NF80
.long NF80
.long NF80
.long NF88
.long NF88
.long NF88
.long NF88
.long NF88
.long NF88
.long NF88
.long NF88
.long NF90
.long NF90
.long NF90
.long NF90
.long NF90
.long NF90
.long NF90
.long NF90
.long NF98
.long NF98
.long NF98
.long NF98
.long NF98
.long NF98
.long NF98
.long NF98
.long NFA0
.long NFA0
.long NFA0
.long NFA0
.long NFA0
.long NFA0
.long NFA0
.long NFA0
.long NFA8
.long NFA8
.long NFA8
.long NFA8
.long NFA8
.long NFA8
.long NFA8
.long NFA8
.long NFB0
.long NFB0
.long NFB0
.long NFB0
.long NFB0
.long NFB0
.long NFB0
.long NFB0
.long NFB8
.long NFB9
.long NFBA
.long NFBB
.long NFBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O000
.long O000
.long O000
.long O000
.long O000
.long O000
.long O000
.long O000
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O010
.long O010
.long O010
.long O010
.long O010
.long O010
.long O010
.long O010
.long O018
.long O018
.long O018
.long O018
.long O018
.long O018
.long O018
.long O018
.long O020
.long O020
.long O020
.long O020
.long O020
.long O020
.long O020
.long O020
.long O028
.long O028
.long O028
.long O028
.long O028
.long O028
.long O028
.long O028
.long O030
.long O030
.long O030
.long O030
.long O030
.long O030
.long O030
.long O030
.long O038
.long O039
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O040
.long O040
.long O040
.long O040
.long O040
.long O040
.long O040
.long O040
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O050
.long O050
.long O050
.long O050
.long O050
.long O050
.long O050
.long O050
.long O058
.long O058
.long O058
.long O058
.long O058
.long O058
.long O058
.long O058
.long O060
.long O060
.long O060
.long O060
.long O060
.long O060
.long O060
.long O060
.long O068
.long O068
.long O068
.long O068
.long O068
.long O068
.long O068
.long O068
.long O070
.long O070
.long O070
.long O070
.long O070
.long O070
.long O070
.long O070
.long O078
.long O079
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O080
.long O080
.long O080
.long O080
.long O080
.long O080
.long O080
.long O080
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O090
.long O090
.long O090
.long O090
.long O090
.long O090
.long O090
.long O090
.long O098
.long O098
.long O098
.long O098
.long O098
.long O098
.long O098
.long O098
.long O0A0
.long O0A0
.long O0A0
.long O0A0
.long O0A0
.long O0A0
.long O0A0
.long O0A0
.long O0A8
.long O0A8
.long O0A8
.long O0A8
.long O0A8
.long O0A8
.long O0A8
.long O0A8
.long O0B0
.long O0B0
.long O0B0
.long O0B0
.long O0B0
.long O0B0
.long O0B0
.long O0B0
.long O0B8
.long O0B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O0C0
.long O0C0
.long O0C0
.long O0C0
.long O0C0
.long O0C0
.long O0C0
.long O0C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O0D0
.long O0D0
.long O0D0
.long O0D0
.long O0D0
.long O0D0
.long O0D0
.long O0D0
.long O0D8
.long O0D8
.long O0D8
.long O0D8
.long O0D8
.long O0D8
.long O0D8
.long O0D8
.long O0E0
.long O0E0
.long O0E0
.long O0E0
.long O0E0
.long O0E0
.long O0E0
.long O0E0
.long O0E8
.long O0E8
.long O0E8
.long O0E8
.long O0E8
.long O0E8
.long O0E8
.long O0E8
.long O0F0
.long O0F0
.long O0F0
.long O0F0
.long O0F0
.long O0F0
.long O0F0
.long O0F0
.long O0F8
.long O0F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O180
.long O180
.long O180
.long O180
.long O180
.long O180
.long O180
.long O180
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O190
.long O190
.long O190
.long O190
.long O190
.long O190
.long O190
.long O190
.long O198
.long O198
.long O198
.long O198
.long O198
.long O198
.long O198
.long O198
.long O1A0
.long O1A0
.long O1A0
.long O1A0
.long O1A0
.long O1A0
.long O1A0
.long O1A0
.long O1A8
.long O1A8
.long O1A8
.long O1A8
.long O1A8
.long O1A8
.long O1A8
.long O1A8
.long O1B0
.long O1B0
.long O1B0
.long O1B0
.long O1B0
.long O1B0
.long O1B0
.long O1B0
.long O1B8
.long O1B9
.long O1BA
.long O1BB
.long O1BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O1D0
.long O1D0
.long O1D0
.long O1D0
.long O1D0
.long O1D0
.long O1D0
.long O1D0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O1E8
.long O1E8
.long O1E8
.long O1E8
.long O1E8
.long O1E8
.long O1E8
.long O1E8
.long O1F0
.long O1F0
.long O1F0
.long O1F0
.long O1F0
.long O1F0
.long O1F0
.long O1F0
.long O1F8
.long O1F9
.long O1FA
.long O1FB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O200
.long O200
.long O200
.long O200
.long O200
.long O200
.long O200
.long O200
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O210
.long O210
.long O210
.long O210
.long O210
.long O210
.long O210
.long O210
.long O218
.long O218
.long O218
.long O218
.long O218
.long O218
.long O218
.long O218
.long O220
.long O220
.long O220
.long O220
.long O220
.long O220
.long O220
.long O220
.long O228
.long O228
.long O228
.long O228
.long O228
.long O228
.long O228
.long O228
.long O230
.long O230
.long O230
.long O230
.long O230
.long O230
.long O230
.long O230
.long O238
.long O239
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O240
.long O240
.long O240
.long O240
.long O240
.long O240
.long O240
.long O240
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O250
.long O250
.long O250
.long O250
.long O250
.long O250
.long O250
.long O250
.long O258
.long O258
.long O258
.long O258
.long O258
.long O258
.long O258
.long O258
.long O260
.long O260
.long O260
.long O260
.long O260
.long O260
.long O260
.long O260
.long O268
.long O268
.long O268
.long O268
.long O268
.long O268
.long O268
.long O268
.long O270
.long O270
.long O270
.long O270
.long O270
.long O270
.long O270
.long O270
.long O278
.long O279
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O280
.long O280
.long O280
.long O280
.long O280
.long O280
.long O280
.long O280
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O290
.long O290
.long O290
.long O290
.long O290
.long O290
.long O290
.long O290
.long O298
.long O298
.long O298
.long O298
.long O298
.long O298
.long O298
.long O298
.long O2A0
.long O2A0
.long O2A0
.long O2A0
.long O2A0
.long O2A0
.long O2A0
.long O2A0
.long O2A8
.long O2A8
.long O2A8
.long O2A8
.long O2A8
.long O2A8
.long O2A8
.long O2A8
.long O2B0
.long O2B0
.long O2B0
.long O2B0
.long O2B0
.long O2B0
.long O2B0
.long O2B0
.long O2B8
.long O2B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O380
.long O380
.long O380
.long O380
.long O380
.long O380
.long O380
.long O380
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O390
.long O390
.long O390
.long O390
.long O390
.long O390
.long O390
.long O390
.long O398
.long O398
.long O398
.long O398
.long O398
.long O398
.long O398
.long O398
.long O3A0
.long O3A0
.long O3A0
.long O3A0
.long O3A0
.long O3A0
.long O3A0
.long O3A0
.long O3A8
.long O3A8
.long O3A8
.long O3A8
.long O3A8
.long O3A8
.long O3A8
.long O3A8
.long O3B0
.long O3B0
.long O3B0
.long O3B0
.long O3B0
.long O3B0
.long O3B0
.long O3B0
.long O3B8
.long O3B9
.long O3BA
.long O3BB
.long O3BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O3D0
.long O3D0
.long O3D0
.long O3D0
.long O3D0
.long O3D0
.long O3D0
.long O3D0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O3E8
.long O3E8
.long O3E8
.long O3E8
.long O3E8
.long O3E8
.long O3E8
.long O3E8
.long O3F0
.long O3F0
.long O3F0
.long O3F0
.long O3F0
.long O3F0
.long O3F0
.long O3F0
.long O3F8
.long O3F9
.long O3FA
.long O3FB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O400
.long O400
.long O400
.long O400
.long O400
.long O400
.long O400
.long O400
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O410
.long O410
.long O410
.long O410
.long O410
.long O410
.long O410
.long O410
.long O418
.long O418
.long O418
.long O418
.long O418
.long O418
.long O418
.long O418
.long O420
.long O420
.long O420
.long O420
.long O420
.long O420
.long O420
.long O420
.long O428
.long O428
.long O428
.long O428
.long O428
.long O428
.long O428
.long O428
.long O430
.long O430
.long O430
.long O430
.long O430
.long O430
.long O430
.long O430
.long O438
.long O439
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O440
.long O440
.long O440
.long O440
.long O440
.long O440
.long O440
.long O440
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O450
.long O450
.long O450
.long O450
.long O450
.long O450
.long O450
.long O450
.long O458
.long O458
.long O458
.long O458
.long O458
.long O458
.long O458
.long O458
.long O460
.long O460
.long O460
.long O460
.long O460
.long O460
.long O460
.long O460
.long O468
.long O468
.long O468
.long O468
.long O468
.long O468
.long O468
.long O468
.long O470
.long O470
.long O470
.long O470
.long O470
.long O470
.long O470
.long O470
.long O478
.long O479
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O480
.long O480
.long O480
.long O480
.long O480
.long O480
.long O480
.long O480
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O490
.long O490
.long O490
.long O490
.long O490
.long O490
.long O490
.long O490
.long O498
.long O498
.long O498
.long O498
.long O498
.long O498
.long O498
.long O498
.long O4A0
.long O4A0
.long O4A0
.long O4A0
.long O4A0
.long O4A0
.long O4A0
.long O4A0
.long O4A8
.long O4A8
.long O4A8
.long O4A8
.long O4A8
.long O4A8
.long O4A8
.long O4A8
.long O4B0
.long O4B0
.long O4B0
.long O4B0
.long O4B0
.long O4B0
.long O4B0
.long O4B0
.long O4B8
.long O4B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O4C0
.long O4C0
.long O4C0
.long O4C0
.long O4C0
.long O4C0
.long O4C0
.long O4C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O4D0
.long O4D0
.long O4D0
.long O4D0
.long O4D0
.long O4D0
.long O4D0
.long O4D0
.long O4D8
.long O4D8
.long O4D8
.long O4D8
.long O4D8
.long O4D8
.long O4D8
.long O4D8
.long O4E0
.long O4E0
.long O4E0
.long O4E0
.long O4E0
.long O4E0
.long O4E0
.long O4E0
.long O4E8
.long O4E8
.long O4E8
.long O4E8
.long O4E8
.long O4E8
.long O4E8
.long O4E8
.long O4F0
.long O4F0
.long O4F0
.long O4F0
.long O4F0
.long O4F0
.long O4F0
.long O4F0
.long O4F8
.long O4F9
.long O4FA
.long O4FB
.long O4FC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O580
.long O580
.long O580
.long O580
.long O580
.long O580
.long O580
.long O580
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O590
.long O590
.long O590
.long O590
.long O590
.long O590
.long O590
.long O590
.long O598
.long O598
.long O598
.long O598
.long O598
.long O598
.long O598
.long O598
.long O5A0
.long O5A0
.long O5A0
.long O5A0
.long O5A0
.long O5A0
.long O5A0
.long O5A0
.long O5A8
.long O5A8
.long O5A8
.long O5A8
.long O5A8
.long O5A8
.long O5A8
.long O5A8
.long O5B0
.long O5B0
.long O5B0
.long O5B0
.long O5B0
.long O5B0
.long O5B0
.long O5B0
.long O5B8
.long O5B9
.long O5BA
.long O5BB
.long O5BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O5D0
.long O5D0
.long O5D0
.long O5D0
.long O5D0
.long O5D0
.long O5D0
.long O5D0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O5E8
.long O5E8
.long O5E8
.long O5E8
.long O5E8
.long O5E8
.long O5E8
.long O5E8
.long O5F0
.long O5F0
.long O5F0
.long O5F0
.long O5F0
.long O5F0
.long O5F0
.long O5F0
.long O5F8
.long O5F9
.long O5FA
.long O5FB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O600
.long O600
.long O600
.long O600
.long O600
.long O600
.long O600
.long O600
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O610
.long O610
.long O610
.long O610
.long O610
.long O610
.long O610
.long O610
.long O618
.long O618
.long O618
.long O618
.long O618
.long O618
.long O618
.long O618
.long O620
.long O620
.long O620
.long O620
.long O620
.long O620
.long O620
.long O620
.long O628
.long O628
.long O628
.long O628
.long O628
.long O628
.long O628
.long O628
.long O630
.long O630
.long O630
.long O630
.long O630
.long O630
.long O630
.long O630
.long O638
.long O639
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O640
.long O640
.long O640
.long O640
.long O640
.long O640
.long O640
.long O640
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O650
.long O650
.long O650
.long O650
.long O650
.long O650
.long O650
.long O650
.long O658
.long O658
.long O658
.long O658
.long O658
.long O658
.long O658
.long O658
.long O660
.long O660
.long O660
.long O660
.long O660
.long O660
.long O660
.long O660
.long O668
.long O668
.long O668
.long O668
.long O668
.long O668
.long O668
.long O668
.long O670
.long O670
.long O670
.long O670
.long O670
.long O670
.long O670
.long O670
.long O678
.long O679
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O680
.long O680
.long O680
.long O680
.long O680
.long O680
.long O680
.long O680
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O690
.long O690
.long O690
.long O690
.long O690
.long O690
.long O690
.long O690
.long O698
.long O698
.long O698
.long O698
.long O698
.long O698
.long O698
.long O698
.long O6A0
.long O6A0
.long O6A0
.long O6A0
.long O6A0
.long O6A0
.long O6A0
.long O6A0
.long O6A8
.long O6A8
.long O6A8
.long O6A8
.long O6A8
.long O6A8
.long O6A8
.long O6A8
.long O6B0
.long O6B0
.long O6B0
.long O6B0
.long O6B0
.long O6B0
.long O6B0
.long O6B0
.long O6B8
.long O6B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O6C0
.long O6C0
.long O6C0
.long O6C0
.long O6C0
.long O6C0
.long O6C0
.long O6C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O6D0
.long O6D0
.long O6D0
.long O6D0
.long O6D0
.long O6D0
.long O6D0
.long O6D0
.long O6D8
.long O6D8
.long O6D8
.long O6D8
.long O6D8
.long O6D8
.long O6D8
.long O6D8
.long O6E0
.long O6E0
.long O6E0
.long O6E0
.long O6E0
.long O6E0
.long O6E0
.long O6E0
.long O6E8
.long O6E8
.long O6E8
.long O6E8
.long O6E8
.long O6E8
.long O6E8
.long O6E8
.long O6F0
.long O6F0
.long O6F0
.long O6F0
.long O6F0
.long O6F0
.long O6F0
.long O6F0
.long O6F8
.long O6F9
.long O6FA
.long O6FB
.long O6FC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O780
.long O780
.long O780
.long O780
.long O780
.long O780
.long O780
.long O780
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O790
.long O790
.long O790
.long O790
.long O790
.long O790
.long O790
.long O790
.long O798
.long O798
.long O798
.long O798
.long O798
.long O798
.long O798
.long O798
.long O7A0
.long O7A0
.long O7A0
.long O7A0
.long O7A0
.long O7A0
.long O7A0
.long O7A0
.long O7A8
.long O7A8
.long O7A8
.long O7A8
.long O7A8
.long O7A8
.long O7A8
.long O7A8
.long O7B0
.long O7B0
.long O7B0
.long O7B0
.long O7B0
.long O7B0
.long O7B0
.long O7B0
.long O7B8
.long O7B9
.long O7BA
.long O7BB
.long O7BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O7D0
.long O7D0
.long O7D0
.long O7D0
.long O7D0
.long O7D0
.long O7D0
.long O7D0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O7E8
.long O7E8
.long O7E8
.long O7E8
.long O7E8
.long O7E8
.long O7E8
.long O7E8
.long O7F0
.long O7F0
.long O7F0
.long O7F0
.long O7F0
.long O7F0
.long O7F0
.long O7F0
.long O7F8
.long O7F9
.long O7FA
.long O7FB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O800
.long O800
.long O800
.long O800
.long O800
.long O800
.long O800
.long O800
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O810
.long O810
.long O810
.long O810
.long O810
.long O810
.long O810
.long O810
.long O818
.long O818
.long O818
.long O818
.long O818
.long O818
.long O818
.long O818
.long O820
.long O820
.long O820
.long O820
.long O820
.long O820
.long O820
.long O820
.long O828
.long O828
.long O828
.long O828
.long O828
.long O828
.long O828
.long O828
.long O830
.long O830
.long O830
.long O830
.long O830
.long O830
.long O830
.long O830
.long O838
.long O839
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O840
.long O840
.long O840
.long O840
.long O840
.long O840
.long O840
.long O840
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O850
.long O850
.long O850
.long O850
.long O850
.long O850
.long O850
.long O850
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O868
.long O868
.long O868
.long O868
.long O868
.long O868
.long O868
.long O868
.long O870
.long O870
.long O870
.long O870
.long O870
.long O870
.long O870
.long O870
.long O878
.long O879
.long O87A
.long O87B
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O880
.long O880
.long O880
.long O880
.long O880
.long O880
.long O880
.long O880
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O890
.long O890
.long O890
.long O890
.long O890
.long O890
.long O890
.long O890
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O8A0
.long O8A0
.long O8A0
.long O8A0
.long O8A0
.long O8A0
.long O8A0
.long O8A0
.long O8A8
.long O8A8
.long O8A8
.long O8A8
.long O8A8
.long O8A8
.long O8A8
.long O8A8
.long O8B0
.long O8B0
.long O8B0
.long O8B0
.long O8B0
.long O8B0
.long O8B0
.long O8B0
.long O8B8
.long O8B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O8C0
.long O8C0
.long O8C0
.long O8C0
.long O8C0
.long O8C0
.long O8C0
.long O8C0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O8D0
.long O8D0
.long O8D0
.long O8D0
.long O8D0
.long O8D0
.long O8D0
.long O8D0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O8E0
.long O8E0
.long O8E0
.long O8E0
.long O8E0
.long O8E0
.long O8E0
.long O8E0
.long O8E8
.long O8E8
.long O8E8
.long O8E8
.long O8E8
.long O8E8
.long O8E8
.long O8E8
.long O8F0
.long O8F0
.long O8F0
.long O8F0
.long O8F0
.long O8F0
.long O8F0
.long O8F0
.long O8F8
.long O8F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O980
.long O980
.long O980
.long O980
.long O980
.long O980
.long O980
.long O980
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O990
.long O990
.long O990
.long O990
.long O990
.long O990
.long O990
.long O990
.long O998
.long O998
.long O998
.long O998
.long O998
.long O998
.long O998
.long O998
.long O9A0
.long O9A0
.long O9A0
.long O9A0
.long O9A0
.long O9A0
.long O9A0
.long O9A0
.long O9A8
.long O9A8
.long O9A8
.long O9A8
.long O9A8
.long O9A8
.long O9A8
.long O9A8
.long O9B0
.long O9B0
.long O9B0
.long O9B0
.long O9B0
.long O9B0
.long O9B0
.long O9B0
.long O9B8
.long O9B9
.long O9BA
.long O9BB
.long O9BC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O9D0
.long O9D0
.long O9D0
.long O9D0
.long O9D0
.long O9D0
.long O9D0
.long O9D0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long O9E8
.long O9E8
.long O9E8
.long O9E8
.long O9E8
.long O9E8
.long O9E8
.long O9E8
.long O9F0
.long O9F0
.long O9F0
.long O9F0
.long O9F0
.long O9F0
.long O9F0
.long O9F0
.long O9F8
.long O9F9
.long O9FA
.long O9FB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OA00
.long OA00
.long OA00
.long OA00
.long OA00
.long OA00
.long OA00
.long OA00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OA10
.long OA10
.long OA10
.long OA10
.long OA10
.long OA10
.long OA10
.long OA10
.long OA18
.long OA18
.long OA18
.long OA18
.long OA18
.long OA18
.long OA18
.long OA18
.long OA20
.long OA20
.long OA20
.long OA20
.long OA20
.long OA20
.long OA20
.long OA20
.long OA28
.long OA28
.long OA28
.long OA28
.long OA28
.long OA28
.long OA28
.long OA28
.long OA30
.long OA30
.long OA30
.long OA30
.long OA30
.long OA30
.long OA30
.long OA30
.long OA38
.long OA39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OA40
.long OA40
.long OA40
.long OA40
.long OA40
.long OA40
.long OA40
.long OA40
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OA50
.long OA50
.long OA50
.long OA50
.long OA50
.long OA50
.long OA50
.long OA50
.long OA58
.long OA58
.long OA58
.long OA58
.long OA58
.long OA58
.long OA58
.long OA58
.long OA60
.long OA60
.long OA60
.long OA60
.long OA60
.long OA60
.long OA60
.long OA60
.long OA68
.long OA68
.long OA68
.long OA68
.long OA68
.long OA68
.long OA68
.long OA68
.long OA70
.long OA70
.long OA70
.long OA70
.long OA70
.long OA70
.long OA70
.long OA70
.long OA78
.long OA79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OA80
.long OA80
.long OA80
.long OA80
.long OA80
.long OA80
.long OA80
.long OA80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OA90
.long OA90
.long OA90
.long OA90
.long OA90
.long OA90
.long OA90
.long OA90
.long OA98
.long OA98
.long OA98
.long OA98
.long OA98
.long OA98
.long OA98
.long OA98
.long OAA0
.long OAA0
.long OAA0
.long OAA0
.long OAA0
.long OAA0
.long OAA0
.long OAA0
.long OAA8
.long OAA8
.long OAA8
.long OAA8
.long OAA8
.long OAA8
.long OAA8
.long OAA8
.long OAB0
.long OAB0
.long OAB0
.long OAB0
.long OAB0
.long OAB0
.long OAB0
.long OAB0
.long OAB8
.long OAB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OAC0
.long OAC0
.long OAC0
.long OAC0
.long OAC0
.long OAC0
.long OAC0
.long OAC0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OAD0
.long OAD0
.long OAD0
.long OAD0
.long OAD0
.long OAD0
.long OAD0
.long OAD0
.long OAD8
.long OAD8
.long OAD8
.long OAD8
.long OAD8
.long OAD8
.long OAD8
.long OAD8
.long OAE0
.long OAE0
.long OAE0
.long OAE0
.long OAE0
.long OAE0
.long OAE0
.long OAE0
.long OAE8
.long OAE8
.long OAE8
.long OAE8
.long OAE8
.long OAE8
.long OAE8
.long OAE8
.long OAF0
.long OAF0
.long OAF0
.long OAF0
.long OAF0
.long OAF0
.long OAF0
.long OAF0
.long OAF8
.long OAF9
.long OAFA
.long OAFB
.long OAFC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OB80
.long OB80
.long OB80
.long OB80
.long OB80
.long OB80
.long OB80
.long OB80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OB90
.long OB90
.long OB90
.long OB90
.long OB90
.long OB90
.long OB90
.long OB90
.long OB98
.long OB98
.long OB98
.long OB98
.long OB98
.long OB98
.long OB98
.long OB98
.long OBA0
.long OBA0
.long OBA0
.long OBA0
.long OBA0
.long OBA0
.long OBA0
.long OBA0
.long OBA8
.long OBA8
.long OBA8
.long OBA8
.long OBA8
.long OBA8
.long OBA8
.long OBA8
.long OBB0
.long OBB0
.long OBB0
.long OBB0
.long OBB0
.long OBB0
.long OBB0
.long OBB0
.long OBB8
.long OBB9
.long OBBA
.long OBBB
.long OBBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OBD0
.long OBD0
.long OBD0
.long OBD0
.long OBD0
.long OBD0
.long OBD0
.long OBD0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OBE8
.long OBE8
.long OBE8
.long OBE8
.long OBE8
.long OBE8
.long OBE8
.long OBE8
.long OBF0
.long OBF0
.long OBF0
.long OBF0
.long OBF0
.long OBF0
.long OBF0
.long OBF0
.long OBF8
.long OBF9
.long OBFA
.long OBFB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OC90
.long OC90
.long OC90
.long OC90
.long OC90
.long OC90
.long OC90
.long OC90
.long OC98
.long OC98
.long OC98
.long OC98
.long OC98
.long OC98
.long OC98
.long OC98
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OCA8
.long OCA8
.long OCA8
.long OCA8
.long OCA8
.long OCA8
.long OCA8
.long OCA8
.long OCB0
.long OCB0
.long OCB0
.long OCB0
.long OCB0
.long OCB0
.long OCB0
.long OCB0
.long OCB8
.long OCB9
.long OCBA
.long OCBB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OCD0
.long OCD0
.long OCD0
.long OCD0
.long OCD0
.long OCD0
.long OCD0
.long OCD0
.long OCD8
.long OCD8
.long OCD8
.long OCD8
.long OCD8
.long OCD8
.long OCD8
.long OCD8
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OCE8
.long OCE8
.long OCE8
.long OCE8
.long OCE8
.long OCE8
.long OCE8
.long OCE8
.long OCF0
.long OCF0
.long OCF0
.long OCF0
.long OCF0
.long OCF0
.long OCF0
.long OCF0
.long OCF8
.long OCF9
.long OCFA
.long OCFB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OD80
.long OD80
.long OD80
.long OD80
.long OD80
.long OD80
.long OD80
.long OD80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OD90
.long OD90
.long OD90
.long OD90
.long OD90
.long OD90
.long OD90
.long OD90
.long OD98
.long OD98
.long OD98
.long OD98
.long OD98
.long OD98
.long OD98
.long OD98
.long ODA0
.long ODA0
.long ODA0
.long ODA0
.long ODA0
.long ODA0
.long ODA0
.long ODA0
.long ODA8
.long ODA8
.long ODA8
.long ODA8
.long ODA8
.long ODA8
.long ODA8
.long ODA8
.long ODB0
.long ODB0
.long ODB0
.long ODB0
.long ODB0
.long ODB0
.long ODB0
.long ODB0
.long ODB8
.long ODB9
.long ODBA
.long ODBB
.long ODBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long ODD0
.long ODD0
.long ODD0
.long ODD0
.long ODD0
.long ODD0
.long ODD0
.long ODD0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long ODE8
.long ODE8
.long ODE8
.long ODE8
.long ODE8
.long ODE8
.long ODE8
.long ODE8
.long ODF0
.long ODF0
.long ODF0
.long ODF0
.long ODF0
.long ODF0
.long ODF0
.long ODF0
.long ODF8
.long ODF9
.long ODFA
.long ODFB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE40
.long OE50
.long OE50
.long OE50
.long OE50
.long OE50
.long OE50
.long OE50
.long OE50
.long OE58
.long OE58
.long OE58
.long OE58
.long OE58
.long OE58
.long OE58
.long OE58
.long OE60
.long OE60
.long OE60
.long OE60
.long OE60
.long OE60
.long OE60
.long OE60
.long OE68
.long OE68
.long OE68
.long OE68
.long OE68
.long OE68
.long OE68
.long OE68
.long OE70
.long OE71
.long OE72
.long OE73
.long r_illegal
.long OE75
.long OE76
.long OE77
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OE90
.long OE90
.long OE90
.long OE90
.long OE90
.long OE90
.long OE90
.long OE90
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OEA8
.long OEA8
.long OEA8
.long OEA8
.long OEA8
.long OEA8
.long OEA8
.long OEA8
.long OEB0
.long OEB0
.long OEB0
.long OEB0
.long OEB0
.long OEB0
.long OEB0
.long OEB0
.long OEB8
.long OEB9
.long OEBA
.long OEBB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OED0
.long OED0
.long OED0
.long OED0
.long OED0
.long OED0
.long OED0
.long OED0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OEE8
.long OEE8
.long OEE8
.long OEE8
.long OEE8
.long OEE8
.long OEE8
.long OEE8
.long OEF0
.long OEF0
.long OEF0
.long OEF0
.long OEF0
.long OEF0
.long OEF0
.long OEF0
.long OEF8
.long OEF9
.long OEFA
.long OEFB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OF80
.long OF80
.long OF80
.long OF80
.long OF80
.long OF80
.long OF80
.long OF80
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OF90
.long OF90
.long OF90
.long OF90
.long OF90
.long OF90
.long OF90
.long OF90
.long OF98
.long OF98
.long OF98
.long OF98
.long OF98
.long OF98
.long OF98
.long OF98
.long OFA0
.long OFA0
.long OFA0
.long OFA0
.long OFA0
.long OFA0
.long OFA0
.long OFA0
.long OFA8
.long OFA8
.long OFA8
.long OFA8
.long OFA8
.long OFA8
.long OFA8
.long OFA8
.long OFB0
.long OFB0
.long OFB0
.long OFB0
.long OFB0
.long OFB0
.long OFB0
.long OFB0
.long OFB8
.long OFB9
.long OFBA
.long OFBB
.long OFBC
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OFD0
.long OFD0
.long OFD0
.long OFD0
.long OFD0
.long OFD0
.long OFD0
.long OFD0
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long OFE8
.long OFE8
.long OFE8
.long OFE8
.long OFE8
.long OFE8
.long OFE8
.long OFE8
.long OFF0
.long OFF0
.long OFF0
.long OFF0
.long OFF0
.long OFF0
.long OFF0
.long OFF0
.long OFF8
.long OFF9
.long OFFA
.long OFFB
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P000
.long P000
.long P000
.long P000
.long P000
.long P000
.long P000
.long P000
.long P008
.long P008
.long P008
.long P008
.long P008
.long P008
.long P008
.long P008
.long P010
.long P010
.long P010
.long P010
.long P010
.long P010
.long P010
.long P010
.long P018
.long P018
.long P018
.long P018
.long P018
.long P018
.long P018
.long P018
.long P020
.long P020
.long P020
.long P020
.long P020
.long P020
.long P020
.long P020
.long P028
.long P028
.long P028
.long P028
.long P028
.long P028
.long P028
.long P028
.long P030
.long P030
.long P030
.long P030
.long P030
.long P030
.long P030
.long P030
.long P038
.long P039
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P040
.long P040
.long P040
.long P040
.long P040
.long P040
.long P040
.long P040
.long P048
.long P048
.long P048
.long P048
.long P048
.long P048
.long P048
.long P048
.long P050
.long P050
.long P050
.long P050
.long P050
.long P050
.long P050
.long P050
.long P058
.long P058
.long P058
.long P058
.long P058
.long P058
.long P058
.long P058
.long P060
.long P060
.long P060
.long P060
.long P060
.long P060
.long P060
.long P060
.long P068
.long P068
.long P068
.long P068
.long P068
.long P068
.long P068
.long P068
.long P070
.long P070
.long P070
.long P070
.long P070
.long P070
.long P070
.long P070
.long P078
.long P079
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P080
.long P080
.long P080
.long P080
.long P080
.long P080
.long P080
.long P080
.long P088
.long P088
.long P088
.long P088
.long P088
.long P088
.long P088
.long P088
.long P090
.long P090
.long P090
.long P090
.long P090
.long P090
.long P090
.long P090
.long P098
.long P098
.long P098
.long P098
.long P098
.long P098
.long P098
.long P098
.long P0A0
.long P0A0
.long P0A0
.long P0A0
.long P0A0
.long P0A0
.long P0A0
.long P0A0
.long P0A8
.long P0A8
.long P0A8
.long P0A8
.long P0A8
.long P0A8
.long P0A8
.long P0A8
.long P0B0
.long P0B0
.long P0B0
.long P0B0
.long P0B0
.long P0B0
.long P0B0
.long P0B0
.long P0B8
.long P0B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P0C0
.long P0C0
.long P0C0
.long P0C0
.long P0C0
.long P0C0
.long P0C0
.long P0C0
.long P0C8
.long P0C8
.long P0C8
.long P0C8
.long P0C8
.long P0C8
.long P0C8
.long P0C8
.long P0D0
.long P0D0
.long P0D0
.long P0D0
.long P0D0
.long P0D0
.long P0D0
.long P0D0
.long P0D8
.long P0D8
.long P0D8
.long P0D8
.long P0D8
.long P0D8
.long P0D8
.long P0D8
.long P0E0
.long P0E0
.long P0E0
.long P0E0
.long P0E0
.long P0E0
.long P0E0
.long P0E0
.long P0E8
.long P0E8
.long P0E8
.long P0E8
.long P0E8
.long P0E8
.long P0E8
.long P0E8
.long P0F0
.long P0F0
.long P0F0
.long P0F0
.long P0F0
.long P0F0
.long P0F0
.long P0F0
.long P0F8
.long P0F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P100
.long P100
.long P100
.long P100
.long P100
.long P100
.long P100
.long P100
.long P108
.long P108
.long P108
.long P108
.long P108
.long P108
.long P108
.long P108
.long P110
.long P110
.long P110
.long P110
.long P110
.long P110
.long P110
.long P110
.long P118
.long P118
.long P118
.long P118
.long P118
.long P118
.long P118
.long P118
.long P120
.long P120
.long P120
.long P120
.long P120
.long P120
.long P120
.long P120
.long P128
.long P128
.long P128
.long P128
.long P128
.long P128
.long P128
.long P128
.long P130
.long P130
.long P130
.long P130
.long P130
.long P130
.long P130
.long P130
.long P138
.long P139
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P140
.long P140
.long P140
.long P140
.long P140
.long P140
.long P140
.long P140
.long P148
.long P148
.long P148
.long P148
.long P148
.long P148
.long P148
.long P148
.long P150
.long P150
.long P150
.long P150
.long P150
.long P150
.long P150
.long P150
.long P158
.long P158
.long P158
.long P158
.long P158
.long P158
.long P158
.long P158
.long P160
.long P160
.long P160
.long P160
.long P160
.long P160
.long P160
.long P160
.long P168
.long P168
.long P168
.long P168
.long P168
.long P168
.long P168
.long P168
.long P170
.long P170
.long P170
.long P170
.long P170
.long P170
.long P170
.long P170
.long P178
.long P179
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P180
.long P180
.long P180
.long P180
.long P180
.long P180
.long P180
.long P180
.long P188
.long P188
.long P188
.long P188
.long P188
.long P188
.long P188
.long P188
.long P190
.long P190
.long P190
.long P190
.long P190
.long P190
.long P190
.long P190
.long P198
.long P198
.long P198
.long P198
.long P198
.long P198
.long P198
.long P198
.long P1A0
.long P1A0
.long P1A0
.long P1A0
.long P1A0
.long P1A0
.long P1A0
.long P1A0
.long P1A8
.long P1A8
.long P1A8
.long P1A8
.long P1A8
.long P1A8
.long P1A8
.long P1A8
.long P1B0
.long P1B0
.long P1B0
.long P1B0
.long P1B0
.long P1B0
.long P1B0
.long P1B0
.long P1B8
.long P1B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P1C0
.long P1C0
.long P1C0
.long P1C0
.long P1C0
.long P1C0
.long P1C0
.long P1C0
.long P1C8
.long P1C8
.long P1C8
.long P1C8
.long P1C8
.long P1C8
.long P1C8
.long P1C8
.long P1D0
.long P1D0
.long P1D0
.long P1D0
.long P1D0
.long P1D0
.long P1D0
.long P1D0
.long P1D8
.long P1D8
.long P1D8
.long P1D8
.long P1D8
.long P1D8
.long P1D8
.long P1D8
.long P1E0
.long P1E0
.long P1E0
.long P1E0
.long P1E0
.long P1E0
.long P1E0
.long P1E0
.long P1E8
.long P1E8
.long P1E8
.long P1E8
.long P1E8
.long P1E8
.long P1E8
.long P1E8
.long P1F0
.long P1F0
.long P1F0
.long P1F0
.long P1F0
.long P1F0
.long P1F0
.long P1F0
.long P1F8
.long P1F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P200
.long P200
.long P200
.long P200
.long P200
.long P200
.long P200
.long P200
.long P208
.long P208
.long P208
.long P208
.long P208
.long P208
.long P208
.long P208
.long P210
.long P210
.long P210
.long P210
.long P210
.long P210
.long P210
.long P210
.long P218
.long P218
.long P218
.long P218
.long P218
.long P218
.long P218
.long P218
.long P220
.long P220
.long P220
.long P220
.long P220
.long P220
.long P220
.long P220
.long P228
.long P228
.long P228
.long P228
.long P228
.long P228
.long P228
.long P228
.long P230
.long P230
.long P230
.long P230
.long P230
.long P230
.long P230
.long P230
.long P238
.long P239
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P240
.long P240
.long P240
.long P240
.long P240
.long P240
.long P240
.long P240
.long P248
.long P248
.long P248
.long P248
.long P248
.long P248
.long P248
.long P248
.long P250
.long P250
.long P250
.long P250
.long P250
.long P250
.long P250
.long P250
.long P258
.long P258
.long P258
.long P258
.long P258
.long P258
.long P258
.long P258
.long P260
.long P260
.long P260
.long P260
.long P260
.long P260
.long P260
.long P260
.long P268
.long P268
.long P268
.long P268
.long P268
.long P268
.long P268
.long P268
.long P270
.long P270
.long P270
.long P270
.long P270
.long P270
.long P270
.long P270
.long P278
.long P279
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P280
.long P280
.long P280
.long P280
.long P280
.long P280
.long P280
.long P280
.long P288
.long P288
.long P288
.long P288
.long P288
.long P288
.long P288
.long P288
.long P290
.long P290
.long P290
.long P290
.long P290
.long P290
.long P290
.long P290
.long P298
.long P298
.long P298
.long P298
.long P298
.long P298
.long P298
.long P298
.long P2A0
.long P2A0
.long P2A0
.long P2A0
.long P2A0
.long P2A0
.long P2A0
.long P2A0
.long P2A8
.long P2A8
.long P2A8
.long P2A8
.long P2A8
.long P2A8
.long P2A8
.long P2A8
.long P2B0
.long P2B0
.long P2B0
.long P2B0
.long P2B0
.long P2B0
.long P2B0
.long P2B0
.long P2B8
.long P2B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P2C0
.long P2C0
.long P2C0
.long P2C0
.long P2C0
.long P2C0
.long P2C0
.long P2C0
.long P2C8
.long P2C8
.long P2C8
.long P2C8
.long P2C8
.long P2C8
.long P2C8
.long P2C8
.long P2D0
.long P2D0
.long P2D0
.long P2D0
.long P2D0
.long P2D0
.long P2D0
.long P2D0
.long P2D8
.long P2D8
.long P2D8
.long P2D8
.long P2D8
.long P2D8
.long P2D8
.long P2D8
.long P2E0
.long P2E0
.long P2E0
.long P2E0
.long P2E0
.long P2E0
.long P2E0
.long P2E0
.long P2E8
.long P2E8
.long P2E8
.long P2E8
.long P2E8
.long P2E8
.long P2E8
.long P2E8
.long P2F0
.long P2F0
.long P2F0
.long P2F0
.long P2F0
.long P2F0
.long P2F0
.long P2F0
.long P2F8
.long P2F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P300
.long P300
.long P300
.long P300
.long P300
.long P300
.long P300
.long P300
.long P308
.long P308
.long P308
.long P308
.long P308
.long P308
.long P308
.long P308
.long P310
.long P310
.long P310
.long P310
.long P310
.long P310
.long P310
.long P310
.long P318
.long P318
.long P318
.long P318
.long P318
.long P318
.long P318
.long P318
.long P320
.long P320
.long P320
.long P320
.long P320
.long P320
.long P320
.long P320
.long P328
.long P328
.long P328
.long P328
.long P328
.long P328
.long P328
.long P328
.long P330
.long P330
.long P330
.long P330
.long P330
.long P330
.long P330
.long P330
.long P338
.long P339
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P340
.long P340
.long P340
.long P340
.long P340
.long P340
.long P340
.long P340
.long P348
.long P348
.long P348
.long P348
.long P348
.long P348
.long P348
.long P348
.long P350
.long P350
.long P350
.long P350
.long P350
.long P350
.long P350
.long P350
.long P358
.long P358
.long P358
.long P358
.long P358
.long P358
.long P358
.long P358
.long P360
.long P360
.long P360
.long P360
.long P360
.long P360
.long P360
.long P360
.long P368
.long P368
.long P368
.long P368
.long P368
.long P368
.long P368
.long P368
.long P370
.long P370
.long P370
.long P370
.long P370
.long P370
.long P370
.long P370
.long P378
.long P379
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P380
.long P380
.long P380
.long P380
.long P380
.long P380
.long P380
.long P380
.long P388
.long P388
.long P388
.long P388
.long P388
.long P388
.long P388
.long P388
.long P390
.long P390
.long P390
.long P390
.long P390
.long P390
.long P390
.long P390
.long P398
.long P398
.long P398
.long P398
.long P398
.long P398
.long P398
.long P398
.long P3A0
.long P3A0
.long P3A0
.long P3A0
.long P3A0
.long P3A0
.long P3A0
.long P3A0
.long P3A8
.long P3A8
.long P3A8
.long P3A8
.long P3A8
.long P3A8
.long P3A8
.long P3A8
.long P3B0
.long P3B0
.long P3B0
.long P3B0
.long P3B0
.long P3B0
.long P3B0
.long P3B0
.long P3B8
.long P3B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P3C0
.long P3C0
.long P3C0
.long P3C0
.long P3C0
.long P3C0
.long P3C0
.long P3C0
.long P3C8
.long P3C8
.long P3C8
.long P3C8
.long P3C8
.long P3C8
.long P3C8
.long P3C8
.long P3D0
.long P3D0
.long P3D0
.long P3D0
.long P3D0
.long P3D0
.long P3D0
.long P3D0
.long P3D8
.long P3D8
.long P3D8
.long P3D8
.long P3D8
.long P3D8
.long P3D8
.long P3D8
.long P3E0
.long P3E0
.long P3E0
.long P3E0
.long P3E0
.long P3E0
.long P3E0
.long P3E0
.long P3E8
.long P3E8
.long P3E8
.long P3E8
.long P3E8
.long P3E8
.long P3E8
.long P3E8
.long P3F0
.long P3F0
.long P3F0
.long P3F0
.long P3F0
.long P3F0
.long P3F0
.long P3F0
.long P3F8
.long P3F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P400
.long P400
.long P400
.long P400
.long P400
.long P400
.long P400
.long P400
.long P408
.long P408
.long P408
.long P408
.long P408
.long P408
.long P408
.long P408
.long P410
.long P410
.long P410
.long P410
.long P410
.long P410
.long P410
.long P410
.long P418
.long P418
.long P418
.long P418
.long P418
.long P418
.long P418
.long P418
.long P420
.long P420
.long P420
.long P420
.long P420
.long P420
.long P420
.long P420
.long P428
.long P428
.long P428
.long P428
.long P428
.long P428
.long P428
.long P428
.long P430
.long P430
.long P430
.long P430
.long P430
.long P430
.long P430
.long P430
.long P438
.long P439
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P440
.long P440
.long P440
.long P440
.long P440
.long P440
.long P440
.long P440
.long P448
.long P448
.long P448
.long P448
.long P448
.long P448
.long P448
.long P448
.long P450
.long P450
.long P450
.long P450
.long P450
.long P450
.long P450
.long P450
.long P458
.long P458
.long P458
.long P458
.long P458
.long P458
.long P458
.long P458
.long P460
.long P460
.long P460
.long P460
.long P460
.long P460
.long P460
.long P460
.long P468
.long P468
.long P468
.long P468
.long P468
.long P468
.long P468
.long P468
.long P470
.long P470
.long P470
.long P470
.long P470
.long P470
.long P470
.long P470
.long P478
.long P479
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P480
.long P480
.long P480
.long P480
.long P480
.long P480
.long P480
.long P480
.long P488
.long P488
.long P488
.long P488
.long P488
.long P488
.long P488
.long P488
.long P490
.long P490
.long P490
.long P490
.long P490
.long P490
.long P490
.long P490
.long P498
.long P498
.long P498
.long P498
.long P498
.long P498
.long P498
.long P498
.long P4A0
.long P4A0
.long P4A0
.long P4A0
.long P4A0
.long P4A0
.long P4A0
.long P4A0
.long P4A8
.long P4A8
.long P4A8
.long P4A8
.long P4A8
.long P4A8
.long P4A8
.long P4A8
.long P4B0
.long P4B0
.long P4B0
.long P4B0
.long P4B0
.long P4B0
.long P4B0
.long P4B0
.long P4B8
.long P4B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P4C0
.long P4C0
.long P4C0
.long P4C0
.long P4C0
.long P4C0
.long P4C0
.long P4C0
.long P4C8
.long P4C8
.long P4C8
.long P4C8
.long P4C8
.long P4C8
.long P4C8
.long P4C8
.long P4D0
.long P4D0
.long P4D0
.long P4D0
.long P4D0
.long P4D0
.long P4D0
.long P4D0
.long P4D8
.long P4D8
.long P4D8
.long P4D8
.long P4D8
.long P4D8
.long P4D8
.long P4D8
.long P4E0
.long P4E0
.long P4E0
.long P4E0
.long P4E0
.long P4E0
.long P4E0
.long P4E0
.long P4E8
.long P4E8
.long P4E8
.long P4E8
.long P4E8
.long P4E8
.long P4E8
.long P4E8
.long P4F0
.long P4F0
.long P4F0
.long P4F0
.long P4F0
.long P4F0
.long P4F0
.long P4F0
.long P4F8
.long P4F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P500
.long P500
.long P500
.long P500
.long P500
.long P500
.long P500
.long P500
.long P508
.long P508
.long P508
.long P508
.long P508
.long P508
.long P508
.long P508
.long P510
.long P510
.long P510
.long P510
.long P510
.long P510
.long P510
.long P510
.long P518
.long P518
.long P518
.long P518
.long P518
.long P518
.long P518
.long P518
.long P520
.long P520
.long P520
.long P520
.long P520
.long P520
.long P520
.long P520
.long P528
.long P528
.long P528
.long P528
.long P528
.long P528
.long P528
.long P528
.long P530
.long P530
.long P530
.long P530
.long P530
.long P530
.long P530
.long P530
.long P538
.long P539
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P540
.long P540
.long P540
.long P540
.long P540
.long P540
.long P540
.long P540
.long P548
.long P548
.long P548
.long P548
.long P548
.long P548
.long P548
.long P548
.long P550
.long P550
.long P550
.long P550
.long P550
.long P550
.long P550
.long P550
.long P558
.long P558
.long P558
.long P558
.long P558
.long P558
.long P558
.long P558
.long P560
.long P560
.long P560
.long P560
.long P560
.long P560
.long P560
.long P560
.long P568
.long P568
.long P568
.long P568
.long P568
.long P568
.long P568
.long P568
.long P570
.long P570
.long P570
.long P570
.long P570
.long P570
.long P570
.long P570
.long P578
.long P579
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P580
.long P580
.long P580
.long P580
.long P580
.long P580
.long P580
.long P580
.long P588
.long P588
.long P588
.long P588
.long P588
.long P588
.long P588
.long P588
.long P590
.long P590
.long P590
.long P590
.long P590
.long P590
.long P590
.long P590
.long P598
.long P598
.long P598
.long P598
.long P598
.long P598
.long P598
.long P598
.long P5A0
.long P5A0
.long P5A0
.long P5A0
.long P5A0
.long P5A0
.long P5A0
.long P5A0
.long P5A8
.long P5A8
.long P5A8
.long P5A8
.long P5A8
.long P5A8
.long P5A8
.long P5A8
.long P5B0
.long P5B0
.long P5B0
.long P5B0
.long P5B0
.long P5B0
.long P5B0
.long P5B0
.long P5B8
.long P5B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P5C0
.long P5C0
.long P5C0
.long P5C0
.long P5C0
.long P5C0
.long P5C0
.long P5C0
.long P5C8
.long P5C8
.long P5C8
.long P5C8
.long P5C8
.long P5C8
.long P5C8
.long P5C8
.long P5D0
.long P5D0
.long P5D0
.long P5D0
.long P5D0
.long P5D0
.long P5D0
.long P5D0
.long P5D8
.long P5D8
.long P5D8
.long P5D8
.long P5D8
.long P5D8
.long P5D8
.long P5D8
.long P5E0
.long P5E0
.long P5E0
.long P5E0
.long P5E0
.long P5E0
.long P5E0
.long P5E0
.long P5E8
.long P5E8
.long P5E8
.long P5E8
.long P5E8
.long P5E8
.long P5E8
.long P5E8
.long P5F0
.long P5F0
.long P5F0
.long P5F0
.long P5F0
.long P5F0
.long P5F0
.long P5F0
.long P5F8
.long P5F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P600
.long P600
.long P600
.long P600
.long P600
.long P600
.long P600
.long P600
.long P608
.long P608
.long P608
.long P608
.long P608
.long P608
.long P608
.long P608
.long P610
.long P610
.long P610
.long P610
.long P610
.long P610
.long P610
.long P610
.long P618
.long P618
.long P618
.long P618
.long P618
.long P618
.long P618
.long P618
.long P620
.long P620
.long P620
.long P620
.long P620
.long P620
.long P620
.long P620
.long P628
.long P628
.long P628
.long P628
.long P628
.long P628
.long P628
.long P628
.long P630
.long P630
.long P630
.long P630
.long P630
.long P630
.long P630
.long P630
.long P638
.long P639
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P640
.long P640
.long P640
.long P640
.long P640
.long P640
.long P640
.long P640
.long P648
.long P648
.long P648
.long P648
.long P648
.long P648
.long P648
.long P648
.long P650
.long P650
.long P650
.long P650
.long P650
.long P650
.long P650
.long P650
.long P658
.long P658
.long P658
.long P658
.long P658
.long P658
.long P658
.long P658
.long P660
.long P660
.long P660
.long P660
.long P660
.long P660
.long P660
.long P660
.long P668
.long P668
.long P668
.long P668
.long P668
.long P668
.long P668
.long P668
.long P670
.long P670
.long P670
.long P670
.long P670
.long P670
.long P670
.long P670
.long P678
.long P679
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P680
.long P680
.long P680
.long P680
.long P680
.long P680
.long P680
.long P680
.long P688
.long P688
.long P688
.long P688
.long P688
.long P688
.long P688
.long P688
.long P690
.long P690
.long P690
.long P690
.long P690
.long P690
.long P690
.long P690
.long P698
.long P698
.long P698
.long P698
.long P698
.long P698
.long P698
.long P698
.long P6A0
.long P6A0
.long P6A0
.long P6A0
.long P6A0
.long P6A0
.long P6A0
.long P6A0
.long P6A8
.long P6A8
.long P6A8
.long P6A8
.long P6A8
.long P6A8
.long P6A8
.long P6A8
.long P6B0
.long P6B0
.long P6B0
.long P6B0
.long P6B0
.long P6B0
.long P6B0
.long P6B0
.long P6B8
.long P6B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P6C0
.long P6C0
.long P6C0
.long P6C0
.long P6C0
.long P6C0
.long P6C0
.long P6C0
.long P6C8
.long P6C8
.long P6C8
.long P6C8
.long P6C8
.long P6C8
.long P6C8
.long P6C8
.long P6D0
.long P6D0
.long P6D0
.long P6D0
.long P6D0
.long P6D0
.long P6D0
.long P6D0
.long P6D8
.long P6D8
.long P6D8
.long P6D8
.long P6D8
.long P6D8
.long P6D8
.long P6D8
.long P6E0
.long P6E0
.long P6E0
.long P6E0
.long P6E0
.long P6E0
.long P6E0
.long P6E0
.long P6E8
.long P6E8
.long P6E8
.long P6E8
.long P6E8
.long P6E8
.long P6E8
.long P6E8
.long P6F0
.long P6F0
.long P6F0
.long P6F0
.long P6F0
.long P6F0
.long P6F0
.long P6F0
.long P6F8
.long P6F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P700
.long P700
.long P700
.long P700
.long P700
.long P700
.long P700
.long P700
.long P708
.long P708
.long P708
.long P708
.long P708
.long P708
.long P708
.long P708
.long P710
.long P710
.long P710
.long P710
.long P710
.long P710
.long P710
.long P710
.long P718
.long P718
.long P718
.long P718
.long P718
.long P718
.long P718
.long P718
.long P720
.long P720
.long P720
.long P720
.long P720
.long P720
.long P720
.long P720
.long P728
.long P728
.long P728
.long P728
.long P728
.long P728
.long P728
.long P728
.long P730
.long P730
.long P730
.long P730
.long P730
.long P730
.long P730
.long P730
.long P738
.long P739
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P740
.long P740
.long P740
.long P740
.long P740
.long P740
.long P740
.long P740
.long P748
.long P748
.long P748
.long P748
.long P748
.long P748
.long P748
.long P748
.long P750
.long P750
.long P750
.long P750
.long P750
.long P750
.long P750
.long P750
.long P758
.long P758
.long P758
.long P758
.long P758
.long P758
.long P758
.long P758
.long P760
.long P760
.long P760
.long P760
.long P760
.long P760
.long P760
.long P760
.long P768
.long P768
.long P768
.long P768
.long P768
.long P768
.long P768
.long P768
.long P770
.long P770
.long P770
.long P770
.long P770
.long P770
.long P770
.long P770
.long P778
.long P779
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P780
.long P780
.long P780
.long P780
.long P780
.long P780
.long P780
.long P780
.long P788
.long P788
.long P788
.long P788
.long P788
.long P788
.long P788
.long P788
.long P790
.long P790
.long P790
.long P790
.long P790
.long P790
.long P790
.long P790
.long P798
.long P798
.long P798
.long P798
.long P798
.long P798
.long P798
.long P798
.long P7A0
.long P7A0
.long P7A0
.long P7A0
.long P7A0
.long P7A0
.long P7A0
.long P7A0
.long P7A8
.long P7A8
.long P7A8
.long P7A8
.long P7A8
.long P7A8
.long P7A8
.long P7A8
.long P7B0
.long P7B0
.long P7B0
.long P7B0
.long P7B0
.long P7B0
.long P7B0
.long P7B0
.long P7B8
.long P7B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P7C0
.long P7C0
.long P7C0
.long P7C0
.long P7C0
.long P7C0
.long P7C0
.long P7C0
.long P7C8
.long P7C8
.long P7C8
.long P7C8
.long P7C8
.long P7C8
.long P7C8
.long P7C8
.long P7D0
.long P7D0
.long P7D0
.long P7D0
.long P7D0
.long P7D0
.long P7D0
.long P7D0
.long P7D8
.long P7D8
.long P7D8
.long P7D8
.long P7D8
.long P7D8
.long P7D8
.long P7D8
.long P7E0
.long P7E0
.long P7E0
.long P7E0
.long P7E0
.long P7E0
.long P7E0
.long P7E0
.long P7E8
.long P7E8
.long P7E8
.long P7E8
.long P7E8
.long P7E8
.long P7E8
.long P7E8
.long P7F0
.long P7F0
.long P7F0
.long P7F0
.long P7F0
.long P7F0
.long P7F0
.long P7F0
.long P7F8
.long P7F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P800
.long P800
.long P800
.long P800
.long P800
.long P800
.long P800
.long P800
.long P808
.long P808
.long P808
.long P808
.long P808
.long P808
.long P808
.long P808
.long P810
.long P810
.long P810
.long P810
.long P810
.long P810
.long P810
.long P810
.long P818
.long P818
.long P818
.long P818
.long P818
.long P818
.long P818
.long P818
.long P820
.long P820
.long P820
.long P820
.long P820
.long P820
.long P820
.long P820
.long P828
.long P828
.long P828
.long P828
.long P828
.long P828
.long P828
.long P828
.long P830
.long P830
.long P830
.long P830
.long P830
.long P830
.long P830
.long P830
.long P838
.long P839
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P840
.long P840
.long P840
.long P840
.long P840
.long P840
.long P840
.long P840
.long P848
.long P848
.long P848
.long P848
.long P848
.long P848
.long P848
.long P848
.long P850
.long P850
.long P850
.long P850
.long P850
.long P850
.long P850
.long P850
.long P858
.long P858
.long P858
.long P858
.long P858
.long P858
.long P858
.long P858
.long P860
.long P860
.long P860
.long P860
.long P860
.long P860
.long P860
.long P860
.long P868
.long P868
.long P868
.long P868
.long P868
.long P868
.long P868
.long P868
.long P870
.long P870
.long P870
.long P870
.long P870
.long P870
.long P870
.long P870
.long P878
.long P879
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P880
.long P880
.long P880
.long P880
.long P880
.long P880
.long P880
.long P880
.long P888
.long P888
.long P888
.long P888
.long P888
.long P888
.long P888
.long P888
.long P890
.long P890
.long P890
.long P890
.long P890
.long P890
.long P890
.long P890
.long P898
.long P898
.long P898
.long P898
.long P898
.long P898
.long P898
.long P898
.long P8A0
.long P8A0
.long P8A0
.long P8A0
.long P8A0
.long P8A0
.long P8A0
.long P8A0
.long P8A8
.long P8A8
.long P8A8
.long P8A8
.long P8A8
.long P8A8
.long P8A8
.long P8A8
.long P8B0
.long P8B0
.long P8B0
.long P8B0
.long P8B0
.long P8B0
.long P8B0
.long P8B0
.long P8B8
.long P8B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P8C0
.long P8C0
.long P8C0
.long P8C0
.long P8C0
.long P8C0
.long P8C0
.long P8C0
.long P8C8
.long P8C8
.long P8C8
.long P8C8
.long P8C8
.long P8C8
.long P8C8
.long P8C8
.long P8D0
.long P8D0
.long P8D0
.long P8D0
.long P8D0
.long P8D0
.long P8D0
.long P8D0
.long P8D8
.long P8D8
.long P8D8
.long P8D8
.long P8D8
.long P8D8
.long P8D8
.long P8D8
.long P8E0
.long P8E0
.long P8E0
.long P8E0
.long P8E0
.long P8E0
.long P8E0
.long P8E0
.long P8E8
.long P8E8
.long P8E8
.long P8E8
.long P8E8
.long P8E8
.long P8E8
.long P8E8
.long P8F0
.long P8F0
.long P8F0
.long P8F0
.long P8F0
.long P8F0
.long P8F0
.long P8F0
.long P8F8
.long P8F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P900
.long P900
.long P900
.long P900
.long P900
.long P900
.long P900
.long P900
.long P908
.long P908
.long P908
.long P908
.long P908
.long P908
.long P908
.long P908
.long P910
.long P910
.long P910
.long P910
.long P910
.long P910
.long P910
.long P910
.long P918
.long P918
.long P918
.long P918
.long P918
.long P918
.long P918
.long P918
.long P920
.long P920
.long P920
.long P920
.long P920
.long P920
.long P920
.long P920
.long P928
.long P928
.long P928
.long P928
.long P928
.long P928
.long P928
.long P928
.long P930
.long P930
.long P930
.long P930
.long P930
.long P930
.long P930
.long P930
.long P938
.long P939
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P940
.long P940
.long P940
.long P940
.long P940
.long P940
.long P940
.long P940
.long P948
.long P948
.long P948
.long P948
.long P948
.long P948
.long P948
.long P948
.long P950
.long P950
.long P950
.long P950
.long P950
.long P950
.long P950
.long P950
.long P958
.long P958
.long P958
.long P958
.long P958
.long P958
.long P958
.long P958
.long P960
.long P960
.long P960
.long P960
.long P960
.long P960
.long P960
.long P960
.long P968
.long P968
.long P968
.long P968
.long P968
.long P968
.long P968
.long P968
.long P970
.long P970
.long P970
.long P970
.long P970
.long P970
.long P970
.long P970
.long P978
.long P979
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P980
.long P980
.long P980
.long P980
.long P980
.long P980
.long P980
.long P980
.long P988
.long P988
.long P988
.long P988
.long P988
.long P988
.long P988
.long P988
.long P990
.long P990
.long P990
.long P990
.long P990
.long P990
.long P990
.long P990
.long P998
.long P998
.long P998
.long P998
.long P998
.long P998
.long P998
.long P998
.long P9A0
.long P9A0
.long P9A0
.long P9A0
.long P9A0
.long P9A0
.long P9A0
.long P9A0
.long P9A8
.long P9A8
.long P9A8
.long P9A8
.long P9A8
.long P9A8
.long P9A8
.long P9A8
.long P9B0
.long P9B0
.long P9B0
.long P9B0
.long P9B0
.long P9B0
.long P9B0
.long P9B0
.long P9B8
.long P9B9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long P9C0
.long P9C0
.long P9C0
.long P9C0
.long P9C0
.long P9C0
.long P9C0
.long P9C0
.long P9C8
.long P9C8
.long P9C8
.long P9C8
.long P9C8
.long P9C8
.long P9C8
.long P9C8
.long P9D0
.long P9D0
.long P9D0
.long P9D0
.long P9D0
.long P9D0
.long P9D0
.long P9D0
.long P9D8
.long P9D8
.long P9D8
.long P9D8
.long P9D8
.long P9D8
.long P9D8
.long P9D8
.long P9E0
.long P9E0
.long P9E0
.long P9E0
.long P9E0
.long P9E0
.long P9E0
.long P9E0
.long P9E8
.long P9E8
.long P9E8
.long P9E8
.long P9E8
.long P9E8
.long P9E8
.long P9E8
.long P9F0
.long P9F0
.long P9F0
.long P9F0
.long P9F0
.long P9F0
.long P9F0
.long P9F0
.long P9F8
.long P9F9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PA00
.long PA00
.long PA00
.long PA00
.long PA00
.long PA00
.long PA00
.long PA00
.long PA08
.long PA08
.long PA08
.long PA08
.long PA08
.long PA08
.long PA08
.long PA08
.long PA10
.long PA10
.long PA10
.long PA10
.long PA10
.long PA10
.long PA10
.long PA10
.long PA18
.long PA18
.long PA18
.long PA18
.long PA18
.long PA18
.long PA18
.long PA18
.long PA20
.long PA20
.long PA20
.long PA20
.long PA20
.long PA20
.long PA20
.long PA20
.long PA28
.long PA28
.long PA28
.long PA28
.long PA28
.long PA28
.long PA28
.long PA28
.long PA30
.long PA30
.long PA30
.long PA30
.long PA30
.long PA30
.long PA30
.long PA30
.long PA38
.long PA39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PA40
.long PA40
.long PA40
.long PA40
.long PA40
.long PA40
.long PA40
.long PA40
.long PA48
.long PA48
.long PA48
.long PA48
.long PA48
.long PA48
.long PA48
.long PA48
.long PA50
.long PA50
.long PA50
.long PA50
.long PA50
.long PA50
.long PA50
.long PA50
.long PA58
.long PA58
.long PA58
.long PA58
.long PA58
.long PA58
.long PA58
.long PA58
.long PA60
.long PA60
.long PA60
.long PA60
.long PA60
.long PA60
.long PA60
.long PA60
.long PA68
.long PA68
.long PA68
.long PA68
.long PA68
.long PA68
.long PA68
.long PA68
.long PA70
.long PA70
.long PA70
.long PA70
.long PA70
.long PA70
.long PA70
.long PA70
.long PA78
.long PA79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PA80
.long PA80
.long PA80
.long PA80
.long PA80
.long PA80
.long PA80
.long PA80
.long PA88
.long PA88
.long PA88
.long PA88
.long PA88
.long PA88
.long PA88
.long PA88
.long PA90
.long PA90
.long PA90
.long PA90
.long PA90
.long PA90
.long PA90
.long PA90
.long PA98
.long PA98
.long PA98
.long PA98
.long PA98
.long PA98
.long PA98
.long PA98
.long PAA0
.long PAA0
.long PAA0
.long PAA0
.long PAA0
.long PAA0
.long PAA0
.long PAA0
.long PAA8
.long PAA8
.long PAA8
.long PAA8
.long PAA8
.long PAA8
.long PAA8
.long PAA8
.long PAB0
.long PAB0
.long PAB0
.long PAB0
.long PAB0
.long PAB0
.long PAB0
.long PAB0
.long PAB8
.long PAB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PAC0
.long PAC0
.long PAC0
.long PAC0
.long PAC0
.long PAC0
.long PAC0
.long PAC0
.long PAC8
.long PAC8
.long PAC8
.long PAC8
.long PAC8
.long PAC8
.long PAC8
.long PAC8
.long PAD0
.long PAD0
.long PAD0
.long PAD0
.long PAD0
.long PAD0
.long PAD0
.long PAD0
.long PAD8
.long PAD8
.long PAD8
.long PAD8
.long PAD8
.long PAD8
.long PAD8
.long PAD8
.long PAE0
.long PAE0
.long PAE0
.long PAE0
.long PAE0
.long PAE0
.long PAE0
.long PAE0
.long PAE8
.long PAE8
.long PAE8
.long PAE8
.long PAE8
.long PAE8
.long PAE8
.long PAE8
.long PAF0
.long PAF0
.long PAF0
.long PAF0
.long PAF0
.long PAF0
.long PAF0
.long PAF0
.long PAF8
.long PAF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PB00
.long PB00
.long PB00
.long PB00
.long PB00
.long PB00
.long PB00
.long PB00
.long PB08
.long PB08
.long PB08
.long PB08
.long PB08
.long PB08
.long PB08
.long PB08
.long PB10
.long PB10
.long PB10
.long PB10
.long PB10
.long PB10
.long PB10
.long PB10
.long PB18
.long PB18
.long PB18
.long PB18
.long PB18
.long PB18
.long PB18
.long PB18
.long PB20
.long PB20
.long PB20
.long PB20
.long PB20
.long PB20
.long PB20
.long PB20
.long PB28
.long PB28
.long PB28
.long PB28
.long PB28
.long PB28
.long PB28
.long PB28
.long PB30
.long PB30
.long PB30
.long PB30
.long PB30
.long PB30
.long PB30
.long PB30
.long PB38
.long PB39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PB40
.long PB40
.long PB40
.long PB40
.long PB40
.long PB40
.long PB40
.long PB40
.long PB48
.long PB48
.long PB48
.long PB48
.long PB48
.long PB48
.long PB48
.long PB48
.long PB50
.long PB50
.long PB50
.long PB50
.long PB50
.long PB50
.long PB50
.long PB50
.long PB58
.long PB58
.long PB58
.long PB58
.long PB58
.long PB58
.long PB58
.long PB58
.long PB60
.long PB60
.long PB60
.long PB60
.long PB60
.long PB60
.long PB60
.long PB60
.long PB68
.long PB68
.long PB68
.long PB68
.long PB68
.long PB68
.long PB68
.long PB68
.long PB70
.long PB70
.long PB70
.long PB70
.long PB70
.long PB70
.long PB70
.long PB70
.long PB78
.long PB79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PB80
.long PB80
.long PB80
.long PB80
.long PB80
.long PB80
.long PB80
.long PB80
.long PB88
.long PB88
.long PB88
.long PB88
.long PB88
.long PB88
.long PB88
.long PB88
.long PB90
.long PB90
.long PB90
.long PB90
.long PB90
.long PB90
.long PB90
.long PB90
.long PB98
.long PB98
.long PB98
.long PB98
.long PB98
.long PB98
.long PB98
.long PB98
.long PBA0
.long PBA0
.long PBA0
.long PBA0
.long PBA0
.long PBA0
.long PBA0
.long PBA0
.long PBA8
.long PBA8
.long PBA8
.long PBA8
.long PBA8
.long PBA8
.long PBA8
.long PBA8
.long PBB0
.long PBB0
.long PBB0
.long PBB0
.long PBB0
.long PBB0
.long PBB0
.long PBB0
.long PBB8
.long PBB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PBC0
.long PBC0
.long PBC0
.long PBC0
.long PBC0
.long PBC0
.long PBC0
.long PBC0
.long PBC8
.long PBC8
.long PBC8
.long PBC8
.long PBC8
.long PBC8
.long PBC8
.long PBC8
.long PBD0
.long PBD0
.long PBD0
.long PBD0
.long PBD0
.long PBD0
.long PBD0
.long PBD0
.long PBD8
.long PBD8
.long PBD8
.long PBD8
.long PBD8
.long PBD8
.long PBD8
.long PBD8
.long PBE0
.long PBE0
.long PBE0
.long PBE0
.long PBE0
.long PBE0
.long PBE0
.long PBE0
.long PBE8
.long PBE8
.long PBE8
.long PBE8
.long PBE8
.long PBE8
.long PBE8
.long PBE8
.long PBF0
.long PBF0
.long PBF0
.long PBF0
.long PBF0
.long PBF0
.long PBF0
.long PBF0
.long PBF8
.long PBF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PC00
.long PC00
.long PC00
.long PC00
.long PC00
.long PC00
.long PC00
.long PC00
.long PC08
.long PC08
.long PC08
.long PC08
.long PC08
.long PC08
.long PC08
.long PC08
.long PC10
.long PC10
.long PC10
.long PC10
.long PC10
.long PC10
.long PC10
.long PC10
.long PC18
.long PC18
.long PC18
.long PC18
.long PC18
.long PC18
.long PC18
.long PC18
.long PC20
.long PC20
.long PC20
.long PC20
.long PC20
.long PC20
.long PC20
.long PC20
.long PC28
.long PC28
.long PC28
.long PC28
.long PC28
.long PC28
.long PC28
.long PC28
.long PC30
.long PC30
.long PC30
.long PC30
.long PC30
.long PC30
.long PC30
.long PC30
.long PC38
.long PC39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PC40
.long PC40
.long PC40
.long PC40
.long PC40
.long PC40
.long PC40
.long PC40
.long PC48
.long PC48
.long PC48
.long PC48
.long PC48
.long PC48
.long PC48
.long PC48
.long PC50
.long PC50
.long PC50
.long PC50
.long PC50
.long PC50
.long PC50
.long PC50
.long PC58
.long PC58
.long PC58
.long PC58
.long PC58
.long PC58
.long PC58
.long PC58
.long PC60
.long PC60
.long PC60
.long PC60
.long PC60
.long PC60
.long PC60
.long PC60
.long PC68
.long PC68
.long PC68
.long PC68
.long PC68
.long PC68
.long PC68
.long PC68
.long PC70
.long PC70
.long PC70
.long PC70
.long PC70
.long PC70
.long PC70
.long PC70
.long PC78
.long PC79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PC80
.long PC80
.long PC80
.long PC80
.long PC80
.long PC80
.long PC80
.long PC80
.long PC88
.long PC88
.long PC88
.long PC88
.long PC88
.long PC88
.long PC88
.long PC88
.long PC90
.long PC90
.long PC90
.long PC90
.long PC90
.long PC90
.long PC90
.long PC90
.long PC98
.long PC98
.long PC98
.long PC98
.long PC98
.long PC98
.long PC98
.long PC98
.long PCA0
.long PCA0
.long PCA0
.long PCA0
.long PCA0
.long PCA0
.long PCA0
.long PCA0
.long PCA8
.long PCA8
.long PCA8
.long PCA8
.long PCA8
.long PCA8
.long PCA8
.long PCA8
.long PCB0
.long PCB0
.long PCB0
.long PCB0
.long PCB0
.long PCB0
.long PCB0
.long PCB0
.long PCB8
.long PCB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PCC0
.long PCC0
.long PCC0
.long PCC0
.long PCC0
.long PCC0
.long PCC0
.long PCC0
.long PCC8
.long PCC8
.long PCC8
.long PCC8
.long PCC8
.long PCC8
.long PCC8
.long PCC8
.long PCD0
.long PCD0
.long PCD0
.long PCD0
.long PCD0
.long PCD0
.long PCD0
.long PCD0
.long PCD8
.long PCD8
.long PCD8
.long PCD8
.long PCD8
.long PCD8
.long PCD8
.long PCD8
.long PCE0
.long PCE0
.long PCE0
.long PCE0
.long PCE0
.long PCE0
.long PCE0
.long PCE0
.long PCE8
.long PCE8
.long PCE8
.long PCE8
.long PCE8
.long PCE8
.long PCE8
.long PCE8
.long PCF0
.long PCF0
.long PCF0
.long PCF0
.long PCF0
.long PCF0
.long PCF0
.long PCF0
.long PCF8
.long PCF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PD00
.long PD00
.long PD00
.long PD00
.long PD00
.long PD00
.long PD00
.long PD00
.long PD08
.long PD08
.long PD08
.long PD08
.long PD08
.long PD08
.long PD08
.long PD08
.long PD10
.long PD10
.long PD10
.long PD10
.long PD10
.long PD10
.long PD10
.long PD10
.long PD18
.long PD18
.long PD18
.long PD18
.long PD18
.long PD18
.long PD18
.long PD18
.long PD20
.long PD20
.long PD20
.long PD20
.long PD20
.long PD20
.long PD20
.long PD20
.long PD28
.long PD28
.long PD28
.long PD28
.long PD28
.long PD28
.long PD28
.long PD28
.long PD30
.long PD30
.long PD30
.long PD30
.long PD30
.long PD30
.long PD30
.long PD30
.long PD38
.long PD39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PD40
.long PD40
.long PD40
.long PD40
.long PD40
.long PD40
.long PD40
.long PD40
.long PD48
.long PD48
.long PD48
.long PD48
.long PD48
.long PD48
.long PD48
.long PD48
.long PD50
.long PD50
.long PD50
.long PD50
.long PD50
.long PD50
.long PD50
.long PD50
.long PD58
.long PD58
.long PD58
.long PD58
.long PD58
.long PD58
.long PD58
.long PD58
.long PD60
.long PD60
.long PD60
.long PD60
.long PD60
.long PD60
.long PD60
.long PD60
.long PD68
.long PD68
.long PD68
.long PD68
.long PD68
.long PD68
.long PD68
.long PD68
.long PD70
.long PD70
.long PD70
.long PD70
.long PD70
.long PD70
.long PD70
.long PD70
.long PD78
.long PD79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PD80
.long PD80
.long PD80
.long PD80
.long PD80
.long PD80
.long PD80
.long PD80
.long PD88
.long PD88
.long PD88
.long PD88
.long PD88
.long PD88
.long PD88
.long PD88
.long PD90
.long PD90
.long PD90
.long PD90
.long PD90
.long PD90
.long PD90
.long PD90
.long PD98
.long PD98
.long PD98
.long PD98
.long PD98
.long PD98
.long PD98
.long PD98
.long PDA0
.long PDA0
.long PDA0
.long PDA0
.long PDA0
.long PDA0
.long PDA0
.long PDA0
.long PDA8
.long PDA8
.long PDA8
.long PDA8
.long PDA8
.long PDA8
.long PDA8
.long PDA8
.long PDB0
.long PDB0
.long PDB0
.long PDB0
.long PDB0
.long PDB0
.long PDB0
.long PDB0
.long PDB8
.long PDB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PDC0
.long PDC0
.long PDC0
.long PDC0
.long PDC0
.long PDC0
.long PDC0
.long PDC0
.long PDC8
.long PDC8
.long PDC8
.long PDC8
.long PDC8
.long PDC8
.long PDC8
.long PDC8
.long PDD0
.long PDD0
.long PDD0
.long PDD0
.long PDD0
.long PDD0
.long PDD0
.long PDD0
.long PDD8
.long PDD8
.long PDD8
.long PDD8
.long PDD8
.long PDD8
.long PDD8
.long PDD8
.long PDE0
.long PDE0
.long PDE0
.long PDE0
.long PDE0
.long PDE0
.long PDE0
.long PDE0
.long PDE8
.long PDE8
.long PDE8
.long PDE8
.long PDE8
.long PDE8
.long PDE8
.long PDE8
.long PDF0
.long PDF0
.long PDF0
.long PDF0
.long PDF0
.long PDF0
.long PDF0
.long PDF0
.long PDF8
.long PDF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PE00
.long PE00
.long PE00
.long PE00
.long PE00
.long PE00
.long PE00
.long PE00
.long PE08
.long PE08
.long PE08
.long PE08
.long PE08
.long PE08
.long PE08
.long PE08
.long PE10
.long PE10
.long PE10
.long PE10
.long PE10
.long PE10
.long PE10
.long PE10
.long PE18
.long PE18
.long PE18
.long PE18
.long PE18
.long PE18
.long PE18
.long PE18
.long PE20
.long PE20
.long PE20
.long PE20
.long PE20
.long PE20
.long PE20
.long PE20
.long PE28
.long PE28
.long PE28
.long PE28
.long PE28
.long PE28
.long PE28
.long PE28
.long PE30
.long PE30
.long PE30
.long PE30
.long PE30
.long PE30
.long PE30
.long PE30
.long PE38
.long PE39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PE40
.long PE40
.long PE40
.long PE40
.long PE40
.long PE40
.long PE40
.long PE40
.long PE48
.long PE48
.long PE48
.long PE48
.long PE48
.long PE48
.long PE48
.long PE48
.long PE50
.long PE50
.long PE50
.long PE50
.long PE50
.long PE50
.long PE50
.long PE50
.long PE58
.long PE58
.long PE58
.long PE58
.long PE58
.long PE58
.long PE58
.long PE58
.long PE60
.long PE60
.long PE60
.long PE60
.long PE60
.long PE60
.long PE60
.long PE60
.long PE68
.long PE68
.long PE68
.long PE68
.long PE68
.long PE68
.long PE68
.long PE68
.long PE70
.long PE70
.long PE70
.long PE70
.long PE70
.long PE70
.long PE70
.long PE70
.long PE78
.long PE79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PE80
.long PE80
.long PE80
.long PE80
.long PE80
.long PE80
.long PE80
.long PE80
.long PE88
.long PE88
.long PE88
.long PE88
.long PE88
.long PE88
.long PE88
.long PE88
.long PE90
.long PE90
.long PE90
.long PE90
.long PE90
.long PE90
.long PE90
.long PE90
.long PE98
.long PE98
.long PE98
.long PE98
.long PE98
.long PE98
.long PE98
.long PE98
.long PEA0
.long PEA0
.long PEA0
.long PEA0
.long PEA0
.long PEA0
.long PEA0
.long PEA0
.long PEA8
.long PEA8
.long PEA8
.long PEA8
.long PEA8
.long PEA8
.long PEA8
.long PEA8
.long PEB0
.long PEB0
.long PEB0
.long PEB0
.long PEB0
.long PEB0
.long PEB0
.long PEB0
.long PEB8
.long PEB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PEC0
.long PEC0
.long PEC0
.long PEC0
.long PEC0
.long PEC0
.long PEC0
.long PEC0
.long PEC8
.long PEC8
.long PEC8
.long PEC8
.long PEC8
.long PEC8
.long PEC8
.long PEC8
.long PED0
.long PED0
.long PED0
.long PED0
.long PED0
.long PED0
.long PED0
.long PED0
.long PED8
.long PED8
.long PED8
.long PED8
.long PED8
.long PED8
.long PED8
.long PED8
.long PEE0
.long PEE0
.long PEE0
.long PEE0
.long PEE0
.long PEE0
.long PEE0
.long PEE0
.long PEE8
.long PEE8
.long PEE8
.long PEE8
.long PEE8
.long PEE8
.long PEE8
.long PEE8
.long PEF0
.long PEF0
.long PEF0
.long PEF0
.long PEF0
.long PEF0
.long PEF0
.long PEF0
.long PEF8
.long PEF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PF00
.long PF00
.long PF00
.long PF00
.long PF00
.long PF00
.long PF00
.long PF00
.long PF08
.long PF08
.long PF08
.long PF08
.long PF08
.long PF08
.long PF08
.long PF08
.long PF10
.long PF10
.long PF10
.long PF10
.long PF10
.long PF10
.long PF10
.long PF10
.long PF18
.long PF18
.long PF18
.long PF18
.long PF18
.long PF18
.long PF18
.long PF18
.long PF20
.long PF20
.long PF20
.long PF20
.long PF20
.long PF20
.long PF20
.long PF20
.long PF28
.long PF28
.long PF28
.long PF28
.long PF28
.long PF28
.long PF28
.long PF28
.long PF30
.long PF30
.long PF30
.long PF30
.long PF30
.long PF30
.long PF30
.long PF30
.long PF38
.long PF39
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PF40
.long PF40
.long PF40
.long PF40
.long PF40
.long PF40
.long PF40
.long PF40
.long PF48
.long PF48
.long PF48
.long PF48
.long PF48
.long PF48
.long PF48
.long PF48
.long PF50
.long PF50
.long PF50
.long PF50
.long PF50
.long PF50
.long PF50
.long PF50
.long PF58
.long PF58
.long PF58
.long PF58
.long PF58
.long PF58
.long PF58
.long PF58
.long PF60
.long PF60
.long PF60
.long PF60
.long PF60
.long PF60
.long PF60
.long PF60
.long PF68
.long PF68
.long PF68
.long PF68
.long PF68
.long PF68
.long PF68
.long PF68
.long PF70
.long PF70
.long PF70
.long PF70
.long PF70
.long PF70
.long PF70
.long PF70
.long PF78
.long PF79
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PF80
.long PF80
.long PF80
.long PF80
.long PF80
.long PF80
.long PF80
.long PF80
.long PF88
.long PF88
.long PF88
.long PF88
.long PF88
.long PF88
.long PF88
.long PF88
.long PF90
.long PF90
.long PF90
.long PF90
.long PF90
.long PF90
.long PF90
.long PF90
.long PF98
.long PF98
.long PF98
.long PF98
.long PF98
.long PF98
.long PF98
.long PF98
.long PFA0
.long PFA0
.long PFA0
.long PFA0
.long PFA0
.long PFA0
.long PFA0
.long PFA0
.long PFA8
.long PFA8
.long PFA8
.long PFA8
.long PFA8
.long PFA8
.long PFA8
.long PFA8
.long PFB0
.long PFB0
.long PFB0
.long PFB0
.long PFB0
.long PFB0
.long PFB0
.long PFB0
.long PFB8
.long PFB9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long PFC0
.long PFC0
.long PFC0
.long PFC0
.long PFC0
.long PFC0
.long PFC0
.long PFC0
.long PFC8
.long PFC8
.long PFC8
.long PFC8
.long PFC8
.long PFC8
.long PFC8
.long PFC8
.long PFD0
.long PFD0
.long PFD0
.long PFD0
.long PFD0
.long PFD0
.long PFD0
.long PFD0
.long PFD8
.long PFD8
.long PFD8
.long PFD8
.long PFD8
.long PFD8
.long PFD8
.long PFD8
.long PFE0
.long PFE0
.long PFE0
.long PFE0
.long PFE0
.long PFE0
.long PFE0
.long PFE0
.long PFE8
.long PFE8
.long PFE8
.long PFE8
.long PFE8
.long PFE8
.long PFE8
.long PFE8
.long PFF0
.long PFF0
.long PFF0
.long PFF0
.long PFF0
.long PFF0
.long PFF0
.long PFF0
.long PFF8
.long PFF9
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long Q000
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q001
.long Q100
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q101
.long Q200
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q201
.long Q300
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q301
.long Q400
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q401
.long Q500
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q501
.long Q600
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q601
.long Q700
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q701
.long Q800
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q801
.long Q900
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long Q901
.long QA00
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QA01
.long QB00
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QB01
.long QC00
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QC01
.long QD00
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QD01
.long QE00
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QE01
.long QF00
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long QF01
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long R000
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long R200
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long R400
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long R600
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long R800
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long RA00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long RC00
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long r_illegal
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
.long RE00
